""" Cisco_IOS_XR_invmgr_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR invmgr package operational data.

This module contains definitions
for the following management objects\:
  inventory\: Inventory information

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class CardResetReason(Enum):
    """
    CardResetReason

    Card reset reason

    .. data:: reset_unknown = 1

    	reset unknown

    .. data:: power_up = 2

    	power up

    .. data:: parity_error = 3

    	parity error

    .. data:: clear_config_reset = 4

    	clear config reset

    .. data:: manual_reset = 5

    	manual reset

    .. data:: watch_dog_timeout_reset = 6

    	watch dog timeout reset

    .. data:: resource_overflow_reset = 7

    	resource overflow reset

    .. data:: missing_task_reset = 8

    	missing task reset

    .. data:: low_voltage_reset = 9

    	low voltage reset

    .. data:: controller_reset = 10

    	controller reset

    .. data:: system_reset = 11

    	system reset

    .. data:: switchover_reset = 12

    	switchover reset

    .. data:: upgrade_reset = 13

    	upgrade reset

    .. data:: downgrade_reset = 14

    	downgrade reset

    .. data:: cache_error_reset = 15

    	cache error reset

    .. data:: device_driver_reset = 16

    	device driver reset

    .. data:: software_exception_reset = 17

    	software exception reset

    .. data:: restore_config_reset = 18

    	restore config reset

    .. data:: abort_rev_reset = 19

    	abort rev reset

    .. data:: burn_boot_reset = 20

    	burn boot reset

    .. data:: standby_cd_healthier_reset = 21

    	standby cd healthier reset

    .. data:: non_native_config_clear_reset = 22

    	non native config clear reset

    .. data:: memory_protection_error_reset = 23

    	memory protection error reset

    .. data:: card_reset_reason_max = 24

    	card reset reason max

    """

    reset_unknown = Enum.YLeaf(1, "reset-unknown")

    power_up = Enum.YLeaf(2, "power-up")

    parity_error = Enum.YLeaf(3, "parity-error")

    clear_config_reset = Enum.YLeaf(4, "clear-config-reset")

    manual_reset = Enum.YLeaf(5, "manual-reset")

    watch_dog_timeout_reset = Enum.YLeaf(6, "watch-dog-timeout-reset")

    resource_overflow_reset = Enum.YLeaf(7, "resource-overflow-reset")

    missing_task_reset = Enum.YLeaf(8, "missing-task-reset")

    low_voltage_reset = Enum.YLeaf(9, "low-voltage-reset")

    controller_reset = Enum.YLeaf(10, "controller-reset")

    system_reset = Enum.YLeaf(11, "system-reset")

    switchover_reset = Enum.YLeaf(12, "switchover-reset")

    upgrade_reset = Enum.YLeaf(13, "upgrade-reset")

    downgrade_reset = Enum.YLeaf(14, "downgrade-reset")

    cache_error_reset = Enum.YLeaf(15, "cache-error-reset")

    device_driver_reset = Enum.YLeaf(16, "device-driver-reset")

    software_exception_reset = Enum.YLeaf(17, "software-exception-reset")

    restore_config_reset = Enum.YLeaf(18, "restore-config-reset")

    abort_rev_reset = Enum.YLeaf(19, "abort-rev-reset")

    burn_boot_reset = Enum.YLeaf(20, "burn-boot-reset")

    standby_cd_healthier_reset = Enum.YLeaf(21, "standby-cd-healthier-reset")

    non_native_config_clear_reset = Enum.YLeaf(22, "non-native-config-clear-reset")

    memory_protection_error_reset = Enum.YLeaf(23, "memory-protection-error-reset")

    card_reset_reason_max = Enum.YLeaf(24, "card-reset-reason-max")


class SensorData(Enum):
    """
    SensorData

    Sensor measurement data types

    .. data:: unknown = 2

    	Datatype unknown

    .. data:: ac_volts = 3

    	AC volts

    .. data:: dc_volts = 4

    	DC volts

    .. data:: amperes = 5

    	Amperes

    .. data:: watts = 6

    	Power in watts

    .. data:: hertz = 7

    	Frequency in hertz

    .. data:: celsius = 8

    	Celsius

    .. data:: rpm = 10

    	Rotations per minute

    .. data:: dbm = 14

    	Power in dBm

    .. data:: db = 15

    	Power in dB

    """

    unknown = Enum.YLeaf(2, "unknown")

    ac_volts = Enum.YLeaf(3, "ac-volts")

    dc_volts = Enum.YLeaf(4, "dc-volts")

    amperes = Enum.YLeaf(5, "amperes")

    watts = Enum.YLeaf(6, "watts")

    hertz = Enum.YLeaf(7, "hertz")

    celsius = Enum.YLeaf(8, "celsius")

    rpm = Enum.YLeaf(10, "rpm")

    dbm = Enum.YLeaf(14, "dbm")

    db = Enum.YLeaf(15, "db")


class SensorStatus(Enum):
    """
    SensorStatus

    Sensor status

    .. data:: ok = 1

    	State ok

    .. data:: unavailable = 2

    	State Unavailable

    .. data:: non_operational = 3

    	State no operational

    """

    ok = Enum.YLeaf(1, "ok")

    unavailable = Enum.YLeaf(2, "unavailable")

    non_operational = Enum.YLeaf(3, "non-operational")


class ThresholdRelation(Enum):
    """
    ThresholdRelation

    Threshold relation

    .. data:: less_than = 1

    	Sensor value is less than threshold

    .. data:: less_or_equal = 2

    	Sensor value is lesser than  or equal to

    	threshold

    .. data:: greater_than = 3

    	Sensor value is greater than threshold

    .. data:: greater_or_equal = 4

    	Sensor value is greater than or equal to

    	threshold

    .. data:: equal = 5

    	Sensor value is equal to threshold

    .. data:: not_equal = 6

    	Sensor value is not equal to threshold

    """

    less_than = Enum.YLeaf(1, "less-than")

    less_or_equal = Enum.YLeaf(2, "less-or-equal")

    greater_than = Enum.YLeaf(3, "greater-than")

    greater_or_equal = Enum.YLeaf(4, "greater-or-equal")

    equal = Enum.YLeaf(5, "equal")

    not_equal = Enum.YLeaf(6, "not-equal")


class ThresholdSeverity(Enum):
    """
    ThresholdSeverity

    Threshold severity

    .. data:: other = 1

    	Other

    .. data:: minor = 10

    	Minor

    .. data:: major = 20

    	Major

    .. data:: critical = 30

    	Critical

    """

    other = Enum.YLeaf(1, "other")

    minor = Enum.YLeaf(10, "minor")

    major = Enum.YLeaf(20, "major")

    critical = Enum.YLeaf(30, "critical")


class Unit(Enum):
    """
    Unit

    Unit information

    .. data:: celsius = 0

    	Degree in celsius

    .. data:: milli_volts = 1

    	Milli volts

    .. data:: milli_amperes = 2

    	Milli amperes

    .. data:: rpm = 3

    	Rotations per minute

    .. data:: watts = 4

    	Watts

    .. data:: dbm = 5

    	dBm

    .. data:: db = 6

    	dB

    """

    celsius = Enum.YLeaf(0, "celsius")

    milli_volts = Enum.YLeaf(1, "milli-volts")

    milli_amperes = Enum.YLeaf(2, "milli-amperes")

    rpm = Enum.YLeaf(3, "rpm")

    watts = Enum.YLeaf(4, "watts")

    dbm = Enum.YLeaf(5, "dbm")

    db = Enum.YLeaf(6, "db")



class Inventory(Entity):
    """
    Inventory information
    
    .. attribute:: entities
    
    	Entities Table
    	**type**\:   :py:class:`Entities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities>`
    
    .. attribute:: racks
    
    	RackTable
    	**type**\:   :py:class:`Racks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks>`
    
    

    """

    _prefix = 'invmgr-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(Inventory, self).__init__()
        self._top_entity = None

        self.yang_name = "inventory"
        self.yang_parent_name = "Cisco-IOS-XR-invmgr-oper"

        self.entities = Inventory.Entities()
        self.entities.parent = self
        self._children_name_map["entities"] = "entities"
        self._children_yang_names.add("entities")

        self.racks = Inventory.Racks()
        self.racks.parent = self
        self._children_name_map["racks"] = "racks"
        self._children_yang_names.add("racks")


    class Entities(Entity):
        """
        Entities Table
        
        .. attribute:: entity_
        
        	Entity name
        	**type**\: list of    :py:class:`Entity_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_>`
        
        

        """

        _prefix = 'invmgr-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(Inventory.Entities, self).__init__()

            self.yang_name = "entities"
            self.yang_parent_name = "inventory"

            self.entity_ = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Inventory.Entities, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Inventory.Entities, self).__setattr__(name, value)


        class Entity_(Entity):
            """
            Entity name
            
            .. attribute:: name  <key>
            
            	Entity name
            	**type**\:  str
            
            .. attribute:: attributes
            
            	Attributes
            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_.Attributes>`
            
            .. attribute:: subentities
            
            	SubEntities Table
            	**type**\:   :py:class:`Subentities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_.Subentities>`
            
            

            """

            _prefix = 'invmgr-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(Inventory.Entities.Entity_, self).__init__()

                self.yang_name = "entity"
                self.yang_parent_name = "entities"

                self.name = YLeaf(YType.str, "name")

                self.attributes = Inventory.Entities.Entity_.Attributes()
                self.attributes.parent = self
                self._children_name_map["attributes"] = "attributes"
                self._children_yang_names.add("attributes")

                self.subentities = Inventory.Entities.Entity_.Subentities()
                self.subentities.parent = self
                self._children_name_map["subentities"] = "subentities"
                self._children_yang_names.add("subentities")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Inventory.Entities.Entity_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Inventory.Entities.Entity_, self).__setattr__(name, value)


            class Subentities(Entity):
                """
                SubEntities Table
                
                .. attribute:: subentity
                
                	Subentity name
                	**type**\: list of    :py:class:`Subentity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_.Subentities.Subentity>`
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Entities.Entity_.Subentities, self).__init__()

                    self.yang_name = "subentities"
                    self.yang_parent_name = "entity"

                    self.subentity = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Inventory.Entities.Entity_.Subentities, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Inventory.Entities.Entity_.Subentities, self).__setattr__(name, value)


                class Subentity(Entity):
                    """
                    Subentity name
                    
                    .. attribute:: name  <key>
                    
                    	Subentity name
                    	**type**\:  str
                    
                    .. attribute:: name_xr
                    
                    	Subentity name
                    	**type**\:  str
                    
                    	**mandatory**\: True
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Entities.Entity_.Subentities.Subentity, self).__init__()

                        self.yang_name = "subentity"
                        self.yang_parent_name = "subentities"

                        self.name = YLeaf(YType.str, "name")

                        self.name_xr = YLeaf(YType.str, "name-xr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("name",
                                        "name_xr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Entities.Entity_.Subentities.Subentity, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Entities.Entity_.Subentities.Subentity, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.name.is_set or
                            self.name_xr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            self.name_xr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "subentity" + "[name='" + self.name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())
                        if (self.name_xr.is_set or self.name_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name_xr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "name" or name == "name-xr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix
                        if(value_path == "name-xr"):
                            self.name_xr = value
                            self.name_xr.value_namespace = name_space
                            self.name_xr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.subentity:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.subentity:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "subentities" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "subentity"):
                        for c in self.subentity:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Inventory.Entities.Entity_.Subentities.Subentity()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.subentity.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "subentity"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Attributes(Entity):
                """
                Attributes
                
                .. attribute:: inv_asset_bag
                
                	Inventory Asset Bag
                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_.Attributes.InvAssetBag>`
                
                .. attribute:: inv_basic_bag
                
                	Inventory Basic Bag
                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Entities.Entity_.Attributes.InvBasicBag>`
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Entities.Entity_.Attributes, self).__init__()

                    self.yang_name = "attributes"
                    self.yang_parent_name = "entity"

                    self.inv_asset_bag = Inventory.Entities.Entity_.Attributes.InvAssetBag()
                    self.inv_asset_bag.parent = self
                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                    self._children_yang_names.add("inv-asset-bag")

                    self.inv_basic_bag = Inventory.Entities.Entity_.Attributes.InvBasicBag()
                    self.inv_basic_bag.parent = self
                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                    self._children_yang_names.add("inv-basic-bag")


                class InvBasicBag(Entity):
                    """
                    Inventory Basic Bag
                    
                    .. attribute:: alias
                    
                    	useful for storing an entity alias 
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: asset_id_str
                    
                    	asset Identification string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: asset_identification
                    
                    	asset Identification
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: ceport
                    
                    	1 if ce port found, 0 if not
                    	**type**\:  bool
                    
                    .. attribute:: chip_hardware_revision
                    
                    	chip module hw revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: composite_class_code
                    
                    	Major&minor class of the entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: description
                    
                    	describes in user\-readable terms       what the entity in question does
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: environmental_monitor_path
                    
                    	sysdb name of sensor in the envmon EDM
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: firmware_revision
                    
                    	firmware revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: group_flag
                    
                    	indicates if this entity is group       or not
                    	**type**\:  bool
                    
                    .. attribute:: hardware_revision
                    
                    	hw revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: is_field_replaceable_unit
                    
                    	1 if Field Replaceable Unit 0, if not
                    	**type**\:  bool
                    
                    .. attribute:: manufacturer_asset_tags
                    
                    	Manufacture Asset Tags
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: manufacturer_name
                    
                    	manufacturer's name
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: memory_size
                    
                    	Size of memory associated with       the entity where applicable
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: model_name
                    
                    	model name
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: name
                    
                    	name string for the entity
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: new_deviation_number
                    
                    	integer value for New Deviation Number 0x88
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: physical_layer_interface_module_type
                    
                    	integer value for plim type if     applicable to this entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: redundancystate
                    
                    	integer value for Redundancy State if     applicable to this entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: serial_number
                    
                    	serial number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: software_revision
                    
                    	software revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: unique_id
                    
                    	Unique id for an entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: unrecognized_fru
                    
                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                    	**type**\:  bool
                    
                    .. attribute:: vendor_type
                    
                    	maps to the vendor OID string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: xr_scoped
                    
                    	1 if xr scoped, 0 if not
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Entities.Entity_.Attributes.InvBasicBag, self).__init__()

                        self.yang_name = "inv-basic-bag"
                        self.yang_parent_name = "attributes"

                        self.alias = YLeaf(YType.str, "alias")

                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                        self.ceport = YLeaf(YType.boolean, "ceport")

                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                        self.description = YLeaf(YType.str, "description")

                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                        self.memory_size = YLeaf(YType.int32, "memory-size")

                        self.model_name = YLeaf(YType.str, "model-name")

                        self.name = YLeaf(YType.str, "name")

                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                        self.serial_number = YLeaf(YType.str, "serial-number")

                        self.software_revision = YLeaf(YType.str, "software-revision")

                        self.unique_id = YLeaf(YType.int32, "unique-id")

                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("alias",
                                        "asset_id_str",
                                        "asset_identification",
                                        "ceport",
                                        "chip_hardware_revision",
                                        "composite_class_code",
                                        "description",
                                        "environmental_monitor_path",
                                        "firmware_revision",
                                        "group_flag",
                                        "hardware_revision",
                                        "is_field_replaceable_unit",
                                        "manufacturer_asset_tags",
                                        "manufacturer_name",
                                        "memory_size",
                                        "model_name",
                                        "name",
                                        "new_deviation_number",
                                        "physical_layer_interface_module_type",
                                        "redundancystate",
                                        "serial_number",
                                        "software_revision",
                                        "unique_id",
                                        "unrecognized_fru",
                                        "vendor_type",
                                        "xr_scoped") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Entities.Entity_.Attributes.InvBasicBag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Entities.Entity_.Attributes.InvBasicBag, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.alias.is_set or
                            self.asset_id_str.is_set or
                            self.asset_identification.is_set or
                            self.ceport.is_set or
                            self.chip_hardware_revision.is_set or
                            self.composite_class_code.is_set or
                            self.description.is_set or
                            self.environmental_monitor_path.is_set or
                            self.firmware_revision.is_set or
                            self.group_flag.is_set or
                            self.hardware_revision.is_set or
                            self.is_field_replaceable_unit.is_set or
                            self.manufacturer_asset_tags.is_set or
                            self.manufacturer_name.is_set or
                            self.memory_size.is_set or
                            self.model_name.is_set or
                            self.name.is_set or
                            self.new_deviation_number.is_set or
                            self.physical_layer_interface_module_type.is_set or
                            self.redundancystate.is_set or
                            self.serial_number.is_set or
                            self.software_revision.is_set or
                            self.unique_id.is_set or
                            self.unrecognized_fru.is_set or
                            self.vendor_type.is_set or
                            self.xr_scoped.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.alias.yfilter != YFilter.not_set or
                            self.asset_id_str.yfilter != YFilter.not_set or
                            self.asset_identification.yfilter != YFilter.not_set or
                            self.ceport.yfilter != YFilter.not_set or
                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                            self.composite_class_code.yfilter != YFilter.not_set or
                            self.description.yfilter != YFilter.not_set or
                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                            self.firmware_revision.yfilter != YFilter.not_set or
                            self.group_flag.yfilter != YFilter.not_set or
                            self.hardware_revision.yfilter != YFilter.not_set or
                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                            self.manufacturer_name.yfilter != YFilter.not_set or
                            self.memory_size.yfilter != YFilter.not_set or
                            self.model_name.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            self.new_deviation_number.yfilter != YFilter.not_set or
                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                            self.redundancystate.yfilter != YFilter.not_set or
                            self.serial_number.yfilter != YFilter.not_set or
                            self.software_revision.yfilter != YFilter.not_set or
                            self.unique_id.yfilter != YFilter.not_set or
                            self.unrecognized_fru.yfilter != YFilter.not_set or
                            self.vendor_type.yfilter != YFilter.not_set or
                            self.xr_scoped.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "inv-basic-bag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.alias.get_name_leafdata())
                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ceport.get_name_leafdata())
                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.description.get_name_leafdata())
                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.model_name.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())
                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "alias"):
                            self.alias = value
                            self.alias.value_namespace = name_space
                            self.alias.value_namespace_prefix = name_space_prefix
                        if(value_path == "asset-id-str"):
                            self.asset_id_str = value
                            self.asset_id_str.value_namespace = name_space
                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                        if(value_path == "asset-identification"):
                            self.asset_identification = value
                            self.asset_identification.value_namespace = name_space
                            self.asset_identification.value_namespace_prefix = name_space_prefix
                        if(value_path == "ceport"):
                            self.ceport = value
                            self.ceport.value_namespace = name_space
                            self.ceport.value_namespace_prefix = name_space_prefix
                        if(value_path == "chip-hardware-revision"):
                            self.chip_hardware_revision = value
                            self.chip_hardware_revision.value_namespace = name_space
                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "composite-class-code"):
                            self.composite_class_code = value
                            self.composite_class_code.value_namespace = name_space
                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "description"):
                            self.description = value
                            self.description.value_namespace = name_space
                            self.description.value_namespace_prefix = name_space_prefix
                        if(value_path == "environmental-monitor-path"):
                            self.environmental_monitor_path = value
                            self.environmental_monitor_path.value_namespace = name_space
                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                        if(value_path == "firmware-revision"):
                            self.firmware_revision = value
                            self.firmware_revision.value_namespace = name_space
                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "group-flag"):
                            self.group_flag = value
                            self.group_flag.value_namespace = name_space
                            self.group_flag.value_namespace_prefix = name_space_prefix
                        if(value_path == "hardware-revision"):
                            self.hardware_revision = value
                            self.hardware_revision.value_namespace = name_space
                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-field-replaceable-unit"):
                            self.is_field_replaceable_unit = value
                            self.is_field_replaceable_unit.value_namespace = name_space
                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-asset-tags"):
                            self.manufacturer_asset_tags = value
                            self.manufacturer_asset_tags.value_namespace = name_space
                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-name"):
                            self.manufacturer_name = value
                            self.manufacturer_name.value_namespace = name_space
                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "memory-size"):
                            self.memory_size = value
                            self.memory_size.value_namespace = name_space
                            self.memory_size.value_namespace_prefix = name_space_prefix
                        if(value_path == "model-name"):
                            self.model_name = value
                            self.model_name.value_namespace = name_space
                            self.model_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix
                        if(value_path == "new-deviation-number"):
                            self.new_deviation_number = value
                            self.new_deviation_number.value_namespace = name_space
                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-layer-interface-module-type"):
                            self.physical_layer_interface_module_type = value
                            self.physical_layer_interface_module_type.value_namespace = name_space
                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "redundancystate"):
                            self.redundancystate = value
                            self.redundancystate.value_namespace = name_space
                            self.redundancystate.value_namespace_prefix = name_space_prefix
                        if(value_path == "serial-number"):
                            self.serial_number = value
                            self.serial_number.value_namespace = name_space
                            self.serial_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "software-revision"):
                            self.software_revision = value
                            self.software_revision.value_namespace = name_space
                            self.software_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "unique-id"):
                            self.unique_id = value
                            self.unique_id.value_namespace = name_space
                            self.unique_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "unrecognized-fru"):
                            self.unrecognized_fru = value
                            self.unrecognized_fru.value_namespace = name_space
                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                        if(value_path == "vendor-type"):
                            self.vendor_type = value
                            self.vendor_type.value_namespace = name_space
                            self.vendor_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "xr-scoped"):
                            self.xr_scoped = value
                            self.xr_scoped.value_namespace = name_space
                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                class InvAssetBag(Entity):
                    """
                    Inventory Asset Bag
                    
                    .. attribute:: manufacturer_assembly_number
                    
                    	Manufacture Assembly number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_assembly_revision
                    
                    	Manufacture assembly revision
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_common_language_equipment_identifier
                    
                    	Common Language Equipment           Identifier number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_firmware_identifier
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_software_identifier
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: original_equipment_manufacturer_string
                    
                    	String containing OEM information           if applicable
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: part_number
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Entities.Entity_.Attributes.InvAssetBag, self).__init__()

                        self.yang_name = "inv-asset-bag"
                        self.yang_parent_name = "attributes"

                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                        self.part_number = YLeaf(YType.str, "part-number")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("manufacturer_assembly_number",
                                        "manufacturer_assembly_revision",
                                        "manufacturer_common_language_equipment_identifier",
                                        "manufacturer_firmware_identifier",
                                        "manufacturer_software_identifier",
                                        "original_equipment_manufacturer_string",
                                        "part_number") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Entities.Entity_.Attributes.InvAssetBag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Entities.Entity_.Attributes.InvAssetBag, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.manufacturer_assembly_number.is_set or
                            self.manufacturer_assembly_revision.is_set or
                            self.manufacturer_common_language_equipment_identifier.is_set or
                            self.manufacturer_firmware_identifier.is_set or
                            self.manufacturer_software_identifier.is_set or
                            self.original_equipment_manufacturer_string.is_set or
                            self.part_number.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                            self.part_number.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "inv-asset-bag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.part_number.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "manufacturer-assembly-number"):
                            self.manufacturer_assembly_number = value
                            self.manufacturer_assembly_number.value_namespace = name_space
                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-assembly-revision"):
                            self.manufacturer_assembly_revision = value
                            self.manufacturer_assembly_revision.value_namespace = name_space
                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                            self.manufacturer_common_language_equipment_identifier = value
                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-firmware-identifier"):
                            self.manufacturer_firmware_identifier = value
                            self.manufacturer_firmware_identifier.value_namespace = name_space
                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-software-identifier"):
                            self.manufacturer_software_identifier = value
                            self.manufacturer_software_identifier.value_namespace = name_space
                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "original-equipment-manufacturer-string"):
                            self.original_equipment_manufacturer_string = value
                            self.original_equipment_manufacturer_string.value_namespace = name_space
                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                        if(value_path == "part-number"):
                            self.part_number = value
                            self.part_number.value_namespace = name_space
                            self.part_number.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "attributes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "inv-asset-bag"):
                        if (self.inv_asset_bag is None):
                            self.inv_asset_bag = Inventory.Entities.Entity_.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                        return self.inv_asset_bag

                    if (child_yang_name == "inv-basic-bag"):
                        if (self.inv_basic_bag is None):
                            self.inv_basic_bag = Inventory.Entities.Entity_.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                        return self.inv_basic_bag

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "inv-asset-bag" or name == "inv-basic-bag"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.name.is_set or
                    (self.attributes is not None and self.attributes.has_data()) or
                    (self.subentities is not None and self.subentities.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.name.yfilter != YFilter.not_set or
                    (self.attributes is not None and self.attributes.has_operation()) or
                    (self.subentities is not None and self.subentities.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "entity" + "[name='" + self.name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-invmgr-oper:inventory/entities/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "attributes"):
                    if (self.attributes is None):
                        self.attributes = Inventory.Entities.Entity_.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                    return self.attributes

                if (child_yang_name == "subentities"):
                    if (self.subentities is None):
                        self.subentities = Inventory.Entities.Entity_.Subentities()
                        self.subentities.parent = self
                        self._children_name_map["subentities"] = "subentities"
                    return self.subentities

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "attributes" or name == "subentities" or name == "name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "name"):
                    self.name = value
                    self.name.value_namespace = name_space
                    self.name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.entity_:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.entity_:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "entities" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-invmgr-oper:inventory/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "entity"):
                for c in self.entity_:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Inventory.Entities.Entity_()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.entity_.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "entity"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Racks(Entity):
        """
        RackTable
        
        .. attribute:: rack
        
        	Rack name
        	**type**\: list of    :py:class:`Rack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack>`
        
        

        """

        _prefix = 'invmgr-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(Inventory.Racks, self).__init__()

            self.yang_name = "racks"
            self.yang_parent_name = "inventory"

            self.rack = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Inventory.Racks, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Inventory.Racks, self).__setattr__(name, value)


        class Rack(Entity):
            """
            Rack name
            
            .. attribute:: name  <key>
            
            	Rack name
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: attributes
            
            	Attributes
            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes>`
            
            .. attribute:: entity_
            
            	Entity information
            	**type**\:   :py:class:`Entity_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_>`
            
            .. attribute:: fantray
            
            	Fantray information
            	**type**\:   :py:class:`Fantray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray>`
            
            .. attribute:: powershelf
            
            	Powershelf information
            	**type**\:   :py:class:`Powershelf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf>`
            
            

            """

            _prefix = 'invmgr-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(Inventory.Racks.Rack, self).__init__()

                self.yang_name = "rack"
                self.yang_parent_name = "racks"

                self.name = YLeaf(YType.str, "name")

                self.attributes = Inventory.Racks.Rack.Attributes()
                self.attributes.parent = self
                self._children_name_map["attributes"] = "attributes"
                self._children_yang_names.add("attributes")

                self.entity_ = Inventory.Racks.Rack.Entity_()
                self.entity_.parent = self
                self._children_name_map["entity_"] = "entity"
                self._children_yang_names.add("entity")

                self.fantray = Inventory.Racks.Rack.Fantray()
                self.fantray.parent = self
                self._children_name_map["fantray"] = "fantray"
                self._children_yang_names.add("fantray")

                self.powershelf = Inventory.Racks.Rack.Powershelf()
                self.powershelf.parent = self
                self._children_name_map["powershelf"] = "powershelf"
                self._children_yang_names.add("powershelf")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Inventory.Racks.Rack, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Inventory.Racks.Rack, self).__setattr__(name, value)


            class Entity_(Entity):
                """
                Entity information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of    :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot>`
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Racks.Rack.Entity_, self).__init__()

                    self.yang_name = "entity"
                    self.yang_parent_name = "rack"

                    self.slot = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Inventory.Racks.Rack.Entity_, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Inventory.Racks.Rack.Entity_, self).__setattr__(name, value)


                class Slot(Entity):
                    """
                    Slot number
                    
                    .. attribute:: name  <key>
                    
                    	Slot name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes>`
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:   :py:class:`Tsi1S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S>`
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Entity_.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "entity"

                        self.name = YLeaf(YType.str, "name")

                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._children_yang_names.add("attributes")

                        self.tsi1s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"
                        self._children_yang_names.add("tsi1s")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Entity_.Slot, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Entity_.Slot, self).__setattr__(name, value)


                    class Tsi1S(Entity):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of    :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"

                            self.tsi1 = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S, self).__setattr__(name, value)


                        class Tsi1(Entity):
                            """
                            TSI1
                            
                            .. attribute:: name  <key>
                            
                            	TSI1
                            	**type**\:  str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes>`
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:   :py:class:`Tsi2S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"

                                self.name = YLeaf(YType.str, "name")

                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._children_yang_names.add("attributes")

                                self.tsi2s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"
                                self._children_yang_names.add("tsi2s")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)


                            class Tsi2S(Entity):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of    :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"

                                    self.tsi2 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)


                                class Tsi2(Entity):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  <key>
                                    
                                    	TSI2
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes>`
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:   :py:class:`Tsi3S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"

                                        self.name = YLeaf(YType.str, "name")

                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._children_yang_names.add("attributes")

                                        self.tsi3s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"
                                        self._children_yang_names.add("tsi3s")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)


                                    class Tsi3S(Entity):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of    :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"

                                            self.tsi3 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)


                                        class Tsi3(Entity):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  <key>
                                            
                                            	TSI3
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes>`
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:   :py:class:`Tsi4S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"

                                                self.name = YLeaf(YType.str, "name")

                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._children_yang_names.add("attributes")

                                                self.tsi4s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"
                                                self._children_yang_names.add("tsi4s")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)


                                            class Tsi4S(Entity):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of    :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"

                                                    self.tsi4 = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)


                                                class Tsi4(Entity):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  <key>
                                                    
                                                    	TSI4
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes>`
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:   :py:class:`Tsi5S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._children_yang_names.add("attributes")

                                                        self.tsi5s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"
                                                        self._children_yang_names.add("tsi5s")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)


                                                    class Tsi5S(Entity):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of    :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"

                                                            self.tsi5 = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)


                                                        class Tsi5(Entity):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  <key>
                                                            
                                                            	TSI5
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes>`
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:   :py:class:`Tsi6S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._children_yang_names.add("attributes")

                                                                self.tsi6s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"
                                                                self._children_yang_names.add("tsi6s")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("name") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)


                                                            class Tsi6S(Entity):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of    :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.tsi6 = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)


                                                                class Tsi6(Entity):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  <key>
                                                                    
                                                                    	TSI6
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes>`
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:   :py:class:`Tsi7S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._children_yang_names.add("attributes")

                                                                        self.tsi7s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"
                                                                        self._children_yang_names.add("tsi7s")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("name") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)


                                                                    class Tsi7S(Entity):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of    :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.tsi7 = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)


                                                                        class Tsi7(Entity):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  <key>
                                                                            
                                                                            	TSI7
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes>`
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:   :py:class:`Tsi8S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._children_yang_names.add("attributes")

                                                                                self.tsi8s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"
                                                                                self._children_yang_names.add("tsi8s")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("name") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)


                                                                            class Tsi8S(Entity):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of    :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.tsi8 = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)


                                                                                class Tsi8(Entity):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  <key>
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes>`
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:   :py:class:`Tsi9S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._children_yang_names.add("attributes")

                                                                                        self.tsi9s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"
                                                                                        self._children_yang_names.add("tsi9s")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)


                                                                                    class Tsi9S(Entity):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of    :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.tsi9 = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)


                                                                                        class Tsi9(Entity):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  <key>
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes>`
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:   :py:class:`Tsi10S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._children_yang_names.add("attributes")

                                                                                                self.tsi10s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                self._children_yang_names.add("tsi10s")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)


                                                                                            class Tsi10S(Entity):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of    :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.tsi10 = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)


                                                                                                class Tsi10(Entity):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  <key>
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes>`
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:   :py:class:`Tsi11S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._children_yang_names.add("attributes")

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                        self._children_yang_names.add("tsi11s")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)


                                                                                                    class Tsi11S(Entity):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of    :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.tsi11 = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)


                                                                                                        class Tsi11(Entity):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  <key>
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._children_yang_names.add("attributes")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)


                                                                                                            class Attributes(Entity):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                .. attribute:: module_done
                                                                                                                
                                                                                                                	Inventory EDM Module Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**default value**\: 1
                                                                                                                
                                                                                                                .. attribute:: node_id
                                                                                                                
                                                                                                                	Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                .. attribute:: vm_done
                                                                                                                
                                                                                                                	VM Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                .. attribute:: vm_node_id
                                                                                                                
                                                                                                                	VM Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"

                                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                    self._children_yang_names.add("threshold")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("module_done",
                                                                                                                                    "node_id",
                                                                                                                                    "vm_done",
                                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)


                                                                                                                class EnvSensorInfo(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("age_time_stamp",
                                                                                                                                        "alarm_type",
                                                                                                                                        "data_type",
                                                                                                                                        "device_description",
                                                                                                                                        "device_id",
                                                                                                                                        "field_validity_bitmap",
                                                                                                                                        "precision",
                                                                                                                                        "scale",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.age_time_stamp.is_set or
                                                                                                                            self.alarm_type.is_set or
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.device_description.is_set or
                                                                                                                            self.device_id.is_set or
                                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                                            self.precision.is_set or
                                                                                                                            self.scale.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                                            self.age_time_stamp = value
                                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "alarm-type"):
                                                                                                                            self.alarm_type = value
                                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-description"):
                                                                                                                            self.device_description = value
                                                                                                                            self.device_description.value_namespace = name_space
                                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-id"):
                                                                                                                            self.device_id = value
                                                                                                                            self.device_id.value_namespace = name_space
                                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                                            self.field_validity_bitmap = value
                                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "precision"):
                                                                                                                            self.precision = value
                                                                                                                            self.precision.value_namespace = name_space
                                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "scale"):
                                                                                                                            self.scale = value
                                                                                                                            self.scale.value_namespace = name_space
                                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class PwgInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("power_group_available_current",
                                                                                                                                        "power_group_drawn_current",
                                                                                                                                        "power_group_power_units",
                                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.power_group_available_current.is_set or
                                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                                            self.power_group_power_units.is_set or
                                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                                            self.power_group_available_current = value
                                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                                            self.power_group_drawn_current = value
                                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                                            self.power_group_power_units = value
                                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                                            self.power_group_redundancy_mode = value
                                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._children_yang_names.add("threshold")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("data_type",
                                                                                                                                        "description",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                                    class Threshold(Entity):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                            self.threshold_array = YList(self)

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in () and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                        class ThresholdArray(Entity):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_name",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_name.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-name"):
                                                                                                                                    self.threshold_name = value
                                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_data()):
                                                                                                                                    return True
                                                                                                                            return False

                                                                                                                        def has_operation(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_operation()):
                                                                                                                                    return True
                                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                                for c in self.threshold_array:
                                                                                                                                    segment = c.get_segment_path()
                                                                                                                                    if (segment_path == segment):
                                                                                                                                        return c
                                                                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                                c.parent = self
                                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                                self.threshold_array.append(c)
                                                                                                                                return c

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "threshold-array"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "threshold"):
                                                                                                                            if (self.threshold is None):
                                                                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                                self.threshold.parent = self
                                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                            return self.threshold

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class InvAssetBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                                        "manufacturer_software_identifier",
                                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                                            self.part_number.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                                            self.manufacturer_assembly_number = value
                                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                                            self.manufacturer_software_identifier = value
                                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "part-number"):
                                                                                                                            self.part_number = value
                                                                                                                            self.part_number.value_namespace = name_space
                                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                                class Threshold(Entity):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                                    class MajorLo(Entity):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalHi(Entity):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorHi(Entity):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MajorHi(Entity):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalLo(Entity):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorLo(Entity):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                                            if (self.critical_hi is None):
                                                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                                self.critical_hi.parent = self
                                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                            return self.critical_hi

                                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                                            if (self.critical_lo is None):
                                                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                                self.critical_lo.parent = self
                                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                            return self.critical_lo

                                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                                            if (self.major_hi is None):
                                                                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                                self.major_hi.parent = self
                                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                            return self.major_hi

                                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                                            if (self.major_lo is None):
                                                                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                                self.major_lo.parent = self
                                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                            return self.major_lo

                                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                                            if (self.minor_hi is None):
                                                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                                self.minor_hi.parent = self
                                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                            return self.minor_hi

                                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                                            if (self.minor_lo is None):
                                                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                                self.minor_lo.parent = self
                                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                            return self.minor_lo

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        pass


                                                                                                                class FruInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("card_administrative_state",
                                                                                                                                        "card_monitor_state",
                                                                                                                                        "card_operational_state",
                                                                                                                                        "card_reset_reason",
                                                                                                                                        "power_administrative_state",
                                                                                                                                        "power_current_measurement",
                                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                                    class CardUpTime(Entity):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.card_administrative_state.is_set or
                                                                                                                            self.card_monitor_state.is_set or
                                                                                                                            self.card_operational_state.is_set or
                                                                                                                            self.card_reset_reason.is_set or
                                                                                                                            self.power_administrative_state.is_set or
                                                                                                                            self.power_current_measurement.is_set or
                                                                                                                            self.power_operational_state.is_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                                            if (self.card_up_time is None):
                                                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                                self.card_up_time.parent = self
                                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                            return self.card_up_time

                                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                            return self.last_operational_state_change

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                                            self.card_administrative_state = value
                                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                                            self.card_monitor_state = value
                                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-operational-state"):
                                                                                                                            self.card_operational_state = value
                                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                                            self.card_reset_reason = value
                                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                                            self.power_administrative_state = value
                                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                                            self.power_current_measurement = value
                                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-operational-state"):
                                                                                                                            self.power_operational_state = value
                                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                                class InvBasicBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("alias",
                                                                                                                                        "asset_id_str",
                                                                                                                                        "asset_identification",
                                                                                                                                        "ceport",
                                                                                                                                        "chip_hardware_revision",
                                                                                                                                        "composite_class_code",
                                                                                                                                        "description",
                                                                                                                                        "environmental_monitor_path",
                                                                                                                                        "firmware_revision",
                                                                                                                                        "group_flag",
                                                                                                                                        "hardware_revision",
                                                                                                                                        "is_field_replaceable_unit",
                                                                                                                                        "manufacturer_asset_tags",
                                                                                                                                        "manufacturer_name",
                                                                                                                                        "memory_size",
                                                                                                                                        "model_name",
                                                                                                                                        "name",
                                                                                                                                        "new_deviation_number",
                                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                                        "redundancystate",
                                                                                                                                        "serial_number",
                                                                                                                                        "software_revision",
                                                                                                                                        "unique_id",
                                                                                                                                        "unrecognized_fru",
                                                                                                                                        "vendor_type",
                                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.alias.is_set or
                                                                                                                            self.asset_id_str.is_set or
                                                                                                                            self.asset_identification.is_set or
                                                                                                                            self.ceport.is_set or
                                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                                            self.composite_class_code.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                                            self.firmware_revision.is_set or
                                                                                                                            self.group_flag.is_set or
                                                                                                                            self.hardware_revision.is_set or
                                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                                            self.manufacturer_name.is_set or
                                                                                                                            self.memory_size.is_set or
                                                                                                                            self.model_name.is_set or
                                                                                                                            self.name.is_set or
                                                                                                                            self.new_deviation_number.is_set or
                                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                                            self.redundancystate.is_set or
                                                                                                                            self.serial_number.is_set or
                                                                                                                            self.software_revision.is_set or
                                                                                                                            self.unique_id.is_set or
                                                                                                                            self.unrecognized_fru.is_set or
                                                                                                                            self.vendor_type.is_set or
                                                                                                                            self.xr_scoped.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "alias"):
                                                                                                                            self.alias = value
                                                                                                                            self.alias.value_namespace = name_space
                                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-id-str"):
                                                                                                                            self.asset_id_str = value
                                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-identification"):
                                                                                                                            self.asset_identification = value
                                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "ceport"):
                                                                                                                            self.ceport = value
                                                                                                                            self.ceport.value_namespace = name_space
                                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                                            self.chip_hardware_revision = value
                                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "composite-class-code"):
                                                                                                                            self.composite_class_code = value
                                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                                            self.environmental_monitor_path = value
                                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "firmware-revision"):
                                                                                                                            self.firmware_revision = value
                                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "group-flag"):
                                                                                                                            self.group_flag = value
                                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "hardware-revision"):
                                                                                                                            self.hardware_revision = value
                                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                                            self.is_field_replaceable_unit = value
                                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                                            self.manufacturer_asset_tags = value
                                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                                            self.manufacturer_name = value
                                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "memory-size"):
                                                                                                                            self.memory_size = value
                                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "model-name"):
                                                                                                                            self.model_name = value
                                                                                                                            self.model_name.value_namespace = name_space
                                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "name"):
                                                                                                                            self.name = value
                                                                                                                            self.name.value_namespace = name_space
                                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                                            self.new_deviation_number = value
                                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "redundancystate"):
                                                                                                                            self.redundancystate = value
                                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "serial-number"):
                                                                                                                            self.serial_number = value
                                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "software-revision"):
                                                                                                                            self.software_revision = value
                                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unique-id"):
                                                                                                                            self.unique_id = value
                                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                                            self.unrecognized_fru = value
                                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "vendor-type"):
                                                                                                                            self.vendor_type = value
                                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "xr-scoped"):
                                                                                                                            self.xr_scoped = value
                                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                                class InvEepromInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("description",
                                                                                                                                        "has_eeprom",
                                                                                                                                        "inv_card_type",
                                                                                                                                        "opaque_data",
                                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                                    class Eeprom(Entity):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._children_yang_names.add("rma")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("asset_alias",
                                                                                                                                            "asset_id",
                                                                                                                                            "base_mac_address1",
                                                                                                                                            "base_mac_address2",
                                                                                                                                            "base_mac_address3",
                                                                                                                                            "base_mac_address4",
                                                                                                                                            "block_checksum",
                                                                                                                                            "block_count",
                                                                                                                                            "block_length",
                                                                                                                                            "block_signature",
                                                                                                                                            "block_version",
                                                                                                                                            "chassis_sid",
                                                                                                                                            "clei",
                                                                                                                                            "controller_family",
                                                                                                                                            "controller_type",
                                                                                                                                            "description",
                                                                                                                                            "dev_num1",
                                                                                                                                            "dev_num2",
                                                                                                                                            "dev_num3",
                                                                                                                                            "dev_num4",
                                                                                                                                            "dev_num5",
                                                                                                                                            "dev_num6",
                                                                                                                                            "dev_num7",
                                                                                                                                            "eci",
                                                                                                                                            "eeprom_size",
                                                                                                                                            "engineer_use",
                                                                                                                                            "fru_major_type",
                                                                                                                                            "fru_minor_type",
                                                                                                                                            "hw_version",
                                                                                                                                            "hwid",
                                                                                                                                            "idprom_format_rev",
                                                                                                                                            "mac_add_blk_size1",
                                                                                                                                            "mac_add_blk_size2",
                                                                                                                                            "mac_add_blk_size3",
                                                                                                                                            "mac_add_blk_size4",
                                                                                                                                            "manu_test_data",
                                                                                                                                            "mfg_bits",
                                                                                                                                            "mfg_deviation",
                                                                                                                                            "oem_string",
                                                                                                                                            "part_number",
                                                                                                                                            "part_revision",
                                                                                                                                            "pca_num",
                                                                                                                                            "pcavid",
                                                                                                                                            "pcb_serial_num",
                                                                                                                                            "pid",
                                                                                                                                            "power_consumption",
                                                                                                                                            "power_supply_type",
                                                                                                                                            "product_id",
                                                                                                                                            "rma_code",
                                                                                                                                            "serial_number",
                                                                                                                                            "snmpoid",
                                                                                                                                            "top_assem_part_num",
                                                                                                                                            "top_assem_vid",
                                                                                                                                            "udi_description",
                                                                                                                                            "udi_name",
                                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                        class Rma(Entity):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("rma_history",
                                                                                                                                                "rma_number",
                                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.rma_history.is_set or
                                                                                                                                    self.rma_number.is_set or
                                                                                                                                    self.test_history.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "rma-history"):
                                                                                                                                    self.rma_history = value
                                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "rma-number"):
                                                                                                                                    self.rma_number = value
                                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "test-history"):
                                                                                                                                    self.test_history = value
                                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.asset_alias.is_set or
                                                                                                                                self.asset_id.is_set or
                                                                                                                                self.base_mac_address1.is_set or
                                                                                                                                self.base_mac_address2.is_set or
                                                                                                                                self.base_mac_address3.is_set or
                                                                                                                                self.base_mac_address4.is_set or
                                                                                                                                self.block_checksum.is_set or
                                                                                                                                self.block_count.is_set or
                                                                                                                                self.block_length.is_set or
                                                                                                                                self.block_signature.is_set or
                                                                                                                                self.block_version.is_set or
                                                                                                                                self.chassis_sid.is_set or
                                                                                                                                self.clei.is_set or
                                                                                                                                self.controller_family.is_set or
                                                                                                                                self.controller_type.is_set or
                                                                                                                                self.description.is_set or
                                                                                                                                self.dev_num1.is_set or
                                                                                                                                self.dev_num2.is_set or
                                                                                                                                self.dev_num3.is_set or
                                                                                                                                self.dev_num4.is_set or
                                                                                                                                self.dev_num5.is_set or
                                                                                                                                self.dev_num6.is_set or
                                                                                                                                self.dev_num7.is_set or
                                                                                                                                self.eci.is_set or
                                                                                                                                self.eeprom_size.is_set or
                                                                                                                                self.engineer_use.is_set or
                                                                                                                                self.fru_major_type.is_set or
                                                                                                                                self.fru_minor_type.is_set or
                                                                                                                                self.hw_version.is_set or
                                                                                                                                self.hwid.is_set or
                                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                                self.manu_test_data.is_set or
                                                                                                                                self.mfg_bits.is_set or
                                                                                                                                self.mfg_deviation.is_set or
                                                                                                                                self.oem_string.is_set or
                                                                                                                                self.part_number.is_set or
                                                                                                                                self.part_revision.is_set or
                                                                                                                                self.pca_num.is_set or
                                                                                                                                self.pcavid.is_set or
                                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                                self.pid.is_set or
                                                                                                                                self.power_consumption.is_set or
                                                                                                                                self.power_supply_type.is_set or
                                                                                                                                self.product_id.is_set or
                                                                                                                                self.rma_code.is_set or
                                                                                                                                self.serial_number.is_set or
                                                                                                                                self.snmpoid.is_set or
                                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                                self.top_assem_vid.is_set or
                                                                                                                                self.udi_description.is_set or
                                                                                                                                self.udi_name.is_set or
                                                                                                                                self.vid.is_set or
                                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "rma"):
                                                                                                                                if (self.rma is None):
                                                                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                                    self.rma.parent = self
                                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                                return self.rma

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "asset-alias"):
                                                                                                                                self.asset_alias = value
                                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "asset-id"):
                                                                                                                                self.asset_id = value
                                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                                self.base_mac_address1 = value
                                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                                self.base_mac_address2 = value
                                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                                self.base_mac_address3 = value
                                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                                self.base_mac_address4 = value
                                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-checksum"):
                                                                                                                                self.block_checksum = value
                                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-count"):
                                                                                                                                self.block_count = value
                                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-length"):
                                                                                                                                self.block_length = value
                                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-signature"):
                                                                                                                                self.block_signature = value
                                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-version"):
                                                                                                                                self.block_version = value
                                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                                self.chassis_sid = value
                                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "clei"):
                                                                                                                                self.clei = value
                                                                                                                                self.clei.value_namespace = name_space
                                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-family"):
                                                                                                                                self.controller_family = value
                                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-type"):
                                                                                                                                self.controller_type = value
                                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "description"):
                                                                                                                                self.description = value
                                                                                                                                self.description.value_namespace = name_space
                                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num1"):
                                                                                                                                self.dev_num1 = value
                                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num2"):
                                                                                                                                self.dev_num2 = value
                                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num3"):
                                                                                                                                self.dev_num3 = value
                                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num4"):
                                                                                                                                self.dev_num4 = value
                                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num5"):
                                                                                                                                self.dev_num5 = value
                                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num6"):
                                                                                                                                self.dev_num6 = value
                                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num7"):
                                                                                                                                self.dev_num7 = value
                                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eci"):
                                                                                                                                self.eci = value
                                                                                                                                self.eci.value_namespace = name_space
                                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                                self.eeprom_size = value
                                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "engineer-use"):
                                                                                                                                self.engineer_use = value
                                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                                self.fru_major_type = value
                                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                                self.fru_minor_type = value
                                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hw-version"):
                                                                                                                                self.hw_version = value
                                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hwid"):
                                                                                                                                self.hwid = value
                                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                                self.idprom_format_rev = value
                                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                                self.manu_test_data = value
                                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                                self.mfg_bits = value
                                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                                self.mfg_deviation = value
                                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "oem-string"):
                                                                                                                                self.oem_string = value
                                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-number"):
                                                                                                                                self.part_number = value
                                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-revision"):
                                                                                                                                self.part_revision = value
                                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pca-num"):
                                                                                                                                self.pca_num = value
                                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcavid"):
                                                                                                                                self.pcavid = value
                                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                                self.pcb_serial_num = value
                                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pid"):
                                                                                                                                self.pid = value
                                                                                                                                self.pid.value_namespace = name_space
                                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-consumption"):
                                                                                                                                self.power_consumption = value
                                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                                self.power_supply_type = value
                                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "product-id"):
                                                                                                                                self.product_id = value
                                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "rma-code"):
                                                                                                                                self.rma_code = value
                                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "serial-number"):
                                                                                                                                self.serial_number = value
                                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "snmpoid"):
                                                                                                                                self.snmpoid = value
                                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                                self.top_assem_part_num = value
                                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                                self.top_assem_vid = value
                                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-description"):
                                                                                                                                self.udi_description = value
                                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-name"):
                                                                                                                                self.udi_name = value
                                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "vid"):
                                                                                                                                self.vid = value
                                                                                                                                self.vid.value_namespace = name_space
                                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.description.is_set or
                                                                                                                            self.has_eeprom.is_set or
                                                                                                                            self.inv_card_type.is_set or
                                                                                                                            self.opaque_data.is_set or
                                                                                                                            self.opaque_data_size.is_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                                            if (self.eeprom is None):
                                                                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                                self.eeprom.parent = self
                                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                            return self.eeprom

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "has-eeprom"):
                                                                                                                            self.has_eeprom = value
                                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "inv-card-type"):
                                                                                                                            self.inv_card_type = value
                                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data"):
                                                                                                                            self.opaque_data = value
                                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                                            self.opaque_data_size = value
                                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.module_done.is_set or
                                                                                                                        self.node_id.is_set or
                                                                                                                        self.vm_done.is_set or
                                                                                                                        self.vm_node_id.is_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                                        if (self.env_sensor_info is None):
                                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                            self.env_sensor_info.parent = self
                                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                        return self.env_sensor_info

                                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                        return self.env_sensor_info_xml

                                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                                        if (self.fru_info is None):
                                                                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                            self.fru_info.parent = self
                                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                                        return self.fru_info

                                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                                        if (self.inv_asset_bag is None):
                                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                            self.inv_asset_bag.parent = self
                                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                        return self.inv_asset_bag

                                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                                        if (self.inv_basic_bag is None):
                                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                            self.inv_basic_bag.parent = self
                                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                        return self.inv_basic_bag

                                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                        return self.inv_eeprom_info

                                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                                        if (self.pwg_info is None):
                                                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                            self.pwg_info.parent = self
                                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                        return self.pwg_info

                                                                                                                    if (child_yang_name == "threshold"):
                                                                                                                        if (self.threshold is None):
                                                                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                            self.threshold.parent = self
                                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                                        return self.threshold

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "module-done"):
                                                                                                                        self.module_done = value
                                                                                                                        self.module_done.value_namespace = name_space
                                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "node-id"):
                                                                                                                        self.node_id = value
                                                                                                                        self.node_id.value_namespace = name_space
                                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-done"):
                                                                                                                        self.vm_done = value
                                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-node-id"):
                                                                                                                        self.vm_node_id = value
                                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.name.is_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "tsi11" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "attributes"):
                                                                                                                    if (self.attributes is None):
                                                                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                        self.attributes.parent = self
                                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                                    return self.attributes

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "attributes" or name == "name"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "tsi11s" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "tsi11"):
                                                                                                                for c in self.tsi11:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.tsi11.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "tsi11"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class Attributes(Entity):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        .. attribute:: module_done
                                                                                                        
                                                                                                        	Inventory EDM Module Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**default value**\: 1
                                                                                                        
                                                                                                        .. attribute:: node_id
                                                                                                        
                                                                                                        	Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        .. attribute:: vm_done
                                                                                                        
                                                                                                        	VM Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        .. attribute:: vm_node_id
                                                                                                        
                                                                                                        	VM Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                            self._children_yang_names.add("fru-info")

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                            self._children_yang_names.add("pwg-info")

                                                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                            self._children_yang_names.add("threshold")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("module_done",
                                                                                                                            "node_id",
                                                                                                                            "vm_done",
                                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)


                                                                                                        class EnvSensorInfo(Entity):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("age_time_stamp",
                                                                                                                                "alarm_type",
                                                                                                                                "data_type",
                                                                                                                                "device_description",
                                                                                                                                "device_id",
                                                                                                                                "field_validity_bitmap",
                                                                                                                                "precision",
                                                                                                                                "scale",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.age_time_stamp.is_set or
                                                                                                                    self.alarm_type.is_set or
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.device_description.is_set or
                                                                                                                    self.device_id.is_set or
                                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                                    self.precision.is_set or
                                                                                                                    self.scale.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "age-time-stamp"):
                                                                                                                    self.age_time_stamp = value
                                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "alarm-type"):
                                                                                                                    self.alarm_type = value
                                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-description"):
                                                                                                                    self.device_description = value
                                                                                                                    self.device_description.value_namespace = name_space
                                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-id"):
                                                                                                                    self.device_id = value
                                                                                                                    self.device_id.value_namespace = name_space
                                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                                    self.field_validity_bitmap = value
                                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "precision"):
                                                                                                                    self.precision = value
                                                                                                                    self.precision.value_namespace = name_space
                                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "scale"):
                                                                                                                    self.scale = value
                                                                                                                    self.scale.value_namespace = name_space
                                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class PwgInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("power_group_available_current",
                                                                                                                                "power_group_drawn_current",
                                                                                                                                "power_group_power_units",
                                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.power_group_available_current.is_set or
                                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                                    self.power_group_power_units.is_set or
                                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "power-group-available-current"):
                                                                                                                    self.power_group_available_current = value
                                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                                    self.power_group_drawn_current = value
                                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-power-units"):
                                                                                                                    self.power_group_power_units = value
                                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                                    self.power_group_redundancy_mode = value
                                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                        class EnvSensorInfoXml(Entity):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._children_yang_names.add("threshold")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("data_type",
                                                                                                                                "description",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                            class Threshold(Entity):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                    self.threshold_array = YList(self)

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in () and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                class ThresholdArray(Entity):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"

                                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_name",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_name.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-name"):
                                                                                                                            self.threshold_name = value
                                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_data()):
                                                                                                                            return True
                                                                                                                    return False

                                                                                                                def has_operation(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_operation()):
                                                                                                                            return True
                                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                                        for c in self.threshold_array:
                                                                                                                            segment = c.get_segment_path()
                                                                                                                            if (segment_path == segment):
                                                                                                                                return c
                                                                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                        c.parent = self
                                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                                        self.threshold_array.append(c)
                                                                                                                        return c

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "threshold-array"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "threshold"):
                                                                                                                    if (self.threshold is None):
                                                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                    return self.threshold

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class InvAssetBag(Entity):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                                "manufacturer_assembly_revision",
                                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                                "manufacturer_software_identifier",
                                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                                "part_number") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                                    self.part_number.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                                    self.manufacturer_assembly_number = value
                                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                                    self.manufacturer_software_identifier = value
                                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "part-number"):
                                                                                                                    self.part_number = value
                                                                                                                    self.part_number.value_namespace = name_space
                                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                        class Threshold(Entity):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                self._children_yang_names.add("major-hi")

                                                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                self._children_yang_names.add("major-lo")

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._children_yang_names.add("minor-lo")


                                                                                                            class MajorLo(Entity):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalHi(Entity):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorHi(Entity):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MajorHi(Entity):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalLo(Entity):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorLo(Entity):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                                    if (self.critical_hi is None):
                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                    return self.critical_hi

                                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                                    if (self.critical_lo is None):
                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                    return self.critical_lo

                                                                                                                if (child_yang_name == "major-hi"):
                                                                                                                    if (self.major_hi is None):
                                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                    return self.major_hi

                                                                                                                if (child_yang_name == "major-lo"):
                                                                                                                    if (self.major_lo is None):
                                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                    return self.major_lo

                                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                                    if (self.minor_hi is None):
                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                    return self.minor_hi

                                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                                    if (self.minor_lo is None):
                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                    return self.minor_lo

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                pass


                                                                                                        class FruInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("card_administrative_state",
                                                                                                                                "card_monitor_state",
                                                                                                                                "card_operational_state",
                                                                                                                                "card_reset_reason",
                                                                                                                                "power_administrative_state",
                                                                                                                                "power_current_measurement",
                                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                            class LastOperationalStateChange(Entity):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                            class CardUpTime(Entity):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.card_administrative_state.is_set or
                                                                                                                    self.card_monitor_state.is_set or
                                                                                                                    self.card_operational_state.is_set or
                                                                                                                    self.card_reset_reason.is_set or
                                                                                                                    self.power_administrative_state.is_set or
                                                                                                                    self.power_current_measurement.is_set or
                                                                                                                    self.power_operational_state.is_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                                    if (self.card_up_time is None):
                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                    return self.card_up_time

                                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                                    if (self.last_operational_state_change is None):
                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                    return self.last_operational_state_change

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "card-administrative-state"):
                                                                                                                    self.card_administrative_state = value
                                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-monitor-state"):
                                                                                                                    self.card_monitor_state = value
                                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-operational-state"):
                                                                                                                    self.card_operational_state = value
                                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-reset-reason"):
                                                                                                                    self.card_reset_reason = value
                                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-administrative-state"):
                                                                                                                    self.power_administrative_state = value
                                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-current-measurement"):
                                                                                                                    self.power_current_measurement = value
                                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-operational-state"):
                                                                                                                    self.power_operational_state = value
                                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                        class InvBasicBag(Entity):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("alias",
                                                                                                                                "asset_id_str",
                                                                                                                                "asset_identification",
                                                                                                                                "ceport",
                                                                                                                                "chip_hardware_revision",
                                                                                                                                "composite_class_code",
                                                                                                                                "description",
                                                                                                                                "environmental_monitor_path",
                                                                                                                                "firmware_revision",
                                                                                                                                "group_flag",
                                                                                                                                "hardware_revision",
                                                                                                                                "is_field_replaceable_unit",
                                                                                                                                "manufacturer_asset_tags",
                                                                                                                                "manufacturer_name",
                                                                                                                                "memory_size",
                                                                                                                                "model_name",
                                                                                                                                "name",
                                                                                                                                "new_deviation_number",
                                                                                                                                "physical_layer_interface_module_type",
                                                                                                                                "redundancystate",
                                                                                                                                "serial_number",
                                                                                                                                "software_revision",
                                                                                                                                "unique_id",
                                                                                                                                "unrecognized_fru",
                                                                                                                                "vendor_type",
                                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.alias.is_set or
                                                                                                                    self.asset_id_str.is_set or
                                                                                                                    self.asset_identification.is_set or
                                                                                                                    self.ceport.is_set or
                                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                                    self.composite_class_code.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                                    self.firmware_revision.is_set or
                                                                                                                    self.group_flag.is_set or
                                                                                                                    self.hardware_revision.is_set or
                                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                                    self.manufacturer_name.is_set or
                                                                                                                    self.memory_size.is_set or
                                                                                                                    self.model_name.is_set or
                                                                                                                    self.name.is_set or
                                                                                                                    self.new_deviation_number.is_set or
                                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                                    self.redundancystate.is_set or
                                                                                                                    self.serial_number.is_set or
                                                                                                                    self.software_revision.is_set or
                                                                                                                    self.unique_id.is_set or
                                                                                                                    self.unrecognized_fru.is_set or
                                                                                                                    self.vendor_type.is_set or
                                                                                                                    self.xr_scoped.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "alias"):
                                                                                                                    self.alias = value
                                                                                                                    self.alias.value_namespace = name_space
                                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-id-str"):
                                                                                                                    self.asset_id_str = value
                                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-identification"):
                                                                                                                    self.asset_identification = value
                                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "ceport"):
                                                                                                                    self.ceport = value
                                                                                                                    self.ceport.value_namespace = name_space
                                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                                    self.chip_hardware_revision = value
                                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "composite-class-code"):
                                                                                                                    self.composite_class_code = value
                                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                                    self.environmental_monitor_path = value
                                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "firmware-revision"):
                                                                                                                    self.firmware_revision = value
                                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "group-flag"):
                                                                                                                    self.group_flag = value
                                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "hardware-revision"):
                                                                                                                    self.hardware_revision = value
                                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                                    self.is_field_replaceable_unit = value
                                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                                    self.manufacturer_asset_tags = value
                                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-name"):
                                                                                                                    self.manufacturer_name = value
                                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "memory-size"):
                                                                                                                    self.memory_size = value
                                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "model-name"):
                                                                                                                    self.model_name = value
                                                                                                                    self.model_name.value_namespace = name_space
                                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "new-deviation-number"):
                                                                                                                    self.new_deviation_number = value
                                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "redundancystate"):
                                                                                                                    self.redundancystate = value
                                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "serial-number"):
                                                                                                                    self.serial_number = value
                                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "software-revision"):
                                                                                                                    self.software_revision = value
                                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unique-id"):
                                                                                                                    self.unique_id = value
                                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                                    self.unrecognized_fru = value
                                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "vendor-type"):
                                                                                                                    self.vendor_type = value
                                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "xr-scoped"):
                                                                                                                    self.xr_scoped = value
                                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                        class InvEepromInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._children_yang_names.add("eeprom")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("description",
                                                                                                                                "has_eeprom",
                                                                                                                                "inv_card_type",
                                                                                                                                "opaque_data",
                                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                            class Eeprom(Entity):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._children_yang_names.add("rma")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("asset_alias",
                                                                                                                                    "asset_id",
                                                                                                                                    "base_mac_address1",
                                                                                                                                    "base_mac_address2",
                                                                                                                                    "base_mac_address3",
                                                                                                                                    "base_mac_address4",
                                                                                                                                    "block_checksum",
                                                                                                                                    "block_count",
                                                                                                                                    "block_length",
                                                                                                                                    "block_signature",
                                                                                                                                    "block_version",
                                                                                                                                    "chassis_sid",
                                                                                                                                    "clei",
                                                                                                                                    "controller_family",
                                                                                                                                    "controller_type",
                                                                                                                                    "description",
                                                                                                                                    "dev_num1",
                                                                                                                                    "dev_num2",
                                                                                                                                    "dev_num3",
                                                                                                                                    "dev_num4",
                                                                                                                                    "dev_num5",
                                                                                                                                    "dev_num6",
                                                                                                                                    "dev_num7",
                                                                                                                                    "eci",
                                                                                                                                    "eeprom_size",
                                                                                                                                    "engineer_use",
                                                                                                                                    "fru_major_type",
                                                                                                                                    "fru_minor_type",
                                                                                                                                    "hw_version",
                                                                                                                                    "hwid",
                                                                                                                                    "idprom_format_rev",
                                                                                                                                    "mac_add_blk_size1",
                                                                                                                                    "mac_add_blk_size2",
                                                                                                                                    "mac_add_blk_size3",
                                                                                                                                    "mac_add_blk_size4",
                                                                                                                                    "manu_test_data",
                                                                                                                                    "mfg_bits",
                                                                                                                                    "mfg_deviation",
                                                                                                                                    "oem_string",
                                                                                                                                    "part_number",
                                                                                                                                    "part_revision",
                                                                                                                                    "pca_num",
                                                                                                                                    "pcavid",
                                                                                                                                    "pcb_serial_num",
                                                                                                                                    "pid",
                                                                                                                                    "power_consumption",
                                                                                                                                    "power_supply_type",
                                                                                                                                    "product_id",
                                                                                                                                    "rma_code",
                                                                                                                                    "serial_number",
                                                                                                                                    "snmpoid",
                                                                                                                                    "top_assem_part_num",
                                                                                                                                    "top_assem_vid",
                                                                                                                                    "udi_description",
                                                                                                                                    "udi_name",
                                                                                                                                    "vid") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                class Rma(Entity):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("rma_history",
                                                                                                                                        "rma_number",
                                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.rma_history.is_set or
                                                                                                                            self.rma_number.is_set or
                                                                                                                            self.test_history.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "rma-history"):
                                                                                                                            self.rma_history = value
                                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "rma-number"):
                                                                                                                            self.rma_number = value
                                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "test-history"):
                                                                                                                            self.test_history = value
                                                                                                                            self.test_history.value_namespace = name_space
                                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.asset_alias.is_set or
                                                                                                                        self.asset_id.is_set or
                                                                                                                        self.base_mac_address1.is_set or
                                                                                                                        self.base_mac_address2.is_set or
                                                                                                                        self.base_mac_address3.is_set or
                                                                                                                        self.base_mac_address4.is_set or
                                                                                                                        self.block_checksum.is_set or
                                                                                                                        self.block_count.is_set or
                                                                                                                        self.block_length.is_set or
                                                                                                                        self.block_signature.is_set or
                                                                                                                        self.block_version.is_set or
                                                                                                                        self.chassis_sid.is_set or
                                                                                                                        self.clei.is_set or
                                                                                                                        self.controller_family.is_set or
                                                                                                                        self.controller_type.is_set or
                                                                                                                        self.description.is_set or
                                                                                                                        self.dev_num1.is_set or
                                                                                                                        self.dev_num2.is_set or
                                                                                                                        self.dev_num3.is_set or
                                                                                                                        self.dev_num4.is_set or
                                                                                                                        self.dev_num5.is_set or
                                                                                                                        self.dev_num6.is_set or
                                                                                                                        self.dev_num7.is_set or
                                                                                                                        self.eci.is_set or
                                                                                                                        self.eeprom_size.is_set or
                                                                                                                        self.engineer_use.is_set or
                                                                                                                        self.fru_major_type.is_set or
                                                                                                                        self.fru_minor_type.is_set or
                                                                                                                        self.hw_version.is_set or
                                                                                                                        self.hwid.is_set or
                                                                                                                        self.idprom_format_rev.is_set or
                                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                                        self.manu_test_data.is_set or
                                                                                                                        self.mfg_bits.is_set or
                                                                                                                        self.mfg_deviation.is_set or
                                                                                                                        self.oem_string.is_set or
                                                                                                                        self.part_number.is_set or
                                                                                                                        self.part_revision.is_set or
                                                                                                                        self.pca_num.is_set or
                                                                                                                        self.pcavid.is_set or
                                                                                                                        self.pcb_serial_num.is_set or
                                                                                                                        self.pid.is_set or
                                                                                                                        self.power_consumption.is_set or
                                                                                                                        self.power_supply_type.is_set or
                                                                                                                        self.product_id.is_set or
                                                                                                                        self.rma_code.is_set or
                                                                                                                        self.serial_number.is_set or
                                                                                                                        self.snmpoid.is_set or
                                                                                                                        self.top_assem_part_num.is_set or
                                                                                                                        self.top_assem_vid.is_set or
                                                                                                                        self.udi_description.is_set or
                                                                                                                        self.udi_name.is_set or
                                                                                                                        self.vid.is_set or
                                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "rma"):
                                                                                                                        if (self.rma is None):
                                                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                        return self.rma

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "asset-alias"):
                                                                                                                        self.asset_alias = value
                                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "asset-id"):
                                                                                                                        self.asset_id = value
                                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                                        self.base_mac_address1 = value
                                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                                        self.base_mac_address2 = value
                                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                                        self.base_mac_address3 = value
                                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                                        self.base_mac_address4 = value
                                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-checksum"):
                                                                                                                        self.block_checksum = value
                                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-count"):
                                                                                                                        self.block_count = value
                                                                                                                        self.block_count.value_namespace = name_space
                                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-length"):
                                                                                                                        self.block_length = value
                                                                                                                        self.block_length.value_namespace = name_space
                                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-signature"):
                                                                                                                        self.block_signature = value
                                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-version"):
                                                                                                                        self.block_version = value
                                                                                                                        self.block_version.value_namespace = name_space
                                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "chassis-sid"):
                                                                                                                        self.chassis_sid = value
                                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "clei"):
                                                                                                                        self.clei = value
                                                                                                                        self.clei.value_namespace = name_space
                                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-family"):
                                                                                                                        self.controller_family = value
                                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-type"):
                                                                                                                        self.controller_type = value
                                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "description"):
                                                                                                                        self.description = value
                                                                                                                        self.description.value_namespace = name_space
                                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num1"):
                                                                                                                        self.dev_num1 = value
                                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num2"):
                                                                                                                        self.dev_num2 = value
                                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num3"):
                                                                                                                        self.dev_num3 = value
                                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num4"):
                                                                                                                        self.dev_num4 = value
                                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num5"):
                                                                                                                        self.dev_num5 = value
                                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num6"):
                                                                                                                        self.dev_num6 = value
                                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num7"):
                                                                                                                        self.dev_num7 = value
                                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eci"):
                                                                                                                        self.eci = value
                                                                                                                        self.eci.value_namespace = name_space
                                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eeprom-size"):
                                                                                                                        self.eeprom_size = value
                                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "engineer-use"):
                                                                                                                        self.engineer_use = value
                                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-major-type"):
                                                                                                                        self.fru_major_type = value
                                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                                        self.fru_minor_type = value
                                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hw-version"):
                                                                                                                        self.hw_version = value
                                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hwid"):
                                                                                                                        self.hwid = value
                                                                                                                        self.hwid.value_namespace = name_space
                                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                                        self.idprom_format_rev = value
                                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                                        self.mac_add_blk_size1 = value
                                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                                        self.mac_add_blk_size2 = value
                                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                                        self.mac_add_blk_size3 = value
                                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                                        self.mac_add_blk_size4 = value
                                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "manu-test-data"):
                                                                                                                        self.manu_test_data = value
                                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-bits"):
                                                                                                                        self.mfg_bits = value
                                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                                        self.mfg_deviation = value
                                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "oem-string"):
                                                                                                                        self.oem_string = value
                                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-number"):
                                                                                                                        self.part_number = value
                                                                                                                        self.part_number.value_namespace = name_space
                                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-revision"):
                                                                                                                        self.part_revision = value
                                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pca-num"):
                                                                                                                        self.pca_num = value
                                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcavid"):
                                                                                                                        self.pcavid = value
                                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                                        self.pcb_serial_num = value
                                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pid"):
                                                                                                                        self.pid = value
                                                                                                                        self.pid.value_namespace = name_space
                                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-consumption"):
                                                                                                                        self.power_consumption = value
                                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-supply-type"):
                                                                                                                        self.power_supply_type = value
                                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "product-id"):
                                                                                                                        self.product_id = value
                                                                                                                        self.product_id.value_namespace = name_space
                                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "rma-code"):
                                                                                                                        self.rma_code = value
                                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "serial-number"):
                                                                                                                        self.serial_number = value
                                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "snmpoid"):
                                                                                                                        self.snmpoid = value
                                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                                        self.top_assem_part_num = value
                                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                                        self.top_assem_vid = value
                                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-description"):
                                                                                                                        self.udi_description = value
                                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-name"):
                                                                                                                        self.udi_name = value
                                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vid"):
                                                                                                                        self.vid = value
                                                                                                                        self.vid.value_namespace = name_space
                                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.description.is_set or
                                                                                                                    self.has_eeprom.is_set or
                                                                                                                    self.inv_card_type.is_set or
                                                                                                                    self.opaque_data.is_set or
                                                                                                                    self.opaque_data_size.is_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "eeprom"):
                                                                                                                    if (self.eeprom is None):
                                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                    return self.eeprom

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "has-eeprom"):
                                                                                                                    self.has_eeprom = value
                                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "inv-card-type"):
                                                                                                                    self.inv_card_type = value
                                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data"):
                                                                                                                    self.opaque_data = value
                                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data-size"):
                                                                                                                    self.opaque_data_size = value
                                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.module_done.is_set or
                                                                                                                self.node_id.is_set or
                                                                                                                self.vm_done.is_set or
                                                                                                                self.vm_node_id.is_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "attributes" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                                if (self.env_sensor_info is None):
                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                return self.env_sensor_info

                                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                return self.env_sensor_info_xml

                                                                                                            if (child_yang_name == "fru-info"):
                                                                                                                if (self.fru_info is None):
                                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                return self.fru_info

                                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                                if (self.inv_asset_bag is None):
                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                return self.inv_asset_bag

                                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                                if (self.inv_basic_bag is None):
                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                return self.inv_basic_bag

                                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                                if (self.inv_eeprom_info is None):
                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                return self.inv_eeprom_info

                                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                                if (self.pwg_info is None):
                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                return self.pwg_info

                                                                                                            if (child_yang_name == "threshold"):
                                                                                                                if (self.threshold is None):
                                                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                return self.threshold

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "module-done"):
                                                                                                                self.module_done = value
                                                                                                                self.module_done.value_namespace = name_space
                                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "node-id"):
                                                                                                                self.node_id = value
                                                                                                                self.node_id.value_namespace = name_space
                                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-done"):
                                                                                                                self.vm_done = value
                                                                                                                self.vm_done.value_namespace = name_space
                                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-node-id"):
                                                                                                                self.vm_node_id = value
                                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.name.is_set or
                                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "tsi10" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "attributes"):
                                                                                                            if (self.attributes is None):
                                                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                            return self.attributes

                                                                                                        if (child_yang_name == "tsi11s"):
                                                                                                            if (self.tsi11s is None):
                                                                                                                self.tsi11s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                                self.tsi11s.parent = self
                                                                                                                self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                            return self.tsi11s

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "attributes" or name == "tsi11s" or name == "name"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "tsi10s" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "tsi10"):
                                                                                                        for c in self.tsi10:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.tsi10.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "tsi10"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class Attributes(Entity):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                .. attribute:: module_done
                                                                                                
                                                                                                	Inventory EDM Module Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**default value**\: 1
                                                                                                
                                                                                                .. attribute:: node_id
                                                                                                
                                                                                                	Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                .. attribute:: vm_done
                                                                                                
                                                                                                	VM Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                .. attribute:: vm_node_id
                                                                                                
                                                                                                	VM Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                    self._children_yang_names.add("threshold")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("module_done",
                                                                                                                    "node_id",
                                                                                                                    "vm_done",
                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)


                                                                                                class EnvSensorInfo(Entity):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("age_time_stamp",
                                                                                                                        "alarm_type",
                                                                                                                        "data_type",
                                                                                                                        "device_description",
                                                                                                                        "device_id",
                                                                                                                        "field_validity_bitmap",
                                                                                                                        "precision",
                                                                                                                        "scale",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.age_time_stamp.is_set or
                                                                                                            self.alarm_type.is_set or
                                                                                                            self.data_type.is_set or
                                                                                                            self.device_description.is_set or
                                                                                                            self.device_id.is_set or
                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                            self.precision.is_set or
                                                                                                            self.scale.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                            self.age_time_stamp = value
                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "alarm-type"):
                                                                                                            self.alarm_type = value
                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-description"):
                                                                                                            self.device_description = value
                                                                                                            self.device_description.value_namespace = name_space
                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-id"):
                                                                                                            self.device_id = value
                                                                                                            self.device_id.value_namespace = name_space
                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                            self.field_validity_bitmap = value
                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "precision"):
                                                                                                            self.precision = value
                                                                                                            self.precision.value_namespace = name_space
                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "scale"):
                                                                                                            self.scale = value
                                                                                                            self.scale.value_namespace = name_space
                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class PwgInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("power_group_available_current",
                                                                                                                        "power_group_drawn_current",
                                                                                                                        "power_group_power_units",
                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.power_group_available_current.is_set or
                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                            self.power_group_power_units.is_set or
                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                            self.power_group_available_current = value
                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                            self.power_group_drawn_current = value
                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                            self.power_group_power_units = value
                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                            self.power_group_redundancy_mode = value
                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._children_yang_names.add("threshold")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("data_type",
                                                                                                                        "description",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                    class Threshold(Entity):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                            self.threshold_array = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                        class ThresholdArray(Entity):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_name",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_name.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-name"):
                                                                                                                    self.threshold_name = value
                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                for c in self.threshold_array:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.threshold_array.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "threshold-array"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.data_type.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set or
                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "threshold"):
                                                                                                            if (self.threshold is None):
                                                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                            return self.threshold

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class InvAssetBag(Entity):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                        "manufacturer_software_identifier",
                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                            self.part_number.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                            self.manufacturer_assembly_number = value
                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                            self.manufacturer_software_identifier = value
                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "part-number"):
                                                                                                            self.part_number = value
                                                                                                            self.part_number.value_namespace = name_space
                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                class Threshold(Entity):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                    class MajorLo(Entity):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalHi(Entity):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorHi(Entity):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MajorHi(Entity):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalLo(Entity):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorLo(Entity):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                            if (self.critical_hi is None):
                                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                            return self.critical_hi

                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                            if (self.critical_lo is None):
                                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                            return self.critical_lo

                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                            if (self.major_hi is None):
                                                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                            return self.major_hi

                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                            if (self.major_lo is None):
                                                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                            return self.major_lo

                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                            if (self.minor_hi is None):
                                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                            return self.minor_hi

                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                            if (self.minor_lo is None):
                                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                            return self.minor_lo

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        pass


                                                                                                class FruInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("card_administrative_state",
                                                                                                                        "card_monitor_state",
                                                                                                                        "card_operational_state",
                                                                                                                        "card_reset_reason",
                                                                                                                        "power_administrative_state",
                                                                                                                        "power_current_measurement",
                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                    class CardUpTime(Entity):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.card_administrative_state.is_set or
                                                                                                            self.card_monitor_state.is_set or
                                                                                                            self.card_operational_state.is_set or
                                                                                                            self.card_reset_reason.is_set or
                                                                                                            self.power_administrative_state.is_set or
                                                                                                            self.power_current_measurement.is_set or
                                                                                                            self.power_operational_state.is_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                            if (self.card_up_time is None):
                                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                            return self.card_up_time

                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                            return self.last_operational_state_change

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                            self.card_administrative_state = value
                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                            self.card_monitor_state = value
                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-operational-state"):
                                                                                                            self.card_operational_state = value
                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                            self.card_reset_reason = value
                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                            self.power_administrative_state = value
                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                            self.power_current_measurement = value
                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-operational-state"):
                                                                                                            self.power_operational_state = value
                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                class InvBasicBag(Entity):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("alias",
                                                                                                                        "asset_id_str",
                                                                                                                        "asset_identification",
                                                                                                                        "ceport",
                                                                                                                        "chip_hardware_revision",
                                                                                                                        "composite_class_code",
                                                                                                                        "description",
                                                                                                                        "environmental_monitor_path",
                                                                                                                        "firmware_revision",
                                                                                                                        "group_flag",
                                                                                                                        "hardware_revision",
                                                                                                                        "is_field_replaceable_unit",
                                                                                                                        "manufacturer_asset_tags",
                                                                                                                        "manufacturer_name",
                                                                                                                        "memory_size",
                                                                                                                        "model_name",
                                                                                                                        "name",
                                                                                                                        "new_deviation_number",
                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                        "redundancystate",
                                                                                                                        "serial_number",
                                                                                                                        "software_revision",
                                                                                                                        "unique_id",
                                                                                                                        "unrecognized_fru",
                                                                                                                        "vendor_type",
                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.alias.is_set or
                                                                                                            self.asset_id_str.is_set or
                                                                                                            self.asset_identification.is_set or
                                                                                                            self.ceport.is_set or
                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                            self.composite_class_code.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                            self.firmware_revision.is_set or
                                                                                                            self.group_flag.is_set or
                                                                                                            self.hardware_revision.is_set or
                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                            self.manufacturer_name.is_set or
                                                                                                            self.memory_size.is_set or
                                                                                                            self.model_name.is_set or
                                                                                                            self.name.is_set or
                                                                                                            self.new_deviation_number.is_set or
                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                            self.redundancystate.is_set or
                                                                                                            self.serial_number.is_set or
                                                                                                            self.software_revision.is_set or
                                                                                                            self.unique_id.is_set or
                                                                                                            self.unrecognized_fru.is_set or
                                                                                                            self.vendor_type.is_set or
                                                                                                            self.xr_scoped.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "alias"):
                                                                                                            self.alias = value
                                                                                                            self.alias.value_namespace = name_space
                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-id-str"):
                                                                                                            self.asset_id_str = value
                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-identification"):
                                                                                                            self.asset_identification = value
                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "ceport"):
                                                                                                            self.ceport = value
                                                                                                            self.ceport.value_namespace = name_space
                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                            self.chip_hardware_revision = value
                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "composite-class-code"):
                                                                                                            self.composite_class_code = value
                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                            self.environmental_monitor_path = value
                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "firmware-revision"):
                                                                                                            self.firmware_revision = value
                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "group-flag"):
                                                                                                            self.group_flag = value
                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "hardware-revision"):
                                                                                                            self.hardware_revision = value
                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                            self.is_field_replaceable_unit = value
                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                            self.manufacturer_asset_tags = value
                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                            self.manufacturer_name = value
                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "memory-size"):
                                                                                                            self.memory_size = value
                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "model-name"):
                                                                                                            self.model_name = value
                                                                                                            self.model_name.value_namespace = name_space
                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                            self.new_deviation_number = value
                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "redundancystate"):
                                                                                                            self.redundancystate = value
                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "serial-number"):
                                                                                                            self.serial_number = value
                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "software-revision"):
                                                                                                            self.software_revision = value
                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unique-id"):
                                                                                                            self.unique_id = value
                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                            self.unrecognized_fru = value
                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "vendor-type"):
                                                                                                            self.vendor_type = value
                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "xr-scoped"):
                                                                                                            self.xr_scoped = value
                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                class InvEepromInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("description",
                                                                                                                        "has_eeprom",
                                                                                                                        "inv_card_type",
                                                                                                                        "opaque_data",
                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                    class Eeprom(Entity):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._children_yang_names.add("rma")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("asset_alias",
                                                                                                                            "asset_id",
                                                                                                                            "base_mac_address1",
                                                                                                                            "base_mac_address2",
                                                                                                                            "base_mac_address3",
                                                                                                                            "base_mac_address4",
                                                                                                                            "block_checksum",
                                                                                                                            "block_count",
                                                                                                                            "block_length",
                                                                                                                            "block_signature",
                                                                                                                            "block_version",
                                                                                                                            "chassis_sid",
                                                                                                                            "clei",
                                                                                                                            "controller_family",
                                                                                                                            "controller_type",
                                                                                                                            "description",
                                                                                                                            "dev_num1",
                                                                                                                            "dev_num2",
                                                                                                                            "dev_num3",
                                                                                                                            "dev_num4",
                                                                                                                            "dev_num5",
                                                                                                                            "dev_num6",
                                                                                                                            "dev_num7",
                                                                                                                            "eci",
                                                                                                                            "eeprom_size",
                                                                                                                            "engineer_use",
                                                                                                                            "fru_major_type",
                                                                                                                            "fru_minor_type",
                                                                                                                            "hw_version",
                                                                                                                            "hwid",
                                                                                                                            "idprom_format_rev",
                                                                                                                            "mac_add_blk_size1",
                                                                                                                            "mac_add_blk_size2",
                                                                                                                            "mac_add_blk_size3",
                                                                                                                            "mac_add_blk_size4",
                                                                                                                            "manu_test_data",
                                                                                                                            "mfg_bits",
                                                                                                                            "mfg_deviation",
                                                                                                                            "oem_string",
                                                                                                                            "part_number",
                                                                                                                            "part_revision",
                                                                                                                            "pca_num",
                                                                                                                            "pcavid",
                                                                                                                            "pcb_serial_num",
                                                                                                                            "pid",
                                                                                                                            "power_consumption",
                                                                                                                            "power_supply_type",
                                                                                                                            "product_id",
                                                                                                                            "rma_code",
                                                                                                                            "serial_number",
                                                                                                                            "snmpoid",
                                                                                                                            "top_assem_part_num",
                                                                                                                            "top_assem_vid",
                                                                                                                            "udi_description",
                                                                                                                            "udi_name",
                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                        class Rma(Entity):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("rma_history",
                                                                                                                                "rma_number",
                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.rma_history.is_set or
                                                                                                                    self.rma_number.is_set or
                                                                                                                    self.test_history.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "rma-history"):
                                                                                                                    self.rma_history = value
                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "rma-number"):
                                                                                                                    self.rma_number = value
                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "test-history"):
                                                                                                                    self.test_history = value
                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.asset_alias.is_set or
                                                                                                                self.asset_id.is_set or
                                                                                                                self.base_mac_address1.is_set or
                                                                                                                self.base_mac_address2.is_set or
                                                                                                                self.base_mac_address3.is_set or
                                                                                                                self.base_mac_address4.is_set or
                                                                                                                self.block_checksum.is_set or
                                                                                                                self.block_count.is_set or
                                                                                                                self.block_length.is_set or
                                                                                                                self.block_signature.is_set or
                                                                                                                self.block_version.is_set or
                                                                                                                self.chassis_sid.is_set or
                                                                                                                self.clei.is_set or
                                                                                                                self.controller_family.is_set or
                                                                                                                self.controller_type.is_set or
                                                                                                                self.description.is_set or
                                                                                                                self.dev_num1.is_set or
                                                                                                                self.dev_num2.is_set or
                                                                                                                self.dev_num3.is_set or
                                                                                                                self.dev_num4.is_set or
                                                                                                                self.dev_num5.is_set or
                                                                                                                self.dev_num6.is_set or
                                                                                                                self.dev_num7.is_set or
                                                                                                                self.eci.is_set or
                                                                                                                self.eeprom_size.is_set or
                                                                                                                self.engineer_use.is_set or
                                                                                                                self.fru_major_type.is_set or
                                                                                                                self.fru_minor_type.is_set or
                                                                                                                self.hw_version.is_set or
                                                                                                                self.hwid.is_set or
                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                self.manu_test_data.is_set or
                                                                                                                self.mfg_bits.is_set or
                                                                                                                self.mfg_deviation.is_set or
                                                                                                                self.oem_string.is_set or
                                                                                                                self.part_number.is_set or
                                                                                                                self.part_revision.is_set or
                                                                                                                self.pca_num.is_set or
                                                                                                                self.pcavid.is_set or
                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                self.pid.is_set or
                                                                                                                self.power_consumption.is_set or
                                                                                                                self.power_supply_type.is_set or
                                                                                                                self.product_id.is_set or
                                                                                                                self.rma_code.is_set or
                                                                                                                self.serial_number.is_set or
                                                                                                                self.snmpoid.is_set or
                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                self.top_assem_vid.is_set or
                                                                                                                self.udi_description.is_set or
                                                                                                                self.udi_name.is_set or
                                                                                                                self.vid.is_set or
                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "rma"):
                                                                                                                if (self.rma is None):
                                                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                return self.rma

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "asset-alias"):
                                                                                                                self.asset_alias = value
                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "asset-id"):
                                                                                                                self.asset_id = value
                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                self.base_mac_address1 = value
                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                self.base_mac_address2 = value
                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                self.base_mac_address3 = value
                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                self.base_mac_address4 = value
                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-checksum"):
                                                                                                                self.block_checksum = value
                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-count"):
                                                                                                                self.block_count = value
                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-length"):
                                                                                                                self.block_length = value
                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-signature"):
                                                                                                                self.block_signature = value
                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-version"):
                                                                                                                self.block_version = value
                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                self.chassis_sid = value
                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "clei"):
                                                                                                                self.clei = value
                                                                                                                self.clei.value_namespace = name_space
                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-family"):
                                                                                                                self.controller_family = value
                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-type"):
                                                                                                                self.controller_type = value
                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "description"):
                                                                                                                self.description = value
                                                                                                                self.description.value_namespace = name_space
                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num1"):
                                                                                                                self.dev_num1 = value
                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num2"):
                                                                                                                self.dev_num2 = value
                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num3"):
                                                                                                                self.dev_num3 = value
                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num4"):
                                                                                                                self.dev_num4 = value
                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num5"):
                                                                                                                self.dev_num5 = value
                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num6"):
                                                                                                                self.dev_num6 = value
                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num7"):
                                                                                                                self.dev_num7 = value
                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eci"):
                                                                                                                self.eci = value
                                                                                                                self.eci.value_namespace = name_space
                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                self.eeprom_size = value
                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "engineer-use"):
                                                                                                                self.engineer_use = value
                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                self.fru_major_type = value
                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                self.fru_minor_type = value
                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hw-version"):
                                                                                                                self.hw_version = value
                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hwid"):
                                                                                                                self.hwid = value
                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                self.idprom_format_rev = value
                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                self.manu_test_data = value
                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                self.mfg_bits = value
                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                self.mfg_deviation = value
                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "oem-string"):
                                                                                                                self.oem_string = value
                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-number"):
                                                                                                                self.part_number = value
                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-revision"):
                                                                                                                self.part_revision = value
                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pca-num"):
                                                                                                                self.pca_num = value
                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcavid"):
                                                                                                                self.pcavid = value
                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                self.pcb_serial_num = value
                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pid"):
                                                                                                                self.pid = value
                                                                                                                self.pid.value_namespace = name_space
                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-consumption"):
                                                                                                                self.power_consumption = value
                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                self.power_supply_type = value
                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "product-id"):
                                                                                                                self.product_id = value
                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "rma-code"):
                                                                                                                self.rma_code = value
                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "serial-number"):
                                                                                                                self.serial_number = value
                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "snmpoid"):
                                                                                                                self.snmpoid = value
                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                self.top_assem_part_num = value
                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                self.top_assem_vid = value
                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-description"):
                                                                                                                self.udi_description = value
                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-name"):
                                                                                                                self.udi_name = value
                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vid"):
                                                                                                                self.vid = value
                                                                                                                self.vid.value_namespace = name_space
                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.description.is_set or
                                                                                                            self.has_eeprom.is_set or
                                                                                                            self.inv_card_type.is_set or
                                                                                                            self.opaque_data.is_set or
                                                                                                            self.opaque_data_size.is_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                            if (self.eeprom is None):
                                                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                            return self.eeprom

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "has-eeprom"):
                                                                                                            self.has_eeprom = value
                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "inv-card-type"):
                                                                                                            self.inv_card_type = value
                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data"):
                                                                                                            self.opaque_data = value
                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                            self.opaque_data_size = value
                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.module_done.is_set or
                                                                                                        self.node_id.is_set or
                                                                                                        self.vm_done.is_set or
                                                                                                        self.vm_node_id.is_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                        if (self.env_sensor_info is None):
                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                        return self.env_sensor_info

                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                        return self.env_sensor_info_xml

                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                        if (self.fru_info is None):
                                                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                        return self.fru_info

                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                        if (self.inv_asset_bag is None):
                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                        return self.inv_asset_bag

                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                        if (self.inv_basic_bag is None):
                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                        return self.inv_basic_bag

                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                        return self.inv_eeprom_info

                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                        if (self.pwg_info is None):
                                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                        return self.pwg_info

                                                                                                    if (child_yang_name == "threshold"):
                                                                                                        if (self.threshold is None):
                                                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                        return self.threshold

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "module-done"):
                                                                                                        self.module_done = value
                                                                                                        self.module_done.value_namespace = name_space
                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "node-id"):
                                                                                                        self.node_id = value
                                                                                                        self.node_id.value_namespace = name_space
                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-done"):
                                                                                                        self.vm_done = value
                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-node-id"):
                                                                                                        self.vm_node_id = value
                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.name.is_set or
                                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "tsi9" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "attributes"):
                                                                                                    if (self.attributes is None):
                                                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                    return self.attributes

                                                                                                if (child_yang_name == "tsi10s"):
                                                                                                    if (self.tsi10s is None):
                                                                                                        self.tsi10s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                        self.tsi10s.parent = self
                                                                                                        self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                    return self.tsi10s

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "attributes" or name == "tsi10s" or name == "name"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "tsi9s" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "tsi9"):
                                                                                                for c in self.tsi9:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.tsi9.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "tsi9"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class Attributes(Entity):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        .. attribute:: module_done
                                                                                        
                                                                                        	Inventory EDM Module Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**default value**\: 1
                                                                                        
                                                                                        .. attribute:: node_id
                                                                                        
                                                                                        	Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        .. attribute:: vm_done
                                                                                        
                                                                                        	VM Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        .. attribute:: vm_node_id
                                                                                        
                                                                                        	VM Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                            self._children_yang_names.add("fru-info")

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                            self._children_yang_names.add("pwg-info")

                                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                            self._children_yang_names.add("threshold")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("module_done",
                                                                                                            "node_id",
                                                                                                            "vm_done",
                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)


                                                                                        class EnvSensorInfo(Entity):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("age_time_stamp",
                                                                                                                "alarm_type",
                                                                                                                "data_type",
                                                                                                                "device_description",
                                                                                                                "device_id",
                                                                                                                "field_validity_bitmap",
                                                                                                                "precision",
                                                                                                                "scale",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.age_time_stamp.is_set or
                                                                                                    self.alarm_type.is_set or
                                                                                                    self.data_type.is_set or
                                                                                                    self.device_description.is_set or
                                                                                                    self.device_id.is_set or
                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                    self.precision.is_set or
                                                                                                    self.scale.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "age-time-stamp"):
                                                                                                    self.age_time_stamp = value
                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "alarm-type"):
                                                                                                    self.alarm_type = value
                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-description"):
                                                                                                    self.device_description = value
                                                                                                    self.device_description.value_namespace = name_space
                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-id"):
                                                                                                    self.device_id = value
                                                                                                    self.device_id.value_namespace = name_space
                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                    self.field_validity_bitmap = value
                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "precision"):
                                                                                                    self.precision = value
                                                                                                    self.precision.value_namespace = name_space
                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "scale"):
                                                                                                    self.scale = value
                                                                                                    self.scale.value_namespace = name_space
                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class PwgInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("power_group_available_current",
                                                                                                                "power_group_drawn_current",
                                                                                                                "power_group_power_units",
                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.power_group_available_current.is_set or
                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                    self.power_group_power_units.is_set or
                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "power-group-available-current"):
                                                                                                    self.power_group_available_current = value
                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                    self.power_group_drawn_current = value
                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-power-units"):
                                                                                                    self.power_group_power_units = value
                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                    self.power_group_redundancy_mode = value
                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                        class EnvSensorInfoXml(Entity):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._children_yang_names.add("threshold")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("data_type",
                                                                                                                "description",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                            class Threshold(Entity):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                    self.threshold_array = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                class ThresholdArray(Entity):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"

                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_name",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_name.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-name"):
                                                                                                            self.threshold_name = value
                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                        for c in self.threshold_array:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.threshold_array.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "threshold-array"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.data_type.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set or
                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "threshold"):
                                                                                                    if (self.threshold is None):
                                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                    return self.threshold

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class InvAssetBag(Entity):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                "manufacturer_assembly_revision",
                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                "manufacturer_software_identifier",
                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                "part_number") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                    self.part_number.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                    self.manufacturer_assembly_number = value
                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                    self.manufacturer_software_identifier = value
                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "part-number"):
                                                                                                    self.part_number = value
                                                                                                    self.part_number.value_namespace = name_space
                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                        class Threshold(Entity):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                self._children_yang_names.add("major-hi")

                                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                self._children_yang_names.add("major-lo")

                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._children_yang_names.add("minor-lo")


                                                                                            class MajorLo(Entity):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalHi(Entity):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorHi(Entity):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MajorHi(Entity):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalLo(Entity):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorLo(Entity):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                    if (self.critical_hi is None):
                                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                    return self.critical_hi

                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                    if (self.critical_lo is None):
                                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                    return self.critical_lo

                                                                                                if (child_yang_name == "major-hi"):
                                                                                                    if (self.major_hi is None):
                                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                    return self.major_hi

                                                                                                if (child_yang_name == "major-lo"):
                                                                                                    if (self.major_lo is None):
                                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                    return self.major_lo

                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                    if (self.minor_hi is None):
                                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                    return self.minor_hi

                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                    if (self.minor_lo is None):
                                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                    return self.minor_lo

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                pass


                                                                                        class FruInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("card_administrative_state",
                                                                                                                "card_monitor_state",
                                                                                                                "card_operational_state",
                                                                                                                "card_reset_reason",
                                                                                                                "power_administrative_state",
                                                                                                                "power_current_measurement",
                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                            class LastOperationalStateChange(Entity):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                            class CardUpTime(Entity):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.card_administrative_state.is_set or
                                                                                                    self.card_monitor_state.is_set or
                                                                                                    self.card_operational_state.is_set or
                                                                                                    self.card_reset_reason.is_set or
                                                                                                    self.power_administrative_state.is_set or
                                                                                                    self.power_current_measurement.is_set or
                                                                                                    self.power_operational_state.is_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                    if (self.card_up_time is None):
                                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                    return self.card_up_time

                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                    if (self.last_operational_state_change is None):
                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                    return self.last_operational_state_change

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "card-administrative-state"):
                                                                                                    self.card_administrative_state = value
                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-monitor-state"):
                                                                                                    self.card_monitor_state = value
                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-operational-state"):
                                                                                                    self.card_operational_state = value
                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-reset-reason"):
                                                                                                    self.card_reset_reason = value
                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-administrative-state"):
                                                                                                    self.power_administrative_state = value
                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-current-measurement"):
                                                                                                    self.power_current_measurement = value
                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-operational-state"):
                                                                                                    self.power_operational_state = value
                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                        class InvBasicBag(Entity):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("alias",
                                                                                                                "asset_id_str",
                                                                                                                "asset_identification",
                                                                                                                "ceport",
                                                                                                                "chip_hardware_revision",
                                                                                                                "composite_class_code",
                                                                                                                "description",
                                                                                                                "environmental_monitor_path",
                                                                                                                "firmware_revision",
                                                                                                                "group_flag",
                                                                                                                "hardware_revision",
                                                                                                                "is_field_replaceable_unit",
                                                                                                                "manufacturer_asset_tags",
                                                                                                                "manufacturer_name",
                                                                                                                "memory_size",
                                                                                                                "model_name",
                                                                                                                "name",
                                                                                                                "new_deviation_number",
                                                                                                                "physical_layer_interface_module_type",
                                                                                                                "redundancystate",
                                                                                                                "serial_number",
                                                                                                                "software_revision",
                                                                                                                "unique_id",
                                                                                                                "unrecognized_fru",
                                                                                                                "vendor_type",
                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.alias.is_set or
                                                                                                    self.asset_id_str.is_set or
                                                                                                    self.asset_identification.is_set or
                                                                                                    self.ceport.is_set or
                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                    self.composite_class_code.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                    self.firmware_revision.is_set or
                                                                                                    self.group_flag.is_set or
                                                                                                    self.hardware_revision.is_set or
                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                    self.manufacturer_name.is_set or
                                                                                                    self.memory_size.is_set or
                                                                                                    self.model_name.is_set or
                                                                                                    self.name.is_set or
                                                                                                    self.new_deviation_number.is_set or
                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                    self.redundancystate.is_set or
                                                                                                    self.serial_number.is_set or
                                                                                                    self.software_revision.is_set or
                                                                                                    self.unique_id.is_set or
                                                                                                    self.unrecognized_fru.is_set or
                                                                                                    self.vendor_type.is_set or
                                                                                                    self.xr_scoped.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "alias"):
                                                                                                    self.alias = value
                                                                                                    self.alias.value_namespace = name_space
                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-id-str"):
                                                                                                    self.asset_id_str = value
                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-identification"):
                                                                                                    self.asset_identification = value
                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "ceport"):
                                                                                                    self.ceport = value
                                                                                                    self.ceport.value_namespace = name_space
                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                    self.chip_hardware_revision = value
                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "composite-class-code"):
                                                                                                    self.composite_class_code = value
                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                    self.environmental_monitor_path = value
                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "firmware-revision"):
                                                                                                    self.firmware_revision = value
                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "group-flag"):
                                                                                                    self.group_flag = value
                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "hardware-revision"):
                                                                                                    self.hardware_revision = value
                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                    self.is_field_replaceable_unit = value
                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                    self.manufacturer_asset_tags = value
                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-name"):
                                                                                                    self.manufacturer_name = value
                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "memory-size"):
                                                                                                    self.memory_size = value
                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "model-name"):
                                                                                                    self.model_name = value
                                                                                                    self.model_name.value_namespace = name_space
                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "new-deviation-number"):
                                                                                                    self.new_deviation_number = value
                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "redundancystate"):
                                                                                                    self.redundancystate = value
                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "serial-number"):
                                                                                                    self.serial_number = value
                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "software-revision"):
                                                                                                    self.software_revision = value
                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unique-id"):
                                                                                                    self.unique_id = value
                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                    self.unrecognized_fru = value
                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "vendor-type"):
                                                                                                    self.vendor_type = value
                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "xr-scoped"):
                                                                                                    self.xr_scoped = value
                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                        class InvEepromInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._children_yang_names.add("eeprom")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("description",
                                                                                                                "has_eeprom",
                                                                                                                "inv_card_type",
                                                                                                                "opaque_data",
                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                            class Eeprom(Entity):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._children_yang_names.add("rma")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("asset_alias",
                                                                                                                    "asset_id",
                                                                                                                    "base_mac_address1",
                                                                                                                    "base_mac_address2",
                                                                                                                    "base_mac_address3",
                                                                                                                    "base_mac_address4",
                                                                                                                    "block_checksum",
                                                                                                                    "block_count",
                                                                                                                    "block_length",
                                                                                                                    "block_signature",
                                                                                                                    "block_version",
                                                                                                                    "chassis_sid",
                                                                                                                    "clei",
                                                                                                                    "controller_family",
                                                                                                                    "controller_type",
                                                                                                                    "description",
                                                                                                                    "dev_num1",
                                                                                                                    "dev_num2",
                                                                                                                    "dev_num3",
                                                                                                                    "dev_num4",
                                                                                                                    "dev_num5",
                                                                                                                    "dev_num6",
                                                                                                                    "dev_num7",
                                                                                                                    "eci",
                                                                                                                    "eeprom_size",
                                                                                                                    "engineer_use",
                                                                                                                    "fru_major_type",
                                                                                                                    "fru_minor_type",
                                                                                                                    "hw_version",
                                                                                                                    "hwid",
                                                                                                                    "idprom_format_rev",
                                                                                                                    "mac_add_blk_size1",
                                                                                                                    "mac_add_blk_size2",
                                                                                                                    "mac_add_blk_size3",
                                                                                                                    "mac_add_blk_size4",
                                                                                                                    "manu_test_data",
                                                                                                                    "mfg_bits",
                                                                                                                    "mfg_deviation",
                                                                                                                    "oem_string",
                                                                                                                    "part_number",
                                                                                                                    "part_revision",
                                                                                                                    "pca_num",
                                                                                                                    "pcavid",
                                                                                                                    "pcb_serial_num",
                                                                                                                    "pid",
                                                                                                                    "power_consumption",
                                                                                                                    "power_supply_type",
                                                                                                                    "product_id",
                                                                                                                    "rma_code",
                                                                                                                    "serial_number",
                                                                                                                    "snmpoid",
                                                                                                                    "top_assem_part_num",
                                                                                                                    "top_assem_vid",
                                                                                                                    "udi_description",
                                                                                                                    "udi_name",
                                                                                                                    "vid") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                class Rma(Entity):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("rma_history",
                                                                                                                        "rma_number",
                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.rma_history.is_set or
                                                                                                            self.rma_number.is_set or
                                                                                                            self.test_history.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "rma-history"):
                                                                                                            self.rma_history = value
                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "rma-number"):
                                                                                                            self.rma_number = value
                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "test-history"):
                                                                                                            self.test_history = value
                                                                                                            self.test_history.value_namespace = name_space
                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.asset_alias.is_set or
                                                                                                        self.asset_id.is_set or
                                                                                                        self.base_mac_address1.is_set or
                                                                                                        self.base_mac_address2.is_set or
                                                                                                        self.base_mac_address3.is_set or
                                                                                                        self.base_mac_address4.is_set or
                                                                                                        self.block_checksum.is_set or
                                                                                                        self.block_count.is_set or
                                                                                                        self.block_length.is_set or
                                                                                                        self.block_signature.is_set or
                                                                                                        self.block_version.is_set or
                                                                                                        self.chassis_sid.is_set or
                                                                                                        self.clei.is_set or
                                                                                                        self.controller_family.is_set or
                                                                                                        self.controller_type.is_set or
                                                                                                        self.description.is_set or
                                                                                                        self.dev_num1.is_set or
                                                                                                        self.dev_num2.is_set or
                                                                                                        self.dev_num3.is_set or
                                                                                                        self.dev_num4.is_set or
                                                                                                        self.dev_num5.is_set or
                                                                                                        self.dev_num6.is_set or
                                                                                                        self.dev_num7.is_set or
                                                                                                        self.eci.is_set or
                                                                                                        self.eeprom_size.is_set or
                                                                                                        self.engineer_use.is_set or
                                                                                                        self.fru_major_type.is_set or
                                                                                                        self.fru_minor_type.is_set or
                                                                                                        self.hw_version.is_set or
                                                                                                        self.hwid.is_set or
                                                                                                        self.idprom_format_rev.is_set or
                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                        self.manu_test_data.is_set or
                                                                                                        self.mfg_bits.is_set or
                                                                                                        self.mfg_deviation.is_set or
                                                                                                        self.oem_string.is_set or
                                                                                                        self.part_number.is_set or
                                                                                                        self.part_revision.is_set or
                                                                                                        self.pca_num.is_set or
                                                                                                        self.pcavid.is_set or
                                                                                                        self.pcb_serial_num.is_set or
                                                                                                        self.pid.is_set or
                                                                                                        self.power_consumption.is_set or
                                                                                                        self.power_supply_type.is_set or
                                                                                                        self.product_id.is_set or
                                                                                                        self.rma_code.is_set or
                                                                                                        self.serial_number.is_set or
                                                                                                        self.snmpoid.is_set or
                                                                                                        self.top_assem_part_num.is_set or
                                                                                                        self.top_assem_vid.is_set or
                                                                                                        self.udi_description.is_set or
                                                                                                        self.udi_name.is_set or
                                                                                                        self.vid.is_set or
                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "rma"):
                                                                                                        if (self.rma is None):
                                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                        return self.rma

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "asset-alias"):
                                                                                                        self.asset_alias = value
                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "asset-id"):
                                                                                                        self.asset_id = value
                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                        self.base_mac_address1 = value
                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                        self.base_mac_address2 = value
                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                        self.base_mac_address3 = value
                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                        self.base_mac_address4 = value
                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-checksum"):
                                                                                                        self.block_checksum = value
                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-count"):
                                                                                                        self.block_count = value
                                                                                                        self.block_count.value_namespace = name_space
                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-length"):
                                                                                                        self.block_length = value
                                                                                                        self.block_length.value_namespace = name_space
                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-signature"):
                                                                                                        self.block_signature = value
                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-version"):
                                                                                                        self.block_version = value
                                                                                                        self.block_version.value_namespace = name_space
                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "chassis-sid"):
                                                                                                        self.chassis_sid = value
                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "clei"):
                                                                                                        self.clei = value
                                                                                                        self.clei.value_namespace = name_space
                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-family"):
                                                                                                        self.controller_family = value
                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-type"):
                                                                                                        self.controller_type = value
                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "description"):
                                                                                                        self.description = value
                                                                                                        self.description.value_namespace = name_space
                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num1"):
                                                                                                        self.dev_num1 = value
                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num2"):
                                                                                                        self.dev_num2 = value
                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num3"):
                                                                                                        self.dev_num3 = value
                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num4"):
                                                                                                        self.dev_num4 = value
                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num5"):
                                                                                                        self.dev_num5 = value
                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num6"):
                                                                                                        self.dev_num6 = value
                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num7"):
                                                                                                        self.dev_num7 = value
                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eci"):
                                                                                                        self.eci = value
                                                                                                        self.eci.value_namespace = name_space
                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eeprom-size"):
                                                                                                        self.eeprom_size = value
                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "engineer-use"):
                                                                                                        self.engineer_use = value
                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-major-type"):
                                                                                                        self.fru_major_type = value
                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                        self.fru_minor_type = value
                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hw-version"):
                                                                                                        self.hw_version = value
                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hwid"):
                                                                                                        self.hwid = value
                                                                                                        self.hwid.value_namespace = name_space
                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                        self.idprom_format_rev = value
                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                        self.mac_add_blk_size1 = value
                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                        self.mac_add_blk_size2 = value
                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                        self.mac_add_blk_size3 = value
                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                        self.mac_add_blk_size4 = value
                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "manu-test-data"):
                                                                                                        self.manu_test_data = value
                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-bits"):
                                                                                                        self.mfg_bits = value
                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                        self.mfg_deviation = value
                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "oem-string"):
                                                                                                        self.oem_string = value
                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-number"):
                                                                                                        self.part_number = value
                                                                                                        self.part_number.value_namespace = name_space
                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-revision"):
                                                                                                        self.part_revision = value
                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pca-num"):
                                                                                                        self.pca_num = value
                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcavid"):
                                                                                                        self.pcavid = value
                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                        self.pcb_serial_num = value
                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pid"):
                                                                                                        self.pid = value
                                                                                                        self.pid.value_namespace = name_space
                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-consumption"):
                                                                                                        self.power_consumption = value
                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-supply-type"):
                                                                                                        self.power_supply_type = value
                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "product-id"):
                                                                                                        self.product_id = value
                                                                                                        self.product_id.value_namespace = name_space
                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "rma-code"):
                                                                                                        self.rma_code = value
                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "serial-number"):
                                                                                                        self.serial_number = value
                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "snmpoid"):
                                                                                                        self.snmpoid = value
                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                        self.top_assem_part_num = value
                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                        self.top_assem_vid = value
                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-description"):
                                                                                                        self.udi_description = value
                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-name"):
                                                                                                        self.udi_name = value
                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vid"):
                                                                                                        self.vid = value
                                                                                                        self.vid.value_namespace = name_space
                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.description.is_set or
                                                                                                    self.has_eeprom.is_set or
                                                                                                    self.inv_card_type.is_set or
                                                                                                    self.opaque_data.is_set or
                                                                                                    self.opaque_data_size.is_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "eeprom"):
                                                                                                    if (self.eeprom is None):
                                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                    return self.eeprom

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "has-eeprom"):
                                                                                                    self.has_eeprom = value
                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "inv-card-type"):
                                                                                                    self.inv_card_type = value
                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data"):
                                                                                                    self.opaque_data = value
                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data-size"):
                                                                                                    self.opaque_data_size = value
                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.module_done.is_set or
                                                                                                self.node_id.is_set or
                                                                                                self.vm_done.is_set or
                                                                                                self.vm_node_id.is_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "attributes" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                if (self.env_sensor_info is None):
                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                return self.env_sensor_info

                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                return self.env_sensor_info_xml

                                                                                            if (child_yang_name == "fru-info"):
                                                                                                if (self.fru_info is None):
                                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                return self.fru_info

                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                if (self.inv_asset_bag is None):
                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                return self.inv_asset_bag

                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                if (self.inv_basic_bag is None):
                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                return self.inv_basic_bag

                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                if (self.inv_eeprom_info is None):
                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                return self.inv_eeprom_info

                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                if (self.pwg_info is None):
                                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                return self.pwg_info

                                                                                            if (child_yang_name == "threshold"):
                                                                                                if (self.threshold is None):
                                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                return self.threshold

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "module-done"):
                                                                                                self.module_done = value
                                                                                                self.module_done.value_namespace = name_space
                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "node-id"):
                                                                                                self.node_id = value
                                                                                                self.node_id.value_namespace = name_space
                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-done"):
                                                                                                self.vm_done = value
                                                                                                self.vm_done.value_namespace = name_space
                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-node-id"):
                                                                                                self.vm_node_id = value
                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.name.is_set or
                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "tsi8" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "attributes"):
                                                                                            if (self.attributes is None):
                                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                            return self.attributes

                                                                                        if (child_yang_name == "tsi9s"):
                                                                                            if (self.tsi9s is None):
                                                                                                self.tsi9s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                                self.tsi9s.parent = self
                                                                                                self._children_name_map["tsi9s"] = "tsi9s"
                                                                                            return self.tsi9s

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "attributes" or name == "tsi9s" or name == "name"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "tsi8s" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "tsi8"):
                                                                                        for c in self.tsi8:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.tsi8.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "tsi8"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class Attributes(Entity):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                .. attribute:: module_done
                                                                                
                                                                                	Inventory EDM Module Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**default value**\: 1
                                                                                
                                                                                .. attribute:: node_id
                                                                                
                                                                                	Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                .. attribute:: vm_done
                                                                                
                                                                                	VM Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                .. attribute:: vm_node_id
                                                                                
                                                                                	VM Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                    self._children_yang_names.add("fru-info")

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                    self._children_yang_names.add("pwg-info")

                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                    self._children_yang_names.add("threshold")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("module_done",
                                                                                                    "node_id",
                                                                                                    "vm_done",
                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)


                                                                                class EnvSensorInfo(Entity):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("age_time_stamp",
                                                                                                        "alarm_type",
                                                                                                        "data_type",
                                                                                                        "device_description",
                                                                                                        "device_id",
                                                                                                        "field_validity_bitmap",
                                                                                                        "precision",
                                                                                                        "scale",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.age_time_stamp.is_set or
                                                                                            self.alarm_type.is_set or
                                                                                            self.data_type.is_set or
                                                                                            self.device_description.is_set or
                                                                                            self.device_id.is_set or
                                                                                            self.field_validity_bitmap.is_set or
                                                                                            self.precision.is_set or
                                                                                            self.scale.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "age-time-stamp"):
                                                                                            self.age_time_stamp = value
                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "alarm-type"):
                                                                                            self.alarm_type = value
                                                                                            self.alarm_type.value_namespace = name_space
                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-description"):
                                                                                            self.device_description = value
                                                                                            self.device_description.value_namespace = name_space
                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-id"):
                                                                                            self.device_id = value
                                                                                            self.device_id.value_namespace = name_space
                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                            self.field_validity_bitmap = value
                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "precision"):
                                                                                            self.precision = value
                                                                                            self.precision.value_namespace = name_space
                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "scale"):
                                                                                            self.scale = value
                                                                                            self.scale.value_namespace = name_space
                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class PwgInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("power_group_available_current",
                                                                                                        "power_group_drawn_current",
                                                                                                        "power_group_power_units",
                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.power_group_available_current.is_set or
                                                                                            self.power_group_drawn_current.is_set or
                                                                                            self.power_group_power_units.is_set or
                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "power-group-available-current"):
                                                                                            self.power_group_available_current = value
                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                            self.power_group_drawn_current = value
                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-power-units"):
                                                                                            self.power_group_power_units = value
                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                            self.power_group_redundancy_mode = value
                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                class EnvSensorInfoXml(Entity):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._children_yang_names.add("threshold")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("data_type",
                                                                                                        "description",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                    class Threshold(Entity):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                            self.threshold_array = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                        class ThresholdArray(Entity):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"

                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_name",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_name.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-name"):
                                                                                                    self.threshold_name = value
                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "threshold" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                for c in self.threshold_array:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.threshold_array.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "threshold-array"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.data_type.is_set or
                                                                                            self.description.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set or
                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "threshold"):
                                                                                            if (self.threshold is None):
                                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                            return self.threshold

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class InvAssetBag(Entity):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                        "manufacturer_assembly_revision",
                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                        "manufacturer_firmware_identifier",
                                                                                                        "manufacturer_software_identifier",
                                                                                                        "original_equipment_manufacturer_string",
                                                                                                        "part_number") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                            self.part_number.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                            self.manufacturer_assembly_number = value
                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                            self.manufacturer_assembly_revision = value
                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                            self.manufacturer_firmware_identifier = value
                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                            self.manufacturer_software_identifier = value
                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                            self.original_equipment_manufacturer_string = value
                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "part-number"):
                                                                                            self.part_number = value
                                                                                            self.part_number.value_namespace = name_space
                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                class Threshold(Entity):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                        self._children_yang_names.add("critical-hi")

                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                        self._children_yang_names.add("critical-lo")

                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                        self._children_yang_names.add("major-hi")

                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                        self._children_yang_names.add("major-lo")

                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                        self._children_yang_names.add("minor-hi")

                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._children_yang_names.add("minor-lo")


                                                                                    class MajorLo(Entity):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalHi(Entity):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorHi(Entity):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MajorHi(Entity):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalLo(Entity):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorLo(Entity):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "critical-hi"):
                                                                                            if (self.critical_hi is None):
                                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                            return self.critical_hi

                                                                                        if (child_yang_name == "critical-lo"):
                                                                                            if (self.critical_lo is None):
                                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                            return self.critical_lo

                                                                                        if (child_yang_name == "major-hi"):
                                                                                            if (self.major_hi is None):
                                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                            return self.major_hi

                                                                                        if (child_yang_name == "major-lo"):
                                                                                            if (self.major_lo is None):
                                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                            return self.major_lo

                                                                                        if (child_yang_name == "minor-hi"):
                                                                                            if (self.minor_hi is None):
                                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                            return self.minor_hi

                                                                                        if (child_yang_name == "minor-lo"):
                                                                                            if (self.minor_lo is None):
                                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                            return self.minor_lo

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        pass


                                                                                class FruInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._children_yang_names.add("card-up-time")

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("card_administrative_state",
                                                                                                        "card_monitor_state",
                                                                                                        "card_operational_state",
                                                                                                        "card_reset_reason",
                                                                                                        "power_administrative_state",
                                                                                                        "power_current_measurement",
                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                    class LastOperationalStateChange(Entity):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                    class CardUpTime(Entity):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.card_administrative_state.is_set or
                                                                                            self.card_monitor_state.is_set or
                                                                                            self.card_operational_state.is_set or
                                                                                            self.card_reset_reason.is_set or
                                                                                            self.power_administrative_state.is_set or
                                                                                            self.power_current_measurement.is_set or
                                                                                            self.power_operational_state.is_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "card-up-time"):
                                                                                            if (self.card_up_time is None):
                                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                            return self.card_up_time

                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                            if (self.last_operational_state_change is None):
                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                            return self.last_operational_state_change

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "card-administrative-state"):
                                                                                            self.card_administrative_state = value
                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-monitor-state"):
                                                                                            self.card_monitor_state = value
                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-operational-state"):
                                                                                            self.card_operational_state = value
                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-reset-reason"):
                                                                                            self.card_reset_reason = value
                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-administrative-state"):
                                                                                            self.power_administrative_state = value
                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-current-measurement"):
                                                                                            self.power_current_measurement = value
                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-operational-state"):
                                                                                            self.power_operational_state = value
                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                class InvBasicBag(Entity):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("alias",
                                                                                                        "asset_id_str",
                                                                                                        "asset_identification",
                                                                                                        "ceport",
                                                                                                        "chip_hardware_revision",
                                                                                                        "composite_class_code",
                                                                                                        "description",
                                                                                                        "environmental_monitor_path",
                                                                                                        "firmware_revision",
                                                                                                        "group_flag",
                                                                                                        "hardware_revision",
                                                                                                        "is_field_replaceable_unit",
                                                                                                        "manufacturer_asset_tags",
                                                                                                        "manufacturer_name",
                                                                                                        "memory_size",
                                                                                                        "model_name",
                                                                                                        "name",
                                                                                                        "new_deviation_number",
                                                                                                        "physical_layer_interface_module_type",
                                                                                                        "redundancystate",
                                                                                                        "serial_number",
                                                                                                        "software_revision",
                                                                                                        "unique_id",
                                                                                                        "unrecognized_fru",
                                                                                                        "vendor_type",
                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.alias.is_set or
                                                                                            self.asset_id_str.is_set or
                                                                                            self.asset_identification.is_set or
                                                                                            self.ceport.is_set or
                                                                                            self.chip_hardware_revision.is_set or
                                                                                            self.composite_class_code.is_set or
                                                                                            self.description.is_set or
                                                                                            self.environmental_monitor_path.is_set or
                                                                                            self.firmware_revision.is_set or
                                                                                            self.group_flag.is_set or
                                                                                            self.hardware_revision.is_set or
                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                            self.manufacturer_name.is_set or
                                                                                            self.memory_size.is_set or
                                                                                            self.model_name.is_set or
                                                                                            self.name.is_set or
                                                                                            self.new_deviation_number.is_set or
                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                            self.redundancystate.is_set or
                                                                                            self.serial_number.is_set or
                                                                                            self.software_revision.is_set or
                                                                                            self.unique_id.is_set or
                                                                                            self.unrecognized_fru.is_set or
                                                                                            self.vendor_type.is_set or
                                                                                            self.xr_scoped.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "alias"):
                                                                                            self.alias = value
                                                                                            self.alias.value_namespace = name_space
                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-id-str"):
                                                                                            self.asset_id_str = value
                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-identification"):
                                                                                            self.asset_identification = value
                                                                                            self.asset_identification.value_namespace = name_space
                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "ceport"):
                                                                                            self.ceport = value
                                                                                            self.ceport.value_namespace = name_space
                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                            self.chip_hardware_revision = value
                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "composite-class-code"):
                                                                                            self.composite_class_code = value
                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                            self.environmental_monitor_path = value
                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "firmware-revision"):
                                                                                            self.firmware_revision = value
                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "group-flag"):
                                                                                            self.group_flag = value
                                                                                            self.group_flag.value_namespace = name_space
                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "hardware-revision"):
                                                                                            self.hardware_revision = value
                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                            self.is_field_replaceable_unit = value
                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                            self.manufacturer_asset_tags = value
                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-name"):
                                                                                            self.manufacturer_name = value
                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "memory-size"):
                                                                                            self.memory_size = value
                                                                                            self.memory_size.value_namespace = name_space
                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "model-name"):
                                                                                            self.model_name = value
                                                                                            self.model_name.value_namespace = name_space
                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "new-deviation-number"):
                                                                                            self.new_deviation_number = value
                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                            self.physical_layer_interface_module_type = value
                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "redundancystate"):
                                                                                            self.redundancystate = value
                                                                                            self.redundancystate.value_namespace = name_space
                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "serial-number"):
                                                                                            self.serial_number = value
                                                                                            self.serial_number.value_namespace = name_space
                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "software-revision"):
                                                                                            self.software_revision = value
                                                                                            self.software_revision.value_namespace = name_space
                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unique-id"):
                                                                                            self.unique_id = value
                                                                                            self.unique_id.value_namespace = name_space
                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unrecognized-fru"):
                                                                                            self.unrecognized_fru = value
                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "vendor-type"):
                                                                                            self.vendor_type = value
                                                                                            self.vendor_type.value_namespace = name_space
                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "xr-scoped"):
                                                                                            self.xr_scoped = value
                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                class InvEepromInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._children_yang_names.add("eeprom")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("description",
                                                                                                        "has_eeprom",
                                                                                                        "inv_card_type",
                                                                                                        "opaque_data",
                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                    class Eeprom(Entity):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._children_yang_names.add("rma")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("asset_alias",
                                                                                                            "asset_id",
                                                                                                            "base_mac_address1",
                                                                                                            "base_mac_address2",
                                                                                                            "base_mac_address3",
                                                                                                            "base_mac_address4",
                                                                                                            "block_checksum",
                                                                                                            "block_count",
                                                                                                            "block_length",
                                                                                                            "block_signature",
                                                                                                            "block_version",
                                                                                                            "chassis_sid",
                                                                                                            "clei",
                                                                                                            "controller_family",
                                                                                                            "controller_type",
                                                                                                            "description",
                                                                                                            "dev_num1",
                                                                                                            "dev_num2",
                                                                                                            "dev_num3",
                                                                                                            "dev_num4",
                                                                                                            "dev_num5",
                                                                                                            "dev_num6",
                                                                                                            "dev_num7",
                                                                                                            "eci",
                                                                                                            "eeprom_size",
                                                                                                            "engineer_use",
                                                                                                            "fru_major_type",
                                                                                                            "fru_minor_type",
                                                                                                            "hw_version",
                                                                                                            "hwid",
                                                                                                            "idprom_format_rev",
                                                                                                            "mac_add_blk_size1",
                                                                                                            "mac_add_blk_size2",
                                                                                                            "mac_add_blk_size3",
                                                                                                            "mac_add_blk_size4",
                                                                                                            "manu_test_data",
                                                                                                            "mfg_bits",
                                                                                                            "mfg_deviation",
                                                                                                            "oem_string",
                                                                                                            "part_number",
                                                                                                            "part_revision",
                                                                                                            "pca_num",
                                                                                                            "pcavid",
                                                                                                            "pcb_serial_num",
                                                                                                            "pid",
                                                                                                            "power_consumption",
                                                                                                            "power_supply_type",
                                                                                                            "product_id",
                                                                                                            "rma_code",
                                                                                                            "serial_number",
                                                                                                            "snmpoid",
                                                                                                            "top_assem_part_num",
                                                                                                            "top_assem_vid",
                                                                                                            "udi_description",
                                                                                                            "udi_name",
                                                                                                            "vid") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                        class Rma(Entity):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"

                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("rma_history",
                                                                                                                "rma_number",
                                                                                                                "test_history") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.rma_history.is_set or
                                                                                                    self.rma_number.is_set or
                                                                                                    self.test_history.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "rma" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "rma-history"):
                                                                                                    self.rma_history = value
                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "rma-number"):
                                                                                                    self.rma_number = value
                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "test-history"):
                                                                                                    self.test_history = value
                                                                                                    self.test_history.value_namespace = name_space
                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.asset_alias.is_set or
                                                                                                self.asset_id.is_set or
                                                                                                self.base_mac_address1.is_set or
                                                                                                self.base_mac_address2.is_set or
                                                                                                self.base_mac_address3.is_set or
                                                                                                self.base_mac_address4.is_set or
                                                                                                self.block_checksum.is_set or
                                                                                                self.block_count.is_set or
                                                                                                self.block_length.is_set or
                                                                                                self.block_signature.is_set or
                                                                                                self.block_version.is_set or
                                                                                                self.chassis_sid.is_set or
                                                                                                self.clei.is_set or
                                                                                                self.controller_family.is_set or
                                                                                                self.controller_type.is_set or
                                                                                                self.description.is_set or
                                                                                                self.dev_num1.is_set or
                                                                                                self.dev_num2.is_set or
                                                                                                self.dev_num3.is_set or
                                                                                                self.dev_num4.is_set or
                                                                                                self.dev_num5.is_set or
                                                                                                self.dev_num6.is_set or
                                                                                                self.dev_num7.is_set or
                                                                                                self.eci.is_set or
                                                                                                self.eeprom_size.is_set or
                                                                                                self.engineer_use.is_set or
                                                                                                self.fru_major_type.is_set or
                                                                                                self.fru_minor_type.is_set or
                                                                                                self.hw_version.is_set or
                                                                                                self.hwid.is_set or
                                                                                                self.idprom_format_rev.is_set or
                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                self.manu_test_data.is_set or
                                                                                                self.mfg_bits.is_set or
                                                                                                self.mfg_deviation.is_set or
                                                                                                self.oem_string.is_set or
                                                                                                self.part_number.is_set or
                                                                                                self.part_revision.is_set or
                                                                                                self.pca_num.is_set or
                                                                                                self.pcavid.is_set or
                                                                                                self.pcb_serial_num.is_set or
                                                                                                self.pid.is_set or
                                                                                                self.power_consumption.is_set or
                                                                                                self.power_supply_type.is_set or
                                                                                                self.product_id.is_set or
                                                                                                self.rma_code.is_set or
                                                                                                self.serial_number.is_set or
                                                                                                self.snmpoid.is_set or
                                                                                                self.top_assem_part_num.is_set or
                                                                                                self.top_assem_vid.is_set or
                                                                                                self.udi_description.is_set or
                                                                                                self.udi_name.is_set or
                                                                                                self.vid.is_set or
                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "rma"):
                                                                                                if (self.rma is None):
                                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                return self.rma

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "asset-alias"):
                                                                                                self.asset_alias = value
                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "asset-id"):
                                                                                                self.asset_id = value
                                                                                                self.asset_id.value_namespace = name_space
                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address1"):
                                                                                                self.base_mac_address1 = value
                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address2"):
                                                                                                self.base_mac_address2 = value
                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address3"):
                                                                                                self.base_mac_address3 = value
                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address4"):
                                                                                                self.base_mac_address4 = value
                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-checksum"):
                                                                                                self.block_checksum = value
                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-count"):
                                                                                                self.block_count = value
                                                                                                self.block_count.value_namespace = name_space
                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-length"):
                                                                                                self.block_length = value
                                                                                                self.block_length.value_namespace = name_space
                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-signature"):
                                                                                                self.block_signature = value
                                                                                                self.block_signature.value_namespace = name_space
                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-version"):
                                                                                                self.block_version = value
                                                                                                self.block_version.value_namespace = name_space
                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "chassis-sid"):
                                                                                                self.chassis_sid = value
                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "clei"):
                                                                                                self.clei = value
                                                                                                self.clei.value_namespace = name_space
                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-family"):
                                                                                                self.controller_family = value
                                                                                                self.controller_family.value_namespace = name_space
                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-type"):
                                                                                                self.controller_type = value
                                                                                                self.controller_type.value_namespace = name_space
                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "description"):
                                                                                                self.description = value
                                                                                                self.description.value_namespace = name_space
                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num1"):
                                                                                                self.dev_num1 = value
                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num2"):
                                                                                                self.dev_num2 = value
                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num3"):
                                                                                                self.dev_num3 = value
                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num4"):
                                                                                                self.dev_num4 = value
                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num5"):
                                                                                                self.dev_num5 = value
                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num6"):
                                                                                                self.dev_num6 = value
                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num7"):
                                                                                                self.dev_num7 = value
                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eci"):
                                                                                                self.eci = value
                                                                                                self.eci.value_namespace = name_space
                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eeprom-size"):
                                                                                                self.eeprom_size = value
                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "engineer-use"):
                                                                                                self.engineer_use = value
                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-major-type"):
                                                                                                self.fru_major_type = value
                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-minor-type"):
                                                                                                self.fru_minor_type = value
                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hw-version"):
                                                                                                self.hw_version = value
                                                                                                self.hw_version.value_namespace = name_space
                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hwid"):
                                                                                                self.hwid = value
                                                                                                self.hwid.value_namespace = name_space
                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                self.idprom_format_rev = value
                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                self.mac_add_blk_size1 = value
                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                self.mac_add_blk_size2 = value
                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                self.mac_add_blk_size3 = value
                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                self.mac_add_blk_size4 = value
                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "manu-test-data"):
                                                                                                self.manu_test_data = value
                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-bits"):
                                                                                                self.mfg_bits = value
                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-deviation"):
                                                                                                self.mfg_deviation = value
                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "oem-string"):
                                                                                                self.oem_string = value
                                                                                                self.oem_string.value_namespace = name_space
                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-number"):
                                                                                                self.part_number = value
                                                                                                self.part_number.value_namespace = name_space
                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-revision"):
                                                                                                self.part_revision = value
                                                                                                self.part_revision.value_namespace = name_space
                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pca-num"):
                                                                                                self.pca_num = value
                                                                                                self.pca_num.value_namespace = name_space
                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcavid"):
                                                                                                self.pcavid = value
                                                                                                self.pcavid.value_namespace = name_space
                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                self.pcb_serial_num = value
                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pid"):
                                                                                                self.pid = value
                                                                                                self.pid.value_namespace = name_space
                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-consumption"):
                                                                                                self.power_consumption = value
                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-supply-type"):
                                                                                                self.power_supply_type = value
                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "product-id"):
                                                                                                self.product_id = value
                                                                                                self.product_id.value_namespace = name_space
                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "rma-code"):
                                                                                                self.rma_code = value
                                                                                                self.rma_code.value_namespace = name_space
                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "serial-number"):
                                                                                                self.serial_number = value
                                                                                                self.serial_number.value_namespace = name_space
                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "snmpoid"):
                                                                                                self.snmpoid = value
                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                self.top_assem_part_num = value
                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-vid"):
                                                                                                self.top_assem_vid = value
                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-description"):
                                                                                                self.udi_description = value
                                                                                                self.udi_description.value_namespace = name_space
                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-name"):
                                                                                                self.udi_name = value
                                                                                                self.udi_name.value_namespace = name_space
                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vid"):
                                                                                                self.vid = value
                                                                                                self.vid.value_namespace = name_space
                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.description.is_set or
                                                                                            self.has_eeprom.is_set or
                                                                                            self.inv_card_type.is_set or
                                                                                            self.opaque_data.is_set or
                                                                                            self.opaque_data_size.is_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "eeprom"):
                                                                                            if (self.eeprom is None):
                                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                            return self.eeprom

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "has-eeprom"):
                                                                                            self.has_eeprom = value
                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "inv-card-type"):
                                                                                            self.inv_card_type = value
                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data"):
                                                                                            self.opaque_data = value
                                                                                            self.opaque_data.value_namespace = name_space
                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data-size"):
                                                                                            self.opaque_data_size = value
                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.module_done.is_set or
                                                                                        self.node_id.is_set or
                                                                                        self.vm_done.is_set or
                                                                                        self.vm_node_id.is_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "attributes" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                        if (self.env_sensor_info is None):
                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                        return self.env_sensor_info

                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                        if (self.env_sensor_info_xml is None):
                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                        return self.env_sensor_info_xml

                                                                                    if (child_yang_name == "fru-info"):
                                                                                        if (self.fru_info is None):
                                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                        return self.fru_info

                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                        if (self.inv_asset_bag is None):
                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                        return self.inv_asset_bag

                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                        if (self.inv_basic_bag is None):
                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                        return self.inv_basic_bag

                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                        if (self.inv_eeprom_info is None):
                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                        return self.inv_eeprom_info

                                                                                    if (child_yang_name == "pwg-info"):
                                                                                        if (self.pwg_info is None):
                                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                        return self.pwg_info

                                                                                    if (child_yang_name == "threshold"):
                                                                                        if (self.threshold is None):
                                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                        return self.threshold

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "module-done"):
                                                                                        self.module_done = value
                                                                                        self.module_done.value_namespace = name_space
                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "node-id"):
                                                                                        self.node_id = value
                                                                                        self.node_id.value_namespace = name_space
                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-done"):
                                                                                        self.vm_done = value
                                                                                        self.vm_done.value_namespace = name_space
                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-node-id"):
                                                                                        self.vm_node_id = value
                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.name.is_set or
                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "tsi7" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "attributes"):
                                                                                    if (self.attributes is None):
                                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                    return self.attributes

                                                                                if (child_yang_name == "tsi8s"):
                                                                                    if (self.tsi8s is None):
                                                                                        self.tsi8s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                        self.tsi8s.parent = self
                                                                                        self._children_name_map["tsi8s"] = "tsi8s"
                                                                                    return self.tsi8s

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "attributes" or name == "tsi8s" or name == "name"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "tsi7s" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "tsi7"):
                                                                                for c in self.tsi7:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.tsi7.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "tsi7"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class Attributes(Entity):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        .. attribute:: module_done
                                                                        
                                                                        	Inventory EDM Module Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**default value**\: 1
                                                                        
                                                                        .. attribute:: node_id
                                                                        
                                                                        	Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        .. attribute:: vm_done
                                                                        
                                                                        	VM Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        .. attribute:: vm_node_id
                                                                        
                                                                        	VM Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                            self._children_yang_names.add("env-sensor-info")

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                            self._children_yang_names.add("fru-info")

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                            self._children_yang_names.add("pwg-info")

                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                            self._children_yang_names.add("threshold")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("module_done",
                                                                                            "node_id",
                                                                                            "vm_done",
                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)


                                                                        class EnvSensorInfo(Entity):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                self.units = YLeaf(YType.str, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("age_time_stamp",
                                                                                                "alarm_type",
                                                                                                "data_type",
                                                                                                "device_description",
                                                                                                "device_id",
                                                                                                "field_validity_bitmap",
                                                                                                "precision",
                                                                                                "scale",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.age_time_stamp.is_set or
                                                                                    self.alarm_type.is_set or
                                                                                    self.data_type.is_set or
                                                                                    self.device_description.is_set or
                                                                                    self.device_id.is_set or
                                                                                    self.field_validity_bitmap.is_set or
                                                                                    self.precision.is_set or
                                                                                    self.scale.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "age-time-stamp"):
                                                                                    self.age_time_stamp = value
                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "alarm-type"):
                                                                                    self.alarm_type = value
                                                                                    self.alarm_type.value_namespace = name_space
                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-description"):
                                                                                    self.device_description = value
                                                                                    self.device_description.value_namespace = name_space
                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-id"):
                                                                                    self.device_id = value
                                                                                    self.device_id.value_namespace = name_space
                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "field-validity-bitmap"):
                                                                                    self.field_validity_bitmap = value
                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "precision"):
                                                                                    self.precision = value
                                                                                    self.precision.value_namespace = name_space
                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "scale"):
                                                                                    self.scale = value
                                                                                    self.scale.value_namespace = name_space
                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class PwgInfo(Entity):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("power_group_available_current",
                                                                                                "power_group_drawn_current",
                                                                                                "power_group_power_units",
                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.power_group_available_current.is_set or
                                                                                    self.power_group_drawn_current.is_set or
                                                                                    self.power_group_power_units.is_set or
                                                                                    self.power_group_redundancy_mode.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "power-group-available-current"):
                                                                                    self.power_group_available_current = value
                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-drawn-current"):
                                                                                    self.power_group_drawn_current = value
                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-power-units"):
                                                                                    self.power_group_power_units = value
                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                    self.power_group_redundancy_mode = value
                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                        class EnvSensorInfoXml(Entity):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.str, "value")

                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._children_yang_names.add("threshold")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("data_type",
                                                                                                "description",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                            class Threshold(Entity):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                    self.threshold_array = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                class ThresholdArray(Entity):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"

                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_name",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_name.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-name"):
                                                                                            self.threshold_name = value
                                                                                            self.threshold_name.value_namespace = name_space
                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "threshold" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "threshold-array"):
                                                                                        for c in self.threshold_array:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.threshold_array.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "threshold-array"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.data_type.is_set or
                                                                                    self.description.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set or
                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "threshold"):
                                                                                    if (self.threshold is None):
                                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                    return self.threshold

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class InvAssetBag(Entity):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                "manufacturer_assembly_revision",
                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                "manufacturer_firmware_identifier",
                                                                                                "manufacturer_software_identifier",
                                                                                                "original_equipment_manufacturer_string",
                                                                                                "part_number") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                    self.part_number.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                    self.manufacturer_assembly_number = value
                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                    self.manufacturer_assembly_revision = value
                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                    self.manufacturer_firmware_identifier = value
                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                    self.manufacturer_software_identifier = value
                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                    self.original_equipment_manufacturer_string = value
                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "part-number"):
                                                                                    self.part_number = value
                                                                                    self.part_number.value_namespace = name_space
                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                        class Threshold(Entity):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                self._children_yang_names.add("critical-hi")

                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                self._children_yang_names.add("critical-lo")

                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                self._children_yang_names.add("major-hi")

                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                self._children_yang_names.add("major-lo")

                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                self._children_yang_names.add("minor-hi")

                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._children_yang_names.add("minor-lo")


                                                                            class MajorLo(Entity):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalHi(Entity):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorHi(Entity):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MajorHi(Entity):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalLo(Entity):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorLo(Entity):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "critical-hi"):
                                                                                    if (self.critical_hi is None):
                                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                    return self.critical_hi

                                                                                if (child_yang_name == "critical-lo"):
                                                                                    if (self.critical_lo is None):
                                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                    return self.critical_lo

                                                                                if (child_yang_name == "major-hi"):
                                                                                    if (self.major_hi is None):
                                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                    return self.major_hi

                                                                                if (child_yang_name == "major-lo"):
                                                                                    if (self.major_lo is None):
                                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                    return self.major_lo

                                                                                if (child_yang_name == "minor-hi"):
                                                                                    if (self.minor_hi is None):
                                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                    return self.minor_hi

                                                                                if (child_yang_name == "minor-lo"):
                                                                                    if (self.minor_lo is None):
                                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                    return self.minor_lo

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                pass


                                                                        class FruInfo(Entity):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._children_yang_names.add("card-up-time")

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("card_administrative_state",
                                                                                                "card_monitor_state",
                                                                                                "card_operational_state",
                                                                                                "card_reset_reason",
                                                                                                "power_administrative_state",
                                                                                                "power_current_measurement",
                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)


                                                                            class LastOperationalStateChange(Entity):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                            class CardUpTime(Entity):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.card_administrative_state.is_set or
                                                                                    self.card_monitor_state.is_set or
                                                                                    self.card_operational_state.is_set or
                                                                                    self.card_reset_reason.is_set or
                                                                                    self.power_administrative_state.is_set or
                                                                                    self.power_current_measurement.is_set or
                                                                                    self.power_operational_state.is_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "fru-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "card-up-time"):
                                                                                    if (self.card_up_time is None):
                                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                    return self.card_up_time

                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                    if (self.last_operational_state_change is None):
                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                    return self.last_operational_state_change

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "card-administrative-state"):
                                                                                    self.card_administrative_state = value
                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-monitor-state"):
                                                                                    self.card_monitor_state = value
                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-operational-state"):
                                                                                    self.card_operational_state = value
                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-reset-reason"):
                                                                                    self.card_reset_reason = value
                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-administrative-state"):
                                                                                    self.power_administrative_state = value
                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-current-measurement"):
                                                                                    self.power_current_measurement = value
                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-operational-state"):
                                                                                    self.power_operational_state = value
                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                        class InvBasicBag(Entity):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("alias",
                                                                                                "asset_id_str",
                                                                                                "asset_identification",
                                                                                                "ceport",
                                                                                                "chip_hardware_revision",
                                                                                                "composite_class_code",
                                                                                                "description",
                                                                                                "environmental_monitor_path",
                                                                                                "firmware_revision",
                                                                                                "group_flag",
                                                                                                "hardware_revision",
                                                                                                "is_field_replaceable_unit",
                                                                                                "manufacturer_asset_tags",
                                                                                                "manufacturer_name",
                                                                                                "memory_size",
                                                                                                "model_name",
                                                                                                "name",
                                                                                                "new_deviation_number",
                                                                                                "physical_layer_interface_module_type",
                                                                                                "redundancystate",
                                                                                                "serial_number",
                                                                                                "software_revision",
                                                                                                "unique_id",
                                                                                                "unrecognized_fru",
                                                                                                "vendor_type",
                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.alias.is_set or
                                                                                    self.asset_id_str.is_set or
                                                                                    self.asset_identification.is_set or
                                                                                    self.ceport.is_set or
                                                                                    self.chip_hardware_revision.is_set or
                                                                                    self.composite_class_code.is_set or
                                                                                    self.description.is_set or
                                                                                    self.environmental_monitor_path.is_set or
                                                                                    self.firmware_revision.is_set or
                                                                                    self.group_flag.is_set or
                                                                                    self.hardware_revision.is_set or
                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                    self.manufacturer_name.is_set or
                                                                                    self.memory_size.is_set or
                                                                                    self.model_name.is_set or
                                                                                    self.name.is_set or
                                                                                    self.new_deviation_number.is_set or
                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                    self.redundancystate.is_set or
                                                                                    self.serial_number.is_set or
                                                                                    self.software_revision.is_set or
                                                                                    self.unique_id.is_set or
                                                                                    self.unrecognized_fru.is_set or
                                                                                    self.vendor_type.is_set or
                                                                                    self.xr_scoped.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "alias"):
                                                                                    self.alias = value
                                                                                    self.alias.value_namespace = name_space
                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-id-str"):
                                                                                    self.asset_id_str = value
                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-identification"):
                                                                                    self.asset_identification = value
                                                                                    self.asset_identification.value_namespace = name_space
                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "ceport"):
                                                                                    self.ceport = value
                                                                                    self.ceport.value_namespace = name_space
                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "chip-hardware-revision"):
                                                                                    self.chip_hardware_revision = value
                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "composite-class-code"):
                                                                                    self.composite_class_code = value
                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "environmental-monitor-path"):
                                                                                    self.environmental_monitor_path = value
                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "firmware-revision"):
                                                                                    self.firmware_revision = value
                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "group-flag"):
                                                                                    self.group_flag = value
                                                                                    self.group_flag.value_namespace = name_space
                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "hardware-revision"):
                                                                                    self.hardware_revision = value
                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                    self.is_field_replaceable_unit = value
                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                    self.manufacturer_asset_tags = value
                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-name"):
                                                                                    self.manufacturer_name = value
                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "memory-size"):
                                                                                    self.memory_size = value
                                                                                    self.memory_size.value_namespace = name_space
                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "model-name"):
                                                                                    self.model_name = value
                                                                                    self.model_name.value_namespace = name_space
                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "new-deviation-number"):
                                                                                    self.new_deviation_number = value
                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                    self.physical_layer_interface_module_type = value
                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "redundancystate"):
                                                                                    self.redundancystate = value
                                                                                    self.redundancystate.value_namespace = name_space
                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "serial-number"):
                                                                                    self.serial_number = value
                                                                                    self.serial_number.value_namespace = name_space
                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "software-revision"):
                                                                                    self.software_revision = value
                                                                                    self.software_revision.value_namespace = name_space
                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unique-id"):
                                                                                    self.unique_id = value
                                                                                    self.unique_id.value_namespace = name_space
                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unrecognized-fru"):
                                                                                    self.unrecognized_fru = value
                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "vendor-type"):
                                                                                    self.vendor_type = value
                                                                                    self.vendor_type.value_namespace = name_space
                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "xr-scoped"):
                                                                                    self.xr_scoped = value
                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                        class InvEepromInfo(Entity):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._children_yang_names.add("eeprom")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("description",
                                                                                                "has_eeprom",
                                                                                                "inv_card_type",
                                                                                                "opaque_data",
                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                            class Eeprom(Entity):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._children_yang_names.add("rma")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("asset_alias",
                                                                                                    "asset_id",
                                                                                                    "base_mac_address1",
                                                                                                    "base_mac_address2",
                                                                                                    "base_mac_address3",
                                                                                                    "base_mac_address4",
                                                                                                    "block_checksum",
                                                                                                    "block_count",
                                                                                                    "block_length",
                                                                                                    "block_signature",
                                                                                                    "block_version",
                                                                                                    "chassis_sid",
                                                                                                    "clei",
                                                                                                    "controller_family",
                                                                                                    "controller_type",
                                                                                                    "description",
                                                                                                    "dev_num1",
                                                                                                    "dev_num2",
                                                                                                    "dev_num3",
                                                                                                    "dev_num4",
                                                                                                    "dev_num5",
                                                                                                    "dev_num6",
                                                                                                    "dev_num7",
                                                                                                    "eci",
                                                                                                    "eeprom_size",
                                                                                                    "engineer_use",
                                                                                                    "fru_major_type",
                                                                                                    "fru_minor_type",
                                                                                                    "hw_version",
                                                                                                    "hwid",
                                                                                                    "idprom_format_rev",
                                                                                                    "mac_add_blk_size1",
                                                                                                    "mac_add_blk_size2",
                                                                                                    "mac_add_blk_size3",
                                                                                                    "mac_add_blk_size4",
                                                                                                    "manu_test_data",
                                                                                                    "mfg_bits",
                                                                                                    "mfg_deviation",
                                                                                                    "oem_string",
                                                                                                    "part_number",
                                                                                                    "part_revision",
                                                                                                    "pca_num",
                                                                                                    "pcavid",
                                                                                                    "pcb_serial_num",
                                                                                                    "pid",
                                                                                                    "power_consumption",
                                                                                                    "power_supply_type",
                                                                                                    "product_id",
                                                                                                    "rma_code",
                                                                                                    "serial_number",
                                                                                                    "snmpoid",
                                                                                                    "top_assem_part_num",
                                                                                                    "top_assem_vid",
                                                                                                    "udi_description",
                                                                                                    "udi_name",
                                                                                                    "vid") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                class Rma(Entity):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"

                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("rma_history",
                                                                                                        "rma_number",
                                                                                                        "test_history") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.rma_history.is_set or
                                                                                            self.rma_number.is_set or
                                                                                            self.test_history.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "rma" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "rma-history"):
                                                                                            self.rma_history = value
                                                                                            self.rma_history.value_namespace = name_space
                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "rma-number"):
                                                                                            self.rma_number = value
                                                                                            self.rma_number.value_namespace = name_space
                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "test-history"):
                                                                                            self.test_history = value
                                                                                            self.test_history.value_namespace = name_space
                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.asset_alias.is_set or
                                                                                        self.asset_id.is_set or
                                                                                        self.base_mac_address1.is_set or
                                                                                        self.base_mac_address2.is_set or
                                                                                        self.base_mac_address3.is_set or
                                                                                        self.base_mac_address4.is_set or
                                                                                        self.block_checksum.is_set or
                                                                                        self.block_count.is_set or
                                                                                        self.block_length.is_set or
                                                                                        self.block_signature.is_set or
                                                                                        self.block_version.is_set or
                                                                                        self.chassis_sid.is_set or
                                                                                        self.clei.is_set or
                                                                                        self.controller_family.is_set or
                                                                                        self.controller_type.is_set or
                                                                                        self.description.is_set or
                                                                                        self.dev_num1.is_set or
                                                                                        self.dev_num2.is_set or
                                                                                        self.dev_num3.is_set or
                                                                                        self.dev_num4.is_set or
                                                                                        self.dev_num5.is_set or
                                                                                        self.dev_num6.is_set or
                                                                                        self.dev_num7.is_set or
                                                                                        self.eci.is_set or
                                                                                        self.eeprom_size.is_set or
                                                                                        self.engineer_use.is_set or
                                                                                        self.fru_major_type.is_set or
                                                                                        self.fru_minor_type.is_set or
                                                                                        self.hw_version.is_set or
                                                                                        self.hwid.is_set or
                                                                                        self.idprom_format_rev.is_set or
                                                                                        self.mac_add_blk_size1.is_set or
                                                                                        self.mac_add_blk_size2.is_set or
                                                                                        self.mac_add_blk_size3.is_set or
                                                                                        self.mac_add_blk_size4.is_set or
                                                                                        self.manu_test_data.is_set or
                                                                                        self.mfg_bits.is_set or
                                                                                        self.mfg_deviation.is_set or
                                                                                        self.oem_string.is_set or
                                                                                        self.part_number.is_set or
                                                                                        self.part_revision.is_set or
                                                                                        self.pca_num.is_set or
                                                                                        self.pcavid.is_set or
                                                                                        self.pcb_serial_num.is_set or
                                                                                        self.pid.is_set or
                                                                                        self.power_consumption.is_set or
                                                                                        self.power_supply_type.is_set or
                                                                                        self.product_id.is_set or
                                                                                        self.rma_code.is_set or
                                                                                        self.serial_number.is_set or
                                                                                        self.snmpoid.is_set or
                                                                                        self.top_assem_part_num.is_set or
                                                                                        self.top_assem_vid.is_set or
                                                                                        self.udi_description.is_set or
                                                                                        self.udi_name.is_set or
                                                                                        self.vid.is_set or
                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "rma"):
                                                                                        if (self.rma is None):
                                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                        return self.rma

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "asset-alias"):
                                                                                        self.asset_alias = value
                                                                                        self.asset_alias.value_namespace = name_space
                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "asset-id"):
                                                                                        self.asset_id = value
                                                                                        self.asset_id.value_namespace = name_space
                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address1"):
                                                                                        self.base_mac_address1 = value
                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address2"):
                                                                                        self.base_mac_address2 = value
                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address3"):
                                                                                        self.base_mac_address3 = value
                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address4"):
                                                                                        self.base_mac_address4 = value
                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-checksum"):
                                                                                        self.block_checksum = value
                                                                                        self.block_checksum.value_namespace = name_space
                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-count"):
                                                                                        self.block_count = value
                                                                                        self.block_count.value_namespace = name_space
                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-length"):
                                                                                        self.block_length = value
                                                                                        self.block_length.value_namespace = name_space
                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-signature"):
                                                                                        self.block_signature = value
                                                                                        self.block_signature.value_namespace = name_space
                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-version"):
                                                                                        self.block_version = value
                                                                                        self.block_version.value_namespace = name_space
                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "chassis-sid"):
                                                                                        self.chassis_sid = value
                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "clei"):
                                                                                        self.clei = value
                                                                                        self.clei.value_namespace = name_space
                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-family"):
                                                                                        self.controller_family = value
                                                                                        self.controller_family.value_namespace = name_space
                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-type"):
                                                                                        self.controller_type = value
                                                                                        self.controller_type.value_namespace = name_space
                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "description"):
                                                                                        self.description = value
                                                                                        self.description.value_namespace = name_space
                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num1"):
                                                                                        self.dev_num1 = value
                                                                                        self.dev_num1.value_namespace = name_space
                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num2"):
                                                                                        self.dev_num2 = value
                                                                                        self.dev_num2.value_namespace = name_space
                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num3"):
                                                                                        self.dev_num3 = value
                                                                                        self.dev_num3.value_namespace = name_space
                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num4"):
                                                                                        self.dev_num4 = value
                                                                                        self.dev_num4.value_namespace = name_space
                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num5"):
                                                                                        self.dev_num5 = value
                                                                                        self.dev_num5.value_namespace = name_space
                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num6"):
                                                                                        self.dev_num6 = value
                                                                                        self.dev_num6.value_namespace = name_space
                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num7"):
                                                                                        self.dev_num7 = value
                                                                                        self.dev_num7.value_namespace = name_space
                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eci"):
                                                                                        self.eci = value
                                                                                        self.eci.value_namespace = name_space
                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eeprom-size"):
                                                                                        self.eeprom_size = value
                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "engineer-use"):
                                                                                        self.engineer_use = value
                                                                                        self.engineer_use.value_namespace = name_space
                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-major-type"):
                                                                                        self.fru_major_type = value
                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-minor-type"):
                                                                                        self.fru_minor_type = value
                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hw-version"):
                                                                                        self.hw_version = value
                                                                                        self.hw_version.value_namespace = name_space
                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hwid"):
                                                                                        self.hwid = value
                                                                                        self.hwid.value_namespace = name_space
                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "idprom-format-rev"):
                                                                                        self.idprom_format_rev = value
                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                        self.mac_add_blk_size1 = value
                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                        self.mac_add_blk_size2 = value
                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                        self.mac_add_blk_size3 = value
                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                        self.mac_add_blk_size4 = value
                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "manu-test-data"):
                                                                                        self.manu_test_data = value
                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-bits"):
                                                                                        self.mfg_bits = value
                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-deviation"):
                                                                                        self.mfg_deviation = value
                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "oem-string"):
                                                                                        self.oem_string = value
                                                                                        self.oem_string.value_namespace = name_space
                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-number"):
                                                                                        self.part_number = value
                                                                                        self.part_number.value_namespace = name_space
                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-revision"):
                                                                                        self.part_revision = value
                                                                                        self.part_revision.value_namespace = name_space
                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pca-num"):
                                                                                        self.pca_num = value
                                                                                        self.pca_num.value_namespace = name_space
                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcavid"):
                                                                                        self.pcavid = value
                                                                                        self.pcavid.value_namespace = name_space
                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcb-serial-num"):
                                                                                        self.pcb_serial_num = value
                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pid"):
                                                                                        self.pid = value
                                                                                        self.pid.value_namespace = name_space
                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-consumption"):
                                                                                        self.power_consumption = value
                                                                                        self.power_consumption.value_namespace = name_space
                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-supply-type"):
                                                                                        self.power_supply_type = value
                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "product-id"):
                                                                                        self.product_id = value
                                                                                        self.product_id.value_namespace = name_space
                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "rma-code"):
                                                                                        self.rma_code = value
                                                                                        self.rma_code.value_namespace = name_space
                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "serial-number"):
                                                                                        self.serial_number = value
                                                                                        self.serial_number.value_namespace = name_space
                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "snmpoid"):
                                                                                        self.snmpoid = value
                                                                                        self.snmpoid.value_namespace = name_space
                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-part-num"):
                                                                                        self.top_assem_part_num = value
                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-vid"):
                                                                                        self.top_assem_vid = value
                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-description"):
                                                                                        self.udi_description = value
                                                                                        self.udi_description.value_namespace = name_space
                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-name"):
                                                                                        self.udi_name = value
                                                                                        self.udi_name.value_namespace = name_space
                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vid"):
                                                                                        self.vid = value
                                                                                        self.vid.value_namespace = name_space
                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.description.is_set or
                                                                                    self.has_eeprom.is_set or
                                                                                    self.inv_card_type.is_set or
                                                                                    self.opaque_data.is_set or
                                                                                    self.opaque_data_size.is_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "eeprom"):
                                                                                    if (self.eeprom is None):
                                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                    return self.eeprom

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "has-eeprom"):
                                                                                    self.has_eeprom = value
                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "inv-card-type"):
                                                                                    self.inv_card_type = value
                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data"):
                                                                                    self.opaque_data = value
                                                                                    self.opaque_data.value_namespace = name_space
                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data-size"):
                                                                                    self.opaque_data_size = value
                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.module_done.is_set or
                                                                                self.node_id.is_set or
                                                                                self.vm_done.is_set or
                                                                                self.vm_node_id.is_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "attributes" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                if (self.env_sensor_info is None):
                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                return self.env_sensor_info

                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                if (self.env_sensor_info_xml is None):
                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                return self.env_sensor_info_xml

                                                                            if (child_yang_name == "fru-info"):
                                                                                if (self.fru_info is None):
                                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                return self.fru_info

                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                if (self.inv_asset_bag is None):
                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                return self.inv_asset_bag

                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                if (self.inv_basic_bag is None):
                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                return self.inv_basic_bag

                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                if (self.inv_eeprom_info is None):
                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                return self.inv_eeprom_info

                                                                            if (child_yang_name == "pwg-info"):
                                                                                if (self.pwg_info is None):
                                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                return self.pwg_info

                                                                            if (child_yang_name == "threshold"):
                                                                                if (self.threshold is None):
                                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                return self.threshold

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "module-done"):
                                                                                self.module_done = value
                                                                                self.module_done.value_namespace = name_space
                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "node-id"):
                                                                                self.node_id = value
                                                                                self.node_id.value_namespace = name_space
                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-done"):
                                                                                self.vm_done = value
                                                                                self.vm_done.value_namespace = name_space
                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-node-id"):
                                                                                self.vm_node_id = value
                                                                                self.vm_node_id.value_namespace = name_space
                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.name.is_set or
                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "tsi6" + "[name='" + self.name.get() + "']" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "attributes"):
                                                                            if (self.attributes is None):
                                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                            return self.attributes

                                                                        if (child_yang_name == "tsi7s"):
                                                                            if (self.tsi7s is None):
                                                                                self.tsi7s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                                self.tsi7s.parent = self
                                                                                self._children_name_map["tsi7s"] = "tsi7s"
                                                                            return self.tsi7s

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "attributes" or name == "tsi7s" or name == "name"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "tsi6s" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "tsi6"):
                                                                        for c in self.tsi6:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.tsi6.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "tsi6"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class Attributes(Entity):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo>`
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                .. attribute:: module_done
                                                                
                                                                	Inventory EDM Module Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**default value**\: 1
                                                                
                                                                .. attribute:: node_id
                                                                
                                                                	Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold>`
                                                                
                                                                .. attribute:: vm_done
                                                                
                                                                	VM Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                .. attribute:: vm_node_id
                                                                
                                                                	VM Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                    self._children_yang_names.add("env-sensor-info")

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                    self._children_yang_names.add("fru-info")

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                    self._children_yang_names.add("pwg-info")

                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                    self._children_yang_names.add("threshold")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("module_done",
                                                                                    "node_id",
                                                                                    "vm_done",
                                                                                    "vm_node_id") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)


                                                                class EnvSensorInfo(Entity):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                        self.units = YLeaf(YType.str, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("age_time_stamp",
                                                                                        "alarm_type",
                                                                                        "data_type",
                                                                                        "device_description",
                                                                                        "device_id",
                                                                                        "field_validity_bitmap",
                                                                                        "precision",
                                                                                        "scale",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.age_time_stamp.is_set or
                                                                            self.alarm_type.is_set or
                                                                            self.data_type.is_set or
                                                                            self.device_description.is_set or
                                                                            self.device_id.is_set or
                                                                            self.field_validity_bitmap.is_set or
                                                                            self.precision.is_set or
                                                                            self.scale.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                            self.precision.yfilter != YFilter.not_set or
                                                                            self.scale.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "age-time-stamp"):
                                                                            self.age_time_stamp = value
                                                                            self.age_time_stamp.value_namespace = name_space
                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "alarm-type"):
                                                                            self.alarm_type = value
                                                                            self.alarm_type.value_namespace = name_space
                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-description"):
                                                                            self.device_description = value
                                                                            self.device_description.value_namespace = name_space
                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-id"):
                                                                            self.device_id = value
                                                                            self.device_id.value_namespace = name_space
                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "field-validity-bitmap"):
                                                                            self.field_validity_bitmap = value
                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "precision"):
                                                                            self.precision = value
                                                                            self.precision.value_namespace = name_space
                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "scale"):
                                                                            self.scale = value
                                                                            self.scale.value_namespace = name_space
                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class PwgInfo(Entity):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("power_group_available_current",
                                                                                        "power_group_drawn_current",
                                                                                        "power_group_power_units",
                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.power_group_available_current.is_set or
                                                                            self.power_group_drawn_current.is_set or
                                                                            self.power_group_power_units.is_set or
                                                                            self.power_group_redundancy_mode.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "pwg-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "power-group-available-current"):
                                                                            self.power_group_available_current = value
                                                                            self.power_group_available_current.value_namespace = name_space
                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-drawn-current"):
                                                                            self.power_group_drawn_current = value
                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-power-units"):
                                                                            self.power_group_power_units = value
                                                                            self.power_group_power_units.value_namespace = name_space
                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                            self.power_group_redundancy_mode = value
                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                class EnvSensorInfoXml(Entity):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.str, "value")

                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._children_yang_names.add("threshold")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("data_type",
                                                                                        "description",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                    class Threshold(Entity):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                            self.threshold_array = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                        class ThresholdArray(Entity):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"

                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_name",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_name.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-name"):
                                                                                    self.threshold_name = value
                                                                                    self.threshold_name.value_namespace = name_space
                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "threshold" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "threshold-array"):
                                                                                for c in self.threshold_array:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.threshold_array.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "threshold-array"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            self.data_type.is_set or
                                                                            self.description.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set or
                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "threshold"):
                                                                            if (self.threshold is None):
                                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                            return self.threshold

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class InvAssetBag(Entity):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("manufacturer_assembly_number",
                                                                                        "manufacturer_assembly_revision",
                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                        "manufacturer_firmware_identifier",
                                                                                        "manufacturer_software_identifier",
                                                                                        "original_equipment_manufacturer_string",
                                                                                        "part_number") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.manufacturer_assembly_number.is_set or
                                                                            self.manufacturer_assembly_revision.is_set or
                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                            self.manufacturer_software_identifier.is_set or
                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                            self.part_number.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                            self.manufacturer_assembly_number = value
                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                            self.manufacturer_assembly_revision = value
                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                            self.manufacturer_firmware_identifier = value
                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                            self.manufacturer_software_identifier = value
                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                            self.original_equipment_manufacturer_string = value
                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "part-number"):
                                                                            self.part_number = value
                                                                            self.part_number.value_namespace = name_space
                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                class Threshold(Entity):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                        self._children_yang_names.add("critical-hi")

                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                        self._children_yang_names.add("critical-lo")

                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                        self._children_yang_names.add("major-hi")

                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                        self._children_yang_names.add("major-lo")

                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                        self._children_yang_names.add("minor-hi")

                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._children_yang_names.add("minor-lo")


                                                                    class MajorLo(Entity):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalHi(Entity):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorHi(Entity):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MajorHi(Entity):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalLo(Entity):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorLo(Entity):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "critical-hi"):
                                                                            if (self.critical_hi is None):
                                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                            return self.critical_hi

                                                                        if (child_yang_name == "critical-lo"):
                                                                            if (self.critical_lo is None):
                                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                            return self.critical_lo

                                                                        if (child_yang_name == "major-hi"):
                                                                            if (self.major_hi is None):
                                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                            return self.major_hi

                                                                        if (child_yang_name == "major-lo"):
                                                                            if (self.major_lo is None):
                                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                            return self.major_lo

                                                                        if (child_yang_name == "minor-hi"):
                                                                            if (self.minor_hi is None):
                                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                            return self.minor_hi

                                                                        if (child_yang_name == "minor-lo"):
                                                                            if (self.minor_lo is None):
                                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                            return self.minor_lo

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        pass


                                                                class FruInfo(Entity):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._children_yang_names.add("card-up-time")

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("card_administrative_state",
                                                                                        "card_monitor_state",
                                                                                        "card_operational_state",
                                                                                        "card_reset_reason",
                                                                                        "power_administrative_state",
                                                                                        "power_current_measurement",
                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)


                                                                    class LastOperationalStateChange(Entity):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                    class CardUpTime(Entity):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "card-up-time" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.card_administrative_state.is_set or
                                                                            self.card_monitor_state.is_set or
                                                                            self.card_operational_state.is_set or
                                                                            self.card_reset_reason.is_set or
                                                                            self.power_administrative_state.is_set or
                                                                            self.power_current_measurement.is_set or
                                                                            self.power_operational_state.is_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "fru-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "card-up-time"):
                                                                            if (self.card_up_time is None):
                                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                            return self.card_up_time

                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                            if (self.last_operational_state_change is None):
                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                            return self.last_operational_state_change

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "card-administrative-state"):
                                                                            self.card_administrative_state = value
                                                                            self.card_administrative_state.value_namespace = name_space
                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-monitor-state"):
                                                                            self.card_monitor_state = value
                                                                            self.card_monitor_state.value_namespace = name_space
                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-operational-state"):
                                                                            self.card_operational_state = value
                                                                            self.card_operational_state.value_namespace = name_space
                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-reset-reason"):
                                                                            self.card_reset_reason = value
                                                                            self.card_reset_reason.value_namespace = name_space
                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-administrative-state"):
                                                                            self.power_administrative_state = value
                                                                            self.power_administrative_state.value_namespace = name_space
                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-current-measurement"):
                                                                            self.power_current_measurement = value
                                                                            self.power_current_measurement.value_namespace = name_space
                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-operational-state"):
                                                                            self.power_operational_state = value
                                                                            self.power_operational_state.value_namespace = name_space
                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                class InvBasicBag(Entity):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("alias",
                                                                                        "asset_id_str",
                                                                                        "asset_identification",
                                                                                        "ceport",
                                                                                        "chip_hardware_revision",
                                                                                        "composite_class_code",
                                                                                        "description",
                                                                                        "environmental_monitor_path",
                                                                                        "firmware_revision",
                                                                                        "group_flag",
                                                                                        "hardware_revision",
                                                                                        "is_field_replaceable_unit",
                                                                                        "manufacturer_asset_tags",
                                                                                        "manufacturer_name",
                                                                                        "memory_size",
                                                                                        "model_name",
                                                                                        "name",
                                                                                        "new_deviation_number",
                                                                                        "physical_layer_interface_module_type",
                                                                                        "redundancystate",
                                                                                        "serial_number",
                                                                                        "software_revision",
                                                                                        "unique_id",
                                                                                        "unrecognized_fru",
                                                                                        "vendor_type",
                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.alias.is_set or
                                                                            self.asset_id_str.is_set or
                                                                            self.asset_identification.is_set or
                                                                            self.ceport.is_set or
                                                                            self.chip_hardware_revision.is_set or
                                                                            self.composite_class_code.is_set or
                                                                            self.description.is_set or
                                                                            self.environmental_monitor_path.is_set or
                                                                            self.firmware_revision.is_set or
                                                                            self.group_flag.is_set or
                                                                            self.hardware_revision.is_set or
                                                                            self.is_field_replaceable_unit.is_set or
                                                                            self.manufacturer_asset_tags.is_set or
                                                                            self.manufacturer_name.is_set or
                                                                            self.memory_size.is_set or
                                                                            self.model_name.is_set or
                                                                            self.name.is_set or
                                                                            self.new_deviation_number.is_set or
                                                                            self.physical_layer_interface_module_type.is_set or
                                                                            self.redundancystate.is_set or
                                                                            self.serial_number.is_set or
                                                                            self.software_revision.is_set or
                                                                            self.unique_id.is_set or
                                                                            self.unrecognized_fru.is_set or
                                                                            self.vendor_type.is_set or
                                                                            self.xr_scoped.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.alias.yfilter != YFilter.not_set or
                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "alias"):
                                                                            self.alias = value
                                                                            self.alias.value_namespace = name_space
                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-id-str"):
                                                                            self.asset_id_str = value
                                                                            self.asset_id_str.value_namespace = name_space
                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-identification"):
                                                                            self.asset_identification = value
                                                                            self.asset_identification.value_namespace = name_space
                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "ceport"):
                                                                            self.ceport = value
                                                                            self.ceport.value_namespace = name_space
                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "chip-hardware-revision"):
                                                                            self.chip_hardware_revision = value
                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "composite-class-code"):
                                                                            self.composite_class_code = value
                                                                            self.composite_class_code.value_namespace = name_space
                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "environmental-monitor-path"):
                                                                            self.environmental_monitor_path = value
                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "firmware-revision"):
                                                                            self.firmware_revision = value
                                                                            self.firmware_revision.value_namespace = name_space
                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "group-flag"):
                                                                            self.group_flag = value
                                                                            self.group_flag.value_namespace = name_space
                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "hardware-revision"):
                                                                            self.hardware_revision = value
                                                                            self.hardware_revision.value_namespace = name_space
                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                            self.is_field_replaceable_unit = value
                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                            self.manufacturer_asset_tags = value
                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-name"):
                                                                            self.manufacturer_name = value
                                                                            self.manufacturer_name.value_namespace = name_space
                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "memory-size"):
                                                                            self.memory_size = value
                                                                            self.memory_size.value_namespace = name_space
                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "model-name"):
                                                                            self.model_name = value
                                                                            self.model_name.value_namespace = name_space
                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "new-deviation-number"):
                                                                            self.new_deviation_number = value
                                                                            self.new_deviation_number.value_namespace = name_space
                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                            self.physical_layer_interface_module_type = value
                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "redundancystate"):
                                                                            self.redundancystate = value
                                                                            self.redundancystate.value_namespace = name_space
                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "serial-number"):
                                                                            self.serial_number = value
                                                                            self.serial_number.value_namespace = name_space
                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "software-revision"):
                                                                            self.software_revision = value
                                                                            self.software_revision.value_namespace = name_space
                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unique-id"):
                                                                            self.unique_id = value
                                                                            self.unique_id.value_namespace = name_space
                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unrecognized-fru"):
                                                                            self.unrecognized_fru = value
                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "vendor-type"):
                                                                            self.vendor_type = value
                                                                            self.vendor_type.value_namespace = name_space
                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "xr-scoped"):
                                                                            self.xr_scoped = value
                                                                            self.xr_scoped.value_namespace = name_space
                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                class InvEepromInfo(Entity):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._children_yang_names.add("eeprom")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("description",
                                                                                        "has_eeprom",
                                                                                        "inv_card_type",
                                                                                        "opaque_data",
                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                    class Eeprom(Entity):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._children_yang_names.add("rma")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("asset_alias",
                                                                                            "asset_id",
                                                                                            "base_mac_address1",
                                                                                            "base_mac_address2",
                                                                                            "base_mac_address3",
                                                                                            "base_mac_address4",
                                                                                            "block_checksum",
                                                                                            "block_count",
                                                                                            "block_length",
                                                                                            "block_signature",
                                                                                            "block_version",
                                                                                            "chassis_sid",
                                                                                            "clei",
                                                                                            "controller_family",
                                                                                            "controller_type",
                                                                                            "description",
                                                                                            "dev_num1",
                                                                                            "dev_num2",
                                                                                            "dev_num3",
                                                                                            "dev_num4",
                                                                                            "dev_num5",
                                                                                            "dev_num6",
                                                                                            "dev_num7",
                                                                                            "eci",
                                                                                            "eeprom_size",
                                                                                            "engineer_use",
                                                                                            "fru_major_type",
                                                                                            "fru_minor_type",
                                                                                            "hw_version",
                                                                                            "hwid",
                                                                                            "idprom_format_rev",
                                                                                            "mac_add_blk_size1",
                                                                                            "mac_add_blk_size2",
                                                                                            "mac_add_blk_size3",
                                                                                            "mac_add_blk_size4",
                                                                                            "manu_test_data",
                                                                                            "mfg_bits",
                                                                                            "mfg_deviation",
                                                                                            "oem_string",
                                                                                            "part_number",
                                                                                            "part_revision",
                                                                                            "pca_num",
                                                                                            "pcavid",
                                                                                            "pcb_serial_num",
                                                                                            "pid",
                                                                                            "power_consumption",
                                                                                            "power_supply_type",
                                                                                            "product_id",
                                                                                            "rma_code",
                                                                                            "serial_number",
                                                                                            "snmpoid",
                                                                                            "top_assem_part_num",
                                                                                            "top_assem_vid",
                                                                                            "udi_description",
                                                                                            "udi_name",
                                                                                            "vid") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                        class Rma(Entity):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"

                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("rma_history",
                                                                                                "rma_number",
                                                                                                "test_history") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.rma_history.is_set or
                                                                                    self.rma_number.is_set or
                                                                                    self.test_history.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "rma" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "rma-history"):
                                                                                    self.rma_history = value
                                                                                    self.rma_history.value_namespace = name_space
                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "rma-number"):
                                                                                    self.rma_number = value
                                                                                    self.rma_number.value_namespace = name_space
                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "test-history"):
                                                                                    self.test_history = value
                                                                                    self.test_history.value_namespace = name_space
                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.asset_alias.is_set or
                                                                                self.asset_id.is_set or
                                                                                self.base_mac_address1.is_set or
                                                                                self.base_mac_address2.is_set or
                                                                                self.base_mac_address3.is_set or
                                                                                self.base_mac_address4.is_set or
                                                                                self.block_checksum.is_set or
                                                                                self.block_count.is_set or
                                                                                self.block_length.is_set or
                                                                                self.block_signature.is_set or
                                                                                self.block_version.is_set or
                                                                                self.chassis_sid.is_set or
                                                                                self.clei.is_set or
                                                                                self.controller_family.is_set or
                                                                                self.controller_type.is_set or
                                                                                self.description.is_set or
                                                                                self.dev_num1.is_set or
                                                                                self.dev_num2.is_set or
                                                                                self.dev_num3.is_set or
                                                                                self.dev_num4.is_set or
                                                                                self.dev_num5.is_set or
                                                                                self.dev_num6.is_set or
                                                                                self.dev_num7.is_set or
                                                                                self.eci.is_set or
                                                                                self.eeprom_size.is_set or
                                                                                self.engineer_use.is_set or
                                                                                self.fru_major_type.is_set or
                                                                                self.fru_minor_type.is_set or
                                                                                self.hw_version.is_set or
                                                                                self.hwid.is_set or
                                                                                self.idprom_format_rev.is_set or
                                                                                self.mac_add_blk_size1.is_set or
                                                                                self.mac_add_blk_size2.is_set or
                                                                                self.mac_add_blk_size3.is_set or
                                                                                self.mac_add_blk_size4.is_set or
                                                                                self.manu_test_data.is_set or
                                                                                self.mfg_bits.is_set or
                                                                                self.mfg_deviation.is_set or
                                                                                self.oem_string.is_set or
                                                                                self.part_number.is_set or
                                                                                self.part_revision.is_set or
                                                                                self.pca_num.is_set or
                                                                                self.pcavid.is_set or
                                                                                self.pcb_serial_num.is_set or
                                                                                self.pid.is_set or
                                                                                self.power_consumption.is_set or
                                                                                self.power_supply_type.is_set or
                                                                                self.product_id.is_set or
                                                                                self.rma_code.is_set or
                                                                                self.serial_number.is_set or
                                                                                self.snmpoid.is_set or
                                                                                self.top_assem_part_num.is_set or
                                                                                self.top_assem_vid.is_set or
                                                                                self.udi_description.is_set or
                                                                                self.udi_name.is_set or
                                                                                self.vid.is_set or
                                                                                (self.rma is not None and self.rma.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                self.description.yfilter != YFilter.not_set or
                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "eeprom" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "rma"):
                                                                                if (self.rma is None):
                                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                return self.rma

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "asset-alias"):
                                                                                self.asset_alias = value
                                                                                self.asset_alias.value_namespace = name_space
                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "asset-id"):
                                                                                self.asset_id = value
                                                                                self.asset_id.value_namespace = name_space
                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address1"):
                                                                                self.base_mac_address1 = value
                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address2"):
                                                                                self.base_mac_address2 = value
                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address3"):
                                                                                self.base_mac_address3 = value
                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address4"):
                                                                                self.base_mac_address4 = value
                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-checksum"):
                                                                                self.block_checksum = value
                                                                                self.block_checksum.value_namespace = name_space
                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-count"):
                                                                                self.block_count = value
                                                                                self.block_count.value_namespace = name_space
                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-length"):
                                                                                self.block_length = value
                                                                                self.block_length.value_namespace = name_space
                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-signature"):
                                                                                self.block_signature = value
                                                                                self.block_signature.value_namespace = name_space
                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-version"):
                                                                                self.block_version = value
                                                                                self.block_version.value_namespace = name_space
                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "chassis-sid"):
                                                                                self.chassis_sid = value
                                                                                self.chassis_sid.value_namespace = name_space
                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "clei"):
                                                                                self.clei = value
                                                                                self.clei.value_namespace = name_space
                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-family"):
                                                                                self.controller_family = value
                                                                                self.controller_family.value_namespace = name_space
                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-type"):
                                                                                self.controller_type = value
                                                                                self.controller_type.value_namespace = name_space
                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "description"):
                                                                                self.description = value
                                                                                self.description.value_namespace = name_space
                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num1"):
                                                                                self.dev_num1 = value
                                                                                self.dev_num1.value_namespace = name_space
                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num2"):
                                                                                self.dev_num2 = value
                                                                                self.dev_num2.value_namespace = name_space
                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num3"):
                                                                                self.dev_num3 = value
                                                                                self.dev_num3.value_namespace = name_space
                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num4"):
                                                                                self.dev_num4 = value
                                                                                self.dev_num4.value_namespace = name_space
                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num5"):
                                                                                self.dev_num5 = value
                                                                                self.dev_num5.value_namespace = name_space
                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num6"):
                                                                                self.dev_num6 = value
                                                                                self.dev_num6.value_namespace = name_space
                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num7"):
                                                                                self.dev_num7 = value
                                                                                self.dev_num7.value_namespace = name_space
                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eci"):
                                                                                self.eci = value
                                                                                self.eci.value_namespace = name_space
                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eeprom-size"):
                                                                                self.eeprom_size = value
                                                                                self.eeprom_size.value_namespace = name_space
                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "engineer-use"):
                                                                                self.engineer_use = value
                                                                                self.engineer_use.value_namespace = name_space
                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-major-type"):
                                                                                self.fru_major_type = value
                                                                                self.fru_major_type.value_namespace = name_space
                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-minor-type"):
                                                                                self.fru_minor_type = value
                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hw-version"):
                                                                                self.hw_version = value
                                                                                self.hw_version.value_namespace = name_space
                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hwid"):
                                                                                self.hwid = value
                                                                                self.hwid.value_namespace = name_space
                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "idprom-format-rev"):
                                                                                self.idprom_format_rev = value
                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                self.mac_add_blk_size1 = value
                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                self.mac_add_blk_size2 = value
                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                self.mac_add_blk_size3 = value
                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                self.mac_add_blk_size4 = value
                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "manu-test-data"):
                                                                                self.manu_test_data = value
                                                                                self.manu_test_data.value_namespace = name_space
                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-bits"):
                                                                                self.mfg_bits = value
                                                                                self.mfg_bits.value_namespace = name_space
                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-deviation"):
                                                                                self.mfg_deviation = value
                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "oem-string"):
                                                                                self.oem_string = value
                                                                                self.oem_string.value_namespace = name_space
                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-number"):
                                                                                self.part_number = value
                                                                                self.part_number.value_namespace = name_space
                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-revision"):
                                                                                self.part_revision = value
                                                                                self.part_revision.value_namespace = name_space
                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pca-num"):
                                                                                self.pca_num = value
                                                                                self.pca_num.value_namespace = name_space
                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcavid"):
                                                                                self.pcavid = value
                                                                                self.pcavid.value_namespace = name_space
                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcb-serial-num"):
                                                                                self.pcb_serial_num = value
                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pid"):
                                                                                self.pid = value
                                                                                self.pid.value_namespace = name_space
                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-consumption"):
                                                                                self.power_consumption = value
                                                                                self.power_consumption.value_namespace = name_space
                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-supply-type"):
                                                                                self.power_supply_type = value
                                                                                self.power_supply_type.value_namespace = name_space
                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "product-id"):
                                                                                self.product_id = value
                                                                                self.product_id.value_namespace = name_space
                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "rma-code"):
                                                                                self.rma_code = value
                                                                                self.rma_code.value_namespace = name_space
                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "serial-number"):
                                                                                self.serial_number = value
                                                                                self.serial_number.value_namespace = name_space
                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "snmpoid"):
                                                                                self.snmpoid = value
                                                                                self.snmpoid.value_namespace = name_space
                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-part-num"):
                                                                                self.top_assem_part_num = value
                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-vid"):
                                                                                self.top_assem_vid = value
                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-description"):
                                                                                self.udi_description = value
                                                                                self.udi_description.value_namespace = name_space
                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-name"):
                                                                                self.udi_name = value
                                                                                self.udi_name.value_namespace = name_space
                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vid"):
                                                                                self.vid = value
                                                                                self.vid.value_namespace = name_space
                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.description.is_set or
                                                                            self.has_eeprom.is_set or
                                                                            self.inv_card_type.is_set or
                                                                            self.opaque_data.is_set or
                                                                            self.opaque_data_size.is_set or
                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "eeprom"):
                                                                            if (self.eeprom is None):
                                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                            return self.eeprom

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "has-eeprom"):
                                                                            self.has_eeprom = value
                                                                            self.has_eeprom.value_namespace = name_space
                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "inv-card-type"):
                                                                            self.inv_card_type = value
                                                                            self.inv_card_type.value_namespace = name_space
                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data"):
                                                                            self.opaque_data = value
                                                                            self.opaque_data.value_namespace = name_space
                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data-size"):
                                                                            self.opaque_data_size = value
                                                                            self.opaque_data_size.value_namespace = name_space
                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.module_done.is_set or
                                                                        self.node_id.is_set or
                                                                        self.vm_done.is_set or
                                                                        self.vm_node_id.is_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "attributes" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "env-sensor-info"):
                                                                        if (self.env_sensor_info is None):
                                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                        return self.env_sensor_info

                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                        if (self.env_sensor_info_xml is None):
                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                        return self.env_sensor_info_xml

                                                                    if (child_yang_name == "fru-info"):
                                                                        if (self.fru_info is None):
                                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                        return self.fru_info

                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                        if (self.inv_asset_bag is None):
                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                        return self.inv_asset_bag

                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                        if (self.inv_basic_bag is None):
                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                        return self.inv_basic_bag

                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                        if (self.inv_eeprom_info is None):
                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                        return self.inv_eeprom_info

                                                                    if (child_yang_name == "pwg-info"):
                                                                        if (self.pwg_info is None):
                                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                        return self.pwg_info

                                                                    if (child_yang_name == "threshold"):
                                                                        if (self.threshold is None):
                                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                        return self.threshold

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "module-done"):
                                                                        self.module_done = value
                                                                        self.module_done.value_namespace = name_space
                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "node-id"):
                                                                        self.node_id = value
                                                                        self.node_id.value_namespace = name_space
                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-done"):
                                                                        self.vm_done = value
                                                                        self.vm_done.value_namespace = name_space
                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-node-id"):
                                                                        self.vm_node_id = value
                                                                        self.vm_node_id.value_namespace = name_space
                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.name.is_set or
                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "tsi5" + "[name='" + self.name.get() + "']" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "attributes"):
                                                                    if (self.attributes is None):
                                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                    return self.attributes

                                                                if (child_yang_name == "tsi6s"):
                                                                    if (self.tsi6s is None):
                                                                        self.tsi6s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                        self.tsi6s.parent = self
                                                                        self._children_name_map["tsi6s"] = "tsi6s"
                                                                    return self.tsi6s

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "attributes" or name == "tsi6s" or name == "name"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.tsi5:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.tsi5:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "tsi5s" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "tsi5"):
                                                                for c in self.tsi5:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.tsi5.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "tsi5"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class Attributes(Entity):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo>`
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        .. attribute:: module_done
                                                        
                                                        	Inventory EDM Module Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**default value**\: 1
                                                        
                                                        .. attribute:: node_id
                                                        
                                                        	Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold>`
                                                        
                                                        .. attribute:: vm_done
                                                        
                                                        	VM Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        .. attribute:: vm_node_id
                                                        
                                                        	VM Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"

                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                            self._children_yang_names.add("env-sensor-info")

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                            self._children_yang_names.add("fru-info")

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                            self._children_yang_names.add("inv-asset-bag")

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                            self._children_yang_names.add("inv-basic-bag")

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._children_yang_names.add("inv-eeprom-info")

                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                            self._children_yang_names.add("pwg-info")

                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                            self._children_yang_names.add("threshold")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("module_done",
                                                                            "node_id",
                                                                            "vm_done",
                                                                            "vm_node_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)


                                                        class EnvSensorInfo(Entity):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                self.status = YLeaf(YType.uint32, "status")

                                                                self.units = YLeaf(YType.str, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("age_time_stamp",
                                                                                "alarm_type",
                                                                                "data_type",
                                                                                "device_description",
                                                                                "device_id",
                                                                                "field_validity_bitmap",
                                                                                "precision",
                                                                                "scale",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.age_time_stamp.is_set or
                                                                    self.alarm_type.is_set or
                                                                    self.data_type.is_set or
                                                                    self.device_description.is_set or
                                                                    self.device_id.is_set or
                                                                    self.field_validity_bitmap.is_set or
                                                                    self.precision.is_set or
                                                                    self.scale.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                    self.precision.yfilter != YFilter.not_set or
                                                                    self.scale.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "age-time-stamp"):
                                                                    self.age_time_stamp = value
                                                                    self.age_time_stamp.value_namespace = name_space
                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "alarm-type"):
                                                                    self.alarm_type = value
                                                                    self.alarm_type.value_namespace = name_space
                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-description"):
                                                                    self.device_description = value
                                                                    self.device_description.value_namespace = name_space
                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-id"):
                                                                    self.device_id = value
                                                                    self.device_id.value_namespace = name_space
                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "field-validity-bitmap"):
                                                                    self.field_validity_bitmap = value
                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "precision"):
                                                                    self.precision = value
                                                                    self.precision.value_namespace = name_space
                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "scale"):
                                                                    self.scale = value
                                                                    self.scale.value_namespace = name_space
                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class PwgInfo(Entity):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("power_group_available_current",
                                                                                "power_group_drawn_current",
                                                                                "power_group_power_units",
                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.power_group_available_current.is_set or
                                                                    self.power_group_drawn_current.is_set or
                                                                    self.power_group_power_units.is_set or
                                                                    self.power_group_redundancy_mode.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "pwg-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "power-group-available-current"):
                                                                    self.power_group_available_current = value
                                                                    self.power_group_available_current.value_namespace = name_space
                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-drawn-current"):
                                                                    self.power_group_drawn_current = value
                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-power-units"):
                                                                    self.power_group_power_units = value
                                                                    self.power_group_power_units.value_namespace = name_space
                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-redundancy-mode"):
                                                                    self.power_group_redundancy_mode = value
                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                        class EnvSensorInfoXml(Entity):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"

                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.str, "value")

                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._children_yang_names.add("threshold")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("data_type",
                                                                                "description",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                            class Threshold(Entity):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                    self.threshold_array = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                class ThresholdArray(Entity):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"

                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_name",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_name.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-name"):
                                                                            self.threshold_name = value
                                                                            self.threshold_name.value_namespace = name_space
                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "threshold" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "threshold-array"):
                                                                        for c in self.threshold_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.threshold_array.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "threshold-array"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    self.data_type.is_set or
                                                                    self.description.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set or
                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "threshold"):
                                                                    if (self.threshold is None):
                                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                    return self.threshold

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class InvAssetBag(Entity):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("manufacturer_assembly_number",
                                                                                "manufacturer_assembly_revision",
                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                "manufacturer_firmware_identifier",
                                                                                "manufacturer_software_identifier",
                                                                                "original_equipment_manufacturer_string",
                                                                                "part_number") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.manufacturer_assembly_number.is_set or
                                                                    self.manufacturer_assembly_revision.is_set or
                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                    self.manufacturer_software_identifier.is_set or
                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                    self.part_number.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                    self.part_number.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "manufacturer-assembly-number"):
                                                                    self.manufacturer_assembly_number = value
                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                    self.manufacturer_assembly_revision = value
                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                    self.manufacturer_firmware_identifier = value
                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-software-identifier"):
                                                                    self.manufacturer_software_identifier = value
                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                    self.original_equipment_manufacturer_string = value
                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "part-number"):
                                                                    self.part_number = value
                                                                    self.part_number.value_namespace = name_space
                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                        class Threshold(Entity):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"

                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                self._children_yang_names.add("critical-hi")

                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                self._children_yang_names.add("critical-lo")

                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                self._children_yang_names.add("major-hi")

                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                self._children_yang_names.add("major-lo")

                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                self._children_yang_names.add("minor-hi")

                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._children_yang_names.add("minor-lo")


                                                            class MajorLo(Entity):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalHi(Entity):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorHi(Entity):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MajorHi(Entity):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalLo(Entity):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorLo(Entity):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "critical-hi"):
                                                                    if (self.critical_hi is None):
                                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                    return self.critical_hi

                                                                if (child_yang_name == "critical-lo"):
                                                                    if (self.critical_lo is None):
                                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                    return self.critical_lo

                                                                if (child_yang_name == "major-hi"):
                                                                    if (self.major_hi is None):
                                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                    return self.major_hi

                                                                if (child_yang_name == "major-lo"):
                                                                    if (self.major_lo is None):
                                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                    return self.major_lo

                                                                if (child_yang_name == "minor-hi"):
                                                                    if (self.minor_hi is None):
                                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                    return self.minor_hi

                                                                if (child_yang_name == "minor-lo"):
                                                                    if (self.minor_lo is None):
                                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                    return self.minor_lo

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                pass


                                                        class FruInfo(Entity):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._children_yang_names.add("card-up-time")

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                self._children_yang_names.add("last-operational-state-change")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("card_administrative_state",
                                                                                "card_monitor_state",
                                                                                "card_operational_state",
                                                                                "card_reset_reason",
                                                                                "power_administrative_state",
                                                                                "power_current_measurement",
                                                                                "power_operational_state") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)


                                                            class LastOperationalStateChange(Entity):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                            class CardUpTime(Entity):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "card-up-time" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.card_administrative_state.is_set or
                                                                    self.card_monitor_state.is_set or
                                                                    self.card_operational_state.is_set or
                                                                    self.card_reset_reason.is_set or
                                                                    self.power_administrative_state.is_set or
                                                                    self.power_current_measurement.is_set or
                                                                    self.power_operational_state.is_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fru-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "card-up-time"):
                                                                    if (self.card_up_time is None):
                                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                    return self.card_up_time

                                                                if (child_yang_name == "last-operational-state-change"):
                                                                    if (self.last_operational_state_change is None):
                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                    return self.last_operational_state_change

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "card-administrative-state"):
                                                                    self.card_administrative_state = value
                                                                    self.card_administrative_state.value_namespace = name_space
                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-monitor-state"):
                                                                    self.card_monitor_state = value
                                                                    self.card_monitor_state.value_namespace = name_space
                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-operational-state"):
                                                                    self.card_operational_state = value
                                                                    self.card_operational_state.value_namespace = name_space
                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-reset-reason"):
                                                                    self.card_reset_reason = value
                                                                    self.card_reset_reason.value_namespace = name_space
                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-administrative-state"):
                                                                    self.power_administrative_state = value
                                                                    self.power_administrative_state.value_namespace = name_space
                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-current-measurement"):
                                                                    self.power_current_measurement = value
                                                                    self.power_current_measurement.value_namespace = name_space
                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-operational-state"):
                                                                    self.power_operational_state = value
                                                                    self.power_operational_state.value_namespace = name_space
                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                        class InvBasicBag(Entity):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.alias = YLeaf(YType.str, "alias")

                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("alias",
                                                                                "asset_id_str",
                                                                                "asset_identification",
                                                                                "ceport",
                                                                                "chip_hardware_revision",
                                                                                "composite_class_code",
                                                                                "description",
                                                                                "environmental_monitor_path",
                                                                                "firmware_revision",
                                                                                "group_flag",
                                                                                "hardware_revision",
                                                                                "is_field_replaceable_unit",
                                                                                "manufacturer_asset_tags",
                                                                                "manufacturer_name",
                                                                                "memory_size",
                                                                                "model_name",
                                                                                "name",
                                                                                "new_deviation_number",
                                                                                "physical_layer_interface_module_type",
                                                                                "redundancystate",
                                                                                "serial_number",
                                                                                "software_revision",
                                                                                "unique_id",
                                                                                "unrecognized_fru",
                                                                                "vendor_type",
                                                                                "xr_scoped") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.alias.is_set or
                                                                    self.asset_id_str.is_set or
                                                                    self.asset_identification.is_set or
                                                                    self.ceport.is_set or
                                                                    self.chip_hardware_revision.is_set or
                                                                    self.composite_class_code.is_set or
                                                                    self.description.is_set or
                                                                    self.environmental_monitor_path.is_set or
                                                                    self.firmware_revision.is_set or
                                                                    self.group_flag.is_set or
                                                                    self.hardware_revision.is_set or
                                                                    self.is_field_replaceable_unit.is_set or
                                                                    self.manufacturer_asset_tags.is_set or
                                                                    self.manufacturer_name.is_set or
                                                                    self.memory_size.is_set or
                                                                    self.model_name.is_set or
                                                                    self.name.is_set or
                                                                    self.new_deviation_number.is_set or
                                                                    self.physical_layer_interface_module_type.is_set or
                                                                    self.redundancystate.is_set or
                                                                    self.serial_number.is_set or
                                                                    self.software_revision.is_set or
                                                                    self.unique_id.is_set or
                                                                    self.unrecognized_fru.is_set or
                                                                    self.vendor_type.is_set or
                                                                    self.xr_scoped.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.alias.yfilter != YFilter.not_set or
                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "alias"):
                                                                    self.alias = value
                                                                    self.alias.value_namespace = name_space
                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-id-str"):
                                                                    self.asset_id_str = value
                                                                    self.asset_id_str.value_namespace = name_space
                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-identification"):
                                                                    self.asset_identification = value
                                                                    self.asset_identification.value_namespace = name_space
                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ceport"):
                                                                    self.ceport = value
                                                                    self.ceport.value_namespace = name_space
                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "chip-hardware-revision"):
                                                                    self.chip_hardware_revision = value
                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "composite-class-code"):
                                                                    self.composite_class_code = value
                                                                    self.composite_class_code.value_namespace = name_space
                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "environmental-monitor-path"):
                                                                    self.environmental_monitor_path = value
                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "firmware-revision"):
                                                                    self.firmware_revision = value
                                                                    self.firmware_revision.value_namespace = name_space
                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "group-flag"):
                                                                    self.group_flag = value
                                                                    self.group_flag.value_namespace = name_space
                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "hardware-revision"):
                                                                    self.hardware_revision = value
                                                                    self.hardware_revision.value_namespace = name_space
                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "is-field-replaceable-unit"):
                                                                    self.is_field_replaceable_unit = value
                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-asset-tags"):
                                                                    self.manufacturer_asset_tags = value
                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-name"):
                                                                    self.manufacturer_name = value
                                                                    self.manufacturer_name.value_namespace = name_space
                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "memory-size"):
                                                                    self.memory_size = value
                                                                    self.memory_size.value_namespace = name_space
                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "model-name"):
                                                                    self.model_name = value
                                                                    self.model_name.value_namespace = name_space
                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "new-deviation-number"):
                                                                    self.new_deviation_number = value
                                                                    self.new_deviation_number.value_namespace = name_space
                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                    self.physical_layer_interface_module_type = value
                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "redundancystate"):
                                                                    self.redundancystate = value
                                                                    self.redundancystate.value_namespace = name_space
                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "serial-number"):
                                                                    self.serial_number = value
                                                                    self.serial_number.value_namespace = name_space
                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "software-revision"):
                                                                    self.software_revision = value
                                                                    self.software_revision.value_namespace = name_space
                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unique-id"):
                                                                    self.unique_id = value
                                                                    self.unique_id.value_namespace = name_space
                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unrecognized-fru"):
                                                                    self.unrecognized_fru = value
                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "vendor-type"):
                                                                    self.vendor_type = value
                                                                    self.vendor_type.value_namespace = name_space
                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "xr-scoped"):
                                                                    self.xr_scoped = value
                                                                    self.xr_scoped.value_namespace = name_space
                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                        class InvEepromInfo(Entity):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._children_yang_names.add("eeprom")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("description",
                                                                                "has_eeprom",
                                                                                "inv_card_type",
                                                                                "opaque_data",
                                                                                "opaque_data_size") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                            class Eeprom(Entity):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._children_yang_names.add("rma")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("asset_alias",
                                                                                    "asset_id",
                                                                                    "base_mac_address1",
                                                                                    "base_mac_address2",
                                                                                    "base_mac_address3",
                                                                                    "base_mac_address4",
                                                                                    "block_checksum",
                                                                                    "block_count",
                                                                                    "block_length",
                                                                                    "block_signature",
                                                                                    "block_version",
                                                                                    "chassis_sid",
                                                                                    "clei",
                                                                                    "controller_family",
                                                                                    "controller_type",
                                                                                    "description",
                                                                                    "dev_num1",
                                                                                    "dev_num2",
                                                                                    "dev_num3",
                                                                                    "dev_num4",
                                                                                    "dev_num5",
                                                                                    "dev_num6",
                                                                                    "dev_num7",
                                                                                    "eci",
                                                                                    "eeprom_size",
                                                                                    "engineer_use",
                                                                                    "fru_major_type",
                                                                                    "fru_minor_type",
                                                                                    "hw_version",
                                                                                    "hwid",
                                                                                    "idprom_format_rev",
                                                                                    "mac_add_blk_size1",
                                                                                    "mac_add_blk_size2",
                                                                                    "mac_add_blk_size3",
                                                                                    "mac_add_blk_size4",
                                                                                    "manu_test_data",
                                                                                    "mfg_bits",
                                                                                    "mfg_deviation",
                                                                                    "oem_string",
                                                                                    "part_number",
                                                                                    "part_revision",
                                                                                    "pca_num",
                                                                                    "pcavid",
                                                                                    "pcb_serial_num",
                                                                                    "pid",
                                                                                    "power_consumption",
                                                                                    "power_supply_type",
                                                                                    "product_id",
                                                                                    "rma_code",
                                                                                    "serial_number",
                                                                                    "snmpoid",
                                                                                    "top_assem_part_num",
                                                                                    "top_assem_vid",
                                                                                    "udi_description",
                                                                                    "udi_name",
                                                                                    "vid") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                class Rma(Entity):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"

                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("rma_history",
                                                                                        "rma_number",
                                                                                        "test_history") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.rma_history.is_set or
                                                                            self.rma_number.is_set or
                                                                            self.test_history.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "rma" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "rma-history"):
                                                                            self.rma_history = value
                                                                            self.rma_history.value_namespace = name_space
                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "rma-number"):
                                                                            self.rma_number = value
                                                                            self.rma_number.value_namespace = name_space
                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "test-history"):
                                                                            self.test_history = value
                                                                            self.test_history.value_namespace = name_space
                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.asset_alias.is_set or
                                                                        self.asset_id.is_set or
                                                                        self.base_mac_address1.is_set or
                                                                        self.base_mac_address2.is_set or
                                                                        self.base_mac_address3.is_set or
                                                                        self.base_mac_address4.is_set or
                                                                        self.block_checksum.is_set or
                                                                        self.block_count.is_set or
                                                                        self.block_length.is_set or
                                                                        self.block_signature.is_set or
                                                                        self.block_version.is_set or
                                                                        self.chassis_sid.is_set or
                                                                        self.clei.is_set or
                                                                        self.controller_family.is_set or
                                                                        self.controller_type.is_set or
                                                                        self.description.is_set or
                                                                        self.dev_num1.is_set or
                                                                        self.dev_num2.is_set or
                                                                        self.dev_num3.is_set or
                                                                        self.dev_num4.is_set or
                                                                        self.dev_num5.is_set or
                                                                        self.dev_num6.is_set or
                                                                        self.dev_num7.is_set or
                                                                        self.eci.is_set or
                                                                        self.eeprom_size.is_set or
                                                                        self.engineer_use.is_set or
                                                                        self.fru_major_type.is_set or
                                                                        self.fru_minor_type.is_set or
                                                                        self.hw_version.is_set or
                                                                        self.hwid.is_set or
                                                                        self.idprom_format_rev.is_set or
                                                                        self.mac_add_blk_size1.is_set or
                                                                        self.mac_add_blk_size2.is_set or
                                                                        self.mac_add_blk_size3.is_set or
                                                                        self.mac_add_blk_size4.is_set or
                                                                        self.manu_test_data.is_set or
                                                                        self.mfg_bits.is_set or
                                                                        self.mfg_deviation.is_set or
                                                                        self.oem_string.is_set or
                                                                        self.part_number.is_set or
                                                                        self.part_revision.is_set or
                                                                        self.pca_num.is_set or
                                                                        self.pcavid.is_set or
                                                                        self.pcb_serial_num.is_set or
                                                                        self.pid.is_set or
                                                                        self.power_consumption.is_set or
                                                                        self.power_supply_type.is_set or
                                                                        self.product_id.is_set or
                                                                        self.rma_code.is_set or
                                                                        self.serial_number.is_set or
                                                                        self.snmpoid.is_set or
                                                                        self.top_assem_part_num.is_set or
                                                                        self.top_assem_vid.is_set or
                                                                        self.udi_description.is_set or
                                                                        self.udi_name.is_set or
                                                                        self.vid.is_set or
                                                                        (self.rma is not None and self.rma.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                        self.clei.yfilter != YFilter.not_set or
                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                        self.description.yfilter != YFilter.not_set or
                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                        self.eci.yfilter != YFilter.not_set or
                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                        self.pid.yfilter != YFilter.not_set or
                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                        self.vid.yfilter != YFilter.not_set or
                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "eeprom" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "rma"):
                                                                        if (self.rma is None):
                                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                        return self.rma

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "asset-alias"):
                                                                        self.asset_alias = value
                                                                        self.asset_alias.value_namespace = name_space
                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "asset-id"):
                                                                        self.asset_id = value
                                                                        self.asset_id.value_namespace = name_space
                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address1"):
                                                                        self.base_mac_address1 = value
                                                                        self.base_mac_address1.value_namespace = name_space
                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address2"):
                                                                        self.base_mac_address2 = value
                                                                        self.base_mac_address2.value_namespace = name_space
                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address3"):
                                                                        self.base_mac_address3 = value
                                                                        self.base_mac_address3.value_namespace = name_space
                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address4"):
                                                                        self.base_mac_address4 = value
                                                                        self.base_mac_address4.value_namespace = name_space
                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-checksum"):
                                                                        self.block_checksum = value
                                                                        self.block_checksum.value_namespace = name_space
                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-count"):
                                                                        self.block_count = value
                                                                        self.block_count.value_namespace = name_space
                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-length"):
                                                                        self.block_length = value
                                                                        self.block_length.value_namespace = name_space
                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-signature"):
                                                                        self.block_signature = value
                                                                        self.block_signature.value_namespace = name_space
                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-version"):
                                                                        self.block_version = value
                                                                        self.block_version.value_namespace = name_space
                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "chassis-sid"):
                                                                        self.chassis_sid = value
                                                                        self.chassis_sid.value_namespace = name_space
                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "clei"):
                                                                        self.clei = value
                                                                        self.clei.value_namespace = name_space
                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-family"):
                                                                        self.controller_family = value
                                                                        self.controller_family.value_namespace = name_space
                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-type"):
                                                                        self.controller_type = value
                                                                        self.controller_type.value_namespace = name_space
                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "description"):
                                                                        self.description = value
                                                                        self.description.value_namespace = name_space
                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num1"):
                                                                        self.dev_num1 = value
                                                                        self.dev_num1.value_namespace = name_space
                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num2"):
                                                                        self.dev_num2 = value
                                                                        self.dev_num2.value_namespace = name_space
                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num3"):
                                                                        self.dev_num3 = value
                                                                        self.dev_num3.value_namespace = name_space
                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num4"):
                                                                        self.dev_num4 = value
                                                                        self.dev_num4.value_namespace = name_space
                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num5"):
                                                                        self.dev_num5 = value
                                                                        self.dev_num5.value_namespace = name_space
                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num6"):
                                                                        self.dev_num6 = value
                                                                        self.dev_num6.value_namespace = name_space
                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num7"):
                                                                        self.dev_num7 = value
                                                                        self.dev_num7.value_namespace = name_space
                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eci"):
                                                                        self.eci = value
                                                                        self.eci.value_namespace = name_space
                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eeprom-size"):
                                                                        self.eeprom_size = value
                                                                        self.eeprom_size.value_namespace = name_space
                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "engineer-use"):
                                                                        self.engineer_use = value
                                                                        self.engineer_use.value_namespace = name_space
                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-major-type"):
                                                                        self.fru_major_type = value
                                                                        self.fru_major_type.value_namespace = name_space
                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-minor-type"):
                                                                        self.fru_minor_type = value
                                                                        self.fru_minor_type.value_namespace = name_space
                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hw-version"):
                                                                        self.hw_version = value
                                                                        self.hw_version.value_namespace = name_space
                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hwid"):
                                                                        self.hwid = value
                                                                        self.hwid.value_namespace = name_space
                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "idprom-format-rev"):
                                                                        self.idprom_format_rev = value
                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size1"):
                                                                        self.mac_add_blk_size1 = value
                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size2"):
                                                                        self.mac_add_blk_size2 = value
                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size3"):
                                                                        self.mac_add_blk_size3 = value
                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size4"):
                                                                        self.mac_add_blk_size4 = value
                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "manu-test-data"):
                                                                        self.manu_test_data = value
                                                                        self.manu_test_data.value_namespace = name_space
                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-bits"):
                                                                        self.mfg_bits = value
                                                                        self.mfg_bits.value_namespace = name_space
                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-deviation"):
                                                                        self.mfg_deviation = value
                                                                        self.mfg_deviation.value_namespace = name_space
                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "oem-string"):
                                                                        self.oem_string = value
                                                                        self.oem_string.value_namespace = name_space
                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-number"):
                                                                        self.part_number = value
                                                                        self.part_number.value_namespace = name_space
                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-revision"):
                                                                        self.part_revision = value
                                                                        self.part_revision.value_namespace = name_space
                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pca-num"):
                                                                        self.pca_num = value
                                                                        self.pca_num.value_namespace = name_space
                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcavid"):
                                                                        self.pcavid = value
                                                                        self.pcavid.value_namespace = name_space
                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcb-serial-num"):
                                                                        self.pcb_serial_num = value
                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pid"):
                                                                        self.pid = value
                                                                        self.pid.value_namespace = name_space
                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-consumption"):
                                                                        self.power_consumption = value
                                                                        self.power_consumption.value_namespace = name_space
                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-supply-type"):
                                                                        self.power_supply_type = value
                                                                        self.power_supply_type.value_namespace = name_space
                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "product-id"):
                                                                        self.product_id = value
                                                                        self.product_id.value_namespace = name_space
                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "rma-code"):
                                                                        self.rma_code = value
                                                                        self.rma_code.value_namespace = name_space
                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "serial-number"):
                                                                        self.serial_number = value
                                                                        self.serial_number.value_namespace = name_space
                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "snmpoid"):
                                                                        self.snmpoid = value
                                                                        self.snmpoid.value_namespace = name_space
                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-part-num"):
                                                                        self.top_assem_part_num = value
                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-vid"):
                                                                        self.top_assem_vid = value
                                                                        self.top_assem_vid.value_namespace = name_space
                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-description"):
                                                                        self.udi_description = value
                                                                        self.udi_description.value_namespace = name_space
                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-name"):
                                                                        self.udi_name = value
                                                                        self.udi_name.value_namespace = name_space
                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vid"):
                                                                        self.vid = value
                                                                        self.vid.value_namespace = name_space
                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.description.is_set or
                                                                    self.has_eeprom.is_set or
                                                                    self.inv_card_type.is_set or
                                                                    self.opaque_data.is_set or
                                                                    self.opaque_data_size.is_set or
                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "eeprom"):
                                                                    if (self.eeprom is None):
                                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                    return self.eeprom

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "has-eeprom"):
                                                                    self.has_eeprom = value
                                                                    self.has_eeprom.value_namespace = name_space
                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "inv-card-type"):
                                                                    self.inv_card_type = value
                                                                    self.inv_card_type.value_namespace = name_space
                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data"):
                                                                    self.opaque_data = value
                                                                    self.opaque_data.value_namespace = name_space
                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data-size"):
                                                                    self.opaque_data_size = value
                                                                    self.opaque_data_size.value_namespace = name_space
                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.module_done.is_set or
                                                                self.node_id.is_set or
                                                                self.vm_done.is_set or
                                                                self.vm_node_id.is_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                (self.threshold is not None and self.threshold.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.module_done.yfilter != YFilter.not_set or
                                                                self.node_id.yfilter != YFilter.not_set or
                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "attributes" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "env-sensor-info"):
                                                                if (self.env_sensor_info is None):
                                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                return self.env_sensor_info

                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                if (self.env_sensor_info_xml is None):
                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                return self.env_sensor_info_xml

                                                            if (child_yang_name == "fru-info"):
                                                                if (self.fru_info is None):
                                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                return self.fru_info

                                                            if (child_yang_name == "inv-asset-bag"):
                                                                if (self.inv_asset_bag is None):
                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                return self.inv_asset_bag

                                                            if (child_yang_name == "inv-basic-bag"):
                                                                if (self.inv_basic_bag is None):
                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                return self.inv_basic_bag

                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                if (self.inv_eeprom_info is None):
                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                return self.inv_eeprom_info

                                                            if (child_yang_name == "pwg-info"):
                                                                if (self.pwg_info is None):
                                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                return self.pwg_info

                                                            if (child_yang_name == "threshold"):
                                                                if (self.threshold is None):
                                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                return self.threshold

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "module-done"):
                                                                self.module_done = value
                                                                self.module_done.value_namespace = name_space
                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "node-id"):
                                                                self.node_id = value
                                                                self.node_id.value_namespace = name_space
                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-done"):
                                                                self.vm_done = value
                                                                self.vm_done.value_namespace = name_space
                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-node-id"):
                                                                self.vm_node_id = value
                                                                self.vm_node_id.value_namespace = name_space
                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.name.is_set or
                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "tsi4" + "[name='" + self.name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "attributes"):
                                                            if (self.attributes is None):
                                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                            return self.attributes

                                                        if (child_yang_name == "tsi5s"):
                                                            if (self.tsi5s is None):
                                                                self.tsi5s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                                self.tsi5s.parent = self
                                                                self._children_name_map["tsi5s"] = "tsi5s"
                                                            return self.tsi5s

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attributes" or name == "tsi5s" or name == "name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.tsi4:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.tsi4:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "tsi4s" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "tsi4"):
                                                        for c in self.tsi4:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.tsi4.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "tsi4"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Attributes(Entity):
                                                """
                                                Attributes
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo>`
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag>`
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag>`
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                .. attribute:: module_done
                                                
                                                	Inventory EDM Module Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**default value**\: 1
                                                
                                                .. attribute:: node_id
                                                
                                                	Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo>`
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold>`
                                                
                                                .. attribute:: vm_done
                                                
                                                	VM Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                .. attribute:: vm_node_id
                                                
                                                	VM Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"

                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                    self._children_yang_names.add("env-sensor-info")

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                    self._children_yang_names.add("fru-info")

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                    self._children_yang_names.add("inv-asset-bag")

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                    self._children_yang_names.add("inv-basic-bag")

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._children_yang_names.add("inv-eeprom-info")

                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                    self._children_yang_names.add("pwg-info")

                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                    self._children_yang_names.add("threshold")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("module_done",
                                                                    "node_id",
                                                                    "vm_done",
                                                                    "vm_node_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)


                                                class EnvSensorInfo(Entity):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                        self.status = YLeaf(YType.uint32, "status")

                                                        self.units = YLeaf(YType.str, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("age_time_stamp",
                                                                        "alarm_type",
                                                                        "data_type",
                                                                        "device_description",
                                                                        "device_id",
                                                                        "field_validity_bitmap",
                                                                        "precision",
                                                                        "scale",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.age_time_stamp.is_set or
                                                            self.alarm_type.is_set or
                                                            self.data_type.is_set or
                                                            self.device_description.is_set or
                                                            self.device_id.is_set or
                                                            self.field_validity_bitmap.is_set or
                                                            self.precision.is_set or
                                                            self.scale.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.device_description.yfilter != YFilter.not_set or
                                                            self.device_id.yfilter != YFilter.not_set or
                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                            self.precision.yfilter != YFilter.not_set or
                                                            self.scale.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "age-time-stamp"):
                                                            self.age_time_stamp = value
                                                            self.age_time_stamp.value_namespace = name_space
                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "alarm-type"):
                                                            self.alarm_type = value
                                                            self.alarm_type.value_namespace = name_space
                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-description"):
                                                            self.device_description = value
                                                            self.device_description.value_namespace = name_space
                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-id"):
                                                            self.device_id = value
                                                            self.device_id.value_namespace = name_space
                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "field-validity-bitmap"):
                                                            self.field_validity_bitmap = value
                                                            self.field_validity_bitmap.value_namespace = name_space
                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "precision"):
                                                            self.precision = value
                                                            self.precision.value_namespace = name_space
                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale"):
                                                            self.scale = value
                                                            self.scale.value_namespace = name_space
                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PwgInfo(Entity):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("power_group_available_current",
                                                                        "power_group_drawn_current",
                                                                        "power_group_power_units",
                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.power_group_available_current.is_set or
                                                            self.power_group_drawn_current.is_set or
                                                            self.power_group_power_units.is_set or
                                                            self.power_group_redundancy_mode.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pwg-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "power-group-available-current"):
                                                            self.power_group_available_current = value
                                                            self.power_group_available_current.value_namespace = name_space
                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-drawn-current"):
                                                            self.power_group_drawn_current = value
                                                            self.power_group_drawn_current.value_namespace = name_space
                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-power-units"):
                                                            self.power_group_power_units = value
                                                            self.power_group_power_units.value_namespace = name_space
                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-redundancy-mode"):
                                                            self.power_group_redundancy_mode = value
                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                class EnvSensorInfoXml(Entity):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"

                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.status = YLeaf(YType.enumeration, "status")

                                                        self.units = YLeaf(YType.enumeration, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.str, "value")

                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._children_yang_names.add("threshold")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("data_type",
                                                                        "description",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                    class Threshold(Entity):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                            self.threshold_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                        class ThresholdArray(Entity):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"

                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_name",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_name.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-name"):
                                                                    self.threshold_name = value
                                                                    self.threshold_name.value_namespace = name_space
                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "threshold-array"):
                                                                for c in self.threshold_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.threshold_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "threshold-array"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            self.data_type.is_set or
                                                            self.description.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set or
                                                            (self.threshold is not None and self.threshold.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "threshold"):
                                                            if (self.threshold is None):
                                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                            return self.threshold

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class InvAssetBag(Entity):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("manufacturer_assembly_number",
                                                                        "manufacturer_assembly_revision",
                                                                        "manufacturer_common_language_equipment_identifier",
                                                                        "manufacturer_firmware_identifier",
                                                                        "manufacturer_software_identifier",
                                                                        "original_equipment_manufacturer_string",
                                                                        "part_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.manufacturer_assembly_number.is_set or
                                                            self.manufacturer_assembly_revision.is_set or
                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                            self.manufacturer_firmware_identifier.is_set or
                                                            self.manufacturer_software_identifier.is_set or
                                                            self.original_equipment_manufacturer_string.is_set or
                                                            self.part_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                            self.part_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "manufacturer-assembly-number"):
                                                            self.manufacturer_assembly_number = value
                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-assembly-revision"):
                                                            self.manufacturer_assembly_revision = value
                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                            self.manufacturer_common_language_equipment_identifier = value
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                            self.manufacturer_firmware_identifier = value
                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-software-identifier"):
                                                            self.manufacturer_software_identifier = value
                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                            self.original_equipment_manufacturer_string = value
                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "part-number"):
                                                            self.part_number = value
                                                            self.part_number.value_namespace = name_space
                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                class Threshold(Entity):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"

                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                        self._children_yang_names.add("critical-hi")

                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                        self._children_yang_names.add("critical-lo")

                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                        self._children_yang_names.add("major-hi")

                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                        self._children_yang_names.add("major-lo")

                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                        self._children_yang_names.add("minor-hi")

                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._children_yang_names.add("minor-lo")


                                                    class MajorLo(Entity):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalHi(Entity):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorHi(Entity):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MajorHi(Entity):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalLo(Entity):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorLo(Entity):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "critical-hi"):
                                                            if (self.critical_hi is None):
                                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                            return self.critical_hi

                                                        if (child_yang_name == "critical-lo"):
                                                            if (self.critical_lo is None):
                                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                            return self.critical_lo

                                                        if (child_yang_name == "major-hi"):
                                                            if (self.major_hi is None):
                                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                            return self.major_hi

                                                        if (child_yang_name == "major-lo"):
                                                            if (self.major_lo is None):
                                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                            return self.major_lo

                                                        if (child_yang_name == "minor-hi"):
                                                            if (self.minor_hi is None):
                                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                            return self.minor_hi

                                                        if (child_yang_name == "minor-lo"):
                                                            if (self.minor_lo is None):
                                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                            return self.minor_lo

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class FruInfo(Entity):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._children_yang_names.add("card-up-time")

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                        self._children_yang_names.add("last-operational-state-change")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("card_administrative_state",
                                                                        "card_monitor_state",
                                                                        "card_operational_state",
                                                                        "card_reset_reason",
                                                                        "power_administrative_state",
                                                                        "power_current_measurement",
                                                                        "power_operational_state") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)


                                                    class LastOperationalStateChange(Entity):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                    class CardUpTime(Entity):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "card-up-time" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.card_administrative_state.is_set or
                                                            self.card_monitor_state.is_set or
                                                            self.card_operational_state.is_set or
                                                            self.card_reset_reason.is_set or
                                                            self.power_administrative_state.is_set or
                                                            self.power_current_measurement.is_set or
                                                            self.power_operational_state.is_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fru-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "card-up-time"):
                                                            if (self.card_up_time is None):
                                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                            return self.card_up_time

                                                        if (child_yang_name == "last-operational-state-change"):
                                                            if (self.last_operational_state_change is None):
                                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                            return self.last_operational_state_change

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "card-administrative-state"):
                                                            self.card_administrative_state = value
                                                            self.card_administrative_state.value_namespace = name_space
                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-monitor-state"):
                                                            self.card_monitor_state = value
                                                            self.card_monitor_state.value_namespace = name_space
                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-operational-state"):
                                                            self.card_operational_state = value
                                                            self.card_operational_state.value_namespace = name_space
                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-reset-reason"):
                                                            self.card_reset_reason = value
                                                            self.card_reset_reason.value_namespace = name_space
                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-administrative-state"):
                                                            self.power_administrative_state = value
                                                            self.power_administrative_state.value_namespace = name_space
                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-current-measurement"):
                                                            self.power_current_measurement = value
                                                            self.power_current_measurement.value_namespace = name_space
                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-operational-state"):
                                                            self.power_operational_state = value
                                                            self.power_operational_state.value_namespace = name_space
                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                class InvBasicBag(Entity):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.alias = YLeaf(YType.str, "alias")

                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("alias",
                                                                        "asset_id_str",
                                                                        "asset_identification",
                                                                        "ceport",
                                                                        "chip_hardware_revision",
                                                                        "composite_class_code",
                                                                        "description",
                                                                        "environmental_monitor_path",
                                                                        "firmware_revision",
                                                                        "group_flag",
                                                                        "hardware_revision",
                                                                        "is_field_replaceable_unit",
                                                                        "manufacturer_asset_tags",
                                                                        "manufacturer_name",
                                                                        "memory_size",
                                                                        "model_name",
                                                                        "name",
                                                                        "new_deviation_number",
                                                                        "physical_layer_interface_module_type",
                                                                        "redundancystate",
                                                                        "serial_number",
                                                                        "software_revision",
                                                                        "unique_id",
                                                                        "unrecognized_fru",
                                                                        "vendor_type",
                                                                        "xr_scoped") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.alias.is_set or
                                                            self.asset_id_str.is_set or
                                                            self.asset_identification.is_set or
                                                            self.ceport.is_set or
                                                            self.chip_hardware_revision.is_set or
                                                            self.composite_class_code.is_set or
                                                            self.description.is_set or
                                                            self.environmental_monitor_path.is_set or
                                                            self.firmware_revision.is_set or
                                                            self.group_flag.is_set or
                                                            self.hardware_revision.is_set or
                                                            self.is_field_replaceable_unit.is_set or
                                                            self.manufacturer_asset_tags.is_set or
                                                            self.manufacturer_name.is_set or
                                                            self.memory_size.is_set or
                                                            self.model_name.is_set or
                                                            self.name.is_set or
                                                            self.new_deviation_number.is_set or
                                                            self.physical_layer_interface_module_type.is_set or
                                                            self.redundancystate.is_set or
                                                            self.serial_number.is_set or
                                                            self.software_revision.is_set or
                                                            self.unique_id.is_set or
                                                            self.unrecognized_fru.is_set or
                                                            self.vendor_type.is_set or
                                                            self.xr_scoped.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.alias.yfilter != YFilter.not_set or
                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                            self.ceport.yfilter != YFilter.not_set or
                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                            self.group_flag.yfilter != YFilter.not_set or
                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                            self.memory_size.yfilter != YFilter.not_set or
                                                            self.model_name.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                            self.serial_number.yfilter != YFilter.not_set or
                                                            self.software_revision.yfilter != YFilter.not_set or
                                                            self.unique_id.yfilter != YFilter.not_set or
                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "alias"):
                                                            self.alias = value
                                                            self.alias.value_namespace = name_space
                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-id-str"):
                                                            self.asset_id_str = value
                                                            self.asset_id_str.value_namespace = name_space
                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-identification"):
                                                            self.asset_identification = value
                                                            self.asset_identification.value_namespace = name_space
                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ceport"):
                                                            self.ceport = value
                                                            self.ceport.value_namespace = name_space
                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "chip-hardware-revision"):
                                                            self.chip_hardware_revision = value
                                                            self.chip_hardware_revision.value_namespace = name_space
                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "composite-class-code"):
                                                            self.composite_class_code = value
                                                            self.composite_class_code.value_namespace = name_space
                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "environmental-monitor-path"):
                                                            self.environmental_monitor_path = value
                                                            self.environmental_monitor_path.value_namespace = name_space
                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "firmware-revision"):
                                                            self.firmware_revision = value
                                                            self.firmware_revision.value_namespace = name_space
                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "group-flag"):
                                                            self.group_flag = value
                                                            self.group_flag.value_namespace = name_space
                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "hardware-revision"):
                                                            self.hardware_revision = value
                                                            self.hardware_revision.value_namespace = name_space
                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-field-replaceable-unit"):
                                                            self.is_field_replaceable_unit = value
                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-asset-tags"):
                                                            self.manufacturer_asset_tags = value
                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-name"):
                                                            self.manufacturer_name = value
                                                            self.manufacturer_name.value_namespace = name_space
                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "memory-size"):
                                                            self.memory_size = value
                                                            self.memory_size.value_namespace = name_space
                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "model-name"):
                                                            self.model_name = value
                                                            self.model_name.value_namespace = name_space
                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "new-deviation-number"):
                                                            self.new_deviation_number = value
                                                            self.new_deviation_number.value_namespace = name_space
                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "physical-layer-interface-module-type"):
                                                            self.physical_layer_interface_module_type = value
                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "redundancystate"):
                                                            self.redundancystate = value
                                                            self.redundancystate.value_namespace = name_space
                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "serial-number"):
                                                            self.serial_number = value
                                                            self.serial_number.value_namespace = name_space
                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "software-revision"):
                                                            self.software_revision = value
                                                            self.software_revision.value_namespace = name_space
                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unique-id"):
                                                            self.unique_id = value
                                                            self.unique_id.value_namespace = name_space
                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unrecognized-fru"):
                                                            self.unrecognized_fru = value
                                                            self.unrecognized_fru.value_namespace = name_space
                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "vendor-type"):
                                                            self.vendor_type = value
                                                            self.vendor_type.value_namespace = name_space
                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "xr-scoped"):
                                                            self.xr_scoped = value
                                                            self.xr_scoped.value_namespace = name_space
                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                class InvEepromInfo(Entity):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._children_yang_names.add("eeprom")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("description",
                                                                        "has_eeprom",
                                                                        "inv_card_type",
                                                                        "opaque_data",
                                                                        "opaque_data_size") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                    class Eeprom(Entity):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"

                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                            self.clei = YLeaf(YType.str, "clei")

                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                            self.description = YLeaf(YType.str, "description")

                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                            self.eci = YLeaf(YType.str, "eci")

                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                            self.pid = YLeaf(YType.str, "pid")

                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                            self.vid = YLeaf(YType.str, "vid")

                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._children_yang_names.add("rma")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("asset_alias",
                                                                            "asset_id",
                                                                            "base_mac_address1",
                                                                            "base_mac_address2",
                                                                            "base_mac_address3",
                                                                            "base_mac_address4",
                                                                            "block_checksum",
                                                                            "block_count",
                                                                            "block_length",
                                                                            "block_signature",
                                                                            "block_version",
                                                                            "chassis_sid",
                                                                            "clei",
                                                                            "controller_family",
                                                                            "controller_type",
                                                                            "description",
                                                                            "dev_num1",
                                                                            "dev_num2",
                                                                            "dev_num3",
                                                                            "dev_num4",
                                                                            "dev_num5",
                                                                            "dev_num6",
                                                                            "dev_num7",
                                                                            "eci",
                                                                            "eeprom_size",
                                                                            "engineer_use",
                                                                            "fru_major_type",
                                                                            "fru_minor_type",
                                                                            "hw_version",
                                                                            "hwid",
                                                                            "idprom_format_rev",
                                                                            "mac_add_blk_size1",
                                                                            "mac_add_blk_size2",
                                                                            "mac_add_blk_size3",
                                                                            "mac_add_blk_size4",
                                                                            "manu_test_data",
                                                                            "mfg_bits",
                                                                            "mfg_deviation",
                                                                            "oem_string",
                                                                            "part_number",
                                                                            "part_revision",
                                                                            "pca_num",
                                                                            "pcavid",
                                                                            "pcb_serial_num",
                                                                            "pid",
                                                                            "power_consumption",
                                                                            "power_supply_type",
                                                                            "product_id",
                                                                            "rma_code",
                                                                            "serial_number",
                                                                            "snmpoid",
                                                                            "top_assem_part_num",
                                                                            "top_assem_vid",
                                                                            "udi_description",
                                                                            "udi_name",
                                                                            "vid") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                        class Rma(Entity):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"

                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("rma_history",
                                                                                "rma_number",
                                                                                "test_history") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.rma_history.is_set or
                                                                    self.rma_number.is_set or
                                                                    self.test_history.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                    self.test_history.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "rma" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "rma-history"):
                                                                    self.rma_history = value
                                                                    self.rma_history.value_namespace = name_space
                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "rma-number"):
                                                                    self.rma_number = value
                                                                    self.rma_number.value_namespace = name_space
                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "test-history"):
                                                                    self.test_history = value
                                                                    self.test_history.value_namespace = name_space
                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.asset_alias.is_set or
                                                                self.asset_id.is_set or
                                                                self.base_mac_address1.is_set or
                                                                self.base_mac_address2.is_set or
                                                                self.base_mac_address3.is_set or
                                                                self.base_mac_address4.is_set or
                                                                self.block_checksum.is_set or
                                                                self.block_count.is_set or
                                                                self.block_length.is_set or
                                                                self.block_signature.is_set or
                                                                self.block_version.is_set or
                                                                self.chassis_sid.is_set or
                                                                self.clei.is_set or
                                                                self.controller_family.is_set or
                                                                self.controller_type.is_set or
                                                                self.description.is_set or
                                                                self.dev_num1.is_set or
                                                                self.dev_num2.is_set or
                                                                self.dev_num3.is_set or
                                                                self.dev_num4.is_set or
                                                                self.dev_num5.is_set or
                                                                self.dev_num6.is_set or
                                                                self.dev_num7.is_set or
                                                                self.eci.is_set or
                                                                self.eeprom_size.is_set or
                                                                self.engineer_use.is_set or
                                                                self.fru_major_type.is_set or
                                                                self.fru_minor_type.is_set or
                                                                self.hw_version.is_set or
                                                                self.hwid.is_set or
                                                                self.idprom_format_rev.is_set or
                                                                self.mac_add_blk_size1.is_set or
                                                                self.mac_add_blk_size2.is_set or
                                                                self.mac_add_blk_size3.is_set or
                                                                self.mac_add_blk_size4.is_set or
                                                                self.manu_test_data.is_set or
                                                                self.mfg_bits.is_set or
                                                                self.mfg_deviation.is_set or
                                                                self.oem_string.is_set or
                                                                self.part_number.is_set or
                                                                self.part_revision.is_set or
                                                                self.pca_num.is_set or
                                                                self.pcavid.is_set or
                                                                self.pcb_serial_num.is_set or
                                                                self.pid.is_set or
                                                                self.power_consumption.is_set or
                                                                self.power_supply_type.is_set or
                                                                self.product_id.is_set or
                                                                self.rma_code.is_set or
                                                                self.serial_number.is_set or
                                                                self.snmpoid.is_set or
                                                                self.top_assem_part_num.is_set or
                                                                self.top_assem_vid.is_set or
                                                                self.udi_description.is_set or
                                                                self.udi_name.is_set or
                                                                self.vid.is_set or
                                                                (self.rma is not None and self.rma.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                self.block_count.yfilter != YFilter.not_set or
                                                                self.block_length.yfilter != YFilter.not_set or
                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                self.block_version.yfilter != YFilter.not_set or
                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                self.clei.yfilter != YFilter.not_set or
                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                self.description.yfilter != YFilter.not_set or
                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                self.eci.yfilter != YFilter.not_set or
                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                self.hwid.yfilter != YFilter.not_set or
                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                self.part_number.yfilter != YFilter.not_set or
                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                self.pid.yfilter != YFilter.not_set or
                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                self.product_id.yfilter != YFilter.not_set or
                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                self.vid.yfilter != YFilter.not_set or
                                                                (self.rma is not None and self.rma.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "eeprom" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "rma"):
                                                                if (self.rma is None):
                                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                return self.rma

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "asset-alias"):
                                                                self.asset_alias = value
                                                                self.asset_alias.value_namespace = name_space
                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "asset-id"):
                                                                self.asset_id = value
                                                                self.asset_id.value_namespace = name_space
                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address1"):
                                                                self.base_mac_address1 = value
                                                                self.base_mac_address1.value_namespace = name_space
                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address2"):
                                                                self.base_mac_address2 = value
                                                                self.base_mac_address2.value_namespace = name_space
                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address3"):
                                                                self.base_mac_address3 = value
                                                                self.base_mac_address3.value_namespace = name_space
                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address4"):
                                                                self.base_mac_address4 = value
                                                                self.base_mac_address4.value_namespace = name_space
                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-checksum"):
                                                                self.block_checksum = value
                                                                self.block_checksum.value_namespace = name_space
                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-count"):
                                                                self.block_count = value
                                                                self.block_count.value_namespace = name_space
                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-length"):
                                                                self.block_length = value
                                                                self.block_length.value_namespace = name_space
                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-signature"):
                                                                self.block_signature = value
                                                                self.block_signature.value_namespace = name_space
                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-version"):
                                                                self.block_version = value
                                                                self.block_version.value_namespace = name_space
                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "chassis-sid"):
                                                                self.chassis_sid = value
                                                                self.chassis_sid.value_namespace = name_space
                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "clei"):
                                                                self.clei = value
                                                                self.clei.value_namespace = name_space
                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-family"):
                                                                self.controller_family = value
                                                                self.controller_family.value_namespace = name_space
                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-type"):
                                                                self.controller_type = value
                                                                self.controller_type.value_namespace = name_space
                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "description"):
                                                                self.description = value
                                                                self.description.value_namespace = name_space
                                                                self.description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num1"):
                                                                self.dev_num1 = value
                                                                self.dev_num1.value_namespace = name_space
                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num2"):
                                                                self.dev_num2 = value
                                                                self.dev_num2.value_namespace = name_space
                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num3"):
                                                                self.dev_num3 = value
                                                                self.dev_num3.value_namespace = name_space
                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num4"):
                                                                self.dev_num4 = value
                                                                self.dev_num4.value_namespace = name_space
                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num5"):
                                                                self.dev_num5 = value
                                                                self.dev_num5.value_namespace = name_space
                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num6"):
                                                                self.dev_num6 = value
                                                                self.dev_num6.value_namespace = name_space
                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num7"):
                                                                self.dev_num7 = value
                                                                self.dev_num7.value_namespace = name_space
                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eci"):
                                                                self.eci = value
                                                                self.eci.value_namespace = name_space
                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eeprom-size"):
                                                                self.eeprom_size = value
                                                                self.eeprom_size.value_namespace = name_space
                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "engineer-use"):
                                                                self.engineer_use = value
                                                                self.engineer_use.value_namespace = name_space
                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-major-type"):
                                                                self.fru_major_type = value
                                                                self.fru_major_type.value_namespace = name_space
                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-minor-type"):
                                                                self.fru_minor_type = value
                                                                self.fru_minor_type.value_namespace = name_space
                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hw-version"):
                                                                self.hw_version = value
                                                                self.hw_version.value_namespace = name_space
                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hwid"):
                                                                self.hwid = value
                                                                self.hwid.value_namespace = name_space
                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "idprom-format-rev"):
                                                                self.idprom_format_rev = value
                                                                self.idprom_format_rev.value_namespace = name_space
                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size1"):
                                                                self.mac_add_blk_size1 = value
                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size2"):
                                                                self.mac_add_blk_size2 = value
                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size3"):
                                                                self.mac_add_blk_size3 = value
                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size4"):
                                                                self.mac_add_blk_size4 = value
                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "manu-test-data"):
                                                                self.manu_test_data = value
                                                                self.manu_test_data.value_namespace = name_space
                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-bits"):
                                                                self.mfg_bits = value
                                                                self.mfg_bits.value_namespace = name_space
                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-deviation"):
                                                                self.mfg_deviation = value
                                                                self.mfg_deviation.value_namespace = name_space
                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "oem-string"):
                                                                self.oem_string = value
                                                                self.oem_string.value_namespace = name_space
                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-number"):
                                                                self.part_number = value
                                                                self.part_number.value_namespace = name_space
                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-revision"):
                                                                self.part_revision = value
                                                                self.part_revision.value_namespace = name_space
                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pca-num"):
                                                                self.pca_num = value
                                                                self.pca_num.value_namespace = name_space
                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcavid"):
                                                                self.pcavid = value
                                                                self.pcavid.value_namespace = name_space
                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcb-serial-num"):
                                                                self.pcb_serial_num = value
                                                                self.pcb_serial_num.value_namespace = name_space
                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pid"):
                                                                self.pid = value
                                                                self.pid.value_namespace = name_space
                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-consumption"):
                                                                self.power_consumption = value
                                                                self.power_consumption.value_namespace = name_space
                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-supply-type"):
                                                                self.power_supply_type = value
                                                                self.power_supply_type.value_namespace = name_space
                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "product-id"):
                                                                self.product_id = value
                                                                self.product_id.value_namespace = name_space
                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "rma-code"):
                                                                self.rma_code = value
                                                                self.rma_code.value_namespace = name_space
                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "serial-number"):
                                                                self.serial_number = value
                                                                self.serial_number.value_namespace = name_space
                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "snmpoid"):
                                                                self.snmpoid = value
                                                                self.snmpoid.value_namespace = name_space
                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-part-num"):
                                                                self.top_assem_part_num = value
                                                                self.top_assem_part_num.value_namespace = name_space
                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-vid"):
                                                                self.top_assem_vid = value
                                                                self.top_assem_vid.value_namespace = name_space
                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-description"):
                                                                self.udi_description = value
                                                                self.udi_description.value_namespace = name_space
                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-name"):
                                                                self.udi_name = value
                                                                self.udi_name.value_namespace = name_space
                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vid"):
                                                                self.vid = value
                                                                self.vid.value_namespace = name_space
                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.description.is_set or
                                                            self.has_eeprom.is_set or
                                                            self.inv_card_type.is_set or
                                                            self.opaque_data.is_set or
                                                            self.opaque_data_size.is_set or
                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "eeprom"):
                                                            if (self.eeprom is None):
                                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                            return self.eeprom

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "has-eeprom"):
                                                            self.has_eeprom = value
                                                            self.has_eeprom.value_namespace = name_space
                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "inv-card-type"):
                                                            self.inv_card_type = value
                                                            self.inv_card_type.value_namespace = name_space
                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data"):
                                                            self.opaque_data = value
                                                            self.opaque_data.value_namespace = name_space
                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data-size"):
                                                            self.opaque_data_size = value
                                                            self.opaque_data_size.value_namespace = name_space
                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.module_done.is_set or
                                                        self.node_id.is_set or
                                                        self.vm_done.is_set or
                                                        self.vm_node_id.is_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                        (self.threshold is not None and self.threshold.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.module_done.yfilter != YFilter.not_set or
                                                        self.node_id.yfilter != YFilter.not_set or
                                                        self.vm_done.yfilter != YFilter.not_set or
                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "attributes" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "env-sensor-info"):
                                                        if (self.env_sensor_info is None):
                                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                        return self.env_sensor_info

                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                        if (self.env_sensor_info_xml is None):
                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                        return self.env_sensor_info_xml

                                                    if (child_yang_name == "fru-info"):
                                                        if (self.fru_info is None):
                                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                        return self.fru_info

                                                    if (child_yang_name == "inv-asset-bag"):
                                                        if (self.inv_asset_bag is None):
                                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                        return self.inv_asset_bag

                                                    if (child_yang_name == "inv-basic-bag"):
                                                        if (self.inv_basic_bag is None):
                                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                        return self.inv_basic_bag

                                                    if (child_yang_name == "inv-eeprom-info"):
                                                        if (self.inv_eeprom_info is None):
                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                        return self.inv_eeprom_info

                                                    if (child_yang_name == "pwg-info"):
                                                        if (self.pwg_info is None):
                                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                        return self.pwg_info

                                                    if (child_yang_name == "threshold"):
                                                        if (self.threshold is None):
                                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                        return self.threshold

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "module-done"):
                                                        self.module_done = value
                                                        self.module_done.value_namespace = name_space
                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "node-id"):
                                                        self.node_id = value
                                                        self.node_id.value_namespace = name_space
                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-done"):
                                                        self.vm_done = value
                                                        self.vm_done.value_namespace = name_space
                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-node-id"):
                                                        self.vm_node_id = value
                                                        self.vm_node_id.value_namespace = name_space
                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.name.is_set or
                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tsi3" + "[name='" + self.name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "attributes"):
                                                    if (self.attributes is None):
                                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                    return self.attributes

                                                if (child_yang_name == "tsi4s"):
                                                    if (self.tsi4s is None):
                                                        self.tsi4s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                        self.tsi4s.parent = self
                                                        self._children_name_map["tsi4s"] = "tsi4s"
                                                    return self.tsi4s

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attributes" or name == "tsi4s" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tsi3:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.tsi3:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tsi3s" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "tsi3"):
                                                for c in self.tsi3:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tsi3.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tsi3"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Attributes(Entity):
                                        """
                                        Attributes
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo>`
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag>`
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag>`
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        .. attribute:: module_done
                                        
                                        	Inventory EDM Module Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**default value**\: 1
                                        
                                        .. attribute:: node_id
                                        
                                        	Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo>`
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold>`
                                        
                                        .. attribute:: vm_done
                                        
                                        	VM Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: vm_node_id
                                        
                                        	VM Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"

                                            self.module_done = YLeaf(YType.int32, "module-done")

                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                            self._children_yang_names.add("env-sensor-info")

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                            self._children_yang_names.add("env-sensor-info-xml")

                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                            self._children_yang_names.add("fru-info")

                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                            self._children_yang_names.add("inv-asset-bag")

                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                            self._children_yang_names.add("inv-basic-bag")

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._children_yang_names.add("inv-eeprom-info")

                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                            self._children_yang_names.add("pwg-info")

                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                            self._children_yang_names.add("threshold")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("module_done",
                                                            "node_id",
                                                            "vm_done",
                                                            "vm_node_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)


                                        class EnvSensorInfo(Entity):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"

                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                self.device_description = YLeaf(YType.str, "device-description")

                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                self.precision = YLeaf(YType.uint32, "precision")

                                                self.scale = YLeaf(YType.uint32, "scale")

                                                self.status = YLeaf(YType.uint32, "status")

                                                self.units = YLeaf(YType.str, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("age_time_stamp",
                                                                "alarm_type",
                                                                "data_type",
                                                                "device_description",
                                                                "device_id",
                                                                "field_validity_bitmap",
                                                                "precision",
                                                                "scale",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.age_time_stamp.is_set or
                                                    self.alarm_type.is_set or
                                                    self.data_type.is_set or
                                                    self.device_description.is_set or
                                                    self.device_id.is_set or
                                                    self.field_validity_bitmap.is_set or
                                                    self.precision.is_set or
                                                    self.scale.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.device_description.yfilter != YFilter.not_set or
                                                    self.device_id.yfilter != YFilter.not_set or
                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                    self.precision.yfilter != YFilter.not_set or
                                                    self.scale.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "age-time-stamp"):
                                                    self.age_time_stamp = value
                                                    self.age_time_stamp.value_namespace = name_space
                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "alarm-type"):
                                                    self.alarm_type = value
                                                    self.alarm_type.value_namespace = name_space
                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-description"):
                                                    self.device_description = value
                                                    self.device_description.value_namespace = name_space
                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-id"):
                                                    self.device_id = value
                                                    self.device_id.value_namespace = name_space
                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "field-validity-bitmap"):
                                                    self.field_validity_bitmap = value
                                                    self.field_validity_bitmap.value_namespace = name_space
                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                if(value_path == "precision"):
                                                    self.precision = value
                                                    self.precision.value_namespace = name_space
                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale"):
                                                    self.scale = value
                                                    self.scale.value_namespace = name_space
                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PwgInfo(Entity):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\:  str
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"

                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("power_group_available_current",
                                                                "power_group_drawn_current",
                                                                "power_group_power_units",
                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.power_group_available_current.is_set or
                                                    self.power_group_drawn_current.is_set or
                                                    self.power_group_power_units.is_set or
                                                    self.power_group_redundancy_mode.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pwg-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "power-group-available-current"):
                                                    self.power_group_available_current = value
                                                    self.power_group_available_current.value_namespace = name_space
                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-drawn-current"):
                                                    self.power_group_drawn_current = value
                                                    self.power_group_drawn_current.value_namespace = name_space
                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-power-units"):
                                                    self.power_group_power_units = value
                                                    self.power_group_power_units.value_namespace = name_space
                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-redundancy-mode"):
                                                    self.power_group_redundancy_mode = value
                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                        class EnvSensorInfoXml(Entity):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"

                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                self.description = YLeaf(YType.str, "description")

                                                self.status = YLeaf(YType.enumeration, "status")

                                                self.units = YLeaf(YType.enumeration, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.str, "value")

                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._children_yang_names.add("threshold")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("data_type",
                                                                "description",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                            class Threshold(Entity):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                    self.threshold_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                class ThresholdArray(Entity):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"

                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_name",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_name.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-name"):
                                                            self.threshold_name = value
                                                            self.threshold_name.value_namespace = name_space
                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "threshold-array"):
                                                        for c in self.threshold_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.threshold_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "threshold-array"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.data_type.is_set or
                                                    self.description.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set or
                                                    (self.threshold is not None and self.threshold.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    (self.threshold is not None and self.threshold.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "threshold"):
                                                    if (self.threshold is None):
                                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                    return self.threshold

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class InvAssetBag(Entity):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"

                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                self.part_number = YLeaf(YType.str, "part-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("manufacturer_assembly_number",
                                                                "manufacturer_assembly_revision",
                                                                "manufacturer_common_language_equipment_identifier",
                                                                "manufacturer_firmware_identifier",
                                                                "manufacturer_software_identifier",
                                                                "original_equipment_manufacturer_string",
                                                                "part_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.manufacturer_assembly_number.is_set or
                                                    self.manufacturer_assembly_revision.is_set or
                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                    self.manufacturer_firmware_identifier.is_set or
                                                    self.manufacturer_software_identifier.is_set or
                                                    self.original_equipment_manufacturer_string.is_set or
                                                    self.part_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                    self.part_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-asset-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "manufacturer-assembly-number"):
                                                    self.manufacturer_assembly_number = value
                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-assembly-revision"):
                                                    self.manufacturer_assembly_revision = value
                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                    self.manufacturer_common_language_equipment_identifier = value
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-firmware-identifier"):
                                                    self.manufacturer_firmware_identifier = value
                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-software-identifier"):
                                                    self.manufacturer_software_identifier = value
                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "original-equipment-manufacturer-string"):
                                                    self.original_equipment_manufacturer_string = value
                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                if(value_path == "part-number"):
                                                    self.part_number = value
                                                    self.part_number.value_namespace = name_space
                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                        class Threshold(Entity):
                                            """
                                            Threshold
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"

                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                self._children_yang_names.add("critical-hi")

                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                self._children_yang_names.add("critical-lo")

                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                                self._children_yang_names.add("major-hi")

                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                                self._children_yang_names.add("major-lo")

                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                self._children_yang_names.add("minor-hi")

                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._children_yang_names.add("minor-lo")


                                            class MajorLo(Entity):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalHi(Entity):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorHi(Entity):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MajorHi(Entity):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalLo(Entity):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorLo(Entity):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "critical-hi"):
                                                    if (self.critical_hi is None):
                                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                    return self.critical_hi

                                                if (child_yang_name == "critical-lo"):
                                                    if (self.critical_lo is None):
                                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                    return self.critical_lo

                                                if (child_yang_name == "major-hi"):
                                                    if (self.major_hi is None):
                                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                    return self.major_hi

                                                if (child_yang_name == "major-lo"):
                                                    if (self.major_lo is None):
                                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                    return self.major_lo

                                                if (child_yang_name == "minor-hi"):
                                                    if (self.minor_hi is None):
                                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                    return self.minor_hi

                                                if (child_yang_name == "minor-lo"):
                                                    if (self.minor_lo is None):
                                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                    return self.minor_lo

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class FruInfo(Entity):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"

                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._children_yang_names.add("card-up-time")

                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                self._children_yang_names.add("last-operational-state-change")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("card_administrative_state",
                                                                "card_monitor_state",
                                                                "card_operational_state",
                                                                "card_reset_reason",
                                                                "power_administrative_state",
                                                                "power_current_measurement",
                                                                "power_operational_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)


                                            class LastOperationalStateChange(Entity):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                            class CardUpTime(Entity):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "card-up-time" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.card_administrative_state.is_set or
                                                    self.card_monitor_state.is_set or
                                                    self.card_operational_state.is_set or
                                                    self.card_reset_reason.is_set or
                                                    self.power_administrative_state.is_set or
                                                    self.power_current_measurement.is_set or
                                                    self.power_operational_state.is_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fru-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "card-up-time"):
                                                    if (self.card_up_time is None):
                                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                    return self.card_up_time

                                                if (child_yang_name == "last-operational-state-change"):
                                                    if (self.last_operational_state_change is None):
                                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                    return self.last_operational_state_change

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "card-administrative-state"):
                                                    self.card_administrative_state = value
                                                    self.card_administrative_state.value_namespace = name_space
                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-monitor-state"):
                                                    self.card_monitor_state = value
                                                    self.card_monitor_state.value_namespace = name_space
                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-operational-state"):
                                                    self.card_operational_state = value
                                                    self.card_operational_state.value_namespace = name_space
                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-reset-reason"):
                                                    self.card_reset_reason = value
                                                    self.card_reset_reason.value_namespace = name_space
                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-administrative-state"):
                                                    self.power_administrative_state = value
                                                    self.power_administrative_state.value_namespace = name_space
                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-current-measurement"):
                                                    self.power_current_measurement = value
                                                    self.power_current_measurement.value_namespace = name_space
                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-operational-state"):
                                                    self.power_operational_state = value
                                                    self.power_operational_state.value_namespace = name_space
                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                        class InvBasicBag(Entity):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\:  bool
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\:  bool
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"

                                                self.alias = YLeaf(YType.str, "alias")

                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                self.description = YLeaf(YType.str, "description")

                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                self.model_name = YLeaf(YType.str, "model-name")

                                                self.name = YLeaf(YType.str, "name")

                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("alias",
                                                                "asset_id_str",
                                                                "asset_identification",
                                                                "ceport",
                                                                "chip_hardware_revision",
                                                                "composite_class_code",
                                                                "description",
                                                                "environmental_monitor_path",
                                                                "firmware_revision",
                                                                "group_flag",
                                                                "hardware_revision",
                                                                "is_field_replaceable_unit",
                                                                "manufacturer_asset_tags",
                                                                "manufacturer_name",
                                                                "memory_size",
                                                                "model_name",
                                                                "name",
                                                                "new_deviation_number",
                                                                "physical_layer_interface_module_type",
                                                                "redundancystate",
                                                                "serial_number",
                                                                "software_revision",
                                                                "unique_id",
                                                                "unrecognized_fru",
                                                                "vendor_type",
                                                                "xr_scoped") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.alias.is_set or
                                                    self.asset_id_str.is_set or
                                                    self.asset_identification.is_set or
                                                    self.ceport.is_set or
                                                    self.chip_hardware_revision.is_set or
                                                    self.composite_class_code.is_set or
                                                    self.description.is_set or
                                                    self.environmental_monitor_path.is_set or
                                                    self.firmware_revision.is_set or
                                                    self.group_flag.is_set or
                                                    self.hardware_revision.is_set or
                                                    self.is_field_replaceable_unit.is_set or
                                                    self.manufacturer_asset_tags.is_set or
                                                    self.manufacturer_name.is_set or
                                                    self.memory_size.is_set or
                                                    self.model_name.is_set or
                                                    self.name.is_set or
                                                    self.new_deviation_number.is_set or
                                                    self.physical_layer_interface_module_type.is_set or
                                                    self.redundancystate.is_set or
                                                    self.serial_number.is_set or
                                                    self.software_revision.is_set or
                                                    self.unique_id.is_set or
                                                    self.unrecognized_fru.is_set or
                                                    self.vendor_type.is_set or
                                                    self.xr_scoped.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.alias.yfilter != YFilter.not_set or
                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                    self.ceport.yfilter != YFilter.not_set or
                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                    self.group_flag.yfilter != YFilter.not_set or
                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                    self.memory_size.yfilter != YFilter.not_set or
                                                    self.model_name.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                    self.serial_number.yfilter != YFilter.not_set or
                                                    self.software_revision.yfilter != YFilter.not_set or
                                                    self.unique_id.yfilter != YFilter.not_set or
                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-basic-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "alias"):
                                                    self.alias = value
                                                    self.alias.value_namespace = name_space
                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-id-str"):
                                                    self.asset_id_str = value
                                                    self.asset_id_str.value_namespace = name_space
                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-identification"):
                                                    self.asset_identification = value
                                                    self.asset_identification.value_namespace = name_space
                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ceport"):
                                                    self.ceport = value
                                                    self.ceport.value_namespace = name_space
                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                if(value_path == "chip-hardware-revision"):
                                                    self.chip_hardware_revision = value
                                                    self.chip_hardware_revision.value_namespace = name_space
                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "composite-class-code"):
                                                    self.composite_class_code = value
                                                    self.composite_class_code.value_namespace = name_space
                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "environmental-monitor-path"):
                                                    self.environmental_monitor_path = value
                                                    self.environmental_monitor_path.value_namespace = name_space
                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                if(value_path == "firmware-revision"):
                                                    self.firmware_revision = value
                                                    self.firmware_revision.value_namespace = name_space
                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "group-flag"):
                                                    self.group_flag = value
                                                    self.group_flag.value_namespace = name_space
                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hardware-revision"):
                                                    self.hardware_revision = value
                                                    self.hardware_revision.value_namespace = name_space
                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-field-replaceable-unit"):
                                                    self.is_field_replaceable_unit = value
                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-asset-tags"):
                                                    self.manufacturer_asset_tags = value
                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-name"):
                                                    self.manufacturer_name = value
                                                    self.manufacturer_name.value_namespace = name_space
                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "memory-size"):
                                                    self.memory_size = value
                                                    self.memory_size.value_namespace = name_space
                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                if(value_path == "model-name"):
                                                    self.model_name = value
                                                    self.model_name.value_namespace = name_space
                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "new-deviation-number"):
                                                    self.new_deviation_number = value
                                                    self.new_deviation_number.value_namespace = name_space
                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "physical-layer-interface-module-type"):
                                                    self.physical_layer_interface_module_type = value
                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "redundancystate"):
                                                    self.redundancystate = value
                                                    self.redundancystate.value_namespace = name_space
                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "serial-number"):
                                                    self.serial_number = value
                                                    self.serial_number.value_namespace = name_space
                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "software-revision"):
                                                    self.software_revision = value
                                                    self.software_revision.value_namespace = name_space
                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unique-id"):
                                                    self.unique_id = value
                                                    self.unique_id.value_namespace = name_space
                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unrecognized-fru"):
                                                    self.unrecognized_fru = value
                                                    self.unrecognized_fru.value_namespace = name_space
                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                if(value_path == "vendor-type"):
                                                    self.vendor_type = value
                                                    self.vendor_type.value_namespace = name_space
                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "xr-scoped"):
                                                    self.xr_scoped = value
                                                    self.xr_scoped.value_namespace = name_space
                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                        class InvEepromInfo(Entity):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\:  str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"

                                                self.description = YLeaf(YType.str, "description")

                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._children_yang_names.add("eeprom")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("description",
                                                                "has_eeprom",
                                                                "inv_card_type",
                                                                "opaque_data",
                                                                "opaque_data_size") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                            class Eeprom(Entity):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"

                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                    self.clei = YLeaf(YType.str, "clei")

                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                    self.description = YLeaf(YType.str, "description")

                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                    self.eci = YLeaf(YType.str, "eci")

                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                    self.pid = YLeaf(YType.str, "pid")

                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                    self.vid = YLeaf(YType.str, "vid")

                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._children_yang_names.add("rma")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("asset_alias",
                                                                    "asset_id",
                                                                    "base_mac_address1",
                                                                    "base_mac_address2",
                                                                    "base_mac_address3",
                                                                    "base_mac_address4",
                                                                    "block_checksum",
                                                                    "block_count",
                                                                    "block_length",
                                                                    "block_signature",
                                                                    "block_version",
                                                                    "chassis_sid",
                                                                    "clei",
                                                                    "controller_family",
                                                                    "controller_type",
                                                                    "description",
                                                                    "dev_num1",
                                                                    "dev_num2",
                                                                    "dev_num3",
                                                                    "dev_num4",
                                                                    "dev_num5",
                                                                    "dev_num6",
                                                                    "dev_num7",
                                                                    "eci",
                                                                    "eeprom_size",
                                                                    "engineer_use",
                                                                    "fru_major_type",
                                                                    "fru_minor_type",
                                                                    "hw_version",
                                                                    "hwid",
                                                                    "idprom_format_rev",
                                                                    "mac_add_blk_size1",
                                                                    "mac_add_blk_size2",
                                                                    "mac_add_blk_size3",
                                                                    "mac_add_blk_size4",
                                                                    "manu_test_data",
                                                                    "mfg_bits",
                                                                    "mfg_deviation",
                                                                    "oem_string",
                                                                    "part_number",
                                                                    "part_revision",
                                                                    "pca_num",
                                                                    "pcavid",
                                                                    "pcb_serial_num",
                                                                    "pid",
                                                                    "power_consumption",
                                                                    "power_supply_type",
                                                                    "product_id",
                                                                    "rma_code",
                                                                    "serial_number",
                                                                    "snmpoid",
                                                                    "top_assem_part_num",
                                                                    "top_assem_vid",
                                                                    "udi_description",
                                                                    "udi_name",
                                                                    "vid") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                class Rma(Entity):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"

                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("rma_history",
                                                                        "rma_number",
                                                                        "test_history") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.rma_history.is_set or
                                                            self.rma_number.is_set or
                                                            self.test_history.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.rma_history.yfilter != YFilter.not_set or
                                                            self.rma_number.yfilter != YFilter.not_set or
                                                            self.test_history.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "rma" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "rma-history"):
                                                            self.rma_history = value
                                                            self.rma_history.value_namespace = name_space
                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rma-number"):
                                                            self.rma_number = value
                                                            self.rma_number.value_namespace = name_space
                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "test-history"):
                                                            self.test_history = value
                                                            self.test_history.value_namespace = name_space
                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.asset_alias.is_set or
                                                        self.asset_id.is_set or
                                                        self.base_mac_address1.is_set or
                                                        self.base_mac_address2.is_set or
                                                        self.base_mac_address3.is_set or
                                                        self.base_mac_address4.is_set or
                                                        self.block_checksum.is_set or
                                                        self.block_count.is_set or
                                                        self.block_length.is_set or
                                                        self.block_signature.is_set or
                                                        self.block_version.is_set or
                                                        self.chassis_sid.is_set or
                                                        self.clei.is_set or
                                                        self.controller_family.is_set or
                                                        self.controller_type.is_set or
                                                        self.description.is_set or
                                                        self.dev_num1.is_set or
                                                        self.dev_num2.is_set or
                                                        self.dev_num3.is_set or
                                                        self.dev_num4.is_set or
                                                        self.dev_num5.is_set or
                                                        self.dev_num6.is_set or
                                                        self.dev_num7.is_set or
                                                        self.eci.is_set or
                                                        self.eeprom_size.is_set or
                                                        self.engineer_use.is_set or
                                                        self.fru_major_type.is_set or
                                                        self.fru_minor_type.is_set or
                                                        self.hw_version.is_set or
                                                        self.hwid.is_set or
                                                        self.idprom_format_rev.is_set or
                                                        self.mac_add_blk_size1.is_set or
                                                        self.mac_add_blk_size2.is_set or
                                                        self.mac_add_blk_size3.is_set or
                                                        self.mac_add_blk_size4.is_set or
                                                        self.manu_test_data.is_set or
                                                        self.mfg_bits.is_set or
                                                        self.mfg_deviation.is_set or
                                                        self.oem_string.is_set or
                                                        self.part_number.is_set or
                                                        self.part_revision.is_set or
                                                        self.pca_num.is_set or
                                                        self.pcavid.is_set or
                                                        self.pcb_serial_num.is_set or
                                                        self.pid.is_set or
                                                        self.power_consumption.is_set or
                                                        self.power_supply_type.is_set or
                                                        self.product_id.is_set or
                                                        self.rma_code.is_set or
                                                        self.serial_number.is_set or
                                                        self.snmpoid.is_set or
                                                        self.top_assem_part_num.is_set or
                                                        self.top_assem_vid.is_set or
                                                        self.udi_description.is_set or
                                                        self.udi_name.is_set or
                                                        self.vid.is_set or
                                                        (self.rma is not None and self.rma.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                        self.asset_id.yfilter != YFilter.not_set or
                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                        self.block_count.yfilter != YFilter.not_set or
                                                        self.block_length.yfilter != YFilter.not_set or
                                                        self.block_signature.yfilter != YFilter.not_set or
                                                        self.block_version.yfilter != YFilter.not_set or
                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                        self.clei.yfilter != YFilter.not_set or
                                                        self.controller_family.yfilter != YFilter.not_set or
                                                        self.controller_type.yfilter != YFilter.not_set or
                                                        self.description.yfilter != YFilter.not_set or
                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                        self.eci.yfilter != YFilter.not_set or
                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                        self.hw_version.yfilter != YFilter.not_set or
                                                        self.hwid.yfilter != YFilter.not_set or
                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                        self.oem_string.yfilter != YFilter.not_set or
                                                        self.part_number.yfilter != YFilter.not_set or
                                                        self.part_revision.yfilter != YFilter.not_set or
                                                        self.pca_num.yfilter != YFilter.not_set or
                                                        self.pcavid.yfilter != YFilter.not_set or
                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                        self.pid.yfilter != YFilter.not_set or
                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                        self.product_id.yfilter != YFilter.not_set or
                                                        self.rma_code.yfilter != YFilter.not_set or
                                                        self.serial_number.yfilter != YFilter.not_set or
                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                        self.udi_description.yfilter != YFilter.not_set or
                                                        self.udi_name.yfilter != YFilter.not_set or
                                                        self.vid.yfilter != YFilter.not_set or
                                                        (self.rma is not None and self.rma.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "eeprom" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "rma"):
                                                        if (self.rma is None):
                                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                        return self.rma

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "asset-alias"):
                                                        self.asset_alias = value
                                                        self.asset_alias.value_namespace = name_space
                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "asset-id"):
                                                        self.asset_id = value
                                                        self.asset_id.value_namespace = name_space
                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address1"):
                                                        self.base_mac_address1 = value
                                                        self.base_mac_address1.value_namespace = name_space
                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address2"):
                                                        self.base_mac_address2 = value
                                                        self.base_mac_address2.value_namespace = name_space
                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address3"):
                                                        self.base_mac_address3 = value
                                                        self.base_mac_address3.value_namespace = name_space
                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address4"):
                                                        self.base_mac_address4 = value
                                                        self.base_mac_address4.value_namespace = name_space
                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-checksum"):
                                                        self.block_checksum = value
                                                        self.block_checksum.value_namespace = name_space
                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-count"):
                                                        self.block_count = value
                                                        self.block_count.value_namespace = name_space
                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-length"):
                                                        self.block_length = value
                                                        self.block_length.value_namespace = name_space
                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-signature"):
                                                        self.block_signature = value
                                                        self.block_signature.value_namespace = name_space
                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-version"):
                                                        self.block_version = value
                                                        self.block_version.value_namespace = name_space
                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "chassis-sid"):
                                                        self.chassis_sid = value
                                                        self.chassis_sid.value_namespace = name_space
                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "clei"):
                                                        self.clei = value
                                                        self.clei.value_namespace = name_space
                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-family"):
                                                        self.controller_family = value
                                                        self.controller_family.value_namespace = name_space
                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-type"):
                                                        self.controller_type = value
                                                        self.controller_type.value_namespace = name_space
                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "description"):
                                                        self.description = value
                                                        self.description.value_namespace = name_space
                                                        self.description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num1"):
                                                        self.dev_num1 = value
                                                        self.dev_num1.value_namespace = name_space
                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num2"):
                                                        self.dev_num2 = value
                                                        self.dev_num2.value_namespace = name_space
                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num3"):
                                                        self.dev_num3 = value
                                                        self.dev_num3.value_namespace = name_space
                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num4"):
                                                        self.dev_num4 = value
                                                        self.dev_num4.value_namespace = name_space
                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num5"):
                                                        self.dev_num5 = value
                                                        self.dev_num5.value_namespace = name_space
                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num6"):
                                                        self.dev_num6 = value
                                                        self.dev_num6.value_namespace = name_space
                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num7"):
                                                        self.dev_num7 = value
                                                        self.dev_num7.value_namespace = name_space
                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eci"):
                                                        self.eci = value
                                                        self.eci.value_namespace = name_space
                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eeprom-size"):
                                                        self.eeprom_size = value
                                                        self.eeprom_size.value_namespace = name_space
                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "engineer-use"):
                                                        self.engineer_use = value
                                                        self.engineer_use.value_namespace = name_space
                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-major-type"):
                                                        self.fru_major_type = value
                                                        self.fru_major_type.value_namespace = name_space
                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-minor-type"):
                                                        self.fru_minor_type = value
                                                        self.fru_minor_type.value_namespace = name_space
                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hw-version"):
                                                        self.hw_version = value
                                                        self.hw_version.value_namespace = name_space
                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hwid"):
                                                        self.hwid = value
                                                        self.hwid.value_namespace = name_space
                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "idprom-format-rev"):
                                                        self.idprom_format_rev = value
                                                        self.idprom_format_rev.value_namespace = name_space
                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size1"):
                                                        self.mac_add_blk_size1 = value
                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size2"):
                                                        self.mac_add_blk_size2 = value
                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size3"):
                                                        self.mac_add_blk_size3 = value
                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size4"):
                                                        self.mac_add_blk_size4 = value
                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "manu-test-data"):
                                                        self.manu_test_data = value
                                                        self.manu_test_data.value_namespace = name_space
                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-bits"):
                                                        self.mfg_bits = value
                                                        self.mfg_bits.value_namespace = name_space
                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-deviation"):
                                                        self.mfg_deviation = value
                                                        self.mfg_deviation.value_namespace = name_space
                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "oem-string"):
                                                        self.oem_string = value
                                                        self.oem_string.value_namespace = name_space
                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-number"):
                                                        self.part_number = value
                                                        self.part_number.value_namespace = name_space
                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-revision"):
                                                        self.part_revision = value
                                                        self.part_revision.value_namespace = name_space
                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pca-num"):
                                                        self.pca_num = value
                                                        self.pca_num.value_namespace = name_space
                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcavid"):
                                                        self.pcavid = value
                                                        self.pcavid.value_namespace = name_space
                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcb-serial-num"):
                                                        self.pcb_serial_num = value
                                                        self.pcb_serial_num.value_namespace = name_space
                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pid"):
                                                        self.pid = value
                                                        self.pid.value_namespace = name_space
                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-consumption"):
                                                        self.power_consumption = value
                                                        self.power_consumption.value_namespace = name_space
                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-supply-type"):
                                                        self.power_supply_type = value
                                                        self.power_supply_type.value_namespace = name_space
                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "product-id"):
                                                        self.product_id = value
                                                        self.product_id.value_namespace = name_space
                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rma-code"):
                                                        self.rma_code = value
                                                        self.rma_code.value_namespace = name_space
                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "serial-number"):
                                                        self.serial_number = value
                                                        self.serial_number.value_namespace = name_space
                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "snmpoid"):
                                                        self.snmpoid = value
                                                        self.snmpoid.value_namespace = name_space
                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-part-num"):
                                                        self.top_assem_part_num = value
                                                        self.top_assem_part_num.value_namespace = name_space
                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-vid"):
                                                        self.top_assem_vid = value
                                                        self.top_assem_vid.value_namespace = name_space
                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-description"):
                                                        self.udi_description = value
                                                        self.udi_description.value_namespace = name_space
                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-name"):
                                                        self.udi_name = value
                                                        self.udi_name.value_namespace = name_space
                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vid"):
                                                        self.vid = value
                                                        self.vid.value_namespace = name_space
                                                        self.vid.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.description.is_set or
                                                    self.has_eeprom.is_set or
                                                    self.inv_card_type.is_set or
                                                    self.opaque_data.is_set or
                                                    self.opaque_data_size.is_set or
                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "eeprom"):
                                                    if (self.eeprom is None):
                                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                    return self.eeprom

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-eeprom"):
                                                    self.has_eeprom = value
                                                    self.has_eeprom.value_namespace = name_space
                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                if(value_path == "inv-card-type"):
                                                    self.inv_card_type = value
                                                    self.inv_card_type.value_namespace = name_space
                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data"):
                                                    self.opaque_data = value
                                                    self.opaque_data.value_namespace = name_space
                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data-size"):
                                                    self.opaque_data_size = value
                                                    self.opaque_data_size.value_namespace = name_space
                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.module_done.is_set or
                                                self.node_id.is_set or
                                                self.vm_done.is_set or
                                                self.vm_node_id.is_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                (self.threshold is not None and self.threshold.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.module_done.yfilter != YFilter.not_set or
                                                self.node_id.yfilter != YFilter.not_set or
                                                self.vm_done.yfilter != YFilter.not_set or
                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                (self.threshold is not None and self.threshold.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attributes" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "env-sensor-info"):
                                                if (self.env_sensor_info is None):
                                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                return self.env_sensor_info

                                            if (child_yang_name == "env-sensor-info-xml"):
                                                if (self.env_sensor_info_xml is None):
                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                return self.env_sensor_info_xml

                                            if (child_yang_name == "fru-info"):
                                                if (self.fru_info is None):
                                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                return self.fru_info

                                            if (child_yang_name == "inv-asset-bag"):
                                                if (self.inv_asset_bag is None):
                                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                return self.inv_asset_bag

                                            if (child_yang_name == "inv-basic-bag"):
                                                if (self.inv_basic_bag is None):
                                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                return self.inv_basic_bag

                                            if (child_yang_name == "inv-eeprom-info"):
                                                if (self.inv_eeprom_info is None):
                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                return self.inv_eeprom_info

                                            if (child_yang_name == "pwg-info"):
                                                if (self.pwg_info is None):
                                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                return self.pwg_info

                                            if (child_yang_name == "threshold"):
                                                if (self.threshold is None):
                                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                return self.threshold

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "module-done"):
                                                self.module_done = value
                                                self.module_done.value_namespace = name_space
                                                self.module_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "node-id"):
                                                self.node_id = value
                                                self.node_id.value_namespace = name_space
                                                self.node_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-done"):
                                                self.vm_done = value
                                                self.vm_done.value_namespace = name_space
                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-node-id"):
                                                self.vm_node_id = value
                                                self.vm_node_id.value_namespace = name_space
                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.name.is_set or
                                            (self.attributes is not None and self.attributes.has_data()) or
                                            (self.tsi3s is not None and self.tsi3s.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            (self.attributes is not None and self.attributes.has_operation()) or
                                            (self.tsi3s is not None and self.tsi3s.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tsi2" + "[name='" + self.name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attributes"):
                                            if (self.attributes is None):
                                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                            return self.attributes

                                        if (child_yang_name == "tsi3s"):
                                            if (self.tsi3s is None):
                                                self.tsi3s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                                self.tsi3s.parent = self
                                                self._children_name_map["tsi3s"] = "tsi3s"
                                            return self.tsi3s

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attributes" or name == "tsi3s" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.tsi2:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.tsi2:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tsi2s" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "tsi2"):
                                        for c in self.tsi2:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.tsi2.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "tsi2"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Attributes(Entity):
                                """
                                Attributes
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo>`
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo>`
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag>`
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag>`
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo>`
                                
                                .. attribute:: module_done
                                
                                	Inventory EDM Module Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**default value**\: 1
                                
                                .. attribute:: node_id
                                
                                	Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo>`
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold>`
                                
                                .. attribute:: vm_done
                                
                                	VM Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vm_node_id
                                
                                	VM Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"

                                    self.module_done = YLeaf(YType.int32, "module-done")

                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                    self._children_yang_names.add("env-sensor-info")

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                    self._children_yang_names.add("env-sensor-info-xml")

                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                    self._children_yang_names.add("fru-info")

                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                    self._children_yang_names.add("inv-asset-bag")

                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                    self._children_yang_names.add("inv-basic-bag")

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._children_yang_names.add("inv-eeprom-info")

                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                    self._children_yang_names.add("pwg-info")

                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                    self._children_yang_names.add("threshold")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("module_done",
                                                    "node_id",
                                                    "vm_done",
                                                    "vm_node_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)


                                class EnvSensorInfo(Entity):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"

                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                        self.device_description = YLeaf(YType.str, "device-description")

                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                        self.precision = YLeaf(YType.uint32, "precision")

                                        self.scale = YLeaf(YType.uint32, "scale")

                                        self.status = YLeaf(YType.uint32, "status")

                                        self.units = YLeaf(YType.str, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.uint32, "value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("age_time_stamp",
                                                        "alarm_type",
                                                        "data_type",
                                                        "device_description",
                                                        "device_id",
                                                        "field_validity_bitmap",
                                                        "precision",
                                                        "scale",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.age_time_stamp.is_set or
                                            self.alarm_type.is_set or
                                            self.data_type.is_set or
                                            self.device_description.is_set or
                                            self.device_id.is_set or
                                            self.field_validity_bitmap.is_set or
                                            self.precision.is_set or
                                            self.scale.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                            self.alarm_type.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.device_description.yfilter != YFilter.not_set or
                                            self.device_id.yfilter != YFilter.not_set or
                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                            self.precision.yfilter != YFilter.not_set or
                                            self.scale.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "age-time-stamp"):
                                            self.age_time_stamp = value
                                            self.age_time_stamp.value_namespace = name_space
                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                        if(value_path == "alarm-type"):
                                            self.alarm_type = value
                                            self.alarm_type.value_namespace = name_space
                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-description"):
                                            self.device_description = value
                                            self.device_description.value_namespace = name_space
                                            self.device_description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-id"):
                                            self.device_id = value
                                            self.device_id.value_namespace = name_space
                                            self.device_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "field-validity-bitmap"):
                                            self.field_validity_bitmap = value
                                            self.field_validity_bitmap.value_namespace = name_space
                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                        if(value_path == "precision"):
                                            self.precision = value
                                            self.precision.value_namespace = name_space
                                            self.precision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "scale"):
                                            self.scale = value
                                            self.scale.value_namespace = name_space
                                            self.scale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class PwgInfo(Entity):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\:  str
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"

                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("power_group_available_current",
                                                        "power_group_drawn_current",
                                                        "power_group_power_units",
                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.power_group_available_current.is_set or
                                            self.power_group_drawn_current.is_set or
                                            self.power_group_power_units.is_set or
                                            self.power_group_redundancy_mode.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pwg-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "power-group-available-current"):
                                            self.power_group_available_current = value
                                            self.power_group_available_current.value_namespace = name_space
                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-drawn-current"):
                                            self.power_group_drawn_current = value
                                            self.power_group_drawn_current.value_namespace = name_space
                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-power-units"):
                                            self.power_group_power_units = value
                                            self.power_group_power_units.value_namespace = name_space
                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-redundancy-mode"):
                                            self.power_group_redundancy_mode = value
                                            self.power_group_redundancy_mode.value_namespace = name_space
                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                class EnvSensorInfoXml(Entity):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"

                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                        self.description = YLeaf(YType.str, "description")

                                        self.status = YLeaf(YType.enumeration, "status")

                                        self.units = YLeaf(YType.enumeration, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.str, "value")

                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._children_yang_names.add("threshold")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("data_type",
                                                        "description",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                    class Threshold(Entity):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"

                                            self.threshold_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                        class ThresholdArray(Entity):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"

                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_name",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_name.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-name"):
                                                    self.threshold_name = value
                                                    self.threshold_name.value_namespace = name_space
                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.threshold_array:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.threshold_array:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "threshold" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "threshold-array"):
                                                for c in self.threshold_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.threshold_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "threshold-array"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.data_type.is_set or
                                            self.description.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set or
                                            (self.threshold is not None and self.threshold.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set or
                                            (self.threshold is not None and self.threshold.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "threshold"):
                                            if (self.threshold is None):
                                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                            return self.threshold

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class InvAssetBag(Entity):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"

                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                        self.part_number = YLeaf(YType.str, "part-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("manufacturer_assembly_number",
                                                        "manufacturer_assembly_revision",
                                                        "manufacturer_common_language_equipment_identifier",
                                                        "manufacturer_firmware_identifier",
                                                        "manufacturer_software_identifier",
                                                        "original_equipment_manufacturer_string",
                                                        "part_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.manufacturer_assembly_number.is_set or
                                            self.manufacturer_assembly_revision.is_set or
                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                            self.manufacturer_firmware_identifier.is_set or
                                            self.manufacturer_software_identifier.is_set or
                                            self.original_equipment_manufacturer_string.is_set or
                                            self.part_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                            self.part_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-asset-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "manufacturer-assembly-number"):
                                            self.manufacturer_assembly_number = value
                                            self.manufacturer_assembly_number.value_namespace = name_space
                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-assembly-revision"):
                                            self.manufacturer_assembly_revision = value
                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                            self.manufacturer_common_language_equipment_identifier = value
                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-firmware-identifier"):
                                            self.manufacturer_firmware_identifier = value
                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-software-identifier"):
                                            self.manufacturer_software_identifier = value
                                            self.manufacturer_software_identifier.value_namespace = name_space
                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "original-equipment-manufacturer-string"):
                                            self.original_equipment_manufacturer_string = value
                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                        if(value_path == "part-number"):
                                            self.part_number = value
                                            self.part_number.value_namespace = name_space
                                            self.part_number.value_namespace_prefix = name_space_prefix


                                class Threshold(Entity):
                                    """
                                    Threshold
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"

                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                        self._children_yang_names.add("critical-hi")

                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                        self._children_yang_names.add("critical-lo")

                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                        self._children_yang_names.add("major-hi")

                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                        self._children_yang_names.add("major-lo")

                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                        self._children_yang_names.add("minor-hi")

                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._children_yang_names.add("minor-lo")


                                    class MajorLo(Entity):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalHi(Entity):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorHi(Entity):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MajorHi(Entity):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalLo(Entity):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorLo(Entity):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "critical-hi"):
                                            if (self.critical_hi is None):
                                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                            return self.critical_hi

                                        if (child_yang_name == "critical-lo"):
                                            if (self.critical_lo is None):
                                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                            return self.critical_lo

                                        if (child_yang_name == "major-hi"):
                                            if (self.major_hi is None):
                                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                            return self.major_hi

                                        if (child_yang_name == "major-lo"):
                                            if (self.major_lo is None):
                                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                            return self.major_lo

                                        if (child_yang_name == "minor-hi"):
                                            if (self.minor_hi is None):
                                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                            return self.minor_hi

                                        if (child_yang_name == "minor-lo"):
                                            if (self.minor_lo is None):
                                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                            return self.minor_lo

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class FruInfo(Entity):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"

                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._children_yang_names.add("card-up-time")

                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                        self._children_yang_names.add("last-operational-state-change")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("card_administrative_state",
                                                        "card_monitor_state",
                                                        "card_operational_state",
                                                        "card_reset_reason",
                                                        "power_administrative_state",
                                                        "power_current_measurement",
                                                        "power_operational_state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)


                                    class LastOperationalStateChange(Entity):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-operational-state-change" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                    class CardUpTime(Entity):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "card-up-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.card_administrative_state.is_set or
                                            self.card_monitor_state.is_set or
                                            self.card_operational_state.is_set or
                                            self.card_reset_reason.is_set or
                                            self.power_administrative_state.is_set or
                                            self.power_current_measurement.is_set or
                                            self.power_operational_state.is_set or
                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                            self.card_operational_state.yfilter != YFilter.not_set or
                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                            self.power_operational_state.yfilter != YFilter.not_set or
                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fru-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "card-up-time"):
                                            if (self.card_up_time is None):
                                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                            return self.card_up_time

                                        if (child_yang_name == "last-operational-state-change"):
                                            if (self.last_operational_state_change is None):
                                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                            return self.last_operational_state_change

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "card-administrative-state"):
                                            self.card_administrative_state = value
                                            self.card_administrative_state.value_namespace = name_space
                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-monitor-state"):
                                            self.card_monitor_state = value
                                            self.card_monitor_state.value_namespace = name_space
                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-operational-state"):
                                            self.card_operational_state = value
                                            self.card_operational_state.value_namespace = name_space
                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-reset-reason"):
                                            self.card_reset_reason = value
                                            self.card_reset_reason.value_namespace = name_space
                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-administrative-state"):
                                            self.power_administrative_state = value
                                            self.power_administrative_state.value_namespace = name_space
                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-current-measurement"):
                                            self.power_current_measurement = value
                                            self.power_current_measurement.value_namespace = name_space
                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-operational-state"):
                                            self.power_operational_state = value
                                            self.power_operational_state.value_namespace = name_space
                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                class InvBasicBag(Entity):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\:  bool
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\:  bool
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"

                                        self.alias = YLeaf(YType.str, "alias")

                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                        self.description = YLeaf(YType.str, "description")

                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                        self.model_name = YLeaf(YType.str, "model-name")

                                        self.name = YLeaf(YType.str, "name")

                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("alias",
                                                        "asset_id_str",
                                                        "asset_identification",
                                                        "ceport",
                                                        "chip_hardware_revision",
                                                        "composite_class_code",
                                                        "description",
                                                        "environmental_monitor_path",
                                                        "firmware_revision",
                                                        "group_flag",
                                                        "hardware_revision",
                                                        "is_field_replaceable_unit",
                                                        "manufacturer_asset_tags",
                                                        "manufacturer_name",
                                                        "memory_size",
                                                        "model_name",
                                                        "name",
                                                        "new_deviation_number",
                                                        "physical_layer_interface_module_type",
                                                        "redundancystate",
                                                        "serial_number",
                                                        "software_revision",
                                                        "unique_id",
                                                        "unrecognized_fru",
                                                        "vendor_type",
                                                        "xr_scoped") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.alias.is_set or
                                            self.asset_id_str.is_set or
                                            self.asset_identification.is_set or
                                            self.ceport.is_set or
                                            self.chip_hardware_revision.is_set or
                                            self.composite_class_code.is_set or
                                            self.description.is_set or
                                            self.environmental_monitor_path.is_set or
                                            self.firmware_revision.is_set or
                                            self.group_flag.is_set or
                                            self.hardware_revision.is_set or
                                            self.is_field_replaceable_unit.is_set or
                                            self.manufacturer_asset_tags.is_set or
                                            self.manufacturer_name.is_set or
                                            self.memory_size.is_set or
                                            self.model_name.is_set or
                                            self.name.is_set or
                                            self.new_deviation_number.is_set or
                                            self.physical_layer_interface_module_type.is_set or
                                            self.redundancystate.is_set or
                                            self.serial_number.is_set or
                                            self.software_revision.is_set or
                                            self.unique_id.is_set or
                                            self.unrecognized_fru.is_set or
                                            self.vendor_type.is_set or
                                            self.xr_scoped.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.alias.yfilter != YFilter.not_set or
                                            self.asset_id_str.yfilter != YFilter.not_set or
                                            self.asset_identification.yfilter != YFilter.not_set or
                                            self.ceport.yfilter != YFilter.not_set or
                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                            self.composite_class_code.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                            self.firmware_revision.yfilter != YFilter.not_set or
                                            self.group_flag.yfilter != YFilter.not_set or
                                            self.hardware_revision.yfilter != YFilter.not_set or
                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                            self.memory_size.yfilter != YFilter.not_set or
                                            self.model_name.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                            self.redundancystate.yfilter != YFilter.not_set or
                                            self.serial_number.yfilter != YFilter.not_set or
                                            self.software_revision.yfilter != YFilter.not_set or
                                            self.unique_id.yfilter != YFilter.not_set or
                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                            self.vendor_type.yfilter != YFilter.not_set or
                                            self.xr_scoped.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-basic-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())
                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "alias"):
                                            self.alias = value
                                            self.alias.value_namespace = name_space
                                            self.alias.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-id-str"):
                                            self.asset_id_str = value
                                            self.asset_id_str.value_namespace = name_space
                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-identification"):
                                            self.asset_identification = value
                                            self.asset_identification.value_namespace = name_space
                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ceport"):
                                            self.ceport = value
                                            self.ceport.value_namespace = name_space
                                            self.ceport.value_namespace_prefix = name_space_prefix
                                        if(value_path == "chip-hardware-revision"):
                                            self.chip_hardware_revision = value
                                            self.chip_hardware_revision.value_namespace = name_space
                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "composite-class-code"):
                                            self.composite_class_code = value
                                            self.composite_class_code.value_namespace = name_space
                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "environmental-monitor-path"):
                                            self.environmental_monitor_path = value
                                            self.environmental_monitor_path.value_namespace = name_space
                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "firmware-revision"):
                                            self.firmware_revision = value
                                            self.firmware_revision.value_namespace = name_space
                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "group-flag"):
                                            self.group_flag = value
                                            self.group_flag.value_namespace = name_space
                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hardware-revision"):
                                            self.hardware_revision = value
                                            self.hardware_revision.value_namespace = name_space
                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-field-replaceable-unit"):
                                            self.is_field_replaceable_unit = value
                                            self.is_field_replaceable_unit.value_namespace = name_space
                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-asset-tags"):
                                            self.manufacturer_asset_tags = value
                                            self.manufacturer_asset_tags.value_namespace = name_space
                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-name"):
                                            self.manufacturer_name = value
                                            self.manufacturer_name.value_namespace = name_space
                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "memory-size"):
                                            self.memory_size = value
                                            self.memory_size.value_namespace = name_space
                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "model-name"):
                                            self.model_name = value
                                            self.model_name.value_namespace = name_space
                                            self.model_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "new-deviation-number"):
                                            self.new_deviation_number = value
                                            self.new_deviation_number.value_namespace = name_space
                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "physical-layer-interface-module-type"):
                                            self.physical_layer_interface_module_type = value
                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "redundancystate"):
                                            self.redundancystate = value
                                            self.redundancystate.value_namespace = name_space
                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "serial-number"):
                                            self.serial_number = value
                                            self.serial_number.value_namespace = name_space
                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "software-revision"):
                                            self.software_revision = value
                                            self.software_revision.value_namespace = name_space
                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unique-id"):
                                            self.unique_id = value
                                            self.unique_id.value_namespace = name_space
                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unrecognized-fru"):
                                            self.unrecognized_fru = value
                                            self.unrecognized_fru.value_namespace = name_space
                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vendor-type"):
                                            self.vendor_type = value
                                            self.vendor_type.value_namespace = name_space
                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "xr-scoped"):
                                            self.xr_scoped = value
                                            self.xr_scoped.value_namespace = name_space
                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                class InvEepromInfo(Entity):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"

                                        self.description = YLeaf(YType.str, "description")

                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._children_yang_names.add("eeprom")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("description",
                                                        "has_eeprom",
                                                        "inv_card_type",
                                                        "opaque_data",
                                                        "opaque_data_size") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                    class Eeprom(Entity):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"

                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                            self.block_count = YLeaf(YType.str, "block-count")

                                            self.block_length = YLeaf(YType.str, "block-length")

                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                            self.block_version = YLeaf(YType.str, "block-version")

                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                            self.clei = YLeaf(YType.str, "clei")

                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                            self.description = YLeaf(YType.str, "description")

                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                            self.eci = YLeaf(YType.str, "eci")

                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                            self.hwid = YLeaf(YType.str, "hwid")

                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                            self.part_number = YLeaf(YType.str, "part-number")

                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                            self.pid = YLeaf(YType.str, "pid")

                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                            self.product_id = YLeaf(YType.str, "product-id")

                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                            self.vid = YLeaf(YType.str, "vid")

                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._children_yang_names.add("rma")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("asset_alias",
                                                            "asset_id",
                                                            "base_mac_address1",
                                                            "base_mac_address2",
                                                            "base_mac_address3",
                                                            "base_mac_address4",
                                                            "block_checksum",
                                                            "block_count",
                                                            "block_length",
                                                            "block_signature",
                                                            "block_version",
                                                            "chassis_sid",
                                                            "clei",
                                                            "controller_family",
                                                            "controller_type",
                                                            "description",
                                                            "dev_num1",
                                                            "dev_num2",
                                                            "dev_num3",
                                                            "dev_num4",
                                                            "dev_num5",
                                                            "dev_num6",
                                                            "dev_num7",
                                                            "eci",
                                                            "eeprom_size",
                                                            "engineer_use",
                                                            "fru_major_type",
                                                            "fru_minor_type",
                                                            "hw_version",
                                                            "hwid",
                                                            "idprom_format_rev",
                                                            "mac_add_blk_size1",
                                                            "mac_add_blk_size2",
                                                            "mac_add_blk_size3",
                                                            "mac_add_blk_size4",
                                                            "manu_test_data",
                                                            "mfg_bits",
                                                            "mfg_deviation",
                                                            "oem_string",
                                                            "part_number",
                                                            "part_revision",
                                                            "pca_num",
                                                            "pcavid",
                                                            "pcb_serial_num",
                                                            "pid",
                                                            "power_consumption",
                                                            "power_supply_type",
                                                            "product_id",
                                                            "rma_code",
                                                            "serial_number",
                                                            "snmpoid",
                                                            "top_assem_part_num",
                                                            "top_assem_vid",
                                                            "udi_description",
                                                            "udi_name",
                                                            "vid") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                        class Rma(Entity):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"

                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                self.test_history = YLeaf(YType.str, "test-history")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("rma_history",
                                                                "rma_number",
                                                                "test_history") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.rma_history.is_set or
                                                    self.rma_number.is_set or
                                                    self.test_history.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.rma_history.yfilter != YFilter.not_set or
                                                    self.rma_number.yfilter != YFilter.not_set or
                                                    self.test_history.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "rma" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "rma-history"):
                                                    self.rma_history = value
                                                    self.rma_history.value_namespace = name_space
                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rma-number"):
                                                    self.rma_number = value
                                                    self.rma_number.value_namespace = name_space
                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "test-history"):
                                                    self.test_history = value
                                                    self.test_history.value_namespace = name_space
                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.asset_alias.is_set or
                                                self.asset_id.is_set or
                                                self.base_mac_address1.is_set or
                                                self.base_mac_address2.is_set or
                                                self.base_mac_address3.is_set or
                                                self.base_mac_address4.is_set or
                                                self.block_checksum.is_set or
                                                self.block_count.is_set or
                                                self.block_length.is_set or
                                                self.block_signature.is_set or
                                                self.block_version.is_set or
                                                self.chassis_sid.is_set or
                                                self.clei.is_set or
                                                self.controller_family.is_set or
                                                self.controller_type.is_set or
                                                self.description.is_set or
                                                self.dev_num1.is_set or
                                                self.dev_num2.is_set or
                                                self.dev_num3.is_set or
                                                self.dev_num4.is_set or
                                                self.dev_num5.is_set or
                                                self.dev_num6.is_set or
                                                self.dev_num7.is_set or
                                                self.eci.is_set or
                                                self.eeprom_size.is_set or
                                                self.engineer_use.is_set or
                                                self.fru_major_type.is_set or
                                                self.fru_minor_type.is_set or
                                                self.hw_version.is_set or
                                                self.hwid.is_set or
                                                self.idprom_format_rev.is_set or
                                                self.mac_add_blk_size1.is_set or
                                                self.mac_add_blk_size2.is_set or
                                                self.mac_add_blk_size3.is_set or
                                                self.mac_add_blk_size4.is_set or
                                                self.manu_test_data.is_set or
                                                self.mfg_bits.is_set or
                                                self.mfg_deviation.is_set or
                                                self.oem_string.is_set or
                                                self.part_number.is_set or
                                                self.part_revision.is_set or
                                                self.pca_num.is_set or
                                                self.pcavid.is_set or
                                                self.pcb_serial_num.is_set or
                                                self.pid.is_set or
                                                self.power_consumption.is_set or
                                                self.power_supply_type.is_set or
                                                self.product_id.is_set or
                                                self.rma_code.is_set or
                                                self.serial_number.is_set or
                                                self.snmpoid.is_set or
                                                self.top_assem_part_num.is_set or
                                                self.top_assem_vid.is_set or
                                                self.udi_description.is_set or
                                                self.udi_name.is_set or
                                                self.vid.is_set or
                                                (self.rma is not None and self.rma.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.asset_alias.yfilter != YFilter.not_set or
                                                self.asset_id.yfilter != YFilter.not_set or
                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                self.block_checksum.yfilter != YFilter.not_set or
                                                self.block_count.yfilter != YFilter.not_set or
                                                self.block_length.yfilter != YFilter.not_set or
                                                self.block_signature.yfilter != YFilter.not_set or
                                                self.block_version.yfilter != YFilter.not_set or
                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                self.clei.yfilter != YFilter.not_set or
                                                self.controller_family.yfilter != YFilter.not_set or
                                                self.controller_type.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.dev_num1.yfilter != YFilter.not_set or
                                                self.dev_num2.yfilter != YFilter.not_set or
                                                self.dev_num3.yfilter != YFilter.not_set or
                                                self.dev_num4.yfilter != YFilter.not_set or
                                                self.dev_num5.yfilter != YFilter.not_set or
                                                self.dev_num6.yfilter != YFilter.not_set or
                                                self.dev_num7.yfilter != YFilter.not_set or
                                                self.eci.yfilter != YFilter.not_set or
                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                self.engineer_use.yfilter != YFilter.not_set or
                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                self.hw_version.yfilter != YFilter.not_set or
                                                self.hwid.yfilter != YFilter.not_set or
                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                self.oem_string.yfilter != YFilter.not_set or
                                                self.part_number.yfilter != YFilter.not_set or
                                                self.part_revision.yfilter != YFilter.not_set or
                                                self.pca_num.yfilter != YFilter.not_set or
                                                self.pcavid.yfilter != YFilter.not_set or
                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                self.pid.yfilter != YFilter.not_set or
                                                self.power_consumption.yfilter != YFilter.not_set or
                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                self.product_id.yfilter != YFilter.not_set or
                                                self.rma_code.yfilter != YFilter.not_set or
                                                self.serial_number.yfilter != YFilter.not_set or
                                                self.snmpoid.yfilter != YFilter.not_set or
                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                self.udi_description.yfilter != YFilter.not_set or
                                                self.udi_name.yfilter != YFilter.not_set or
                                                self.vid.yfilter != YFilter.not_set or
                                                (self.rma is not None and self.rma.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "eeprom" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "rma"):
                                                if (self.rma is None):
                                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                return self.rma

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "asset-alias"):
                                                self.asset_alias = value
                                                self.asset_alias.value_namespace = name_space
                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                            if(value_path == "asset-id"):
                                                self.asset_id = value
                                                self.asset_id.value_namespace = name_space
                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address1"):
                                                self.base_mac_address1 = value
                                                self.base_mac_address1.value_namespace = name_space
                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address2"):
                                                self.base_mac_address2 = value
                                                self.base_mac_address2.value_namespace = name_space
                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address3"):
                                                self.base_mac_address3 = value
                                                self.base_mac_address3.value_namespace = name_space
                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address4"):
                                                self.base_mac_address4 = value
                                                self.base_mac_address4.value_namespace = name_space
                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-checksum"):
                                                self.block_checksum = value
                                                self.block_checksum.value_namespace = name_space
                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-count"):
                                                self.block_count = value
                                                self.block_count.value_namespace = name_space
                                                self.block_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-length"):
                                                self.block_length = value
                                                self.block_length.value_namespace = name_space
                                                self.block_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-signature"):
                                                self.block_signature = value
                                                self.block_signature.value_namespace = name_space
                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-version"):
                                                self.block_version = value
                                                self.block_version.value_namespace = name_space
                                                self.block_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "chassis-sid"):
                                                self.chassis_sid = value
                                                self.chassis_sid.value_namespace = name_space
                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "clei"):
                                                self.clei = value
                                                self.clei.value_namespace = name_space
                                                self.clei.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-family"):
                                                self.controller_family = value
                                                self.controller_family.value_namespace = name_space
                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-type"):
                                                self.controller_type = value
                                                self.controller_type.value_namespace = name_space
                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num1"):
                                                self.dev_num1 = value
                                                self.dev_num1.value_namespace = name_space
                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num2"):
                                                self.dev_num2 = value
                                                self.dev_num2.value_namespace = name_space
                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num3"):
                                                self.dev_num3 = value
                                                self.dev_num3.value_namespace = name_space
                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num4"):
                                                self.dev_num4 = value
                                                self.dev_num4.value_namespace = name_space
                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num5"):
                                                self.dev_num5 = value
                                                self.dev_num5.value_namespace = name_space
                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num6"):
                                                self.dev_num6 = value
                                                self.dev_num6.value_namespace = name_space
                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num7"):
                                                self.dev_num7 = value
                                                self.dev_num7.value_namespace = name_space
                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eci"):
                                                self.eci = value
                                                self.eci.value_namespace = name_space
                                                self.eci.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eeprom-size"):
                                                self.eeprom_size = value
                                                self.eeprom_size.value_namespace = name_space
                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                            if(value_path == "engineer-use"):
                                                self.engineer_use = value
                                                self.engineer_use.value_namespace = name_space
                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-major-type"):
                                                self.fru_major_type = value
                                                self.fru_major_type.value_namespace = name_space
                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-minor-type"):
                                                self.fru_minor_type = value
                                                self.fru_minor_type.value_namespace = name_space
                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hw-version"):
                                                self.hw_version = value
                                                self.hw_version.value_namespace = name_space
                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hwid"):
                                                self.hwid = value
                                                self.hwid.value_namespace = name_space
                                                self.hwid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "idprom-format-rev"):
                                                self.idprom_format_rev = value
                                                self.idprom_format_rev.value_namespace = name_space
                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size1"):
                                                self.mac_add_blk_size1 = value
                                                self.mac_add_blk_size1.value_namespace = name_space
                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size2"):
                                                self.mac_add_blk_size2 = value
                                                self.mac_add_blk_size2.value_namespace = name_space
                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size3"):
                                                self.mac_add_blk_size3 = value
                                                self.mac_add_blk_size3.value_namespace = name_space
                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size4"):
                                                self.mac_add_blk_size4 = value
                                                self.mac_add_blk_size4.value_namespace = name_space
                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "manu-test-data"):
                                                self.manu_test_data = value
                                                self.manu_test_data.value_namespace = name_space
                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-bits"):
                                                self.mfg_bits = value
                                                self.mfg_bits.value_namespace = name_space
                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-deviation"):
                                                self.mfg_deviation = value
                                                self.mfg_deviation.value_namespace = name_space
                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "oem-string"):
                                                self.oem_string = value
                                                self.oem_string.value_namespace = name_space
                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-number"):
                                                self.part_number = value
                                                self.part_number.value_namespace = name_space
                                                self.part_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-revision"):
                                                self.part_revision = value
                                                self.part_revision.value_namespace = name_space
                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pca-num"):
                                                self.pca_num = value
                                                self.pca_num.value_namespace = name_space
                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcavid"):
                                                self.pcavid = value
                                                self.pcavid.value_namespace = name_space
                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcb-serial-num"):
                                                self.pcb_serial_num = value
                                                self.pcb_serial_num.value_namespace = name_space
                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pid"):
                                                self.pid = value
                                                self.pid.value_namespace = name_space
                                                self.pid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-consumption"):
                                                self.power_consumption = value
                                                self.power_consumption.value_namespace = name_space
                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-supply-type"):
                                                self.power_supply_type = value
                                                self.power_supply_type.value_namespace = name_space
                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "product-id"):
                                                self.product_id = value
                                                self.product_id.value_namespace = name_space
                                                self.product_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rma-code"):
                                                self.rma_code = value
                                                self.rma_code.value_namespace = name_space
                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                            if(value_path == "serial-number"):
                                                self.serial_number = value
                                                self.serial_number.value_namespace = name_space
                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snmpoid"):
                                                self.snmpoid = value
                                                self.snmpoid.value_namespace = name_space
                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-part-num"):
                                                self.top_assem_part_num = value
                                                self.top_assem_part_num.value_namespace = name_space
                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-vid"):
                                                self.top_assem_vid = value
                                                self.top_assem_vid.value_namespace = name_space
                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-description"):
                                                self.udi_description = value
                                                self.udi_description.value_namespace = name_space
                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-name"):
                                                self.udi_name = value
                                                self.udi_name.value_namespace = name_space
                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vid"):
                                                self.vid = value
                                                self.vid.value_namespace = name_space
                                                self.vid.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.description.is_set or
                                            self.has_eeprom.is_set or
                                            self.inv_card_type.is_set or
                                            self.opaque_data.is_set or
                                            self.opaque_data_size.is_set or
                                            (self.eeprom is not None and self.eeprom.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.has_eeprom.yfilter != YFilter.not_set or
                                            self.inv_card_type.yfilter != YFilter.not_set or
                                            self.opaque_data.yfilter != YFilter.not_set or
                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-eeprom-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "eeprom"):
                                            if (self.eeprom is None):
                                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                            return self.eeprom

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "has-eeprom"):
                                            self.has_eeprom = value
                                            self.has_eeprom.value_namespace = name_space
                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inv-card-type"):
                                            self.inv_card_type = value
                                            self.inv_card_type.value_namespace = name_space
                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data"):
                                            self.opaque_data = value
                                            self.opaque_data.value_namespace = name_space
                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data-size"):
                                            self.opaque_data_size = value
                                            self.opaque_data_size.value_namespace = name_space
                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.module_done.is_set or
                                        self.node_id.is_set or
                                        self.vm_done.is_set or
                                        self.vm_node_id.is_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                        (self.threshold is not None and self.threshold.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.module_done.yfilter != YFilter.not_set or
                                        self.node_id.yfilter != YFilter.not_set or
                                        self.vm_done.yfilter != YFilter.not_set or
                                        self.vm_node_id.yfilter != YFilter.not_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                        (self.threshold is not None and self.threshold.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attributes" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "env-sensor-info"):
                                        if (self.env_sensor_info is None):
                                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                        return self.env_sensor_info

                                    if (child_yang_name == "env-sensor-info-xml"):
                                        if (self.env_sensor_info_xml is None):
                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                        return self.env_sensor_info_xml

                                    if (child_yang_name == "fru-info"):
                                        if (self.fru_info is None):
                                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                        return self.fru_info

                                    if (child_yang_name == "inv-asset-bag"):
                                        if (self.inv_asset_bag is None):
                                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                        return self.inv_asset_bag

                                    if (child_yang_name == "inv-basic-bag"):
                                        if (self.inv_basic_bag is None):
                                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                        return self.inv_basic_bag

                                    if (child_yang_name == "inv-eeprom-info"):
                                        if (self.inv_eeprom_info is None):
                                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                        return self.inv_eeprom_info

                                    if (child_yang_name == "pwg-info"):
                                        if (self.pwg_info is None):
                                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                        return self.pwg_info

                                    if (child_yang_name == "threshold"):
                                        if (self.threshold is None):
                                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                        return self.threshold

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "module-done"):
                                        self.module_done = value
                                        self.module_done.value_namespace = name_space
                                        self.module_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-id"):
                                        self.node_id = value
                                        self.node_id.value_namespace = name_space
                                        self.node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-done"):
                                        self.vm_done = value
                                        self.vm_done.value_namespace = name_space
                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-node-id"):
                                        self.vm_node_id = value
                                        self.vm_node_id.value_namespace = name_space
                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.name.is_set or
                                    (self.attributes is not None and self.attributes.has_data()) or
                                    (self.tsi2s is not None and self.tsi2s.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    (self.attributes is not None and self.attributes.has_operation()) or
                                    (self.tsi2s is not None and self.tsi2s.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tsi1" + "[name='" + self.name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attributes"):
                                    if (self.attributes is None):
                                        self.attributes = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                    return self.attributes

                                if (child_yang_name == "tsi2s"):
                                    if (self.tsi2s is None):
                                        self.tsi2s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1.Tsi2S()
                                        self.tsi2s.parent = self
                                        self._children_name_map["tsi2s"] = "tsi2s"
                                    return self.tsi2s

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attributes" or name == "tsi2s" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.tsi1:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.tsi1:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tsi1s" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "tsi1"):
                                for c in self.tsi1:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Inventory.Racks.Rack.Entity_.Slot.Tsi1S.Tsi1()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.tsi1.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tsi1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Attributes(Entity):
                        """
                        Attributes
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo>`
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml>`
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo>`
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag>`
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag>`
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo>`
                        
                        .. attribute:: module_done
                        
                        	Inventory EDM Module Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**default value**\: 1
                        
                        .. attribute:: node_id
                        
                        	Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo>`
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold>`
                        
                        .. attribute:: vm_done
                        
                        	VM Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: vm_node_id
                        
                        	VM Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"

                            self.module_done = YLeaf(YType.int32, "module-done")

                            self.node_id = YLeaf(YType.uint32, "node-id")

                            self.vm_done = YLeaf(YType.int32, "vm-done")

                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                            self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                            self._children_yang_names.add("env-sensor-info")

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                            self._children_yang_names.add("env-sensor-info-xml")

                            self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"
                            self._children_yang_names.add("fru-info")

                            self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                            self._children_yang_names.add("inv-asset-bag")

                            self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                            self._children_yang_names.add("inv-basic-bag")

                            self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._children_yang_names.add("inv-eeprom-info")

                            self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"
                            self._children_yang_names.add("pwg-info")

                            self.threshold = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"
                            self._children_yang_names.add("threshold")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("module_done",
                                            "node_id",
                                            "vm_done",
                                            "vm_node_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes, self).__setattr__(name, value)


                        class EnvSensorInfo(Entity):
                            """
                            Environment sensor info
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"

                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                self.data_type = YLeaf(YType.uint32, "data-type")

                                self.device_description = YLeaf(YType.str, "device-description")

                                self.device_id = YLeaf(YType.uint32, "device-id")

                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                self.precision = YLeaf(YType.uint32, "precision")

                                self.scale = YLeaf(YType.uint32, "scale")

                                self.status = YLeaf(YType.uint32, "status")

                                self.units = YLeaf(YType.str, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.uint32, "value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("age_time_stamp",
                                                "alarm_type",
                                                "data_type",
                                                "device_description",
                                                "device_id",
                                                "field_validity_bitmap",
                                                "precision",
                                                "scale",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.age_time_stamp.is_set or
                                    self.alarm_type.is_set or
                                    self.data_type.is_set or
                                    self.device_description.is_set or
                                    self.device_id.is_set or
                                    self.field_validity_bitmap.is_set or
                                    self.precision.is_set or
                                    self.scale.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                    self.alarm_type.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.device_description.yfilter != YFilter.not_set or
                                    self.device_id.yfilter != YFilter.not_set or
                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                    self.precision.yfilter != YFilter.not_set or
                                    self.scale.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "age-time-stamp"):
                                    self.age_time_stamp = value
                                    self.age_time_stamp.value_namespace = name_space
                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "alarm-type"):
                                    self.alarm_type = value
                                    self.alarm_type.value_namespace = name_space
                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-description"):
                                    self.device_description = value
                                    self.device_description.value_namespace = name_space
                                    self.device_description.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-id"):
                                    self.device_id = value
                                    self.device_id.value_namespace = name_space
                                    self.device_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "field-validity-bitmap"):
                                    self.field_validity_bitmap = value
                                    self.field_validity_bitmap.value_namespace = name_space
                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                if(value_path == "precision"):
                                    self.precision = value
                                    self.precision.value_namespace = name_space
                                    self.precision.value_namespace_prefix = name_space_prefix
                                if(value_path == "scale"):
                                    self.scale = value
                                    self.scale.value_namespace = name_space
                                    self.scale.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class PwgInfo(Entity):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\:  str
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"

                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("power_group_available_current",
                                                "power_group_drawn_current",
                                                "power_group_power_units",
                                                "power_group_redundancy_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.power_group_available_current.is_set or
                                    self.power_group_drawn_current.is_set or
                                    self.power_group_power_units.is_set or
                                    self.power_group_redundancy_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pwg-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "power-group-available-current"):
                                    self.power_group_available_current = value
                                    self.power_group_available_current.value_namespace = name_space
                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-drawn-current"):
                                    self.power_group_drawn_current = value
                                    self.power_group_drawn_current.value_namespace = name_space
                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-power-units"):
                                    self.power_group_power_units = value
                                    self.power_group_power_units.value_namespace = name_space
                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-redundancy-mode"):
                                    self.power_group_redundancy_mode = value
                                    self.power_group_redundancy_mode.value_namespace = name_space
                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                        class EnvSensorInfoXml(Entity):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"

                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                self.description = YLeaf(YType.str, "description")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.units = YLeaf(YType.enumeration, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.str, "value")

                                self.threshold = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._children_yang_names.add("threshold")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("data_type",
                                                "description",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                            class Threshold(Entity):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"

                                    self.threshold_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                class ThresholdArray(Entity):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"

                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_name",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_name.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_name.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-name"):
                                            self.threshold_name = value
                                            self.threshold_name.value_namespace = name_space
                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.threshold_array:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.threshold_array:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "threshold" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "threshold-array"):
                                        for c in self.threshold_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.threshold_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "threshold-array"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.data_type.is_set or
                                    self.description.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set or
                                    (self.threshold is not None and self.threshold.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set or
                                    (self.threshold is not None and self.threshold.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info-xml" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "threshold"):
                                    if (self.threshold is None):
                                        self.threshold = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                    return self.threshold

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class InvAssetBag(Entity):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"

                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                self.part_number = YLeaf(YType.str, "part-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("manufacturer_assembly_number",
                                                "manufacturer_assembly_revision",
                                                "manufacturer_common_language_equipment_identifier",
                                                "manufacturer_firmware_identifier",
                                                "manufacturer_software_identifier",
                                                "original_equipment_manufacturer_string",
                                                "part_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.manufacturer_assembly_number.is_set or
                                    self.manufacturer_assembly_revision.is_set or
                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                    self.manufacturer_firmware_identifier.is_set or
                                    self.manufacturer_software_identifier.is_set or
                                    self.original_equipment_manufacturer_string.is_set or
                                    self.part_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                    self.part_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-asset-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "manufacturer-assembly-number"):
                                    self.manufacturer_assembly_number = value
                                    self.manufacturer_assembly_number.value_namespace = name_space
                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-assembly-revision"):
                                    self.manufacturer_assembly_revision = value
                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                    self.manufacturer_common_language_equipment_identifier = value
                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-firmware-identifier"):
                                    self.manufacturer_firmware_identifier = value
                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-software-identifier"):
                                    self.manufacturer_software_identifier = value
                                    self.manufacturer_software_identifier.value_namespace = name_space
                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-equipment-manufacturer-string"):
                                    self.original_equipment_manufacturer_string = value
                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                if(value_path == "part-number"):
                                    self.part_number = value
                                    self.part_number.value_namespace = name_space
                                    self.part_number.value_namespace_prefix = name_space_prefix


                        class Threshold(Entity):
                            """
                            Threshold
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi>`
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo>`
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi>`
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo>`
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi>`
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"

                                self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"
                                self._children_yang_names.add("critical-hi")

                                self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"
                                self._children_yang_names.add("critical-lo")

                                self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"
                                self._children_yang_names.add("major-hi")

                                self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"
                                self._children_yang_names.add("major-lo")

                                self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"
                                self._children_yang_names.add("minor-hi")

                                self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._children_yang_names.add("minor-lo")


                            class MajorLo(Entity):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalHi(Entity):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorHi(Entity):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MajorHi(Entity):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalLo(Entity):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorLo(Entity):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "threshold" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "critical-hi"):
                                    if (self.critical_hi is None):
                                        self.critical_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                    return self.critical_hi

                                if (child_yang_name == "critical-lo"):
                                    if (self.critical_lo is None):
                                        self.critical_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                    return self.critical_lo

                                if (child_yang_name == "major-hi"):
                                    if (self.major_hi is None):
                                        self.major_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                    return self.major_hi

                                if (child_yang_name == "major-lo"):
                                    if (self.major_lo is None):
                                        self.major_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                    return self.major_lo

                                if (child_yang_name == "minor-hi"):
                                    if (self.minor_hi is None):
                                        self.minor_hi = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                    return self.minor_hi

                                if (child_yang_name == "minor-lo"):
                                    if (self.minor_lo is None):
                                        self.minor_lo = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                    return self.minor_lo

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class FruInfo(Entity):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"

                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._children_yang_names.add("card-up-time")

                                self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                self._children_yang_names.add("last-operational-state-change")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("card_administrative_state",
                                                "card_monitor_state",
                                                "card_operational_state",
                                                "card_reset_reason",
                                                "power_administrative_state",
                                                "power_current_measurement",
                                                "power_operational_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo, self).__setattr__(name, value)


                            class LastOperationalStateChange(Entity):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "last-operational-state-change" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                            class CardUpTime(Entity):
                                """
                                card up time
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "card-up-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.card_administrative_state.is_set or
                                    self.card_monitor_state.is_set or
                                    self.card_operational_state.is_set or
                                    self.card_reset_reason.is_set or
                                    self.power_administrative_state.is_set or
                                    self.power_current_measurement.is_set or
                                    self.power_operational_state.is_set or
                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                    self.card_operational_state.yfilter != YFilter.not_set or
                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                    self.power_operational_state.yfilter != YFilter.not_set or
                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fru-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "card-up-time"):
                                    if (self.card_up_time is None):
                                        self.card_up_time = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                    return self.card_up_time

                                if (child_yang_name == "last-operational-state-change"):
                                    if (self.last_operational_state_change is None):
                                        self.last_operational_state_change = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                    return self.last_operational_state_change

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "card-administrative-state"):
                                    self.card_administrative_state = value
                                    self.card_administrative_state.value_namespace = name_space
                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-monitor-state"):
                                    self.card_monitor_state = value
                                    self.card_monitor_state.value_namespace = name_space
                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-operational-state"):
                                    self.card_operational_state = value
                                    self.card_operational_state.value_namespace = name_space
                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-reset-reason"):
                                    self.card_reset_reason = value
                                    self.card_reset_reason.value_namespace = name_space
                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-administrative-state"):
                                    self.power_administrative_state = value
                                    self.power_administrative_state.value_namespace = name_space
                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-current-measurement"):
                                    self.power_current_measurement = value
                                    self.power_current_measurement.value_namespace = name_space
                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-operational-state"):
                                    self.power_operational_state = value
                                    self.power_operational_state.value_namespace = name_space
                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                        class InvBasicBag(Entity):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\:  bool
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\:  bool
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\:  bool
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\:  bool
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"

                                self.alias = YLeaf(YType.str, "alias")

                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                self.ceport = YLeaf(YType.boolean, "ceport")

                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                self.description = YLeaf(YType.str, "description")

                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                self.model_name = YLeaf(YType.str, "model-name")

                                self.name = YLeaf(YType.str, "name")

                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                self.serial_number = YLeaf(YType.str, "serial-number")

                                self.software_revision = YLeaf(YType.str, "software-revision")

                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("alias",
                                                "asset_id_str",
                                                "asset_identification",
                                                "ceport",
                                                "chip_hardware_revision",
                                                "composite_class_code",
                                                "description",
                                                "environmental_monitor_path",
                                                "firmware_revision",
                                                "group_flag",
                                                "hardware_revision",
                                                "is_field_replaceable_unit",
                                                "manufacturer_asset_tags",
                                                "manufacturer_name",
                                                "memory_size",
                                                "model_name",
                                                "name",
                                                "new_deviation_number",
                                                "physical_layer_interface_module_type",
                                                "redundancystate",
                                                "serial_number",
                                                "software_revision",
                                                "unique_id",
                                                "unrecognized_fru",
                                                "vendor_type",
                                                "xr_scoped") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.alias.is_set or
                                    self.asset_id_str.is_set or
                                    self.asset_identification.is_set or
                                    self.ceport.is_set or
                                    self.chip_hardware_revision.is_set or
                                    self.composite_class_code.is_set or
                                    self.description.is_set or
                                    self.environmental_monitor_path.is_set or
                                    self.firmware_revision.is_set or
                                    self.group_flag.is_set or
                                    self.hardware_revision.is_set or
                                    self.is_field_replaceable_unit.is_set or
                                    self.manufacturer_asset_tags.is_set or
                                    self.manufacturer_name.is_set or
                                    self.memory_size.is_set or
                                    self.model_name.is_set or
                                    self.name.is_set or
                                    self.new_deviation_number.is_set or
                                    self.physical_layer_interface_module_type.is_set or
                                    self.redundancystate.is_set or
                                    self.serial_number.is_set or
                                    self.software_revision.is_set or
                                    self.unique_id.is_set or
                                    self.unrecognized_fru.is_set or
                                    self.vendor_type.is_set or
                                    self.xr_scoped.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.alias.yfilter != YFilter.not_set or
                                    self.asset_id_str.yfilter != YFilter.not_set or
                                    self.asset_identification.yfilter != YFilter.not_set or
                                    self.ceport.yfilter != YFilter.not_set or
                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                    self.composite_class_code.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                    self.firmware_revision.yfilter != YFilter.not_set or
                                    self.group_flag.yfilter != YFilter.not_set or
                                    self.hardware_revision.yfilter != YFilter.not_set or
                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                    self.memory_size.yfilter != YFilter.not_set or
                                    self.model_name.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                    self.redundancystate.yfilter != YFilter.not_set or
                                    self.serial_number.yfilter != YFilter.not_set or
                                    self.software_revision.yfilter != YFilter.not_set or
                                    self.unique_id.yfilter != YFilter.not_set or
                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                    self.vendor_type.yfilter != YFilter.not_set or
                                    self.xr_scoped.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-basic-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())
                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "alias"):
                                    self.alias = value
                                    self.alias.value_namespace = name_space
                                    self.alias.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-id-str"):
                                    self.asset_id_str = value
                                    self.asset_id_str.value_namespace = name_space
                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-identification"):
                                    self.asset_identification = value
                                    self.asset_identification.value_namespace = name_space
                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                if(value_path == "ceport"):
                                    self.ceport = value
                                    self.ceport.value_namespace = name_space
                                    self.ceport.value_namespace_prefix = name_space_prefix
                                if(value_path == "chip-hardware-revision"):
                                    self.chip_hardware_revision = value
                                    self.chip_hardware_revision.value_namespace = name_space
                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "composite-class-code"):
                                    self.composite_class_code = value
                                    self.composite_class_code.value_namespace = name_space
                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "environmental-monitor-path"):
                                    self.environmental_monitor_path = value
                                    self.environmental_monitor_path.value_namespace = name_space
                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "firmware-revision"):
                                    self.firmware_revision = value
                                    self.firmware_revision.value_namespace = name_space
                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "group-flag"):
                                    self.group_flag = value
                                    self.group_flag.value_namespace = name_space
                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                if(value_path == "hardware-revision"):
                                    self.hardware_revision = value
                                    self.hardware_revision.value_namespace = name_space
                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-field-replaceable-unit"):
                                    self.is_field_replaceable_unit = value
                                    self.is_field_replaceable_unit.value_namespace = name_space
                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-asset-tags"):
                                    self.manufacturer_asset_tags = value
                                    self.manufacturer_asset_tags.value_namespace = name_space
                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-name"):
                                    self.manufacturer_name = value
                                    self.manufacturer_name.value_namespace = name_space
                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "memory-size"):
                                    self.memory_size = value
                                    self.memory_size.value_namespace = name_space
                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                if(value_path == "model-name"):
                                    self.model_name = value
                                    self.model_name.value_namespace = name_space
                                    self.model_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix
                                if(value_path == "new-deviation-number"):
                                    self.new_deviation_number = value
                                    self.new_deviation_number.value_namespace = name_space
                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "physical-layer-interface-module-type"):
                                    self.physical_layer_interface_module_type = value
                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "redundancystate"):
                                    self.redundancystate = value
                                    self.redundancystate.value_namespace = name_space
                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                if(value_path == "serial-number"):
                                    self.serial_number = value
                                    self.serial_number.value_namespace = name_space
                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "software-revision"):
                                    self.software_revision = value
                                    self.software_revision.value_namespace = name_space
                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "unique-id"):
                                    self.unique_id = value
                                    self.unique_id.value_namespace = name_space
                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "unrecognized-fru"):
                                    self.unrecognized_fru = value
                                    self.unrecognized_fru.value_namespace = name_space
                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                if(value_path == "vendor-type"):
                                    self.vendor_type = value
                                    self.vendor_type.value_namespace = name_space
                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "xr-scoped"):
                                    self.xr_scoped = value
                                    self.xr_scoped.value_namespace = name_space
                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                        class InvEepromInfo(Entity):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"

                                self.description = YLeaf(YType.str, "description")

                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._children_yang_names.add("eeprom")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("description",
                                                "has_eeprom",
                                                "inv_card_type",
                                                "opaque_data",
                                                "opaque_data_size") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)


                            class Eeprom(Entity):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"

                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                    self.block_count = YLeaf(YType.str, "block-count")

                                    self.block_length = YLeaf(YType.str, "block-length")

                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                    self.block_version = YLeaf(YType.str, "block-version")

                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                    self.clei = YLeaf(YType.str, "clei")

                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                    self.description = YLeaf(YType.str, "description")

                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                    self.eci = YLeaf(YType.str, "eci")

                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                    self.hwid = YLeaf(YType.str, "hwid")

                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                    self.part_number = YLeaf(YType.str, "part-number")

                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                    self.pid = YLeaf(YType.str, "pid")

                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                    self.product_id = YLeaf(YType.str, "product-id")

                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                    self.vid = YLeaf(YType.str, "vid")

                                    self.rma = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._children_yang_names.add("rma")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("asset_alias",
                                                    "asset_id",
                                                    "base_mac_address1",
                                                    "base_mac_address2",
                                                    "base_mac_address3",
                                                    "base_mac_address4",
                                                    "block_checksum",
                                                    "block_count",
                                                    "block_length",
                                                    "block_signature",
                                                    "block_version",
                                                    "chassis_sid",
                                                    "clei",
                                                    "controller_family",
                                                    "controller_type",
                                                    "description",
                                                    "dev_num1",
                                                    "dev_num2",
                                                    "dev_num3",
                                                    "dev_num4",
                                                    "dev_num5",
                                                    "dev_num6",
                                                    "dev_num7",
                                                    "eci",
                                                    "eeprom_size",
                                                    "engineer_use",
                                                    "fru_major_type",
                                                    "fru_minor_type",
                                                    "hw_version",
                                                    "hwid",
                                                    "idprom_format_rev",
                                                    "mac_add_blk_size1",
                                                    "mac_add_blk_size2",
                                                    "mac_add_blk_size3",
                                                    "mac_add_blk_size4",
                                                    "manu_test_data",
                                                    "mfg_bits",
                                                    "mfg_deviation",
                                                    "oem_string",
                                                    "part_number",
                                                    "part_revision",
                                                    "pca_num",
                                                    "pcavid",
                                                    "pcb_serial_num",
                                                    "pid",
                                                    "power_consumption",
                                                    "power_supply_type",
                                                    "product_id",
                                                    "rma_code",
                                                    "serial_number",
                                                    "snmpoid",
                                                    "top_assem_part_num",
                                                    "top_assem_vid",
                                                    "udi_description",
                                                    "udi_name",
                                                    "vid") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                class Rma(Entity):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"

                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                        self.test_history = YLeaf(YType.str, "test-history")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rma_history",
                                                        "rma_number",
                                                        "test_history") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.rma_history.is_set or
                                            self.rma_number.is_set or
                                            self.test_history.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rma_history.yfilter != YFilter.not_set or
                                            self.rma_number.yfilter != YFilter.not_set or
                                            self.test_history.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rma" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rma-history"):
                                            self.rma_history = value
                                            self.rma_history.value_namespace = name_space
                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rma-number"):
                                            self.rma_number = value
                                            self.rma_number.value_namespace = name_space
                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "test-history"):
                                            self.test_history = value
                                            self.test_history.value_namespace = name_space
                                            self.test_history.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.asset_alias.is_set or
                                        self.asset_id.is_set or
                                        self.base_mac_address1.is_set or
                                        self.base_mac_address2.is_set or
                                        self.base_mac_address3.is_set or
                                        self.base_mac_address4.is_set or
                                        self.block_checksum.is_set or
                                        self.block_count.is_set or
                                        self.block_length.is_set or
                                        self.block_signature.is_set or
                                        self.block_version.is_set or
                                        self.chassis_sid.is_set or
                                        self.clei.is_set or
                                        self.controller_family.is_set or
                                        self.controller_type.is_set or
                                        self.description.is_set or
                                        self.dev_num1.is_set or
                                        self.dev_num2.is_set or
                                        self.dev_num3.is_set or
                                        self.dev_num4.is_set or
                                        self.dev_num5.is_set or
                                        self.dev_num6.is_set or
                                        self.dev_num7.is_set or
                                        self.eci.is_set or
                                        self.eeprom_size.is_set or
                                        self.engineer_use.is_set or
                                        self.fru_major_type.is_set or
                                        self.fru_minor_type.is_set or
                                        self.hw_version.is_set or
                                        self.hwid.is_set or
                                        self.idprom_format_rev.is_set or
                                        self.mac_add_blk_size1.is_set or
                                        self.mac_add_blk_size2.is_set or
                                        self.mac_add_blk_size3.is_set or
                                        self.mac_add_blk_size4.is_set or
                                        self.manu_test_data.is_set or
                                        self.mfg_bits.is_set or
                                        self.mfg_deviation.is_set or
                                        self.oem_string.is_set or
                                        self.part_number.is_set or
                                        self.part_revision.is_set or
                                        self.pca_num.is_set or
                                        self.pcavid.is_set or
                                        self.pcb_serial_num.is_set or
                                        self.pid.is_set or
                                        self.power_consumption.is_set or
                                        self.power_supply_type.is_set or
                                        self.product_id.is_set or
                                        self.rma_code.is_set or
                                        self.serial_number.is_set or
                                        self.snmpoid.is_set or
                                        self.top_assem_part_num.is_set or
                                        self.top_assem_vid.is_set or
                                        self.udi_description.is_set or
                                        self.udi_name.is_set or
                                        self.vid.is_set or
                                        (self.rma is not None and self.rma.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.asset_alias.yfilter != YFilter.not_set or
                                        self.asset_id.yfilter != YFilter.not_set or
                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                        self.block_checksum.yfilter != YFilter.not_set or
                                        self.block_count.yfilter != YFilter.not_set or
                                        self.block_length.yfilter != YFilter.not_set or
                                        self.block_signature.yfilter != YFilter.not_set or
                                        self.block_version.yfilter != YFilter.not_set or
                                        self.chassis_sid.yfilter != YFilter.not_set or
                                        self.clei.yfilter != YFilter.not_set or
                                        self.controller_family.yfilter != YFilter.not_set or
                                        self.controller_type.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.dev_num1.yfilter != YFilter.not_set or
                                        self.dev_num2.yfilter != YFilter.not_set or
                                        self.dev_num3.yfilter != YFilter.not_set or
                                        self.dev_num4.yfilter != YFilter.not_set or
                                        self.dev_num5.yfilter != YFilter.not_set or
                                        self.dev_num6.yfilter != YFilter.not_set or
                                        self.dev_num7.yfilter != YFilter.not_set or
                                        self.eci.yfilter != YFilter.not_set or
                                        self.eeprom_size.yfilter != YFilter.not_set or
                                        self.engineer_use.yfilter != YFilter.not_set or
                                        self.fru_major_type.yfilter != YFilter.not_set or
                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                        self.hw_version.yfilter != YFilter.not_set or
                                        self.hwid.yfilter != YFilter.not_set or
                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                        self.manu_test_data.yfilter != YFilter.not_set or
                                        self.mfg_bits.yfilter != YFilter.not_set or
                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                        self.oem_string.yfilter != YFilter.not_set or
                                        self.part_number.yfilter != YFilter.not_set or
                                        self.part_revision.yfilter != YFilter.not_set or
                                        self.pca_num.yfilter != YFilter.not_set or
                                        self.pcavid.yfilter != YFilter.not_set or
                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                        self.pid.yfilter != YFilter.not_set or
                                        self.power_consumption.yfilter != YFilter.not_set or
                                        self.power_supply_type.yfilter != YFilter.not_set or
                                        self.product_id.yfilter != YFilter.not_set or
                                        self.rma_code.yfilter != YFilter.not_set or
                                        self.serial_number.yfilter != YFilter.not_set or
                                        self.snmpoid.yfilter != YFilter.not_set or
                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                        self.udi_description.yfilter != YFilter.not_set or
                                        self.udi_name.yfilter != YFilter.not_set or
                                        self.vid.yfilter != YFilter.not_set or
                                        (self.rma is not None and self.rma.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "eeprom" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rma"):
                                        if (self.rma is None):
                                            self.rma = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                        return self.rma

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "asset-alias"):
                                        self.asset_alias = value
                                        self.asset_alias.value_namespace = name_space
                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                    if(value_path == "asset-id"):
                                        self.asset_id = value
                                        self.asset_id.value_namespace = name_space
                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address1"):
                                        self.base_mac_address1 = value
                                        self.base_mac_address1.value_namespace = name_space
                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address2"):
                                        self.base_mac_address2 = value
                                        self.base_mac_address2.value_namespace = name_space
                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address3"):
                                        self.base_mac_address3 = value
                                        self.base_mac_address3.value_namespace = name_space
                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address4"):
                                        self.base_mac_address4 = value
                                        self.base_mac_address4.value_namespace = name_space
                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-checksum"):
                                        self.block_checksum = value
                                        self.block_checksum.value_namespace = name_space
                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-count"):
                                        self.block_count = value
                                        self.block_count.value_namespace = name_space
                                        self.block_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-length"):
                                        self.block_length = value
                                        self.block_length.value_namespace = name_space
                                        self.block_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-signature"):
                                        self.block_signature = value
                                        self.block_signature.value_namespace = name_space
                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-version"):
                                        self.block_version = value
                                        self.block_version.value_namespace = name_space
                                        self.block_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "chassis-sid"):
                                        self.chassis_sid = value
                                        self.chassis_sid.value_namespace = name_space
                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "clei"):
                                        self.clei = value
                                        self.clei.value_namespace = name_space
                                        self.clei.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-family"):
                                        self.controller_family = value
                                        self.controller_family.value_namespace = name_space
                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-type"):
                                        self.controller_type = value
                                        self.controller_type.value_namespace = name_space
                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num1"):
                                        self.dev_num1 = value
                                        self.dev_num1.value_namespace = name_space
                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num2"):
                                        self.dev_num2 = value
                                        self.dev_num2.value_namespace = name_space
                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num3"):
                                        self.dev_num3 = value
                                        self.dev_num3.value_namespace = name_space
                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num4"):
                                        self.dev_num4 = value
                                        self.dev_num4.value_namespace = name_space
                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num5"):
                                        self.dev_num5 = value
                                        self.dev_num5.value_namespace = name_space
                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num6"):
                                        self.dev_num6 = value
                                        self.dev_num6.value_namespace = name_space
                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num7"):
                                        self.dev_num7 = value
                                        self.dev_num7.value_namespace = name_space
                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eci"):
                                        self.eci = value
                                        self.eci.value_namespace = name_space
                                        self.eci.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eeprom-size"):
                                        self.eeprom_size = value
                                        self.eeprom_size.value_namespace = name_space
                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "engineer-use"):
                                        self.engineer_use = value
                                        self.engineer_use.value_namespace = name_space
                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-major-type"):
                                        self.fru_major_type = value
                                        self.fru_major_type.value_namespace = name_space
                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-minor-type"):
                                        self.fru_minor_type = value
                                        self.fru_minor_type.value_namespace = name_space
                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hw-version"):
                                        self.hw_version = value
                                        self.hw_version.value_namespace = name_space
                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hwid"):
                                        self.hwid = value
                                        self.hwid.value_namespace = name_space
                                        self.hwid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "idprom-format-rev"):
                                        self.idprom_format_rev = value
                                        self.idprom_format_rev.value_namespace = name_space
                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size1"):
                                        self.mac_add_blk_size1 = value
                                        self.mac_add_blk_size1.value_namespace = name_space
                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size2"):
                                        self.mac_add_blk_size2 = value
                                        self.mac_add_blk_size2.value_namespace = name_space
                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size3"):
                                        self.mac_add_blk_size3 = value
                                        self.mac_add_blk_size3.value_namespace = name_space
                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size4"):
                                        self.mac_add_blk_size4 = value
                                        self.mac_add_blk_size4.value_namespace = name_space
                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "manu-test-data"):
                                        self.manu_test_data = value
                                        self.manu_test_data.value_namespace = name_space
                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-bits"):
                                        self.mfg_bits = value
                                        self.mfg_bits.value_namespace = name_space
                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-deviation"):
                                        self.mfg_deviation = value
                                        self.mfg_deviation.value_namespace = name_space
                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "oem-string"):
                                        self.oem_string = value
                                        self.oem_string.value_namespace = name_space
                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-number"):
                                        self.part_number = value
                                        self.part_number.value_namespace = name_space
                                        self.part_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-revision"):
                                        self.part_revision = value
                                        self.part_revision.value_namespace = name_space
                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pca-num"):
                                        self.pca_num = value
                                        self.pca_num.value_namespace = name_space
                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcavid"):
                                        self.pcavid = value
                                        self.pcavid.value_namespace = name_space
                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcb-serial-num"):
                                        self.pcb_serial_num = value
                                        self.pcb_serial_num.value_namespace = name_space
                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pid"):
                                        self.pid = value
                                        self.pid.value_namespace = name_space
                                        self.pid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-consumption"):
                                        self.power_consumption = value
                                        self.power_consumption.value_namespace = name_space
                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-supply-type"):
                                        self.power_supply_type = value
                                        self.power_supply_type.value_namespace = name_space
                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "product-id"):
                                        self.product_id = value
                                        self.product_id.value_namespace = name_space
                                        self.product_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rma-code"):
                                        self.rma_code = value
                                        self.rma_code.value_namespace = name_space
                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "serial-number"):
                                        self.serial_number = value
                                        self.serial_number.value_namespace = name_space
                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "snmpoid"):
                                        self.snmpoid = value
                                        self.snmpoid.value_namespace = name_space
                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-part-num"):
                                        self.top_assem_part_num = value
                                        self.top_assem_part_num.value_namespace = name_space
                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-vid"):
                                        self.top_assem_vid = value
                                        self.top_assem_vid.value_namespace = name_space
                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-description"):
                                        self.udi_description = value
                                        self.udi_description.value_namespace = name_space
                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-name"):
                                        self.udi_name = value
                                        self.udi_name.value_namespace = name_space
                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vid"):
                                        self.vid = value
                                        self.vid.value_namespace = name_space
                                        self.vid.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.description.is_set or
                                    self.has_eeprom.is_set or
                                    self.inv_card_type.is_set or
                                    self.opaque_data.is_set or
                                    self.opaque_data_size.is_set or
                                    (self.eeprom is not None and self.eeprom.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.has_eeprom.yfilter != YFilter.not_set or
                                    self.inv_card_type.yfilter != YFilter.not_set or
                                    self.opaque_data.yfilter != YFilter.not_set or
                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                    (self.eeprom is not None and self.eeprom.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-eeprom-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "eeprom"):
                                    if (self.eeprom is None):
                                        self.eeprom = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                    return self.eeprom

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-eeprom"):
                                    self.has_eeprom = value
                                    self.has_eeprom.value_namespace = name_space
                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                if(value_path == "inv-card-type"):
                                    self.inv_card_type = value
                                    self.inv_card_type.value_namespace = name_space
                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data"):
                                    self.opaque_data = value
                                    self.opaque_data.value_namespace = name_space
                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data-size"):
                                    self.opaque_data_size = value
                                    self.opaque_data_size.value_namespace = name_space
                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.module_done.is_set or
                                self.node_id.is_set or
                                self.vm_done.is_set or
                                self.vm_node_id.is_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                (self.fru_info is not None and self.fru_info.has_data()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                (self.threshold is not None and self.threshold.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.module_done.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.vm_done.yfilter != YFilter.not_set or
                                self.vm_node_id.yfilter != YFilter.not_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                (self.threshold is not None and self.threshold.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attributes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.module_done.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "env-sensor-info"):
                                if (self.env_sensor_info is None):
                                    self.env_sensor_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                return self.env_sensor_info

                            if (child_yang_name == "env-sensor-info-xml"):
                                if (self.env_sensor_info_xml is None):
                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Entity_.Slot.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                return self.env_sensor_info_xml

                            if (child_yang_name == "fru-info"):
                                if (self.fru_info is None):
                                    self.fru_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                return self.fru_info

                            if (child_yang_name == "inv-asset-bag"):
                                if (self.inv_asset_bag is None):
                                    self.inv_asset_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                return self.inv_asset_bag

                            if (child_yang_name == "inv-basic-bag"):
                                if (self.inv_basic_bag is None):
                                    self.inv_basic_bag = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                return self.inv_basic_bag

                            if (child_yang_name == "inv-eeprom-info"):
                                if (self.inv_eeprom_info is None):
                                    self.inv_eeprom_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                return self.inv_eeprom_info

                            if (child_yang_name == "pwg-info"):
                                if (self.pwg_info is None):
                                    self.pwg_info = Inventory.Racks.Rack.Entity_.Slot.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                return self.pwg_info

                            if (child_yang_name == "threshold"):
                                if (self.threshold is None):
                                    self.threshold = Inventory.Racks.Rack.Entity_.Slot.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                return self.threshold

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "module-done"):
                                self.module_done = value
                                self.module_done.value_namespace = name_space
                                self.module_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-done"):
                                self.vm_done = value
                                self.vm_done.value_namespace = name_space
                                self.vm_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-node-id"):
                                self.vm_node_id = value
                                self.vm_node_id.value_namespace = name_space
                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.name.is_set or
                            (self.attributes is not None and self.attributes.has_data()) or
                            (self.tsi1s is not None and self.tsi1s.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            (self.attributes is not None and self.attributes.has_operation()) or
                            (self.tsi1s is not None and self.tsi1s.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slot" + "[name='" + self.name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attributes"):
                            if (self.attributes is None):
                                self.attributes = Inventory.Racks.Rack.Entity_.Slot.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                            return self.attributes

                        if (child_yang_name == "tsi1s"):
                            if (self.tsi1s is None):
                                self.tsi1s = Inventory.Racks.Rack.Entity_.Slot.Tsi1S()
                                self.tsi1s.parent = self
                                self._children_name_map["tsi1s"] = "tsi1s"
                            return self.tsi1s

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attributes" or name == "tsi1s" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.slot:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.slot:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "entity" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "slot"):
                        for c in self.slot:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Inventory.Racks.Rack.Entity_.Slot()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.slot.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "slot"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Powershelf(Entity):
                """
                Powershelf information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of    :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot>`
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Racks.Rack.Powershelf, self).__init__()

                    self.yang_name = "powershelf"
                    self.yang_parent_name = "rack"

                    self.slot = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Inventory.Racks.Rack.Powershelf, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Inventory.Racks.Rack.Powershelf, self).__setattr__(name, value)


                class Slot(Entity):
                    """
                    Slot number
                    
                    .. attribute:: name  <key>
                    
                    	Slot name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes>`
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:   :py:class:`Tsi1S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S>`
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Powershelf.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "powershelf"

                        self.name = YLeaf(YType.str, "name")

                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._children_yang_names.add("attributes")

                        self.tsi1s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"
                        self._children_yang_names.add("tsi1s")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Powershelf.Slot, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Powershelf.Slot, self).__setattr__(name, value)


                    class Tsi1S(Entity):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of    :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"

                            self.tsi1 = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S, self).__setattr__(name, value)


                        class Tsi1(Entity):
                            """
                            TSI1
                            
                            .. attribute:: name  <key>
                            
                            	TSI1
                            	**type**\:  str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes>`
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:   :py:class:`Tsi2S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"

                                self.name = YLeaf(YType.str, "name")

                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._children_yang_names.add("attributes")

                                self.tsi2s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"
                                self._children_yang_names.add("tsi2s")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)


                            class Tsi2S(Entity):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of    :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"

                                    self.tsi2 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)


                                class Tsi2(Entity):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  <key>
                                    
                                    	TSI2
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes>`
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:   :py:class:`Tsi3S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"

                                        self.name = YLeaf(YType.str, "name")

                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._children_yang_names.add("attributes")

                                        self.tsi3s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"
                                        self._children_yang_names.add("tsi3s")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)


                                    class Tsi3S(Entity):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of    :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"

                                            self.tsi3 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)


                                        class Tsi3(Entity):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  <key>
                                            
                                            	TSI3
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes>`
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:   :py:class:`Tsi4S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"

                                                self.name = YLeaf(YType.str, "name")

                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._children_yang_names.add("attributes")

                                                self.tsi4s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"
                                                self._children_yang_names.add("tsi4s")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)


                                            class Tsi4S(Entity):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of    :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"

                                                    self.tsi4 = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)


                                                class Tsi4(Entity):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  <key>
                                                    
                                                    	TSI4
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes>`
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:   :py:class:`Tsi5S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._children_yang_names.add("attributes")

                                                        self.tsi5s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"
                                                        self._children_yang_names.add("tsi5s")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)


                                                    class Tsi5S(Entity):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of    :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"

                                                            self.tsi5 = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)


                                                        class Tsi5(Entity):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  <key>
                                                            
                                                            	TSI5
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes>`
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:   :py:class:`Tsi6S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._children_yang_names.add("attributes")

                                                                self.tsi6s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"
                                                                self._children_yang_names.add("tsi6s")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("name") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)


                                                            class Tsi6S(Entity):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of    :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.tsi6 = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)


                                                                class Tsi6(Entity):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  <key>
                                                                    
                                                                    	TSI6
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes>`
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:   :py:class:`Tsi7S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._children_yang_names.add("attributes")

                                                                        self.tsi7s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"
                                                                        self._children_yang_names.add("tsi7s")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("name") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)


                                                                    class Tsi7S(Entity):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of    :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.tsi7 = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)


                                                                        class Tsi7(Entity):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  <key>
                                                                            
                                                                            	TSI7
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes>`
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:   :py:class:`Tsi8S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._children_yang_names.add("attributes")

                                                                                self.tsi8s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"
                                                                                self._children_yang_names.add("tsi8s")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("name") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)


                                                                            class Tsi8S(Entity):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of    :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.tsi8 = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)


                                                                                class Tsi8(Entity):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  <key>
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes>`
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:   :py:class:`Tsi9S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._children_yang_names.add("attributes")

                                                                                        self.tsi9s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"
                                                                                        self._children_yang_names.add("tsi9s")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)


                                                                                    class Tsi9S(Entity):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of    :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.tsi9 = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)


                                                                                        class Tsi9(Entity):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  <key>
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes>`
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:   :py:class:`Tsi10S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._children_yang_names.add("attributes")

                                                                                                self.tsi10s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                self._children_yang_names.add("tsi10s")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)


                                                                                            class Tsi10S(Entity):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of    :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.tsi10 = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)


                                                                                                class Tsi10(Entity):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  <key>
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes>`
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:   :py:class:`Tsi11S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._children_yang_names.add("attributes")

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                        self._children_yang_names.add("tsi11s")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)


                                                                                                    class Tsi11S(Entity):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of    :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.tsi11 = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)


                                                                                                        class Tsi11(Entity):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  <key>
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._children_yang_names.add("attributes")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)


                                                                                                            class Attributes(Entity):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                .. attribute:: module_done
                                                                                                                
                                                                                                                	Inventory EDM Module Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**default value**\: 1
                                                                                                                
                                                                                                                .. attribute:: node_id
                                                                                                                
                                                                                                                	Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                .. attribute:: vm_done
                                                                                                                
                                                                                                                	VM Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                .. attribute:: vm_node_id
                                                                                                                
                                                                                                                	VM Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"

                                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                    self._children_yang_names.add("threshold")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("module_done",
                                                                                                                                    "node_id",
                                                                                                                                    "vm_done",
                                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)


                                                                                                                class EnvSensorInfo(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("age_time_stamp",
                                                                                                                                        "alarm_type",
                                                                                                                                        "data_type",
                                                                                                                                        "device_description",
                                                                                                                                        "device_id",
                                                                                                                                        "field_validity_bitmap",
                                                                                                                                        "precision",
                                                                                                                                        "scale",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.age_time_stamp.is_set or
                                                                                                                            self.alarm_type.is_set or
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.device_description.is_set or
                                                                                                                            self.device_id.is_set or
                                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                                            self.precision.is_set or
                                                                                                                            self.scale.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                                            self.age_time_stamp = value
                                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "alarm-type"):
                                                                                                                            self.alarm_type = value
                                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-description"):
                                                                                                                            self.device_description = value
                                                                                                                            self.device_description.value_namespace = name_space
                                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-id"):
                                                                                                                            self.device_id = value
                                                                                                                            self.device_id.value_namespace = name_space
                                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                                            self.field_validity_bitmap = value
                                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "precision"):
                                                                                                                            self.precision = value
                                                                                                                            self.precision.value_namespace = name_space
                                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "scale"):
                                                                                                                            self.scale = value
                                                                                                                            self.scale.value_namespace = name_space
                                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class PwgInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("power_group_available_current",
                                                                                                                                        "power_group_drawn_current",
                                                                                                                                        "power_group_power_units",
                                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.power_group_available_current.is_set or
                                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                                            self.power_group_power_units.is_set or
                                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                                            self.power_group_available_current = value
                                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                                            self.power_group_drawn_current = value
                                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                                            self.power_group_power_units = value
                                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                                            self.power_group_redundancy_mode = value
                                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._children_yang_names.add("threshold")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("data_type",
                                                                                                                                        "description",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                                    class Threshold(Entity):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                            self.threshold_array = YList(self)

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in () and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                        class ThresholdArray(Entity):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_name",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_name.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-name"):
                                                                                                                                    self.threshold_name = value
                                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_data()):
                                                                                                                                    return True
                                                                                                                            return False

                                                                                                                        def has_operation(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_operation()):
                                                                                                                                    return True
                                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                                for c in self.threshold_array:
                                                                                                                                    segment = c.get_segment_path()
                                                                                                                                    if (segment_path == segment):
                                                                                                                                        return c
                                                                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                                c.parent = self
                                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                                self.threshold_array.append(c)
                                                                                                                                return c

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "threshold-array"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "threshold"):
                                                                                                                            if (self.threshold is None):
                                                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                                self.threshold.parent = self
                                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                            return self.threshold

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class InvAssetBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                                        "manufacturer_software_identifier",
                                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                                            self.part_number.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                                            self.manufacturer_assembly_number = value
                                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                                            self.manufacturer_software_identifier = value
                                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "part-number"):
                                                                                                                            self.part_number = value
                                                                                                                            self.part_number.value_namespace = name_space
                                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                                class Threshold(Entity):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                                    class MajorLo(Entity):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalHi(Entity):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorHi(Entity):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MajorHi(Entity):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalLo(Entity):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorLo(Entity):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                                            if (self.critical_hi is None):
                                                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                                self.critical_hi.parent = self
                                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                            return self.critical_hi

                                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                                            if (self.critical_lo is None):
                                                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                                self.critical_lo.parent = self
                                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                            return self.critical_lo

                                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                                            if (self.major_hi is None):
                                                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                                self.major_hi.parent = self
                                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                            return self.major_hi

                                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                                            if (self.major_lo is None):
                                                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                                self.major_lo.parent = self
                                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                            return self.major_lo

                                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                                            if (self.minor_hi is None):
                                                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                                self.minor_hi.parent = self
                                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                            return self.minor_hi

                                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                                            if (self.minor_lo is None):
                                                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                                self.minor_lo.parent = self
                                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                            return self.minor_lo

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        pass


                                                                                                                class FruInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("card_administrative_state",
                                                                                                                                        "card_monitor_state",
                                                                                                                                        "card_operational_state",
                                                                                                                                        "card_reset_reason",
                                                                                                                                        "power_administrative_state",
                                                                                                                                        "power_current_measurement",
                                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                                    class CardUpTime(Entity):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.card_administrative_state.is_set or
                                                                                                                            self.card_monitor_state.is_set or
                                                                                                                            self.card_operational_state.is_set or
                                                                                                                            self.card_reset_reason.is_set or
                                                                                                                            self.power_administrative_state.is_set or
                                                                                                                            self.power_current_measurement.is_set or
                                                                                                                            self.power_operational_state.is_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                                            if (self.card_up_time is None):
                                                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                                self.card_up_time.parent = self
                                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                            return self.card_up_time

                                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                            return self.last_operational_state_change

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                                            self.card_administrative_state = value
                                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                                            self.card_monitor_state = value
                                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-operational-state"):
                                                                                                                            self.card_operational_state = value
                                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                                            self.card_reset_reason = value
                                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                                            self.power_administrative_state = value
                                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                                            self.power_current_measurement = value
                                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-operational-state"):
                                                                                                                            self.power_operational_state = value
                                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                                class InvBasicBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("alias",
                                                                                                                                        "asset_id_str",
                                                                                                                                        "asset_identification",
                                                                                                                                        "ceport",
                                                                                                                                        "chip_hardware_revision",
                                                                                                                                        "composite_class_code",
                                                                                                                                        "description",
                                                                                                                                        "environmental_monitor_path",
                                                                                                                                        "firmware_revision",
                                                                                                                                        "group_flag",
                                                                                                                                        "hardware_revision",
                                                                                                                                        "is_field_replaceable_unit",
                                                                                                                                        "manufacturer_asset_tags",
                                                                                                                                        "manufacturer_name",
                                                                                                                                        "memory_size",
                                                                                                                                        "model_name",
                                                                                                                                        "name",
                                                                                                                                        "new_deviation_number",
                                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                                        "redundancystate",
                                                                                                                                        "serial_number",
                                                                                                                                        "software_revision",
                                                                                                                                        "unique_id",
                                                                                                                                        "unrecognized_fru",
                                                                                                                                        "vendor_type",
                                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.alias.is_set or
                                                                                                                            self.asset_id_str.is_set or
                                                                                                                            self.asset_identification.is_set or
                                                                                                                            self.ceport.is_set or
                                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                                            self.composite_class_code.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                                            self.firmware_revision.is_set or
                                                                                                                            self.group_flag.is_set or
                                                                                                                            self.hardware_revision.is_set or
                                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                                            self.manufacturer_name.is_set or
                                                                                                                            self.memory_size.is_set or
                                                                                                                            self.model_name.is_set or
                                                                                                                            self.name.is_set or
                                                                                                                            self.new_deviation_number.is_set or
                                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                                            self.redundancystate.is_set or
                                                                                                                            self.serial_number.is_set or
                                                                                                                            self.software_revision.is_set or
                                                                                                                            self.unique_id.is_set or
                                                                                                                            self.unrecognized_fru.is_set or
                                                                                                                            self.vendor_type.is_set or
                                                                                                                            self.xr_scoped.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "alias"):
                                                                                                                            self.alias = value
                                                                                                                            self.alias.value_namespace = name_space
                                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-id-str"):
                                                                                                                            self.asset_id_str = value
                                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-identification"):
                                                                                                                            self.asset_identification = value
                                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "ceport"):
                                                                                                                            self.ceport = value
                                                                                                                            self.ceport.value_namespace = name_space
                                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                                            self.chip_hardware_revision = value
                                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "composite-class-code"):
                                                                                                                            self.composite_class_code = value
                                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                                            self.environmental_monitor_path = value
                                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "firmware-revision"):
                                                                                                                            self.firmware_revision = value
                                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "group-flag"):
                                                                                                                            self.group_flag = value
                                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "hardware-revision"):
                                                                                                                            self.hardware_revision = value
                                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                                            self.is_field_replaceable_unit = value
                                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                                            self.manufacturer_asset_tags = value
                                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                                            self.manufacturer_name = value
                                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "memory-size"):
                                                                                                                            self.memory_size = value
                                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "model-name"):
                                                                                                                            self.model_name = value
                                                                                                                            self.model_name.value_namespace = name_space
                                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "name"):
                                                                                                                            self.name = value
                                                                                                                            self.name.value_namespace = name_space
                                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                                            self.new_deviation_number = value
                                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "redundancystate"):
                                                                                                                            self.redundancystate = value
                                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "serial-number"):
                                                                                                                            self.serial_number = value
                                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "software-revision"):
                                                                                                                            self.software_revision = value
                                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unique-id"):
                                                                                                                            self.unique_id = value
                                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                                            self.unrecognized_fru = value
                                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "vendor-type"):
                                                                                                                            self.vendor_type = value
                                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "xr-scoped"):
                                                                                                                            self.xr_scoped = value
                                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                                class InvEepromInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("description",
                                                                                                                                        "has_eeprom",
                                                                                                                                        "inv_card_type",
                                                                                                                                        "opaque_data",
                                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                                    class Eeprom(Entity):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._children_yang_names.add("rma")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("asset_alias",
                                                                                                                                            "asset_id",
                                                                                                                                            "base_mac_address1",
                                                                                                                                            "base_mac_address2",
                                                                                                                                            "base_mac_address3",
                                                                                                                                            "base_mac_address4",
                                                                                                                                            "block_checksum",
                                                                                                                                            "block_count",
                                                                                                                                            "block_length",
                                                                                                                                            "block_signature",
                                                                                                                                            "block_version",
                                                                                                                                            "chassis_sid",
                                                                                                                                            "clei",
                                                                                                                                            "controller_family",
                                                                                                                                            "controller_type",
                                                                                                                                            "description",
                                                                                                                                            "dev_num1",
                                                                                                                                            "dev_num2",
                                                                                                                                            "dev_num3",
                                                                                                                                            "dev_num4",
                                                                                                                                            "dev_num5",
                                                                                                                                            "dev_num6",
                                                                                                                                            "dev_num7",
                                                                                                                                            "eci",
                                                                                                                                            "eeprom_size",
                                                                                                                                            "engineer_use",
                                                                                                                                            "fru_major_type",
                                                                                                                                            "fru_minor_type",
                                                                                                                                            "hw_version",
                                                                                                                                            "hwid",
                                                                                                                                            "idprom_format_rev",
                                                                                                                                            "mac_add_blk_size1",
                                                                                                                                            "mac_add_blk_size2",
                                                                                                                                            "mac_add_blk_size3",
                                                                                                                                            "mac_add_blk_size4",
                                                                                                                                            "manu_test_data",
                                                                                                                                            "mfg_bits",
                                                                                                                                            "mfg_deviation",
                                                                                                                                            "oem_string",
                                                                                                                                            "part_number",
                                                                                                                                            "part_revision",
                                                                                                                                            "pca_num",
                                                                                                                                            "pcavid",
                                                                                                                                            "pcb_serial_num",
                                                                                                                                            "pid",
                                                                                                                                            "power_consumption",
                                                                                                                                            "power_supply_type",
                                                                                                                                            "product_id",
                                                                                                                                            "rma_code",
                                                                                                                                            "serial_number",
                                                                                                                                            "snmpoid",
                                                                                                                                            "top_assem_part_num",
                                                                                                                                            "top_assem_vid",
                                                                                                                                            "udi_description",
                                                                                                                                            "udi_name",
                                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                        class Rma(Entity):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("rma_history",
                                                                                                                                                "rma_number",
                                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.rma_history.is_set or
                                                                                                                                    self.rma_number.is_set or
                                                                                                                                    self.test_history.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "rma-history"):
                                                                                                                                    self.rma_history = value
                                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "rma-number"):
                                                                                                                                    self.rma_number = value
                                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "test-history"):
                                                                                                                                    self.test_history = value
                                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.asset_alias.is_set or
                                                                                                                                self.asset_id.is_set or
                                                                                                                                self.base_mac_address1.is_set or
                                                                                                                                self.base_mac_address2.is_set or
                                                                                                                                self.base_mac_address3.is_set or
                                                                                                                                self.base_mac_address4.is_set or
                                                                                                                                self.block_checksum.is_set or
                                                                                                                                self.block_count.is_set or
                                                                                                                                self.block_length.is_set or
                                                                                                                                self.block_signature.is_set or
                                                                                                                                self.block_version.is_set or
                                                                                                                                self.chassis_sid.is_set or
                                                                                                                                self.clei.is_set or
                                                                                                                                self.controller_family.is_set or
                                                                                                                                self.controller_type.is_set or
                                                                                                                                self.description.is_set or
                                                                                                                                self.dev_num1.is_set or
                                                                                                                                self.dev_num2.is_set or
                                                                                                                                self.dev_num3.is_set or
                                                                                                                                self.dev_num4.is_set or
                                                                                                                                self.dev_num5.is_set or
                                                                                                                                self.dev_num6.is_set or
                                                                                                                                self.dev_num7.is_set or
                                                                                                                                self.eci.is_set or
                                                                                                                                self.eeprom_size.is_set or
                                                                                                                                self.engineer_use.is_set or
                                                                                                                                self.fru_major_type.is_set or
                                                                                                                                self.fru_minor_type.is_set or
                                                                                                                                self.hw_version.is_set or
                                                                                                                                self.hwid.is_set or
                                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                                self.manu_test_data.is_set or
                                                                                                                                self.mfg_bits.is_set or
                                                                                                                                self.mfg_deviation.is_set or
                                                                                                                                self.oem_string.is_set or
                                                                                                                                self.part_number.is_set or
                                                                                                                                self.part_revision.is_set or
                                                                                                                                self.pca_num.is_set or
                                                                                                                                self.pcavid.is_set or
                                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                                self.pid.is_set or
                                                                                                                                self.power_consumption.is_set or
                                                                                                                                self.power_supply_type.is_set or
                                                                                                                                self.product_id.is_set or
                                                                                                                                self.rma_code.is_set or
                                                                                                                                self.serial_number.is_set or
                                                                                                                                self.snmpoid.is_set or
                                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                                self.top_assem_vid.is_set or
                                                                                                                                self.udi_description.is_set or
                                                                                                                                self.udi_name.is_set or
                                                                                                                                self.vid.is_set or
                                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "rma"):
                                                                                                                                if (self.rma is None):
                                                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                                    self.rma.parent = self
                                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                                return self.rma

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "asset-alias"):
                                                                                                                                self.asset_alias = value
                                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "asset-id"):
                                                                                                                                self.asset_id = value
                                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                                self.base_mac_address1 = value
                                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                                self.base_mac_address2 = value
                                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                                self.base_mac_address3 = value
                                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                                self.base_mac_address4 = value
                                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-checksum"):
                                                                                                                                self.block_checksum = value
                                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-count"):
                                                                                                                                self.block_count = value
                                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-length"):
                                                                                                                                self.block_length = value
                                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-signature"):
                                                                                                                                self.block_signature = value
                                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-version"):
                                                                                                                                self.block_version = value
                                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                                self.chassis_sid = value
                                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "clei"):
                                                                                                                                self.clei = value
                                                                                                                                self.clei.value_namespace = name_space
                                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-family"):
                                                                                                                                self.controller_family = value
                                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-type"):
                                                                                                                                self.controller_type = value
                                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "description"):
                                                                                                                                self.description = value
                                                                                                                                self.description.value_namespace = name_space
                                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num1"):
                                                                                                                                self.dev_num1 = value
                                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num2"):
                                                                                                                                self.dev_num2 = value
                                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num3"):
                                                                                                                                self.dev_num3 = value
                                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num4"):
                                                                                                                                self.dev_num4 = value
                                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num5"):
                                                                                                                                self.dev_num5 = value
                                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num6"):
                                                                                                                                self.dev_num6 = value
                                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num7"):
                                                                                                                                self.dev_num7 = value
                                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eci"):
                                                                                                                                self.eci = value
                                                                                                                                self.eci.value_namespace = name_space
                                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                                self.eeprom_size = value
                                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "engineer-use"):
                                                                                                                                self.engineer_use = value
                                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                                self.fru_major_type = value
                                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                                self.fru_minor_type = value
                                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hw-version"):
                                                                                                                                self.hw_version = value
                                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hwid"):
                                                                                                                                self.hwid = value
                                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                                self.idprom_format_rev = value
                                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                                self.manu_test_data = value
                                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                                self.mfg_bits = value
                                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                                self.mfg_deviation = value
                                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "oem-string"):
                                                                                                                                self.oem_string = value
                                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-number"):
                                                                                                                                self.part_number = value
                                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-revision"):
                                                                                                                                self.part_revision = value
                                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pca-num"):
                                                                                                                                self.pca_num = value
                                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcavid"):
                                                                                                                                self.pcavid = value
                                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                                self.pcb_serial_num = value
                                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pid"):
                                                                                                                                self.pid = value
                                                                                                                                self.pid.value_namespace = name_space
                                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-consumption"):
                                                                                                                                self.power_consumption = value
                                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                                self.power_supply_type = value
                                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "product-id"):
                                                                                                                                self.product_id = value
                                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "rma-code"):
                                                                                                                                self.rma_code = value
                                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "serial-number"):
                                                                                                                                self.serial_number = value
                                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "snmpoid"):
                                                                                                                                self.snmpoid = value
                                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                                self.top_assem_part_num = value
                                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                                self.top_assem_vid = value
                                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-description"):
                                                                                                                                self.udi_description = value
                                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-name"):
                                                                                                                                self.udi_name = value
                                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "vid"):
                                                                                                                                self.vid = value
                                                                                                                                self.vid.value_namespace = name_space
                                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.description.is_set or
                                                                                                                            self.has_eeprom.is_set or
                                                                                                                            self.inv_card_type.is_set or
                                                                                                                            self.opaque_data.is_set or
                                                                                                                            self.opaque_data_size.is_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                                            if (self.eeprom is None):
                                                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                                self.eeprom.parent = self
                                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                            return self.eeprom

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "has-eeprom"):
                                                                                                                            self.has_eeprom = value
                                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "inv-card-type"):
                                                                                                                            self.inv_card_type = value
                                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data"):
                                                                                                                            self.opaque_data = value
                                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                                            self.opaque_data_size = value
                                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.module_done.is_set or
                                                                                                                        self.node_id.is_set or
                                                                                                                        self.vm_done.is_set or
                                                                                                                        self.vm_node_id.is_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                                        if (self.env_sensor_info is None):
                                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                            self.env_sensor_info.parent = self
                                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                        return self.env_sensor_info

                                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                        return self.env_sensor_info_xml

                                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                                        if (self.fru_info is None):
                                                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                            self.fru_info.parent = self
                                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                                        return self.fru_info

                                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                                        if (self.inv_asset_bag is None):
                                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                            self.inv_asset_bag.parent = self
                                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                        return self.inv_asset_bag

                                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                                        if (self.inv_basic_bag is None):
                                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                            self.inv_basic_bag.parent = self
                                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                        return self.inv_basic_bag

                                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                        return self.inv_eeprom_info

                                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                                        if (self.pwg_info is None):
                                                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                            self.pwg_info.parent = self
                                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                        return self.pwg_info

                                                                                                                    if (child_yang_name == "threshold"):
                                                                                                                        if (self.threshold is None):
                                                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                            self.threshold.parent = self
                                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                                        return self.threshold

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "module-done"):
                                                                                                                        self.module_done = value
                                                                                                                        self.module_done.value_namespace = name_space
                                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "node-id"):
                                                                                                                        self.node_id = value
                                                                                                                        self.node_id.value_namespace = name_space
                                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-done"):
                                                                                                                        self.vm_done = value
                                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-node-id"):
                                                                                                                        self.vm_node_id = value
                                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.name.is_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "tsi11" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "attributes"):
                                                                                                                    if (self.attributes is None):
                                                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                        self.attributes.parent = self
                                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                                    return self.attributes

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "attributes" or name == "name"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "tsi11s" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "tsi11"):
                                                                                                                for c in self.tsi11:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.tsi11.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "tsi11"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class Attributes(Entity):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        .. attribute:: module_done
                                                                                                        
                                                                                                        	Inventory EDM Module Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**default value**\: 1
                                                                                                        
                                                                                                        .. attribute:: node_id
                                                                                                        
                                                                                                        	Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        .. attribute:: vm_done
                                                                                                        
                                                                                                        	VM Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        .. attribute:: vm_node_id
                                                                                                        
                                                                                                        	VM Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                            self._children_yang_names.add("fru-info")

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                            self._children_yang_names.add("pwg-info")

                                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                            self._children_yang_names.add("threshold")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("module_done",
                                                                                                                            "node_id",
                                                                                                                            "vm_done",
                                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)


                                                                                                        class EnvSensorInfo(Entity):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("age_time_stamp",
                                                                                                                                "alarm_type",
                                                                                                                                "data_type",
                                                                                                                                "device_description",
                                                                                                                                "device_id",
                                                                                                                                "field_validity_bitmap",
                                                                                                                                "precision",
                                                                                                                                "scale",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.age_time_stamp.is_set or
                                                                                                                    self.alarm_type.is_set or
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.device_description.is_set or
                                                                                                                    self.device_id.is_set or
                                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                                    self.precision.is_set or
                                                                                                                    self.scale.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "age-time-stamp"):
                                                                                                                    self.age_time_stamp = value
                                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "alarm-type"):
                                                                                                                    self.alarm_type = value
                                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-description"):
                                                                                                                    self.device_description = value
                                                                                                                    self.device_description.value_namespace = name_space
                                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-id"):
                                                                                                                    self.device_id = value
                                                                                                                    self.device_id.value_namespace = name_space
                                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                                    self.field_validity_bitmap = value
                                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "precision"):
                                                                                                                    self.precision = value
                                                                                                                    self.precision.value_namespace = name_space
                                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "scale"):
                                                                                                                    self.scale = value
                                                                                                                    self.scale.value_namespace = name_space
                                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class PwgInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("power_group_available_current",
                                                                                                                                "power_group_drawn_current",
                                                                                                                                "power_group_power_units",
                                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.power_group_available_current.is_set or
                                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                                    self.power_group_power_units.is_set or
                                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "power-group-available-current"):
                                                                                                                    self.power_group_available_current = value
                                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                                    self.power_group_drawn_current = value
                                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-power-units"):
                                                                                                                    self.power_group_power_units = value
                                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                                    self.power_group_redundancy_mode = value
                                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                        class EnvSensorInfoXml(Entity):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._children_yang_names.add("threshold")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("data_type",
                                                                                                                                "description",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                            class Threshold(Entity):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                    self.threshold_array = YList(self)

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in () and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                class ThresholdArray(Entity):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"

                                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_name",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_name.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-name"):
                                                                                                                            self.threshold_name = value
                                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_data()):
                                                                                                                            return True
                                                                                                                    return False

                                                                                                                def has_operation(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_operation()):
                                                                                                                            return True
                                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                                        for c in self.threshold_array:
                                                                                                                            segment = c.get_segment_path()
                                                                                                                            if (segment_path == segment):
                                                                                                                                return c
                                                                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                        c.parent = self
                                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                                        self.threshold_array.append(c)
                                                                                                                        return c

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "threshold-array"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "threshold"):
                                                                                                                    if (self.threshold is None):
                                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                    return self.threshold

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class InvAssetBag(Entity):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                                "manufacturer_assembly_revision",
                                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                                "manufacturer_software_identifier",
                                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                                "part_number") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                                    self.part_number.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                                    self.manufacturer_assembly_number = value
                                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                                    self.manufacturer_software_identifier = value
                                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "part-number"):
                                                                                                                    self.part_number = value
                                                                                                                    self.part_number.value_namespace = name_space
                                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                        class Threshold(Entity):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                self._children_yang_names.add("major-hi")

                                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                self._children_yang_names.add("major-lo")

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._children_yang_names.add("minor-lo")


                                                                                                            class MajorLo(Entity):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalHi(Entity):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorHi(Entity):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MajorHi(Entity):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalLo(Entity):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorLo(Entity):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                                    if (self.critical_hi is None):
                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                    return self.critical_hi

                                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                                    if (self.critical_lo is None):
                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                    return self.critical_lo

                                                                                                                if (child_yang_name == "major-hi"):
                                                                                                                    if (self.major_hi is None):
                                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                    return self.major_hi

                                                                                                                if (child_yang_name == "major-lo"):
                                                                                                                    if (self.major_lo is None):
                                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                    return self.major_lo

                                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                                    if (self.minor_hi is None):
                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                    return self.minor_hi

                                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                                    if (self.minor_lo is None):
                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                    return self.minor_lo

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                pass


                                                                                                        class FruInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("card_administrative_state",
                                                                                                                                "card_monitor_state",
                                                                                                                                "card_operational_state",
                                                                                                                                "card_reset_reason",
                                                                                                                                "power_administrative_state",
                                                                                                                                "power_current_measurement",
                                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                            class LastOperationalStateChange(Entity):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                            class CardUpTime(Entity):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.card_administrative_state.is_set or
                                                                                                                    self.card_monitor_state.is_set or
                                                                                                                    self.card_operational_state.is_set or
                                                                                                                    self.card_reset_reason.is_set or
                                                                                                                    self.power_administrative_state.is_set or
                                                                                                                    self.power_current_measurement.is_set or
                                                                                                                    self.power_operational_state.is_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                                    if (self.card_up_time is None):
                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                    return self.card_up_time

                                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                                    if (self.last_operational_state_change is None):
                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                    return self.last_operational_state_change

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "card-administrative-state"):
                                                                                                                    self.card_administrative_state = value
                                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-monitor-state"):
                                                                                                                    self.card_monitor_state = value
                                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-operational-state"):
                                                                                                                    self.card_operational_state = value
                                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-reset-reason"):
                                                                                                                    self.card_reset_reason = value
                                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-administrative-state"):
                                                                                                                    self.power_administrative_state = value
                                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-current-measurement"):
                                                                                                                    self.power_current_measurement = value
                                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-operational-state"):
                                                                                                                    self.power_operational_state = value
                                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                        class InvBasicBag(Entity):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("alias",
                                                                                                                                "asset_id_str",
                                                                                                                                "asset_identification",
                                                                                                                                "ceport",
                                                                                                                                "chip_hardware_revision",
                                                                                                                                "composite_class_code",
                                                                                                                                "description",
                                                                                                                                "environmental_monitor_path",
                                                                                                                                "firmware_revision",
                                                                                                                                "group_flag",
                                                                                                                                "hardware_revision",
                                                                                                                                "is_field_replaceable_unit",
                                                                                                                                "manufacturer_asset_tags",
                                                                                                                                "manufacturer_name",
                                                                                                                                "memory_size",
                                                                                                                                "model_name",
                                                                                                                                "name",
                                                                                                                                "new_deviation_number",
                                                                                                                                "physical_layer_interface_module_type",
                                                                                                                                "redundancystate",
                                                                                                                                "serial_number",
                                                                                                                                "software_revision",
                                                                                                                                "unique_id",
                                                                                                                                "unrecognized_fru",
                                                                                                                                "vendor_type",
                                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.alias.is_set or
                                                                                                                    self.asset_id_str.is_set or
                                                                                                                    self.asset_identification.is_set or
                                                                                                                    self.ceport.is_set or
                                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                                    self.composite_class_code.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                                    self.firmware_revision.is_set or
                                                                                                                    self.group_flag.is_set or
                                                                                                                    self.hardware_revision.is_set or
                                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                                    self.manufacturer_name.is_set or
                                                                                                                    self.memory_size.is_set or
                                                                                                                    self.model_name.is_set or
                                                                                                                    self.name.is_set or
                                                                                                                    self.new_deviation_number.is_set or
                                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                                    self.redundancystate.is_set or
                                                                                                                    self.serial_number.is_set or
                                                                                                                    self.software_revision.is_set or
                                                                                                                    self.unique_id.is_set or
                                                                                                                    self.unrecognized_fru.is_set or
                                                                                                                    self.vendor_type.is_set or
                                                                                                                    self.xr_scoped.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "alias"):
                                                                                                                    self.alias = value
                                                                                                                    self.alias.value_namespace = name_space
                                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-id-str"):
                                                                                                                    self.asset_id_str = value
                                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-identification"):
                                                                                                                    self.asset_identification = value
                                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "ceport"):
                                                                                                                    self.ceport = value
                                                                                                                    self.ceport.value_namespace = name_space
                                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                                    self.chip_hardware_revision = value
                                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "composite-class-code"):
                                                                                                                    self.composite_class_code = value
                                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                                    self.environmental_monitor_path = value
                                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "firmware-revision"):
                                                                                                                    self.firmware_revision = value
                                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "group-flag"):
                                                                                                                    self.group_flag = value
                                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "hardware-revision"):
                                                                                                                    self.hardware_revision = value
                                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                                    self.is_field_replaceable_unit = value
                                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                                    self.manufacturer_asset_tags = value
                                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-name"):
                                                                                                                    self.manufacturer_name = value
                                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "memory-size"):
                                                                                                                    self.memory_size = value
                                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "model-name"):
                                                                                                                    self.model_name = value
                                                                                                                    self.model_name.value_namespace = name_space
                                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "new-deviation-number"):
                                                                                                                    self.new_deviation_number = value
                                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "redundancystate"):
                                                                                                                    self.redundancystate = value
                                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "serial-number"):
                                                                                                                    self.serial_number = value
                                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "software-revision"):
                                                                                                                    self.software_revision = value
                                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unique-id"):
                                                                                                                    self.unique_id = value
                                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                                    self.unrecognized_fru = value
                                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "vendor-type"):
                                                                                                                    self.vendor_type = value
                                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "xr-scoped"):
                                                                                                                    self.xr_scoped = value
                                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                        class InvEepromInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._children_yang_names.add("eeprom")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("description",
                                                                                                                                "has_eeprom",
                                                                                                                                "inv_card_type",
                                                                                                                                "opaque_data",
                                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                            class Eeprom(Entity):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._children_yang_names.add("rma")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("asset_alias",
                                                                                                                                    "asset_id",
                                                                                                                                    "base_mac_address1",
                                                                                                                                    "base_mac_address2",
                                                                                                                                    "base_mac_address3",
                                                                                                                                    "base_mac_address4",
                                                                                                                                    "block_checksum",
                                                                                                                                    "block_count",
                                                                                                                                    "block_length",
                                                                                                                                    "block_signature",
                                                                                                                                    "block_version",
                                                                                                                                    "chassis_sid",
                                                                                                                                    "clei",
                                                                                                                                    "controller_family",
                                                                                                                                    "controller_type",
                                                                                                                                    "description",
                                                                                                                                    "dev_num1",
                                                                                                                                    "dev_num2",
                                                                                                                                    "dev_num3",
                                                                                                                                    "dev_num4",
                                                                                                                                    "dev_num5",
                                                                                                                                    "dev_num6",
                                                                                                                                    "dev_num7",
                                                                                                                                    "eci",
                                                                                                                                    "eeprom_size",
                                                                                                                                    "engineer_use",
                                                                                                                                    "fru_major_type",
                                                                                                                                    "fru_minor_type",
                                                                                                                                    "hw_version",
                                                                                                                                    "hwid",
                                                                                                                                    "idprom_format_rev",
                                                                                                                                    "mac_add_blk_size1",
                                                                                                                                    "mac_add_blk_size2",
                                                                                                                                    "mac_add_blk_size3",
                                                                                                                                    "mac_add_blk_size4",
                                                                                                                                    "manu_test_data",
                                                                                                                                    "mfg_bits",
                                                                                                                                    "mfg_deviation",
                                                                                                                                    "oem_string",
                                                                                                                                    "part_number",
                                                                                                                                    "part_revision",
                                                                                                                                    "pca_num",
                                                                                                                                    "pcavid",
                                                                                                                                    "pcb_serial_num",
                                                                                                                                    "pid",
                                                                                                                                    "power_consumption",
                                                                                                                                    "power_supply_type",
                                                                                                                                    "product_id",
                                                                                                                                    "rma_code",
                                                                                                                                    "serial_number",
                                                                                                                                    "snmpoid",
                                                                                                                                    "top_assem_part_num",
                                                                                                                                    "top_assem_vid",
                                                                                                                                    "udi_description",
                                                                                                                                    "udi_name",
                                                                                                                                    "vid") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                class Rma(Entity):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("rma_history",
                                                                                                                                        "rma_number",
                                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.rma_history.is_set or
                                                                                                                            self.rma_number.is_set or
                                                                                                                            self.test_history.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "rma-history"):
                                                                                                                            self.rma_history = value
                                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "rma-number"):
                                                                                                                            self.rma_number = value
                                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "test-history"):
                                                                                                                            self.test_history = value
                                                                                                                            self.test_history.value_namespace = name_space
                                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.asset_alias.is_set or
                                                                                                                        self.asset_id.is_set or
                                                                                                                        self.base_mac_address1.is_set or
                                                                                                                        self.base_mac_address2.is_set or
                                                                                                                        self.base_mac_address3.is_set or
                                                                                                                        self.base_mac_address4.is_set or
                                                                                                                        self.block_checksum.is_set or
                                                                                                                        self.block_count.is_set or
                                                                                                                        self.block_length.is_set or
                                                                                                                        self.block_signature.is_set or
                                                                                                                        self.block_version.is_set or
                                                                                                                        self.chassis_sid.is_set or
                                                                                                                        self.clei.is_set or
                                                                                                                        self.controller_family.is_set or
                                                                                                                        self.controller_type.is_set or
                                                                                                                        self.description.is_set or
                                                                                                                        self.dev_num1.is_set or
                                                                                                                        self.dev_num2.is_set or
                                                                                                                        self.dev_num3.is_set or
                                                                                                                        self.dev_num4.is_set or
                                                                                                                        self.dev_num5.is_set or
                                                                                                                        self.dev_num6.is_set or
                                                                                                                        self.dev_num7.is_set or
                                                                                                                        self.eci.is_set or
                                                                                                                        self.eeprom_size.is_set or
                                                                                                                        self.engineer_use.is_set or
                                                                                                                        self.fru_major_type.is_set or
                                                                                                                        self.fru_minor_type.is_set or
                                                                                                                        self.hw_version.is_set or
                                                                                                                        self.hwid.is_set or
                                                                                                                        self.idprom_format_rev.is_set or
                                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                                        self.manu_test_data.is_set or
                                                                                                                        self.mfg_bits.is_set or
                                                                                                                        self.mfg_deviation.is_set or
                                                                                                                        self.oem_string.is_set or
                                                                                                                        self.part_number.is_set or
                                                                                                                        self.part_revision.is_set or
                                                                                                                        self.pca_num.is_set or
                                                                                                                        self.pcavid.is_set or
                                                                                                                        self.pcb_serial_num.is_set or
                                                                                                                        self.pid.is_set or
                                                                                                                        self.power_consumption.is_set or
                                                                                                                        self.power_supply_type.is_set or
                                                                                                                        self.product_id.is_set or
                                                                                                                        self.rma_code.is_set or
                                                                                                                        self.serial_number.is_set or
                                                                                                                        self.snmpoid.is_set or
                                                                                                                        self.top_assem_part_num.is_set or
                                                                                                                        self.top_assem_vid.is_set or
                                                                                                                        self.udi_description.is_set or
                                                                                                                        self.udi_name.is_set or
                                                                                                                        self.vid.is_set or
                                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "rma"):
                                                                                                                        if (self.rma is None):
                                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                        return self.rma

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "asset-alias"):
                                                                                                                        self.asset_alias = value
                                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "asset-id"):
                                                                                                                        self.asset_id = value
                                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                                        self.base_mac_address1 = value
                                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                                        self.base_mac_address2 = value
                                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                                        self.base_mac_address3 = value
                                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                                        self.base_mac_address4 = value
                                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-checksum"):
                                                                                                                        self.block_checksum = value
                                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-count"):
                                                                                                                        self.block_count = value
                                                                                                                        self.block_count.value_namespace = name_space
                                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-length"):
                                                                                                                        self.block_length = value
                                                                                                                        self.block_length.value_namespace = name_space
                                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-signature"):
                                                                                                                        self.block_signature = value
                                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-version"):
                                                                                                                        self.block_version = value
                                                                                                                        self.block_version.value_namespace = name_space
                                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "chassis-sid"):
                                                                                                                        self.chassis_sid = value
                                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "clei"):
                                                                                                                        self.clei = value
                                                                                                                        self.clei.value_namespace = name_space
                                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-family"):
                                                                                                                        self.controller_family = value
                                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-type"):
                                                                                                                        self.controller_type = value
                                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "description"):
                                                                                                                        self.description = value
                                                                                                                        self.description.value_namespace = name_space
                                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num1"):
                                                                                                                        self.dev_num1 = value
                                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num2"):
                                                                                                                        self.dev_num2 = value
                                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num3"):
                                                                                                                        self.dev_num3 = value
                                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num4"):
                                                                                                                        self.dev_num4 = value
                                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num5"):
                                                                                                                        self.dev_num5 = value
                                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num6"):
                                                                                                                        self.dev_num6 = value
                                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num7"):
                                                                                                                        self.dev_num7 = value
                                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eci"):
                                                                                                                        self.eci = value
                                                                                                                        self.eci.value_namespace = name_space
                                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eeprom-size"):
                                                                                                                        self.eeprom_size = value
                                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "engineer-use"):
                                                                                                                        self.engineer_use = value
                                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-major-type"):
                                                                                                                        self.fru_major_type = value
                                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                                        self.fru_minor_type = value
                                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hw-version"):
                                                                                                                        self.hw_version = value
                                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hwid"):
                                                                                                                        self.hwid = value
                                                                                                                        self.hwid.value_namespace = name_space
                                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                                        self.idprom_format_rev = value
                                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                                        self.mac_add_blk_size1 = value
                                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                                        self.mac_add_blk_size2 = value
                                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                                        self.mac_add_blk_size3 = value
                                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                                        self.mac_add_blk_size4 = value
                                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "manu-test-data"):
                                                                                                                        self.manu_test_data = value
                                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-bits"):
                                                                                                                        self.mfg_bits = value
                                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                                        self.mfg_deviation = value
                                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "oem-string"):
                                                                                                                        self.oem_string = value
                                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-number"):
                                                                                                                        self.part_number = value
                                                                                                                        self.part_number.value_namespace = name_space
                                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-revision"):
                                                                                                                        self.part_revision = value
                                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pca-num"):
                                                                                                                        self.pca_num = value
                                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcavid"):
                                                                                                                        self.pcavid = value
                                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                                        self.pcb_serial_num = value
                                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pid"):
                                                                                                                        self.pid = value
                                                                                                                        self.pid.value_namespace = name_space
                                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-consumption"):
                                                                                                                        self.power_consumption = value
                                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-supply-type"):
                                                                                                                        self.power_supply_type = value
                                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "product-id"):
                                                                                                                        self.product_id = value
                                                                                                                        self.product_id.value_namespace = name_space
                                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "rma-code"):
                                                                                                                        self.rma_code = value
                                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "serial-number"):
                                                                                                                        self.serial_number = value
                                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "snmpoid"):
                                                                                                                        self.snmpoid = value
                                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                                        self.top_assem_part_num = value
                                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                                        self.top_assem_vid = value
                                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-description"):
                                                                                                                        self.udi_description = value
                                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-name"):
                                                                                                                        self.udi_name = value
                                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vid"):
                                                                                                                        self.vid = value
                                                                                                                        self.vid.value_namespace = name_space
                                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.description.is_set or
                                                                                                                    self.has_eeprom.is_set or
                                                                                                                    self.inv_card_type.is_set or
                                                                                                                    self.opaque_data.is_set or
                                                                                                                    self.opaque_data_size.is_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "eeprom"):
                                                                                                                    if (self.eeprom is None):
                                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                    return self.eeprom

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "has-eeprom"):
                                                                                                                    self.has_eeprom = value
                                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "inv-card-type"):
                                                                                                                    self.inv_card_type = value
                                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data"):
                                                                                                                    self.opaque_data = value
                                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data-size"):
                                                                                                                    self.opaque_data_size = value
                                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.module_done.is_set or
                                                                                                                self.node_id.is_set or
                                                                                                                self.vm_done.is_set or
                                                                                                                self.vm_node_id.is_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "attributes" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                                if (self.env_sensor_info is None):
                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                return self.env_sensor_info

                                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                return self.env_sensor_info_xml

                                                                                                            if (child_yang_name == "fru-info"):
                                                                                                                if (self.fru_info is None):
                                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                return self.fru_info

                                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                                if (self.inv_asset_bag is None):
                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                return self.inv_asset_bag

                                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                                if (self.inv_basic_bag is None):
                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                return self.inv_basic_bag

                                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                                if (self.inv_eeprom_info is None):
                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                return self.inv_eeprom_info

                                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                                if (self.pwg_info is None):
                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                return self.pwg_info

                                                                                                            if (child_yang_name == "threshold"):
                                                                                                                if (self.threshold is None):
                                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                return self.threshold

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "module-done"):
                                                                                                                self.module_done = value
                                                                                                                self.module_done.value_namespace = name_space
                                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "node-id"):
                                                                                                                self.node_id = value
                                                                                                                self.node_id.value_namespace = name_space
                                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-done"):
                                                                                                                self.vm_done = value
                                                                                                                self.vm_done.value_namespace = name_space
                                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-node-id"):
                                                                                                                self.vm_node_id = value
                                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.name.is_set or
                                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "tsi10" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "attributes"):
                                                                                                            if (self.attributes is None):
                                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                            return self.attributes

                                                                                                        if (child_yang_name == "tsi11s"):
                                                                                                            if (self.tsi11s is None):
                                                                                                                self.tsi11s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                                self.tsi11s.parent = self
                                                                                                                self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                            return self.tsi11s

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "attributes" or name == "tsi11s" or name == "name"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "tsi10s" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "tsi10"):
                                                                                                        for c in self.tsi10:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.tsi10.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "tsi10"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class Attributes(Entity):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                .. attribute:: module_done
                                                                                                
                                                                                                	Inventory EDM Module Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**default value**\: 1
                                                                                                
                                                                                                .. attribute:: node_id
                                                                                                
                                                                                                	Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                .. attribute:: vm_done
                                                                                                
                                                                                                	VM Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                .. attribute:: vm_node_id
                                                                                                
                                                                                                	VM Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                    self._children_yang_names.add("threshold")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("module_done",
                                                                                                                    "node_id",
                                                                                                                    "vm_done",
                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)


                                                                                                class EnvSensorInfo(Entity):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("age_time_stamp",
                                                                                                                        "alarm_type",
                                                                                                                        "data_type",
                                                                                                                        "device_description",
                                                                                                                        "device_id",
                                                                                                                        "field_validity_bitmap",
                                                                                                                        "precision",
                                                                                                                        "scale",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.age_time_stamp.is_set or
                                                                                                            self.alarm_type.is_set or
                                                                                                            self.data_type.is_set or
                                                                                                            self.device_description.is_set or
                                                                                                            self.device_id.is_set or
                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                            self.precision.is_set or
                                                                                                            self.scale.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                            self.age_time_stamp = value
                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "alarm-type"):
                                                                                                            self.alarm_type = value
                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-description"):
                                                                                                            self.device_description = value
                                                                                                            self.device_description.value_namespace = name_space
                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-id"):
                                                                                                            self.device_id = value
                                                                                                            self.device_id.value_namespace = name_space
                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                            self.field_validity_bitmap = value
                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "precision"):
                                                                                                            self.precision = value
                                                                                                            self.precision.value_namespace = name_space
                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "scale"):
                                                                                                            self.scale = value
                                                                                                            self.scale.value_namespace = name_space
                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class PwgInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("power_group_available_current",
                                                                                                                        "power_group_drawn_current",
                                                                                                                        "power_group_power_units",
                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.power_group_available_current.is_set or
                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                            self.power_group_power_units.is_set or
                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                            self.power_group_available_current = value
                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                            self.power_group_drawn_current = value
                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                            self.power_group_power_units = value
                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                            self.power_group_redundancy_mode = value
                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._children_yang_names.add("threshold")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("data_type",
                                                                                                                        "description",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                    class Threshold(Entity):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                            self.threshold_array = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                        class ThresholdArray(Entity):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_name",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_name.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-name"):
                                                                                                                    self.threshold_name = value
                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                for c in self.threshold_array:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.threshold_array.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "threshold-array"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.data_type.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set or
                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "threshold"):
                                                                                                            if (self.threshold is None):
                                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                            return self.threshold

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class InvAssetBag(Entity):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                        "manufacturer_software_identifier",
                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                            self.part_number.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                            self.manufacturer_assembly_number = value
                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                            self.manufacturer_software_identifier = value
                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "part-number"):
                                                                                                            self.part_number = value
                                                                                                            self.part_number.value_namespace = name_space
                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                class Threshold(Entity):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                    class MajorLo(Entity):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalHi(Entity):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorHi(Entity):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MajorHi(Entity):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalLo(Entity):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorLo(Entity):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                            if (self.critical_hi is None):
                                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                            return self.critical_hi

                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                            if (self.critical_lo is None):
                                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                            return self.critical_lo

                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                            if (self.major_hi is None):
                                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                            return self.major_hi

                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                            if (self.major_lo is None):
                                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                            return self.major_lo

                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                            if (self.minor_hi is None):
                                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                            return self.minor_hi

                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                            if (self.minor_lo is None):
                                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                            return self.minor_lo

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        pass


                                                                                                class FruInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("card_administrative_state",
                                                                                                                        "card_monitor_state",
                                                                                                                        "card_operational_state",
                                                                                                                        "card_reset_reason",
                                                                                                                        "power_administrative_state",
                                                                                                                        "power_current_measurement",
                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                    class CardUpTime(Entity):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.card_administrative_state.is_set or
                                                                                                            self.card_monitor_state.is_set or
                                                                                                            self.card_operational_state.is_set or
                                                                                                            self.card_reset_reason.is_set or
                                                                                                            self.power_administrative_state.is_set or
                                                                                                            self.power_current_measurement.is_set or
                                                                                                            self.power_operational_state.is_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                            if (self.card_up_time is None):
                                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                            return self.card_up_time

                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                            return self.last_operational_state_change

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                            self.card_administrative_state = value
                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                            self.card_monitor_state = value
                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-operational-state"):
                                                                                                            self.card_operational_state = value
                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                            self.card_reset_reason = value
                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                            self.power_administrative_state = value
                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                            self.power_current_measurement = value
                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-operational-state"):
                                                                                                            self.power_operational_state = value
                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                class InvBasicBag(Entity):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("alias",
                                                                                                                        "asset_id_str",
                                                                                                                        "asset_identification",
                                                                                                                        "ceport",
                                                                                                                        "chip_hardware_revision",
                                                                                                                        "composite_class_code",
                                                                                                                        "description",
                                                                                                                        "environmental_monitor_path",
                                                                                                                        "firmware_revision",
                                                                                                                        "group_flag",
                                                                                                                        "hardware_revision",
                                                                                                                        "is_field_replaceable_unit",
                                                                                                                        "manufacturer_asset_tags",
                                                                                                                        "manufacturer_name",
                                                                                                                        "memory_size",
                                                                                                                        "model_name",
                                                                                                                        "name",
                                                                                                                        "new_deviation_number",
                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                        "redundancystate",
                                                                                                                        "serial_number",
                                                                                                                        "software_revision",
                                                                                                                        "unique_id",
                                                                                                                        "unrecognized_fru",
                                                                                                                        "vendor_type",
                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.alias.is_set or
                                                                                                            self.asset_id_str.is_set or
                                                                                                            self.asset_identification.is_set or
                                                                                                            self.ceport.is_set or
                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                            self.composite_class_code.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                            self.firmware_revision.is_set or
                                                                                                            self.group_flag.is_set or
                                                                                                            self.hardware_revision.is_set or
                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                            self.manufacturer_name.is_set or
                                                                                                            self.memory_size.is_set or
                                                                                                            self.model_name.is_set or
                                                                                                            self.name.is_set or
                                                                                                            self.new_deviation_number.is_set or
                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                            self.redundancystate.is_set or
                                                                                                            self.serial_number.is_set or
                                                                                                            self.software_revision.is_set or
                                                                                                            self.unique_id.is_set or
                                                                                                            self.unrecognized_fru.is_set or
                                                                                                            self.vendor_type.is_set or
                                                                                                            self.xr_scoped.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "alias"):
                                                                                                            self.alias = value
                                                                                                            self.alias.value_namespace = name_space
                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-id-str"):
                                                                                                            self.asset_id_str = value
                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-identification"):
                                                                                                            self.asset_identification = value
                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "ceport"):
                                                                                                            self.ceport = value
                                                                                                            self.ceport.value_namespace = name_space
                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                            self.chip_hardware_revision = value
                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "composite-class-code"):
                                                                                                            self.composite_class_code = value
                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                            self.environmental_monitor_path = value
                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "firmware-revision"):
                                                                                                            self.firmware_revision = value
                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "group-flag"):
                                                                                                            self.group_flag = value
                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "hardware-revision"):
                                                                                                            self.hardware_revision = value
                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                            self.is_field_replaceable_unit = value
                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                            self.manufacturer_asset_tags = value
                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                            self.manufacturer_name = value
                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "memory-size"):
                                                                                                            self.memory_size = value
                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "model-name"):
                                                                                                            self.model_name = value
                                                                                                            self.model_name.value_namespace = name_space
                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                            self.new_deviation_number = value
                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "redundancystate"):
                                                                                                            self.redundancystate = value
                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "serial-number"):
                                                                                                            self.serial_number = value
                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "software-revision"):
                                                                                                            self.software_revision = value
                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unique-id"):
                                                                                                            self.unique_id = value
                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                            self.unrecognized_fru = value
                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "vendor-type"):
                                                                                                            self.vendor_type = value
                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "xr-scoped"):
                                                                                                            self.xr_scoped = value
                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                class InvEepromInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("description",
                                                                                                                        "has_eeprom",
                                                                                                                        "inv_card_type",
                                                                                                                        "opaque_data",
                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                    class Eeprom(Entity):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._children_yang_names.add("rma")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("asset_alias",
                                                                                                                            "asset_id",
                                                                                                                            "base_mac_address1",
                                                                                                                            "base_mac_address2",
                                                                                                                            "base_mac_address3",
                                                                                                                            "base_mac_address4",
                                                                                                                            "block_checksum",
                                                                                                                            "block_count",
                                                                                                                            "block_length",
                                                                                                                            "block_signature",
                                                                                                                            "block_version",
                                                                                                                            "chassis_sid",
                                                                                                                            "clei",
                                                                                                                            "controller_family",
                                                                                                                            "controller_type",
                                                                                                                            "description",
                                                                                                                            "dev_num1",
                                                                                                                            "dev_num2",
                                                                                                                            "dev_num3",
                                                                                                                            "dev_num4",
                                                                                                                            "dev_num5",
                                                                                                                            "dev_num6",
                                                                                                                            "dev_num7",
                                                                                                                            "eci",
                                                                                                                            "eeprom_size",
                                                                                                                            "engineer_use",
                                                                                                                            "fru_major_type",
                                                                                                                            "fru_minor_type",
                                                                                                                            "hw_version",
                                                                                                                            "hwid",
                                                                                                                            "idprom_format_rev",
                                                                                                                            "mac_add_blk_size1",
                                                                                                                            "mac_add_blk_size2",
                                                                                                                            "mac_add_blk_size3",
                                                                                                                            "mac_add_blk_size4",
                                                                                                                            "manu_test_data",
                                                                                                                            "mfg_bits",
                                                                                                                            "mfg_deviation",
                                                                                                                            "oem_string",
                                                                                                                            "part_number",
                                                                                                                            "part_revision",
                                                                                                                            "pca_num",
                                                                                                                            "pcavid",
                                                                                                                            "pcb_serial_num",
                                                                                                                            "pid",
                                                                                                                            "power_consumption",
                                                                                                                            "power_supply_type",
                                                                                                                            "product_id",
                                                                                                                            "rma_code",
                                                                                                                            "serial_number",
                                                                                                                            "snmpoid",
                                                                                                                            "top_assem_part_num",
                                                                                                                            "top_assem_vid",
                                                                                                                            "udi_description",
                                                                                                                            "udi_name",
                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                        class Rma(Entity):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("rma_history",
                                                                                                                                "rma_number",
                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.rma_history.is_set or
                                                                                                                    self.rma_number.is_set or
                                                                                                                    self.test_history.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "rma-history"):
                                                                                                                    self.rma_history = value
                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "rma-number"):
                                                                                                                    self.rma_number = value
                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "test-history"):
                                                                                                                    self.test_history = value
                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.asset_alias.is_set or
                                                                                                                self.asset_id.is_set or
                                                                                                                self.base_mac_address1.is_set or
                                                                                                                self.base_mac_address2.is_set or
                                                                                                                self.base_mac_address3.is_set or
                                                                                                                self.base_mac_address4.is_set or
                                                                                                                self.block_checksum.is_set or
                                                                                                                self.block_count.is_set or
                                                                                                                self.block_length.is_set or
                                                                                                                self.block_signature.is_set or
                                                                                                                self.block_version.is_set or
                                                                                                                self.chassis_sid.is_set or
                                                                                                                self.clei.is_set or
                                                                                                                self.controller_family.is_set or
                                                                                                                self.controller_type.is_set or
                                                                                                                self.description.is_set or
                                                                                                                self.dev_num1.is_set or
                                                                                                                self.dev_num2.is_set or
                                                                                                                self.dev_num3.is_set or
                                                                                                                self.dev_num4.is_set or
                                                                                                                self.dev_num5.is_set or
                                                                                                                self.dev_num6.is_set or
                                                                                                                self.dev_num7.is_set or
                                                                                                                self.eci.is_set or
                                                                                                                self.eeprom_size.is_set or
                                                                                                                self.engineer_use.is_set or
                                                                                                                self.fru_major_type.is_set or
                                                                                                                self.fru_minor_type.is_set or
                                                                                                                self.hw_version.is_set or
                                                                                                                self.hwid.is_set or
                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                self.manu_test_data.is_set or
                                                                                                                self.mfg_bits.is_set or
                                                                                                                self.mfg_deviation.is_set or
                                                                                                                self.oem_string.is_set or
                                                                                                                self.part_number.is_set or
                                                                                                                self.part_revision.is_set or
                                                                                                                self.pca_num.is_set or
                                                                                                                self.pcavid.is_set or
                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                self.pid.is_set or
                                                                                                                self.power_consumption.is_set or
                                                                                                                self.power_supply_type.is_set or
                                                                                                                self.product_id.is_set or
                                                                                                                self.rma_code.is_set or
                                                                                                                self.serial_number.is_set or
                                                                                                                self.snmpoid.is_set or
                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                self.top_assem_vid.is_set or
                                                                                                                self.udi_description.is_set or
                                                                                                                self.udi_name.is_set or
                                                                                                                self.vid.is_set or
                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "rma"):
                                                                                                                if (self.rma is None):
                                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                return self.rma

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "asset-alias"):
                                                                                                                self.asset_alias = value
                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "asset-id"):
                                                                                                                self.asset_id = value
                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                self.base_mac_address1 = value
                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                self.base_mac_address2 = value
                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                self.base_mac_address3 = value
                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                self.base_mac_address4 = value
                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-checksum"):
                                                                                                                self.block_checksum = value
                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-count"):
                                                                                                                self.block_count = value
                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-length"):
                                                                                                                self.block_length = value
                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-signature"):
                                                                                                                self.block_signature = value
                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-version"):
                                                                                                                self.block_version = value
                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                self.chassis_sid = value
                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "clei"):
                                                                                                                self.clei = value
                                                                                                                self.clei.value_namespace = name_space
                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-family"):
                                                                                                                self.controller_family = value
                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-type"):
                                                                                                                self.controller_type = value
                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "description"):
                                                                                                                self.description = value
                                                                                                                self.description.value_namespace = name_space
                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num1"):
                                                                                                                self.dev_num1 = value
                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num2"):
                                                                                                                self.dev_num2 = value
                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num3"):
                                                                                                                self.dev_num3 = value
                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num4"):
                                                                                                                self.dev_num4 = value
                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num5"):
                                                                                                                self.dev_num5 = value
                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num6"):
                                                                                                                self.dev_num6 = value
                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num7"):
                                                                                                                self.dev_num7 = value
                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eci"):
                                                                                                                self.eci = value
                                                                                                                self.eci.value_namespace = name_space
                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                self.eeprom_size = value
                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "engineer-use"):
                                                                                                                self.engineer_use = value
                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                self.fru_major_type = value
                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                self.fru_minor_type = value
                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hw-version"):
                                                                                                                self.hw_version = value
                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hwid"):
                                                                                                                self.hwid = value
                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                self.idprom_format_rev = value
                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                self.manu_test_data = value
                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                self.mfg_bits = value
                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                self.mfg_deviation = value
                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "oem-string"):
                                                                                                                self.oem_string = value
                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-number"):
                                                                                                                self.part_number = value
                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-revision"):
                                                                                                                self.part_revision = value
                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pca-num"):
                                                                                                                self.pca_num = value
                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcavid"):
                                                                                                                self.pcavid = value
                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                self.pcb_serial_num = value
                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pid"):
                                                                                                                self.pid = value
                                                                                                                self.pid.value_namespace = name_space
                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-consumption"):
                                                                                                                self.power_consumption = value
                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                self.power_supply_type = value
                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "product-id"):
                                                                                                                self.product_id = value
                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "rma-code"):
                                                                                                                self.rma_code = value
                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "serial-number"):
                                                                                                                self.serial_number = value
                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "snmpoid"):
                                                                                                                self.snmpoid = value
                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                self.top_assem_part_num = value
                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                self.top_assem_vid = value
                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-description"):
                                                                                                                self.udi_description = value
                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-name"):
                                                                                                                self.udi_name = value
                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vid"):
                                                                                                                self.vid = value
                                                                                                                self.vid.value_namespace = name_space
                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.description.is_set or
                                                                                                            self.has_eeprom.is_set or
                                                                                                            self.inv_card_type.is_set or
                                                                                                            self.opaque_data.is_set or
                                                                                                            self.opaque_data_size.is_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                            if (self.eeprom is None):
                                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                            return self.eeprom

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "has-eeprom"):
                                                                                                            self.has_eeprom = value
                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "inv-card-type"):
                                                                                                            self.inv_card_type = value
                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data"):
                                                                                                            self.opaque_data = value
                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                            self.opaque_data_size = value
                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.module_done.is_set or
                                                                                                        self.node_id.is_set or
                                                                                                        self.vm_done.is_set or
                                                                                                        self.vm_node_id.is_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                        if (self.env_sensor_info is None):
                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                        return self.env_sensor_info

                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                        return self.env_sensor_info_xml

                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                        if (self.fru_info is None):
                                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                        return self.fru_info

                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                        if (self.inv_asset_bag is None):
                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                        return self.inv_asset_bag

                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                        if (self.inv_basic_bag is None):
                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                        return self.inv_basic_bag

                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                        return self.inv_eeprom_info

                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                        if (self.pwg_info is None):
                                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                        return self.pwg_info

                                                                                                    if (child_yang_name == "threshold"):
                                                                                                        if (self.threshold is None):
                                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                        return self.threshold

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "module-done"):
                                                                                                        self.module_done = value
                                                                                                        self.module_done.value_namespace = name_space
                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "node-id"):
                                                                                                        self.node_id = value
                                                                                                        self.node_id.value_namespace = name_space
                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-done"):
                                                                                                        self.vm_done = value
                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-node-id"):
                                                                                                        self.vm_node_id = value
                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.name.is_set or
                                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "tsi9" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "attributes"):
                                                                                                    if (self.attributes is None):
                                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                    return self.attributes

                                                                                                if (child_yang_name == "tsi10s"):
                                                                                                    if (self.tsi10s is None):
                                                                                                        self.tsi10s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                        self.tsi10s.parent = self
                                                                                                        self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                    return self.tsi10s

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "attributes" or name == "tsi10s" or name == "name"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "tsi9s" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "tsi9"):
                                                                                                for c in self.tsi9:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.tsi9.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "tsi9"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class Attributes(Entity):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        .. attribute:: module_done
                                                                                        
                                                                                        	Inventory EDM Module Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**default value**\: 1
                                                                                        
                                                                                        .. attribute:: node_id
                                                                                        
                                                                                        	Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        .. attribute:: vm_done
                                                                                        
                                                                                        	VM Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        .. attribute:: vm_node_id
                                                                                        
                                                                                        	VM Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                            self._children_yang_names.add("fru-info")

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                            self._children_yang_names.add("pwg-info")

                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                            self._children_yang_names.add("threshold")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("module_done",
                                                                                                            "node_id",
                                                                                                            "vm_done",
                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)


                                                                                        class EnvSensorInfo(Entity):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("age_time_stamp",
                                                                                                                "alarm_type",
                                                                                                                "data_type",
                                                                                                                "device_description",
                                                                                                                "device_id",
                                                                                                                "field_validity_bitmap",
                                                                                                                "precision",
                                                                                                                "scale",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.age_time_stamp.is_set or
                                                                                                    self.alarm_type.is_set or
                                                                                                    self.data_type.is_set or
                                                                                                    self.device_description.is_set or
                                                                                                    self.device_id.is_set or
                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                    self.precision.is_set or
                                                                                                    self.scale.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "age-time-stamp"):
                                                                                                    self.age_time_stamp = value
                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "alarm-type"):
                                                                                                    self.alarm_type = value
                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-description"):
                                                                                                    self.device_description = value
                                                                                                    self.device_description.value_namespace = name_space
                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-id"):
                                                                                                    self.device_id = value
                                                                                                    self.device_id.value_namespace = name_space
                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                    self.field_validity_bitmap = value
                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "precision"):
                                                                                                    self.precision = value
                                                                                                    self.precision.value_namespace = name_space
                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "scale"):
                                                                                                    self.scale = value
                                                                                                    self.scale.value_namespace = name_space
                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class PwgInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("power_group_available_current",
                                                                                                                "power_group_drawn_current",
                                                                                                                "power_group_power_units",
                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.power_group_available_current.is_set or
                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                    self.power_group_power_units.is_set or
                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "power-group-available-current"):
                                                                                                    self.power_group_available_current = value
                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                    self.power_group_drawn_current = value
                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-power-units"):
                                                                                                    self.power_group_power_units = value
                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                    self.power_group_redundancy_mode = value
                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                        class EnvSensorInfoXml(Entity):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._children_yang_names.add("threshold")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("data_type",
                                                                                                                "description",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                            class Threshold(Entity):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                    self.threshold_array = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                class ThresholdArray(Entity):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"

                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_name",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_name.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-name"):
                                                                                                            self.threshold_name = value
                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                        for c in self.threshold_array:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.threshold_array.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "threshold-array"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.data_type.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set or
                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "threshold"):
                                                                                                    if (self.threshold is None):
                                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                    return self.threshold

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class InvAssetBag(Entity):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                "manufacturer_assembly_revision",
                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                "manufacturer_software_identifier",
                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                "part_number") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                    self.part_number.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                    self.manufacturer_assembly_number = value
                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                    self.manufacturer_software_identifier = value
                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "part-number"):
                                                                                                    self.part_number = value
                                                                                                    self.part_number.value_namespace = name_space
                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                        class Threshold(Entity):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                self._children_yang_names.add("major-hi")

                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                self._children_yang_names.add("major-lo")

                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._children_yang_names.add("minor-lo")


                                                                                            class MajorLo(Entity):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalHi(Entity):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorHi(Entity):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MajorHi(Entity):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalLo(Entity):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorLo(Entity):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                    if (self.critical_hi is None):
                                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                    return self.critical_hi

                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                    if (self.critical_lo is None):
                                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                    return self.critical_lo

                                                                                                if (child_yang_name == "major-hi"):
                                                                                                    if (self.major_hi is None):
                                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                    return self.major_hi

                                                                                                if (child_yang_name == "major-lo"):
                                                                                                    if (self.major_lo is None):
                                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                    return self.major_lo

                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                    if (self.minor_hi is None):
                                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                    return self.minor_hi

                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                    if (self.minor_lo is None):
                                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                    return self.minor_lo

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                pass


                                                                                        class FruInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("card_administrative_state",
                                                                                                                "card_monitor_state",
                                                                                                                "card_operational_state",
                                                                                                                "card_reset_reason",
                                                                                                                "power_administrative_state",
                                                                                                                "power_current_measurement",
                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                            class LastOperationalStateChange(Entity):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                            class CardUpTime(Entity):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.card_administrative_state.is_set or
                                                                                                    self.card_monitor_state.is_set or
                                                                                                    self.card_operational_state.is_set or
                                                                                                    self.card_reset_reason.is_set or
                                                                                                    self.power_administrative_state.is_set or
                                                                                                    self.power_current_measurement.is_set or
                                                                                                    self.power_operational_state.is_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                    if (self.card_up_time is None):
                                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                    return self.card_up_time

                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                    if (self.last_operational_state_change is None):
                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                    return self.last_operational_state_change

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "card-administrative-state"):
                                                                                                    self.card_administrative_state = value
                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-monitor-state"):
                                                                                                    self.card_monitor_state = value
                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-operational-state"):
                                                                                                    self.card_operational_state = value
                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-reset-reason"):
                                                                                                    self.card_reset_reason = value
                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-administrative-state"):
                                                                                                    self.power_administrative_state = value
                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-current-measurement"):
                                                                                                    self.power_current_measurement = value
                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-operational-state"):
                                                                                                    self.power_operational_state = value
                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                        class InvBasicBag(Entity):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("alias",
                                                                                                                "asset_id_str",
                                                                                                                "asset_identification",
                                                                                                                "ceport",
                                                                                                                "chip_hardware_revision",
                                                                                                                "composite_class_code",
                                                                                                                "description",
                                                                                                                "environmental_monitor_path",
                                                                                                                "firmware_revision",
                                                                                                                "group_flag",
                                                                                                                "hardware_revision",
                                                                                                                "is_field_replaceable_unit",
                                                                                                                "manufacturer_asset_tags",
                                                                                                                "manufacturer_name",
                                                                                                                "memory_size",
                                                                                                                "model_name",
                                                                                                                "name",
                                                                                                                "new_deviation_number",
                                                                                                                "physical_layer_interface_module_type",
                                                                                                                "redundancystate",
                                                                                                                "serial_number",
                                                                                                                "software_revision",
                                                                                                                "unique_id",
                                                                                                                "unrecognized_fru",
                                                                                                                "vendor_type",
                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.alias.is_set or
                                                                                                    self.asset_id_str.is_set or
                                                                                                    self.asset_identification.is_set or
                                                                                                    self.ceport.is_set or
                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                    self.composite_class_code.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                    self.firmware_revision.is_set or
                                                                                                    self.group_flag.is_set or
                                                                                                    self.hardware_revision.is_set or
                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                    self.manufacturer_name.is_set or
                                                                                                    self.memory_size.is_set or
                                                                                                    self.model_name.is_set or
                                                                                                    self.name.is_set or
                                                                                                    self.new_deviation_number.is_set or
                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                    self.redundancystate.is_set or
                                                                                                    self.serial_number.is_set or
                                                                                                    self.software_revision.is_set or
                                                                                                    self.unique_id.is_set or
                                                                                                    self.unrecognized_fru.is_set or
                                                                                                    self.vendor_type.is_set or
                                                                                                    self.xr_scoped.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "alias"):
                                                                                                    self.alias = value
                                                                                                    self.alias.value_namespace = name_space
                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-id-str"):
                                                                                                    self.asset_id_str = value
                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-identification"):
                                                                                                    self.asset_identification = value
                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "ceport"):
                                                                                                    self.ceport = value
                                                                                                    self.ceport.value_namespace = name_space
                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                    self.chip_hardware_revision = value
                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "composite-class-code"):
                                                                                                    self.composite_class_code = value
                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                    self.environmental_monitor_path = value
                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "firmware-revision"):
                                                                                                    self.firmware_revision = value
                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "group-flag"):
                                                                                                    self.group_flag = value
                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "hardware-revision"):
                                                                                                    self.hardware_revision = value
                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                    self.is_field_replaceable_unit = value
                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                    self.manufacturer_asset_tags = value
                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-name"):
                                                                                                    self.manufacturer_name = value
                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "memory-size"):
                                                                                                    self.memory_size = value
                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "model-name"):
                                                                                                    self.model_name = value
                                                                                                    self.model_name.value_namespace = name_space
                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "new-deviation-number"):
                                                                                                    self.new_deviation_number = value
                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "redundancystate"):
                                                                                                    self.redundancystate = value
                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "serial-number"):
                                                                                                    self.serial_number = value
                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "software-revision"):
                                                                                                    self.software_revision = value
                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unique-id"):
                                                                                                    self.unique_id = value
                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                    self.unrecognized_fru = value
                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "vendor-type"):
                                                                                                    self.vendor_type = value
                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "xr-scoped"):
                                                                                                    self.xr_scoped = value
                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                        class InvEepromInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._children_yang_names.add("eeprom")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("description",
                                                                                                                "has_eeprom",
                                                                                                                "inv_card_type",
                                                                                                                "opaque_data",
                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                            class Eeprom(Entity):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._children_yang_names.add("rma")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("asset_alias",
                                                                                                                    "asset_id",
                                                                                                                    "base_mac_address1",
                                                                                                                    "base_mac_address2",
                                                                                                                    "base_mac_address3",
                                                                                                                    "base_mac_address4",
                                                                                                                    "block_checksum",
                                                                                                                    "block_count",
                                                                                                                    "block_length",
                                                                                                                    "block_signature",
                                                                                                                    "block_version",
                                                                                                                    "chassis_sid",
                                                                                                                    "clei",
                                                                                                                    "controller_family",
                                                                                                                    "controller_type",
                                                                                                                    "description",
                                                                                                                    "dev_num1",
                                                                                                                    "dev_num2",
                                                                                                                    "dev_num3",
                                                                                                                    "dev_num4",
                                                                                                                    "dev_num5",
                                                                                                                    "dev_num6",
                                                                                                                    "dev_num7",
                                                                                                                    "eci",
                                                                                                                    "eeprom_size",
                                                                                                                    "engineer_use",
                                                                                                                    "fru_major_type",
                                                                                                                    "fru_minor_type",
                                                                                                                    "hw_version",
                                                                                                                    "hwid",
                                                                                                                    "idprom_format_rev",
                                                                                                                    "mac_add_blk_size1",
                                                                                                                    "mac_add_blk_size2",
                                                                                                                    "mac_add_blk_size3",
                                                                                                                    "mac_add_blk_size4",
                                                                                                                    "manu_test_data",
                                                                                                                    "mfg_bits",
                                                                                                                    "mfg_deviation",
                                                                                                                    "oem_string",
                                                                                                                    "part_number",
                                                                                                                    "part_revision",
                                                                                                                    "pca_num",
                                                                                                                    "pcavid",
                                                                                                                    "pcb_serial_num",
                                                                                                                    "pid",
                                                                                                                    "power_consumption",
                                                                                                                    "power_supply_type",
                                                                                                                    "product_id",
                                                                                                                    "rma_code",
                                                                                                                    "serial_number",
                                                                                                                    "snmpoid",
                                                                                                                    "top_assem_part_num",
                                                                                                                    "top_assem_vid",
                                                                                                                    "udi_description",
                                                                                                                    "udi_name",
                                                                                                                    "vid") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                class Rma(Entity):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("rma_history",
                                                                                                                        "rma_number",
                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.rma_history.is_set or
                                                                                                            self.rma_number.is_set or
                                                                                                            self.test_history.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "rma-history"):
                                                                                                            self.rma_history = value
                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "rma-number"):
                                                                                                            self.rma_number = value
                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "test-history"):
                                                                                                            self.test_history = value
                                                                                                            self.test_history.value_namespace = name_space
                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.asset_alias.is_set or
                                                                                                        self.asset_id.is_set or
                                                                                                        self.base_mac_address1.is_set or
                                                                                                        self.base_mac_address2.is_set or
                                                                                                        self.base_mac_address3.is_set or
                                                                                                        self.base_mac_address4.is_set or
                                                                                                        self.block_checksum.is_set or
                                                                                                        self.block_count.is_set or
                                                                                                        self.block_length.is_set or
                                                                                                        self.block_signature.is_set or
                                                                                                        self.block_version.is_set or
                                                                                                        self.chassis_sid.is_set or
                                                                                                        self.clei.is_set or
                                                                                                        self.controller_family.is_set or
                                                                                                        self.controller_type.is_set or
                                                                                                        self.description.is_set or
                                                                                                        self.dev_num1.is_set or
                                                                                                        self.dev_num2.is_set or
                                                                                                        self.dev_num3.is_set or
                                                                                                        self.dev_num4.is_set or
                                                                                                        self.dev_num5.is_set or
                                                                                                        self.dev_num6.is_set or
                                                                                                        self.dev_num7.is_set or
                                                                                                        self.eci.is_set or
                                                                                                        self.eeprom_size.is_set or
                                                                                                        self.engineer_use.is_set or
                                                                                                        self.fru_major_type.is_set or
                                                                                                        self.fru_minor_type.is_set or
                                                                                                        self.hw_version.is_set or
                                                                                                        self.hwid.is_set or
                                                                                                        self.idprom_format_rev.is_set or
                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                        self.manu_test_data.is_set or
                                                                                                        self.mfg_bits.is_set or
                                                                                                        self.mfg_deviation.is_set or
                                                                                                        self.oem_string.is_set or
                                                                                                        self.part_number.is_set or
                                                                                                        self.part_revision.is_set or
                                                                                                        self.pca_num.is_set or
                                                                                                        self.pcavid.is_set or
                                                                                                        self.pcb_serial_num.is_set or
                                                                                                        self.pid.is_set or
                                                                                                        self.power_consumption.is_set or
                                                                                                        self.power_supply_type.is_set or
                                                                                                        self.product_id.is_set or
                                                                                                        self.rma_code.is_set or
                                                                                                        self.serial_number.is_set or
                                                                                                        self.snmpoid.is_set or
                                                                                                        self.top_assem_part_num.is_set or
                                                                                                        self.top_assem_vid.is_set or
                                                                                                        self.udi_description.is_set or
                                                                                                        self.udi_name.is_set or
                                                                                                        self.vid.is_set or
                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "rma"):
                                                                                                        if (self.rma is None):
                                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                        return self.rma

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "asset-alias"):
                                                                                                        self.asset_alias = value
                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "asset-id"):
                                                                                                        self.asset_id = value
                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                        self.base_mac_address1 = value
                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                        self.base_mac_address2 = value
                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                        self.base_mac_address3 = value
                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                        self.base_mac_address4 = value
                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-checksum"):
                                                                                                        self.block_checksum = value
                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-count"):
                                                                                                        self.block_count = value
                                                                                                        self.block_count.value_namespace = name_space
                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-length"):
                                                                                                        self.block_length = value
                                                                                                        self.block_length.value_namespace = name_space
                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-signature"):
                                                                                                        self.block_signature = value
                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-version"):
                                                                                                        self.block_version = value
                                                                                                        self.block_version.value_namespace = name_space
                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "chassis-sid"):
                                                                                                        self.chassis_sid = value
                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "clei"):
                                                                                                        self.clei = value
                                                                                                        self.clei.value_namespace = name_space
                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-family"):
                                                                                                        self.controller_family = value
                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-type"):
                                                                                                        self.controller_type = value
                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "description"):
                                                                                                        self.description = value
                                                                                                        self.description.value_namespace = name_space
                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num1"):
                                                                                                        self.dev_num1 = value
                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num2"):
                                                                                                        self.dev_num2 = value
                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num3"):
                                                                                                        self.dev_num3 = value
                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num4"):
                                                                                                        self.dev_num4 = value
                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num5"):
                                                                                                        self.dev_num5 = value
                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num6"):
                                                                                                        self.dev_num6 = value
                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num7"):
                                                                                                        self.dev_num7 = value
                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eci"):
                                                                                                        self.eci = value
                                                                                                        self.eci.value_namespace = name_space
                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eeprom-size"):
                                                                                                        self.eeprom_size = value
                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "engineer-use"):
                                                                                                        self.engineer_use = value
                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-major-type"):
                                                                                                        self.fru_major_type = value
                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                        self.fru_minor_type = value
                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hw-version"):
                                                                                                        self.hw_version = value
                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hwid"):
                                                                                                        self.hwid = value
                                                                                                        self.hwid.value_namespace = name_space
                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                        self.idprom_format_rev = value
                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                        self.mac_add_blk_size1 = value
                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                        self.mac_add_blk_size2 = value
                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                        self.mac_add_blk_size3 = value
                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                        self.mac_add_blk_size4 = value
                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "manu-test-data"):
                                                                                                        self.manu_test_data = value
                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-bits"):
                                                                                                        self.mfg_bits = value
                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                        self.mfg_deviation = value
                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "oem-string"):
                                                                                                        self.oem_string = value
                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-number"):
                                                                                                        self.part_number = value
                                                                                                        self.part_number.value_namespace = name_space
                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-revision"):
                                                                                                        self.part_revision = value
                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pca-num"):
                                                                                                        self.pca_num = value
                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcavid"):
                                                                                                        self.pcavid = value
                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                        self.pcb_serial_num = value
                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pid"):
                                                                                                        self.pid = value
                                                                                                        self.pid.value_namespace = name_space
                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-consumption"):
                                                                                                        self.power_consumption = value
                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-supply-type"):
                                                                                                        self.power_supply_type = value
                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "product-id"):
                                                                                                        self.product_id = value
                                                                                                        self.product_id.value_namespace = name_space
                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "rma-code"):
                                                                                                        self.rma_code = value
                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "serial-number"):
                                                                                                        self.serial_number = value
                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "snmpoid"):
                                                                                                        self.snmpoid = value
                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                        self.top_assem_part_num = value
                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                        self.top_assem_vid = value
                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-description"):
                                                                                                        self.udi_description = value
                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-name"):
                                                                                                        self.udi_name = value
                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vid"):
                                                                                                        self.vid = value
                                                                                                        self.vid.value_namespace = name_space
                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.description.is_set or
                                                                                                    self.has_eeprom.is_set or
                                                                                                    self.inv_card_type.is_set or
                                                                                                    self.opaque_data.is_set or
                                                                                                    self.opaque_data_size.is_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "eeprom"):
                                                                                                    if (self.eeprom is None):
                                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                    return self.eeprom

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "has-eeprom"):
                                                                                                    self.has_eeprom = value
                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "inv-card-type"):
                                                                                                    self.inv_card_type = value
                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data"):
                                                                                                    self.opaque_data = value
                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data-size"):
                                                                                                    self.opaque_data_size = value
                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.module_done.is_set or
                                                                                                self.node_id.is_set or
                                                                                                self.vm_done.is_set or
                                                                                                self.vm_node_id.is_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "attributes" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                if (self.env_sensor_info is None):
                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                return self.env_sensor_info

                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                return self.env_sensor_info_xml

                                                                                            if (child_yang_name == "fru-info"):
                                                                                                if (self.fru_info is None):
                                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                return self.fru_info

                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                if (self.inv_asset_bag is None):
                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                return self.inv_asset_bag

                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                if (self.inv_basic_bag is None):
                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                return self.inv_basic_bag

                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                if (self.inv_eeprom_info is None):
                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                return self.inv_eeprom_info

                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                if (self.pwg_info is None):
                                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                return self.pwg_info

                                                                                            if (child_yang_name == "threshold"):
                                                                                                if (self.threshold is None):
                                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                return self.threshold

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "module-done"):
                                                                                                self.module_done = value
                                                                                                self.module_done.value_namespace = name_space
                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "node-id"):
                                                                                                self.node_id = value
                                                                                                self.node_id.value_namespace = name_space
                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-done"):
                                                                                                self.vm_done = value
                                                                                                self.vm_done.value_namespace = name_space
                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-node-id"):
                                                                                                self.vm_node_id = value
                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.name.is_set or
                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "tsi8" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "attributes"):
                                                                                            if (self.attributes is None):
                                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                            return self.attributes

                                                                                        if (child_yang_name == "tsi9s"):
                                                                                            if (self.tsi9s is None):
                                                                                                self.tsi9s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                                self.tsi9s.parent = self
                                                                                                self._children_name_map["tsi9s"] = "tsi9s"
                                                                                            return self.tsi9s

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "attributes" or name == "tsi9s" or name == "name"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "tsi8s" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "tsi8"):
                                                                                        for c in self.tsi8:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.tsi8.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "tsi8"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class Attributes(Entity):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                .. attribute:: module_done
                                                                                
                                                                                	Inventory EDM Module Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**default value**\: 1
                                                                                
                                                                                .. attribute:: node_id
                                                                                
                                                                                	Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                .. attribute:: vm_done
                                                                                
                                                                                	VM Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                .. attribute:: vm_node_id
                                                                                
                                                                                	VM Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                    self._children_yang_names.add("fru-info")

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                    self._children_yang_names.add("pwg-info")

                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                    self._children_yang_names.add("threshold")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("module_done",
                                                                                                    "node_id",
                                                                                                    "vm_done",
                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)


                                                                                class EnvSensorInfo(Entity):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("age_time_stamp",
                                                                                                        "alarm_type",
                                                                                                        "data_type",
                                                                                                        "device_description",
                                                                                                        "device_id",
                                                                                                        "field_validity_bitmap",
                                                                                                        "precision",
                                                                                                        "scale",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.age_time_stamp.is_set or
                                                                                            self.alarm_type.is_set or
                                                                                            self.data_type.is_set or
                                                                                            self.device_description.is_set or
                                                                                            self.device_id.is_set or
                                                                                            self.field_validity_bitmap.is_set or
                                                                                            self.precision.is_set or
                                                                                            self.scale.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "age-time-stamp"):
                                                                                            self.age_time_stamp = value
                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "alarm-type"):
                                                                                            self.alarm_type = value
                                                                                            self.alarm_type.value_namespace = name_space
                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-description"):
                                                                                            self.device_description = value
                                                                                            self.device_description.value_namespace = name_space
                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-id"):
                                                                                            self.device_id = value
                                                                                            self.device_id.value_namespace = name_space
                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                            self.field_validity_bitmap = value
                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "precision"):
                                                                                            self.precision = value
                                                                                            self.precision.value_namespace = name_space
                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "scale"):
                                                                                            self.scale = value
                                                                                            self.scale.value_namespace = name_space
                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class PwgInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("power_group_available_current",
                                                                                                        "power_group_drawn_current",
                                                                                                        "power_group_power_units",
                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.power_group_available_current.is_set or
                                                                                            self.power_group_drawn_current.is_set or
                                                                                            self.power_group_power_units.is_set or
                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "power-group-available-current"):
                                                                                            self.power_group_available_current = value
                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                            self.power_group_drawn_current = value
                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-power-units"):
                                                                                            self.power_group_power_units = value
                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                            self.power_group_redundancy_mode = value
                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                class EnvSensorInfoXml(Entity):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._children_yang_names.add("threshold")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("data_type",
                                                                                                        "description",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                    class Threshold(Entity):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                            self.threshold_array = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                        class ThresholdArray(Entity):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"

                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_name",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_name.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-name"):
                                                                                                    self.threshold_name = value
                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "threshold" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                for c in self.threshold_array:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.threshold_array.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "threshold-array"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.data_type.is_set or
                                                                                            self.description.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set or
                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "threshold"):
                                                                                            if (self.threshold is None):
                                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                            return self.threshold

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class InvAssetBag(Entity):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                        "manufacturer_assembly_revision",
                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                        "manufacturer_firmware_identifier",
                                                                                                        "manufacturer_software_identifier",
                                                                                                        "original_equipment_manufacturer_string",
                                                                                                        "part_number") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                            self.part_number.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                            self.manufacturer_assembly_number = value
                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                            self.manufacturer_assembly_revision = value
                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                            self.manufacturer_firmware_identifier = value
                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                            self.manufacturer_software_identifier = value
                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                            self.original_equipment_manufacturer_string = value
                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "part-number"):
                                                                                            self.part_number = value
                                                                                            self.part_number.value_namespace = name_space
                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                class Threshold(Entity):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                        self._children_yang_names.add("critical-hi")

                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                        self._children_yang_names.add("critical-lo")

                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                        self._children_yang_names.add("major-hi")

                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                        self._children_yang_names.add("major-lo")

                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                        self._children_yang_names.add("minor-hi")

                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._children_yang_names.add("minor-lo")


                                                                                    class MajorLo(Entity):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalHi(Entity):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorHi(Entity):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MajorHi(Entity):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalLo(Entity):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorLo(Entity):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "critical-hi"):
                                                                                            if (self.critical_hi is None):
                                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                            return self.critical_hi

                                                                                        if (child_yang_name == "critical-lo"):
                                                                                            if (self.critical_lo is None):
                                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                            return self.critical_lo

                                                                                        if (child_yang_name == "major-hi"):
                                                                                            if (self.major_hi is None):
                                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                            return self.major_hi

                                                                                        if (child_yang_name == "major-lo"):
                                                                                            if (self.major_lo is None):
                                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                            return self.major_lo

                                                                                        if (child_yang_name == "minor-hi"):
                                                                                            if (self.minor_hi is None):
                                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                            return self.minor_hi

                                                                                        if (child_yang_name == "minor-lo"):
                                                                                            if (self.minor_lo is None):
                                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                            return self.minor_lo

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        pass


                                                                                class FruInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._children_yang_names.add("card-up-time")

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("card_administrative_state",
                                                                                                        "card_monitor_state",
                                                                                                        "card_operational_state",
                                                                                                        "card_reset_reason",
                                                                                                        "power_administrative_state",
                                                                                                        "power_current_measurement",
                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                    class LastOperationalStateChange(Entity):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                    class CardUpTime(Entity):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.card_administrative_state.is_set or
                                                                                            self.card_monitor_state.is_set or
                                                                                            self.card_operational_state.is_set or
                                                                                            self.card_reset_reason.is_set or
                                                                                            self.power_administrative_state.is_set or
                                                                                            self.power_current_measurement.is_set or
                                                                                            self.power_operational_state.is_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "card-up-time"):
                                                                                            if (self.card_up_time is None):
                                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                            return self.card_up_time

                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                            if (self.last_operational_state_change is None):
                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                            return self.last_operational_state_change

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "card-administrative-state"):
                                                                                            self.card_administrative_state = value
                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-monitor-state"):
                                                                                            self.card_monitor_state = value
                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-operational-state"):
                                                                                            self.card_operational_state = value
                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-reset-reason"):
                                                                                            self.card_reset_reason = value
                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-administrative-state"):
                                                                                            self.power_administrative_state = value
                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-current-measurement"):
                                                                                            self.power_current_measurement = value
                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-operational-state"):
                                                                                            self.power_operational_state = value
                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                class InvBasicBag(Entity):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("alias",
                                                                                                        "asset_id_str",
                                                                                                        "asset_identification",
                                                                                                        "ceport",
                                                                                                        "chip_hardware_revision",
                                                                                                        "composite_class_code",
                                                                                                        "description",
                                                                                                        "environmental_monitor_path",
                                                                                                        "firmware_revision",
                                                                                                        "group_flag",
                                                                                                        "hardware_revision",
                                                                                                        "is_field_replaceable_unit",
                                                                                                        "manufacturer_asset_tags",
                                                                                                        "manufacturer_name",
                                                                                                        "memory_size",
                                                                                                        "model_name",
                                                                                                        "name",
                                                                                                        "new_deviation_number",
                                                                                                        "physical_layer_interface_module_type",
                                                                                                        "redundancystate",
                                                                                                        "serial_number",
                                                                                                        "software_revision",
                                                                                                        "unique_id",
                                                                                                        "unrecognized_fru",
                                                                                                        "vendor_type",
                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.alias.is_set or
                                                                                            self.asset_id_str.is_set or
                                                                                            self.asset_identification.is_set or
                                                                                            self.ceport.is_set or
                                                                                            self.chip_hardware_revision.is_set or
                                                                                            self.composite_class_code.is_set or
                                                                                            self.description.is_set or
                                                                                            self.environmental_monitor_path.is_set or
                                                                                            self.firmware_revision.is_set or
                                                                                            self.group_flag.is_set or
                                                                                            self.hardware_revision.is_set or
                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                            self.manufacturer_name.is_set or
                                                                                            self.memory_size.is_set or
                                                                                            self.model_name.is_set or
                                                                                            self.name.is_set or
                                                                                            self.new_deviation_number.is_set or
                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                            self.redundancystate.is_set or
                                                                                            self.serial_number.is_set or
                                                                                            self.software_revision.is_set or
                                                                                            self.unique_id.is_set or
                                                                                            self.unrecognized_fru.is_set or
                                                                                            self.vendor_type.is_set or
                                                                                            self.xr_scoped.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "alias"):
                                                                                            self.alias = value
                                                                                            self.alias.value_namespace = name_space
                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-id-str"):
                                                                                            self.asset_id_str = value
                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-identification"):
                                                                                            self.asset_identification = value
                                                                                            self.asset_identification.value_namespace = name_space
                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "ceport"):
                                                                                            self.ceport = value
                                                                                            self.ceport.value_namespace = name_space
                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                            self.chip_hardware_revision = value
                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "composite-class-code"):
                                                                                            self.composite_class_code = value
                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                            self.environmental_monitor_path = value
                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "firmware-revision"):
                                                                                            self.firmware_revision = value
                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "group-flag"):
                                                                                            self.group_flag = value
                                                                                            self.group_flag.value_namespace = name_space
                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "hardware-revision"):
                                                                                            self.hardware_revision = value
                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                            self.is_field_replaceable_unit = value
                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                            self.manufacturer_asset_tags = value
                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-name"):
                                                                                            self.manufacturer_name = value
                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "memory-size"):
                                                                                            self.memory_size = value
                                                                                            self.memory_size.value_namespace = name_space
                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "model-name"):
                                                                                            self.model_name = value
                                                                                            self.model_name.value_namespace = name_space
                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "new-deviation-number"):
                                                                                            self.new_deviation_number = value
                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                            self.physical_layer_interface_module_type = value
                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "redundancystate"):
                                                                                            self.redundancystate = value
                                                                                            self.redundancystate.value_namespace = name_space
                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "serial-number"):
                                                                                            self.serial_number = value
                                                                                            self.serial_number.value_namespace = name_space
                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "software-revision"):
                                                                                            self.software_revision = value
                                                                                            self.software_revision.value_namespace = name_space
                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unique-id"):
                                                                                            self.unique_id = value
                                                                                            self.unique_id.value_namespace = name_space
                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unrecognized-fru"):
                                                                                            self.unrecognized_fru = value
                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "vendor-type"):
                                                                                            self.vendor_type = value
                                                                                            self.vendor_type.value_namespace = name_space
                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "xr-scoped"):
                                                                                            self.xr_scoped = value
                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                class InvEepromInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._children_yang_names.add("eeprom")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("description",
                                                                                                        "has_eeprom",
                                                                                                        "inv_card_type",
                                                                                                        "opaque_data",
                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                    class Eeprom(Entity):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._children_yang_names.add("rma")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("asset_alias",
                                                                                                            "asset_id",
                                                                                                            "base_mac_address1",
                                                                                                            "base_mac_address2",
                                                                                                            "base_mac_address3",
                                                                                                            "base_mac_address4",
                                                                                                            "block_checksum",
                                                                                                            "block_count",
                                                                                                            "block_length",
                                                                                                            "block_signature",
                                                                                                            "block_version",
                                                                                                            "chassis_sid",
                                                                                                            "clei",
                                                                                                            "controller_family",
                                                                                                            "controller_type",
                                                                                                            "description",
                                                                                                            "dev_num1",
                                                                                                            "dev_num2",
                                                                                                            "dev_num3",
                                                                                                            "dev_num4",
                                                                                                            "dev_num5",
                                                                                                            "dev_num6",
                                                                                                            "dev_num7",
                                                                                                            "eci",
                                                                                                            "eeprom_size",
                                                                                                            "engineer_use",
                                                                                                            "fru_major_type",
                                                                                                            "fru_minor_type",
                                                                                                            "hw_version",
                                                                                                            "hwid",
                                                                                                            "idprom_format_rev",
                                                                                                            "mac_add_blk_size1",
                                                                                                            "mac_add_blk_size2",
                                                                                                            "mac_add_blk_size3",
                                                                                                            "mac_add_blk_size4",
                                                                                                            "manu_test_data",
                                                                                                            "mfg_bits",
                                                                                                            "mfg_deviation",
                                                                                                            "oem_string",
                                                                                                            "part_number",
                                                                                                            "part_revision",
                                                                                                            "pca_num",
                                                                                                            "pcavid",
                                                                                                            "pcb_serial_num",
                                                                                                            "pid",
                                                                                                            "power_consumption",
                                                                                                            "power_supply_type",
                                                                                                            "product_id",
                                                                                                            "rma_code",
                                                                                                            "serial_number",
                                                                                                            "snmpoid",
                                                                                                            "top_assem_part_num",
                                                                                                            "top_assem_vid",
                                                                                                            "udi_description",
                                                                                                            "udi_name",
                                                                                                            "vid") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                        class Rma(Entity):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"

                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("rma_history",
                                                                                                                "rma_number",
                                                                                                                "test_history") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.rma_history.is_set or
                                                                                                    self.rma_number.is_set or
                                                                                                    self.test_history.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "rma" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "rma-history"):
                                                                                                    self.rma_history = value
                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "rma-number"):
                                                                                                    self.rma_number = value
                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "test-history"):
                                                                                                    self.test_history = value
                                                                                                    self.test_history.value_namespace = name_space
                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.asset_alias.is_set or
                                                                                                self.asset_id.is_set or
                                                                                                self.base_mac_address1.is_set or
                                                                                                self.base_mac_address2.is_set or
                                                                                                self.base_mac_address3.is_set or
                                                                                                self.base_mac_address4.is_set or
                                                                                                self.block_checksum.is_set or
                                                                                                self.block_count.is_set or
                                                                                                self.block_length.is_set or
                                                                                                self.block_signature.is_set or
                                                                                                self.block_version.is_set or
                                                                                                self.chassis_sid.is_set or
                                                                                                self.clei.is_set or
                                                                                                self.controller_family.is_set or
                                                                                                self.controller_type.is_set or
                                                                                                self.description.is_set or
                                                                                                self.dev_num1.is_set or
                                                                                                self.dev_num2.is_set or
                                                                                                self.dev_num3.is_set or
                                                                                                self.dev_num4.is_set or
                                                                                                self.dev_num5.is_set or
                                                                                                self.dev_num6.is_set or
                                                                                                self.dev_num7.is_set or
                                                                                                self.eci.is_set or
                                                                                                self.eeprom_size.is_set or
                                                                                                self.engineer_use.is_set or
                                                                                                self.fru_major_type.is_set or
                                                                                                self.fru_minor_type.is_set or
                                                                                                self.hw_version.is_set or
                                                                                                self.hwid.is_set or
                                                                                                self.idprom_format_rev.is_set or
                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                self.manu_test_data.is_set or
                                                                                                self.mfg_bits.is_set or
                                                                                                self.mfg_deviation.is_set or
                                                                                                self.oem_string.is_set or
                                                                                                self.part_number.is_set or
                                                                                                self.part_revision.is_set or
                                                                                                self.pca_num.is_set or
                                                                                                self.pcavid.is_set or
                                                                                                self.pcb_serial_num.is_set or
                                                                                                self.pid.is_set or
                                                                                                self.power_consumption.is_set or
                                                                                                self.power_supply_type.is_set or
                                                                                                self.product_id.is_set or
                                                                                                self.rma_code.is_set or
                                                                                                self.serial_number.is_set or
                                                                                                self.snmpoid.is_set or
                                                                                                self.top_assem_part_num.is_set or
                                                                                                self.top_assem_vid.is_set or
                                                                                                self.udi_description.is_set or
                                                                                                self.udi_name.is_set or
                                                                                                self.vid.is_set or
                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "rma"):
                                                                                                if (self.rma is None):
                                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                return self.rma

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "asset-alias"):
                                                                                                self.asset_alias = value
                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "asset-id"):
                                                                                                self.asset_id = value
                                                                                                self.asset_id.value_namespace = name_space
                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address1"):
                                                                                                self.base_mac_address1 = value
                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address2"):
                                                                                                self.base_mac_address2 = value
                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address3"):
                                                                                                self.base_mac_address3 = value
                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address4"):
                                                                                                self.base_mac_address4 = value
                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-checksum"):
                                                                                                self.block_checksum = value
                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-count"):
                                                                                                self.block_count = value
                                                                                                self.block_count.value_namespace = name_space
                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-length"):
                                                                                                self.block_length = value
                                                                                                self.block_length.value_namespace = name_space
                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-signature"):
                                                                                                self.block_signature = value
                                                                                                self.block_signature.value_namespace = name_space
                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-version"):
                                                                                                self.block_version = value
                                                                                                self.block_version.value_namespace = name_space
                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "chassis-sid"):
                                                                                                self.chassis_sid = value
                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "clei"):
                                                                                                self.clei = value
                                                                                                self.clei.value_namespace = name_space
                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-family"):
                                                                                                self.controller_family = value
                                                                                                self.controller_family.value_namespace = name_space
                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-type"):
                                                                                                self.controller_type = value
                                                                                                self.controller_type.value_namespace = name_space
                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "description"):
                                                                                                self.description = value
                                                                                                self.description.value_namespace = name_space
                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num1"):
                                                                                                self.dev_num1 = value
                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num2"):
                                                                                                self.dev_num2 = value
                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num3"):
                                                                                                self.dev_num3 = value
                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num4"):
                                                                                                self.dev_num4 = value
                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num5"):
                                                                                                self.dev_num5 = value
                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num6"):
                                                                                                self.dev_num6 = value
                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num7"):
                                                                                                self.dev_num7 = value
                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eci"):
                                                                                                self.eci = value
                                                                                                self.eci.value_namespace = name_space
                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eeprom-size"):
                                                                                                self.eeprom_size = value
                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "engineer-use"):
                                                                                                self.engineer_use = value
                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-major-type"):
                                                                                                self.fru_major_type = value
                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-minor-type"):
                                                                                                self.fru_minor_type = value
                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hw-version"):
                                                                                                self.hw_version = value
                                                                                                self.hw_version.value_namespace = name_space
                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hwid"):
                                                                                                self.hwid = value
                                                                                                self.hwid.value_namespace = name_space
                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                self.idprom_format_rev = value
                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                self.mac_add_blk_size1 = value
                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                self.mac_add_blk_size2 = value
                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                self.mac_add_blk_size3 = value
                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                self.mac_add_blk_size4 = value
                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "manu-test-data"):
                                                                                                self.manu_test_data = value
                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-bits"):
                                                                                                self.mfg_bits = value
                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-deviation"):
                                                                                                self.mfg_deviation = value
                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "oem-string"):
                                                                                                self.oem_string = value
                                                                                                self.oem_string.value_namespace = name_space
                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-number"):
                                                                                                self.part_number = value
                                                                                                self.part_number.value_namespace = name_space
                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-revision"):
                                                                                                self.part_revision = value
                                                                                                self.part_revision.value_namespace = name_space
                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pca-num"):
                                                                                                self.pca_num = value
                                                                                                self.pca_num.value_namespace = name_space
                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcavid"):
                                                                                                self.pcavid = value
                                                                                                self.pcavid.value_namespace = name_space
                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                self.pcb_serial_num = value
                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pid"):
                                                                                                self.pid = value
                                                                                                self.pid.value_namespace = name_space
                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-consumption"):
                                                                                                self.power_consumption = value
                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-supply-type"):
                                                                                                self.power_supply_type = value
                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "product-id"):
                                                                                                self.product_id = value
                                                                                                self.product_id.value_namespace = name_space
                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "rma-code"):
                                                                                                self.rma_code = value
                                                                                                self.rma_code.value_namespace = name_space
                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "serial-number"):
                                                                                                self.serial_number = value
                                                                                                self.serial_number.value_namespace = name_space
                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "snmpoid"):
                                                                                                self.snmpoid = value
                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                self.top_assem_part_num = value
                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-vid"):
                                                                                                self.top_assem_vid = value
                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-description"):
                                                                                                self.udi_description = value
                                                                                                self.udi_description.value_namespace = name_space
                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-name"):
                                                                                                self.udi_name = value
                                                                                                self.udi_name.value_namespace = name_space
                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vid"):
                                                                                                self.vid = value
                                                                                                self.vid.value_namespace = name_space
                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.description.is_set or
                                                                                            self.has_eeprom.is_set or
                                                                                            self.inv_card_type.is_set or
                                                                                            self.opaque_data.is_set or
                                                                                            self.opaque_data_size.is_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "eeprom"):
                                                                                            if (self.eeprom is None):
                                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                            return self.eeprom

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "has-eeprom"):
                                                                                            self.has_eeprom = value
                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "inv-card-type"):
                                                                                            self.inv_card_type = value
                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data"):
                                                                                            self.opaque_data = value
                                                                                            self.opaque_data.value_namespace = name_space
                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data-size"):
                                                                                            self.opaque_data_size = value
                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.module_done.is_set or
                                                                                        self.node_id.is_set or
                                                                                        self.vm_done.is_set or
                                                                                        self.vm_node_id.is_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "attributes" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                        if (self.env_sensor_info is None):
                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                        return self.env_sensor_info

                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                        if (self.env_sensor_info_xml is None):
                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                        return self.env_sensor_info_xml

                                                                                    if (child_yang_name == "fru-info"):
                                                                                        if (self.fru_info is None):
                                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                        return self.fru_info

                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                        if (self.inv_asset_bag is None):
                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                        return self.inv_asset_bag

                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                        if (self.inv_basic_bag is None):
                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                        return self.inv_basic_bag

                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                        if (self.inv_eeprom_info is None):
                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                        return self.inv_eeprom_info

                                                                                    if (child_yang_name == "pwg-info"):
                                                                                        if (self.pwg_info is None):
                                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                        return self.pwg_info

                                                                                    if (child_yang_name == "threshold"):
                                                                                        if (self.threshold is None):
                                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                        return self.threshold

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "module-done"):
                                                                                        self.module_done = value
                                                                                        self.module_done.value_namespace = name_space
                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "node-id"):
                                                                                        self.node_id = value
                                                                                        self.node_id.value_namespace = name_space
                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-done"):
                                                                                        self.vm_done = value
                                                                                        self.vm_done.value_namespace = name_space
                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-node-id"):
                                                                                        self.vm_node_id = value
                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.name.is_set or
                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "tsi7" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "attributes"):
                                                                                    if (self.attributes is None):
                                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                    return self.attributes

                                                                                if (child_yang_name == "tsi8s"):
                                                                                    if (self.tsi8s is None):
                                                                                        self.tsi8s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                        self.tsi8s.parent = self
                                                                                        self._children_name_map["tsi8s"] = "tsi8s"
                                                                                    return self.tsi8s

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "attributes" or name == "tsi8s" or name == "name"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "tsi7s" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "tsi7"):
                                                                                for c in self.tsi7:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.tsi7.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "tsi7"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class Attributes(Entity):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        .. attribute:: module_done
                                                                        
                                                                        	Inventory EDM Module Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**default value**\: 1
                                                                        
                                                                        .. attribute:: node_id
                                                                        
                                                                        	Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        .. attribute:: vm_done
                                                                        
                                                                        	VM Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        .. attribute:: vm_node_id
                                                                        
                                                                        	VM Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                            self._children_yang_names.add("env-sensor-info")

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                            self._children_yang_names.add("fru-info")

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                            self._children_yang_names.add("pwg-info")

                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                            self._children_yang_names.add("threshold")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("module_done",
                                                                                            "node_id",
                                                                                            "vm_done",
                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)


                                                                        class EnvSensorInfo(Entity):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                self.units = YLeaf(YType.str, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("age_time_stamp",
                                                                                                "alarm_type",
                                                                                                "data_type",
                                                                                                "device_description",
                                                                                                "device_id",
                                                                                                "field_validity_bitmap",
                                                                                                "precision",
                                                                                                "scale",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.age_time_stamp.is_set or
                                                                                    self.alarm_type.is_set or
                                                                                    self.data_type.is_set or
                                                                                    self.device_description.is_set or
                                                                                    self.device_id.is_set or
                                                                                    self.field_validity_bitmap.is_set or
                                                                                    self.precision.is_set or
                                                                                    self.scale.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "age-time-stamp"):
                                                                                    self.age_time_stamp = value
                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "alarm-type"):
                                                                                    self.alarm_type = value
                                                                                    self.alarm_type.value_namespace = name_space
                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-description"):
                                                                                    self.device_description = value
                                                                                    self.device_description.value_namespace = name_space
                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-id"):
                                                                                    self.device_id = value
                                                                                    self.device_id.value_namespace = name_space
                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "field-validity-bitmap"):
                                                                                    self.field_validity_bitmap = value
                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "precision"):
                                                                                    self.precision = value
                                                                                    self.precision.value_namespace = name_space
                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "scale"):
                                                                                    self.scale = value
                                                                                    self.scale.value_namespace = name_space
                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class PwgInfo(Entity):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("power_group_available_current",
                                                                                                "power_group_drawn_current",
                                                                                                "power_group_power_units",
                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.power_group_available_current.is_set or
                                                                                    self.power_group_drawn_current.is_set or
                                                                                    self.power_group_power_units.is_set or
                                                                                    self.power_group_redundancy_mode.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "power-group-available-current"):
                                                                                    self.power_group_available_current = value
                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-drawn-current"):
                                                                                    self.power_group_drawn_current = value
                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-power-units"):
                                                                                    self.power_group_power_units = value
                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                    self.power_group_redundancy_mode = value
                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                        class EnvSensorInfoXml(Entity):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.str, "value")

                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._children_yang_names.add("threshold")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("data_type",
                                                                                                "description",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                            class Threshold(Entity):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                    self.threshold_array = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                class ThresholdArray(Entity):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"

                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_name",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_name.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-name"):
                                                                                            self.threshold_name = value
                                                                                            self.threshold_name.value_namespace = name_space
                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "threshold" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "threshold-array"):
                                                                                        for c in self.threshold_array:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.threshold_array.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "threshold-array"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.data_type.is_set or
                                                                                    self.description.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set or
                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "threshold"):
                                                                                    if (self.threshold is None):
                                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                    return self.threshold

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class InvAssetBag(Entity):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                "manufacturer_assembly_revision",
                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                "manufacturer_firmware_identifier",
                                                                                                "manufacturer_software_identifier",
                                                                                                "original_equipment_manufacturer_string",
                                                                                                "part_number") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                    self.part_number.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                    self.manufacturer_assembly_number = value
                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                    self.manufacturer_assembly_revision = value
                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                    self.manufacturer_firmware_identifier = value
                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                    self.manufacturer_software_identifier = value
                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                    self.original_equipment_manufacturer_string = value
                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "part-number"):
                                                                                    self.part_number = value
                                                                                    self.part_number.value_namespace = name_space
                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                        class Threshold(Entity):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                self._children_yang_names.add("critical-hi")

                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                self._children_yang_names.add("critical-lo")

                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                self._children_yang_names.add("major-hi")

                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                self._children_yang_names.add("major-lo")

                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                self._children_yang_names.add("minor-hi")

                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._children_yang_names.add("minor-lo")


                                                                            class MajorLo(Entity):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalHi(Entity):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorHi(Entity):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MajorHi(Entity):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalLo(Entity):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorLo(Entity):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "critical-hi"):
                                                                                    if (self.critical_hi is None):
                                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                    return self.critical_hi

                                                                                if (child_yang_name == "critical-lo"):
                                                                                    if (self.critical_lo is None):
                                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                    return self.critical_lo

                                                                                if (child_yang_name == "major-hi"):
                                                                                    if (self.major_hi is None):
                                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                    return self.major_hi

                                                                                if (child_yang_name == "major-lo"):
                                                                                    if (self.major_lo is None):
                                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                    return self.major_lo

                                                                                if (child_yang_name == "minor-hi"):
                                                                                    if (self.minor_hi is None):
                                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                    return self.minor_hi

                                                                                if (child_yang_name == "minor-lo"):
                                                                                    if (self.minor_lo is None):
                                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                    return self.minor_lo

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                pass


                                                                        class FruInfo(Entity):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._children_yang_names.add("card-up-time")

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("card_administrative_state",
                                                                                                "card_monitor_state",
                                                                                                "card_operational_state",
                                                                                                "card_reset_reason",
                                                                                                "power_administrative_state",
                                                                                                "power_current_measurement",
                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)


                                                                            class LastOperationalStateChange(Entity):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                            class CardUpTime(Entity):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.card_administrative_state.is_set or
                                                                                    self.card_monitor_state.is_set or
                                                                                    self.card_operational_state.is_set or
                                                                                    self.card_reset_reason.is_set or
                                                                                    self.power_administrative_state.is_set or
                                                                                    self.power_current_measurement.is_set or
                                                                                    self.power_operational_state.is_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "fru-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "card-up-time"):
                                                                                    if (self.card_up_time is None):
                                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                    return self.card_up_time

                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                    if (self.last_operational_state_change is None):
                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                    return self.last_operational_state_change

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "card-administrative-state"):
                                                                                    self.card_administrative_state = value
                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-monitor-state"):
                                                                                    self.card_monitor_state = value
                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-operational-state"):
                                                                                    self.card_operational_state = value
                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-reset-reason"):
                                                                                    self.card_reset_reason = value
                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-administrative-state"):
                                                                                    self.power_administrative_state = value
                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-current-measurement"):
                                                                                    self.power_current_measurement = value
                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-operational-state"):
                                                                                    self.power_operational_state = value
                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                        class InvBasicBag(Entity):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("alias",
                                                                                                "asset_id_str",
                                                                                                "asset_identification",
                                                                                                "ceport",
                                                                                                "chip_hardware_revision",
                                                                                                "composite_class_code",
                                                                                                "description",
                                                                                                "environmental_monitor_path",
                                                                                                "firmware_revision",
                                                                                                "group_flag",
                                                                                                "hardware_revision",
                                                                                                "is_field_replaceable_unit",
                                                                                                "manufacturer_asset_tags",
                                                                                                "manufacturer_name",
                                                                                                "memory_size",
                                                                                                "model_name",
                                                                                                "name",
                                                                                                "new_deviation_number",
                                                                                                "physical_layer_interface_module_type",
                                                                                                "redundancystate",
                                                                                                "serial_number",
                                                                                                "software_revision",
                                                                                                "unique_id",
                                                                                                "unrecognized_fru",
                                                                                                "vendor_type",
                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.alias.is_set or
                                                                                    self.asset_id_str.is_set or
                                                                                    self.asset_identification.is_set or
                                                                                    self.ceport.is_set or
                                                                                    self.chip_hardware_revision.is_set or
                                                                                    self.composite_class_code.is_set or
                                                                                    self.description.is_set or
                                                                                    self.environmental_monitor_path.is_set or
                                                                                    self.firmware_revision.is_set or
                                                                                    self.group_flag.is_set or
                                                                                    self.hardware_revision.is_set or
                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                    self.manufacturer_name.is_set or
                                                                                    self.memory_size.is_set or
                                                                                    self.model_name.is_set or
                                                                                    self.name.is_set or
                                                                                    self.new_deviation_number.is_set or
                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                    self.redundancystate.is_set or
                                                                                    self.serial_number.is_set or
                                                                                    self.software_revision.is_set or
                                                                                    self.unique_id.is_set or
                                                                                    self.unrecognized_fru.is_set or
                                                                                    self.vendor_type.is_set or
                                                                                    self.xr_scoped.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "alias"):
                                                                                    self.alias = value
                                                                                    self.alias.value_namespace = name_space
                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-id-str"):
                                                                                    self.asset_id_str = value
                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-identification"):
                                                                                    self.asset_identification = value
                                                                                    self.asset_identification.value_namespace = name_space
                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "ceport"):
                                                                                    self.ceport = value
                                                                                    self.ceport.value_namespace = name_space
                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "chip-hardware-revision"):
                                                                                    self.chip_hardware_revision = value
                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "composite-class-code"):
                                                                                    self.composite_class_code = value
                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "environmental-monitor-path"):
                                                                                    self.environmental_monitor_path = value
                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "firmware-revision"):
                                                                                    self.firmware_revision = value
                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "group-flag"):
                                                                                    self.group_flag = value
                                                                                    self.group_flag.value_namespace = name_space
                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "hardware-revision"):
                                                                                    self.hardware_revision = value
                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                    self.is_field_replaceable_unit = value
                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                    self.manufacturer_asset_tags = value
                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-name"):
                                                                                    self.manufacturer_name = value
                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "memory-size"):
                                                                                    self.memory_size = value
                                                                                    self.memory_size.value_namespace = name_space
                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "model-name"):
                                                                                    self.model_name = value
                                                                                    self.model_name.value_namespace = name_space
                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "new-deviation-number"):
                                                                                    self.new_deviation_number = value
                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                    self.physical_layer_interface_module_type = value
                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "redundancystate"):
                                                                                    self.redundancystate = value
                                                                                    self.redundancystate.value_namespace = name_space
                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "serial-number"):
                                                                                    self.serial_number = value
                                                                                    self.serial_number.value_namespace = name_space
                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "software-revision"):
                                                                                    self.software_revision = value
                                                                                    self.software_revision.value_namespace = name_space
                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unique-id"):
                                                                                    self.unique_id = value
                                                                                    self.unique_id.value_namespace = name_space
                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unrecognized-fru"):
                                                                                    self.unrecognized_fru = value
                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "vendor-type"):
                                                                                    self.vendor_type = value
                                                                                    self.vendor_type.value_namespace = name_space
                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "xr-scoped"):
                                                                                    self.xr_scoped = value
                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                        class InvEepromInfo(Entity):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._children_yang_names.add("eeprom")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("description",
                                                                                                "has_eeprom",
                                                                                                "inv_card_type",
                                                                                                "opaque_data",
                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                            class Eeprom(Entity):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._children_yang_names.add("rma")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("asset_alias",
                                                                                                    "asset_id",
                                                                                                    "base_mac_address1",
                                                                                                    "base_mac_address2",
                                                                                                    "base_mac_address3",
                                                                                                    "base_mac_address4",
                                                                                                    "block_checksum",
                                                                                                    "block_count",
                                                                                                    "block_length",
                                                                                                    "block_signature",
                                                                                                    "block_version",
                                                                                                    "chassis_sid",
                                                                                                    "clei",
                                                                                                    "controller_family",
                                                                                                    "controller_type",
                                                                                                    "description",
                                                                                                    "dev_num1",
                                                                                                    "dev_num2",
                                                                                                    "dev_num3",
                                                                                                    "dev_num4",
                                                                                                    "dev_num5",
                                                                                                    "dev_num6",
                                                                                                    "dev_num7",
                                                                                                    "eci",
                                                                                                    "eeprom_size",
                                                                                                    "engineer_use",
                                                                                                    "fru_major_type",
                                                                                                    "fru_minor_type",
                                                                                                    "hw_version",
                                                                                                    "hwid",
                                                                                                    "idprom_format_rev",
                                                                                                    "mac_add_blk_size1",
                                                                                                    "mac_add_blk_size2",
                                                                                                    "mac_add_blk_size3",
                                                                                                    "mac_add_blk_size4",
                                                                                                    "manu_test_data",
                                                                                                    "mfg_bits",
                                                                                                    "mfg_deviation",
                                                                                                    "oem_string",
                                                                                                    "part_number",
                                                                                                    "part_revision",
                                                                                                    "pca_num",
                                                                                                    "pcavid",
                                                                                                    "pcb_serial_num",
                                                                                                    "pid",
                                                                                                    "power_consumption",
                                                                                                    "power_supply_type",
                                                                                                    "product_id",
                                                                                                    "rma_code",
                                                                                                    "serial_number",
                                                                                                    "snmpoid",
                                                                                                    "top_assem_part_num",
                                                                                                    "top_assem_vid",
                                                                                                    "udi_description",
                                                                                                    "udi_name",
                                                                                                    "vid") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                class Rma(Entity):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"

                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("rma_history",
                                                                                                        "rma_number",
                                                                                                        "test_history") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.rma_history.is_set or
                                                                                            self.rma_number.is_set or
                                                                                            self.test_history.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "rma" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "rma-history"):
                                                                                            self.rma_history = value
                                                                                            self.rma_history.value_namespace = name_space
                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "rma-number"):
                                                                                            self.rma_number = value
                                                                                            self.rma_number.value_namespace = name_space
                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "test-history"):
                                                                                            self.test_history = value
                                                                                            self.test_history.value_namespace = name_space
                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.asset_alias.is_set or
                                                                                        self.asset_id.is_set or
                                                                                        self.base_mac_address1.is_set or
                                                                                        self.base_mac_address2.is_set or
                                                                                        self.base_mac_address3.is_set or
                                                                                        self.base_mac_address4.is_set or
                                                                                        self.block_checksum.is_set or
                                                                                        self.block_count.is_set or
                                                                                        self.block_length.is_set or
                                                                                        self.block_signature.is_set or
                                                                                        self.block_version.is_set or
                                                                                        self.chassis_sid.is_set or
                                                                                        self.clei.is_set or
                                                                                        self.controller_family.is_set or
                                                                                        self.controller_type.is_set or
                                                                                        self.description.is_set or
                                                                                        self.dev_num1.is_set or
                                                                                        self.dev_num2.is_set or
                                                                                        self.dev_num3.is_set or
                                                                                        self.dev_num4.is_set or
                                                                                        self.dev_num5.is_set or
                                                                                        self.dev_num6.is_set or
                                                                                        self.dev_num7.is_set or
                                                                                        self.eci.is_set or
                                                                                        self.eeprom_size.is_set or
                                                                                        self.engineer_use.is_set or
                                                                                        self.fru_major_type.is_set or
                                                                                        self.fru_minor_type.is_set or
                                                                                        self.hw_version.is_set or
                                                                                        self.hwid.is_set or
                                                                                        self.idprom_format_rev.is_set or
                                                                                        self.mac_add_blk_size1.is_set or
                                                                                        self.mac_add_blk_size2.is_set or
                                                                                        self.mac_add_blk_size3.is_set or
                                                                                        self.mac_add_blk_size4.is_set or
                                                                                        self.manu_test_data.is_set or
                                                                                        self.mfg_bits.is_set or
                                                                                        self.mfg_deviation.is_set or
                                                                                        self.oem_string.is_set or
                                                                                        self.part_number.is_set or
                                                                                        self.part_revision.is_set or
                                                                                        self.pca_num.is_set or
                                                                                        self.pcavid.is_set or
                                                                                        self.pcb_serial_num.is_set or
                                                                                        self.pid.is_set or
                                                                                        self.power_consumption.is_set or
                                                                                        self.power_supply_type.is_set or
                                                                                        self.product_id.is_set or
                                                                                        self.rma_code.is_set or
                                                                                        self.serial_number.is_set or
                                                                                        self.snmpoid.is_set or
                                                                                        self.top_assem_part_num.is_set or
                                                                                        self.top_assem_vid.is_set or
                                                                                        self.udi_description.is_set or
                                                                                        self.udi_name.is_set or
                                                                                        self.vid.is_set or
                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "rma"):
                                                                                        if (self.rma is None):
                                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                        return self.rma

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "asset-alias"):
                                                                                        self.asset_alias = value
                                                                                        self.asset_alias.value_namespace = name_space
                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "asset-id"):
                                                                                        self.asset_id = value
                                                                                        self.asset_id.value_namespace = name_space
                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address1"):
                                                                                        self.base_mac_address1 = value
                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address2"):
                                                                                        self.base_mac_address2 = value
                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address3"):
                                                                                        self.base_mac_address3 = value
                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address4"):
                                                                                        self.base_mac_address4 = value
                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-checksum"):
                                                                                        self.block_checksum = value
                                                                                        self.block_checksum.value_namespace = name_space
                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-count"):
                                                                                        self.block_count = value
                                                                                        self.block_count.value_namespace = name_space
                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-length"):
                                                                                        self.block_length = value
                                                                                        self.block_length.value_namespace = name_space
                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-signature"):
                                                                                        self.block_signature = value
                                                                                        self.block_signature.value_namespace = name_space
                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-version"):
                                                                                        self.block_version = value
                                                                                        self.block_version.value_namespace = name_space
                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "chassis-sid"):
                                                                                        self.chassis_sid = value
                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "clei"):
                                                                                        self.clei = value
                                                                                        self.clei.value_namespace = name_space
                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-family"):
                                                                                        self.controller_family = value
                                                                                        self.controller_family.value_namespace = name_space
                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-type"):
                                                                                        self.controller_type = value
                                                                                        self.controller_type.value_namespace = name_space
                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "description"):
                                                                                        self.description = value
                                                                                        self.description.value_namespace = name_space
                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num1"):
                                                                                        self.dev_num1 = value
                                                                                        self.dev_num1.value_namespace = name_space
                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num2"):
                                                                                        self.dev_num2 = value
                                                                                        self.dev_num2.value_namespace = name_space
                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num3"):
                                                                                        self.dev_num3 = value
                                                                                        self.dev_num3.value_namespace = name_space
                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num4"):
                                                                                        self.dev_num4 = value
                                                                                        self.dev_num4.value_namespace = name_space
                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num5"):
                                                                                        self.dev_num5 = value
                                                                                        self.dev_num5.value_namespace = name_space
                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num6"):
                                                                                        self.dev_num6 = value
                                                                                        self.dev_num6.value_namespace = name_space
                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num7"):
                                                                                        self.dev_num7 = value
                                                                                        self.dev_num7.value_namespace = name_space
                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eci"):
                                                                                        self.eci = value
                                                                                        self.eci.value_namespace = name_space
                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eeprom-size"):
                                                                                        self.eeprom_size = value
                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "engineer-use"):
                                                                                        self.engineer_use = value
                                                                                        self.engineer_use.value_namespace = name_space
                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-major-type"):
                                                                                        self.fru_major_type = value
                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-minor-type"):
                                                                                        self.fru_minor_type = value
                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hw-version"):
                                                                                        self.hw_version = value
                                                                                        self.hw_version.value_namespace = name_space
                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hwid"):
                                                                                        self.hwid = value
                                                                                        self.hwid.value_namespace = name_space
                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "idprom-format-rev"):
                                                                                        self.idprom_format_rev = value
                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                        self.mac_add_blk_size1 = value
                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                        self.mac_add_blk_size2 = value
                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                        self.mac_add_blk_size3 = value
                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                        self.mac_add_blk_size4 = value
                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "manu-test-data"):
                                                                                        self.manu_test_data = value
                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-bits"):
                                                                                        self.mfg_bits = value
                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-deviation"):
                                                                                        self.mfg_deviation = value
                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "oem-string"):
                                                                                        self.oem_string = value
                                                                                        self.oem_string.value_namespace = name_space
                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-number"):
                                                                                        self.part_number = value
                                                                                        self.part_number.value_namespace = name_space
                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-revision"):
                                                                                        self.part_revision = value
                                                                                        self.part_revision.value_namespace = name_space
                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pca-num"):
                                                                                        self.pca_num = value
                                                                                        self.pca_num.value_namespace = name_space
                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcavid"):
                                                                                        self.pcavid = value
                                                                                        self.pcavid.value_namespace = name_space
                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcb-serial-num"):
                                                                                        self.pcb_serial_num = value
                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pid"):
                                                                                        self.pid = value
                                                                                        self.pid.value_namespace = name_space
                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-consumption"):
                                                                                        self.power_consumption = value
                                                                                        self.power_consumption.value_namespace = name_space
                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-supply-type"):
                                                                                        self.power_supply_type = value
                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "product-id"):
                                                                                        self.product_id = value
                                                                                        self.product_id.value_namespace = name_space
                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "rma-code"):
                                                                                        self.rma_code = value
                                                                                        self.rma_code.value_namespace = name_space
                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "serial-number"):
                                                                                        self.serial_number = value
                                                                                        self.serial_number.value_namespace = name_space
                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "snmpoid"):
                                                                                        self.snmpoid = value
                                                                                        self.snmpoid.value_namespace = name_space
                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-part-num"):
                                                                                        self.top_assem_part_num = value
                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-vid"):
                                                                                        self.top_assem_vid = value
                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-description"):
                                                                                        self.udi_description = value
                                                                                        self.udi_description.value_namespace = name_space
                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-name"):
                                                                                        self.udi_name = value
                                                                                        self.udi_name.value_namespace = name_space
                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vid"):
                                                                                        self.vid = value
                                                                                        self.vid.value_namespace = name_space
                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.description.is_set or
                                                                                    self.has_eeprom.is_set or
                                                                                    self.inv_card_type.is_set or
                                                                                    self.opaque_data.is_set or
                                                                                    self.opaque_data_size.is_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "eeprom"):
                                                                                    if (self.eeprom is None):
                                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                    return self.eeprom

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "has-eeprom"):
                                                                                    self.has_eeprom = value
                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "inv-card-type"):
                                                                                    self.inv_card_type = value
                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data"):
                                                                                    self.opaque_data = value
                                                                                    self.opaque_data.value_namespace = name_space
                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data-size"):
                                                                                    self.opaque_data_size = value
                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.module_done.is_set or
                                                                                self.node_id.is_set or
                                                                                self.vm_done.is_set or
                                                                                self.vm_node_id.is_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "attributes" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                if (self.env_sensor_info is None):
                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                return self.env_sensor_info

                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                if (self.env_sensor_info_xml is None):
                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                return self.env_sensor_info_xml

                                                                            if (child_yang_name == "fru-info"):
                                                                                if (self.fru_info is None):
                                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                return self.fru_info

                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                if (self.inv_asset_bag is None):
                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                return self.inv_asset_bag

                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                if (self.inv_basic_bag is None):
                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                return self.inv_basic_bag

                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                if (self.inv_eeprom_info is None):
                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                return self.inv_eeprom_info

                                                                            if (child_yang_name == "pwg-info"):
                                                                                if (self.pwg_info is None):
                                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                return self.pwg_info

                                                                            if (child_yang_name == "threshold"):
                                                                                if (self.threshold is None):
                                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                return self.threshold

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "module-done"):
                                                                                self.module_done = value
                                                                                self.module_done.value_namespace = name_space
                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "node-id"):
                                                                                self.node_id = value
                                                                                self.node_id.value_namespace = name_space
                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-done"):
                                                                                self.vm_done = value
                                                                                self.vm_done.value_namespace = name_space
                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-node-id"):
                                                                                self.vm_node_id = value
                                                                                self.vm_node_id.value_namespace = name_space
                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.name.is_set or
                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "tsi6" + "[name='" + self.name.get() + "']" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "attributes"):
                                                                            if (self.attributes is None):
                                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                            return self.attributes

                                                                        if (child_yang_name == "tsi7s"):
                                                                            if (self.tsi7s is None):
                                                                                self.tsi7s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                                self.tsi7s.parent = self
                                                                                self._children_name_map["tsi7s"] = "tsi7s"
                                                                            return self.tsi7s

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "attributes" or name == "tsi7s" or name == "name"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "tsi6s" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "tsi6"):
                                                                        for c in self.tsi6:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.tsi6.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "tsi6"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class Attributes(Entity):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo>`
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                .. attribute:: module_done
                                                                
                                                                	Inventory EDM Module Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**default value**\: 1
                                                                
                                                                .. attribute:: node_id
                                                                
                                                                	Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold>`
                                                                
                                                                .. attribute:: vm_done
                                                                
                                                                	VM Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                .. attribute:: vm_node_id
                                                                
                                                                	VM Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                    self._children_yang_names.add("env-sensor-info")

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                    self._children_yang_names.add("fru-info")

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                    self._children_yang_names.add("pwg-info")

                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                    self._children_yang_names.add("threshold")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("module_done",
                                                                                    "node_id",
                                                                                    "vm_done",
                                                                                    "vm_node_id") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)


                                                                class EnvSensorInfo(Entity):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                        self.units = YLeaf(YType.str, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("age_time_stamp",
                                                                                        "alarm_type",
                                                                                        "data_type",
                                                                                        "device_description",
                                                                                        "device_id",
                                                                                        "field_validity_bitmap",
                                                                                        "precision",
                                                                                        "scale",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.age_time_stamp.is_set or
                                                                            self.alarm_type.is_set or
                                                                            self.data_type.is_set or
                                                                            self.device_description.is_set or
                                                                            self.device_id.is_set or
                                                                            self.field_validity_bitmap.is_set or
                                                                            self.precision.is_set or
                                                                            self.scale.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                            self.precision.yfilter != YFilter.not_set or
                                                                            self.scale.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "age-time-stamp"):
                                                                            self.age_time_stamp = value
                                                                            self.age_time_stamp.value_namespace = name_space
                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "alarm-type"):
                                                                            self.alarm_type = value
                                                                            self.alarm_type.value_namespace = name_space
                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-description"):
                                                                            self.device_description = value
                                                                            self.device_description.value_namespace = name_space
                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-id"):
                                                                            self.device_id = value
                                                                            self.device_id.value_namespace = name_space
                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "field-validity-bitmap"):
                                                                            self.field_validity_bitmap = value
                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "precision"):
                                                                            self.precision = value
                                                                            self.precision.value_namespace = name_space
                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "scale"):
                                                                            self.scale = value
                                                                            self.scale.value_namespace = name_space
                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class PwgInfo(Entity):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("power_group_available_current",
                                                                                        "power_group_drawn_current",
                                                                                        "power_group_power_units",
                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.power_group_available_current.is_set or
                                                                            self.power_group_drawn_current.is_set or
                                                                            self.power_group_power_units.is_set or
                                                                            self.power_group_redundancy_mode.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "pwg-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "power-group-available-current"):
                                                                            self.power_group_available_current = value
                                                                            self.power_group_available_current.value_namespace = name_space
                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-drawn-current"):
                                                                            self.power_group_drawn_current = value
                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-power-units"):
                                                                            self.power_group_power_units = value
                                                                            self.power_group_power_units.value_namespace = name_space
                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                            self.power_group_redundancy_mode = value
                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                class EnvSensorInfoXml(Entity):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.str, "value")

                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._children_yang_names.add("threshold")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("data_type",
                                                                                        "description",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                    class Threshold(Entity):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                            self.threshold_array = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                        class ThresholdArray(Entity):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"

                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_name",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_name.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-name"):
                                                                                    self.threshold_name = value
                                                                                    self.threshold_name.value_namespace = name_space
                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "threshold" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "threshold-array"):
                                                                                for c in self.threshold_array:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.threshold_array.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "threshold-array"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            self.data_type.is_set or
                                                                            self.description.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set or
                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "threshold"):
                                                                            if (self.threshold is None):
                                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                            return self.threshold

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class InvAssetBag(Entity):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("manufacturer_assembly_number",
                                                                                        "manufacturer_assembly_revision",
                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                        "manufacturer_firmware_identifier",
                                                                                        "manufacturer_software_identifier",
                                                                                        "original_equipment_manufacturer_string",
                                                                                        "part_number") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.manufacturer_assembly_number.is_set or
                                                                            self.manufacturer_assembly_revision.is_set or
                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                            self.manufacturer_software_identifier.is_set or
                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                            self.part_number.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                            self.manufacturer_assembly_number = value
                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                            self.manufacturer_assembly_revision = value
                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                            self.manufacturer_firmware_identifier = value
                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                            self.manufacturer_software_identifier = value
                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                            self.original_equipment_manufacturer_string = value
                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "part-number"):
                                                                            self.part_number = value
                                                                            self.part_number.value_namespace = name_space
                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                class Threshold(Entity):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                        self._children_yang_names.add("critical-hi")

                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                        self._children_yang_names.add("critical-lo")

                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                        self._children_yang_names.add("major-hi")

                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                        self._children_yang_names.add("major-lo")

                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                        self._children_yang_names.add("minor-hi")

                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._children_yang_names.add("minor-lo")


                                                                    class MajorLo(Entity):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalHi(Entity):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorHi(Entity):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MajorHi(Entity):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalLo(Entity):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorLo(Entity):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "critical-hi"):
                                                                            if (self.critical_hi is None):
                                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                            return self.critical_hi

                                                                        if (child_yang_name == "critical-lo"):
                                                                            if (self.critical_lo is None):
                                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                            return self.critical_lo

                                                                        if (child_yang_name == "major-hi"):
                                                                            if (self.major_hi is None):
                                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                            return self.major_hi

                                                                        if (child_yang_name == "major-lo"):
                                                                            if (self.major_lo is None):
                                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                            return self.major_lo

                                                                        if (child_yang_name == "minor-hi"):
                                                                            if (self.minor_hi is None):
                                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                            return self.minor_hi

                                                                        if (child_yang_name == "minor-lo"):
                                                                            if (self.minor_lo is None):
                                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                            return self.minor_lo

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        pass


                                                                class FruInfo(Entity):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._children_yang_names.add("card-up-time")

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("card_administrative_state",
                                                                                        "card_monitor_state",
                                                                                        "card_operational_state",
                                                                                        "card_reset_reason",
                                                                                        "power_administrative_state",
                                                                                        "power_current_measurement",
                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)


                                                                    class LastOperationalStateChange(Entity):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                    class CardUpTime(Entity):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "card-up-time" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.card_administrative_state.is_set or
                                                                            self.card_monitor_state.is_set or
                                                                            self.card_operational_state.is_set or
                                                                            self.card_reset_reason.is_set or
                                                                            self.power_administrative_state.is_set or
                                                                            self.power_current_measurement.is_set or
                                                                            self.power_operational_state.is_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "fru-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "card-up-time"):
                                                                            if (self.card_up_time is None):
                                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                            return self.card_up_time

                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                            if (self.last_operational_state_change is None):
                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                            return self.last_operational_state_change

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "card-administrative-state"):
                                                                            self.card_administrative_state = value
                                                                            self.card_administrative_state.value_namespace = name_space
                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-monitor-state"):
                                                                            self.card_monitor_state = value
                                                                            self.card_monitor_state.value_namespace = name_space
                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-operational-state"):
                                                                            self.card_operational_state = value
                                                                            self.card_operational_state.value_namespace = name_space
                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-reset-reason"):
                                                                            self.card_reset_reason = value
                                                                            self.card_reset_reason.value_namespace = name_space
                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-administrative-state"):
                                                                            self.power_administrative_state = value
                                                                            self.power_administrative_state.value_namespace = name_space
                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-current-measurement"):
                                                                            self.power_current_measurement = value
                                                                            self.power_current_measurement.value_namespace = name_space
                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-operational-state"):
                                                                            self.power_operational_state = value
                                                                            self.power_operational_state.value_namespace = name_space
                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                class InvBasicBag(Entity):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("alias",
                                                                                        "asset_id_str",
                                                                                        "asset_identification",
                                                                                        "ceport",
                                                                                        "chip_hardware_revision",
                                                                                        "composite_class_code",
                                                                                        "description",
                                                                                        "environmental_monitor_path",
                                                                                        "firmware_revision",
                                                                                        "group_flag",
                                                                                        "hardware_revision",
                                                                                        "is_field_replaceable_unit",
                                                                                        "manufacturer_asset_tags",
                                                                                        "manufacturer_name",
                                                                                        "memory_size",
                                                                                        "model_name",
                                                                                        "name",
                                                                                        "new_deviation_number",
                                                                                        "physical_layer_interface_module_type",
                                                                                        "redundancystate",
                                                                                        "serial_number",
                                                                                        "software_revision",
                                                                                        "unique_id",
                                                                                        "unrecognized_fru",
                                                                                        "vendor_type",
                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.alias.is_set or
                                                                            self.asset_id_str.is_set or
                                                                            self.asset_identification.is_set or
                                                                            self.ceport.is_set or
                                                                            self.chip_hardware_revision.is_set or
                                                                            self.composite_class_code.is_set or
                                                                            self.description.is_set or
                                                                            self.environmental_monitor_path.is_set or
                                                                            self.firmware_revision.is_set or
                                                                            self.group_flag.is_set or
                                                                            self.hardware_revision.is_set or
                                                                            self.is_field_replaceable_unit.is_set or
                                                                            self.manufacturer_asset_tags.is_set or
                                                                            self.manufacturer_name.is_set or
                                                                            self.memory_size.is_set or
                                                                            self.model_name.is_set or
                                                                            self.name.is_set or
                                                                            self.new_deviation_number.is_set or
                                                                            self.physical_layer_interface_module_type.is_set or
                                                                            self.redundancystate.is_set or
                                                                            self.serial_number.is_set or
                                                                            self.software_revision.is_set or
                                                                            self.unique_id.is_set or
                                                                            self.unrecognized_fru.is_set or
                                                                            self.vendor_type.is_set or
                                                                            self.xr_scoped.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.alias.yfilter != YFilter.not_set or
                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "alias"):
                                                                            self.alias = value
                                                                            self.alias.value_namespace = name_space
                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-id-str"):
                                                                            self.asset_id_str = value
                                                                            self.asset_id_str.value_namespace = name_space
                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-identification"):
                                                                            self.asset_identification = value
                                                                            self.asset_identification.value_namespace = name_space
                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "ceport"):
                                                                            self.ceport = value
                                                                            self.ceport.value_namespace = name_space
                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "chip-hardware-revision"):
                                                                            self.chip_hardware_revision = value
                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "composite-class-code"):
                                                                            self.composite_class_code = value
                                                                            self.composite_class_code.value_namespace = name_space
                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "environmental-monitor-path"):
                                                                            self.environmental_monitor_path = value
                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "firmware-revision"):
                                                                            self.firmware_revision = value
                                                                            self.firmware_revision.value_namespace = name_space
                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "group-flag"):
                                                                            self.group_flag = value
                                                                            self.group_flag.value_namespace = name_space
                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "hardware-revision"):
                                                                            self.hardware_revision = value
                                                                            self.hardware_revision.value_namespace = name_space
                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                            self.is_field_replaceable_unit = value
                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                            self.manufacturer_asset_tags = value
                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-name"):
                                                                            self.manufacturer_name = value
                                                                            self.manufacturer_name.value_namespace = name_space
                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "memory-size"):
                                                                            self.memory_size = value
                                                                            self.memory_size.value_namespace = name_space
                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "model-name"):
                                                                            self.model_name = value
                                                                            self.model_name.value_namespace = name_space
                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "new-deviation-number"):
                                                                            self.new_deviation_number = value
                                                                            self.new_deviation_number.value_namespace = name_space
                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                            self.physical_layer_interface_module_type = value
                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "redundancystate"):
                                                                            self.redundancystate = value
                                                                            self.redundancystate.value_namespace = name_space
                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "serial-number"):
                                                                            self.serial_number = value
                                                                            self.serial_number.value_namespace = name_space
                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "software-revision"):
                                                                            self.software_revision = value
                                                                            self.software_revision.value_namespace = name_space
                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unique-id"):
                                                                            self.unique_id = value
                                                                            self.unique_id.value_namespace = name_space
                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unrecognized-fru"):
                                                                            self.unrecognized_fru = value
                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "vendor-type"):
                                                                            self.vendor_type = value
                                                                            self.vendor_type.value_namespace = name_space
                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "xr-scoped"):
                                                                            self.xr_scoped = value
                                                                            self.xr_scoped.value_namespace = name_space
                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                class InvEepromInfo(Entity):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._children_yang_names.add("eeprom")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("description",
                                                                                        "has_eeprom",
                                                                                        "inv_card_type",
                                                                                        "opaque_data",
                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                    class Eeprom(Entity):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._children_yang_names.add("rma")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("asset_alias",
                                                                                            "asset_id",
                                                                                            "base_mac_address1",
                                                                                            "base_mac_address2",
                                                                                            "base_mac_address3",
                                                                                            "base_mac_address4",
                                                                                            "block_checksum",
                                                                                            "block_count",
                                                                                            "block_length",
                                                                                            "block_signature",
                                                                                            "block_version",
                                                                                            "chassis_sid",
                                                                                            "clei",
                                                                                            "controller_family",
                                                                                            "controller_type",
                                                                                            "description",
                                                                                            "dev_num1",
                                                                                            "dev_num2",
                                                                                            "dev_num3",
                                                                                            "dev_num4",
                                                                                            "dev_num5",
                                                                                            "dev_num6",
                                                                                            "dev_num7",
                                                                                            "eci",
                                                                                            "eeprom_size",
                                                                                            "engineer_use",
                                                                                            "fru_major_type",
                                                                                            "fru_minor_type",
                                                                                            "hw_version",
                                                                                            "hwid",
                                                                                            "idprom_format_rev",
                                                                                            "mac_add_blk_size1",
                                                                                            "mac_add_blk_size2",
                                                                                            "mac_add_blk_size3",
                                                                                            "mac_add_blk_size4",
                                                                                            "manu_test_data",
                                                                                            "mfg_bits",
                                                                                            "mfg_deviation",
                                                                                            "oem_string",
                                                                                            "part_number",
                                                                                            "part_revision",
                                                                                            "pca_num",
                                                                                            "pcavid",
                                                                                            "pcb_serial_num",
                                                                                            "pid",
                                                                                            "power_consumption",
                                                                                            "power_supply_type",
                                                                                            "product_id",
                                                                                            "rma_code",
                                                                                            "serial_number",
                                                                                            "snmpoid",
                                                                                            "top_assem_part_num",
                                                                                            "top_assem_vid",
                                                                                            "udi_description",
                                                                                            "udi_name",
                                                                                            "vid") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                        class Rma(Entity):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"

                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("rma_history",
                                                                                                "rma_number",
                                                                                                "test_history") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.rma_history.is_set or
                                                                                    self.rma_number.is_set or
                                                                                    self.test_history.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "rma" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "rma-history"):
                                                                                    self.rma_history = value
                                                                                    self.rma_history.value_namespace = name_space
                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "rma-number"):
                                                                                    self.rma_number = value
                                                                                    self.rma_number.value_namespace = name_space
                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "test-history"):
                                                                                    self.test_history = value
                                                                                    self.test_history.value_namespace = name_space
                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.asset_alias.is_set or
                                                                                self.asset_id.is_set or
                                                                                self.base_mac_address1.is_set or
                                                                                self.base_mac_address2.is_set or
                                                                                self.base_mac_address3.is_set or
                                                                                self.base_mac_address4.is_set or
                                                                                self.block_checksum.is_set or
                                                                                self.block_count.is_set or
                                                                                self.block_length.is_set or
                                                                                self.block_signature.is_set or
                                                                                self.block_version.is_set or
                                                                                self.chassis_sid.is_set or
                                                                                self.clei.is_set or
                                                                                self.controller_family.is_set or
                                                                                self.controller_type.is_set or
                                                                                self.description.is_set or
                                                                                self.dev_num1.is_set or
                                                                                self.dev_num2.is_set or
                                                                                self.dev_num3.is_set or
                                                                                self.dev_num4.is_set or
                                                                                self.dev_num5.is_set or
                                                                                self.dev_num6.is_set or
                                                                                self.dev_num7.is_set or
                                                                                self.eci.is_set or
                                                                                self.eeprom_size.is_set or
                                                                                self.engineer_use.is_set or
                                                                                self.fru_major_type.is_set or
                                                                                self.fru_minor_type.is_set or
                                                                                self.hw_version.is_set or
                                                                                self.hwid.is_set or
                                                                                self.idprom_format_rev.is_set or
                                                                                self.mac_add_blk_size1.is_set or
                                                                                self.mac_add_blk_size2.is_set or
                                                                                self.mac_add_blk_size3.is_set or
                                                                                self.mac_add_blk_size4.is_set or
                                                                                self.manu_test_data.is_set or
                                                                                self.mfg_bits.is_set or
                                                                                self.mfg_deviation.is_set or
                                                                                self.oem_string.is_set or
                                                                                self.part_number.is_set or
                                                                                self.part_revision.is_set or
                                                                                self.pca_num.is_set or
                                                                                self.pcavid.is_set or
                                                                                self.pcb_serial_num.is_set or
                                                                                self.pid.is_set or
                                                                                self.power_consumption.is_set or
                                                                                self.power_supply_type.is_set or
                                                                                self.product_id.is_set or
                                                                                self.rma_code.is_set or
                                                                                self.serial_number.is_set or
                                                                                self.snmpoid.is_set or
                                                                                self.top_assem_part_num.is_set or
                                                                                self.top_assem_vid.is_set or
                                                                                self.udi_description.is_set or
                                                                                self.udi_name.is_set or
                                                                                self.vid.is_set or
                                                                                (self.rma is not None and self.rma.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                self.description.yfilter != YFilter.not_set or
                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "eeprom" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "rma"):
                                                                                if (self.rma is None):
                                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                return self.rma

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "asset-alias"):
                                                                                self.asset_alias = value
                                                                                self.asset_alias.value_namespace = name_space
                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "asset-id"):
                                                                                self.asset_id = value
                                                                                self.asset_id.value_namespace = name_space
                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address1"):
                                                                                self.base_mac_address1 = value
                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address2"):
                                                                                self.base_mac_address2 = value
                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address3"):
                                                                                self.base_mac_address3 = value
                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address4"):
                                                                                self.base_mac_address4 = value
                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-checksum"):
                                                                                self.block_checksum = value
                                                                                self.block_checksum.value_namespace = name_space
                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-count"):
                                                                                self.block_count = value
                                                                                self.block_count.value_namespace = name_space
                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-length"):
                                                                                self.block_length = value
                                                                                self.block_length.value_namespace = name_space
                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-signature"):
                                                                                self.block_signature = value
                                                                                self.block_signature.value_namespace = name_space
                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-version"):
                                                                                self.block_version = value
                                                                                self.block_version.value_namespace = name_space
                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "chassis-sid"):
                                                                                self.chassis_sid = value
                                                                                self.chassis_sid.value_namespace = name_space
                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "clei"):
                                                                                self.clei = value
                                                                                self.clei.value_namespace = name_space
                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-family"):
                                                                                self.controller_family = value
                                                                                self.controller_family.value_namespace = name_space
                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-type"):
                                                                                self.controller_type = value
                                                                                self.controller_type.value_namespace = name_space
                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "description"):
                                                                                self.description = value
                                                                                self.description.value_namespace = name_space
                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num1"):
                                                                                self.dev_num1 = value
                                                                                self.dev_num1.value_namespace = name_space
                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num2"):
                                                                                self.dev_num2 = value
                                                                                self.dev_num2.value_namespace = name_space
                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num3"):
                                                                                self.dev_num3 = value
                                                                                self.dev_num3.value_namespace = name_space
                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num4"):
                                                                                self.dev_num4 = value
                                                                                self.dev_num4.value_namespace = name_space
                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num5"):
                                                                                self.dev_num5 = value
                                                                                self.dev_num5.value_namespace = name_space
                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num6"):
                                                                                self.dev_num6 = value
                                                                                self.dev_num6.value_namespace = name_space
                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num7"):
                                                                                self.dev_num7 = value
                                                                                self.dev_num7.value_namespace = name_space
                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eci"):
                                                                                self.eci = value
                                                                                self.eci.value_namespace = name_space
                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eeprom-size"):
                                                                                self.eeprom_size = value
                                                                                self.eeprom_size.value_namespace = name_space
                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "engineer-use"):
                                                                                self.engineer_use = value
                                                                                self.engineer_use.value_namespace = name_space
                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-major-type"):
                                                                                self.fru_major_type = value
                                                                                self.fru_major_type.value_namespace = name_space
                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-minor-type"):
                                                                                self.fru_minor_type = value
                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hw-version"):
                                                                                self.hw_version = value
                                                                                self.hw_version.value_namespace = name_space
                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hwid"):
                                                                                self.hwid = value
                                                                                self.hwid.value_namespace = name_space
                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "idprom-format-rev"):
                                                                                self.idprom_format_rev = value
                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                self.mac_add_blk_size1 = value
                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                self.mac_add_blk_size2 = value
                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                self.mac_add_blk_size3 = value
                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                self.mac_add_blk_size4 = value
                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "manu-test-data"):
                                                                                self.manu_test_data = value
                                                                                self.manu_test_data.value_namespace = name_space
                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-bits"):
                                                                                self.mfg_bits = value
                                                                                self.mfg_bits.value_namespace = name_space
                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-deviation"):
                                                                                self.mfg_deviation = value
                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "oem-string"):
                                                                                self.oem_string = value
                                                                                self.oem_string.value_namespace = name_space
                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-number"):
                                                                                self.part_number = value
                                                                                self.part_number.value_namespace = name_space
                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-revision"):
                                                                                self.part_revision = value
                                                                                self.part_revision.value_namespace = name_space
                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pca-num"):
                                                                                self.pca_num = value
                                                                                self.pca_num.value_namespace = name_space
                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcavid"):
                                                                                self.pcavid = value
                                                                                self.pcavid.value_namespace = name_space
                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcb-serial-num"):
                                                                                self.pcb_serial_num = value
                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pid"):
                                                                                self.pid = value
                                                                                self.pid.value_namespace = name_space
                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-consumption"):
                                                                                self.power_consumption = value
                                                                                self.power_consumption.value_namespace = name_space
                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-supply-type"):
                                                                                self.power_supply_type = value
                                                                                self.power_supply_type.value_namespace = name_space
                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "product-id"):
                                                                                self.product_id = value
                                                                                self.product_id.value_namespace = name_space
                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "rma-code"):
                                                                                self.rma_code = value
                                                                                self.rma_code.value_namespace = name_space
                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "serial-number"):
                                                                                self.serial_number = value
                                                                                self.serial_number.value_namespace = name_space
                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "snmpoid"):
                                                                                self.snmpoid = value
                                                                                self.snmpoid.value_namespace = name_space
                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-part-num"):
                                                                                self.top_assem_part_num = value
                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-vid"):
                                                                                self.top_assem_vid = value
                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-description"):
                                                                                self.udi_description = value
                                                                                self.udi_description.value_namespace = name_space
                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-name"):
                                                                                self.udi_name = value
                                                                                self.udi_name.value_namespace = name_space
                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vid"):
                                                                                self.vid = value
                                                                                self.vid.value_namespace = name_space
                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.description.is_set or
                                                                            self.has_eeprom.is_set or
                                                                            self.inv_card_type.is_set or
                                                                            self.opaque_data.is_set or
                                                                            self.opaque_data_size.is_set or
                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "eeprom"):
                                                                            if (self.eeprom is None):
                                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                            return self.eeprom

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "has-eeprom"):
                                                                            self.has_eeprom = value
                                                                            self.has_eeprom.value_namespace = name_space
                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "inv-card-type"):
                                                                            self.inv_card_type = value
                                                                            self.inv_card_type.value_namespace = name_space
                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data"):
                                                                            self.opaque_data = value
                                                                            self.opaque_data.value_namespace = name_space
                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data-size"):
                                                                            self.opaque_data_size = value
                                                                            self.opaque_data_size.value_namespace = name_space
                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.module_done.is_set or
                                                                        self.node_id.is_set or
                                                                        self.vm_done.is_set or
                                                                        self.vm_node_id.is_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "attributes" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "env-sensor-info"):
                                                                        if (self.env_sensor_info is None):
                                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                        return self.env_sensor_info

                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                        if (self.env_sensor_info_xml is None):
                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                        return self.env_sensor_info_xml

                                                                    if (child_yang_name == "fru-info"):
                                                                        if (self.fru_info is None):
                                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                        return self.fru_info

                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                        if (self.inv_asset_bag is None):
                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                        return self.inv_asset_bag

                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                        if (self.inv_basic_bag is None):
                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                        return self.inv_basic_bag

                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                        if (self.inv_eeprom_info is None):
                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                        return self.inv_eeprom_info

                                                                    if (child_yang_name == "pwg-info"):
                                                                        if (self.pwg_info is None):
                                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                        return self.pwg_info

                                                                    if (child_yang_name == "threshold"):
                                                                        if (self.threshold is None):
                                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                        return self.threshold

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "module-done"):
                                                                        self.module_done = value
                                                                        self.module_done.value_namespace = name_space
                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "node-id"):
                                                                        self.node_id = value
                                                                        self.node_id.value_namespace = name_space
                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-done"):
                                                                        self.vm_done = value
                                                                        self.vm_done.value_namespace = name_space
                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-node-id"):
                                                                        self.vm_node_id = value
                                                                        self.vm_node_id.value_namespace = name_space
                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.name.is_set or
                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "tsi5" + "[name='" + self.name.get() + "']" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "attributes"):
                                                                    if (self.attributes is None):
                                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                    return self.attributes

                                                                if (child_yang_name == "tsi6s"):
                                                                    if (self.tsi6s is None):
                                                                        self.tsi6s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                        self.tsi6s.parent = self
                                                                        self._children_name_map["tsi6s"] = "tsi6s"
                                                                    return self.tsi6s

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "attributes" or name == "tsi6s" or name == "name"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.tsi5:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.tsi5:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "tsi5s" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "tsi5"):
                                                                for c in self.tsi5:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.tsi5.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "tsi5"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class Attributes(Entity):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo>`
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        .. attribute:: module_done
                                                        
                                                        	Inventory EDM Module Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**default value**\: 1
                                                        
                                                        .. attribute:: node_id
                                                        
                                                        	Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold>`
                                                        
                                                        .. attribute:: vm_done
                                                        
                                                        	VM Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        .. attribute:: vm_node_id
                                                        
                                                        	VM Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"

                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                            self._children_yang_names.add("env-sensor-info")

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                            self._children_yang_names.add("fru-info")

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                            self._children_yang_names.add("inv-asset-bag")

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                            self._children_yang_names.add("inv-basic-bag")

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._children_yang_names.add("inv-eeprom-info")

                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                            self._children_yang_names.add("pwg-info")

                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                            self._children_yang_names.add("threshold")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("module_done",
                                                                            "node_id",
                                                                            "vm_done",
                                                                            "vm_node_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)


                                                        class EnvSensorInfo(Entity):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                self.status = YLeaf(YType.uint32, "status")

                                                                self.units = YLeaf(YType.str, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("age_time_stamp",
                                                                                "alarm_type",
                                                                                "data_type",
                                                                                "device_description",
                                                                                "device_id",
                                                                                "field_validity_bitmap",
                                                                                "precision",
                                                                                "scale",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.age_time_stamp.is_set or
                                                                    self.alarm_type.is_set or
                                                                    self.data_type.is_set or
                                                                    self.device_description.is_set or
                                                                    self.device_id.is_set or
                                                                    self.field_validity_bitmap.is_set or
                                                                    self.precision.is_set or
                                                                    self.scale.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                    self.precision.yfilter != YFilter.not_set or
                                                                    self.scale.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "age-time-stamp"):
                                                                    self.age_time_stamp = value
                                                                    self.age_time_stamp.value_namespace = name_space
                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "alarm-type"):
                                                                    self.alarm_type = value
                                                                    self.alarm_type.value_namespace = name_space
                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-description"):
                                                                    self.device_description = value
                                                                    self.device_description.value_namespace = name_space
                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-id"):
                                                                    self.device_id = value
                                                                    self.device_id.value_namespace = name_space
                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "field-validity-bitmap"):
                                                                    self.field_validity_bitmap = value
                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "precision"):
                                                                    self.precision = value
                                                                    self.precision.value_namespace = name_space
                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "scale"):
                                                                    self.scale = value
                                                                    self.scale.value_namespace = name_space
                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class PwgInfo(Entity):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("power_group_available_current",
                                                                                "power_group_drawn_current",
                                                                                "power_group_power_units",
                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.power_group_available_current.is_set or
                                                                    self.power_group_drawn_current.is_set or
                                                                    self.power_group_power_units.is_set or
                                                                    self.power_group_redundancy_mode.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "pwg-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "power-group-available-current"):
                                                                    self.power_group_available_current = value
                                                                    self.power_group_available_current.value_namespace = name_space
                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-drawn-current"):
                                                                    self.power_group_drawn_current = value
                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-power-units"):
                                                                    self.power_group_power_units = value
                                                                    self.power_group_power_units.value_namespace = name_space
                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-redundancy-mode"):
                                                                    self.power_group_redundancy_mode = value
                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                        class EnvSensorInfoXml(Entity):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"

                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.str, "value")

                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._children_yang_names.add("threshold")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("data_type",
                                                                                "description",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                            class Threshold(Entity):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                    self.threshold_array = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                class ThresholdArray(Entity):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"

                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_name",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_name.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-name"):
                                                                            self.threshold_name = value
                                                                            self.threshold_name.value_namespace = name_space
                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "threshold" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "threshold-array"):
                                                                        for c in self.threshold_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.threshold_array.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "threshold-array"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    self.data_type.is_set or
                                                                    self.description.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set or
                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "threshold"):
                                                                    if (self.threshold is None):
                                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                    return self.threshold

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class InvAssetBag(Entity):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("manufacturer_assembly_number",
                                                                                "manufacturer_assembly_revision",
                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                "manufacturer_firmware_identifier",
                                                                                "manufacturer_software_identifier",
                                                                                "original_equipment_manufacturer_string",
                                                                                "part_number") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.manufacturer_assembly_number.is_set or
                                                                    self.manufacturer_assembly_revision.is_set or
                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                    self.manufacturer_software_identifier.is_set or
                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                    self.part_number.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                    self.part_number.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "manufacturer-assembly-number"):
                                                                    self.manufacturer_assembly_number = value
                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                    self.manufacturer_assembly_revision = value
                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                    self.manufacturer_firmware_identifier = value
                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-software-identifier"):
                                                                    self.manufacturer_software_identifier = value
                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                    self.original_equipment_manufacturer_string = value
                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "part-number"):
                                                                    self.part_number = value
                                                                    self.part_number.value_namespace = name_space
                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                        class Threshold(Entity):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"

                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                self._children_yang_names.add("critical-hi")

                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                self._children_yang_names.add("critical-lo")

                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                self._children_yang_names.add("major-hi")

                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                self._children_yang_names.add("major-lo")

                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                self._children_yang_names.add("minor-hi")

                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._children_yang_names.add("minor-lo")


                                                            class MajorLo(Entity):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalHi(Entity):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorHi(Entity):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MajorHi(Entity):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalLo(Entity):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorLo(Entity):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "critical-hi"):
                                                                    if (self.critical_hi is None):
                                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                    return self.critical_hi

                                                                if (child_yang_name == "critical-lo"):
                                                                    if (self.critical_lo is None):
                                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                    return self.critical_lo

                                                                if (child_yang_name == "major-hi"):
                                                                    if (self.major_hi is None):
                                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                    return self.major_hi

                                                                if (child_yang_name == "major-lo"):
                                                                    if (self.major_lo is None):
                                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                    return self.major_lo

                                                                if (child_yang_name == "minor-hi"):
                                                                    if (self.minor_hi is None):
                                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                    return self.minor_hi

                                                                if (child_yang_name == "minor-lo"):
                                                                    if (self.minor_lo is None):
                                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                    return self.minor_lo

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                pass


                                                        class FruInfo(Entity):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._children_yang_names.add("card-up-time")

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                self._children_yang_names.add("last-operational-state-change")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("card_administrative_state",
                                                                                "card_monitor_state",
                                                                                "card_operational_state",
                                                                                "card_reset_reason",
                                                                                "power_administrative_state",
                                                                                "power_current_measurement",
                                                                                "power_operational_state") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)


                                                            class LastOperationalStateChange(Entity):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                            class CardUpTime(Entity):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "card-up-time" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.card_administrative_state.is_set or
                                                                    self.card_monitor_state.is_set or
                                                                    self.card_operational_state.is_set or
                                                                    self.card_reset_reason.is_set or
                                                                    self.power_administrative_state.is_set or
                                                                    self.power_current_measurement.is_set or
                                                                    self.power_operational_state.is_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fru-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "card-up-time"):
                                                                    if (self.card_up_time is None):
                                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                    return self.card_up_time

                                                                if (child_yang_name == "last-operational-state-change"):
                                                                    if (self.last_operational_state_change is None):
                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                    return self.last_operational_state_change

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "card-administrative-state"):
                                                                    self.card_administrative_state = value
                                                                    self.card_administrative_state.value_namespace = name_space
                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-monitor-state"):
                                                                    self.card_monitor_state = value
                                                                    self.card_monitor_state.value_namespace = name_space
                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-operational-state"):
                                                                    self.card_operational_state = value
                                                                    self.card_operational_state.value_namespace = name_space
                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-reset-reason"):
                                                                    self.card_reset_reason = value
                                                                    self.card_reset_reason.value_namespace = name_space
                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-administrative-state"):
                                                                    self.power_administrative_state = value
                                                                    self.power_administrative_state.value_namespace = name_space
                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-current-measurement"):
                                                                    self.power_current_measurement = value
                                                                    self.power_current_measurement.value_namespace = name_space
                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-operational-state"):
                                                                    self.power_operational_state = value
                                                                    self.power_operational_state.value_namespace = name_space
                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                        class InvBasicBag(Entity):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.alias = YLeaf(YType.str, "alias")

                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("alias",
                                                                                "asset_id_str",
                                                                                "asset_identification",
                                                                                "ceport",
                                                                                "chip_hardware_revision",
                                                                                "composite_class_code",
                                                                                "description",
                                                                                "environmental_monitor_path",
                                                                                "firmware_revision",
                                                                                "group_flag",
                                                                                "hardware_revision",
                                                                                "is_field_replaceable_unit",
                                                                                "manufacturer_asset_tags",
                                                                                "manufacturer_name",
                                                                                "memory_size",
                                                                                "model_name",
                                                                                "name",
                                                                                "new_deviation_number",
                                                                                "physical_layer_interface_module_type",
                                                                                "redundancystate",
                                                                                "serial_number",
                                                                                "software_revision",
                                                                                "unique_id",
                                                                                "unrecognized_fru",
                                                                                "vendor_type",
                                                                                "xr_scoped") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.alias.is_set or
                                                                    self.asset_id_str.is_set or
                                                                    self.asset_identification.is_set or
                                                                    self.ceport.is_set or
                                                                    self.chip_hardware_revision.is_set or
                                                                    self.composite_class_code.is_set or
                                                                    self.description.is_set or
                                                                    self.environmental_monitor_path.is_set or
                                                                    self.firmware_revision.is_set or
                                                                    self.group_flag.is_set or
                                                                    self.hardware_revision.is_set or
                                                                    self.is_field_replaceable_unit.is_set or
                                                                    self.manufacturer_asset_tags.is_set or
                                                                    self.manufacturer_name.is_set or
                                                                    self.memory_size.is_set or
                                                                    self.model_name.is_set or
                                                                    self.name.is_set or
                                                                    self.new_deviation_number.is_set or
                                                                    self.physical_layer_interface_module_type.is_set or
                                                                    self.redundancystate.is_set or
                                                                    self.serial_number.is_set or
                                                                    self.software_revision.is_set or
                                                                    self.unique_id.is_set or
                                                                    self.unrecognized_fru.is_set or
                                                                    self.vendor_type.is_set or
                                                                    self.xr_scoped.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.alias.yfilter != YFilter.not_set or
                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "alias"):
                                                                    self.alias = value
                                                                    self.alias.value_namespace = name_space
                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-id-str"):
                                                                    self.asset_id_str = value
                                                                    self.asset_id_str.value_namespace = name_space
                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-identification"):
                                                                    self.asset_identification = value
                                                                    self.asset_identification.value_namespace = name_space
                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ceport"):
                                                                    self.ceport = value
                                                                    self.ceport.value_namespace = name_space
                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "chip-hardware-revision"):
                                                                    self.chip_hardware_revision = value
                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "composite-class-code"):
                                                                    self.composite_class_code = value
                                                                    self.composite_class_code.value_namespace = name_space
                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "environmental-monitor-path"):
                                                                    self.environmental_monitor_path = value
                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "firmware-revision"):
                                                                    self.firmware_revision = value
                                                                    self.firmware_revision.value_namespace = name_space
                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "group-flag"):
                                                                    self.group_flag = value
                                                                    self.group_flag.value_namespace = name_space
                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "hardware-revision"):
                                                                    self.hardware_revision = value
                                                                    self.hardware_revision.value_namespace = name_space
                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "is-field-replaceable-unit"):
                                                                    self.is_field_replaceable_unit = value
                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-asset-tags"):
                                                                    self.manufacturer_asset_tags = value
                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-name"):
                                                                    self.manufacturer_name = value
                                                                    self.manufacturer_name.value_namespace = name_space
                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "memory-size"):
                                                                    self.memory_size = value
                                                                    self.memory_size.value_namespace = name_space
                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "model-name"):
                                                                    self.model_name = value
                                                                    self.model_name.value_namespace = name_space
                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "new-deviation-number"):
                                                                    self.new_deviation_number = value
                                                                    self.new_deviation_number.value_namespace = name_space
                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                    self.physical_layer_interface_module_type = value
                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "redundancystate"):
                                                                    self.redundancystate = value
                                                                    self.redundancystate.value_namespace = name_space
                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "serial-number"):
                                                                    self.serial_number = value
                                                                    self.serial_number.value_namespace = name_space
                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "software-revision"):
                                                                    self.software_revision = value
                                                                    self.software_revision.value_namespace = name_space
                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unique-id"):
                                                                    self.unique_id = value
                                                                    self.unique_id.value_namespace = name_space
                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unrecognized-fru"):
                                                                    self.unrecognized_fru = value
                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "vendor-type"):
                                                                    self.vendor_type = value
                                                                    self.vendor_type.value_namespace = name_space
                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "xr-scoped"):
                                                                    self.xr_scoped = value
                                                                    self.xr_scoped.value_namespace = name_space
                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                        class InvEepromInfo(Entity):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._children_yang_names.add("eeprom")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("description",
                                                                                "has_eeprom",
                                                                                "inv_card_type",
                                                                                "opaque_data",
                                                                                "opaque_data_size") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                            class Eeprom(Entity):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._children_yang_names.add("rma")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("asset_alias",
                                                                                    "asset_id",
                                                                                    "base_mac_address1",
                                                                                    "base_mac_address2",
                                                                                    "base_mac_address3",
                                                                                    "base_mac_address4",
                                                                                    "block_checksum",
                                                                                    "block_count",
                                                                                    "block_length",
                                                                                    "block_signature",
                                                                                    "block_version",
                                                                                    "chassis_sid",
                                                                                    "clei",
                                                                                    "controller_family",
                                                                                    "controller_type",
                                                                                    "description",
                                                                                    "dev_num1",
                                                                                    "dev_num2",
                                                                                    "dev_num3",
                                                                                    "dev_num4",
                                                                                    "dev_num5",
                                                                                    "dev_num6",
                                                                                    "dev_num7",
                                                                                    "eci",
                                                                                    "eeprom_size",
                                                                                    "engineer_use",
                                                                                    "fru_major_type",
                                                                                    "fru_minor_type",
                                                                                    "hw_version",
                                                                                    "hwid",
                                                                                    "idprom_format_rev",
                                                                                    "mac_add_blk_size1",
                                                                                    "mac_add_blk_size2",
                                                                                    "mac_add_blk_size3",
                                                                                    "mac_add_blk_size4",
                                                                                    "manu_test_data",
                                                                                    "mfg_bits",
                                                                                    "mfg_deviation",
                                                                                    "oem_string",
                                                                                    "part_number",
                                                                                    "part_revision",
                                                                                    "pca_num",
                                                                                    "pcavid",
                                                                                    "pcb_serial_num",
                                                                                    "pid",
                                                                                    "power_consumption",
                                                                                    "power_supply_type",
                                                                                    "product_id",
                                                                                    "rma_code",
                                                                                    "serial_number",
                                                                                    "snmpoid",
                                                                                    "top_assem_part_num",
                                                                                    "top_assem_vid",
                                                                                    "udi_description",
                                                                                    "udi_name",
                                                                                    "vid") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                class Rma(Entity):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"

                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("rma_history",
                                                                                        "rma_number",
                                                                                        "test_history") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.rma_history.is_set or
                                                                            self.rma_number.is_set or
                                                                            self.test_history.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "rma" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "rma-history"):
                                                                            self.rma_history = value
                                                                            self.rma_history.value_namespace = name_space
                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "rma-number"):
                                                                            self.rma_number = value
                                                                            self.rma_number.value_namespace = name_space
                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "test-history"):
                                                                            self.test_history = value
                                                                            self.test_history.value_namespace = name_space
                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.asset_alias.is_set or
                                                                        self.asset_id.is_set or
                                                                        self.base_mac_address1.is_set or
                                                                        self.base_mac_address2.is_set or
                                                                        self.base_mac_address3.is_set or
                                                                        self.base_mac_address4.is_set or
                                                                        self.block_checksum.is_set or
                                                                        self.block_count.is_set or
                                                                        self.block_length.is_set or
                                                                        self.block_signature.is_set or
                                                                        self.block_version.is_set or
                                                                        self.chassis_sid.is_set or
                                                                        self.clei.is_set or
                                                                        self.controller_family.is_set or
                                                                        self.controller_type.is_set or
                                                                        self.description.is_set or
                                                                        self.dev_num1.is_set or
                                                                        self.dev_num2.is_set or
                                                                        self.dev_num3.is_set or
                                                                        self.dev_num4.is_set or
                                                                        self.dev_num5.is_set or
                                                                        self.dev_num6.is_set or
                                                                        self.dev_num7.is_set or
                                                                        self.eci.is_set or
                                                                        self.eeprom_size.is_set or
                                                                        self.engineer_use.is_set or
                                                                        self.fru_major_type.is_set or
                                                                        self.fru_minor_type.is_set or
                                                                        self.hw_version.is_set or
                                                                        self.hwid.is_set or
                                                                        self.idprom_format_rev.is_set or
                                                                        self.mac_add_blk_size1.is_set or
                                                                        self.mac_add_blk_size2.is_set or
                                                                        self.mac_add_blk_size3.is_set or
                                                                        self.mac_add_blk_size4.is_set or
                                                                        self.manu_test_data.is_set or
                                                                        self.mfg_bits.is_set or
                                                                        self.mfg_deviation.is_set or
                                                                        self.oem_string.is_set or
                                                                        self.part_number.is_set or
                                                                        self.part_revision.is_set or
                                                                        self.pca_num.is_set or
                                                                        self.pcavid.is_set or
                                                                        self.pcb_serial_num.is_set or
                                                                        self.pid.is_set or
                                                                        self.power_consumption.is_set or
                                                                        self.power_supply_type.is_set or
                                                                        self.product_id.is_set or
                                                                        self.rma_code.is_set or
                                                                        self.serial_number.is_set or
                                                                        self.snmpoid.is_set or
                                                                        self.top_assem_part_num.is_set or
                                                                        self.top_assem_vid.is_set or
                                                                        self.udi_description.is_set or
                                                                        self.udi_name.is_set or
                                                                        self.vid.is_set or
                                                                        (self.rma is not None and self.rma.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                        self.clei.yfilter != YFilter.not_set or
                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                        self.description.yfilter != YFilter.not_set or
                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                        self.eci.yfilter != YFilter.not_set or
                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                        self.pid.yfilter != YFilter.not_set or
                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                        self.vid.yfilter != YFilter.not_set or
                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "eeprom" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "rma"):
                                                                        if (self.rma is None):
                                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                        return self.rma

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "asset-alias"):
                                                                        self.asset_alias = value
                                                                        self.asset_alias.value_namespace = name_space
                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "asset-id"):
                                                                        self.asset_id = value
                                                                        self.asset_id.value_namespace = name_space
                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address1"):
                                                                        self.base_mac_address1 = value
                                                                        self.base_mac_address1.value_namespace = name_space
                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address2"):
                                                                        self.base_mac_address2 = value
                                                                        self.base_mac_address2.value_namespace = name_space
                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address3"):
                                                                        self.base_mac_address3 = value
                                                                        self.base_mac_address3.value_namespace = name_space
                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address4"):
                                                                        self.base_mac_address4 = value
                                                                        self.base_mac_address4.value_namespace = name_space
                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-checksum"):
                                                                        self.block_checksum = value
                                                                        self.block_checksum.value_namespace = name_space
                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-count"):
                                                                        self.block_count = value
                                                                        self.block_count.value_namespace = name_space
                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-length"):
                                                                        self.block_length = value
                                                                        self.block_length.value_namespace = name_space
                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-signature"):
                                                                        self.block_signature = value
                                                                        self.block_signature.value_namespace = name_space
                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-version"):
                                                                        self.block_version = value
                                                                        self.block_version.value_namespace = name_space
                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "chassis-sid"):
                                                                        self.chassis_sid = value
                                                                        self.chassis_sid.value_namespace = name_space
                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "clei"):
                                                                        self.clei = value
                                                                        self.clei.value_namespace = name_space
                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-family"):
                                                                        self.controller_family = value
                                                                        self.controller_family.value_namespace = name_space
                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-type"):
                                                                        self.controller_type = value
                                                                        self.controller_type.value_namespace = name_space
                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "description"):
                                                                        self.description = value
                                                                        self.description.value_namespace = name_space
                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num1"):
                                                                        self.dev_num1 = value
                                                                        self.dev_num1.value_namespace = name_space
                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num2"):
                                                                        self.dev_num2 = value
                                                                        self.dev_num2.value_namespace = name_space
                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num3"):
                                                                        self.dev_num3 = value
                                                                        self.dev_num3.value_namespace = name_space
                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num4"):
                                                                        self.dev_num4 = value
                                                                        self.dev_num4.value_namespace = name_space
                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num5"):
                                                                        self.dev_num5 = value
                                                                        self.dev_num5.value_namespace = name_space
                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num6"):
                                                                        self.dev_num6 = value
                                                                        self.dev_num6.value_namespace = name_space
                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num7"):
                                                                        self.dev_num7 = value
                                                                        self.dev_num7.value_namespace = name_space
                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eci"):
                                                                        self.eci = value
                                                                        self.eci.value_namespace = name_space
                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eeprom-size"):
                                                                        self.eeprom_size = value
                                                                        self.eeprom_size.value_namespace = name_space
                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "engineer-use"):
                                                                        self.engineer_use = value
                                                                        self.engineer_use.value_namespace = name_space
                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-major-type"):
                                                                        self.fru_major_type = value
                                                                        self.fru_major_type.value_namespace = name_space
                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-minor-type"):
                                                                        self.fru_minor_type = value
                                                                        self.fru_minor_type.value_namespace = name_space
                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hw-version"):
                                                                        self.hw_version = value
                                                                        self.hw_version.value_namespace = name_space
                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hwid"):
                                                                        self.hwid = value
                                                                        self.hwid.value_namespace = name_space
                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "idprom-format-rev"):
                                                                        self.idprom_format_rev = value
                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size1"):
                                                                        self.mac_add_blk_size1 = value
                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size2"):
                                                                        self.mac_add_blk_size2 = value
                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size3"):
                                                                        self.mac_add_blk_size3 = value
                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size4"):
                                                                        self.mac_add_blk_size4 = value
                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "manu-test-data"):
                                                                        self.manu_test_data = value
                                                                        self.manu_test_data.value_namespace = name_space
                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-bits"):
                                                                        self.mfg_bits = value
                                                                        self.mfg_bits.value_namespace = name_space
                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-deviation"):
                                                                        self.mfg_deviation = value
                                                                        self.mfg_deviation.value_namespace = name_space
                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "oem-string"):
                                                                        self.oem_string = value
                                                                        self.oem_string.value_namespace = name_space
                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-number"):
                                                                        self.part_number = value
                                                                        self.part_number.value_namespace = name_space
                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-revision"):
                                                                        self.part_revision = value
                                                                        self.part_revision.value_namespace = name_space
                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pca-num"):
                                                                        self.pca_num = value
                                                                        self.pca_num.value_namespace = name_space
                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcavid"):
                                                                        self.pcavid = value
                                                                        self.pcavid.value_namespace = name_space
                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcb-serial-num"):
                                                                        self.pcb_serial_num = value
                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pid"):
                                                                        self.pid = value
                                                                        self.pid.value_namespace = name_space
                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-consumption"):
                                                                        self.power_consumption = value
                                                                        self.power_consumption.value_namespace = name_space
                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-supply-type"):
                                                                        self.power_supply_type = value
                                                                        self.power_supply_type.value_namespace = name_space
                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "product-id"):
                                                                        self.product_id = value
                                                                        self.product_id.value_namespace = name_space
                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "rma-code"):
                                                                        self.rma_code = value
                                                                        self.rma_code.value_namespace = name_space
                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "serial-number"):
                                                                        self.serial_number = value
                                                                        self.serial_number.value_namespace = name_space
                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "snmpoid"):
                                                                        self.snmpoid = value
                                                                        self.snmpoid.value_namespace = name_space
                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-part-num"):
                                                                        self.top_assem_part_num = value
                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-vid"):
                                                                        self.top_assem_vid = value
                                                                        self.top_assem_vid.value_namespace = name_space
                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-description"):
                                                                        self.udi_description = value
                                                                        self.udi_description.value_namespace = name_space
                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-name"):
                                                                        self.udi_name = value
                                                                        self.udi_name.value_namespace = name_space
                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vid"):
                                                                        self.vid = value
                                                                        self.vid.value_namespace = name_space
                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.description.is_set or
                                                                    self.has_eeprom.is_set or
                                                                    self.inv_card_type.is_set or
                                                                    self.opaque_data.is_set or
                                                                    self.opaque_data_size.is_set or
                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "eeprom"):
                                                                    if (self.eeprom is None):
                                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                    return self.eeprom

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "has-eeprom"):
                                                                    self.has_eeprom = value
                                                                    self.has_eeprom.value_namespace = name_space
                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "inv-card-type"):
                                                                    self.inv_card_type = value
                                                                    self.inv_card_type.value_namespace = name_space
                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data"):
                                                                    self.opaque_data = value
                                                                    self.opaque_data.value_namespace = name_space
                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data-size"):
                                                                    self.opaque_data_size = value
                                                                    self.opaque_data_size.value_namespace = name_space
                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.module_done.is_set or
                                                                self.node_id.is_set or
                                                                self.vm_done.is_set or
                                                                self.vm_node_id.is_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                (self.threshold is not None and self.threshold.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.module_done.yfilter != YFilter.not_set or
                                                                self.node_id.yfilter != YFilter.not_set or
                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "attributes" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "env-sensor-info"):
                                                                if (self.env_sensor_info is None):
                                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                return self.env_sensor_info

                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                if (self.env_sensor_info_xml is None):
                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                return self.env_sensor_info_xml

                                                            if (child_yang_name == "fru-info"):
                                                                if (self.fru_info is None):
                                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                return self.fru_info

                                                            if (child_yang_name == "inv-asset-bag"):
                                                                if (self.inv_asset_bag is None):
                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                return self.inv_asset_bag

                                                            if (child_yang_name == "inv-basic-bag"):
                                                                if (self.inv_basic_bag is None):
                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                return self.inv_basic_bag

                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                if (self.inv_eeprom_info is None):
                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                return self.inv_eeprom_info

                                                            if (child_yang_name == "pwg-info"):
                                                                if (self.pwg_info is None):
                                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                return self.pwg_info

                                                            if (child_yang_name == "threshold"):
                                                                if (self.threshold is None):
                                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                return self.threshold

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "module-done"):
                                                                self.module_done = value
                                                                self.module_done.value_namespace = name_space
                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "node-id"):
                                                                self.node_id = value
                                                                self.node_id.value_namespace = name_space
                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-done"):
                                                                self.vm_done = value
                                                                self.vm_done.value_namespace = name_space
                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-node-id"):
                                                                self.vm_node_id = value
                                                                self.vm_node_id.value_namespace = name_space
                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.name.is_set or
                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "tsi4" + "[name='" + self.name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "attributes"):
                                                            if (self.attributes is None):
                                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                            return self.attributes

                                                        if (child_yang_name == "tsi5s"):
                                                            if (self.tsi5s is None):
                                                                self.tsi5s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                                self.tsi5s.parent = self
                                                                self._children_name_map["tsi5s"] = "tsi5s"
                                                            return self.tsi5s

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attributes" or name == "tsi5s" or name == "name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.tsi4:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.tsi4:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "tsi4s" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "tsi4"):
                                                        for c in self.tsi4:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.tsi4.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "tsi4"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Attributes(Entity):
                                                """
                                                Attributes
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo>`
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag>`
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag>`
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                .. attribute:: module_done
                                                
                                                	Inventory EDM Module Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**default value**\: 1
                                                
                                                .. attribute:: node_id
                                                
                                                	Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo>`
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold>`
                                                
                                                .. attribute:: vm_done
                                                
                                                	VM Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                .. attribute:: vm_node_id
                                                
                                                	VM Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"

                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                    self._children_yang_names.add("env-sensor-info")

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                    self._children_yang_names.add("fru-info")

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                    self._children_yang_names.add("inv-asset-bag")

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                    self._children_yang_names.add("inv-basic-bag")

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._children_yang_names.add("inv-eeprom-info")

                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                    self._children_yang_names.add("pwg-info")

                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                    self._children_yang_names.add("threshold")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("module_done",
                                                                    "node_id",
                                                                    "vm_done",
                                                                    "vm_node_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)


                                                class EnvSensorInfo(Entity):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                        self.status = YLeaf(YType.uint32, "status")

                                                        self.units = YLeaf(YType.str, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("age_time_stamp",
                                                                        "alarm_type",
                                                                        "data_type",
                                                                        "device_description",
                                                                        "device_id",
                                                                        "field_validity_bitmap",
                                                                        "precision",
                                                                        "scale",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.age_time_stamp.is_set or
                                                            self.alarm_type.is_set or
                                                            self.data_type.is_set or
                                                            self.device_description.is_set or
                                                            self.device_id.is_set or
                                                            self.field_validity_bitmap.is_set or
                                                            self.precision.is_set or
                                                            self.scale.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.device_description.yfilter != YFilter.not_set or
                                                            self.device_id.yfilter != YFilter.not_set or
                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                            self.precision.yfilter != YFilter.not_set or
                                                            self.scale.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "age-time-stamp"):
                                                            self.age_time_stamp = value
                                                            self.age_time_stamp.value_namespace = name_space
                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "alarm-type"):
                                                            self.alarm_type = value
                                                            self.alarm_type.value_namespace = name_space
                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-description"):
                                                            self.device_description = value
                                                            self.device_description.value_namespace = name_space
                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-id"):
                                                            self.device_id = value
                                                            self.device_id.value_namespace = name_space
                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "field-validity-bitmap"):
                                                            self.field_validity_bitmap = value
                                                            self.field_validity_bitmap.value_namespace = name_space
                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "precision"):
                                                            self.precision = value
                                                            self.precision.value_namespace = name_space
                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale"):
                                                            self.scale = value
                                                            self.scale.value_namespace = name_space
                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PwgInfo(Entity):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("power_group_available_current",
                                                                        "power_group_drawn_current",
                                                                        "power_group_power_units",
                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.power_group_available_current.is_set or
                                                            self.power_group_drawn_current.is_set or
                                                            self.power_group_power_units.is_set or
                                                            self.power_group_redundancy_mode.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pwg-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "power-group-available-current"):
                                                            self.power_group_available_current = value
                                                            self.power_group_available_current.value_namespace = name_space
                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-drawn-current"):
                                                            self.power_group_drawn_current = value
                                                            self.power_group_drawn_current.value_namespace = name_space
                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-power-units"):
                                                            self.power_group_power_units = value
                                                            self.power_group_power_units.value_namespace = name_space
                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-redundancy-mode"):
                                                            self.power_group_redundancy_mode = value
                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                class EnvSensorInfoXml(Entity):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"

                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.status = YLeaf(YType.enumeration, "status")

                                                        self.units = YLeaf(YType.enumeration, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.str, "value")

                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._children_yang_names.add("threshold")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("data_type",
                                                                        "description",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                    class Threshold(Entity):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                            self.threshold_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                        class ThresholdArray(Entity):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"

                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_name",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_name.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-name"):
                                                                    self.threshold_name = value
                                                                    self.threshold_name.value_namespace = name_space
                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "threshold-array"):
                                                                for c in self.threshold_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.threshold_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "threshold-array"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            self.data_type.is_set or
                                                            self.description.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set or
                                                            (self.threshold is not None and self.threshold.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "threshold"):
                                                            if (self.threshold is None):
                                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                            return self.threshold

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class InvAssetBag(Entity):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("manufacturer_assembly_number",
                                                                        "manufacturer_assembly_revision",
                                                                        "manufacturer_common_language_equipment_identifier",
                                                                        "manufacturer_firmware_identifier",
                                                                        "manufacturer_software_identifier",
                                                                        "original_equipment_manufacturer_string",
                                                                        "part_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.manufacturer_assembly_number.is_set or
                                                            self.manufacturer_assembly_revision.is_set or
                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                            self.manufacturer_firmware_identifier.is_set or
                                                            self.manufacturer_software_identifier.is_set or
                                                            self.original_equipment_manufacturer_string.is_set or
                                                            self.part_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                            self.part_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "manufacturer-assembly-number"):
                                                            self.manufacturer_assembly_number = value
                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-assembly-revision"):
                                                            self.manufacturer_assembly_revision = value
                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                            self.manufacturer_common_language_equipment_identifier = value
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                            self.manufacturer_firmware_identifier = value
                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-software-identifier"):
                                                            self.manufacturer_software_identifier = value
                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                            self.original_equipment_manufacturer_string = value
                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "part-number"):
                                                            self.part_number = value
                                                            self.part_number.value_namespace = name_space
                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                class Threshold(Entity):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"

                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                        self._children_yang_names.add("critical-hi")

                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                        self._children_yang_names.add("critical-lo")

                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                        self._children_yang_names.add("major-hi")

                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                        self._children_yang_names.add("major-lo")

                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                        self._children_yang_names.add("minor-hi")

                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._children_yang_names.add("minor-lo")


                                                    class MajorLo(Entity):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalHi(Entity):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorHi(Entity):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MajorHi(Entity):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalLo(Entity):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorLo(Entity):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "critical-hi"):
                                                            if (self.critical_hi is None):
                                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                            return self.critical_hi

                                                        if (child_yang_name == "critical-lo"):
                                                            if (self.critical_lo is None):
                                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                            return self.critical_lo

                                                        if (child_yang_name == "major-hi"):
                                                            if (self.major_hi is None):
                                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                            return self.major_hi

                                                        if (child_yang_name == "major-lo"):
                                                            if (self.major_lo is None):
                                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                            return self.major_lo

                                                        if (child_yang_name == "minor-hi"):
                                                            if (self.minor_hi is None):
                                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                            return self.minor_hi

                                                        if (child_yang_name == "minor-lo"):
                                                            if (self.minor_lo is None):
                                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                            return self.minor_lo

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class FruInfo(Entity):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._children_yang_names.add("card-up-time")

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                        self._children_yang_names.add("last-operational-state-change")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("card_administrative_state",
                                                                        "card_monitor_state",
                                                                        "card_operational_state",
                                                                        "card_reset_reason",
                                                                        "power_administrative_state",
                                                                        "power_current_measurement",
                                                                        "power_operational_state") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)


                                                    class LastOperationalStateChange(Entity):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                    class CardUpTime(Entity):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "card-up-time" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.card_administrative_state.is_set or
                                                            self.card_monitor_state.is_set or
                                                            self.card_operational_state.is_set or
                                                            self.card_reset_reason.is_set or
                                                            self.power_administrative_state.is_set or
                                                            self.power_current_measurement.is_set or
                                                            self.power_operational_state.is_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fru-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "card-up-time"):
                                                            if (self.card_up_time is None):
                                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                            return self.card_up_time

                                                        if (child_yang_name == "last-operational-state-change"):
                                                            if (self.last_operational_state_change is None):
                                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                            return self.last_operational_state_change

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "card-administrative-state"):
                                                            self.card_administrative_state = value
                                                            self.card_administrative_state.value_namespace = name_space
                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-monitor-state"):
                                                            self.card_monitor_state = value
                                                            self.card_monitor_state.value_namespace = name_space
                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-operational-state"):
                                                            self.card_operational_state = value
                                                            self.card_operational_state.value_namespace = name_space
                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-reset-reason"):
                                                            self.card_reset_reason = value
                                                            self.card_reset_reason.value_namespace = name_space
                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-administrative-state"):
                                                            self.power_administrative_state = value
                                                            self.power_administrative_state.value_namespace = name_space
                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-current-measurement"):
                                                            self.power_current_measurement = value
                                                            self.power_current_measurement.value_namespace = name_space
                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-operational-state"):
                                                            self.power_operational_state = value
                                                            self.power_operational_state.value_namespace = name_space
                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                class InvBasicBag(Entity):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.alias = YLeaf(YType.str, "alias")

                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("alias",
                                                                        "asset_id_str",
                                                                        "asset_identification",
                                                                        "ceport",
                                                                        "chip_hardware_revision",
                                                                        "composite_class_code",
                                                                        "description",
                                                                        "environmental_monitor_path",
                                                                        "firmware_revision",
                                                                        "group_flag",
                                                                        "hardware_revision",
                                                                        "is_field_replaceable_unit",
                                                                        "manufacturer_asset_tags",
                                                                        "manufacturer_name",
                                                                        "memory_size",
                                                                        "model_name",
                                                                        "name",
                                                                        "new_deviation_number",
                                                                        "physical_layer_interface_module_type",
                                                                        "redundancystate",
                                                                        "serial_number",
                                                                        "software_revision",
                                                                        "unique_id",
                                                                        "unrecognized_fru",
                                                                        "vendor_type",
                                                                        "xr_scoped") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.alias.is_set or
                                                            self.asset_id_str.is_set or
                                                            self.asset_identification.is_set or
                                                            self.ceport.is_set or
                                                            self.chip_hardware_revision.is_set or
                                                            self.composite_class_code.is_set or
                                                            self.description.is_set or
                                                            self.environmental_monitor_path.is_set or
                                                            self.firmware_revision.is_set or
                                                            self.group_flag.is_set or
                                                            self.hardware_revision.is_set or
                                                            self.is_field_replaceable_unit.is_set or
                                                            self.manufacturer_asset_tags.is_set or
                                                            self.manufacturer_name.is_set or
                                                            self.memory_size.is_set or
                                                            self.model_name.is_set or
                                                            self.name.is_set or
                                                            self.new_deviation_number.is_set or
                                                            self.physical_layer_interface_module_type.is_set or
                                                            self.redundancystate.is_set or
                                                            self.serial_number.is_set or
                                                            self.software_revision.is_set or
                                                            self.unique_id.is_set or
                                                            self.unrecognized_fru.is_set or
                                                            self.vendor_type.is_set or
                                                            self.xr_scoped.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.alias.yfilter != YFilter.not_set or
                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                            self.ceport.yfilter != YFilter.not_set or
                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                            self.group_flag.yfilter != YFilter.not_set or
                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                            self.memory_size.yfilter != YFilter.not_set or
                                                            self.model_name.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                            self.serial_number.yfilter != YFilter.not_set or
                                                            self.software_revision.yfilter != YFilter.not_set or
                                                            self.unique_id.yfilter != YFilter.not_set or
                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "alias"):
                                                            self.alias = value
                                                            self.alias.value_namespace = name_space
                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-id-str"):
                                                            self.asset_id_str = value
                                                            self.asset_id_str.value_namespace = name_space
                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-identification"):
                                                            self.asset_identification = value
                                                            self.asset_identification.value_namespace = name_space
                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ceport"):
                                                            self.ceport = value
                                                            self.ceport.value_namespace = name_space
                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "chip-hardware-revision"):
                                                            self.chip_hardware_revision = value
                                                            self.chip_hardware_revision.value_namespace = name_space
                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "composite-class-code"):
                                                            self.composite_class_code = value
                                                            self.composite_class_code.value_namespace = name_space
                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "environmental-monitor-path"):
                                                            self.environmental_monitor_path = value
                                                            self.environmental_monitor_path.value_namespace = name_space
                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "firmware-revision"):
                                                            self.firmware_revision = value
                                                            self.firmware_revision.value_namespace = name_space
                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "group-flag"):
                                                            self.group_flag = value
                                                            self.group_flag.value_namespace = name_space
                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "hardware-revision"):
                                                            self.hardware_revision = value
                                                            self.hardware_revision.value_namespace = name_space
                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-field-replaceable-unit"):
                                                            self.is_field_replaceable_unit = value
                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-asset-tags"):
                                                            self.manufacturer_asset_tags = value
                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-name"):
                                                            self.manufacturer_name = value
                                                            self.manufacturer_name.value_namespace = name_space
                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "memory-size"):
                                                            self.memory_size = value
                                                            self.memory_size.value_namespace = name_space
                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "model-name"):
                                                            self.model_name = value
                                                            self.model_name.value_namespace = name_space
                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "new-deviation-number"):
                                                            self.new_deviation_number = value
                                                            self.new_deviation_number.value_namespace = name_space
                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "physical-layer-interface-module-type"):
                                                            self.physical_layer_interface_module_type = value
                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "redundancystate"):
                                                            self.redundancystate = value
                                                            self.redundancystate.value_namespace = name_space
                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "serial-number"):
                                                            self.serial_number = value
                                                            self.serial_number.value_namespace = name_space
                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "software-revision"):
                                                            self.software_revision = value
                                                            self.software_revision.value_namespace = name_space
                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unique-id"):
                                                            self.unique_id = value
                                                            self.unique_id.value_namespace = name_space
                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unrecognized-fru"):
                                                            self.unrecognized_fru = value
                                                            self.unrecognized_fru.value_namespace = name_space
                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "vendor-type"):
                                                            self.vendor_type = value
                                                            self.vendor_type.value_namespace = name_space
                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "xr-scoped"):
                                                            self.xr_scoped = value
                                                            self.xr_scoped.value_namespace = name_space
                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                class InvEepromInfo(Entity):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._children_yang_names.add("eeprom")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("description",
                                                                        "has_eeprom",
                                                                        "inv_card_type",
                                                                        "opaque_data",
                                                                        "opaque_data_size") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                    class Eeprom(Entity):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"

                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                            self.clei = YLeaf(YType.str, "clei")

                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                            self.description = YLeaf(YType.str, "description")

                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                            self.eci = YLeaf(YType.str, "eci")

                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                            self.pid = YLeaf(YType.str, "pid")

                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                            self.vid = YLeaf(YType.str, "vid")

                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._children_yang_names.add("rma")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("asset_alias",
                                                                            "asset_id",
                                                                            "base_mac_address1",
                                                                            "base_mac_address2",
                                                                            "base_mac_address3",
                                                                            "base_mac_address4",
                                                                            "block_checksum",
                                                                            "block_count",
                                                                            "block_length",
                                                                            "block_signature",
                                                                            "block_version",
                                                                            "chassis_sid",
                                                                            "clei",
                                                                            "controller_family",
                                                                            "controller_type",
                                                                            "description",
                                                                            "dev_num1",
                                                                            "dev_num2",
                                                                            "dev_num3",
                                                                            "dev_num4",
                                                                            "dev_num5",
                                                                            "dev_num6",
                                                                            "dev_num7",
                                                                            "eci",
                                                                            "eeprom_size",
                                                                            "engineer_use",
                                                                            "fru_major_type",
                                                                            "fru_minor_type",
                                                                            "hw_version",
                                                                            "hwid",
                                                                            "idprom_format_rev",
                                                                            "mac_add_blk_size1",
                                                                            "mac_add_blk_size2",
                                                                            "mac_add_blk_size3",
                                                                            "mac_add_blk_size4",
                                                                            "manu_test_data",
                                                                            "mfg_bits",
                                                                            "mfg_deviation",
                                                                            "oem_string",
                                                                            "part_number",
                                                                            "part_revision",
                                                                            "pca_num",
                                                                            "pcavid",
                                                                            "pcb_serial_num",
                                                                            "pid",
                                                                            "power_consumption",
                                                                            "power_supply_type",
                                                                            "product_id",
                                                                            "rma_code",
                                                                            "serial_number",
                                                                            "snmpoid",
                                                                            "top_assem_part_num",
                                                                            "top_assem_vid",
                                                                            "udi_description",
                                                                            "udi_name",
                                                                            "vid") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                        class Rma(Entity):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"

                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("rma_history",
                                                                                "rma_number",
                                                                                "test_history") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.rma_history.is_set or
                                                                    self.rma_number.is_set or
                                                                    self.test_history.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                    self.test_history.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "rma" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "rma-history"):
                                                                    self.rma_history = value
                                                                    self.rma_history.value_namespace = name_space
                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "rma-number"):
                                                                    self.rma_number = value
                                                                    self.rma_number.value_namespace = name_space
                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "test-history"):
                                                                    self.test_history = value
                                                                    self.test_history.value_namespace = name_space
                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.asset_alias.is_set or
                                                                self.asset_id.is_set or
                                                                self.base_mac_address1.is_set or
                                                                self.base_mac_address2.is_set or
                                                                self.base_mac_address3.is_set or
                                                                self.base_mac_address4.is_set or
                                                                self.block_checksum.is_set or
                                                                self.block_count.is_set or
                                                                self.block_length.is_set or
                                                                self.block_signature.is_set or
                                                                self.block_version.is_set or
                                                                self.chassis_sid.is_set or
                                                                self.clei.is_set or
                                                                self.controller_family.is_set or
                                                                self.controller_type.is_set or
                                                                self.description.is_set or
                                                                self.dev_num1.is_set or
                                                                self.dev_num2.is_set or
                                                                self.dev_num3.is_set or
                                                                self.dev_num4.is_set or
                                                                self.dev_num5.is_set or
                                                                self.dev_num6.is_set or
                                                                self.dev_num7.is_set or
                                                                self.eci.is_set or
                                                                self.eeprom_size.is_set or
                                                                self.engineer_use.is_set or
                                                                self.fru_major_type.is_set or
                                                                self.fru_minor_type.is_set or
                                                                self.hw_version.is_set or
                                                                self.hwid.is_set or
                                                                self.idprom_format_rev.is_set or
                                                                self.mac_add_blk_size1.is_set or
                                                                self.mac_add_blk_size2.is_set or
                                                                self.mac_add_blk_size3.is_set or
                                                                self.mac_add_blk_size4.is_set or
                                                                self.manu_test_data.is_set or
                                                                self.mfg_bits.is_set or
                                                                self.mfg_deviation.is_set or
                                                                self.oem_string.is_set or
                                                                self.part_number.is_set or
                                                                self.part_revision.is_set or
                                                                self.pca_num.is_set or
                                                                self.pcavid.is_set or
                                                                self.pcb_serial_num.is_set or
                                                                self.pid.is_set or
                                                                self.power_consumption.is_set or
                                                                self.power_supply_type.is_set or
                                                                self.product_id.is_set or
                                                                self.rma_code.is_set or
                                                                self.serial_number.is_set or
                                                                self.snmpoid.is_set or
                                                                self.top_assem_part_num.is_set or
                                                                self.top_assem_vid.is_set or
                                                                self.udi_description.is_set or
                                                                self.udi_name.is_set or
                                                                self.vid.is_set or
                                                                (self.rma is not None and self.rma.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                self.block_count.yfilter != YFilter.not_set or
                                                                self.block_length.yfilter != YFilter.not_set or
                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                self.block_version.yfilter != YFilter.not_set or
                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                self.clei.yfilter != YFilter.not_set or
                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                self.description.yfilter != YFilter.not_set or
                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                self.eci.yfilter != YFilter.not_set or
                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                self.hwid.yfilter != YFilter.not_set or
                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                self.part_number.yfilter != YFilter.not_set or
                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                self.pid.yfilter != YFilter.not_set or
                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                self.product_id.yfilter != YFilter.not_set or
                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                self.vid.yfilter != YFilter.not_set or
                                                                (self.rma is not None and self.rma.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "eeprom" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "rma"):
                                                                if (self.rma is None):
                                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                return self.rma

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "asset-alias"):
                                                                self.asset_alias = value
                                                                self.asset_alias.value_namespace = name_space
                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "asset-id"):
                                                                self.asset_id = value
                                                                self.asset_id.value_namespace = name_space
                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address1"):
                                                                self.base_mac_address1 = value
                                                                self.base_mac_address1.value_namespace = name_space
                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address2"):
                                                                self.base_mac_address2 = value
                                                                self.base_mac_address2.value_namespace = name_space
                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address3"):
                                                                self.base_mac_address3 = value
                                                                self.base_mac_address3.value_namespace = name_space
                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address4"):
                                                                self.base_mac_address4 = value
                                                                self.base_mac_address4.value_namespace = name_space
                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-checksum"):
                                                                self.block_checksum = value
                                                                self.block_checksum.value_namespace = name_space
                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-count"):
                                                                self.block_count = value
                                                                self.block_count.value_namespace = name_space
                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-length"):
                                                                self.block_length = value
                                                                self.block_length.value_namespace = name_space
                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-signature"):
                                                                self.block_signature = value
                                                                self.block_signature.value_namespace = name_space
                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-version"):
                                                                self.block_version = value
                                                                self.block_version.value_namespace = name_space
                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "chassis-sid"):
                                                                self.chassis_sid = value
                                                                self.chassis_sid.value_namespace = name_space
                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "clei"):
                                                                self.clei = value
                                                                self.clei.value_namespace = name_space
                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-family"):
                                                                self.controller_family = value
                                                                self.controller_family.value_namespace = name_space
                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-type"):
                                                                self.controller_type = value
                                                                self.controller_type.value_namespace = name_space
                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "description"):
                                                                self.description = value
                                                                self.description.value_namespace = name_space
                                                                self.description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num1"):
                                                                self.dev_num1 = value
                                                                self.dev_num1.value_namespace = name_space
                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num2"):
                                                                self.dev_num2 = value
                                                                self.dev_num2.value_namespace = name_space
                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num3"):
                                                                self.dev_num3 = value
                                                                self.dev_num3.value_namespace = name_space
                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num4"):
                                                                self.dev_num4 = value
                                                                self.dev_num4.value_namespace = name_space
                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num5"):
                                                                self.dev_num5 = value
                                                                self.dev_num5.value_namespace = name_space
                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num6"):
                                                                self.dev_num6 = value
                                                                self.dev_num6.value_namespace = name_space
                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num7"):
                                                                self.dev_num7 = value
                                                                self.dev_num7.value_namespace = name_space
                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eci"):
                                                                self.eci = value
                                                                self.eci.value_namespace = name_space
                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eeprom-size"):
                                                                self.eeprom_size = value
                                                                self.eeprom_size.value_namespace = name_space
                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "engineer-use"):
                                                                self.engineer_use = value
                                                                self.engineer_use.value_namespace = name_space
                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-major-type"):
                                                                self.fru_major_type = value
                                                                self.fru_major_type.value_namespace = name_space
                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-minor-type"):
                                                                self.fru_minor_type = value
                                                                self.fru_minor_type.value_namespace = name_space
                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hw-version"):
                                                                self.hw_version = value
                                                                self.hw_version.value_namespace = name_space
                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hwid"):
                                                                self.hwid = value
                                                                self.hwid.value_namespace = name_space
                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "idprom-format-rev"):
                                                                self.idprom_format_rev = value
                                                                self.idprom_format_rev.value_namespace = name_space
                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size1"):
                                                                self.mac_add_blk_size1 = value
                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size2"):
                                                                self.mac_add_blk_size2 = value
                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size3"):
                                                                self.mac_add_blk_size3 = value
                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size4"):
                                                                self.mac_add_blk_size4 = value
                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "manu-test-data"):
                                                                self.manu_test_data = value
                                                                self.manu_test_data.value_namespace = name_space
                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-bits"):
                                                                self.mfg_bits = value
                                                                self.mfg_bits.value_namespace = name_space
                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-deviation"):
                                                                self.mfg_deviation = value
                                                                self.mfg_deviation.value_namespace = name_space
                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "oem-string"):
                                                                self.oem_string = value
                                                                self.oem_string.value_namespace = name_space
                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-number"):
                                                                self.part_number = value
                                                                self.part_number.value_namespace = name_space
                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-revision"):
                                                                self.part_revision = value
                                                                self.part_revision.value_namespace = name_space
                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pca-num"):
                                                                self.pca_num = value
                                                                self.pca_num.value_namespace = name_space
                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcavid"):
                                                                self.pcavid = value
                                                                self.pcavid.value_namespace = name_space
                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcb-serial-num"):
                                                                self.pcb_serial_num = value
                                                                self.pcb_serial_num.value_namespace = name_space
                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pid"):
                                                                self.pid = value
                                                                self.pid.value_namespace = name_space
                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-consumption"):
                                                                self.power_consumption = value
                                                                self.power_consumption.value_namespace = name_space
                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-supply-type"):
                                                                self.power_supply_type = value
                                                                self.power_supply_type.value_namespace = name_space
                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "product-id"):
                                                                self.product_id = value
                                                                self.product_id.value_namespace = name_space
                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "rma-code"):
                                                                self.rma_code = value
                                                                self.rma_code.value_namespace = name_space
                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "serial-number"):
                                                                self.serial_number = value
                                                                self.serial_number.value_namespace = name_space
                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "snmpoid"):
                                                                self.snmpoid = value
                                                                self.snmpoid.value_namespace = name_space
                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-part-num"):
                                                                self.top_assem_part_num = value
                                                                self.top_assem_part_num.value_namespace = name_space
                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-vid"):
                                                                self.top_assem_vid = value
                                                                self.top_assem_vid.value_namespace = name_space
                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-description"):
                                                                self.udi_description = value
                                                                self.udi_description.value_namespace = name_space
                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-name"):
                                                                self.udi_name = value
                                                                self.udi_name.value_namespace = name_space
                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vid"):
                                                                self.vid = value
                                                                self.vid.value_namespace = name_space
                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.description.is_set or
                                                            self.has_eeprom.is_set or
                                                            self.inv_card_type.is_set or
                                                            self.opaque_data.is_set or
                                                            self.opaque_data_size.is_set or
                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "eeprom"):
                                                            if (self.eeprom is None):
                                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                            return self.eeprom

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "has-eeprom"):
                                                            self.has_eeprom = value
                                                            self.has_eeprom.value_namespace = name_space
                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "inv-card-type"):
                                                            self.inv_card_type = value
                                                            self.inv_card_type.value_namespace = name_space
                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data"):
                                                            self.opaque_data = value
                                                            self.opaque_data.value_namespace = name_space
                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data-size"):
                                                            self.opaque_data_size = value
                                                            self.opaque_data_size.value_namespace = name_space
                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.module_done.is_set or
                                                        self.node_id.is_set or
                                                        self.vm_done.is_set or
                                                        self.vm_node_id.is_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                        (self.threshold is not None and self.threshold.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.module_done.yfilter != YFilter.not_set or
                                                        self.node_id.yfilter != YFilter.not_set or
                                                        self.vm_done.yfilter != YFilter.not_set or
                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "attributes" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "env-sensor-info"):
                                                        if (self.env_sensor_info is None):
                                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                        return self.env_sensor_info

                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                        if (self.env_sensor_info_xml is None):
                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                        return self.env_sensor_info_xml

                                                    if (child_yang_name == "fru-info"):
                                                        if (self.fru_info is None):
                                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                        return self.fru_info

                                                    if (child_yang_name == "inv-asset-bag"):
                                                        if (self.inv_asset_bag is None):
                                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                        return self.inv_asset_bag

                                                    if (child_yang_name == "inv-basic-bag"):
                                                        if (self.inv_basic_bag is None):
                                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                        return self.inv_basic_bag

                                                    if (child_yang_name == "inv-eeprom-info"):
                                                        if (self.inv_eeprom_info is None):
                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                        return self.inv_eeprom_info

                                                    if (child_yang_name == "pwg-info"):
                                                        if (self.pwg_info is None):
                                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                        return self.pwg_info

                                                    if (child_yang_name == "threshold"):
                                                        if (self.threshold is None):
                                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                        return self.threshold

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "module-done"):
                                                        self.module_done = value
                                                        self.module_done.value_namespace = name_space
                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "node-id"):
                                                        self.node_id = value
                                                        self.node_id.value_namespace = name_space
                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-done"):
                                                        self.vm_done = value
                                                        self.vm_done.value_namespace = name_space
                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-node-id"):
                                                        self.vm_node_id = value
                                                        self.vm_node_id.value_namespace = name_space
                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.name.is_set or
                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tsi3" + "[name='" + self.name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "attributes"):
                                                    if (self.attributes is None):
                                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                    return self.attributes

                                                if (child_yang_name == "tsi4s"):
                                                    if (self.tsi4s is None):
                                                        self.tsi4s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                        self.tsi4s.parent = self
                                                        self._children_name_map["tsi4s"] = "tsi4s"
                                                    return self.tsi4s

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attributes" or name == "tsi4s" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tsi3:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.tsi3:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tsi3s" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "tsi3"):
                                                for c in self.tsi3:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tsi3.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tsi3"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Attributes(Entity):
                                        """
                                        Attributes
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo>`
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag>`
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag>`
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        .. attribute:: module_done
                                        
                                        	Inventory EDM Module Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**default value**\: 1
                                        
                                        .. attribute:: node_id
                                        
                                        	Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo>`
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold>`
                                        
                                        .. attribute:: vm_done
                                        
                                        	VM Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: vm_node_id
                                        
                                        	VM Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"

                                            self.module_done = YLeaf(YType.int32, "module-done")

                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                            self._children_yang_names.add("env-sensor-info")

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                            self._children_yang_names.add("env-sensor-info-xml")

                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                            self._children_yang_names.add("fru-info")

                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                            self._children_yang_names.add("inv-asset-bag")

                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                            self._children_yang_names.add("inv-basic-bag")

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._children_yang_names.add("inv-eeprom-info")

                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                            self._children_yang_names.add("pwg-info")

                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                            self._children_yang_names.add("threshold")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("module_done",
                                                            "node_id",
                                                            "vm_done",
                                                            "vm_node_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)


                                        class EnvSensorInfo(Entity):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"

                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                self.device_description = YLeaf(YType.str, "device-description")

                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                self.precision = YLeaf(YType.uint32, "precision")

                                                self.scale = YLeaf(YType.uint32, "scale")

                                                self.status = YLeaf(YType.uint32, "status")

                                                self.units = YLeaf(YType.str, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("age_time_stamp",
                                                                "alarm_type",
                                                                "data_type",
                                                                "device_description",
                                                                "device_id",
                                                                "field_validity_bitmap",
                                                                "precision",
                                                                "scale",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.age_time_stamp.is_set or
                                                    self.alarm_type.is_set or
                                                    self.data_type.is_set or
                                                    self.device_description.is_set or
                                                    self.device_id.is_set or
                                                    self.field_validity_bitmap.is_set or
                                                    self.precision.is_set or
                                                    self.scale.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.device_description.yfilter != YFilter.not_set or
                                                    self.device_id.yfilter != YFilter.not_set or
                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                    self.precision.yfilter != YFilter.not_set or
                                                    self.scale.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "age-time-stamp"):
                                                    self.age_time_stamp = value
                                                    self.age_time_stamp.value_namespace = name_space
                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "alarm-type"):
                                                    self.alarm_type = value
                                                    self.alarm_type.value_namespace = name_space
                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-description"):
                                                    self.device_description = value
                                                    self.device_description.value_namespace = name_space
                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-id"):
                                                    self.device_id = value
                                                    self.device_id.value_namespace = name_space
                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "field-validity-bitmap"):
                                                    self.field_validity_bitmap = value
                                                    self.field_validity_bitmap.value_namespace = name_space
                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                if(value_path == "precision"):
                                                    self.precision = value
                                                    self.precision.value_namespace = name_space
                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale"):
                                                    self.scale = value
                                                    self.scale.value_namespace = name_space
                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PwgInfo(Entity):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\:  str
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"

                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("power_group_available_current",
                                                                "power_group_drawn_current",
                                                                "power_group_power_units",
                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.power_group_available_current.is_set or
                                                    self.power_group_drawn_current.is_set or
                                                    self.power_group_power_units.is_set or
                                                    self.power_group_redundancy_mode.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pwg-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "power-group-available-current"):
                                                    self.power_group_available_current = value
                                                    self.power_group_available_current.value_namespace = name_space
                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-drawn-current"):
                                                    self.power_group_drawn_current = value
                                                    self.power_group_drawn_current.value_namespace = name_space
                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-power-units"):
                                                    self.power_group_power_units = value
                                                    self.power_group_power_units.value_namespace = name_space
                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-redundancy-mode"):
                                                    self.power_group_redundancy_mode = value
                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                        class EnvSensorInfoXml(Entity):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"

                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                self.description = YLeaf(YType.str, "description")

                                                self.status = YLeaf(YType.enumeration, "status")

                                                self.units = YLeaf(YType.enumeration, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.str, "value")

                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._children_yang_names.add("threshold")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("data_type",
                                                                "description",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                            class Threshold(Entity):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                    self.threshold_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                class ThresholdArray(Entity):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"

                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_name",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_name.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-name"):
                                                            self.threshold_name = value
                                                            self.threshold_name.value_namespace = name_space
                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "threshold-array"):
                                                        for c in self.threshold_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.threshold_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "threshold-array"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.data_type.is_set or
                                                    self.description.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set or
                                                    (self.threshold is not None and self.threshold.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    (self.threshold is not None and self.threshold.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "threshold"):
                                                    if (self.threshold is None):
                                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                    return self.threshold

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class InvAssetBag(Entity):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"

                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                self.part_number = YLeaf(YType.str, "part-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("manufacturer_assembly_number",
                                                                "manufacturer_assembly_revision",
                                                                "manufacturer_common_language_equipment_identifier",
                                                                "manufacturer_firmware_identifier",
                                                                "manufacturer_software_identifier",
                                                                "original_equipment_manufacturer_string",
                                                                "part_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.manufacturer_assembly_number.is_set or
                                                    self.manufacturer_assembly_revision.is_set or
                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                    self.manufacturer_firmware_identifier.is_set or
                                                    self.manufacturer_software_identifier.is_set or
                                                    self.original_equipment_manufacturer_string.is_set or
                                                    self.part_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                    self.part_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-asset-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "manufacturer-assembly-number"):
                                                    self.manufacturer_assembly_number = value
                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-assembly-revision"):
                                                    self.manufacturer_assembly_revision = value
                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                    self.manufacturer_common_language_equipment_identifier = value
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-firmware-identifier"):
                                                    self.manufacturer_firmware_identifier = value
                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-software-identifier"):
                                                    self.manufacturer_software_identifier = value
                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "original-equipment-manufacturer-string"):
                                                    self.original_equipment_manufacturer_string = value
                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                if(value_path == "part-number"):
                                                    self.part_number = value
                                                    self.part_number.value_namespace = name_space
                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                        class Threshold(Entity):
                                            """
                                            Threshold
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"

                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                self._children_yang_names.add("critical-hi")

                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                self._children_yang_names.add("critical-lo")

                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                                self._children_yang_names.add("major-hi")

                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                                self._children_yang_names.add("major-lo")

                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                self._children_yang_names.add("minor-hi")

                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._children_yang_names.add("minor-lo")


                                            class MajorLo(Entity):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalHi(Entity):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorHi(Entity):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MajorHi(Entity):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalLo(Entity):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorLo(Entity):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "critical-hi"):
                                                    if (self.critical_hi is None):
                                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                    return self.critical_hi

                                                if (child_yang_name == "critical-lo"):
                                                    if (self.critical_lo is None):
                                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                    return self.critical_lo

                                                if (child_yang_name == "major-hi"):
                                                    if (self.major_hi is None):
                                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                    return self.major_hi

                                                if (child_yang_name == "major-lo"):
                                                    if (self.major_lo is None):
                                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                    return self.major_lo

                                                if (child_yang_name == "minor-hi"):
                                                    if (self.minor_hi is None):
                                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                    return self.minor_hi

                                                if (child_yang_name == "minor-lo"):
                                                    if (self.minor_lo is None):
                                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                    return self.minor_lo

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class FruInfo(Entity):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"

                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._children_yang_names.add("card-up-time")

                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                self._children_yang_names.add("last-operational-state-change")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("card_administrative_state",
                                                                "card_monitor_state",
                                                                "card_operational_state",
                                                                "card_reset_reason",
                                                                "power_administrative_state",
                                                                "power_current_measurement",
                                                                "power_operational_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)


                                            class LastOperationalStateChange(Entity):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                            class CardUpTime(Entity):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "card-up-time" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.card_administrative_state.is_set or
                                                    self.card_monitor_state.is_set or
                                                    self.card_operational_state.is_set or
                                                    self.card_reset_reason.is_set or
                                                    self.power_administrative_state.is_set or
                                                    self.power_current_measurement.is_set or
                                                    self.power_operational_state.is_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fru-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "card-up-time"):
                                                    if (self.card_up_time is None):
                                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                    return self.card_up_time

                                                if (child_yang_name == "last-operational-state-change"):
                                                    if (self.last_operational_state_change is None):
                                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                    return self.last_operational_state_change

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "card-administrative-state"):
                                                    self.card_administrative_state = value
                                                    self.card_administrative_state.value_namespace = name_space
                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-monitor-state"):
                                                    self.card_monitor_state = value
                                                    self.card_monitor_state.value_namespace = name_space
                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-operational-state"):
                                                    self.card_operational_state = value
                                                    self.card_operational_state.value_namespace = name_space
                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-reset-reason"):
                                                    self.card_reset_reason = value
                                                    self.card_reset_reason.value_namespace = name_space
                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-administrative-state"):
                                                    self.power_administrative_state = value
                                                    self.power_administrative_state.value_namespace = name_space
                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-current-measurement"):
                                                    self.power_current_measurement = value
                                                    self.power_current_measurement.value_namespace = name_space
                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-operational-state"):
                                                    self.power_operational_state = value
                                                    self.power_operational_state.value_namespace = name_space
                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                        class InvBasicBag(Entity):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\:  bool
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\:  bool
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"

                                                self.alias = YLeaf(YType.str, "alias")

                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                self.description = YLeaf(YType.str, "description")

                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                self.model_name = YLeaf(YType.str, "model-name")

                                                self.name = YLeaf(YType.str, "name")

                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("alias",
                                                                "asset_id_str",
                                                                "asset_identification",
                                                                "ceport",
                                                                "chip_hardware_revision",
                                                                "composite_class_code",
                                                                "description",
                                                                "environmental_monitor_path",
                                                                "firmware_revision",
                                                                "group_flag",
                                                                "hardware_revision",
                                                                "is_field_replaceable_unit",
                                                                "manufacturer_asset_tags",
                                                                "manufacturer_name",
                                                                "memory_size",
                                                                "model_name",
                                                                "name",
                                                                "new_deviation_number",
                                                                "physical_layer_interface_module_type",
                                                                "redundancystate",
                                                                "serial_number",
                                                                "software_revision",
                                                                "unique_id",
                                                                "unrecognized_fru",
                                                                "vendor_type",
                                                                "xr_scoped") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.alias.is_set or
                                                    self.asset_id_str.is_set or
                                                    self.asset_identification.is_set or
                                                    self.ceport.is_set or
                                                    self.chip_hardware_revision.is_set or
                                                    self.composite_class_code.is_set or
                                                    self.description.is_set or
                                                    self.environmental_monitor_path.is_set or
                                                    self.firmware_revision.is_set or
                                                    self.group_flag.is_set or
                                                    self.hardware_revision.is_set or
                                                    self.is_field_replaceable_unit.is_set or
                                                    self.manufacturer_asset_tags.is_set or
                                                    self.manufacturer_name.is_set or
                                                    self.memory_size.is_set or
                                                    self.model_name.is_set or
                                                    self.name.is_set or
                                                    self.new_deviation_number.is_set or
                                                    self.physical_layer_interface_module_type.is_set or
                                                    self.redundancystate.is_set or
                                                    self.serial_number.is_set or
                                                    self.software_revision.is_set or
                                                    self.unique_id.is_set or
                                                    self.unrecognized_fru.is_set or
                                                    self.vendor_type.is_set or
                                                    self.xr_scoped.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.alias.yfilter != YFilter.not_set or
                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                    self.ceport.yfilter != YFilter.not_set or
                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                    self.group_flag.yfilter != YFilter.not_set or
                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                    self.memory_size.yfilter != YFilter.not_set or
                                                    self.model_name.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                    self.serial_number.yfilter != YFilter.not_set or
                                                    self.software_revision.yfilter != YFilter.not_set or
                                                    self.unique_id.yfilter != YFilter.not_set or
                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-basic-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "alias"):
                                                    self.alias = value
                                                    self.alias.value_namespace = name_space
                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-id-str"):
                                                    self.asset_id_str = value
                                                    self.asset_id_str.value_namespace = name_space
                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-identification"):
                                                    self.asset_identification = value
                                                    self.asset_identification.value_namespace = name_space
                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ceport"):
                                                    self.ceport = value
                                                    self.ceport.value_namespace = name_space
                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                if(value_path == "chip-hardware-revision"):
                                                    self.chip_hardware_revision = value
                                                    self.chip_hardware_revision.value_namespace = name_space
                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "composite-class-code"):
                                                    self.composite_class_code = value
                                                    self.composite_class_code.value_namespace = name_space
                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "environmental-monitor-path"):
                                                    self.environmental_monitor_path = value
                                                    self.environmental_monitor_path.value_namespace = name_space
                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                if(value_path == "firmware-revision"):
                                                    self.firmware_revision = value
                                                    self.firmware_revision.value_namespace = name_space
                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "group-flag"):
                                                    self.group_flag = value
                                                    self.group_flag.value_namespace = name_space
                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hardware-revision"):
                                                    self.hardware_revision = value
                                                    self.hardware_revision.value_namespace = name_space
                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-field-replaceable-unit"):
                                                    self.is_field_replaceable_unit = value
                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-asset-tags"):
                                                    self.manufacturer_asset_tags = value
                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-name"):
                                                    self.manufacturer_name = value
                                                    self.manufacturer_name.value_namespace = name_space
                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "memory-size"):
                                                    self.memory_size = value
                                                    self.memory_size.value_namespace = name_space
                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                if(value_path == "model-name"):
                                                    self.model_name = value
                                                    self.model_name.value_namespace = name_space
                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "new-deviation-number"):
                                                    self.new_deviation_number = value
                                                    self.new_deviation_number.value_namespace = name_space
                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "physical-layer-interface-module-type"):
                                                    self.physical_layer_interface_module_type = value
                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "redundancystate"):
                                                    self.redundancystate = value
                                                    self.redundancystate.value_namespace = name_space
                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "serial-number"):
                                                    self.serial_number = value
                                                    self.serial_number.value_namespace = name_space
                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "software-revision"):
                                                    self.software_revision = value
                                                    self.software_revision.value_namespace = name_space
                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unique-id"):
                                                    self.unique_id = value
                                                    self.unique_id.value_namespace = name_space
                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unrecognized-fru"):
                                                    self.unrecognized_fru = value
                                                    self.unrecognized_fru.value_namespace = name_space
                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                if(value_path == "vendor-type"):
                                                    self.vendor_type = value
                                                    self.vendor_type.value_namespace = name_space
                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "xr-scoped"):
                                                    self.xr_scoped = value
                                                    self.xr_scoped.value_namespace = name_space
                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                        class InvEepromInfo(Entity):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\:  str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"

                                                self.description = YLeaf(YType.str, "description")

                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._children_yang_names.add("eeprom")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("description",
                                                                "has_eeprom",
                                                                "inv_card_type",
                                                                "opaque_data",
                                                                "opaque_data_size") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                            class Eeprom(Entity):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"

                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                    self.clei = YLeaf(YType.str, "clei")

                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                    self.description = YLeaf(YType.str, "description")

                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                    self.eci = YLeaf(YType.str, "eci")

                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                    self.pid = YLeaf(YType.str, "pid")

                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                    self.vid = YLeaf(YType.str, "vid")

                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._children_yang_names.add("rma")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("asset_alias",
                                                                    "asset_id",
                                                                    "base_mac_address1",
                                                                    "base_mac_address2",
                                                                    "base_mac_address3",
                                                                    "base_mac_address4",
                                                                    "block_checksum",
                                                                    "block_count",
                                                                    "block_length",
                                                                    "block_signature",
                                                                    "block_version",
                                                                    "chassis_sid",
                                                                    "clei",
                                                                    "controller_family",
                                                                    "controller_type",
                                                                    "description",
                                                                    "dev_num1",
                                                                    "dev_num2",
                                                                    "dev_num3",
                                                                    "dev_num4",
                                                                    "dev_num5",
                                                                    "dev_num6",
                                                                    "dev_num7",
                                                                    "eci",
                                                                    "eeprom_size",
                                                                    "engineer_use",
                                                                    "fru_major_type",
                                                                    "fru_minor_type",
                                                                    "hw_version",
                                                                    "hwid",
                                                                    "idprom_format_rev",
                                                                    "mac_add_blk_size1",
                                                                    "mac_add_blk_size2",
                                                                    "mac_add_blk_size3",
                                                                    "mac_add_blk_size4",
                                                                    "manu_test_data",
                                                                    "mfg_bits",
                                                                    "mfg_deviation",
                                                                    "oem_string",
                                                                    "part_number",
                                                                    "part_revision",
                                                                    "pca_num",
                                                                    "pcavid",
                                                                    "pcb_serial_num",
                                                                    "pid",
                                                                    "power_consumption",
                                                                    "power_supply_type",
                                                                    "product_id",
                                                                    "rma_code",
                                                                    "serial_number",
                                                                    "snmpoid",
                                                                    "top_assem_part_num",
                                                                    "top_assem_vid",
                                                                    "udi_description",
                                                                    "udi_name",
                                                                    "vid") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                class Rma(Entity):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"

                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("rma_history",
                                                                        "rma_number",
                                                                        "test_history") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.rma_history.is_set or
                                                            self.rma_number.is_set or
                                                            self.test_history.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.rma_history.yfilter != YFilter.not_set or
                                                            self.rma_number.yfilter != YFilter.not_set or
                                                            self.test_history.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "rma" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "rma-history"):
                                                            self.rma_history = value
                                                            self.rma_history.value_namespace = name_space
                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rma-number"):
                                                            self.rma_number = value
                                                            self.rma_number.value_namespace = name_space
                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "test-history"):
                                                            self.test_history = value
                                                            self.test_history.value_namespace = name_space
                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.asset_alias.is_set or
                                                        self.asset_id.is_set or
                                                        self.base_mac_address1.is_set or
                                                        self.base_mac_address2.is_set or
                                                        self.base_mac_address3.is_set or
                                                        self.base_mac_address4.is_set or
                                                        self.block_checksum.is_set or
                                                        self.block_count.is_set or
                                                        self.block_length.is_set or
                                                        self.block_signature.is_set or
                                                        self.block_version.is_set or
                                                        self.chassis_sid.is_set or
                                                        self.clei.is_set or
                                                        self.controller_family.is_set or
                                                        self.controller_type.is_set or
                                                        self.description.is_set or
                                                        self.dev_num1.is_set or
                                                        self.dev_num2.is_set or
                                                        self.dev_num3.is_set or
                                                        self.dev_num4.is_set or
                                                        self.dev_num5.is_set or
                                                        self.dev_num6.is_set or
                                                        self.dev_num7.is_set or
                                                        self.eci.is_set or
                                                        self.eeprom_size.is_set or
                                                        self.engineer_use.is_set or
                                                        self.fru_major_type.is_set or
                                                        self.fru_minor_type.is_set or
                                                        self.hw_version.is_set or
                                                        self.hwid.is_set or
                                                        self.idprom_format_rev.is_set or
                                                        self.mac_add_blk_size1.is_set or
                                                        self.mac_add_blk_size2.is_set or
                                                        self.mac_add_blk_size3.is_set or
                                                        self.mac_add_blk_size4.is_set or
                                                        self.manu_test_data.is_set or
                                                        self.mfg_bits.is_set or
                                                        self.mfg_deviation.is_set or
                                                        self.oem_string.is_set or
                                                        self.part_number.is_set or
                                                        self.part_revision.is_set or
                                                        self.pca_num.is_set or
                                                        self.pcavid.is_set or
                                                        self.pcb_serial_num.is_set or
                                                        self.pid.is_set or
                                                        self.power_consumption.is_set or
                                                        self.power_supply_type.is_set or
                                                        self.product_id.is_set or
                                                        self.rma_code.is_set or
                                                        self.serial_number.is_set or
                                                        self.snmpoid.is_set or
                                                        self.top_assem_part_num.is_set or
                                                        self.top_assem_vid.is_set or
                                                        self.udi_description.is_set or
                                                        self.udi_name.is_set or
                                                        self.vid.is_set or
                                                        (self.rma is not None and self.rma.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                        self.asset_id.yfilter != YFilter.not_set or
                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                        self.block_count.yfilter != YFilter.not_set or
                                                        self.block_length.yfilter != YFilter.not_set or
                                                        self.block_signature.yfilter != YFilter.not_set or
                                                        self.block_version.yfilter != YFilter.not_set or
                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                        self.clei.yfilter != YFilter.not_set or
                                                        self.controller_family.yfilter != YFilter.not_set or
                                                        self.controller_type.yfilter != YFilter.not_set or
                                                        self.description.yfilter != YFilter.not_set or
                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                        self.eci.yfilter != YFilter.not_set or
                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                        self.hw_version.yfilter != YFilter.not_set or
                                                        self.hwid.yfilter != YFilter.not_set or
                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                        self.oem_string.yfilter != YFilter.not_set or
                                                        self.part_number.yfilter != YFilter.not_set or
                                                        self.part_revision.yfilter != YFilter.not_set or
                                                        self.pca_num.yfilter != YFilter.not_set or
                                                        self.pcavid.yfilter != YFilter.not_set or
                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                        self.pid.yfilter != YFilter.not_set or
                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                        self.product_id.yfilter != YFilter.not_set or
                                                        self.rma_code.yfilter != YFilter.not_set or
                                                        self.serial_number.yfilter != YFilter.not_set or
                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                        self.udi_description.yfilter != YFilter.not_set or
                                                        self.udi_name.yfilter != YFilter.not_set or
                                                        self.vid.yfilter != YFilter.not_set or
                                                        (self.rma is not None and self.rma.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "eeprom" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "rma"):
                                                        if (self.rma is None):
                                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                        return self.rma

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "asset-alias"):
                                                        self.asset_alias = value
                                                        self.asset_alias.value_namespace = name_space
                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "asset-id"):
                                                        self.asset_id = value
                                                        self.asset_id.value_namespace = name_space
                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address1"):
                                                        self.base_mac_address1 = value
                                                        self.base_mac_address1.value_namespace = name_space
                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address2"):
                                                        self.base_mac_address2 = value
                                                        self.base_mac_address2.value_namespace = name_space
                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address3"):
                                                        self.base_mac_address3 = value
                                                        self.base_mac_address3.value_namespace = name_space
                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address4"):
                                                        self.base_mac_address4 = value
                                                        self.base_mac_address4.value_namespace = name_space
                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-checksum"):
                                                        self.block_checksum = value
                                                        self.block_checksum.value_namespace = name_space
                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-count"):
                                                        self.block_count = value
                                                        self.block_count.value_namespace = name_space
                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-length"):
                                                        self.block_length = value
                                                        self.block_length.value_namespace = name_space
                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-signature"):
                                                        self.block_signature = value
                                                        self.block_signature.value_namespace = name_space
                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-version"):
                                                        self.block_version = value
                                                        self.block_version.value_namespace = name_space
                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "chassis-sid"):
                                                        self.chassis_sid = value
                                                        self.chassis_sid.value_namespace = name_space
                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "clei"):
                                                        self.clei = value
                                                        self.clei.value_namespace = name_space
                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-family"):
                                                        self.controller_family = value
                                                        self.controller_family.value_namespace = name_space
                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-type"):
                                                        self.controller_type = value
                                                        self.controller_type.value_namespace = name_space
                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "description"):
                                                        self.description = value
                                                        self.description.value_namespace = name_space
                                                        self.description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num1"):
                                                        self.dev_num1 = value
                                                        self.dev_num1.value_namespace = name_space
                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num2"):
                                                        self.dev_num2 = value
                                                        self.dev_num2.value_namespace = name_space
                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num3"):
                                                        self.dev_num3 = value
                                                        self.dev_num3.value_namespace = name_space
                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num4"):
                                                        self.dev_num4 = value
                                                        self.dev_num4.value_namespace = name_space
                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num5"):
                                                        self.dev_num5 = value
                                                        self.dev_num5.value_namespace = name_space
                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num6"):
                                                        self.dev_num6 = value
                                                        self.dev_num6.value_namespace = name_space
                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num7"):
                                                        self.dev_num7 = value
                                                        self.dev_num7.value_namespace = name_space
                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eci"):
                                                        self.eci = value
                                                        self.eci.value_namespace = name_space
                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eeprom-size"):
                                                        self.eeprom_size = value
                                                        self.eeprom_size.value_namespace = name_space
                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "engineer-use"):
                                                        self.engineer_use = value
                                                        self.engineer_use.value_namespace = name_space
                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-major-type"):
                                                        self.fru_major_type = value
                                                        self.fru_major_type.value_namespace = name_space
                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-minor-type"):
                                                        self.fru_minor_type = value
                                                        self.fru_minor_type.value_namespace = name_space
                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hw-version"):
                                                        self.hw_version = value
                                                        self.hw_version.value_namespace = name_space
                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hwid"):
                                                        self.hwid = value
                                                        self.hwid.value_namespace = name_space
                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "idprom-format-rev"):
                                                        self.idprom_format_rev = value
                                                        self.idprom_format_rev.value_namespace = name_space
                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size1"):
                                                        self.mac_add_blk_size1 = value
                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size2"):
                                                        self.mac_add_blk_size2 = value
                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size3"):
                                                        self.mac_add_blk_size3 = value
                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size4"):
                                                        self.mac_add_blk_size4 = value
                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "manu-test-data"):
                                                        self.manu_test_data = value
                                                        self.manu_test_data.value_namespace = name_space
                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-bits"):
                                                        self.mfg_bits = value
                                                        self.mfg_bits.value_namespace = name_space
                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-deviation"):
                                                        self.mfg_deviation = value
                                                        self.mfg_deviation.value_namespace = name_space
                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "oem-string"):
                                                        self.oem_string = value
                                                        self.oem_string.value_namespace = name_space
                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-number"):
                                                        self.part_number = value
                                                        self.part_number.value_namespace = name_space
                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-revision"):
                                                        self.part_revision = value
                                                        self.part_revision.value_namespace = name_space
                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pca-num"):
                                                        self.pca_num = value
                                                        self.pca_num.value_namespace = name_space
                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcavid"):
                                                        self.pcavid = value
                                                        self.pcavid.value_namespace = name_space
                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcb-serial-num"):
                                                        self.pcb_serial_num = value
                                                        self.pcb_serial_num.value_namespace = name_space
                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pid"):
                                                        self.pid = value
                                                        self.pid.value_namespace = name_space
                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-consumption"):
                                                        self.power_consumption = value
                                                        self.power_consumption.value_namespace = name_space
                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-supply-type"):
                                                        self.power_supply_type = value
                                                        self.power_supply_type.value_namespace = name_space
                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "product-id"):
                                                        self.product_id = value
                                                        self.product_id.value_namespace = name_space
                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rma-code"):
                                                        self.rma_code = value
                                                        self.rma_code.value_namespace = name_space
                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "serial-number"):
                                                        self.serial_number = value
                                                        self.serial_number.value_namespace = name_space
                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "snmpoid"):
                                                        self.snmpoid = value
                                                        self.snmpoid.value_namespace = name_space
                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-part-num"):
                                                        self.top_assem_part_num = value
                                                        self.top_assem_part_num.value_namespace = name_space
                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-vid"):
                                                        self.top_assem_vid = value
                                                        self.top_assem_vid.value_namespace = name_space
                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-description"):
                                                        self.udi_description = value
                                                        self.udi_description.value_namespace = name_space
                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-name"):
                                                        self.udi_name = value
                                                        self.udi_name.value_namespace = name_space
                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vid"):
                                                        self.vid = value
                                                        self.vid.value_namespace = name_space
                                                        self.vid.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.description.is_set or
                                                    self.has_eeprom.is_set or
                                                    self.inv_card_type.is_set or
                                                    self.opaque_data.is_set or
                                                    self.opaque_data_size.is_set or
                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "eeprom"):
                                                    if (self.eeprom is None):
                                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                    return self.eeprom

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-eeprom"):
                                                    self.has_eeprom = value
                                                    self.has_eeprom.value_namespace = name_space
                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                if(value_path == "inv-card-type"):
                                                    self.inv_card_type = value
                                                    self.inv_card_type.value_namespace = name_space
                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data"):
                                                    self.opaque_data = value
                                                    self.opaque_data.value_namespace = name_space
                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data-size"):
                                                    self.opaque_data_size = value
                                                    self.opaque_data_size.value_namespace = name_space
                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.module_done.is_set or
                                                self.node_id.is_set or
                                                self.vm_done.is_set or
                                                self.vm_node_id.is_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                (self.threshold is not None and self.threshold.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.module_done.yfilter != YFilter.not_set or
                                                self.node_id.yfilter != YFilter.not_set or
                                                self.vm_done.yfilter != YFilter.not_set or
                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                (self.threshold is not None and self.threshold.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attributes" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "env-sensor-info"):
                                                if (self.env_sensor_info is None):
                                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                return self.env_sensor_info

                                            if (child_yang_name == "env-sensor-info-xml"):
                                                if (self.env_sensor_info_xml is None):
                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                return self.env_sensor_info_xml

                                            if (child_yang_name == "fru-info"):
                                                if (self.fru_info is None):
                                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                return self.fru_info

                                            if (child_yang_name == "inv-asset-bag"):
                                                if (self.inv_asset_bag is None):
                                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                return self.inv_asset_bag

                                            if (child_yang_name == "inv-basic-bag"):
                                                if (self.inv_basic_bag is None):
                                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                return self.inv_basic_bag

                                            if (child_yang_name == "inv-eeprom-info"):
                                                if (self.inv_eeprom_info is None):
                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                return self.inv_eeprom_info

                                            if (child_yang_name == "pwg-info"):
                                                if (self.pwg_info is None):
                                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                return self.pwg_info

                                            if (child_yang_name == "threshold"):
                                                if (self.threshold is None):
                                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                return self.threshold

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "module-done"):
                                                self.module_done = value
                                                self.module_done.value_namespace = name_space
                                                self.module_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "node-id"):
                                                self.node_id = value
                                                self.node_id.value_namespace = name_space
                                                self.node_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-done"):
                                                self.vm_done = value
                                                self.vm_done.value_namespace = name_space
                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-node-id"):
                                                self.vm_node_id = value
                                                self.vm_node_id.value_namespace = name_space
                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.name.is_set or
                                            (self.attributes is not None and self.attributes.has_data()) or
                                            (self.tsi3s is not None and self.tsi3s.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            (self.attributes is not None and self.attributes.has_operation()) or
                                            (self.tsi3s is not None and self.tsi3s.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tsi2" + "[name='" + self.name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attributes"):
                                            if (self.attributes is None):
                                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                            return self.attributes

                                        if (child_yang_name == "tsi3s"):
                                            if (self.tsi3s is None):
                                                self.tsi3s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                                self.tsi3s.parent = self
                                                self._children_name_map["tsi3s"] = "tsi3s"
                                            return self.tsi3s

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attributes" or name == "tsi3s" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.tsi2:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.tsi2:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tsi2s" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "tsi2"):
                                        for c in self.tsi2:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.tsi2.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "tsi2"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Attributes(Entity):
                                """
                                Attributes
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo>`
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo>`
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag>`
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag>`
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo>`
                                
                                .. attribute:: module_done
                                
                                	Inventory EDM Module Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**default value**\: 1
                                
                                .. attribute:: node_id
                                
                                	Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo>`
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold>`
                                
                                .. attribute:: vm_done
                                
                                	VM Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vm_node_id
                                
                                	VM Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"

                                    self.module_done = YLeaf(YType.int32, "module-done")

                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                    self._children_yang_names.add("env-sensor-info")

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                    self._children_yang_names.add("env-sensor-info-xml")

                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                    self._children_yang_names.add("fru-info")

                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                    self._children_yang_names.add("inv-asset-bag")

                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                    self._children_yang_names.add("inv-basic-bag")

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._children_yang_names.add("inv-eeprom-info")

                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                    self._children_yang_names.add("pwg-info")

                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                    self._children_yang_names.add("threshold")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("module_done",
                                                    "node_id",
                                                    "vm_done",
                                                    "vm_node_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)


                                class EnvSensorInfo(Entity):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"

                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                        self.device_description = YLeaf(YType.str, "device-description")

                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                        self.precision = YLeaf(YType.uint32, "precision")

                                        self.scale = YLeaf(YType.uint32, "scale")

                                        self.status = YLeaf(YType.uint32, "status")

                                        self.units = YLeaf(YType.str, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.uint32, "value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("age_time_stamp",
                                                        "alarm_type",
                                                        "data_type",
                                                        "device_description",
                                                        "device_id",
                                                        "field_validity_bitmap",
                                                        "precision",
                                                        "scale",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.age_time_stamp.is_set or
                                            self.alarm_type.is_set or
                                            self.data_type.is_set or
                                            self.device_description.is_set or
                                            self.device_id.is_set or
                                            self.field_validity_bitmap.is_set or
                                            self.precision.is_set or
                                            self.scale.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                            self.alarm_type.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.device_description.yfilter != YFilter.not_set or
                                            self.device_id.yfilter != YFilter.not_set or
                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                            self.precision.yfilter != YFilter.not_set or
                                            self.scale.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "age-time-stamp"):
                                            self.age_time_stamp = value
                                            self.age_time_stamp.value_namespace = name_space
                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                        if(value_path == "alarm-type"):
                                            self.alarm_type = value
                                            self.alarm_type.value_namespace = name_space
                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-description"):
                                            self.device_description = value
                                            self.device_description.value_namespace = name_space
                                            self.device_description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-id"):
                                            self.device_id = value
                                            self.device_id.value_namespace = name_space
                                            self.device_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "field-validity-bitmap"):
                                            self.field_validity_bitmap = value
                                            self.field_validity_bitmap.value_namespace = name_space
                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                        if(value_path == "precision"):
                                            self.precision = value
                                            self.precision.value_namespace = name_space
                                            self.precision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "scale"):
                                            self.scale = value
                                            self.scale.value_namespace = name_space
                                            self.scale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class PwgInfo(Entity):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\:  str
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"

                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("power_group_available_current",
                                                        "power_group_drawn_current",
                                                        "power_group_power_units",
                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.power_group_available_current.is_set or
                                            self.power_group_drawn_current.is_set or
                                            self.power_group_power_units.is_set or
                                            self.power_group_redundancy_mode.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pwg-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "power-group-available-current"):
                                            self.power_group_available_current = value
                                            self.power_group_available_current.value_namespace = name_space
                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-drawn-current"):
                                            self.power_group_drawn_current = value
                                            self.power_group_drawn_current.value_namespace = name_space
                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-power-units"):
                                            self.power_group_power_units = value
                                            self.power_group_power_units.value_namespace = name_space
                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-redundancy-mode"):
                                            self.power_group_redundancy_mode = value
                                            self.power_group_redundancy_mode.value_namespace = name_space
                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                class EnvSensorInfoXml(Entity):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"

                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                        self.description = YLeaf(YType.str, "description")

                                        self.status = YLeaf(YType.enumeration, "status")

                                        self.units = YLeaf(YType.enumeration, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.str, "value")

                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._children_yang_names.add("threshold")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("data_type",
                                                        "description",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                    class Threshold(Entity):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"

                                            self.threshold_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                        class ThresholdArray(Entity):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"

                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_name",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_name.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-name"):
                                                    self.threshold_name = value
                                                    self.threshold_name.value_namespace = name_space
                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.threshold_array:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.threshold_array:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "threshold" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "threshold-array"):
                                                for c in self.threshold_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.threshold_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "threshold-array"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.data_type.is_set or
                                            self.description.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set or
                                            (self.threshold is not None and self.threshold.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set or
                                            (self.threshold is not None and self.threshold.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "threshold"):
                                            if (self.threshold is None):
                                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                            return self.threshold

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class InvAssetBag(Entity):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"

                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                        self.part_number = YLeaf(YType.str, "part-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("manufacturer_assembly_number",
                                                        "manufacturer_assembly_revision",
                                                        "manufacturer_common_language_equipment_identifier",
                                                        "manufacturer_firmware_identifier",
                                                        "manufacturer_software_identifier",
                                                        "original_equipment_manufacturer_string",
                                                        "part_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.manufacturer_assembly_number.is_set or
                                            self.manufacturer_assembly_revision.is_set or
                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                            self.manufacturer_firmware_identifier.is_set or
                                            self.manufacturer_software_identifier.is_set or
                                            self.original_equipment_manufacturer_string.is_set or
                                            self.part_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                            self.part_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-asset-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "manufacturer-assembly-number"):
                                            self.manufacturer_assembly_number = value
                                            self.manufacturer_assembly_number.value_namespace = name_space
                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-assembly-revision"):
                                            self.manufacturer_assembly_revision = value
                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                            self.manufacturer_common_language_equipment_identifier = value
                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-firmware-identifier"):
                                            self.manufacturer_firmware_identifier = value
                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-software-identifier"):
                                            self.manufacturer_software_identifier = value
                                            self.manufacturer_software_identifier.value_namespace = name_space
                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "original-equipment-manufacturer-string"):
                                            self.original_equipment_manufacturer_string = value
                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                        if(value_path == "part-number"):
                                            self.part_number = value
                                            self.part_number.value_namespace = name_space
                                            self.part_number.value_namespace_prefix = name_space_prefix


                                class Threshold(Entity):
                                    """
                                    Threshold
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"

                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                        self._children_yang_names.add("critical-hi")

                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                        self._children_yang_names.add("critical-lo")

                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                        self._children_yang_names.add("major-hi")

                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                        self._children_yang_names.add("major-lo")

                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                        self._children_yang_names.add("minor-hi")

                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._children_yang_names.add("minor-lo")


                                    class MajorLo(Entity):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalHi(Entity):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorHi(Entity):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MajorHi(Entity):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalLo(Entity):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorLo(Entity):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "critical-hi"):
                                            if (self.critical_hi is None):
                                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                            return self.critical_hi

                                        if (child_yang_name == "critical-lo"):
                                            if (self.critical_lo is None):
                                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                            return self.critical_lo

                                        if (child_yang_name == "major-hi"):
                                            if (self.major_hi is None):
                                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                            return self.major_hi

                                        if (child_yang_name == "major-lo"):
                                            if (self.major_lo is None):
                                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                            return self.major_lo

                                        if (child_yang_name == "minor-hi"):
                                            if (self.minor_hi is None):
                                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                            return self.minor_hi

                                        if (child_yang_name == "minor-lo"):
                                            if (self.minor_lo is None):
                                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                            return self.minor_lo

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class FruInfo(Entity):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"

                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._children_yang_names.add("card-up-time")

                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                        self._children_yang_names.add("last-operational-state-change")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("card_administrative_state",
                                                        "card_monitor_state",
                                                        "card_operational_state",
                                                        "card_reset_reason",
                                                        "power_administrative_state",
                                                        "power_current_measurement",
                                                        "power_operational_state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)


                                    class LastOperationalStateChange(Entity):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-operational-state-change" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                    class CardUpTime(Entity):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "card-up-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.card_administrative_state.is_set or
                                            self.card_monitor_state.is_set or
                                            self.card_operational_state.is_set or
                                            self.card_reset_reason.is_set or
                                            self.power_administrative_state.is_set or
                                            self.power_current_measurement.is_set or
                                            self.power_operational_state.is_set or
                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                            self.card_operational_state.yfilter != YFilter.not_set or
                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                            self.power_operational_state.yfilter != YFilter.not_set or
                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fru-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "card-up-time"):
                                            if (self.card_up_time is None):
                                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                            return self.card_up_time

                                        if (child_yang_name == "last-operational-state-change"):
                                            if (self.last_operational_state_change is None):
                                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                            return self.last_operational_state_change

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "card-administrative-state"):
                                            self.card_administrative_state = value
                                            self.card_administrative_state.value_namespace = name_space
                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-monitor-state"):
                                            self.card_monitor_state = value
                                            self.card_monitor_state.value_namespace = name_space
                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-operational-state"):
                                            self.card_operational_state = value
                                            self.card_operational_state.value_namespace = name_space
                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-reset-reason"):
                                            self.card_reset_reason = value
                                            self.card_reset_reason.value_namespace = name_space
                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-administrative-state"):
                                            self.power_administrative_state = value
                                            self.power_administrative_state.value_namespace = name_space
                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-current-measurement"):
                                            self.power_current_measurement = value
                                            self.power_current_measurement.value_namespace = name_space
                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-operational-state"):
                                            self.power_operational_state = value
                                            self.power_operational_state.value_namespace = name_space
                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                class InvBasicBag(Entity):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\:  bool
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\:  bool
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"

                                        self.alias = YLeaf(YType.str, "alias")

                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                        self.description = YLeaf(YType.str, "description")

                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                        self.model_name = YLeaf(YType.str, "model-name")

                                        self.name = YLeaf(YType.str, "name")

                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("alias",
                                                        "asset_id_str",
                                                        "asset_identification",
                                                        "ceport",
                                                        "chip_hardware_revision",
                                                        "composite_class_code",
                                                        "description",
                                                        "environmental_monitor_path",
                                                        "firmware_revision",
                                                        "group_flag",
                                                        "hardware_revision",
                                                        "is_field_replaceable_unit",
                                                        "manufacturer_asset_tags",
                                                        "manufacturer_name",
                                                        "memory_size",
                                                        "model_name",
                                                        "name",
                                                        "new_deviation_number",
                                                        "physical_layer_interface_module_type",
                                                        "redundancystate",
                                                        "serial_number",
                                                        "software_revision",
                                                        "unique_id",
                                                        "unrecognized_fru",
                                                        "vendor_type",
                                                        "xr_scoped") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.alias.is_set or
                                            self.asset_id_str.is_set or
                                            self.asset_identification.is_set or
                                            self.ceport.is_set or
                                            self.chip_hardware_revision.is_set or
                                            self.composite_class_code.is_set or
                                            self.description.is_set or
                                            self.environmental_monitor_path.is_set or
                                            self.firmware_revision.is_set or
                                            self.group_flag.is_set or
                                            self.hardware_revision.is_set or
                                            self.is_field_replaceable_unit.is_set or
                                            self.manufacturer_asset_tags.is_set or
                                            self.manufacturer_name.is_set or
                                            self.memory_size.is_set or
                                            self.model_name.is_set or
                                            self.name.is_set or
                                            self.new_deviation_number.is_set or
                                            self.physical_layer_interface_module_type.is_set or
                                            self.redundancystate.is_set or
                                            self.serial_number.is_set or
                                            self.software_revision.is_set or
                                            self.unique_id.is_set or
                                            self.unrecognized_fru.is_set or
                                            self.vendor_type.is_set or
                                            self.xr_scoped.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.alias.yfilter != YFilter.not_set or
                                            self.asset_id_str.yfilter != YFilter.not_set or
                                            self.asset_identification.yfilter != YFilter.not_set or
                                            self.ceport.yfilter != YFilter.not_set or
                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                            self.composite_class_code.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                            self.firmware_revision.yfilter != YFilter.not_set or
                                            self.group_flag.yfilter != YFilter.not_set or
                                            self.hardware_revision.yfilter != YFilter.not_set or
                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                            self.memory_size.yfilter != YFilter.not_set or
                                            self.model_name.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                            self.redundancystate.yfilter != YFilter.not_set or
                                            self.serial_number.yfilter != YFilter.not_set or
                                            self.software_revision.yfilter != YFilter.not_set or
                                            self.unique_id.yfilter != YFilter.not_set or
                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                            self.vendor_type.yfilter != YFilter.not_set or
                                            self.xr_scoped.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-basic-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())
                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "alias"):
                                            self.alias = value
                                            self.alias.value_namespace = name_space
                                            self.alias.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-id-str"):
                                            self.asset_id_str = value
                                            self.asset_id_str.value_namespace = name_space
                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-identification"):
                                            self.asset_identification = value
                                            self.asset_identification.value_namespace = name_space
                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ceport"):
                                            self.ceport = value
                                            self.ceport.value_namespace = name_space
                                            self.ceport.value_namespace_prefix = name_space_prefix
                                        if(value_path == "chip-hardware-revision"):
                                            self.chip_hardware_revision = value
                                            self.chip_hardware_revision.value_namespace = name_space
                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "composite-class-code"):
                                            self.composite_class_code = value
                                            self.composite_class_code.value_namespace = name_space
                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "environmental-monitor-path"):
                                            self.environmental_monitor_path = value
                                            self.environmental_monitor_path.value_namespace = name_space
                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "firmware-revision"):
                                            self.firmware_revision = value
                                            self.firmware_revision.value_namespace = name_space
                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "group-flag"):
                                            self.group_flag = value
                                            self.group_flag.value_namespace = name_space
                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hardware-revision"):
                                            self.hardware_revision = value
                                            self.hardware_revision.value_namespace = name_space
                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-field-replaceable-unit"):
                                            self.is_field_replaceable_unit = value
                                            self.is_field_replaceable_unit.value_namespace = name_space
                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-asset-tags"):
                                            self.manufacturer_asset_tags = value
                                            self.manufacturer_asset_tags.value_namespace = name_space
                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-name"):
                                            self.manufacturer_name = value
                                            self.manufacturer_name.value_namespace = name_space
                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "memory-size"):
                                            self.memory_size = value
                                            self.memory_size.value_namespace = name_space
                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "model-name"):
                                            self.model_name = value
                                            self.model_name.value_namespace = name_space
                                            self.model_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "new-deviation-number"):
                                            self.new_deviation_number = value
                                            self.new_deviation_number.value_namespace = name_space
                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "physical-layer-interface-module-type"):
                                            self.physical_layer_interface_module_type = value
                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "redundancystate"):
                                            self.redundancystate = value
                                            self.redundancystate.value_namespace = name_space
                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "serial-number"):
                                            self.serial_number = value
                                            self.serial_number.value_namespace = name_space
                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "software-revision"):
                                            self.software_revision = value
                                            self.software_revision.value_namespace = name_space
                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unique-id"):
                                            self.unique_id = value
                                            self.unique_id.value_namespace = name_space
                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unrecognized-fru"):
                                            self.unrecognized_fru = value
                                            self.unrecognized_fru.value_namespace = name_space
                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vendor-type"):
                                            self.vendor_type = value
                                            self.vendor_type.value_namespace = name_space
                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "xr-scoped"):
                                            self.xr_scoped = value
                                            self.xr_scoped.value_namespace = name_space
                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                class InvEepromInfo(Entity):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"

                                        self.description = YLeaf(YType.str, "description")

                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._children_yang_names.add("eeprom")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("description",
                                                        "has_eeprom",
                                                        "inv_card_type",
                                                        "opaque_data",
                                                        "opaque_data_size") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                    class Eeprom(Entity):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"

                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                            self.block_count = YLeaf(YType.str, "block-count")

                                            self.block_length = YLeaf(YType.str, "block-length")

                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                            self.block_version = YLeaf(YType.str, "block-version")

                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                            self.clei = YLeaf(YType.str, "clei")

                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                            self.description = YLeaf(YType.str, "description")

                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                            self.eci = YLeaf(YType.str, "eci")

                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                            self.hwid = YLeaf(YType.str, "hwid")

                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                            self.part_number = YLeaf(YType.str, "part-number")

                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                            self.pid = YLeaf(YType.str, "pid")

                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                            self.product_id = YLeaf(YType.str, "product-id")

                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                            self.vid = YLeaf(YType.str, "vid")

                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._children_yang_names.add("rma")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("asset_alias",
                                                            "asset_id",
                                                            "base_mac_address1",
                                                            "base_mac_address2",
                                                            "base_mac_address3",
                                                            "base_mac_address4",
                                                            "block_checksum",
                                                            "block_count",
                                                            "block_length",
                                                            "block_signature",
                                                            "block_version",
                                                            "chassis_sid",
                                                            "clei",
                                                            "controller_family",
                                                            "controller_type",
                                                            "description",
                                                            "dev_num1",
                                                            "dev_num2",
                                                            "dev_num3",
                                                            "dev_num4",
                                                            "dev_num5",
                                                            "dev_num6",
                                                            "dev_num7",
                                                            "eci",
                                                            "eeprom_size",
                                                            "engineer_use",
                                                            "fru_major_type",
                                                            "fru_minor_type",
                                                            "hw_version",
                                                            "hwid",
                                                            "idprom_format_rev",
                                                            "mac_add_blk_size1",
                                                            "mac_add_blk_size2",
                                                            "mac_add_blk_size3",
                                                            "mac_add_blk_size4",
                                                            "manu_test_data",
                                                            "mfg_bits",
                                                            "mfg_deviation",
                                                            "oem_string",
                                                            "part_number",
                                                            "part_revision",
                                                            "pca_num",
                                                            "pcavid",
                                                            "pcb_serial_num",
                                                            "pid",
                                                            "power_consumption",
                                                            "power_supply_type",
                                                            "product_id",
                                                            "rma_code",
                                                            "serial_number",
                                                            "snmpoid",
                                                            "top_assem_part_num",
                                                            "top_assem_vid",
                                                            "udi_description",
                                                            "udi_name",
                                                            "vid") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                        class Rma(Entity):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"

                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                self.test_history = YLeaf(YType.str, "test-history")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("rma_history",
                                                                "rma_number",
                                                                "test_history") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.rma_history.is_set or
                                                    self.rma_number.is_set or
                                                    self.test_history.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.rma_history.yfilter != YFilter.not_set or
                                                    self.rma_number.yfilter != YFilter.not_set or
                                                    self.test_history.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "rma" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "rma-history"):
                                                    self.rma_history = value
                                                    self.rma_history.value_namespace = name_space
                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rma-number"):
                                                    self.rma_number = value
                                                    self.rma_number.value_namespace = name_space
                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "test-history"):
                                                    self.test_history = value
                                                    self.test_history.value_namespace = name_space
                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.asset_alias.is_set or
                                                self.asset_id.is_set or
                                                self.base_mac_address1.is_set or
                                                self.base_mac_address2.is_set or
                                                self.base_mac_address3.is_set or
                                                self.base_mac_address4.is_set or
                                                self.block_checksum.is_set or
                                                self.block_count.is_set or
                                                self.block_length.is_set or
                                                self.block_signature.is_set or
                                                self.block_version.is_set or
                                                self.chassis_sid.is_set or
                                                self.clei.is_set or
                                                self.controller_family.is_set or
                                                self.controller_type.is_set or
                                                self.description.is_set or
                                                self.dev_num1.is_set or
                                                self.dev_num2.is_set or
                                                self.dev_num3.is_set or
                                                self.dev_num4.is_set or
                                                self.dev_num5.is_set or
                                                self.dev_num6.is_set or
                                                self.dev_num7.is_set or
                                                self.eci.is_set or
                                                self.eeprom_size.is_set or
                                                self.engineer_use.is_set or
                                                self.fru_major_type.is_set or
                                                self.fru_minor_type.is_set or
                                                self.hw_version.is_set or
                                                self.hwid.is_set or
                                                self.idprom_format_rev.is_set or
                                                self.mac_add_blk_size1.is_set or
                                                self.mac_add_blk_size2.is_set or
                                                self.mac_add_blk_size3.is_set or
                                                self.mac_add_blk_size4.is_set or
                                                self.manu_test_data.is_set or
                                                self.mfg_bits.is_set or
                                                self.mfg_deviation.is_set or
                                                self.oem_string.is_set or
                                                self.part_number.is_set or
                                                self.part_revision.is_set or
                                                self.pca_num.is_set or
                                                self.pcavid.is_set or
                                                self.pcb_serial_num.is_set or
                                                self.pid.is_set or
                                                self.power_consumption.is_set or
                                                self.power_supply_type.is_set or
                                                self.product_id.is_set or
                                                self.rma_code.is_set or
                                                self.serial_number.is_set or
                                                self.snmpoid.is_set or
                                                self.top_assem_part_num.is_set or
                                                self.top_assem_vid.is_set or
                                                self.udi_description.is_set or
                                                self.udi_name.is_set or
                                                self.vid.is_set or
                                                (self.rma is not None and self.rma.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.asset_alias.yfilter != YFilter.not_set or
                                                self.asset_id.yfilter != YFilter.not_set or
                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                self.block_checksum.yfilter != YFilter.not_set or
                                                self.block_count.yfilter != YFilter.not_set or
                                                self.block_length.yfilter != YFilter.not_set or
                                                self.block_signature.yfilter != YFilter.not_set or
                                                self.block_version.yfilter != YFilter.not_set or
                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                self.clei.yfilter != YFilter.not_set or
                                                self.controller_family.yfilter != YFilter.not_set or
                                                self.controller_type.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.dev_num1.yfilter != YFilter.not_set or
                                                self.dev_num2.yfilter != YFilter.not_set or
                                                self.dev_num3.yfilter != YFilter.not_set or
                                                self.dev_num4.yfilter != YFilter.not_set or
                                                self.dev_num5.yfilter != YFilter.not_set or
                                                self.dev_num6.yfilter != YFilter.not_set or
                                                self.dev_num7.yfilter != YFilter.not_set or
                                                self.eci.yfilter != YFilter.not_set or
                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                self.engineer_use.yfilter != YFilter.not_set or
                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                self.hw_version.yfilter != YFilter.not_set or
                                                self.hwid.yfilter != YFilter.not_set or
                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                self.oem_string.yfilter != YFilter.not_set or
                                                self.part_number.yfilter != YFilter.not_set or
                                                self.part_revision.yfilter != YFilter.not_set or
                                                self.pca_num.yfilter != YFilter.not_set or
                                                self.pcavid.yfilter != YFilter.not_set or
                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                self.pid.yfilter != YFilter.not_set or
                                                self.power_consumption.yfilter != YFilter.not_set or
                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                self.product_id.yfilter != YFilter.not_set or
                                                self.rma_code.yfilter != YFilter.not_set or
                                                self.serial_number.yfilter != YFilter.not_set or
                                                self.snmpoid.yfilter != YFilter.not_set or
                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                self.udi_description.yfilter != YFilter.not_set or
                                                self.udi_name.yfilter != YFilter.not_set or
                                                self.vid.yfilter != YFilter.not_set or
                                                (self.rma is not None and self.rma.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "eeprom" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "rma"):
                                                if (self.rma is None):
                                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                return self.rma

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "asset-alias"):
                                                self.asset_alias = value
                                                self.asset_alias.value_namespace = name_space
                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                            if(value_path == "asset-id"):
                                                self.asset_id = value
                                                self.asset_id.value_namespace = name_space
                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address1"):
                                                self.base_mac_address1 = value
                                                self.base_mac_address1.value_namespace = name_space
                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address2"):
                                                self.base_mac_address2 = value
                                                self.base_mac_address2.value_namespace = name_space
                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address3"):
                                                self.base_mac_address3 = value
                                                self.base_mac_address3.value_namespace = name_space
                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address4"):
                                                self.base_mac_address4 = value
                                                self.base_mac_address4.value_namespace = name_space
                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-checksum"):
                                                self.block_checksum = value
                                                self.block_checksum.value_namespace = name_space
                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-count"):
                                                self.block_count = value
                                                self.block_count.value_namespace = name_space
                                                self.block_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-length"):
                                                self.block_length = value
                                                self.block_length.value_namespace = name_space
                                                self.block_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-signature"):
                                                self.block_signature = value
                                                self.block_signature.value_namespace = name_space
                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-version"):
                                                self.block_version = value
                                                self.block_version.value_namespace = name_space
                                                self.block_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "chassis-sid"):
                                                self.chassis_sid = value
                                                self.chassis_sid.value_namespace = name_space
                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "clei"):
                                                self.clei = value
                                                self.clei.value_namespace = name_space
                                                self.clei.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-family"):
                                                self.controller_family = value
                                                self.controller_family.value_namespace = name_space
                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-type"):
                                                self.controller_type = value
                                                self.controller_type.value_namespace = name_space
                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num1"):
                                                self.dev_num1 = value
                                                self.dev_num1.value_namespace = name_space
                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num2"):
                                                self.dev_num2 = value
                                                self.dev_num2.value_namespace = name_space
                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num3"):
                                                self.dev_num3 = value
                                                self.dev_num3.value_namespace = name_space
                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num4"):
                                                self.dev_num4 = value
                                                self.dev_num4.value_namespace = name_space
                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num5"):
                                                self.dev_num5 = value
                                                self.dev_num5.value_namespace = name_space
                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num6"):
                                                self.dev_num6 = value
                                                self.dev_num6.value_namespace = name_space
                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num7"):
                                                self.dev_num7 = value
                                                self.dev_num7.value_namespace = name_space
                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eci"):
                                                self.eci = value
                                                self.eci.value_namespace = name_space
                                                self.eci.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eeprom-size"):
                                                self.eeprom_size = value
                                                self.eeprom_size.value_namespace = name_space
                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                            if(value_path == "engineer-use"):
                                                self.engineer_use = value
                                                self.engineer_use.value_namespace = name_space
                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-major-type"):
                                                self.fru_major_type = value
                                                self.fru_major_type.value_namespace = name_space
                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-minor-type"):
                                                self.fru_minor_type = value
                                                self.fru_minor_type.value_namespace = name_space
                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hw-version"):
                                                self.hw_version = value
                                                self.hw_version.value_namespace = name_space
                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hwid"):
                                                self.hwid = value
                                                self.hwid.value_namespace = name_space
                                                self.hwid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "idprom-format-rev"):
                                                self.idprom_format_rev = value
                                                self.idprom_format_rev.value_namespace = name_space
                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size1"):
                                                self.mac_add_blk_size1 = value
                                                self.mac_add_blk_size1.value_namespace = name_space
                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size2"):
                                                self.mac_add_blk_size2 = value
                                                self.mac_add_blk_size2.value_namespace = name_space
                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size3"):
                                                self.mac_add_blk_size3 = value
                                                self.mac_add_blk_size3.value_namespace = name_space
                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size4"):
                                                self.mac_add_blk_size4 = value
                                                self.mac_add_blk_size4.value_namespace = name_space
                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "manu-test-data"):
                                                self.manu_test_data = value
                                                self.manu_test_data.value_namespace = name_space
                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-bits"):
                                                self.mfg_bits = value
                                                self.mfg_bits.value_namespace = name_space
                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-deviation"):
                                                self.mfg_deviation = value
                                                self.mfg_deviation.value_namespace = name_space
                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "oem-string"):
                                                self.oem_string = value
                                                self.oem_string.value_namespace = name_space
                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-number"):
                                                self.part_number = value
                                                self.part_number.value_namespace = name_space
                                                self.part_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-revision"):
                                                self.part_revision = value
                                                self.part_revision.value_namespace = name_space
                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pca-num"):
                                                self.pca_num = value
                                                self.pca_num.value_namespace = name_space
                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcavid"):
                                                self.pcavid = value
                                                self.pcavid.value_namespace = name_space
                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcb-serial-num"):
                                                self.pcb_serial_num = value
                                                self.pcb_serial_num.value_namespace = name_space
                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pid"):
                                                self.pid = value
                                                self.pid.value_namespace = name_space
                                                self.pid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-consumption"):
                                                self.power_consumption = value
                                                self.power_consumption.value_namespace = name_space
                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-supply-type"):
                                                self.power_supply_type = value
                                                self.power_supply_type.value_namespace = name_space
                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "product-id"):
                                                self.product_id = value
                                                self.product_id.value_namespace = name_space
                                                self.product_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rma-code"):
                                                self.rma_code = value
                                                self.rma_code.value_namespace = name_space
                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                            if(value_path == "serial-number"):
                                                self.serial_number = value
                                                self.serial_number.value_namespace = name_space
                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snmpoid"):
                                                self.snmpoid = value
                                                self.snmpoid.value_namespace = name_space
                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-part-num"):
                                                self.top_assem_part_num = value
                                                self.top_assem_part_num.value_namespace = name_space
                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-vid"):
                                                self.top_assem_vid = value
                                                self.top_assem_vid.value_namespace = name_space
                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-description"):
                                                self.udi_description = value
                                                self.udi_description.value_namespace = name_space
                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-name"):
                                                self.udi_name = value
                                                self.udi_name.value_namespace = name_space
                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vid"):
                                                self.vid = value
                                                self.vid.value_namespace = name_space
                                                self.vid.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.description.is_set or
                                            self.has_eeprom.is_set or
                                            self.inv_card_type.is_set or
                                            self.opaque_data.is_set or
                                            self.opaque_data_size.is_set or
                                            (self.eeprom is not None and self.eeprom.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.has_eeprom.yfilter != YFilter.not_set or
                                            self.inv_card_type.yfilter != YFilter.not_set or
                                            self.opaque_data.yfilter != YFilter.not_set or
                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-eeprom-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "eeprom"):
                                            if (self.eeprom is None):
                                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                            return self.eeprom

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "has-eeprom"):
                                            self.has_eeprom = value
                                            self.has_eeprom.value_namespace = name_space
                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inv-card-type"):
                                            self.inv_card_type = value
                                            self.inv_card_type.value_namespace = name_space
                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data"):
                                            self.opaque_data = value
                                            self.opaque_data.value_namespace = name_space
                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data-size"):
                                            self.opaque_data_size = value
                                            self.opaque_data_size.value_namespace = name_space
                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.module_done.is_set or
                                        self.node_id.is_set or
                                        self.vm_done.is_set or
                                        self.vm_node_id.is_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                        (self.threshold is not None and self.threshold.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.module_done.yfilter != YFilter.not_set or
                                        self.node_id.yfilter != YFilter.not_set or
                                        self.vm_done.yfilter != YFilter.not_set or
                                        self.vm_node_id.yfilter != YFilter.not_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                        (self.threshold is not None and self.threshold.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attributes" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "env-sensor-info"):
                                        if (self.env_sensor_info is None):
                                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                        return self.env_sensor_info

                                    if (child_yang_name == "env-sensor-info-xml"):
                                        if (self.env_sensor_info_xml is None):
                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                        return self.env_sensor_info_xml

                                    if (child_yang_name == "fru-info"):
                                        if (self.fru_info is None):
                                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                        return self.fru_info

                                    if (child_yang_name == "inv-asset-bag"):
                                        if (self.inv_asset_bag is None):
                                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                        return self.inv_asset_bag

                                    if (child_yang_name == "inv-basic-bag"):
                                        if (self.inv_basic_bag is None):
                                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                        return self.inv_basic_bag

                                    if (child_yang_name == "inv-eeprom-info"):
                                        if (self.inv_eeprom_info is None):
                                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                        return self.inv_eeprom_info

                                    if (child_yang_name == "pwg-info"):
                                        if (self.pwg_info is None):
                                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                        return self.pwg_info

                                    if (child_yang_name == "threshold"):
                                        if (self.threshold is None):
                                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                        return self.threshold

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "module-done"):
                                        self.module_done = value
                                        self.module_done.value_namespace = name_space
                                        self.module_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-id"):
                                        self.node_id = value
                                        self.node_id.value_namespace = name_space
                                        self.node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-done"):
                                        self.vm_done = value
                                        self.vm_done.value_namespace = name_space
                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-node-id"):
                                        self.vm_node_id = value
                                        self.vm_node_id.value_namespace = name_space
                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.name.is_set or
                                    (self.attributes is not None and self.attributes.has_data()) or
                                    (self.tsi2s is not None and self.tsi2s.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    (self.attributes is not None and self.attributes.has_operation()) or
                                    (self.tsi2s is not None and self.tsi2s.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tsi1" + "[name='" + self.name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attributes"):
                                    if (self.attributes is None):
                                        self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                    return self.attributes

                                if (child_yang_name == "tsi2s"):
                                    if (self.tsi2s is None):
                                        self.tsi2s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1.Tsi2S()
                                        self.tsi2s.parent = self
                                        self._children_name_map["tsi2s"] = "tsi2s"
                                    return self.tsi2s

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attributes" or name == "tsi2s" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.tsi1:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.tsi1:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tsi1s" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "tsi1"):
                                for c in self.tsi1:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S.Tsi1()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.tsi1.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tsi1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Attributes(Entity):
                        """
                        Attributes
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo>`
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml>`
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo>`
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag>`
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag>`
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo>`
                        
                        .. attribute:: module_done
                        
                        	Inventory EDM Module Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**default value**\: 1
                        
                        .. attribute:: node_id
                        
                        	Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo>`
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold>`
                        
                        .. attribute:: vm_done
                        
                        	VM Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: vm_node_id
                        
                        	VM Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"

                            self.module_done = YLeaf(YType.int32, "module-done")

                            self.node_id = YLeaf(YType.uint32, "node-id")

                            self.vm_done = YLeaf(YType.int32, "vm-done")

                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                            self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                            self._children_yang_names.add("env-sensor-info")

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                            self._children_yang_names.add("env-sensor-info-xml")

                            self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"
                            self._children_yang_names.add("fru-info")

                            self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                            self._children_yang_names.add("inv-asset-bag")

                            self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                            self._children_yang_names.add("inv-basic-bag")

                            self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._children_yang_names.add("inv-eeprom-info")

                            self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"
                            self._children_yang_names.add("pwg-info")

                            self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"
                            self._children_yang_names.add("threshold")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("module_done",
                                            "node_id",
                                            "vm_done",
                                            "vm_node_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes, self).__setattr__(name, value)


                        class EnvSensorInfo(Entity):
                            """
                            Environment sensor info
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"

                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                self.data_type = YLeaf(YType.uint32, "data-type")

                                self.device_description = YLeaf(YType.str, "device-description")

                                self.device_id = YLeaf(YType.uint32, "device-id")

                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                self.precision = YLeaf(YType.uint32, "precision")

                                self.scale = YLeaf(YType.uint32, "scale")

                                self.status = YLeaf(YType.uint32, "status")

                                self.units = YLeaf(YType.str, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.uint32, "value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("age_time_stamp",
                                                "alarm_type",
                                                "data_type",
                                                "device_description",
                                                "device_id",
                                                "field_validity_bitmap",
                                                "precision",
                                                "scale",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.age_time_stamp.is_set or
                                    self.alarm_type.is_set or
                                    self.data_type.is_set or
                                    self.device_description.is_set or
                                    self.device_id.is_set or
                                    self.field_validity_bitmap.is_set or
                                    self.precision.is_set or
                                    self.scale.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                    self.alarm_type.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.device_description.yfilter != YFilter.not_set or
                                    self.device_id.yfilter != YFilter.not_set or
                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                    self.precision.yfilter != YFilter.not_set or
                                    self.scale.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "age-time-stamp"):
                                    self.age_time_stamp = value
                                    self.age_time_stamp.value_namespace = name_space
                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "alarm-type"):
                                    self.alarm_type = value
                                    self.alarm_type.value_namespace = name_space
                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-description"):
                                    self.device_description = value
                                    self.device_description.value_namespace = name_space
                                    self.device_description.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-id"):
                                    self.device_id = value
                                    self.device_id.value_namespace = name_space
                                    self.device_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "field-validity-bitmap"):
                                    self.field_validity_bitmap = value
                                    self.field_validity_bitmap.value_namespace = name_space
                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                if(value_path == "precision"):
                                    self.precision = value
                                    self.precision.value_namespace = name_space
                                    self.precision.value_namespace_prefix = name_space_prefix
                                if(value_path == "scale"):
                                    self.scale = value
                                    self.scale.value_namespace = name_space
                                    self.scale.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class PwgInfo(Entity):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\:  str
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"

                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("power_group_available_current",
                                                "power_group_drawn_current",
                                                "power_group_power_units",
                                                "power_group_redundancy_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.power_group_available_current.is_set or
                                    self.power_group_drawn_current.is_set or
                                    self.power_group_power_units.is_set or
                                    self.power_group_redundancy_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pwg-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "power-group-available-current"):
                                    self.power_group_available_current = value
                                    self.power_group_available_current.value_namespace = name_space
                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-drawn-current"):
                                    self.power_group_drawn_current = value
                                    self.power_group_drawn_current.value_namespace = name_space
                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-power-units"):
                                    self.power_group_power_units = value
                                    self.power_group_power_units.value_namespace = name_space
                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-redundancy-mode"):
                                    self.power_group_redundancy_mode = value
                                    self.power_group_redundancy_mode.value_namespace = name_space
                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                        class EnvSensorInfoXml(Entity):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"

                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                self.description = YLeaf(YType.str, "description")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.units = YLeaf(YType.enumeration, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.str, "value")

                                self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._children_yang_names.add("threshold")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("data_type",
                                                "description",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                            class Threshold(Entity):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"

                                    self.threshold_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                class ThresholdArray(Entity):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"

                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_name",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_name.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_name.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-name"):
                                            self.threshold_name = value
                                            self.threshold_name.value_namespace = name_space
                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.threshold_array:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.threshold_array:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "threshold" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "threshold-array"):
                                        for c in self.threshold_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.threshold_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "threshold-array"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.data_type.is_set or
                                    self.description.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set or
                                    (self.threshold is not None and self.threshold.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set or
                                    (self.threshold is not None and self.threshold.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info-xml" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "threshold"):
                                    if (self.threshold is None):
                                        self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                    return self.threshold

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class InvAssetBag(Entity):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"

                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                self.part_number = YLeaf(YType.str, "part-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("manufacturer_assembly_number",
                                                "manufacturer_assembly_revision",
                                                "manufacturer_common_language_equipment_identifier",
                                                "manufacturer_firmware_identifier",
                                                "manufacturer_software_identifier",
                                                "original_equipment_manufacturer_string",
                                                "part_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.manufacturer_assembly_number.is_set or
                                    self.manufacturer_assembly_revision.is_set or
                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                    self.manufacturer_firmware_identifier.is_set or
                                    self.manufacturer_software_identifier.is_set or
                                    self.original_equipment_manufacturer_string.is_set or
                                    self.part_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                    self.part_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-asset-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "manufacturer-assembly-number"):
                                    self.manufacturer_assembly_number = value
                                    self.manufacturer_assembly_number.value_namespace = name_space
                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-assembly-revision"):
                                    self.manufacturer_assembly_revision = value
                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                    self.manufacturer_common_language_equipment_identifier = value
                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-firmware-identifier"):
                                    self.manufacturer_firmware_identifier = value
                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-software-identifier"):
                                    self.manufacturer_software_identifier = value
                                    self.manufacturer_software_identifier.value_namespace = name_space
                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-equipment-manufacturer-string"):
                                    self.original_equipment_manufacturer_string = value
                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                if(value_path == "part-number"):
                                    self.part_number = value
                                    self.part_number.value_namespace = name_space
                                    self.part_number.value_namespace_prefix = name_space_prefix


                        class Threshold(Entity):
                            """
                            Threshold
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi>`
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo>`
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi>`
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo>`
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi>`
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"

                                self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"
                                self._children_yang_names.add("critical-hi")

                                self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"
                                self._children_yang_names.add("critical-lo")

                                self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"
                                self._children_yang_names.add("major-hi")

                                self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"
                                self._children_yang_names.add("major-lo")

                                self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"
                                self._children_yang_names.add("minor-hi")

                                self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._children_yang_names.add("minor-lo")


                            class MajorLo(Entity):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalHi(Entity):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorHi(Entity):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MajorHi(Entity):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalLo(Entity):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorLo(Entity):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "threshold" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "critical-hi"):
                                    if (self.critical_hi is None):
                                        self.critical_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                    return self.critical_hi

                                if (child_yang_name == "critical-lo"):
                                    if (self.critical_lo is None):
                                        self.critical_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                    return self.critical_lo

                                if (child_yang_name == "major-hi"):
                                    if (self.major_hi is None):
                                        self.major_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                    return self.major_hi

                                if (child_yang_name == "major-lo"):
                                    if (self.major_lo is None):
                                        self.major_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                    return self.major_lo

                                if (child_yang_name == "minor-hi"):
                                    if (self.minor_hi is None):
                                        self.minor_hi = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                    return self.minor_hi

                                if (child_yang_name == "minor-lo"):
                                    if (self.minor_lo is None):
                                        self.minor_lo = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                    return self.minor_lo

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class FruInfo(Entity):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"

                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._children_yang_names.add("card-up-time")

                                self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                self._children_yang_names.add("last-operational-state-change")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("card_administrative_state",
                                                "card_monitor_state",
                                                "card_operational_state",
                                                "card_reset_reason",
                                                "power_administrative_state",
                                                "power_current_measurement",
                                                "power_operational_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo, self).__setattr__(name, value)


                            class LastOperationalStateChange(Entity):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "last-operational-state-change" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                            class CardUpTime(Entity):
                                """
                                card up time
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "card-up-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.card_administrative_state.is_set or
                                    self.card_monitor_state.is_set or
                                    self.card_operational_state.is_set or
                                    self.card_reset_reason.is_set or
                                    self.power_administrative_state.is_set or
                                    self.power_current_measurement.is_set or
                                    self.power_operational_state.is_set or
                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                    self.card_operational_state.yfilter != YFilter.not_set or
                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                    self.power_operational_state.yfilter != YFilter.not_set or
                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fru-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "card-up-time"):
                                    if (self.card_up_time is None):
                                        self.card_up_time = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                    return self.card_up_time

                                if (child_yang_name == "last-operational-state-change"):
                                    if (self.last_operational_state_change is None):
                                        self.last_operational_state_change = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                    return self.last_operational_state_change

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "card-administrative-state"):
                                    self.card_administrative_state = value
                                    self.card_administrative_state.value_namespace = name_space
                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-monitor-state"):
                                    self.card_monitor_state = value
                                    self.card_monitor_state.value_namespace = name_space
                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-operational-state"):
                                    self.card_operational_state = value
                                    self.card_operational_state.value_namespace = name_space
                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-reset-reason"):
                                    self.card_reset_reason = value
                                    self.card_reset_reason.value_namespace = name_space
                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-administrative-state"):
                                    self.power_administrative_state = value
                                    self.power_administrative_state.value_namespace = name_space
                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-current-measurement"):
                                    self.power_current_measurement = value
                                    self.power_current_measurement.value_namespace = name_space
                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-operational-state"):
                                    self.power_operational_state = value
                                    self.power_operational_state.value_namespace = name_space
                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                        class InvBasicBag(Entity):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\:  bool
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\:  bool
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\:  bool
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\:  bool
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"

                                self.alias = YLeaf(YType.str, "alias")

                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                self.ceport = YLeaf(YType.boolean, "ceport")

                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                self.description = YLeaf(YType.str, "description")

                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                self.model_name = YLeaf(YType.str, "model-name")

                                self.name = YLeaf(YType.str, "name")

                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                self.serial_number = YLeaf(YType.str, "serial-number")

                                self.software_revision = YLeaf(YType.str, "software-revision")

                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("alias",
                                                "asset_id_str",
                                                "asset_identification",
                                                "ceport",
                                                "chip_hardware_revision",
                                                "composite_class_code",
                                                "description",
                                                "environmental_monitor_path",
                                                "firmware_revision",
                                                "group_flag",
                                                "hardware_revision",
                                                "is_field_replaceable_unit",
                                                "manufacturer_asset_tags",
                                                "manufacturer_name",
                                                "memory_size",
                                                "model_name",
                                                "name",
                                                "new_deviation_number",
                                                "physical_layer_interface_module_type",
                                                "redundancystate",
                                                "serial_number",
                                                "software_revision",
                                                "unique_id",
                                                "unrecognized_fru",
                                                "vendor_type",
                                                "xr_scoped") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.alias.is_set or
                                    self.asset_id_str.is_set or
                                    self.asset_identification.is_set or
                                    self.ceport.is_set or
                                    self.chip_hardware_revision.is_set or
                                    self.composite_class_code.is_set or
                                    self.description.is_set or
                                    self.environmental_monitor_path.is_set or
                                    self.firmware_revision.is_set or
                                    self.group_flag.is_set or
                                    self.hardware_revision.is_set or
                                    self.is_field_replaceable_unit.is_set or
                                    self.manufacturer_asset_tags.is_set or
                                    self.manufacturer_name.is_set or
                                    self.memory_size.is_set or
                                    self.model_name.is_set or
                                    self.name.is_set or
                                    self.new_deviation_number.is_set or
                                    self.physical_layer_interface_module_type.is_set or
                                    self.redundancystate.is_set or
                                    self.serial_number.is_set or
                                    self.software_revision.is_set or
                                    self.unique_id.is_set or
                                    self.unrecognized_fru.is_set or
                                    self.vendor_type.is_set or
                                    self.xr_scoped.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.alias.yfilter != YFilter.not_set or
                                    self.asset_id_str.yfilter != YFilter.not_set or
                                    self.asset_identification.yfilter != YFilter.not_set or
                                    self.ceport.yfilter != YFilter.not_set or
                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                    self.composite_class_code.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                    self.firmware_revision.yfilter != YFilter.not_set or
                                    self.group_flag.yfilter != YFilter.not_set or
                                    self.hardware_revision.yfilter != YFilter.not_set or
                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                    self.memory_size.yfilter != YFilter.not_set or
                                    self.model_name.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                    self.redundancystate.yfilter != YFilter.not_set or
                                    self.serial_number.yfilter != YFilter.not_set or
                                    self.software_revision.yfilter != YFilter.not_set or
                                    self.unique_id.yfilter != YFilter.not_set or
                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                    self.vendor_type.yfilter != YFilter.not_set or
                                    self.xr_scoped.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-basic-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())
                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "alias"):
                                    self.alias = value
                                    self.alias.value_namespace = name_space
                                    self.alias.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-id-str"):
                                    self.asset_id_str = value
                                    self.asset_id_str.value_namespace = name_space
                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-identification"):
                                    self.asset_identification = value
                                    self.asset_identification.value_namespace = name_space
                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                if(value_path == "ceport"):
                                    self.ceport = value
                                    self.ceport.value_namespace = name_space
                                    self.ceport.value_namespace_prefix = name_space_prefix
                                if(value_path == "chip-hardware-revision"):
                                    self.chip_hardware_revision = value
                                    self.chip_hardware_revision.value_namespace = name_space
                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "composite-class-code"):
                                    self.composite_class_code = value
                                    self.composite_class_code.value_namespace = name_space
                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "environmental-monitor-path"):
                                    self.environmental_monitor_path = value
                                    self.environmental_monitor_path.value_namespace = name_space
                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "firmware-revision"):
                                    self.firmware_revision = value
                                    self.firmware_revision.value_namespace = name_space
                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "group-flag"):
                                    self.group_flag = value
                                    self.group_flag.value_namespace = name_space
                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                if(value_path == "hardware-revision"):
                                    self.hardware_revision = value
                                    self.hardware_revision.value_namespace = name_space
                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-field-replaceable-unit"):
                                    self.is_field_replaceable_unit = value
                                    self.is_field_replaceable_unit.value_namespace = name_space
                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-asset-tags"):
                                    self.manufacturer_asset_tags = value
                                    self.manufacturer_asset_tags.value_namespace = name_space
                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-name"):
                                    self.manufacturer_name = value
                                    self.manufacturer_name.value_namespace = name_space
                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "memory-size"):
                                    self.memory_size = value
                                    self.memory_size.value_namespace = name_space
                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                if(value_path == "model-name"):
                                    self.model_name = value
                                    self.model_name.value_namespace = name_space
                                    self.model_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix
                                if(value_path == "new-deviation-number"):
                                    self.new_deviation_number = value
                                    self.new_deviation_number.value_namespace = name_space
                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "physical-layer-interface-module-type"):
                                    self.physical_layer_interface_module_type = value
                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "redundancystate"):
                                    self.redundancystate = value
                                    self.redundancystate.value_namespace = name_space
                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                if(value_path == "serial-number"):
                                    self.serial_number = value
                                    self.serial_number.value_namespace = name_space
                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "software-revision"):
                                    self.software_revision = value
                                    self.software_revision.value_namespace = name_space
                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "unique-id"):
                                    self.unique_id = value
                                    self.unique_id.value_namespace = name_space
                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "unrecognized-fru"):
                                    self.unrecognized_fru = value
                                    self.unrecognized_fru.value_namespace = name_space
                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                if(value_path == "vendor-type"):
                                    self.vendor_type = value
                                    self.vendor_type.value_namespace = name_space
                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "xr-scoped"):
                                    self.xr_scoped = value
                                    self.xr_scoped.value_namespace = name_space
                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                        class InvEepromInfo(Entity):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"

                                self.description = YLeaf(YType.str, "description")

                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._children_yang_names.add("eeprom")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("description",
                                                "has_eeprom",
                                                "inv_card_type",
                                                "opaque_data",
                                                "opaque_data_size") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)


                            class Eeprom(Entity):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"

                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                    self.block_count = YLeaf(YType.str, "block-count")

                                    self.block_length = YLeaf(YType.str, "block-length")

                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                    self.block_version = YLeaf(YType.str, "block-version")

                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                    self.clei = YLeaf(YType.str, "clei")

                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                    self.description = YLeaf(YType.str, "description")

                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                    self.eci = YLeaf(YType.str, "eci")

                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                    self.hwid = YLeaf(YType.str, "hwid")

                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                    self.part_number = YLeaf(YType.str, "part-number")

                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                    self.pid = YLeaf(YType.str, "pid")

                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                    self.product_id = YLeaf(YType.str, "product-id")

                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                    self.vid = YLeaf(YType.str, "vid")

                                    self.rma = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._children_yang_names.add("rma")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("asset_alias",
                                                    "asset_id",
                                                    "base_mac_address1",
                                                    "base_mac_address2",
                                                    "base_mac_address3",
                                                    "base_mac_address4",
                                                    "block_checksum",
                                                    "block_count",
                                                    "block_length",
                                                    "block_signature",
                                                    "block_version",
                                                    "chassis_sid",
                                                    "clei",
                                                    "controller_family",
                                                    "controller_type",
                                                    "description",
                                                    "dev_num1",
                                                    "dev_num2",
                                                    "dev_num3",
                                                    "dev_num4",
                                                    "dev_num5",
                                                    "dev_num6",
                                                    "dev_num7",
                                                    "eci",
                                                    "eeprom_size",
                                                    "engineer_use",
                                                    "fru_major_type",
                                                    "fru_minor_type",
                                                    "hw_version",
                                                    "hwid",
                                                    "idprom_format_rev",
                                                    "mac_add_blk_size1",
                                                    "mac_add_blk_size2",
                                                    "mac_add_blk_size3",
                                                    "mac_add_blk_size4",
                                                    "manu_test_data",
                                                    "mfg_bits",
                                                    "mfg_deviation",
                                                    "oem_string",
                                                    "part_number",
                                                    "part_revision",
                                                    "pca_num",
                                                    "pcavid",
                                                    "pcb_serial_num",
                                                    "pid",
                                                    "power_consumption",
                                                    "power_supply_type",
                                                    "product_id",
                                                    "rma_code",
                                                    "serial_number",
                                                    "snmpoid",
                                                    "top_assem_part_num",
                                                    "top_assem_vid",
                                                    "udi_description",
                                                    "udi_name",
                                                    "vid") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                class Rma(Entity):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"

                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                        self.test_history = YLeaf(YType.str, "test-history")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rma_history",
                                                        "rma_number",
                                                        "test_history") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.rma_history.is_set or
                                            self.rma_number.is_set or
                                            self.test_history.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rma_history.yfilter != YFilter.not_set or
                                            self.rma_number.yfilter != YFilter.not_set or
                                            self.test_history.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rma" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rma-history"):
                                            self.rma_history = value
                                            self.rma_history.value_namespace = name_space
                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rma-number"):
                                            self.rma_number = value
                                            self.rma_number.value_namespace = name_space
                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "test-history"):
                                            self.test_history = value
                                            self.test_history.value_namespace = name_space
                                            self.test_history.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.asset_alias.is_set or
                                        self.asset_id.is_set or
                                        self.base_mac_address1.is_set or
                                        self.base_mac_address2.is_set or
                                        self.base_mac_address3.is_set or
                                        self.base_mac_address4.is_set or
                                        self.block_checksum.is_set or
                                        self.block_count.is_set or
                                        self.block_length.is_set or
                                        self.block_signature.is_set or
                                        self.block_version.is_set or
                                        self.chassis_sid.is_set or
                                        self.clei.is_set or
                                        self.controller_family.is_set or
                                        self.controller_type.is_set or
                                        self.description.is_set or
                                        self.dev_num1.is_set or
                                        self.dev_num2.is_set or
                                        self.dev_num3.is_set or
                                        self.dev_num4.is_set or
                                        self.dev_num5.is_set or
                                        self.dev_num6.is_set or
                                        self.dev_num7.is_set or
                                        self.eci.is_set or
                                        self.eeprom_size.is_set or
                                        self.engineer_use.is_set or
                                        self.fru_major_type.is_set or
                                        self.fru_minor_type.is_set or
                                        self.hw_version.is_set or
                                        self.hwid.is_set or
                                        self.idprom_format_rev.is_set or
                                        self.mac_add_blk_size1.is_set or
                                        self.mac_add_blk_size2.is_set or
                                        self.mac_add_blk_size3.is_set or
                                        self.mac_add_blk_size4.is_set or
                                        self.manu_test_data.is_set or
                                        self.mfg_bits.is_set or
                                        self.mfg_deviation.is_set or
                                        self.oem_string.is_set or
                                        self.part_number.is_set or
                                        self.part_revision.is_set or
                                        self.pca_num.is_set or
                                        self.pcavid.is_set or
                                        self.pcb_serial_num.is_set or
                                        self.pid.is_set or
                                        self.power_consumption.is_set or
                                        self.power_supply_type.is_set or
                                        self.product_id.is_set or
                                        self.rma_code.is_set or
                                        self.serial_number.is_set or
                                        self.snmpoid.is_set or
                                        self.top_assem_part_num.is_set or
                                        self.top_assem_vid.is_set or
                                        self.udi_description.is_set or
                                        self.udi_name.is_set or
                                        self.vid.is_set or
                                        (self.rma is not None and self.rma.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.asset_alias.yfilter != YFilter.not_set or
                                        self.asset_id.yfilter != YFilter.not_set or
                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                        self.block_checksum.yfilter != YFilter.not_set or
                                        self.block_count.yfilter != YFilter.not_set or
                                        self.block_length.yfilter != YFilter.not_set or
                                        self.block_signature.yfilter != YFilter.not_set or
                                        self.block_version.yfilter != YFilter.not_set or
                                        self.chassis_sid.yfilter != YFilter.not_set or
                                        self.clei.yfilter != YFilter.not_set or
                                        self.controller_family.yfilter != YFilter.not_set or
                                        self.controller_type.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.dev_num1.yfilter != YFilter.not_set or
                                        self.dev_num2.yfilter != YFilter.not_set or
                                        self.dev_num3.yfilter != YFilter.not_set or
                                        self.dev_num4.yfilter != YFilter.not_set or
                                        self.dev_num5.yfilter != YFilter.not_set or
                                        self.dev_num6.yfilter != YFilter.not_set or
                                        self.dev_num7.yfilter != YFilter.not_set or
                                        self.eci.yfilter != YFilter.not_set or
                                        self.eeprom_size.yfilter != YFilter.not_set or
                                        self.engineer_use.yfilter != YFilter.not_set or
                                        self.fru_major_type.yfilter != YFilter.not_set or
                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                        self.hw_version.yfilter != YFilter.not_set or
                                        self.hwid.yfilter != YFilter.not_set or
                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                        self.manu_test_data.yfilter != YFilter.not_set or
                                        self.mfg_bits.yfilter != YFilter.not_set or
                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                        self.oem_string.yfilter != YFilter.not_set or
                                        self.part_number.yfilter != YFilter.not_set or
                                        self.part_revision.yfilter != YFilter.not_set or
                                        self.pca_num.yfilter != YFilter.not_set or
                                        self.pcavid.yfilter != YFilter.not_set or
                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                        self.pid.yfilter != YFilter.not_set or
                                        self.power_consumption.yfilter != YFilter.not_set or
                                        self.power_supply_type.yfilter != YFilter.not_set or
                                        self.product_id.yfilter != YFilter.not_set or
                                        self.rma_code.yfilter != YFilter.not_set or
                                        self.serial_number.yfilter != YFilter.not_set or
                                        self.snmpoid.yfilter != YFilter.not_set or
                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                        self.udi_description.yfilter != YFilter.not_set or
                                        self.udi_name.yfilter != YFilter.not_set or
                                        self.vid.yfilter != YFilter.not_set or
                                        (self.rma is not None and self.rma.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "eeprom" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rma"):
                                        if (self.rma is None):
                                            self.rma = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                        return self.rma

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "asset-alias"):
                                        self.asset_alias = value
                                        self.asset_alias.value_namespace = name_space
                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                    if(value_path == "asset-id"):
                                        self.asset_id = value
                                        self.asset_id.value_namespace = name_space
                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address1"):
                                        self.base_mac_address1 = value
                                        self.base_mac_address1.value_namespace = name_space
                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address2"):
                                        self.base_mac_address2 = value
                                        self.base_mac_address2.value_namespace = name_space
                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address3"):
                                        self.base_mac_address3 = value
                                        self.base_mac_address3.value_namespace = name_space
                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address4"):
                                        self.base_mac_address4 = value
                                        self.base_mac_address4.value_namespace = name_space
                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-checksum"):
                                        self.block_checksum = value
                                        self.block_checksum.value_namespace = name_space
                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-count"):
                                        self.block_count = value
                                        self.block_count.value_namespace = name_space
                                        self.block_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-length"):
                                        self.block_length = value
                                        self.block_length.value_namespace = name_space
                                        self.block_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-signature"):
                                        self.block_signature = value
                                        self.block_signature.value_namespace = name_space
                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-version"):
                                        self.block_version = value
                                        self.block_version.value_namespace = name_space
                                        self.block_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "chassis-sid"):
                                        self.chassis_sid = value
                                        self.chassis_sid.value_namespace = name_space
                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "clei"):
                                        self.clei = value
                                        self.clei.value_namespace = name_space
                                        self.clei.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-family"):
                                        self.controller_family = value
                                        self.controller_family.value_namespace = name_space
                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-type"):
                                        self.controller_type = value
                                        self.controller_type.value_namespace = name_space
                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num1"):
                                        self.dev_num1 = value
                                        self.dev_num1.value_namespace = name_space
                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num2"):
                                        self.dev_num2 = value
                                        self.dev_num2.value_namespace = name_space
                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num3"):
                                        self.dev_num3 = value
                                        self.dev_num3.value_namespace = name_space
                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num4"):
                                        self.dev_num4 = value
                                        self.dev_num4.value_namespace = name_space
                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num5"):
                                        self.dev_num5 = value
                                        self.dev_num5.value_namespace = name_space
                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num6"):
                                        self.dev_num6 = value
                                        self.dev_num6.value_namespace = name_space
                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num7"):
                                        self.dev_num7 = value
                                        self.dev_num7.value_namespace = name_space
                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eci"):
                                        self.eci = value
                                        self.eci.value_namespace = name_space
                                        self.eci.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eeprom-size"):
                                        self.eeprom_size = value
                                        self.eeprom_size.value_namespace = name_space
                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "engineer-use"):
                                        self.engineer_use = value
                                        self.engineer_use.value_namespace = name_space
                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-major-type"):
                                        self.fru_major_type = value
                                        self.fru_major_type.value_namespace = name_space
                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-minor-type"):
                                        self.fru_minor_type = value
                                        self.fru_minor_type.value_namespace = name_space
                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hw-version"):
                                        self.hw_version = value
                                        self.hw_version.value_namespace = name_space
                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hwid"):
                                        self.hwid = value
                                        self.hwid.value_namespace = name_space
                                        self.hwid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "idprom-format-rev"):
                                        self.idprom_format_rev = value
                                        self.idprom_format_rev.value_namespace = name_space
                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size1"):
                                        self.mac_add_blk_size1 = value
                                        self.mac_add_blk_size1.value_namespace = name_space
                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size2"):
                                        self.mac_add_blk_size2 = value
                                        self.mac_add_blk_size2.value_namespace = name_space
                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size3"):
                                        self.mac_add_blk_size3 = value
                                        self.mac_add_blk_size3.value_namespace = name_space
                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size4"):
                                        self.mac_add_blk_size4 = value
                                        self.mac_add_blk_size4.value_namespace = name_space
                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "manu-test-data"):
                                        self.manu_test_data = value
                                        self.manu_test_data.value_namespace = name_space
                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-bits"):
                                        self.mfg_bits = value
                                        self.mfg_bits.value_namespace = name_space
                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-deviation"):
                                        self.mfg_deviation = value
                                        self.mfg_deviation.value_namespace = name_space
                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "oem-string"):
                                        self.oem_string = value
                                        self.oem_string.value_namespace = name_space
                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-number"):
                                        self.part_number = value
                                        self.part_number.value_namespace = name_space
                                        self.part_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-revision"):
                                        self.part_revision = value
                                        self.part_revision.value_namespace = name_space
                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pca-num"):
                                        self.pca_num = value
                                        self.pca_num.value_namespace = name_space
                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcavid"):
                                        self.pcavid = value
                                        self.pcavid.value_namespace = name_space
                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcb-serial-num"):
                                        self.pcb_serial_num = value
                                        self.pcb_serial_num.value_namespace = name_space
                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pid"):
                                        self.pid = value
                                        self.pid.value_namespace = name_space
                                        self.pid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-consumption"):
                                        self.power_consumption = value
                                        self.power_consumption.value_namespace = name_space
                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-supply-type"):
                                        self.power_supply_type = value
                                        self.power_supply_type.value_namespace = name_space
                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "product-id"):
                                        self.product_id = value
                                        self.product_id.value_namespace = name_space
                                        self.product_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rma-code"):
                                        self.rma_code = value
                                        self.rma_code.value_namespace = name_space
                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "serial-number"):
                                        self.serial_number = value
                                        self.serial_number.value_namespace = name_space
                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "snmpoid"):
                                        self.snmpoid = value
                                        self.snmpoid.value_namespace = name_space
                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-part-num"):
                                        self.top_assem_part_num = value
                                        self.top_assem_part_num.value_namespace = name_space
                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-vid"):
                                        self.top_assem_vid = value
                                        self.top_assem_vid.value_namespace = name_space
                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-description"):
                                        self.udi_description = value
                                        self.udi_description.value_namespace = name_space
                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-name"):
                                        self.udi_name = value
                                        self.udi_name.value_namespace = name_space
                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vid"):
                                        self.vid = value
                                        self.vid.value_namespace = name_space
                                        self.vid.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.description.is_set or
                                    self.has_eeprom.is_set or
                                    self.inv_card_type.is_set or
                                    self.opaque_data.is_set or
                                    self.opaque_data_size.is_set or
                                    (self.eeprom is not None and self.eeprom.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.has_eeprom.yfilter != YFilter.not_set or
                                    self.inv_card_type.yfilter != YFilter.not_set or
                                    self.opaque_data.yfilter != YFilter.not_set or
                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                    (self.eeprom is not None and self.eeprom.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-eeprom-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "eeprom"):
                                    if (self.eeprom is None):
                                        self.eeprom = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                    return self.eeprom

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-eeprom"):
                                    self.has_eeprom = value
                                    self.has_eeprom.value_namespace = name_space
                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                if(value_path == "inv-card-type"):
                                    self.inv_card_type = value
                                    self.inv_card_type.value_namespace = name_space
                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data"):
                                    self.opaque_data = value
                                    self.opaque_data.value_namespace = name_space
                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data-size"):
                                    self.opaque_data_size = value
                                    self.opaque_data_size.value_namespace = name_space
                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.module_done.is_set or
                                self.node_id.is_set or
                                self.vm_done.is_set or
                                self.vm_node_id.is_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                (self.fru_info is not None and self.fru_info.has_data()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                (self.threshold is not None and self.threshold.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.module_done.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.vm_done.yfilter != YFilter.not_set or
                                self.vm_node_id.yfilter != YFilter.not_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                (self.threshold is not None and self.threshold.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attributes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.module_done.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "env-sensor-info"):
                                if (self.env_sensor_info is None):
                                    self.env_sensor_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                return self.env_sensor_info

                            if (child_yang_name == "env-sensor-info-xml"):
                                if (self.env_sensor_info_xml is None):
                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Powershelf.Slot.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                return self.env_sensor_info_xml

                            if (child_yang_name == "fru-info"):
                                if (self.fru_info is None):
                                    self.fru_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                return self.fru_info

                            if (child_yang_name == "inv-asset-bag"):
                                if (self.inv_asset_bag is None):
                                    self.inv_asset_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                return self.inv_asset_bag

                            if (child_yang_name == "inv-basic-bag"):
                                if (self.inv_basic_bag is None):
                                    self.inv_basic_bag = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                return self.inv_basic_bag

                            if (child_yang_name == "inv-eeprom-info"):
                                if (self.inv_eeprom_info is None):
                                    self.inv_eeprom_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                return self.inv_eeprom_info

                            if (child_yang_name == "pwg-info"):
                                if (self.pwg_info is None):
                                    self.pwg_info = Inventory.Racks.Rack.Powershelf.Slot.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                return self.pwg_info

                            if (child_yang_name == "threshold"):
                                if (self.threshold is None):
                                    self.threshold = Inventory.Racks.Rack.Powershelf.Slot.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                return self.threshold

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "module-done"):
                                self.module_done = value
                                self.module_done.value_namespace = name_space
                                self.module_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-done"):
                                self.vm_done = value
                                self.vm_done.value_namespace = name_space
                                self.vm_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-node-id"):
                                self.vm_node_id = value
                                self.vm_node_id.value_namespace = name_space
                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.name.is_set or
                            (self.attributes is not None and self.attributes.has_data()) or
                            (self.tsi1s is not None and self.tsi1s.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            (self.attributes is not None and self.attributes.has_operation()) or
                            (self.tsi1s is not None and self.tsi1s.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slot" + "[name='" + self.name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attributes"):
                            if (self.attributes is None):
                                self.attributes = Inventory.Racks.Rack.Powershelf.Slot.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                            return self.attributes

                        if (child_yang_name == "tsi1s"):
                            if (self.tsi1s is None):
                                self.tsi1s = Inventory.Racks.Rack.Powershelf.Slot.Tsi1S()
                                self.tsi1s.parent = self
                                self._children_name_map["tsi1s"] = "tsi1s"
                            return self.tsi1s

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attributes" or name == "tsi1s" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.slot:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.slot:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "powershelf" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "slot"):
                        for c in self.slot:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Inventory.Racks.Rack.Powershelf.Slot()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.slot.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "slot"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Fantray(Entity):
                """
                Fantray information
                
                .. attribute:: slot
                
                	Slot number
                	**type**\: list of    :py:class:`Slot <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot>`
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Racks.Rack.Fantray, self).__init__()

                    self.yang_name = "fantray"
                    self.yang_parent_name = "rack"

                    self.slot = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Inventory.Racks.Rack.Fantray, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Inventory.Racks.Rack.Fantray, self).__setattr__(name, value)


                class Slot(Entity):
                    """
                    Slot number
                    
                    .. attribute:: name  <key>
                    
                    	Slot name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: attributes
                    
                    	Attributes
                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes>`
                    
                    .. attribute:: tsi1s
                    
                    	Entity Level 1
                    	**type**\:   :py:class:`Tsi1S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S>`
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Fantray.Slot, self).__init__()

                        self.yang_name = "slot"
                        self.yang_parent_name = "fantray"

                        self.name = YLeaf(YType.str, "name")

                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                        self._children_yang_names.add("attributes")

                        self.tsi1s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S()
                        self.tsi1s.parent = self
                        self._children_name_map["tsi1s"] = "tsi1s"
                        self._children_yang_names.add("tsi1s")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Fantray.Slot, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Fantray.Slot, self).__setattr__(name, value)


                    class Tsi1S(Entity):
                        """
                        Entity Level 1
                        
                        .. attribute:: tsi1
                        
                        	TSI1
                        	**type**\: list of    :py:class:`Tsi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S, self).__init__()

                            self.yang_name = "tsi1s"
                            self.yang_parent_name = "slot"

                            self.tsi1 = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S, self).__setattr__(name, value)


                        class Tsi1(Entity):
                            """
                            TSI1
                            
                            .. attribute:: name  <key>
                            
                            	TSI1
                            	**type**\:  str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            .. attribute:: attributes
                            
                            	Attributes
                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes>`
                            
                            .. attribute:: tsi2s
                            
                            	Entity Level 2
                            	**type**\:   :py:class:`Tsi2S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1, self).__init__()

                                self.yang_name = "tsi1"
                                self.yang_parent_name = "tsi1s"

                                self.name = YLeaf(YType.str, "name")

                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                                self._children_yang_names.add("attributes")

                                self.tsi2s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S()
                                self.tsi2s.parent = self
                                self._children_name_map["tsi2s"] = "tsi2s"
                                self._children_yang_names.add("tsi2s")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1, self).__setattr__(name, value)


                            class Tsi2S(Entity):
                                """
                                Entity Level 2
                                
                                .. attribute:: tsi2
                                
                                	TSI2
                                	**type**\: list of    :py:class:`Tsi2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S, self).__init__()

                                    self.yang_name = "tsi2s"
                                    self.yang_parent_name = "tsi1"

                                    self.tsi2 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S, self).__setattr__(name, value)


                                class Tsi2(Entity):
                                    """
                                    TSI2
                                    
                                    .. attribute:: name  <key>
                                    
                                    	TSI2
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    .. attribute:: attributes
                                    
                                    	Attributes
                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes>`
                                    
                                    .. attribute:: tsi3s
                                    
                                    	Entity Level 3
                                    	**type**\:   :py:class:`Tsi3S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__init__()

                                        self.yang_name = "tsi2"
                                        self.yang_parent_name = "tsi2s"

                                        self.name = YLeaf(YType.str, "name")

                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                        self._children_yang_names.add("attributes")

                                        self.tsi3s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                        self.tsi3s.parent = self
                                        self._children_name_map["tsi3s"] = "tsi3s"
                                        self._children_yang_names.add("tsi3s")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2, self).__setattr__(name, value)


                                    class Tsi3S(Entity):
                                        """
                                        Entity Level 3
                                        
                                        .. attribute:: tsi3
                                        
                                        	TSI3
                                        	**type**\: list of    :py:class:`Tsi3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__init__()

                                            self.yang_name = "tsi3s"
                                            self.yang_parent_name = "tsi2"

                                            self.tsi3 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S, self).__setattr__(name, value)


                                        class Tsi3(Entity):
                                            """
                                            TSI3
                                            
                                            .. attribute:: name  <key>
                                            
                                            	TSI3
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            .. attribute:: attributes
                                            
                                            	Attributes
                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes>`
                                            
                                            .. attribute:: tsi4s
                                            
                                            	Entity Level 4
                                            	**type**\:   :py:class:`Tsi4S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__init__()

                                                self.yang_name = "tsi3"
                                                self.yang_parent_name = "tsi3s"

                                                self.name = YLeaf(YType.str, "name")

                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                                self._children_yang_names.add("attributes")

                                                self.tsi4s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                self.tsi4s.parent = self
                                                self._children_name_map["tsi4s"] = "tsi4s"
                                                self._children_yang_names.add("tsi4s")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3, self).__setattr__(name, value)


                                            class Tsi4S(Entity):
                                                """
                                                Entity Level 4
                                                
                                                .. attribute:: tsi4
                                                
                                                	TSI4
                                                	**type**\: list of    :py:class:`Tsi4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__init__()

                                                    self.yang_name = "tsi4s"
                                                    self.yang_parent_name = "tsi3"

                                                    self.tsi4 = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S, self).__setattr__(name, value)


                                                class Tsi4(Entity):
                                                    """
                                                    TSI4
                                                    
                                                    .. attribute:: name  <key>
                                                    
                                                    	TSI4
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    .. attribute:: attributes
                                                    
                                                    	Attributes
                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes>`
                                                    
                                                    .. attribute:: tsi5s
                                                    
                                                    	Entity Level 5
                                                    	**type**\:   :py:class:`Tsi5S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__init__()

                                                        self.yang_name = "tsi4"
                                                        self.yang_parent_name = "tsi4s"

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                        self._children_yang_names.add("attributes")

                                                        self.tsi5s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                        self.tsi5s.parent = self
                                                        self._children_name_map["tsi5s"] = "tsi5s"
                                                        self._children_yang_names.add("tsi5s")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4, self).__setattr__(name, value)


                                                    class Tsi5S(Entity):
                                                        """
                                                        Entity Level 5
                                                        
                                                        .. attribute:: tsi5
                                                        
                                                        	TSI5
                                                        	**type**\: list of    :py:class:`Tsi5 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__init__()

                                                            self.yang_name = "tsi5s"
                                                            self.yang_parent_name = "tsi4"

                                                            self.tsi5 = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S, self).__setattr__(name, value)


                                                        class Tsi5(Entity):
                                                            """
                                                            TSI5
                                                            
                                                            .. attribute:: name  <key>
                                                            
                                                            	TSI5
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                            
                                                            .. attribute:: attributes
                                                            
                                                            	Attributes
                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes>`
                                                            
                                                            .. attribute:: tsi6s
                                                            
                                                            	Entity Level 6
                                                            	**type**\:   :py:class:`Tsi6S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__init__()

                                                                self.yang_name = "tsi5"
                                                                self.yang_parent_name = "tsi5s"

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                                self._children_yang_names.add("attributes")

                                                                self.tsi6s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                self.tsi6s.parent = self
                                                                self._children_name_map["tsi6s"] = "tsi6s"
                                                                self._children_yang_names.add("tsi6s")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("name") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5, self).__setattr__(name, value)


                                                            class Tsi6S(Entity):
                                                                """
                                                                Entity Level 6
                                                                
                                                                .. attribute:: tsi6
                                                                
                                                                	TSI6
                                                                	**type**\: list of    :py:class:`Tsi6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__init__()

                                                                    self.yang_name = "tsi6s"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.tsi6 = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S, self).__setattr__(name, value)


                                                                class Tsi6(Entity):
                                                                    """
                                                                    TSI6
                                                                    
                                                                    .. attribute:: name  <key>
                                                                    
                                                                    	TSI6
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                    
                                                                    .. attribute:: attributes
                                                                    
                                                                    	Attributes
                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes>`
                                                                    
                                                                    .. attribute:: tsi7s
                                                                    
                                                                    	Entity Level 7
                                                                    	**type**\:   :py:class:`Tsi7S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__init__()

                                                                        self.yang_name = "tsi6"
                                                                        self.yang_parent_name = "tsi6s"

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                        self._children_yang_names.add("attributes")

                                                                        self.tsi7s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                        self.tsi7s.parent = self
                                                                        self._children_name_map["tsi7s"] = "tsi7s"
                                                                        self._children_yang_names.add("tsi7s")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("name") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6, self).__setattr__(name, value)


                                                                    class Tsi7S(Entity):
                                                                        """
                                                                        Entity Level 7
                                                                        
                                                                        .. attribute:: tsi7
                                                                        
                                                                        	TSI7
                                                                        	**type**\: list of    :py:class:`Tsi7 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__init__()

                                                                            self.yang_name = "tsi7s"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.tsi7 = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S, self).__setattr__(name, value)


                                                                        class Tsi7(Entity):
                                                                            """
                                                                            TSI7
                                                                            
                                                                            .. attribute:: name  <key>
                                                                            
                                                                            	TSI7
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                            
                                                                            .. attribute:: attributes
                                                                            
                                                                            	Attributes
                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes>`
                                                                            
                                                                            .. attribute:: tsi8s
                                                                            
                                                                            	Entity Level 8
                                                                            	**type**\:   :py:class:`Tsi8S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__init__()

                                                                                self.yang_name = "tsi7"
                                                                                self.yang_parent_name = "tsi7s"

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                self._children_yang_names.add("attributes")

                                                                                self.tsi8s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                self.tsi8s.parent = self
                                                                                self._children_name_map["tsi8s"] = "tsi8s"
                                                                                self._children_yang_names.add("tsi8s")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("name") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7, self).__setattr__(name, value)


                                                                            class Tsi8S(Entity):
                                                                                """
                                                                                Entity Level 8
                                                                                
                                                                                .. attribute:: tsi8
                                                                                
                                                                                	TSI8
                                                                                	**type**\: list of    :py:class:`Tsi8 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__init__()

                                                                                    self.yang_name = "tsi8s"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.tsi8 = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S, self).__setattr__(name, value)


                                                                                class Tsi8(Entity):
                                                                                    """
                                                                                    TSI8
                                                                                    
                                                                                    .. attribute:: name  <key>
                                                                                    
                                                                                    	TSI8
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                    
                                                                                    .. attribute:: attributes
                                                                                    
                                                                                    	Attributes
                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes>`
                                                                                    
                                                                                    .. attribute:: tsi9s
                                                                                    
                                                                                    	Entity Level 9
                                                                                    	**type**\:   :py:class:`Tsi9S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__init__()

                                                                                        self.yang_name = "tsi8"
                                                                                        self.yang_parent_name = "tsi8s"

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                        self._children_yang_names.add("attributes")

                                                                                        self.tsi9s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                        self.tsi9s.parent = self
                                                                                        self._children_name_map["tsi9s"] = "tsi9s"
                                                                                        self._children_yang_names.add("tsi9s")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8, self).__setattr__(name, value)


                                                                                    class Tsi9S(Entity):
                                                                                        """
                                                                                        Entity Level 9
                                                                                        
                                                                                        .. attribute:: tsi9
                                                                                        
                                                                                        	TSI9
                                                                                        	**type**\: list of    :py:class:`Tsi9 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__init__()

                                                                                            self.yang_name = "tsi9s"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.tsi9 = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S, self).__setattr__(name, value)


                                                                                        class Tsi9(Entity):
                                                                                            """
                                                                                            TSI9
                                                                                            
                                                                                            .. attribute:: name  <key>
                                                                                            
                                                                                            	TSI9
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                            
                                                                                            .. attribute:: attributes
                                                                                            
                                                                                            	Attributes
                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes>`
                                                                                            
                                                                                            .. attribute:: tsi10s
                                                                                            
                                                                                            	Entity Level 10
                                                                                            	**type**\:   :py:class:`Tsi10S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__init__()

                                                                                                self.yang_name = "tsi9"
                                                                                                self.yang_parent_name = "tsi9s"

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                self._children_yang_names.add("attributes")

                                                                                                self.tsi10s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                self.tsi10s.parent = self
                                                                                                self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                self._children_yang_names.add("tsi10s")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9, self).__setattr__(name, value)


                                                                                            class Tsi10S(Entity):
                                                                                                """
                                                                                                Entity Level 10
                                                                                                
                                                                                                .. attribute:: tsi10
                                                                                                
                                                                                                	TSI10
                                                                                                	**type**\: list of    :py:class:`Tsi10 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__init__()

                                                                                                    self.yang_name = "tsi10s"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.tsi10 = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S, self).__setattr__(name, value)


                                                                                                class Tsi10(Entity):
                                                                                                    """
                                                                                                    TSI10
                                                                                                    
                                                                                                    .. attribute:: name  <key>
                                                                                                    
                                                                                                    	TSI10
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                    
                                                                                                    .. attribute:: attributes
                                                                                                    
                                                                                                    	Attributes
                                                                                                    	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes>`
                                                                                                    
                                                                                                    .. attribute:: tsi11s
                                                                                                    
                                                                                                    	Entity Level 11
                                                                                                    	**type**\:   :py:class:`Tsi11S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__init__()

                                                                                                        self.yang_name = "tsi10"
                                                                                                        self.yang_parent_name = "tsi10s"

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                        self._children_yang_names.add("attributes")

                                                                                                        self.tsi11s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                        self.tsi11s.parent = self
                                                                                                        self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                        self._children_yang_names.add("tsi11s")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("name") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10, self).__setattr__(name, value)


                                                                                                    class Tsi11S(Entity):
                                                                                                        """
                                                                                                        Entity Level 11
                                                                                                        
                                                                                                        .. attribute:: tsi11
                                                                                                        
                                                                                                        	TSI11
                                                                                                        	**type**\: list of    :py:class:`Tsi11 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__init__()

                                                                                                            self.yang_name = "tsi11s"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.tsi11 = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S, self).__setattr__(name, value)


                                                                                                        class Tsi11(Entity):
                                                                                                            """
                                                                                                            TSI11
                                                                                                            
                                                                                                            .. attribute:: name  <key>
                                                                                                            
                                                                                                            	TSI11
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                                                                            
                                                                                                            .. attribute:: attributes
                                                                                                            
                                                                                                            	Attributes
                                                                                                            	**type**\:   :py:class:`Attributes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__init__()

                                                                                                                self.yang_name = "tsi11"
                                                                                                                self.yang_parent_name = "tsi11s"

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                                self._children_yang_names.add("attributes")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("name") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11, self).__setattr__(name, value)


                                                                                                            class Attributes(Entity):
                                                                                                                """
                                                                                                                Attributes
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info
                                                                                                                
                                                                                                                	Environment sensor info
                                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo>`
                                                                                                                
                                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                                
                                                                                                                	Environment sensor info XML
                                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml>`
                                                                                                                
                                                                                                                .. attribute:: fru_info
                                                                                                                
                                                                                                                	Inventory EDM FRU info
                                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo>`
                                                                                                                
                                                                                                                .. attribute:: inv_asset_bag
                                                                                                                
                                                                                                                	Inventory Asset Bag
                                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_basic_bag
                                                                                                                
                                                                                                                	Inventory Basic Bag
                                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag>`
                                                                                                                
                                                                                                                .. attribute:: inv_eeprom_info
                                                                                                                
                                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo>`
                                                                                                                
                                                                                                                .. attribute:: module_done
                                                                                                                
                                                                                                                	Inventory EDM Module Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**default value**\: 1
                                                                                                                
                                                                                                                .. attribute:: node_id
                                                                                                                
                                                                                                                	Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                .. attribute:: pwg_info
                                                                                                                
                                                                                                                	Inventory EDM PWG info
                                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo>`
                                                                                                                
                                                                                                                .. attribute:: threshold
                                                                                                                
                                                                                                                	Threshold
                                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold>`
                                                                                                                
                                                                                                                .. attribute:: vm_done
                                                                                                                
                                                                                                                	VM Done Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                .. attribute:: vm_node_id
                                                                                                                
                                                                                                                	VM Node ID Tuple
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** 0..4294967295
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__init__()

                                                                                                                    self.yang_name = "attributes"
                                                                                                                    self.yang_parent_name = "tsi11"

                                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                    self._children_yang_names.add("threshold")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("module_done",
                                                                                                                                    "node_id",
                                                                                                                                    "vm_done",
                                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes, self).__setattr__(name, value)


                                                                                                                class EnvSensorInfo(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info
                                                                                                                    
                                                                                                                    .. attribute:: age_time_stamp
                                                                                                                    
                                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: alarm_type
                                                                                                                    
                                                                                                                    	Indicates threshold violation
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: device_description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: device_id
                                                                                                                    
                                                                                                                    	Identifier for this device
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                                    
                                                                                                                    	Sensor valid bitmap
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: precision
                                                                                                                    
                                                                                                                    	Sensor precision range
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: scale
                                                                                                                    
                                                                                                                    	Sensor scale enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state enums
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("age_time_stamp",
                                                                                                                                        "alarm_type",
                                                                                                                                        "data_type",
                                                                                                                                        "device_description",
                                                                                                                                        "device_id",
                                                                                                                                        "field_validity_bitmap",
                                                                                                                                        "precision",
                                                                                                                                        "scale",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.age_time_stamp.is_set or
                                                                                                                            self.alarm_type.is_set or
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.device_description.is_set or
                                                                                                                            self.device_id.is_set or
                                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                                            self.precision.is_set or
                                                                                                                            self.scale.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                                            self.age_time_stamp = value
                                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "alarm-type"):
                                                                                                                            self.alarm_type = value
                                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-description"):
                                                                                                                            self.device_description = value
                                                                                                                            self.device_description.value_namespace = name_space
                                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "device-id"):
                                                                                                                            self.device_id = value
                                                                                                                            self.device_id.value_namespace = name_space
                                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                                            self.field_validity_bitmap = value
                                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "precision"):
                                                                                                                            self.precision = value
                                                                                                                            self.precision.value_namespace = name_space
                                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "scale"):
                                                                                                                            self.scale = value
                                                                                                                            self.scale.value_namespace = name_space
                                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class PwgInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM PWG info
                                                                                                                    
                                                                                                                    .. attribute:: power_group_available_current
                                                                                                                    
                                                                                                                    	available current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                                    
                                                                                                                    	drawn current
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_group_power_units
                                                                                                                    
                                                                                                                    	power units
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                                    
                                                                                                                    	redundancy mode
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__init__()

                                                                                                                        self.yang_name = "pwg-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("power_group_available_current",
                                                                                                                                        "power_group_drawn_current",
                                                                                                                                        "power_group_power_units",
                                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.power_group_available_current.is_set or
                                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                                            self.power_group_power_units.is_set or
                                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                                            self.power_group_available_current = value
                                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                                            self.power_group_drawn_current = value
                                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                                            self.power_group_power_units = value
                                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                                            self.power_group_redundancy_mode = value
                                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                                    """
                                                                                                                    Environment sensor info XML
                                                                                                                    
                                                                                                                    .. attribute:: data_type
                                                                                                                    
                                                                                                                    	Sensor data type
                                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	Device Name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: status
                                                                                                                    
                                                                                                                    	Sensor operation state
                                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold
                                                                                                                    
                                                                                                                    	Threshold information
                                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                                    
                                                                                                                    .. attribute:: units
                                                                                                                    
                                                                                                                    	Units of variable being read
                                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                                    
                                                                                                                    .. attribute:: update_rate
                                                                                                                    
                                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: value
                                                                                                                    
                                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                        self._children_yang_names.add("threshold")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("data_type",
                                                                                                                                        "description",
                                                                                                                                        "status",
                                                                                                                                        "units",
                                                                                                                                        "update_rate",
                                                                                                                                        "value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                                    class Threshold(Entity):
                                                                                                                        """
                                                                                                                        Threshold information
                                                                                                                        
                                                                                                                        .. attribute:: threshold_array
                                                                                                                        
                                                                                                                        	Array of threshold
                                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                            self.yang_name = "threshold"
                                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                            self.threshold_array = YList(self)

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in () and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                        class ThresholdArray(Entity):
                                                                                                                            """
                                                                                                                            Array of threshold
                                                                                                                            
                                                                                                                            .. attribute:: threshold_name
                                                                                                                            
                                                                                                                            	Threshold name
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..50
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                                self.yang_name = "threshold-array"
                                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_name",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_name.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-name"):
                                                                                                                                    self.threshold_name = value
                                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_data()):
                                                                                                                                    return True
                                                                                                                            return False

                                                                                                                        def has_operation(self):
                                                                                                                            for c in self.threshold_array:
                                                                                                                                if (c.has_operation()):
                                                                                                                                    return True
                                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                                for c in self.threshold_array:
                                                                                                                                    segment = c.get_segment_path()
                                                                                                                                    if (segment_path == segment):
                                                                                                                                        return c
                                                                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                                c.parent = self
                                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                                self.threshold_array.append(c)
                                                                                                                                return c

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "threshold-array"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.data_type.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.status.is_set or
                                                                                                                            self.units.is_set or
                                                                                                                            self.update_rate.is_set or
                                                                                                                            self.value.is_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "threshold"):
                                                                                                                            if (self.threshold is None):
                                                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                                self.threshold.parent = self
                                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                            return self.threshold

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "data-type"):
                                                                                                                            self.data_type = value
                                                                                                                            self.data_type.value_namespace = name_space
                                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "status"):
                                                                                                                            self.status = value
                                                                                                                            self.status.value_namespace = name_space
                                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "units"):
                                                                                                                            self.units = value
                                                                                                                            self.units.value_namespace = name_space
                                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "update-rate"):
                                                                                                                            self.update_rate = value
                                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "value"):
                                                                                                                            self.value = value
                                                                                                                            self.value.value_namespace = name_space
                                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                                class InvAssetBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Asset Bag
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                                    
                                                                                                                    	Manufacture Assembly number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                                    
                                                                                                                    	Manufacture assembly revision
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                                    
                                                                                                                    	Common Language Equipment           Identifier number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                                    
                                                                                                                    	String containing OEM information           if applicable
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: part_number
                                                                                                                    
                                                                                                                    	
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__init__()

                                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                                        "manufacturer_software_identifier",
                                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                                            self.part_number.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                                            self.manufacturer_assembly_number = value
                                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                                            self.manufacturer_software_identifier = value
                                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "part-number"):
                                                                                                                            self.part_number = value
                                                                                                                            self.part_number.value_namespace = name_space
                                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                                class Threshold(Entity):
                                                                                                                    """
                                                                                                                    Threshold
                                                                                                                    
                                                                                                                    .. attribute:: critical_hi
                                                                                                                    
                                                                                                                    	Critical High
                                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi>`
                                                                                                                    
                                                                                                                    .. attribute:: critical_lo
                                                                                                                    
                                                                                                                    	Critical Low
                                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo>`
                                                                                                                    
                                                                                                                    .. attribute:: major_hi
                                                                                                                    
                                                                                                                    	Major High
                                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: major_lo
                                                                                                                    
                                                                                                                    	Major Low
                                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_hi
                                                                                                                    
                                                                                                                    	Minor High
                                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi>`
                                                                                                                    
                                                                                                                    .. attribute:: minor_lo
                                                                                                                    
                                                                                                                    	Minor Low
                                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo>`
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold, self).__init__()

                                                                                                                        self.yang_name = "threshold"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                                    class MajorLo(Entity):
                                                                                                                        """
                                                                                                                        Major Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                            self.yang_name = "major-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalHi(Entity):
                                                                                                                        """
                                                                                                                        Critical High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                            self.yang_name = "critical-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorHi(Entity):
                                                                                                                        """
                                                                                                                        Minor High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                            self.yang_name = "minor-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MajorHi(Entity):
                                                                                                                        """
                                                                                                                        Major High
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                            self.yang_name = "major-hi"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class CriticalLo(Entity):
                                                                                                                        """
                                                                                                                        Critical Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                            self.yang_name = "critical-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass


                                                                                                                    class MinorLo(Entity):
                                                                                                                        """
                                                                                                                        Minor Low
                                                                                                                        
                                                                                                                        .. attribute:: thresh_bag
                                                                                                                        
                                                                                                                        	Environment threshold info
                                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                            self.yang_name = "minor-lo"
                                                                                                                            self.yang_parent_name = "threshold"

                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                                        class ThreshBag(Entity):
                                                                                                                            """
                                                                                                                            Environment threshold info
                                                                                                                            
                                                                                                                            .. attribute:: threshold_evaluation
                                                                                                                            
                                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                                            
                                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                            	**type**\:  bool
                                                                                                                            
                                                                                                                            .. attribute:: threshold_relation
                                                                                                                            
                                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_severity
                                                                                                                            
                                                                                                                            	Indicates minor, major, critical severities
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            .. attribute:: threshold_value
                                                                                                                            
                                                                                                                            	Value of the configured threshold
                                                                                                                            	**type**\:  int
                                                                                                                            
                                                                                                                            	**range:** 0..4294967295
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                                "threshold_notification_enabled",
                                                                                                                                                "threshold_relation",
                                                                                                                                                "threshold_severity",
                                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                                    self.threshold_relation.is_set or
                                                                                                                                    self.threshold_severity.is_set or
                                                                                                                                    self.threshold_value.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                                    self.threshold_evaluation = value
                                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                                    self.threshold_relation = value
                                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                                    self.threshold_severity = value
                                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "threshold-value"):
                                                                                                                                    self.threshold_value = value
                                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                                if (self.thresh_bag is None):
                                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                                    self.thresh_bag.parent = self
                                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                                return self.thresh_bag

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "thresh-bag"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            pass

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                                            if (self.critical_hi is None):
                                                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalHi()
                                                                                                                                self.critical_hi.parent = self
                                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                            return self.critical_hi

                                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                                            if (self.critical_lo is None):
                                                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.CriticalLo()
                                                                                                                                self.critical_lo.parent = self
                                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                            return self.critical_lo

                                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                                            if (self.major_hi is None):
                                                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorHi()
                                                                                                                                self.major_hi.parent = self
                                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                            return self.major_hi

                                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                                            if (self.major_lo is None):
                                                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MajorLo()
                                                                                                                                self.major_lo.parent = self
                                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                            return self.major_lo

                                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                                            if (self.minor_hi is None):
                                                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorHi()
                                                                                                                                self.minor_hi.parent = self
                                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                            return self.minor_hi

                                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                                            if (self.minor_lo is None):
                                                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold.MinorLo()
                                                                                                                                self.minor_lo.parent = self
                                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                            return self.minor_lo

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        pass


                                                                                                                class FruInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM FRU info
                                                                                                                    
                                                                                                                    .. attribute:: card_administrative_state
                                                                                                                    
                                                                                                                    	card admin state\: shutdown or not
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_monitor_state
                                                                                                                    
                                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_operational_state
                                                                                                                    
                                                                                                                    	card operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: card_reset_reason
                                                                                                                    
                                                                                                                    	card reset reason enum
                                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                                    
                                                                                                                    .. attribute:: card_up_time
                                                                                                                    
                                                                                                                    	card up time
                                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime>`
                                                                                                                    
                                                                                                                    .. attribute:: last_operational_state_change
                                                                                                                    
                                                                                                                    	last card oper change state
                                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                                    
                                                                                                                    .. attribute:: power_administrative_state
                                                                                                                    
                                                                                                                    	power admin state\: up or down
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_current_measurement
                                                                                                                    
                                                                                                                    	power current\: not implemented
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: power_operational_state
                                                                                                                    
                                                                                                                    	Power operation state
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__init__()

                                                                                                                        self.yang_name = "fru-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("card_administrative_state",
                                                                                                                                        "card_monitor_state",
                                                                                                                                        "card_operational_state",
                                                                                                                                        "card_reset_reason",
                                                                                                                                        "power_administrative_state",
                                                                                                                                        "power_current_measurement",
                                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                                        """
                                                                                                                        last card oper change state
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                                    class CardUpTime(Entity):
                                                                                                                        """
                                                                                                                        card up time
                                                                                                                        
                                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                                        
                                                                                                                        	Time Value in Nano\-seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: nanosecond
                                                                                                                        
                                                                                                                        .. attribute:: time_in_seconds
                                                                                                                        
                                                                                                                        	Time Value in Seconds
                                                                                                                        	**type**\:  int
                                                                                                                        
                                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                                        
                                                                                                                        	**units**\: second
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                            self.yang_name = "card-up-time"
                                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                                self.time_in_seconds.is_set)

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                                self.time_in_nano_seconds = value
                                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                                self.time_in_seconds = value
                                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.card_administrative_state.is_set or
                                                                                                                            self.card_monitor_state.is_set or
                                                                                                                            self.card_operational_state.is_set or
                                                                                                                            self.card_reset_reason.is_set or
                                                                                                                            self.power_administrative_state.is_set or
                                                                                                                            self.power_current_measurement.is_set or
                                                                                                                            self.power_operational_state.is_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                                            if (self.card_up_time is None):
                                                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.CardUpTime()
                                                                                                                                self.card_up_time.parent = self
                                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                            return self.card_up_time

                                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                            return self.last_operational_state_change

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                                            self.card_administrative_state = value
                                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                                            self.card_monitor_state = value
                                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-operational-state"):
                                                                                                                            self.card_operational_state = value
                                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                                            self.card_reset_reason = value
                                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                                            self.power_administrative_state = value
                                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                                            self.power_current_measurement = value
                                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "power-operational-state"):
                                                                                                                            self.power_operational_state = value
                                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                                class InvBasicBag(Entity):
                                                                                                                    """
                                                                                                                    Inventory Basic Bag
                                                                                                                    
                                                                                                                    .. attribute:: alias
                                                                                                                    
                                                                                                                    	useful for storing an entity alias 
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_id_str
                                                                                                                    
                                                                                                                    	asset Identification string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: asset_identification
                                                                                                                    
                                                                                                                    	asset Identification
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: ceport
                                                                                                                    
                                                                                                                    	1 if ce port found, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                                    
                                                                                                                    	chip module hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: composite_class_code
                                                                                                                    
                                                                                                                    	Major&minor class of the entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                                    
                                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: firmware_revision
                                                                                                                    
                                                                                                                    	firmware revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: group_flag
                                                                                                                    
                                                                                                                    	indicates if this entity is group       or not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: hardware_revision
                                                                                                                    
                                                                                                                    	hw revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                                    
                                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                                    
                                                                                                                    	Manufacture Asset Tags
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: manufacturer_name
                                                                                                                    
                                                                                                                    	manufacturer's name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: memory_size
                                                                                                                    
                                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: model_name
                                                                                                                    
                                                                                                                    	model name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: name
                                                                                                                    
                                                                                                                    	name string for the entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: new_deviation_number
                                                                                                                    
                                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                                    
                                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: redundancystate
                                                                                                                    
                                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: serial_number
                                                                                                                    
                                                                                                                    	serial number
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: software_revision
                                                                                                                    
                                                                                                                    	software revision string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: unique_id
                                                                                                                    
                                                                                                                    	Unique id for an entity
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    .. attribute:: unrecognized_fru
                                                                                                                    
                                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: vendor_type
                                                                                                                    
                                                                                                                    	maps to the vendor OID string
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: xr_scoped
                                                                                                                    
                                                                                                                    	1 if xr scoped, 0 if not
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__init__()

                                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("alias",
                                                                                                                                        "asset_id_str",
                                                                                                                                        "asset_identification",
                                                                                                                                        "ceport",
                                                                                                                                        "chip_hardware_revision",
                                                                                                                                        "composite_class_code",
                                                                                                                                        "description",
                                                                                                                                        "environmental_monitor_path",
                                                                                                                                        "firmware_revision",
                                                                                                                                        "group_flag",
                                                                                                                                        "hardware_revision",
                                                                                                                                        "is_field_replaceable_unit",
                                                                                                                                        "manufacturer_asset_tags",
                                                                                                                                        "manufacturer_name",
                                                                                                                                        "memory_size",
                                                                                                                                        "model_name",
                                                                                                                                        "name",
                                                                                                                                        "new_deviation_number",
                                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                                        "redundancystate",
                                                                                                                                        "serial_number",
                                                                                                                                        "software_revision",
                                                                                                                                        "unique_id",
                                                                                                                                        "unrecognized_fru",
                                                                                                                                        "vendor_type",
                                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.alias.is_set or
                                                                                                                            self.asset_id_str.is_set or
                                                                                                                            self.asset_identification.is_set or
                                                                                                                            self.ceport.is_set or
                                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                                            self.composite_class_code.is_set or
                                                                                                                            self.description.is_set or
                                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                                            self.firmware_revision.is_set or
                                                                                                                            self.group_flag.is_set or
                                                                                                                            self.hardware_revision.is_set or
                                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                                            self.manufacturer_name.is_set or
                                                                                                                            self.memory_size.is_set or
                                                                                                                            self.model_name.is_set or
                                                                                                                            self.name.is_set or
                                                                                                                            self.new_deviation_number.is_set or
                                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                                            self.redundancystate.is_set or
                                                                                                                            self.serial_number.is_set or
                                                                                                                            self.software_revision.is_set or
                                                                                                                            self.unique_id.is_set or
                                                                                                                            self.unrecognized_fru.is_set or
                                                                                                                            self.vendor_type.is_set or
                                                                                                                            self.xr_scoped.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "alias"):
                                                                                                                            self.alias = value
                                                                                                                            self.alias.value_namespace = name_space
                                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-id-str"):
                                                                                                                            self.asset_id_str = value
                                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "asset-identification"):
                                                                                                                            self.asset_identification = value
                                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "ceport"):
                                                                                                                            self.ceport = value
                                                                                                                            self.ceport.value_namespace = name_space
                                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                                            self.chip_hardware_revision = value
                                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "composite-class-code"):
                                                                                                                            self.composite_class_code = value
                                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                                            self.environmental_monitor_path = value
                                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "firmware-revision"):
                                                                                                                            self.firmware_revision = value
                                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "group-flag"):
                                                                                                                            self.group_flag = value
                                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "hardware-revision"):
                                                                                                                            self.hardware_revision = value
                                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                                            self.is_field_replaceable_unit = value
                                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                                            self.manufacturer_asset_tags = value
                                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                                            self.manufacturer_name = value
                                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "memory-size"):
                                                                                                                            self.memory_size = value
                                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "model-name"):
                                                                                                                            self.model_name = value
                                                                                                                            self.model_name.value_namespace = name_space
                                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "name"):
                                                                                                                            self.name = value
                                                                                                                            self.name.value_namespace = name_space
                                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                                            self.new_deviation_number = value
                                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "redundancystate"):
                                                                                                                            self.redundancystate = value
                                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "serial-number"):
                                                                                                                            self.serial_number = value
                                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "software-revision"):
                                                                                                                            self.software_revision = value
                                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unique-id"):
                                                                                                                            self.unique_id = value
                                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                                            self.unrecognized_fru = value
                                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "vendor-type"):
                                                                                                                            self.vendor_type = value
                                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "xr-scoped"):
                                                                                                                            self.xr_scoped = value
                                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                                class InvEepromInfo(Entity):
                                                                                                                    """
                                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                                    
                                                                                                                    .. attribute:: description
                                                                                                                    
                                                                                                                    	A textual description of physical entity
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: eeprom
                                                                                                                    
                                                                                                                    	EEPROM data not from hex data
                                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom>`
                                                                                                                    
                                                                                                                    .. attribute:: has_eeprom
                                                                                                                    
                                                                                                                    	use eeprom instead of opaque data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: inv_card_type
                                                                                                                    
                                                                                                                    	Inventory card type
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data
                                                                                                                    
                                                                                                                    	EEPROM hex data
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                                    
                                                                                                                    .. attribute:: opaque_data_size
                                                                                                                    
                                                                                                                    	size of the EEPROM hex data
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__init__()

                                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                                        self.yang_parent_name = "attributes"

                                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("description",
                                                                                                                                        "has_eeprom",
                                                                                                                                        "inv_card_type",
                                                                                                                                        "opaque_data",
                                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                                    class Eeprom(Entity):
                                                                                                                        """
                                                                                                                        EEPROM data not from hex data
                                                                                                                        
                                                                                                                        .. attribute:: asset_alias
                                                                                                                        
                                                                                                                        	Asset Alias
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: asset_id
                                                                                                                        
                                                                                                                        	Asset ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address1
                                                                                                                        
                                                                                                                        	Base Mac Address #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address2
                                                                                                                        
                                                                                                                        	Base Mac Address #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address3
                                                                                                                        
                                                                                                                        	Base Mac Address #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: base_mac_address4
                                                                                                                        
                                                                                                                        	Base Mac Address #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_checksum
                                                                                                                        
                                                                                                                        	Block Checksum
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_count
                                                                                                                        
                                                                                                                        	Block Count
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_length
                                                                                                                        
                                                                                                                        	Block Length
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_signature
                                                                                                                        
                                                                                                                        	Block Signature
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: block_version
                                                                                                                        
                                                                                                                        	Block Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: chassis_sid
                                                                                                                        
                                                                                                                        	Chassis serial number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: clei
                                                                                                                        
                                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_family
                                                                                                                        
                                                                                                                        	Controller family
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: controller_type
                                                                                                                        
                                                                                                                        	Controller type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: description
                                                                                                                        
                                                                                                                        	A textual description of physical entity
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num1
                                                                                                                        
                                                                                                                        	Deviation Number # 1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num2
                                                                                                                        
                                                                                                                        	Deviation Number # 2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num3
                                                                                                                        
                                                                                                                        	Deviation Number # 3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num4
                                                                                                                        
                                                                                                                        	Deviation Number # 4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num5
                                                                                                                        
                                                                                                                        	Deviation Number # 5
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num6
                                                                                                                        
                                                                                                                        	Deviation Number # 6
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: dev_num7
                                                                                                                        
                                                                                                                        	Deviation Number # 7
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eci
                                                                                                                        
                                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: eeprom_size
                                                                                                                        
                                                                                                                        	EEPROM Size
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: engineer_use
                                                                                                                        
                                                                                                                        	Engineer Use
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_major_type
                                                                                                                        
                                                                                                                        	FRU Major Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: fru_minor_type
                                                                                                                        
                                                                                                                        	FRU Minor Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hw_version
                                                                                                                        
                                                                                                                        	Hardware Version
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: hwid
                                                                                                                        
                                                                                                                        	Hardware Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: idprom_format_rev
                                                                                                                        
                                                                                                                        	IDPROM Format Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                                        
                                                                                                                        	Mac Address Block Size #1
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                                        
                                                                                                                        	Mac Address Block Size #2
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                                        
                                                                                                                        	Mac Address Block Size #3
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                                        
                                                                                                                        	Mac Address Block Size #4
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: manu_test_data
                                                                                                                        
                                                                                                                        	Manufacturing Test Data
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_bits
                                                                                                                        
                                                                                                                        	MFG Bits
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: mfg_deviation
                                                                                                                        
                                                                                                                        	MFG Deviation
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: oem_string
                                                                                                                        
                                                                                                                        	OEM String
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_number
                                                                                                                        
                                                                                                                        	Part Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: part_revision
                                                                                                                        
                                                                                                                        	Part Revision
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pca_num
                                                                                                                        
                                                                                                                        	PCA number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcavid
                                                                                                                        
                                                                                                                        	PCA revision ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pcb_serial_num
                                                                                                                        
                                                                                                                        	PCB Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: pid
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_consumption
                                                                                                                        
                                                                                                                        	Power Consumption
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: power_supply_type
                                                                                                                        
                                                                                                                        	Power Supply Type
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: product_id
                                                                                                                        
                                                                                                                        	Product ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: rma
                                                                                                                        
                                                                                                                        	RMA Data
                                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                        
                                                                                                                        .. attribute:: rma_code
                                                                                                                        
                                                                                                                        	RMA Code
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: serial_number
                                                                                                                        
                                                                                                                        	Serial Number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: snmpoid
                                                                                                                        
                                                                                                                        	SNMP OID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_part_num
                                                                                                                        
                                                                                                                        	Top assembly part number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: top_assem_vid
                                                                                                                        
                                                                                                                        	Top assembly revision number
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_description
                                                                                                                        
                                                                                                                        	UDI description
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: udi_name
                                                                                                                        
                                                                                                                        	UDI name
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        .. attribute:: vid
                                                                                                                        
                                                                                                                        	Version ID
                                                                                                                        	**type**\:  str
                                                                                                                        
                                                                                                                        	**length:** 0..255
                                                                                                                        
                                                                                                                        

                                                                                                                        """

                                                                                                                        _prefix = 'invmgr-oper'
                                                                                                                        _revision = '2015-11-09'

                                                                                                                        def __init__(self):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                            self.yang_name = "eeprom"
                                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                            self._children_yang_names.add("rma")

                                                                                                                        def __setattr__(self, name, value):
                                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                                            with _handle_type_error():
                                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                        "Please use list append or extend method."
                                                                                                                                                        .format(value))
                                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                                    value = value.name
                                                                                                                                if name in ("asset_alias",
                                                                                                                                            "asset_id",
                                                                                                                                            "base_mac_address1",
                                                                                                                                            "base_mac_address2",
                                                                                                                                            "base_mac_address3",
                                                                                                                                            "base_mac_address4",
                                                                                                                                            "block_checksum",
                                                                                                                                            "block_count",
                                                                                                                                            "block_length",
                                                                                                                                            "block_signature",
                                                                                                                                            "block_version",
                                                                                                                                            "chassis_sid",
                                                                                                                                            "clei",
                                                                                                                                            "controller_family",
                                                                                                                                            "controller_type",
                                                                                                                                            "description",
                                                                                                                                            "dev_num1",
                                                                                                                                            "dev_num2",
                                                                                                                                            "dev_num3",
                                                                                                                                            "dev_num4",
                                                                                                                                            "dev_num5",
                                                                                                                                            "dev_num6",
                                                                                                                                            "dev_num7",
                                                                                                                                            "eci",
                                                                                                                                            "eeprom_size",
                                                                                                                                            "engineer_use",
                                                                                                                                            "fru_major_type",
                                                                                                                                            "fru_minor_type",
                                                                                                                                            "hw_version",
                                                                                                                                            "hwid",
                                                                                                                                            "idprom_format_rev",
                                                                                                                                            "mac_add_blk_size1",
                                                                                                                                            "mac_add_blk_size2",
                                                                                                                                            "mac_add_blk_size3",
                                                                                                                                            "mac_add_blk_size4",
                                                                                                                                            "manu_test_data",
                                                                                                                                            "mfg_bits",
                                                                                                                                            "mfg_deviation",
                                                                                                                                            "oem_string",
                                                                                                                                            "part_number",
                                                                                                                                            "part_revision",
                                                                                                                                            "pca_num",
                                                                                                                                            "pcavid",
                                                                                                                                            "pcb_serial_num",
                                                                                                                                            "pid",
                                                                                                                                            "power_consumption",
                                                                                                                                            "power_supply_type",
                                                                                                                                            "product_id",
                                                                                                                                            "rma_code",
                                                                                                                                            "serial_number",
                                                                                                                                            "snmpoid",
                                                                                                                                            "top_assem_part_num",
                                                                                                                                            "top_assem_vid",
                                                                                                                                            "udi_description",
                                                                                                                                            "udi_name",
                                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                                    else:
                                                                                                                                        self.__dict__[name].set(value)
                                                                                                                                else:
                                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                            value.parent = self
                                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                            value.parent = self
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                        class Rma(Entity):
                                                                                                                            """
                                                                                                                            RMA Data
                                                                                                                            
                                                                                                                            .. attribute:: rma_history
                                                                                                                            
                                                                                                                            	RMA history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: rma_number
                                                                                                                            
                                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            .. attribute:: test_history
                                                                                                                            
                                                                                                                            	Test history
                                                                                                                            	**type**\:  str
                                                                                                                            
                                                                                                                            	**length:** 0..255
                                                                                                                            
                                                                                                                            

                                                                                                                            """

                                                                                                                            _prefix = 'invmgr-oper'
                                                                                                                            _revision = '2015-11-09'

                                                                                                                            def __init__(self):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                                self.yang_name = "rma"
                                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                            def __setattr__(self, name, value):
                                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                                with _handle_type_error():
                                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                            "Please use list append or extend method."
                                                                                                                                                            .format(value))
                                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                                        value = value.name
                                                                                                                                    if name in ("rma_history",
                                                                                                                                                "rma_number",
                                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                        else:
                                                                                                                                            self.__dict__[name].set(value)
                                                                                                                                    else:
                                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                                value.parent = self
                                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                                value.parent = self
                                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                            def has_data(self):
                                                                                                                                return (
                                                                                                                                    self.rma_history.is_set or
                                                                                                                                    self.rma_number.is_set or
                                                                                                                                    self.test_history.is_set)

                                                                                                                            def has_operation(self):
                                                                                                                                return (
                                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                                            def get_segment_path(self):
                                                                                                                                path_buffer = ""
                                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                                return path_buffer

                                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                                path_buffer = ""
                                                                                                                                if (ancestor is None):
                                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                                else:
                                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                                return entity_path

                                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                                if child is not None:
                                                                                                                                    return child

                                                                                                                                return None

                                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                                    return True
                                                                                                                                return False

                                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                                if(value_path == "rma-history"):
                                                                                                                                    self.rma_history = value
                                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "rma-number"):
                                                                                                                                    self.rma_number = value
                                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                                if(value_path == "test-history"):
                                                                                                                                    self.test_history = value
                                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                        def has_data(self):
                                                                                                                            return (
                                                                                                                                self.asset_alias.is_set or
                                                                                                                                self.asset_id.is_set or
                                                                                                                                self.base_mac_address1.is_set or
                                                                                                                                self.base_mac_address2.is_set or
                                                                                                                                self.base_mac_address3.is_set or
                                                                                                                                self.base_mac_address4.is_set or
                                                                                                                                self.block_checksum.is_set or
                                                                                                                                self.block_count.is_set or
                                                                                                                                self.block_length.is_set or
                                                                                                                                self.block_signature.is_set or
                                                                                                                                self.block_version.is_set or
                                                                                                                                self.chassis_sid.is_set or
                                                                                                                                self.clei.is_set or
                                                                                                                                self.controller_family.is_set or
                                                                                                                                self.controller_type.is_set or
                                                                                                                                self.description.is_set or
                                                                                                                                self.dev_num1.is_set or
                                                                                                                                self.dev_num2.is_set or
                                                                                                                                self.dev_num3.is_set or
                                                                                                                                self.dev_num4.is_set or
                                                                                                                                self.dev_num5.is_set or
                                                                                                                                self.dev_num6.is_set or
                                                                                                                                self.dev_num7.is_set or
                                                                                                                                self.eci.is_set or
                                                                                                                                self.eeprom_size.is_set or
                                                                                                                                self.engineer_use.is_set or
                                                                                                                                self.fru_major_type.is_set or
                                                                                                                                self.fru_minor_type.is_set or
                                                                                                                                self.hw_version.is_set or
                                                                                                                                self.hwid.is_set or
                                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                                self.manu_test_data.is_set or
                                                                                                                                self.mfg_bits.is_set or
                                                                                                                                self.mfg_deviation.is_set or
                                                                                                                                self.oem_string.is_set or
                                                                                                                                self.part_number.is_set or
                                                                                                                                self.part_revision.is_set or
                                                                                                                                self.pca_num.is_set or
                                                                                                                                self.pcavid.is_set or
                                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                                self.pid.is_set or
                                                                                                                                self.power_consumption.is_set or
                                                                                                                                self.power_supply_type.is_set or
                                                                                                                                self.product_id.is_set or
                                                                                                                                self.rma_code.is_set or
                                                                                                                                self.serial_number.is_set or
                                                                                                                                self.snmpoid.is_set or
                                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                                self.top_assem_vid.is_set or
                                                                                                                                self.udi_description.is_set or
                                                                                                                                self.udi_name.is_set or
                                                                                                                                self.vid.is_set or
                                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                                        def has_operation(self):
                                                                                                                            return (
                                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                                        def get_segment_path(self):
                                                                                                                            path_buffer = ""
                                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                                            return path_buffer

                                                                                                                        def get_entity_path(self, ancestor):
                                                                                                                            path_buffer = ""
                                                                                                                            if (ancestor is None):
                                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                            else:
                                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                            leaf_name_data = LeafDataList()
                                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                            return entity_path

                                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                            if child is not None:
                                                                                                                                return child

                                                                                                                            if (child_yang_name == "rma"):
                                                                                                                                if (self.rma is None):
                                                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                                    self.rma.parent = self
                                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                                return self.rma

                                                                                                                            return None

                                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                                return True
                                                                                                                            return False

                                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                            if(value_path == "asset-alias"):
                                                                                                                                self.asset_alias = value
                                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "asset-id"):
                                                                                                                                self.asset_id = value
                                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                                self.base_mac_address1 = value
                                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                                self.base_mac_address2 = value
                                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                                self.base_mac_address3 = value
                                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                                self.base_mac_address4 = value
                                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-checksum"):
                                                                                                                                self.block_checksum = value
                                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-count"):
                                                                                                                                self.block_count = value
                                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-length"):
                                                                                                                                self.block_length = value
                                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-signature"):
                                                                                                                                self.block_signature = value
                                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "block-version"):
                                                                                                                                self.block_version = value
                                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                                self.chassis_sid = value
                                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "clei"):
                                                                                                                                self.clei = value
                                                                                                                                self.clei.value_namespace = name_space
                                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-family"):
                                                                                                                                self.controller_family = value
                                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "controller-type"):
                                                                                                                                self.controller_type = value
                                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "description"):
                                                                                                                                self.description = value
                                                                                                                                self.description.value_namespace = name_space
                                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num1"):
                                                                                                                                self.dev_num1 = value
                                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num2"):
                                                                                                                                self.dev_num2 = value
                                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num3"):
                                                                                                                                self.dev_num3 = value
                                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num4"):
                                                                                                                                self.dev_num4 = value
                                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num5"):
                                                                                                                                self.dev_num5 = value
                                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num6"):
                                                                                                                                self.dev_num6 = value
                                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "dev-num7"):
                                                                                                                                self.dev_num7 = value
                                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eci"):
                                                                                                                                self.eci = value
                                                                                                                                self.eci.value_namespace = name_space
                                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                                self.eeprom_size = value
                                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "engineer-use"):
                                                                                                                                self.engineer_use = value
                                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                                self.fru_major_type = value
                                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                                self.fru_minor_type = value
                                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hw-version"):
                                                                                                                                self.hw_version = value
                                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "hwid"):
                                                                                                                                self.hwid = value
                                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                                self.idprom_format_rev = value
                                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                                self.manu_test_data = value
                                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                                self.mfg_bits = value
                                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                                self.mfg_deviation = value
                                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "oem-string"):
                                                                                                                                self.oem_string = value
                                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-number"):
                                                                                                                                self.part_number = value
                                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "part-revision"):
                                                                                                                                self.part_revision = value
                                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pca-num"):
                                                                                                                                self.pca_num = value
                                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcavid"):
                                                                                                                                self.pcavid = value
                                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                                self.pcb_serial_num = value
                                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "pid"):
                                                                                                                                self.pid = value
                                                                                                                                self.pid.value_namespace = name_space
                                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-consumption"):
                                                                                                                                self.power_consumption = value
                                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                                self.power_supply_type = value
                                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "product-id"):
                                                                                                                                self.product_id = value
                                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "rma-code"):
                                                                                                                                self.rma_code = value
                                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "serial-number"):
                                                                                                                                self.serial_number = value
                                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "snmpoid"):
                                                                                                                                self.snmpoid = value
                                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                                self.top_assem_part_num = value
                                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                                self.top_assem_vid = value
                                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-description"):
                                                                                                                                self.udi_description = value
                                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "udi-name"):
                                                                                                                                self.udi_name = value
                                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                            if(value_path == "vid"):
                                                                                                                                self.vid = value
                                                                                                                                self.vid.value_namespace = name_space
                                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.description.is_set or
                                                                                                                            self.has_eeprom.is_set or
                                                                                                                            self.inv_card_type.is_set or
                                                                                                                            self.opaque_data.is_set or
                                                                                                                            self.opaque_data_size.is_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                                            if (self.eeprom is None):
                                                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo.Eeprom()
                                                                                                                                self.eeprom.parent = self
                                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                            return self.eeprom

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "description"):
                                                                                                                            self.description = value
                                                                                                                            self.description.value_namespace = name_space
                                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "has-eeprom"):
                                                                                                                            self.has_eeprom = value
                                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "inv-card-type"):
                                                                                                                            self.inv_card_type = value
                                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data"):
                                                                                                                            self.opaque_data = value
                                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                                            self.opaque_data_size = value
                                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.module_done.is_set or
                                                                                                                        self.node_id.is_set or
                                                                                                                        self.vm_done.is_set or
                                                                                                                        self.vm_node_id.is_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                                        if (self.env_sensor_info is None):
                                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfo()
                                                                                                                            self.env_sensor_info.parent = self
                                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                        return self.env_sensor_info

                                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.EnvSensorInfoXml()
                                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                        return self.env_sensor_info_xml

                                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                                        if (self.fru_info is None):
                                                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.FruInfo()
                                                                                                                            self.fru_info.parent = self
                                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                                        return self.fru_info

                                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                                        if (self.inv_asset_bag is None):
                                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvAssetBag()
                                                                                                                            self.inv_asset_bag.parent = self
                                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                        return self.inv_asset_bag

                                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                                        if (self.inv_basic_bag is None):
                                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvBasicBag()
                                                                                                                            self.inv_basic_bag.parent = self
                                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                        return self.inv_basic_bag

                                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.InvEepromInfo()
                                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                        return self.inv_eeprom_info

                                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                                        if (self.pwg_info is None):
                                                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.PwgInfo()
                                                                                                                            self.pwg_info.parent = self
                                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                        return self.pwg_info

                                                                                                                    if (child_yang_name == "threshold"):
                                                                                                                        if (self.threshold is None):
                                                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes.Threshold()
                                                                                                                            self.threshold.parent = self
                                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                                        return self.threshold

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "module-done"):
                                                                                                                        self.module_done = value
                                                                                                                        self.module_done.value_namespace = name_space
                                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "node-id"):
                                                                                                                        self.node_id = value
                                                                                                                        self.node_id.value_namespace = name_space
                                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-done"):
                                                                                                                        self.vm_done = value
                                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vm-node-id"):
                                                                                                                        self.vm_node_id = value
                                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.name.is_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    (self.attributes is not None and self.attributes.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "tsi11" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "attributes"):
                                                                                                                    if (self.attributes is None):
                                                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11.Attributes()
                                                                                                                        self.attributes.parent = self
                                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                                    return self.attributes

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "attributes" or name == "name"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.tsi11:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "tsi11s" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "tsi11"):
                                                                                                                for c in self.tsi11:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S.Tsi11()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.tsi11.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "tsi11"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class Attributes(Entity):
                                                                                                        """
                                                                                                        Attributes
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info
                                                                                                        
                                                                                                        	Environment sensor info
                                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo>`
                                                                                                        
                                                                                                        .. attribute:: env_sensor_info_xml
                                                                                                        
                                                                                                        	Environment sensor info XML
                                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml>`
                                                                                                        
                                                                                                        .. attribute:: fru_info
                                                                                                        
                                                                                                        	Inventory EDM FRU info
                                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo>`
                                                                                                        
                                                                                                        .. attribute:: inv_asset_bag
                                                                                                        
                                                                                                        	Inventory Asset Bag
                                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_basic_bag
                                                                                                        
                                                                                                        	Inventory Basic Bag
                                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag>`
                                                                                                        
                                                                                                        .. attribute:: inv_eeprom_info
                                                                                                        
                                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo>`
                                                                                                        
                                                                                                        .. attribute:: module_done
                                                                                                        
                                                                                                        	Inventory EDM Module Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**default value**\: 1
                                                                                                        
                                                                                                        .. attribute:: node_id
                                                                                                        
                                                                                                        	Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: pwg_info
                                                                                                        
                                                                                                        	Inventory EDM PWG info
                                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo>`
                                                                                                        
                                                                                                        .. attribute:: threshold
                                                                                                        
                                                                                                        	Threshold
                                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold>`
                                                                                                        
                                                                                                        .. attribute:: vm_done
                                                                                                        
                                                                                                        	VM Done Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        .. attribute:: vm_node_id
                                                                                                        
                                                                                                        	VM Node ID Tuple
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__init__()

                                                                                                            self.yang_name = "attributes"
                                                                                                            self.yang_parent_name = "tsi10"

                                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                            self._children_yang_names.add("fru-info")

                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                            self._children_yang_names.add("pwg-info")

                                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                            self._children_yang_names.add("threshold")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("module_done",
                                                                                                                            "node_id",
                                                                                                                            "vm_done",
                                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes, self).__setattr__(name, value)


                                                                                                        class EnvSensorInfo(Entity):
                                                                                                            """
                                                                                                            Environment sensor info
                                                                                                            
                                                                                                            .. attribute:: age_time_stamp
                                                                                                            
                                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: alarm_type
                                                                                                            
                                                                                                            	Indicates threshold violation
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: device_description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: device_id
                                                                                                            
                                                                                                            	Identifier for this device
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: field_validity_bitmap
                                                                                                            
                                                                                                            	Sensor valid bitmap
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: precision
                                                                                                            
                                                                                                            	Sensor precision range
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: scale
                                                                                                            
                                                                                                            	Sensor scale enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state enums
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("age_time_stamp",
                                                                                                                                "alarm_type",
                                                                                                                                "data_type",
                                                                                                                                "device_description",
                                                                                                                                "device_id",
                                                                                                                                "field_validity_bitmap",
                                                                                                                                "precision",
                                                                                                                                "scale",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.age_time_stamp.is_set or
                                                                                                                    self.alarm_type.is_set or
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.device_description.is_set or
                                                                                                                    self.device_id.is_set or
                                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                                    self.precision.is_set or
                                                                                                                    self.scale.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "age-time-stamp"):
                                                                                                                    self.age_time_stamp = value
                                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "alarm-type"):
                                                                                                                    self.alarm_type = value
                                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-description"):
                                                                                                                    self.device_description = value
                                                                                                                    self.device_description.value_namespace = name_space
                                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "device-id"):
                                                                                                                    self.device_id = value
                                                                                                                    self.device_id.value_namespace = name_space
                                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                                    self.field_validity_bitmap = value
                                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "precision"):
                                                                                                                    self.precision = value
                                                                                                                    self.precision.value_namespace = name_space
                                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "scale"):
                                                                                                                    self.scale = value
                                                                                                                    self.scale.value_namespace = name_space
                                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class PwgInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM PWG info
                                                                                                            
                                                                                                            .. attribute:: power_group_available_current
                                                                                                            
                                                                                                            	available current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_drawn_current
                                                                                                            
                                                                                                            	drawn current
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_group_power_units
                                                                                                            
                                                                                                            	power units
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                                            
                                                                                                            	redundancy mode
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__init__()

                                                                                                                self.yang_name = "pwg-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("power_group_available_current",
                                                                                                                                "power_group_drawn_current",
                                                                                                                                "power_group_power_units",
                                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.power_group_available_current.is_set or
                                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                                    self.power_group_power_units.is_set or
                                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "power-group-available-current"):
                                                                                                                    self.power_group_available_current = value
                                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                                    self.power_group_drawn_current = value
                                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-power-units"):
                                                                                                                    self.power_group_power_units = value
                                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                                    self.power_group_redundancy_mode = value
                                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                        class EnvSensorInfoXml(Entity):
                                                                                                            """
                                                                                                            Environment sensor info XML
                                                                                                            
                                                                                                            .. attribute:: data_type
                                                                                                            
                                                                                                            	Sensor data type
                                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	Device Name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: status
                                                                                                            
                                                                                                            	Sensor operation state
                                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                            
                                                                                                            .. attribute:: threshold
                                                                                                            
                                                                                                            	Threshold information
                                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                            
                                                                                                            .. attribute:: units
                                                                                                            
                                                                                                            	Units of variable being read
                                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                            
                                                                                                            .. attribute:: update_rate
                                                                                                            
                                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: value
                                                                                                            
                                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                                self._children_yang_names.add("threshold")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("data_type",
                                                                                                                                "description",
                                                                                                                                "status",
                                                                                                                                "units",
                                                                                                                                "update_rate",
                                                                                                                                "value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                            class Threshold(Entity):
                                                                                                                """
                                                                                                                Threshold information
                                                                                                                
                                                                                                                .. attribute:: threshold_array
                                                                                                                
                                                                                                                	Array of threshold
                                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                                    self.yang_name = "threshold"
                                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                                    self.threshold_array = YList(self)

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in () and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                                class ThresholdArray(Entity):
                                                                                                                    """
                                                                                                                    Array of threshold
                                                                                                                    
                                                                                                                    .. attribute:: threshold_name
                                                                                                                    
                                                                                                                    	Threshold name
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..50
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                        self.yang_name = "threshold-array"
                                                                                                                        self.yang_parent_name = "threshold"

                                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_name",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_name.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-name"):
                                                                                                                            self.threshold_name = value
                                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_data()):
                                                                                                                            return True
                                                                                                                    return False

                                                                                                                def has_operation(self):
                                                                                                                    for c in self.threshold_array:
                                                                                                                        if (c.has_operation()):
                                                                                                                            return True
                                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                                        for c in self.threshold_array:
                                                                                                                            segment = c.get_segment_path()
                                                                                                                            if (segment_path == segment):
                                                                                                                                return c
                                                                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                        c.parent = self
                                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                                        self.threshold_array.append(c)
                                                                                                                        return c

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "threshold-array"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.data_type.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.status.is_set or
                                                                                                                    self.units.is_set or
                                                                                                                    self.update_rate.is_set or
                                                                                                                    self.value.is_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "threshold"):
                                                                                                                    if (self.threshold is None):
                                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                        self.threshold.parent = self
                                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                                    return self.threshold

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "data-type"):
                                                                                                                    self.data_type = value
                                                                                                                    self.data_type.value_namespace = name_space
                                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "status"):
                                                                                                                    self.status = value
                                                                                                                    self.status.value_namespace = name_space
                                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "units"):
                                                                                                                    self.units = value
                                                                                                                    self.units.value_namespace = name_space
                                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "update-rate"):
                                                                                                                    self.update_rate = value
                                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "value"):
                                                                                                                    self.value = value
                                                                                                                    self.value.value_namespace = name_space
                                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                                        class InvAssetBag(Entity):
                                                                                                            """
                                                                                                            Inventory Asset Bag
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                                            
                                                                                                            	Manufacture Assembly number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                                            
                                                                                                            	Manufacture assembly revision
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                            
                                                                                                            	Common Language Equipment           Identifier number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                                            
                                                                                                            	String containing OEM information           if applicable
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: part_number
                                                                                                            
                                                                                                            	
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__init__()

                                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                                "manufacturer_assembly_revision",
                                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                                "manufacturer_software_identifier",
                                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                                "part_number") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                                    self.part_number.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                                    self.manufacturer_assembly_number = value
                                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                                    self.manufacturer_software_identifier = value
                                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "part-number"):
                                                                                                                    self.part_number = value
                                                                                                                    self.part_number.value_namespace = name_space
                                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                        class Threshold(Entity):
                                                                                                            """
                                                                                                            Threshold
                                                                                                            
                                                                                                            .. attribute:: critical_hi
                                                                                                            
                                                                                                            	Critical High
                                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi>`
                                                                                                            
                                                                                                            .. attribute:: critical_lo
                                                                                                            
                                                                                                            	Critical Low
                                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo>`
                                                                                                            
                                                                                                            .. attribute:: major_hi
                                                                                                            
                                                                                                            	Major High
                                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi>`
                                                                                                            
                                                                                                            .. attribute:: major_lo
                                                                                                            
                                                                                                            	Major Low
                                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo>`
                                                                                                            
                                                                                                            .. attribute:: minor_hi
                                                                                                            
                                                                                                            	Minor High
                                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi>`
                                                                                                            
                                                                                                            .. attribute:: minor_lo
                                                                                                            
                                                                                                            	Minor Low
                                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo>`
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold, self).__init__()

                                                                                                                self.yang_name = "threshold"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                                self._children_yang_names.add("major-hi")

                                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                                self._children_yang_names.add("major-lo")

                                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                self._children_yang_names.add("minor-lo")


                                                                                                            class MajorLo(Entity):
                                                                                                                """
                                                                                                                Major Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                                    self.yang_name = "major-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalHi(Entity):
                                                                                                                """
                                                                                                                Critical High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                                    self.yang_name = "critical-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorHi(Entity):
                                                                                                                """
                                                                                                                Minor High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                                    self.yang_name = "minor-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MajorHi(Entity):
                                                                                                                """
                                                                                                                Major High
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                                    self.yang_name = "major-hi"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class CriticalLo(Entity):
                                                                                                                """
                                                                                                                Critical Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                                    self.yang_name = "critical-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass


                                                                                                            class MinorLo(Entity):
                                                                                                                """
                                                                                                                Minor Low
                                                                                                                
                                                                                                                .. attribute:: thresh_bag
                                                                                                                
                                                                                                                	Environment threshold info
                                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                                    self.yang_name = "minor-lo"
                                                                                                                    self.yang_parent_name = "threshold"

                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                                class ThreshBag(Entity):
                                                                                                                    """
                                                                                                                    Environment threshold info
                                                                                                                    
                                                                                                                    .. attribute:: threshold_evaluation
                                                                                                                    
                                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                                    
                                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                                    	**type**\:  bool
                                                                                                                    
                                                                                                                    .. attribute:: threshold_relation
                                                                                                                    
                                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_severity
                                                                                                                    
                                                                                                                    	Indicates minor, major, critical severities
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    .. attribute:: threshold_value
                                                                                                                    
                                                                                                                    	Value of the configured threshold
                                                                                                                    	**type**\:  int
                                                                                                                    
                                                                                                                    	**range:** 0..4294967295
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                        self.yang_name = "thresh-bag"
                                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("threshold_evaluation",
                                                                                                                                        "threshold_notification_enabled",
                                                                                                                                        "threshold_relation",
                                                                                                                                        "threshold_severity",
                                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.threshold_evaluation.is_set or
                                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                                            self.threshold_relation.is_set or
                                                                                                                            self.threshold_severity.is_set or
                                                                                                                            self.threshold_value.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                                            self.threshold_evaluation = value
                                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                                            self.threshold_notification_enabled = value
                                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-relation"):
                                                                                                                            self.threshold_relation = value
                                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-severity"):
                                                                                                                            self.threshold_severity = value
                                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "threshold-value"):
                                                                                                                            self.threshold_value = value
                                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                                        if (self.thresh_bag is None):
                                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                            self.thresh_bag.parent = self
                                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                        return self.thresh_bag

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "thresh-bag"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    pass

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                                    if (self.critical_hi is None):
                                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalHi()
                                                                                                                        self.critical_hi.parent = self
                                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                                    return self.critical_hi

                                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                                    if (self.critical_lo is None):
                                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.CriticalLo()
                                                                                                                        self.critical_lo.parent = self
                                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                                    return self.critical_lo

                                                                                                                if (child_yang_name == "major-hi"):
                                                                                                                    if (self.major_hi is None):
                                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorHi()
                                                                                                                        self.major_hi.parent = self
                                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                                    return self.major_hi

                                                                                                                if (child_yang_name == "major-lo"):
                                                                                                                    if (self.major_lo is None):
                                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MajorLo()
                                                                                                                        self.major_lo.parent = self
                                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                                    return self.major_lo

                                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                                    if (self.minor_hi is None):
                                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorHi()
                                                                                                                        self.minor_hi.parent = self
                                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                                    return self.minor_hi

                                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                                    if (self.minor_lo is None):
                                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold.MinorLo()
                                                                                                                        self.minor_lo.parent = self
                                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                                    return self.minor_lo

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                pass


                                                                                                        class FruInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM FRU info
                                                                                                            
                                                                                                            .. attribute:: card_administrative_state
                                                                                                            
                                                                                                            	card admin state\: shutdown or not
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_monitor_state
                                                                                                            
                                                                                                            	card is monitored by a manager or left unmonitored
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_operational_state
                                                                                                            
                                                                                                            	card operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: card_reset_reason
                                                                                                            
                                                                                                            	card reset reason enum
                                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                            
                                                                                                            .. attribute:: card_up_time
                                                                                                            
                                                                                                            	card up time
                                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime>`
                                                                                                            
                                                                                                            .. attribute:: last_operational_state_change
                                                                                                            
                                                                                                            	last card oper change state
                                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                            
                                                                                                            .. attribute:: power_administrative_state
                                                                                                            
                                                                                                            	power admin state\: up or down
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_current_measurement
                                                                                                            
                                                                                                            	power current\: not implemented
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: power_operational_state
                                                                                                            
                                                                                                            	Power operation state
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__init__()

                                                                                                                self.yang_name = "fru-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("card_administrative_state",
                                                                                                                                "card_monitor_state",
                                                                                                                                "card_operational_state",
                                                                                                                                "card_reset_reason",
                                                                                                                                "power_administrative_state",
                                                                                                                                "power_current_measurement",
                                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                            class LastOperationalStateChange(Entity):
                                                                                                                """
                                                                                                                last card oper change state
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                            class CardUpTime(Entity):
                                                                                                                """
                                                                                                                card up time
                                                                                                                
                                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                                
                                                                                                                	Time Value in Nano\-seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: nanosecond
                                                                                                                
                                                                                                                .. attribute:: time_in_seconds
                                                                                                                
                                                                                                                	Time Value in Seconds
                                                                                                                	**type**\:  int
                                                                                                                
                                                                                                                	**range:** \-2147483648..2147483647
                                                                                                                
                                                                                                                	**units**\: second
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                                    self.yang_name = "card-up-time"
                                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                                        self.time_in_seconds.is_set)

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                                        self.time_in_nano_seconds = value
                                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                                        self.time_in_seconds = value
                                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.card_administrative_state.is_set or
                                                                                                                    self.card_monitor_state.is_set or
                                                                                                                    self.card_operational_state.is_set or
                                                                                                                    self.card_reset_reason.is_set or
                                                                                                                    self.power_administrative_state.is_set or
                                                                                                                    self.power_current_measurement.is_set or
                                                                                                                    self.power_operational_state.is_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                                    if (self.card_up_time is None):
                                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.CardUpTime()
                                                                                                                        self.card_up_time.parent = self
                                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                                    return self.card_up_time

                                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                                    if (self.last_operational_state_change is None):
                                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                        self.last_operational_state_change.parent = self
                                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                                    return self.last_operational_state_change

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "card-administrative-state"):
                                                                                                                    self.card_administrative_state = value
                                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-monitor-state"):
                                                                                                                    self.card_monitor_state = value
                                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-operational-state"):
                                                                                                                    self.card_operational_state = value
                                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "card-reset-reason"):
                                                                                                                    self.card_reset_reason = value
                                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-administrative-state"):
                                                                                                                    self.power_administrative_state = value
                                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-current-measurement"):
                                                                                                                    self.power_current_measurement = value
                                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "power-operational-state"):
                                                                                                                    self.power_operational_state = value
                                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                        class InvBasicBag(Entity):
                                                                                                            """
                                                                                                            Inventory Basic Bag
                                                                                                            
                                                                                                            .. attribute:: alias
                                                                                                            
                                                                                                            	useful for storing an entity alias 
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_id_str
                                                                                                            
                                                                                                            	asset Identification string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: asset_identification
                                                                                                            
                                                                                                            	asset Identification
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: ceport
                                                                                                            
                                                                                                            	1 if ce port found, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: chip_hardware_revision
                                                                                                            
                                                                                                            	chip module hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: composite_class_code
                                                                                                            
                                                                                                            	Major&minor class of the entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: environmental_monitor_path
                                                                                                            
                                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: firmware_revision
                                                                                                            
                                                                                                            	firmware revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: group_flag
                                                                                                            
                                                                                                            	indicates if this entity is group       or not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: hardware_revision
                                                                                                            
                                                                                                            	hw revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                                            
                                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                                            
                                                                                                            	Manufacture Asset Tags
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: manufacturer_name
                                                                                                            
                                                                                                            	manufacturer's name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: memory_size
                                                                                                            
                                                                                                            	Size of memory associated with       the entity where applicable
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: model_name
                                                                                                            
                                                                                                            	model name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: name
                                                                                                            
                                                                                                            	name string for the entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: new_deviation_number
                                                                                                            
                                                                                                            	integer value for New Deviation Number 0x88
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                                            
                                                                                                            	integer value for plim type if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: redundancystate
                                                                                                            
                                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: serial_number
                                                                                                            
                                                                                                            	serial number
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: software_revision
                                                                                                            
                                                                                                            	software revision string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: unique_id
                                                                                                            
                                                                                                            	Unique id for an entity
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            .. attribute:: unrecognized_fru
                                                                                                            
                                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: vendor_type
                                                                                                            
                                                                                                            	maps to the vendor OID string
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: xr_scoped
                                                                                                            
                                                                                                            	1 if xr scoped, 0 if not
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__init__()

                                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("alias",
                                                                                                                                "asset_id_str",
                                                                                                                                "asset_identification",
                                                                                                                                "ceport",
                                                                                                                                "chip_hardware_revision",
                                                                                                                                "composite_class_code",
                                                                                                                                "description",
                                                                                                                                "environmental_monitor_path",
                                                                                                                                "firmware_revision",
                                                                                                                                "group_flag",
                                                                                                                                "hardware_revision",
                                                                                                                                "is_field_replaceable_unit",
                                                                                                                                "manufacturer_asset_tags",
                                                                                                                                "manufacturer_name",
                                                                                                                                "memory_size",
                                                                                                                                "model_name",
                                                                                                                                "name",
                                                                                                                                "new_deviation_number",
                                                                                                                                "physical_layer_interface_module_type",
                                                                                                                                "redundancystate",
                                                                                                                                "serial_number",
                                                                                                                                "software_revision",
                                                                                                                                "unique_id",
                                                                                                                                "unrecognized_fru",
                                                                                                                                "vendor_type",
                                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.alias.is_set or
                                                                                                                    self.asset_id_str.is_set or
                                                                                                                    self.asset_identification.is_set or
                                                                                                                    self.ceport.is_set or
                                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                                    self.composite_class_code.is_set or
                                                                                                                    self.description.is_set or
                                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                                    self.firmware_revision.is_set or
                                                                                                                    self.group_flag.is_set or
                                                                                                                    self.hardware_revision.is_set or
                                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                                    self.manufacturer_name.is_set or
                                                                                                                    self.memory_size.is_set or
                                                                                                                    self.model_name.is_set or
                                                                                                                    self.name.is_set or
                                                                                                                    self.new_deviation_number.is_set or
                                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                                    self.redundancystate.is_set or
                                                                                                                    self.serial_number.is_set or
                                                                                                                    self.software_revision.is_set or
                                                                                                                    self.unique_id.is_set or
                                                                                                                    self.unrecognized_fru.is_set or
                                                                                                                    self.vendor_type.is_set or
                                                                                                                    self.xr_scoped.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "alias"):
                                                                                                                    self.alias = value
                                                                                                                    self.alias.value_namespace = name_space
                                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-id-str"):
                                                                                                                    self.asset_id_str = value
                                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "asset-identification"):
                                                                                                                    self.asset_identification = value
                                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "ceport"):
                                                                                                                    self.ceport = value
                                                                                                                    self.ceport.value_namespace = name_space
                                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                                    self.chip_hardware_revision = value
                                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "composite-class-code"):
                                                                                                                    self.composite_class_code = value
                                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                                    self.environmental_monitor_path = value
                                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "firmware-revision"):
                                                                                                                    self.firmware_revision = value
                                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "group-flag"):
                                                                                                                    self.group_flag = value
                                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "hardware-revision"):
                                                                                                                    self.hardware_revision = value
                                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                                    self.is_field_replaceable_unit = value
                                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                                    self.manufacturer_asset_tags = value
                                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "manufacturer-name"):
                                                                                                                    self.manufacturer_name = value
                                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "memory-size"):
                                                                                                                    self.memory_size = value
                                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "model-name"):
                                                                                                                    self.model_name = value
                                                                                                                    self.model_name.value_namespace = name_space
                                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "name"):
                                                                                                                    self.name = value
                                                                                                                    self.name.value_namespace = name_space
                                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "new-deviation-number"):
                                                                                                                    self.new_deviation_number = value
                                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "redundancystate"):
                                                                                                                    self.redundancystate = value
                                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "serial-number"):
                                                                                                                    self.serial_number = value
                                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "software-revision"):
                                                                                                                    self.software_revision = value
                                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unique-id"):
                                                                                                                    self.unique_id = value
                                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                                    self.unrecognized_fru = value
                                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "vendor-type"):
                                                                                                                    self.vendor_type = value
                                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "xr-scoped"):
                                                                                                                    self.xr_scoped = value
                                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                        class InvEepromInfo(Entity):
                                                                                                            """
                                                                                                            Inventory EDM EEPROM Information Bag
                                                                                                            
                                                                                                            .. attribute:: description
                                                                                                            
                                                                                                            	A textual description of physical entity
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: eeprom
                                                                                                            
                                                                                                            	EEPROM data not from hex data
                                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom>`
                                                                                                            
                                                                                                            .. attribute:: has_eeprom
                                                                                                            
                                                                                                            	use eeprom instead of opaque data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: inv_card_type
                                                                                                            
                                                                                                            	Inventory card type
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..255
                                                                                                            
                                                                                                            .. attribute:: opaque_data
                                                                                                            
                                                                                                            	EEPROM hex data
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                            
                                                                                                            .. attribute:: opaque_data_size
                                                                                                            
                                                                                                            	size of the EEPROM hex data
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__init__()

                                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                                self.yang_parent_name = "attributes"

                                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                                self._children_yang_names.add("eeprom")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("description",
                                                                                                                                "has_eeprom",
                                                                                                                                "inv_card_type",
                                                                                                                                "opaque_data",
                                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                            class Eeprom(Entity):
                                                                                                                """
                                                                                                                EEPROM data not from hex data
                                                                                                                
                                                                                                                .. attribute:: asset_alias
                                                                                                                
                                                                                                                	Asset Alias
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: asset_id
                                                                                                                
                                                                                                                	Asset ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address1
                                                                                                                
                                                                                                                	Base Mac Address #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address2
                                                                                                                
                                                                                                                	Base Mac Address #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address3
                                                                                                                
                                                                                                                	Base Mac Address #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: base_mac_address4
                                                                                                                
                                                                                                                	Base Mac Address #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_checksum
                                                                                                                
                                                                                                                	Block Checksum
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_count
                                                                                                                
                                                                                                                	Block Count
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_length
                                                                                                                
                                                                                                                	Block Length
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_signature
                                                                                                                
                                                                                                                	Block Signature
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: block_version
                                                                                                                
                                                                                                                	Block Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: chassis_sid
                                                                                                                
                                                                                                                	Chassis serial number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: clei
                                                                                                                
                                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_family
                                                                                                                
                                                                                                                	Controller family
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: controller_type
                                                                                                                
                                                                                                                	Controller type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: description
                                                                                                                
                                                                                                                	A textual description of physical entity
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num1
                                                                                                                
                                                                                                                	Deviation Number # 1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num2
                                                                                                                
                                                                                                                	Deviation Number # 2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num3
                                                                                                                
                                                                                                                	Deviation Number # 3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num4
                                                                                                                
                                                                                                                	Deviation Number # 4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num5
                                                                                                                
                                                                                                                	Deviation Number # 5
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num6
                                                                                                                
                                                                                                                	Deviation Number # 6
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: dev_num7
                                                                                                                
                                                                                                                	Deviation Number # 7
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eci
                                                                                                                
                                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: eeprom_size
                                                                                                                
                                                                                                                	EEPROM Size
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: engineer_use
                                                                                                                
                                                                                                                	Engineer Use
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_major_type
                                                                                                                
                                                                                                                	FRU Major Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: fru_minor_type
                                                                                                                
                                                                                                                	FRU Minor Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hw_version
                                                                                                                
                                                                                                                	Hardware Version
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: hwid
                                                                                                                
                                                                                                                	Hardware Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: idprom_format_rev
                                                                                                                
                                                                                                                	IDPROM Format Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                                
                                                                                                                	Mac Address Block Size #1
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                                
                                                                                                                	Mac Address Block Size #2
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                                
                                                                                                                	Mac Address Block Size #3
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                                
                                                                                                                	Mac Address Block Size #4
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: manu_test_data
                                                                                                                
                                                                                                                	Manufacturing Test Data
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_bits
                                                                                                                
                                                                                                                	MFG Bits
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: mfg_deviation
                                                                                                                
                                                                                                                	MFG Deviation
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: oem_string
                                                                                                                
                                                                                                                	OEM String
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_number
                                                                                                                
                                                                                                                	Part Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: part_revision
                                                                                                                
                                                                                                                	Part Revision
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pca_num
                                                                                                                
                                                                                                                	PCA number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcavid
                                                                                                                
                                                                                                                	PCA revision ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pcb_serial_num
                                                                                                                
                                                                                                                	PCB Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: pid
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_consumption
                                                                                                                
                                                                                                                	Power Consumption
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: power_supply_type
                                                                                                                
                                                                                                                	Power Supply Type
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: product_id
                                                                                                                
                                                                                                                	Product ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: rma
                                                                                                                
                                                                                                                	RMA Data
                                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                                
                                                                                                                .. attribute:: rma_code
                                                                                                                
                                                                                                                	RMA Code
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: serial_number
                                                                                                                
                                                                                                                	Serial Number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: snmpoid
                                                                                                                
                                                                                                                	SNMP OID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_part_num
                                                                                                                
                                                                                                                	Top assembly part number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: top_assem_vid
                                                                                                                
                                                                                                                	Top assembly revision number
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_description
                                                                                                                
                                                                                                                	UDI description
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: udi_name
                                                                                                                
                                                                                                                	UDI name
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                .. attribute:: vid
                                                                                                                
                                                                                                                	Version ID
                                                                                                                	**type**\:  str
                                                                                                                
                                                                                                                	**length:** 0..255
                                                                                                                
                                                                                                                

                                                                                                                """

                                                                                                                _prefix = 'invmgr-oper'
                                                                                                                _revision = '2015-11-09'

                                                                                                                def __init__(self):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                                    self.yang_name = "eeprom"
                                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                    self._children_yang_names.add("rma")

                                                                                                                def __setattr__(self, name, value):
                                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                                    with _handle_type_error():
                                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                "Please use list append or extend method."
                                                                                                                                                .format(value))
                                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                                            value = value.name
                                                                                                                        if name in ("asset_alias",
                                                                                                                                    "asset_id",
                                                                                                                                    "base_mac_address1",
                                                                                                                                    "base_mac_address2",
                                                                                                                                    "base_mac_address3",
                                                                                                                                    "base_mac_address4",
                                                                                                                                    "block_checksum",
                                                                                                                                    "block_count",
                                                                                                                                    "block_length",
                                                                                                                                    "block_signature",
                                                                                                                                    "block_version",
                                                                                                                                    "chassis_sid",
                                                                                                                                    "clei",
                                                                                                                                    "controller_family",
                                                                                                                                    "controller_type",
                                                                                                                                    "description",
                                                                                                                                    "dev_num1",
                                                                                                                                    "dev_num2",
                                                                                                                                    "dev_num3",
                                                                                                                                    "dev_num4",
                                                                                                                                    "dev_num5",
                                                                                                                                    "dev_num6",
                                                                                                                                    "dev_num7",
                                                                                                                                    "eci",
                                                                                                                                    "eeprom_size",
                                                                                                                                    "engineer_use",
                                                                                                                                    "fru_major_type",
                                                                                                                                    "fru_minor_type",
                                                                                                                                    "hw_version",
                                                                                                                                    "hwid",
                                                                                                                                    "idprom_format_rev",
                                                                                                                                    "mac_add_blk_size1",
                                                                                                                                    "mac_add_blk_size2",
                                                                                                                                    "mac_add_blk_size3",
                                                                                                                                    "mac_add_blk_size4",
                                                                                                                                    "manu_test_data",
                                                                                                                                    "mfg_bits",
                                                                                                                                    "mfg_deviation",
                                                                                                                                    "oem_string",
                                                                                                                                    "part_number",
                                                                                                                                    "part_revision",
                                                                                                                                    "pca_num",
                                                                                                                                    "pcavid",
                                                                                                                                    "pcb_serial_num",
                                                                                                                                    "pid",
                                                                                                                                    "power_consumption",
                                                                                                                                    "power_supply_type",
                                                                                                                                    "product_id",
                                                                                                                                    "rma_code",
                                                                                                                                    "serial_number",
                                                                                                                                    "snmpoid",
                                                                                                                                    "top_assem_part_num",
                                                                                                                                    "top_assem_vid",
                                                                                                                                    "udi_description",
                                                                                                                                    "udi_name",
                                                                                                                                    "vid") and name in self.__dict__:
                                                                                                                            if isinstance(value, YLeaf):
                                                                                                                                self.__dict__[name].set(value.get())
                                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                            else:
                                                                                                                                self.__dict__[name].set(value)
                                                                                                                        else:
                                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                    value.parent = self
                                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                    value.parent = self
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                                class Rma(Entity):
                                                                                                                    """
                                                                                                                    RMA Data
                                                                                                                    
                                                                                                                    .. attribute:: rma_history
                                                                                                                    
                                                                                                                    	RMA history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: rma_number
                                                                                                                    
                                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    .. attribute:: test_history
                                                                                                                    
                                                                                                                    	Test history
                                                                                                                    	**type**\:  str
                                                                                                                    
                                                                                                                    	**length:** 0..255
                                                                                                                    
                                                                                                                    

                                                                                                                    """

                                                                                                                    _prefix = 'invmgr-oper'
                                                                                                                    _revision = '2015-11-09'

                                                                                                                    def __init__(self):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                        self.yang_name = "rma"
                                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                                    def __setattr__(self, name, value):
                                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                                        with _handle_type_error():
                                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                                    "Please use list append or extend method."
                                                                                                                                                    .format(value))
                                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                                value = value.name
                                                                                                                            if name in ("rma_history",
                                                                                                                                        "rma_number",
                                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                                if isinstance(value, YLeaf):
                                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                                else:
                                                                                                                                    self.__dict__[name].set(value)
                                                                                                                            else:
                                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                        value.parent = self
                                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                        value.parent = self
                                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                                    def has_data(self):
                                                                                                                        return (
                                                                                                                            self.rma_history.is_set or
                                                                                                                            self.rma_number.is_set or
                                                                                                                            self.test_history.is_set)

                                                                                                                    def has_operation(self):
                                                                                                                        return (
                                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                                    def get_segment_path(self):
                                                                                                                        path_buffer = ""
                                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                                        return path_buffer

                                                                                                                    def get_entity_path(self, ancestor):
                                                                                                                        path_buffer = ""
                                                                                                                        if (ancestor is None):
                                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                        else:
                                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                        leaf_name_data = LeafDataList()
                                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                        return entity_path

                                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                        if child is not None:
                                                                                                                            return child

                                                                                                                        return None

                                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                            return True
                                                                                                                        return False

                                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                        if(value_path == "rma-history"):
                                                                                                                            self.rma_history = value
                                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "rma-number"):
                                                                                                                            self.rma_number = value
                                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                        if(value_path == "test-history"):
                                                                                                                            self.test_history = value
                                                                                                                            self.test_history.value_namespace = name_space
                                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                                def has_data(self):
                                                                                                                    return (
                                                                                                                        self.asset_alias.is_set or
                                                                                                                        self.asset_id.is_set or
                                                                                                                        self.base_mac_address1.is_set or
                                                                                                                        self.base_mac_address2.is_set or
                                                                                                                        self.base_mac_address3.is_set or
                                                                                                                        self.base_mac_address4.is_set or
                                                                                                                        self.block_checksum.is_set or
                                                                                                                        self.block_count.is_set or
                                                                                                                        self.block_length.is_set or
                                                                                                                        self.block_signature.is_set or
                                                                                                                        self.block_version.is_set or
                                                                                                                        self.chassis_sid.is_set or
                                                                                                                        self.clei.is_set or
                                                                                                                        self.controller_family.is_set or
                                                                                                                        self.controller_type.is_set or
                                                                                                                        self.description.is_set or
                                                                                                                        self.dev_num1.is_set or
                                                                                                                        self.dev_num2.is_set or
                                                                                                                        self.dev_num3.is_set or
                                                                                                                        self.dev_num4.is_set or
                                                                                                                        self.dev_num5.is_set or
                                                                                                                        self.dev_num6.is_set or
                                                                                                                        self.dev_num7.is_set or
                                                                                                                        self.eci.is_set or
                                                                                                                        self.eeprom_size.is_set or
                                                                                                                        self.engineer_use.is_set or
                                                                                                                        self.fru_major_type.is_set or
                                                                                                                        self.fru_minor_type.is_set or
                                                                                                                        self.hw_version.is_set or
                                                                                                                        self.hwid.is_set or
                                                                                                                        self.idprom_format_rev.is_set or
                                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                                        self.manu_test_data.is_set or
                                                                                                                        self.mfg_bits.is_set or
                                                                                                                        self.mfg_deviation.is_set or
                                                                                                                        self.oem_string.is_set or
                                                                                                                        self.part_number.is_set or
                                                                                                                        self.part_revision.is_set or
                                                                                                                        self.pca_num.is_set or
                                                                                                                        self.pcavid.is_set or
                                                                                                                        self.pcb_serial_num.is_set or
                                                                                                                        self.pid.is_set or
                                                                                                                        self.power_consumption.is_set or
                                                                                                                        self.power_supply_type.is_set or
                                                                                                                        self.product_id.is_set or
                                                                                                                        self.rma_code.is_set or
                                                                                                                        self.serial_number.is_set or
                                                                                                                        self.snmpoid.is_set or
                                                                                                                        self.top_assem_part_num.is_set or
                                                                                                                        self.top_assem_vid.is_set or
                                                                                                                        self.udi_description.is_set or
                                                                                                                        self.udi_name.is_set or
                                                                                                                        self.vid.is_set or
                                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                                def has_operation(self):
                                                                                                                    return (
                                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                                def get_segment_path(self):
                                                                                                                    path_buffer = ""
                                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                                    return path_buffer

                                                                                                                def get_entity_path(self, ancestor):
                                                                                                                    path_buffer = ""
                                                                                                                    if (ancestor is None):
                                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                    else:
                                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                    leaf_name_data = LeafDataList()
                                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                    return entity_path

                                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                    if child is not None:
                                                                                                                        return child

                                                                                                                    if (child_yang_name == "rma"):
                                                                                                                        if (self.rma is None):
                                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                            self.rma.parent = self
                                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                                        return self.rma

                                                                                                                    return None

                                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                        return True
                                                                                                                    return False

                                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                    if(value_path == "asset-alias"):
                                                                                                                        self.asset_alias = value
                                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "asset-id"):
                                                                                                                        self.asset_id = value
                                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                                        self.base_mac_address1 = value
                                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                                        self.base_mac_address2 = value
                                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                                        self.base_mac_address3 = value
                                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                                        self.base_mac_address4 = value
                                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-checksum"):
                                                                                                                        self.block_checksum = value
                                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-count"):
                                                                                                                        self.block_count = value
                                                                                                                        self.block_count.value_namespace = name_space
                                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-length"):
                                                                                                                        self.block_length = value
                                                                                                                        self.block_length.value_namespace = name_space
                                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-signature"):
                                                                                                                        self.block_signature = value
                                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "block-version"):
                                                                                                                        self.block_version = value
                                                                                                                        self.block_version.value_namespace = name_space
                                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "chassis-sid"):
                                                                                                                        self.chassis_sid = value
                                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "clei"):
                                                                                                                        self.clei = value
                                                                                                                        self.clei.value_namespace = name_space
                                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-family"):
                                                                                                                        self.controller_family = value
                                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "controller-type"):
                                                                                                                        self.controller_type = value
                                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "description"):
                                                                                                                        self.description = value
                                                                                                                        self.description.value_namespace = name_space
                                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num1"):
                                                                                                                        self.dev_num1 = value
                                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num2"):
                                                                                                                        self.dev_num2 = value
                                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num3"):
                                                                                                                        self.dev_num3 = value
                                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num4"):
                                                                                                                        self.dev_num4 = value
                                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num5"):
                                                                                                                        self.dev_num5 = value
                                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num6"):
                                                                                                                        self.dev_num6 = value
                                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "dev-num7"):
                                                                                                                        self.dev_num7 = value
                                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eci"):
                                                                                                                        self.eci = value
                                                                                                                        self.eci.value_namespace = name_space
                                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "eeprom-size"):
                                                                                                                        self.eeprom_size = value
                                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "engineer-use"):
                                                                                                                        self.engineer_use = value
                                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-major-type"):
                                                                                                                        self.fru_major_type = value
                                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                                        self.fru_minor_type = value
                                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hw-version"):
                                                                                                                        self.hw_version = value
                                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "hwid"):
                                                                                                                        self.hwid = value
                                                                                                                        self.hwid.value_namespace = name_space
                                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                                        self.idprom_format_rev = value
                                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                                        self.mac_add_blk_size1 = value
                                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                                        self.mac_add_blk_size2 = value
                                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                                        self.mac_add_blk_size3 = value
                                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                                        self.mac_add_blk_size4 = value
                                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "manu-test-data"):
                                                                                                                        self.manu_test_data = value
                                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-bits"):
                                                                                                                        self.mfg_bits = value
                                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                                        self.mfg_deviation = value
                                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "oem-string"):
                                                                                                                        self.oem_string = value
                                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-number"):
                                                                                                                        self.part_number = value
                                                                                                                        self.part_number.value_namespace = name_space
                                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "part-revision"):
                                                                                                                        self.part_revision = value
                                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pca-num"):
                                                                                                                        self.pca_num = value
                                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcavid"):
                                                                                                                        self.pcavid = value
                                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                                        self.pcb_serial_num = value
                                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "pid"):
                                                                                                                        self.pid = value
                                                                                                                        self.pid.value_namespace = name_space
                                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-consumption"):
                                                                                                                        self.power_consumption = value
                                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "power-supply-type"):
                                                                                                                        self.power_supply_type = value
                                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "product-id"):
                                                                                                                        self.product_id = value
                                                                                                                        self.product_id.value_namespace = name_space
                                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "rma-code"):
                                                                                                                        self.rma_code = value
                                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "serial-number"):
                                                                                                                        self.serial_number = value
                                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "snmpoid"):
                                                                                                                        self.snmpoid = value
                                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                                        self.top_assem_part_num = value
                                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                                        self.top_assem_vid = value
                                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-description"):
                                                                                                                        self.udi_description = value
                                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "udi-name"):
                                                                                                                        self.udi_name = value
                                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                                    if(value_path == "vid"):
                                                                                                                        self.vid = value
                                                                                                                        self.vid.value_namespace = name_space
                                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.description.is_set or
                                                                                                                    self.has_eeprom.is_set or
                                                                                                                    self.inv_card_type.is_set or
                                                                                                                    self.opaque_data.is_set or
                                                                                                                    self.opaque_data_size.is_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                if (child_yang_name == "eeprom"):
                                                                                                                    if (self.eeprom is None):
                                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo.Eeprom()
                                                                                                                        self.eeprom.parent = self
                                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                                    return self.eeprom

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "description"):
                                                                                                                    self.description = value
                                                                                                                    self.description.value_namespace = name_space
                                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "has-eeprom"):
                                                                                                                    self.has_eeprom = value
                                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "inv-card-type"):
                                                                                                                    self.inv_card_type = value
                                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data"):
                                                                                                                    self.opaque_data = value
                                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "opaque-data-size"):
                                                                                                                    self.opaque_data_size = value
                                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.module_done.is_set or
                                                                                                                self.node_id.is_set or
                                                                                                                self.vm_done.is_set or
                                                                                                                self.vm_node_id.is_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "attributes" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                                if (self.env_sensor_info is None):
                                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfo()
                                                                                                                    self.env_sensor_info.parent = self
                                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                                return self.env_sensor_info

                                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.EnvSensorInfoXml()
                                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                                return self.env_sensor_info_xml

                                                                                                            if (child_yang_name == "fru-info"):
                                                                                                                if (self.fru_info is None):
                                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.FruInfo()
                                                                                                                    self.fru_info.parent = self
                                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                                return self.fru_info

                                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                                if (self.inv_asset_bag is None):
                                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvAssetBag()
                                                                                                                    self.inv_asset_bag.parent = self
                                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                                return self.inv_asset_bag

                                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                                if (self.inv_basic_bag is None):
                                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvBasicBag()
                                                                                                                    self.inv_basic_bag.parent = self
                                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                                return self.inv_basic_bag

                                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                                if (self.inv_eeprom_info is None):
                                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.InvEepromInfo()
                                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                                return self.inv_eeprom_info

                                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                                if (self.pwg_info is None):
                                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.PwgInfo()
                                                                                                                    self.pwg_info.parent = self
                                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                                return self.pwg_info

                                                                                                            if (child_yang_name == "threshold"):
                                                                                                                if (self.threshold is None):
                                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes.Threshold()
                                                                                                                    self.threshold.parent = self
                                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                                return self.threshold

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "module-done"):
                                                                                                                self.module_done = value
                                                                                                                self.module_done.value_namespace = name_space
                                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "node-id"):
                                                                                                                self.node_id = value
                                                                                                                self.node_id.value_namespace = name_space
                                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-done"):
                                                                                                                self.vm_done = value
                                                                                                                self.vm_done.value_namespace = name_space
                                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vm-node-id"):
                                                                                                                self.vm_node_id = value
                                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.name.is_set or
                                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                            (self.tsi11s is not None and self.tsi11s.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "tsi10" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "attributes"):
                                                                                                            if (self.attributes is None):
                                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Attributes()
                                                                                                                self.attributes.parent = self
                                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                                            return self.attributes

                                                                                                        if (child_yang_name == "tsi11s"):
                                                                                                            if (self.tsi11s is None):
                                                                                                                self.tsi11s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10.Tsi11S()
                                                                                                                self.tsi11s.parent = self
                                                                                                                self._children_name_map["tsi11s"] = "tsi11s"
                                                                                                            return self.tsi11s

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "attributes" or name == "tsi11s" or name == "name"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.tsi10:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "tsi10s" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "tsi10"):
                                                                                                        for c in self.tsi10:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S.Tsi10()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.tsi10.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "tsi10"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class Attributes(Entity):
                                                                                                """
                                                                                                Attributes
                                                                                                
                                                                                                .. attribute:: env_sensor_info
                                                                                                
                                                                                                	Environment sensor info
                                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo>`
                                                                                                
                                                                                                .. attribute:: env_sensor_info_xml
                                                                                                
                                                                                                	Environment sensor info XML
                                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml>`
                                                                                                
                                                                                                .. attribute:: fru_info
                                                                                                
                                                                                                	Inventory EDM FRU info
                                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo>`
                                                                                                
                                                                                                .. attribute:: inv_asset_bag
                                                                                                
                                                                                                	Inventory Asset Bag
                                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag>`
                                                                                                
                                                                                                .. attribute:: inv_basic_bag
                                                                                                
                                                                                                	Inventory Basic Bag
                                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag>`
                                                                                                
                                                                                                .. attribute:: inv_eeprom_info
                                                                                                
                                                                                                	Inventory EDM EEPROM Information Bag
                                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo>`
                                                                                                
                                                                                                .. attribute:: module_done
                                                                                                
                                                                                                	Inventory EDM Module Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**default value**\: 1
                                                                                                
                                                                                                .. attribute:: node_id
                                                                                                
                                                                                                	Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: pwg_info
                                                                                                
                                                                                                	Inventory EDM PWG info
                                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo>`
                                                                                                
                                                                                                .. attribute:: threshold
                                                                                                
                                                                                                	Threshold
                                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold>`
                                                                                                
                                                                                                .. attribute:: vm_done
                                                                                                
                                                                                                	VM Done Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                .. attribute:: vm_node_id
                                                                                                
                                                                                                	VM Node ID Tuple
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__init__()

                                                                                                    self.yang_name = "attributes"
                                                                                                    self.yang_parent_name = "tsi9"

                                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                    self._children_yang_names.add("fru-info")

                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                    self._children_yang_names.add("pwg-info")

                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                    self._children_yang_names.add("threshold")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("module_done",
                                                                                                                    "node_id",
                                                                                                                    "vm_done",
                                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes, self).__setattr__(name, value)


                                                                                                class EnvSensorInfo(Entity):
                                                                                                    """
                                                                                                    Environment sensor info
                                                                                                    
                                                                                                    .. attribute:: age_time_stamp
                                                                                                    
                                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: alarm_type
                                                                                                    
                                                                                                    	Indicates threshold violation
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: device_description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: device_id
                                                                                                    
                                                                                                    	Identifier for this device
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: field_validity_bitmap
                                                                                                    
                                                                                                    	Sensor valid bitmap
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: precision
                                                                                                    
                                                                                                    	Sensor precision range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: scale
                                                                                                    
                                                                                                    	Sensor scale enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state enums
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("age_time_stamp",
                                                                                                                        "alarm_type",
                                                                                                                        "data_type",
                                                                                                                        "device_description",
                                                                                                                        "device_id",
                                                                                                                        "field_validity_bitmap",
                                                                                                                        "precision",
                                                                                                                        "scale",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.age_time_stamp.is_set or
                                                                                                            self.alarm_type.is_set or
                                                                                                            self.data_type.is_set or
                                                                                                            self.device_description.is_set or
                                                                                                            self.device_id.is_set or
                                                                                                            self.field_validity_bitmap.is_set or
                                                                                                            self.precision.is_set or
                                                                                                            self.scale.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "age-time-stamp"):
                                                                                                            self.age_time_stamp = value
                                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "alarm-type"):
                                                                                                            self.alarm_type = value
                                                                                                            self.alarm_type.value_namespace = name_space
                                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-description"):
                                                                                                            self.device_description = value
                                                                                                            self.device_description.value_namespace = name_space
                                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "device-id"):
                                                                                                            self.device_id = value
                                                                                                            self.device_id.value_namespace = name_space
                                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                                            self.field_validity_bitmap = value
                                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "precision"):
                                                                                                            self.precision = value
                                                                                                            self.precision.value_namespace = name_space
                                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "scale"):
                                                                                                            self.scale = value
                                                                                                            self.scale.value_namespace = name_space
                                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class PwgInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM PWG info
                                                                                                    
                                                                                                    .. attribute:: power_group_available_current
                                                                                                    
                                                                                                    	available current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_drawn_current
                                                                                                    
                                                                                                    	drawn current
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_group_power_units
                                                                                                    
                                                                                                    	power units
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                                    
                                                                                                    	redundancy mode
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__init__()

                                                                                                        self.yang_name = "pwg-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("power_group_available_current",
                                                                                                                        "power_group_drawn_current",
                                                                                                                        "power_group_power_units",
                                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.power_group_available_current.is_set or
                                                                                                            self.power_group_drawn_current.is_set or
                                                                                                            self.power_group_power_units.is_set or
                                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "power-group-available-current"):
                                                                                                            self.power_group_available_current = value
                                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                                            self.power_group_drawn_current = value
                                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-power-units"):
                                                                                                            self.power_group_power_units = value
                                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                                            self.power_group_redundancy_mode = value
                                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                                class EnvSensorInfoXml(Entity):
                                                                                                    """
                                                                                                    Environment sensor info XML
                                                                                                    
                                                                                                    .. attribute:: data_type
                                                                                                    
                                                                                                    	Sensor data type
                                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	Device Name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: status
                                                                                                    
                                                                                                    	Sensor operation state
                                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                                    
                                                                                                    .. attribute:: threshold
                                                                                                    
                                                                                                    	Threshold information
                                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                                    
                                                                                                    .. attribute:: units
                                                                                                    
                                                                                                    	Units of variable being read
                                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                                    
                                                                                                    .. attribute:: update_rate
                                                                                                    
                                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                        self._children_yang_names.add("threshold")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("data_type",
                                                                                                                        "description",
                                                                                                                        "status",
                                                                                                                        "units",
                                                                                                                        "update_rate",
                                                                                                                        "value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                                    class Threshold(Entity):
                                                                                                        """
                                                                                                        Threshold information
                                                                                                        
                                                                                                        .. attribute:: threshold_array
                                                                                                        
                                                                                                        	Array of threshold
                                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                            self.yang_name = "threshold"
                                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                                            self.threshold_array = YList(self)

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in () and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                        class ThresholdArray(Entity):
                                                                                                            """
                                                                                                            Array of threshold
                                                                                                            
                                                                                                            .. attribute:: threshold_name
                                                                                                            
                                                                                                            	Threshold name
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..50
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** \-2147483648..2147483647
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                                self.yang_name = "threshold-array"
                                                                                                                self.yang_parent_name = "threshold"

                                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_name",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_name.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-name"):
                                                                                                                    self.threshold_name = value
                                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_data()):
                                                                                                                    return True
                                                                                                            return False

                                                                                                        def has_operation(self):
                                                                                                            for c in self.threshold_array:
                                                                                                                if (c.has_operation()):
                                                                                                                    return True
                                                                                                            return self.yfilter != YFilter.not_set

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "threshold" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                                for c in self.threshold_array:
                                                                                                                    segment = c.get_segment_path()
                                                                                                                    if (segment_path == segment):
                                                                                                                        return c
                                                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                                c.parent = self
                                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                                self._local_refs[local_reference_key] = c
                                                                                                                self.threshold_array.append(c)
                                                                                                                return c

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "threshold-array"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.data_type.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.status.is_set or
                                                                                                            self.units.is_set or
                                                                                                            self.update_rate.is_set or
                                                                                                            self.value.is_set or
                                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "threshold"):
                                                                                                            if (self.threshold is None):
                                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                                self.threshold.parent = self
                                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                            return self.threshold

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "data-type"):
                                                                                                            self.data_type = value
                                                                                                            self.data_type.value_namespace = name_space
                                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "status"):
                                                                                                            self.status = value
                                                                                                            self.status.value_namespace = name_space
                                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "units"):
                                                                                                            self.units = value
                                                                                                            self.units.value_namespace = name_space
                                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "update-rate"):
                                                                                                            self.update_rate = value
                                                                                                            self.update_rate.value_namespace = name_space
                                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "value"):
                                                                                                            self.value = value
                                                                                                            self.value.value_namespace = name_space
                                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                                class InvAssetBag(Entity):
                                                                                                    """
                                                                                                    Inventory Asset Bag
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                                    
                                                                                                    	Manufacture Assembly number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                                    
                                                                                                    	Manufacture assembly revision
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                                    
                                                                                                    	Common Language Equipment           Identifier number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                                    
                                                                                                    	String containing OEM information           if applicable
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: part_number
                                                                                                    
                                                                                                    	
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__init__()

                                                                                                        self.yang_name = "inv-asset-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                                        "manufacturer_assembly_revision",
                                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                                        "manufacturer_firmware_identifier",
                                                                                                                        "manufacturer_software_identifier",
                                                                                                                        "original_equipment_manufacturer_string",
                                                                                                                        "part_number") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                                            self.part_number.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                                            self.manufacturer_assembly_number = value
                                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                                            self.manufacturer_assembly_revision = value
                                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                                            self.manufacturer_firmware_identifier = value
                                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                                            self.manufacturer_software_identifier = value
                                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                                            self.original_equipment_manufacturer_string = value
                                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "part-number"):
                                                                                                            self.part_number = value
                                                                                                            self.part_number.value_namespace = name_space
                                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                                class Threshold(Entity):
                                                                                                    """
                                                                                                    Threshold
                                                                                                    
                                                                                                    .. attribute:: critical_hi
                                                                                                    
                                                                                                    	Critical High
                                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi>`
                                                                                                    
                                                                                                    .. attribute:: critical_lo
                                                                                                    
                                                                                                    	Critical Low
                                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo>`
                                                                                                    
                                                                                                    .. attribute:: major_hi
                                                                                                    
                                                                                                    	Major High
                                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi>`
                                                                                                    
                                                                                                    .. attribute:: major_lo
                                                                                                    
                                                                                                    	Major Low
                                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo>`
                                                                                                    
                                                                                                    .. attribute:: minor_hi
                                                                                                    
                                                                                                    	Minor High
                                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi>`
                                                                                                    
                                                                                                    .. attribute:: minor_lo
                                                                                                    
                                                                                                    	Minor Low
                                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold, self).__init__()

                                                                                                        self.yang_name = "threshold"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                        self._children_yang_names.add("critical-hi")

                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                        self._children_yang_names.add("critical-lo")

                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                        self._children_yang_names.add("major-hi")

                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                        self._children_yang_names.add("major-lo")

                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                        self._children_yang_names.add("minor-hi")

                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                        self._children_yang_names.add("minor-lo")


                                                                                                    class MajorLo(Entity):
                                                                                                        """
                                                                                                        Major Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                            self.yang_name = "major-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalHi(Entity):
                                                                                                        """
                                                                                                        Critical High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                            self.yang_name = "critical-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorHi(Entity):
                                                                                                        """
                                                                                                        Minor High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                            self.yang_name = "minor-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MajorHi(Entity):
                                                                                                        """
                                                                                                        Major High
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                            self.yang_name = "major-hi"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "major-hi"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class CriticalLo(Entity):
                                                                                                        """
                                                                                                        Critical Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                            self.yang_name = "critical-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass


                                                                                                    class MinorLo(Entity):
                                                                                                        """
                                                                                                        Minor Low
                                                                                                        
                                                                                                        .. attribute:: thresh_bag
                                                                                                        
                                                                                                        	Environment threshold info
                                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                            self.yang_name = "minor-lo"
                                                                                                            self.yang_parent_name = "threshold"

                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                                        class ThreshBag(Entity):
                                                                                                            """
                                                                                                            Environment threshold info
                                                                                                            
                                                                                                            .. attribute:: threshold_evaluation
                                                                                                            
                                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_notification_enabled
                                                                                                            
                                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                            	**type**\:  bool
                                                                                                            
                                                                                                            .. attribute:: threshold_relation
                                                                                                            
                                                                                                            	Indicates relation between sensor value and threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_severity
                                                                                                            
                                                                                                            	Indicates minor, major, critical severities
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            .. attribute:: threshold_value
                                                                                                            
                                                                                                            	Value of the configured threshold
                                                                                                            	**type**\:  int
                                                                                                            
                                                                                                            	**range:** 0..4294967295
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                                self.yang_name = "thresh-bag"
                                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("threshold_evaluation",
                                                                                                                                "threshold_notification_enabled",
                                                                                                                                "threshold_relation",
                                                                                                                                "threshold_severity",
                                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.threshold_evaluation.is_set or
                                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                                    self.threshold_relation.is_set or
                                                                                                                    self.threshold_severity.is_set or
                                                                                                                    self.threshold_value.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                                    self.threshold_evaluation = value
                                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                                    self.threshold_notification_enabled = value
                                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-relation"):
                                                                                                                    self.threshold_relation = value
                                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-severity"):
                                                                                                                    self.threshold_severity = value
                                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "threshold-value"):
                                                                                                                    self.threshold_value = value
                                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                                if (self.thresh_bag is None):
                                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                                    self.thresh_bag.parent = self
                                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                                return self.thresh_bag

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "thresh-bag"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            pass

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "critical-hi"):
                                                                                                            if (self.critical_hi is None):
                                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalHi()
                                                                                                                self.critical_hi.parent = self
                                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                            return self.critical_hi

                                                                                                        if (child_yang_name == "critical-lo"):
                                                                                                            if (self.critical_lo is None):
                                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.CriticalLo()
                                                                                                                self.critical_lo.parent = self
                                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                            return self.critical_lo

                                                                                                        if (child_yang_name == "major-hi"):
                                                                                                            if (self.major_hi is None):
                                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorHi()
                                                                                                                self.major_hi.parent = self
                                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                            return self.major_hi

                                                                                                        if (child_yang_name == "major-lo"):
                                                                                                            if (self.major_lo is None):
                                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MajorLo()
                                                                                                                self.major_lo.parent = self
                                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                            return self.major_lo

                                                                                                        if (child_yang_name == "minor-hi"):
                                                                                                            if (self.minor_hi is None):
                                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorHi()
                                                                                                                self.minor_hi.parent = self
                                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                            return self.minor_hi

                                                                                                        if (child_yang_name == "minor-lo"):
                                                                                                            if (self.minor_lo is None):
                                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold.MinorLo()
                                                                                                                self.minor_lo.parent = self
                                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                            return self.minor_lo

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        pass


                                                                                                class FruInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM FRU info
                                                                                                    
                                                                                                    .. attribute:: card_administrative_state
                                                                                                    
                                                                                                    	card admin state\: shutdown or not
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_monitor_state
                                                                                                    
                                                                                                    	card is monitored by a manager or left unmonitored
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_operational_state
                                                                                                    
                                                                                                    	card operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: card_reset_reason
                                                                                                    
                                                                                                    	card reset reason enum
                                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                                    
                                                                                                    .. attribute:: card_up_time
                                                                                                    
                                                                                                    	card up time
                                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime>`
                                                                                                    
                                                                                                    .. attribute:: last_operational_state_change
                                                                                                    
                                                                                                    	last card oper change state
                                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                                    
                                                                                                    .. attribute:: power_administrative_state
                                                                                                    
                                                                                                    	power admin state\: up or down
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_current_measurement
                                                                                                    
                                                                                                    	power current\: not implemented
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: power_operational_state
                                                                                                    
                                                                                                    	Power operation state
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__init__()

                                                                                                        self.yang_name = "fru-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                        self._children_yang_names.add("card-up-time")

                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("card_administrative_state",
                                                                                                                        "card_monitor_state",
                                                                                                                        "card_operational_state",
                                                                                                                        "card_reset_reason",
                                                                                                                        "power_administrative_state",
                                                                                                                        "power_current_measurement",
                                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                                    class LastOperationalStateChange(Entity):
                                                                                                        """
                                                                                                        last card oper change state
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                            self.yang_name = "last-operational-state-change"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                                    class CardUpTime(Entity):
                                                                                                        """
                                                                                                        card up time
                                                                                                        
                                                                                                        .. attribute:: time_in_nano_seconds
                                                                                                        
                                                                                                        	Time Value in Nano\-seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: nanosecond
                                                                                                        
                                                                                                        .. attribute:: time_in_seconds
                                                                                                        
                                                                                                        	Time Value in Seconds
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** \-2147483648..2147483647
                                                                                                        
                                                                                                        	**units**\: second
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                            self.yang_name = "card-up-time"
                                                                                                            self.yang_parent_name = "fru-info"

                                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("time_in_nano_seconds",
                                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                                self.time_in_seconds.is_set)

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                                self.time_in_nano_seconds = value
                                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "time-in-seconds"):
                                                                                                                self.time_in_seconds = value
                                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.card_administrative_state.is_set or
                                                                                                            self.card_monitor_state.is_set or
                                                                                                            self.card_operational_state.is_set or
                                                                                                            self.card_reset_reason.is_set or
                                                                                                            self.power_administrative_state.is_set or
                                                                                                            self.power_current_measurement.is_set or
                                                                                                            self.power_operational_state.is_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "card-up-time"):
                                                                                                            if (self.card_up_time is None):
                                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.CardUpTime()
                                                                                                                self.card_up_time.parent = self
                                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                            return self.card_up_time

                                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                                            if (self.last_operational_state_change is None):
                                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                                self.last_operational_state_change.parent = self
                                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                            return self.last_operational_state_change

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "card-administrative-state"):
                                                                                                            self.card_administrative_state = value
                                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-monitor-state"):
                                                                                                            self.card_monitor_state = value
                                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-operational-state"):
                                                                                                            self.card_operational_state = value
                                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "card-reset-reason"):
                                                                                                            self.card_reset_reason = value
                                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-administrative-state"):
                                                                                                            self.power_administrative_state = value
                                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-current-measurement"):
                                                                                                            self.power_current_measurement = value
                                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "power-operational-state"):
                                                                                                            self.power_operational_state = value
                                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                                class InvBasicBag(Entity):
                                                                                                    """
                                                                                                    Inventory Basic Bag
                                                                                                    
                                                                                                    .. attribute:: alias
                                                                                                    
                                                                                                    	useful for storing an entity alias 
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_id_str
                                                                                                    
                                                                                                    	asset Identification string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: asset_identification
                                                                                                    
                                                                                                    	asset Identification
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: ceport
                                                                                                    
                                                                                                    	1 if ce port found, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: chip_hardware_revision
                                                                                                    
                                                                                                    	chip module hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: composite_class_code
                                                                                                    
                                                                                                    	Major&minor class of the entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: environmental_monitor_path
                                                                                                    
                                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: firmware_revision
                                                                                                    
                                                                                                    	firmware revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: group_flag
                                                                                                    
                                                                                                    	indicates if this entity is group       or not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: hardware_revision
                                                                                                    
                                                                                                    	hw revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                                    
                                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                                    
                                                                                                    	Manufacture Asset Tags
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: manufacturer_name
                                                                                                    
                                                                                                    	manufacturer's name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: memory_size
                                                                                                    
                                                                                                    	Size of memory associated with       the entity where applicable
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: model_name
                                                                                                    
                                                                                                    	model name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: name
                                                                                                    
                                                                                                    	name string for the entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: new_deviation_number
                                                                                                    
                                                                                                    	integer value for New Deviation Number 0x88
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                                    
                                                                                                    	integer value for plim type if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: redundancystate
                                                                                                    
                                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: serial_number
                                                                                                    
                                                                                                    	serial number
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: software_revision
                                                                                                    
                                                                                                    	software revision string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: unique_id
                                                                                                    
                                                                                                    	Unique id for an entity
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    .. attribute:: unrecognized_fru
                                                                                                    
                                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: vendor_type
                                                                                                    
                                                                                                    	maps to the vendor OID string
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: xr_scoped
                                                                                                    
                                                                                                    	1 if xr scoped, 0 if not
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__init__()

                                                                                                        self.yang_name = "inv-basic-bag"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("alias",
                                                                                                                        "asset_id_str",
                                                                                                                        "asset_identification",
                                                                                                                        "ceport",
                                                                                                                        "chip_hardware_revision",
                                                                                                                        "composite_class_code",
                                                                                                                        "description",
                                                                                                                        "environmental_monitor_path",
                                                                                                                        "firmware_revision",
                                                                                                                        "group_flag",
                                                                                                                        "hardware_revision",
                                                                                                                        "is_field_replaceable_unit",
                                                                                                                        "manufacturer_asset_tags",
                                                                                                                        "manufacturer_name",
                                                                                                                        "memory_size",
                                                                                                                        "model_name",
                                                                                                                        "name",
                                                                                                                        "new_deviation_number",
                                                                                                                        "physical_layer_interface_module_type",
                                                                                                                        "redundancystate",
                                                                                                                        "serial_number",
                                                                                                                        "software_revision",
                                                                                                                        "unique_id",
                                                                                                                        "unrecognized_fru",
                                                                                                                        "vendor_type",
                                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.alias.is_set or
                                                                                                            self.asset_id_str.is_set or
                                                                                                            self.asset_identification.is_set or
                                                                                                            self.ceport.is_set or
                                                                                                            self.chip_hardware_revision.is_set or
                                                                                                            self.composite_class_code.is_set or
                                                                                                            self.description.is_set or
                                                                                                            self.environmental_monitor_path.is_set or
                                                                                                            self.firmware_revision.is_set or
                                                                                                            self.group_flag.is_set or
                                                                                                            self.hardware_revision.is_set or
                                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                                            self.manufacturer_name.is_set or
                                                                                                            self.memory_size.is_set or
                                                                                                            self.model_name.is_set or
                                                                                                            self.name.is_set or
                                                                                                            self.new_deviation_number.is_set or
                                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                                            self.redundancystate.is_set or
                                                                                                            self.serial_number.is_set or
                                                                                                            self.software_revision.is_set or
                                                                                                            self.unique_id.is_set or
                                                                                                            self.unrecognized_fru.is_set or
                                                                                                            self.vendor_type.is_set or
                                                                                                            self.xr_scoped.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "alias"):
                                                                                                            self.alias = value
                                                                                                            self.alias.value_namespace = name_space
                                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-id-str"):
                                                                                                            self.asset_id_str = value
                                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "asset-identification"):
                                                                                                            self.asset_identification = value
                                                                                                            self.asset_identification.value_namespace = name_space
                                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "ceport"):
                                                                                                            self.ceport = value
                                                                                                            self.ceport.value_namespace = name_space
                                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                                            self.chip_hardware_revision = value
                                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "composite-class-code"):
                                                                                                            self.composite_class_code = value
                                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                                            self.environmental_monitor_path = value
                                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "firmware-revision"):
                                                                                                            self.firmware_revision = value
                                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "group-flag"):
                                                                                                            self.group_flag = value
                                                                                                            self.group_flag.value_namespace = name_space
                                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "hardware-revision"):
                                                                                                            self.hardware_revision = value
                                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                                            self.is_field_replaceable_unit = value
                                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                                            self.manufacturer_asset_tags = value
                                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "manufacturer-name"):
                                                                                                            self.manufacturer_name = value
                                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "memory-size"):
                                                                                                            self.memory_size = value
                                                                                                            self.memory_size.value_namespace = name_space
                                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "model-name"):
                                                                                                            self.model_name = value
                                                                                                            self.model_name.value_namespace = name_space
                                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "name"):
                                                                                                            self.name = value
                                                                                                            self.name.value_namespace = name_space
                                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "new-deviation-number"):
                                                                                                            self.new_deviation_number = value
                                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                                            self.physical_layer_interface_module_type = value
                                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "redundancystate"):
                                                                                                            self.redundancystate = value
                                                                                                            self.redundancystate.value_namespace = name_space
                                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "serial-number"):
                                                                                                            self.serial_number = value
                                                                                                            self.serial_number.value_namespace = name_space
                                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "software-revision"):
                                                                                                            self.software_revision = value
                                                                                                            self.software_revision.value_namespace = name_space
                                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unique-id"):
                                                                                                            self.unique_id = value
                                                                                                            self.unique_id.value_namespace = name_space
                                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "unrecognized-fru"):
                                                                                                            self.unrecognized_fru = value
                                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "vendor-type"):
                                                                                                            self.vendor_type = value
                                                                                                            self.vendor_type.value_namespace = name_space
                                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "xr-scoped"):
                                                                                                            self.xr_scoped = value
                                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                                class InvEepromInfo(Entity):
                                                                                                    """
                                                                                                    Inventory EDM EEPROM Information Bag
                                                                                                    
                                                                                                    .. attribute:: description
                                                                                                    
                                                                                                    	A textual description of physical entity
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: eeprom
                                                                                                    
                                                                                                    	EEPROM data not from hex data
                                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom>`
                                                                                                    
                                                                                                    .. attribute:: has_eeprom
                                                                                                    
                                                                                                    	use eeprom instead of opaque data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: inv_card_type
                                                                                                    
                                                                                                    	Inventory card type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: opaque_data
                                                                                                    
                                                                                                    	EEPROM hex data
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: opaque_data_size
                                                                                                    
                                                                                                    	size of the EEPROM hex data
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__init__()

                                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                                        self.yang_parent_name = "attributes"

                                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                        self._children_yang_names.add("eeprom")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("description",
                                                                                                                        "has_eeprom",
                                                                                                                        "inv_card_type",
                                                                                                                        "opaque_data",
                                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                                    class Eeprom(Entity):
                                                                                                        """
                                                                                                        EEPROM data not from hex data
                                                                                                        
                                                                                                        .. attribute:: asset_alias
                                                                                                        
                                                                                                        	Asset Alias
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: asset_id
                                                                                                        
                                                                                                        	Asset ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address1
                                                                                                        
                                                                                                        	Base Mac Address #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address2
                                                                                                        
                                                                                                        	Base Mac Address #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address3
                                                                                                        
                                                                                                        	Base Mac Address #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: base_mac_address4
                                                                                                        
                                                                                                        	Base Mac Address #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_checksum
                                                                                                        
                                                                                                        	Block Checksum
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_count
                                                                                                        
                                                                                                        	Block Count
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_length
                                                                                                        
                                                                                                        	Block Length
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_signature
                                                                                                        
                                                                                                        	Block Signature
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: block_version
                                                                                                        
                                                                                                        	Block Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: chassis_sid
                                                                                                        
                                                                                                        	Chassis serial number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: clei
                                                                                                        
                                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_family
                                                                                                        
                                                                                                        	Controller family
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: controller_type
                                                                                                        
                                                                                                        	Controller type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: description
                                                                                                        
                                                                                                        	A textual description of physical entity
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num1
                                                                                                        
                                                                                                        	Deviation Number # 1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num2
                                                                                                        
                                                                                                        	Deviation Number # 2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num3
                                                                                                        
                                                                                                        	Deviation Number # 3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num4
                                                                                                        
                                                                                                        	Deviation Number # 4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num5
                                                                                                        
                                                                                                        	Deviation Number # 5
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num6
                                                                                                        
                                                                                                        	Deviation Number # 6
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: dev_num7
                                                                                                        
                                                                                                        	Deviation Number # 7
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eci
                                                                                                        
                                                                                                        	Equipment Catalog Item (ECI) number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: eeprom_size
                                                                                                        
                                                                                                        	EEPROM Size
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: engineer_use
                                                                                                        
                                                                                                        	Engineer Use
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_major_type
                                                                                                        
                                                                                                        	FRU Major Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: fru_minor_type
                                                                                                        
                                                                                                        	FRU Minor Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hw_version
                                                                                                        
                                                                                                        	Hardware Version
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: hwid
                                                                                                        
                                                                                                        	Hardware Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: idprom_format_rev
                                                                                                        
                                                                                                        	IDPROM Format Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size1
                                                                                                        
                                                                                                        	Mac Address Block Size #1
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size2
                                                                                                        
                                                                                                        	Mac Address Block Size #2
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size3
                                                                                                        
                                                                                                        	Mac Address Block Size #3
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mac_add_blk_size4
                                                                                                        
                                                                                                        	Mac Address Block Size #4
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: manu_test_data
                                                                                                        
                                                                                                        	Manufacturing Test Data
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_bits
                                                                                                        
                                                                                                        	MFG Bits
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: mfg_deviation
                                                                                                        
                                                                                                        	MFG Deviation
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: oem_string
                                                                                                        
                                                                                                        	OEM String
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_number
                                                                                                        
                                                                                                        	Part Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: part_revision
                                                                                                        
                                                                                                        	Part Revision
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pca_num
                                                                                                        
                                                                                                        	PCA number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcavid
                                                                                                        
                                                                                                        	PCA revision ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pcb_serial_num
                                                                                                        
                                                                                                        	PCB Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: pid
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_consumption
                                                                                                        
                                                                                                        	Power Consumption
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: power_supply_type
                                                                                                        
                                                                                                        	Power Supply Type
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: product_id
                                                                                                        
                                                                                                        	Product ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: rma
                                                                                                        
                                                                                                        	RMA Data
                                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                        
                                                                                                        .. attribute:: rma_code
                                                                                                        
                                                                                                        	RMA Code
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: serial_number
                                                                                                        
                                                                                                        	Serial Number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: snmpoid
                                                                                                        
                                                                                                        	SNMP OID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_part_num
                                                                                                        
                                                                                                        	Top assembly part number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: top_assem_vid
                                                                                                        
                                                                                                        	Top assembly revision number
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_description
                                                                                                        
                                                                                                        	UDI description
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: udi_name
                                                                                                        
                                                                                                        	UDI name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        .. attribute:: vid
                                                                                                        
                                                                                                        	Version ID
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**length:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'invmgr-oper'
                                                                                                        _revision = '2015-11-09'

                                                                                                        def __init__(self):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                            self.yang_name = "eeprom"
                                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                            self._children_yang_names.add("rma")

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._check_monkey_patching_error(name, value)
                                                                                                            with _handle_type_error():
                                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                        "Please use list append or extend method."
                                                                                                                                        .format(value))
                                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                                    value = value.name
                                                                                                                if name in ("asset_alias",
                                                                                                                            "asset_id",
                                                                                                                            "base_mac_address1",
                                                                                                                            "base_mac_address2",
                                                                                                                            "base_mac_address3",
                                                                                                                            "base_mac_address4",
                                                                                                                            "block_checksum",
                                                                                                                            "block_count",
                                                                                                                            "block_length",
                                                                                                                            "block_signature",
                                                                                                                            "block_version",
                                                                                                                            "chassis_sid",
                                                                                                                            "clei",
                                                                                                                            "controller_family",
                                                                                                                            "controller_type",
                                                                                                                            "description",
                                                                                                                            "dev_num1",
                                                                                                                            "dev_num2",
                                                                                                                            "dev_num3",
                                                                                                                            "dev_num4",
                                                                                                                            "dev_num5",
                                                                                                                            "dev_num6",
                                                                                                                            "dev_num7",
                                                                                                                            "eci",
                                                                                                                            "eeprom_size",
                                                                                                                            "engineer_use",
                                                                                                                            "fru_major_type",
                                                                                                                            "fru_minor_type",
                                                                                                                            "hw_version",
                                                                                                                            "hwid",
                                                                                                                            "idprom_format_rev",
                                                                                                                            "mac_add_blk_size1",
                                                                                                                            "mac_add_blk_size2",
                                                                                                                            "mac_add_blk_size3",
                                                                                                                            "mac_add_blk_size4",
                                                                                                                            "manu_test_data",
                                                                                                                            "mfg_bits",
                                                                                                                            "mfg_deviation",
                                                                                                                            "oem_string",
                                                                                                                            "part_number",
                                                                                                                            "part_revision",
                                                                                                                            "pca_num",
                                                                                                                            "pcavid",
                                                                                                                            "pcb_serial_num",
                                                                                                                            "pid",
                                                                                                                            "power_consumption",
                                                                                                                            "power_supply_type",
                                                                                                                            "product_id",
                                                                                                                            "rma_code",
                                                                                                                            "serial_number",
                                                                                                                            "snmpoid",
                                                                                                                            "top_assem_part_num",
                                                                                                                            "top_assem_vid",
                                                                                                                            "udi_description",
                                                                                                                            "udi_name",
                                                                                                                            "vid") and name in self.__dict__:
                                                                                                                    if isinstance(value, YLeaf):
                                                                                                                        self.__dict__[name].set(value.get())
                                                                                                                    elif isinstance(value, YLeafList):
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                                    else:
                                                                                                                        self.__dict__[name].set(value)
                                                                                                                else:
                                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                            value.parent = self
                                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                            value.parent = self
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                        class Rma(Entity):
                                                                                                            """
                                                                                                            RMA Data
                                                                                                            
                                                                                                            .. attribute:: rma_history
                                                                                                            
                                                                                                            	RMA history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: rma_number
                                                                                                            
                                                                                                            	RMA tracking number format is N\-N\-N
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            .. attribute:: test_history
                                                                                                            
                                                                                                            	Test history
                                                                                                            	**type**\:  str
                                                                                                            
                                                                                                            	**length:** 0..255
                                                                                                            
                                                                                                            

                                                                                                            """

                                                                                                            _prefix = 'invmgr-oper'
                                                                                                            _revision = '2015-11-09'

                                                                                                            def __init__(self):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                                self.yang_name = "rma"
                                                                                                                self.yang_parent_name = "eeprom"

                                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                                            def __setattr__(self, name, value):
                                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                                with _handle_type_error():
                                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                            "Please use list append or extend method."
                                                                                                                                            .format(value))
                                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                                        value = value.name
                                                                                                                    if name in ("rma_history",
                                                                                                                                "rma_number",
                                                                                                                                "test_history") and name in self.__dict__:
                                                                                                                        if isinstance(value, YLeaf):
                                                                                                                            self.__dict__[name].set(value.get())
                                                                                                                        elif isinstance(value, YLeafList):
                                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                        else:
                                                                                                                            self.__dict__[name].set(value)
                                                                                                                    else:
                                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                                value.parent = self
                                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                                value.parent = self
                                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                            def has_data(self):
                                                                                                                return (
                                                                                                                    self.rma_history.is_set or
                                                                                                                    self.rma_number.is_set or
                                                                                                                    self.test_history.is_set)

                                                                                                            def has_operation(self):
                                                                                                                return (
                                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                                            def get_segment_path(self):
                                                                                                                path_buffer = ""
                                                                                                                path_buffer = "rma" + path_buffer

                                                                                                                return path_buffer

                                                                                                            def get_entity_path(self, ancestor):
                                                                                                                path_buffer = ""
                                                                                                                if (ancestor is None):
                                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                                else:
                                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                                leaf_name_data = LeafDataList()
                                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                                return entity_path

                                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                                if child is not None:
                                                                                                                    return child

                                                                                                                return None

                                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                                    return True
                                                                                                                return False

                                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                                if(value_path == "rma-history"):
                                                                                                                    self.rma_history = value
                                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "rma-number"):
                                                                                                                    self.rma_number = value
                                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                                if(value_path == "test-history"):
                                                                                                                    self.test_history = value
                                                                                                                    self.test_history.value_namespace = name_space
                                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                        def has_data(self):
                                                                                                            return (
                                                                                                                self.asset_alias.is_set or
                                                                                                                self.asset_id.is_set or
                                                                                                                self.base_mac_address1.is_set or
                                                                                                                self.base_mac_address2.is_set or
                                                                                                                self.base_mac_address3.is_set or
                                                                                                                self.base_mac_address4.is_set or
                                                                                                                self.block_checksum.is_set or
                                                                                                                self.block_count.is_set or
                                                                                                                self.block_length.is_set or
                                                                                                                self.block_signature.is_set or
                                                                                                                self.block_version.is_set or
                                                                                                                self.chassis_sid.is_set or
                                                                                                                self.clei.is_set or
                                                                                                                self.controller_family.is_set or
                                                                                                                self.controller_type.is_set or
                                                                                                                self.description.is_set or
                                                                                                                self.dev_num1.is_set or
                                                                                                                self.dev_num2.is_set or
                                                                                                                self.dev_num3.is_set or
                                                                                                                self.dev_num4.is_set or
                                                                                                                self.dev_num5.is_set or
                                                                                                                self.dev_num6.is_set or
                                                                                                                self.dev_num7.is_set or
                                                                                                                self.eci.is_set or
                                                                                                                self.eeprom_size.is_set or
                                                                                                                self.engineer_use.is_set or
                                                                                                                self.fru_major_type.is_set or
                                                                                                                self.fru_minor_type.is_set or
                                                                                                                self.hw_version.is_set or
                                                                                                                self.hwid.is_set or
                                                                                                                self.idprom_format_rev.is_set or
                                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                                self.manu_test_data.is_set or
                                                                                                                self.mfg_bits.is_set or
                                                                                                                self.mfg_deviation.is_set or
                                                                                                                self.oem_string.is_set or
                                                                                                                self.part_number.is_set or
                                                                                                                self.part_revision.is_set or
                                                                                                                self.pca_num.is_set or
                                                                                                                self.pcavid.is_set or
                                                                                                                self.pcb_serial_num.is_set or
                                                                                                                self.pid.is_set or
                                                                                                                self.power_consumption.is_set or
                                                                                                                self.power_supply_type.is_set or
                                                                                                                self.product_id.is_set or
                                                                                                                self.rma_code.is_set or
                                                                                                                self.serial_number.is_set or
                                                                                                                self.snmpoid.is_set or
                                                                                                                self.top_assem_part_num.is_set or
                                                                                                                self.top_assem_vid.is_set or
                                                                                                                self.udi_description.is_set or
                                                                                                                self.udi_name.is_set or
                                                                                                                self.vid.is_set or
                                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                                        def has_operation(self):
                                                                                                            return (
                                                                                                                self.yfilter != YFilter.not_set or
                                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                                        def get_segment_path(self):
                                                                                                            path_buffer = ""
                                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                                            return path_buffer

                                                                                                        def get_entity_path(self, ancestor):
                                                                                                            path_buffer = ""
                                                                                                            if (ancestor is None):
                                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                            else:
                                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                            leaf_name_data = LeafDataList()
                                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                            return entity_path

                                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                            if child is not None:
                                                                                                                return child

                                                                                                            if (child_yang_name == "rma"):
                                                                                                                if (self.rma is None):
                                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                                    self.rma.parent = self
                                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                                return self.rma

                                                                                                            return None

                                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                                return True
                                                                                                            return False

                                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                            if(value_path == "asset-alias"):
                                                                                                                self.asset_alias = value
                                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "asset-id"):
                                                                                                                self.asset_id = value
                                                                                                                self.asset_id.value_namespace = name_space
                                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address1"):
                                                                                                                self.base_mac_address1 = value
                                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address2"):
                                                                                                                self.base_mac_address2 = value
                                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address3"):
                                                                                                                self.base_mac_address3 = value
                                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "base-mac-address4"):
                                                                                                                self.base_mac_address4 = value
                                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-checksum"):
                                                                                                                self.block_checksum = value
                                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-count"):
                                                                                                                self.block_count = value
                                                                                                                self.block_count.value_namespace = name_space
                                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-length"):
                                                                                                                self.block_length = value
                                                                                                                self.block_length.value_namespace = name_space
                                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-signature"):
                                                                                                                self.block_signature = value
                                                                                                                self.block_signature.value_namespace = name_space
                                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "block-version"):
                                                                                                                self.block_version = value
                                                                                                                self.block_version.value_namespace = name_space
                                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "chassis-sid"):
                                                                                                                self.chassis_sid = value
                                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "clei"):
                                                                                                                self.clei = value
                                                                                                                self.clei.value_namespace = name_space
                                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-family"):
                                                                                                                self.controller_family = value
                                                                                                                self.controller_family.value_namespace = name_space
                                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "controller-type"):
                                                                                                                self.controller_type = value
                                                                                                                self.controller_type.value_namespace = name_space
                                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "description"):
                                                                                                                self.description = value
                                                                                                                self.description.value_namespace = name_space
                                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num1"):
                                                                                                                self.dev_num1 = value
                                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num2"):
                                                                                                                self.dev_num2 = value
                                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num3"):
                                                                                                                self.dev_num3 = value
                                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num4"):
                                                                                                                self.dev_num4 = value
                                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num5"):
                                                                                                                self.dev_num5 = value
                                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num6"):
                                                                                                                self.dev_num6 = value
                                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "dev-num7"):
                                                                                                                self.dev_num7 = value
                                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eci"):
                                                                                                                self.eci = value
                                                                                                                self.eci.value_namespace = name_space
                                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "eeprom-size"):
                                                                                                                self.eeprom_size = value
                                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "engineer-use"):
                                                                                                                self.engineer_use = value
                                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-major-type"):
                                                                                                                self.fru_major_type = value
                                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "fru-minor-type"):
                                                                                                                self.fru_minor_type = value
                                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hw-version"):
                                                                                                                self.hw_version = value
                                                                                                                self.hw_version.value_namespace = name_space
                                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "hwid"):
                                                                                                                self.hwid = value
                                                                                                                self.hwid.value_namespace = name_space
                                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                                self.idprom_format_rev = value
                                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                                self.mac_add_blk_size1 = value
                                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                                self.mac_add_blk_size2 = value
                                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                                self.mac_add_blk_size3 = value
                                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                                self.mac_add_blk_size4 = value
                                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "manu-test-data"):
                                                                                                                self.manu_test_data = value
                                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-bits"):
                                                                                                                self.mfg_bits = value
                                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "mfg-deviation"):
                                                                                                                self.mfg_deviation = value
                                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "oem-string"):
                                                                                                                self.oem_string = value
                                                                                                                self.oem_string.value_namespace = name_space
                                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-number"):
                                                                                                                self.part_number = value
                                                                                                                self.part_number.value_namespace = name_space
                                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "part-revision"):
                                                                                                                self.part_revision = value
                                                                                                                self.part_revision.value_namespace = name_space
                                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pca-num"):
                                                                                                                self.pca_num = value
                                                                                                                self.pca_num.value_namespace = name_space
                                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcavid"):
                                                                                                                self.pcavid = value
                                                                                                                self.pcavid.value_namespace = name_space
                                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                                self.pcb_serial_num = value
                                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "pid"):
                                                                                                                self.pid = value
                                                                                                                self.pid.value_namespace = name_space
                                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-consumption"):
                                                                                                                self.power_consumption = value
                                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "power-supply-type"):
                                                                                                                self.power_supply_type = value
                                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "product-id"):
                                                                                                                self.product_id = value
                                                                                                                self.product_id.value_namespace = name_space
                                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "rma-code"):
                                                                                                                self.rma_code = value
                                                                                                                self.rma_code.value_namespace = name_space
                                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "serial-number"):
                                                                                                                self.serial_number = value
                                                                                                                self.serial_number.value_namespace = name_space
                                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "snmpoid"):
                                                                                                                self.snmpoid = value
                                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                                self.top_assem_part_num = value
                                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "top-assem-vid"):
                                                                                                                self.top_assem_vid = value
                                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-description"):
                                                                                                                self.udi_description = value
                                                                                                                self.udi_description.value_namespace = name_space
                                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "udi-name"):
                                                                                                                self.udi_name = value
                                                                                                                self.udi_name.value_namespace = name_space
                                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                            if(value_path == "vid"):
                                                                                                                self.vid = value
                                                                                                                self.vid.value_namespace = name_space
                                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.description.is_set or
                                                                                                            self.has_eeprom.is_set or
                                                                                                            self.inv_card_type.is_set or
                                                                                                            self.opaque_data.is_set or
                                                                                                            self.opaque_data_size.is_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        if (child_yang_name == "eeprom"):
                                                                                                            if (self.eeprom is None):
                                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo.Eeprom()
                                                                                                                self.eeprom.parent = self
                                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                            return self.eeprom

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "description"):
                                                                                                            self.description = value
                                                                                                            self.description.value_namespace = name_space
                                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "has-eeprom"):
                                                                                                            self.has_eeprom = value
                                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "inv-card-type"):
                                                                                                            self.inv_card_type = value
                                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data"):
                                                                                                            self.opaque_data = value
                                                                                                            self.opaque_data.value_namespace = name_space
                                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "opaque-data-size"):
                                                                                                            self.opaque_data_size = value
                                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.module_done.is_set or
                                                                                                        self.node_id.is_set or
                                                                                                        self.vm_done.is_set or
                                                                                                        self.vm_node_id.is_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "attributes" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                                        if (self.env_sensor_info is None):
                                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfo()
                                                                                                            self.env_sensor_info.parent = self
                                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                        return self.env_sensor_info

                                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                                        if (self.env_sensor_info_xml is None):
                                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.EnvSensorInfoXml()
                                                                                                            self.env_sensor_info_xml.parent = self
                                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                        return self.env_sensor_info_xml

                                                                                                    if (child_yang_name == "fru-info"):
                                                                                                        if (self.fru_info is None):
                                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.FruInfo()
                                                                                                            self.fru_info.parent = self
                                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                                        return self.fru_info

                                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                                        if (self.inv_asset_bag is None):
                                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvAssetBag()
                                                                                                            self.inv_asset_bag.parent = self
                                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                        return self.inv_asset_bag

                                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                                        if (self.inv_basic_bag is None):
                                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvBasicBag()
                                                                                                            self.inv_basic_bag.parent = self
                                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                        return self.inv_basic_bag

                                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                                        if (self.inv_eeprom_info is None):
                                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.InvEepromInfo()
                                                                                                            self.inv_eeprom_info.parent = self
                                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                        return self.inv_eeprom_info

                                                                                                    if (child_yang_name == "pwg-info"):
                                                                                                        if (self.pwg_info is None):
                                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.PwgInfo()
                                                                                                            self.pwg_info.parent = self
                                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                        return self.pwg_info

                                                                                                    if (child_yang_name == "threshold"):
                                                                                                        if (self.threshold is None):
                                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes.Threshold()
                                                                                                            self.threshold.parent = self
                                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                                        return self.threshold

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "module-done"):
                                                                                                        self.module_done = value
                                                                                                        self.module_done.value_namespace = name_space
                                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "node-id"):
                                                                                                        self.node_id = value
                                                                                                        self.node_id.value_namespace = name_space
                                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-done"):
                                                                                                        self.vm_done = value
                                                                                                        self.vm_done.value_namespace = name_space
                                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vm-node-id"):
                                                                                                        self.vm_node_id = value
                                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.name.is_set or
                                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                                    (self.tsi10s is not None and self.tsi10s.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "tsi9" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "attributes"):
                                                                                                    if (self.attributes is None):
                                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Attributes()
                                                                                                        self.attributes.parent = self
                                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                                    return self.attributes

                                                                                                if (child_yang_name == "tsi10s"):
                                                                                                    if (self.tsi10s is None):
                                                                                                        self.tsi10s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9.Tsi10S()
                                                                                                        self.tsi10s.parent = self
                                                                                                        self._children_name_map["tsi10s"] = "tsi10s"
                                                                                                    return self.tsi10s

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "attributes" or name == "tsi10s" or name == "name"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.tsi9:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "tsi9s" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "tsi9"):
                                                                                                for c in self.tsi9:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S.Tsi9()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.tsi9.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "tsi9"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class Attributes(Entity):
                                                                                        """
                                                                                        Attributes
                                                                                        
                                                                                        .. attribute:: env_sensor_info
                                                                                        
                                                                                        	Environment sensor info
                                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo>`
                                                                                        
                                                                                        .. attribute:: env_sensor_info_xml
                                                                                        
                                                                                        	Environment sensor info XML
                                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml>`
                                                                                        
                                                                                        .. attribute:: fru_info
                                                                                        
                                                                                        	Inventory EDM FRU info
                                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo>`
                                                                                        
                                                                                        .. attribute:: inv_asset_bag
                                                                                        
                                                                                        	Inventory Asset Bag
                                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag>`
                                                                                        
                                                                                        .. attribute:: inv_basic_bag
                                                                                        
                                                                                        	Inventory Basic Bag
                                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag>`
                                                                                        
                                                                                        .. attribute:: inv_eeprom_info
                                                                                        
                                                                                        	Inventory EDM EEPROM Information Bag
                                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo>`
                                                                                        
                                                                                        .. attribute:: module_done
                                                                                        
                                                                                        	Inventory EDM Module Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**default value**\: 1
                                                                                        
                                                                                        .. attribute:: node_id
                                                                                        
                                                                                        	Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: pwg_info
                                                                                        
                                                                                        	Inventory EDM PWG info
                                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo>`
                                                                                        
                                                                                        .. attribute:: threshold
                                                                                        
                                                                                        	Threshold
                                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold>`
                                                                                        
                                                                                        .. attribute:: vm_done
                                                                                        
                                                                                        	VM Done Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        .. attribute:: vm_node_id
                                                                                        
                                                                                        	VM Node ID Tuple
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__init__()

                                                                                            self.yang_name = "attributes"
                                                                                            self.yang_parent_name = "tsi8"

                                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                            self._children_yang_names.add("env-sensor-info")

                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                            self._children_yang_names.add("fru-info")

                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                            self._children_yang_names.add("pwg-info")

                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                            self._children_yang_names.add("threshold")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("module_done",
                                                                                                            "node_id",
                                                                                                            "vm_done",
                                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes, self).__setattr__(name, value)


                                                                                        class EnvSensorInfo(Entity):
                                                                                            """
                                                                                            Environment sensor info
                                                                                            
                                                                                            .. attribute:: age_time_stamp
                                                                                            
                                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: alarm_type
                                                                                            
                                                                                            	Indicates threshold violation
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: device_description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: device_id
                                                                                            
                                                                                            	Identifier for this device
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: field_validity_bitmap
                                                                                            
                                                                                            	Sensor valid bitmap
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: precision
                                                                                            
                                                                                            	Sensor precision range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: scale
                                                                                            
                                                                                            	Sensor scale enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state enums
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__init__()

                                                                                                self.yang_name = "env-sensor-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                                self.units = YLeaf(YType.str, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("age_time_stamp",
                                                                                                                "alarm_type",
                                                                                                                "data_type",
                                                                                                                "device_description",
                                                                                                                "device_id",
                                                                                                                "field_validity_bitmap",
                                                                                                                "precision",
                                                                                                                "scale",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.age_time_stamp.is_set or
                                                                                                    self.alarm_type.is_set or
                                                                                                    self.data_type.is_set or
                                                                                                    self.device_description.is_set or
                                                                                                    self.device_id.is_set or
                                                                                                    self.field_validity_bitmap.is_set or
                                                                                                    self.precision.is_set or
                                                                                                    self.scale.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "age-time-stamp"):
                                                                                                    self.age_time_stamp = value
                                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "alarm-type"):
                                                                                                    self.alarm_type = value
                                                                                                    self.alarm_type.value_namespace = name_space
                                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-description"):
                                                                                                    self.device_description = value
                                                                                                    self.device_description.value_namespace = name_space
                                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "device-id"):
                                                                                                    self.device_id = value
                                                                                                    self.device_id.value_namespace = name_space
                                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "field-validity-bitmap"):
                                                                                                    self.field_validity_bitmap = value
                                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "precision"):
                                                                                                    self.precision = value
                                                                                                    self.precision.value_namespace = name_space
                                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "scale"):
                                                                                                    self.scale = value
                                                                                                    self.scale.value_namespace = name_space
                                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class PwgInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM PWG info
                                                                                            
                                                                                            .. attribute:: power_group_available_current
                                                                                            
                                                                                            	available current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_drawn_current
                                                                                            
                                                                                            	drawn current
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_group_power_units
                                                                                            
                                                                                            	power units
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: power_group_redundancy_mode
                                                                                            
                                                                                            	redundancy mode
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__init__()

                                                                                                self.yang_name = "pwg-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("power_group_available_current",
                                                                                                                "power_group_drawn_current",
                                                                                                                "power_group_power_units",
                                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.power_group_available_current.is_set or
                                                                                                    self.power_group_drawn_current.is_set or
                                                                                                    self.power_group_power_units.is_set or
                                                                                                    self.power_group_redundancy_mode.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "power-group-available-current"):
                                                                                                    self.power_group_available_current = value
                                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-drawn-current"):
                                                                                                    self.power_group_drawn_current = value
                                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-power-units"):
                                                                                                    self.power_group_power_units = value
                                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                                    self.power_group_redundancy_mode = value
                                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                        class EnvSensorInfoXml(Entity):
                                                                                            """
                                                                                            Environment sensor info XML
                                                                                            
                                                                                            .. attribute:: data_type
                                                                                            
                                                                                            	Sensor data type
                                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	Device Name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: status
                                                                                            
                                                                                            	Sensor operation state
                                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                            
                                                                                            .. attribute:: threshold
                                                                                            
                                                                                            	Threshold information
                                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                            
                                                                                            .. attribute:: units
                                                                                            
                                                                                            	Units of variable being read
                                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                            
                                                                                            .. attribute:: update_rate
                                                                                            
                                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                                self.value = YLeaf(YType.str, "value")

                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                                self._children_yang_names.add("threshold")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("data_type",
                                                                                                                "description",
                                                                                                                "status",
                                                                                                                "units",
                                                                                                                "update_rate",
                                                                                                                "value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                            class Threshold(Entity):
                                                                                                """
                                                                                                Threshold information
                                                                                                
                                                                                                .. attribute:: threshold_array
                                                                                                
                                                                                                	Array of threshold
                                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                                    self.yang_name = "threshold"
                                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                                    self.threshold_array = YList(self)

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in () and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                                class ThresholdArray(Entity):
                                                                                                    """
                                                                                                    Array of threshold
                                                                                                    
                                                                                                    .. attribute:: threshold_name
                                                                                                    
                                                                                                    	Threshold name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..50
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** \-2147483648..2147483647
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                        self.yang_name = "threshold-array"
                                                                                                        self.yang_parent_name = "threshold"

                                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_name",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_name.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-name"):
                                                                                                            self.threshold_name = value
                                                                                                            self.threshold_name.value_namespace = name_space
                                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_data()):
                                                                                                            return True
                                                                                                    return False

                                                                                                def has_operation(self):
                                                                                                    for c in self.threshold_array:
                                                                                                        if (c.has_operation()):
                                                                                                            return True
                                                                                                    return self.yfilter != YFilter.not_set

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "threshold" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "threshold-array"):
                                                                                                        for c in self.threshold_array:
                                                                                                            segment = c.get_segment_path()
                                                                                                            if (segment_path == segment):
                                                                                                                return c
                                                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                        c.parent = self
                                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                        self._local_refs[local_reference_key] = c
                                                                                                        self.threshold_array.append(c)
                                                                                                        return c

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "threshold-array"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.data_type.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.status.is_set or
                                                                                                    self.units.is_set or
                                                                                                    self.update_rate.is_set or
                                                                                                    self.value.is_set or
                                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "threshold"):
                                                                                                    if (self.threshold is None):
                                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                        self.threshold.parent = self
                                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                                    return self.threshold

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "data-type"):
                                                                                                    self.data_type = value
                                                                                                    self.data_type.value_namespace = name_space
                                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "status"):
                                                                                                    self.status = value
                                                                                                    self.status.value_namespace = name_space
                                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "units"):
                                                                                                    self.units = value
                                                                                                    self.units.value_namespace = name_space
                                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "update-rate"):
                                                                                                    self.update_rate = value
                                                                                                    self.update_rate.value_namespace = name_space
                                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "value"):
                                                                                                    self.value = value
                                                                                                    self.value.value_namespace = name_space
                                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                                        class InvAssetBag(Entity):
                                                                                            """
                                                                                            Inventory Asset Bag
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_number
                                                                                            
                                                                                            	Manufacture Assembly number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_assembly_revision
                                                                                            
                                                                                            	Manufacture assembly revision
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                            
                                                                                            	Common Language Equipment           Identifier number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: manufacturer_software_identifier
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                                            
                                                                                            	String containing OEM information           if applicable
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: part_number
                                                                                            
                                                                                            	
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__init__()

                                                                                                self.yang_name = "inv-asset-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                                "manufacturer_assembly_revision",
                                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                                "manufacturer_firmware_identifier",
                                                                                                                "manufacturer_software_identifier",
                                                                                                                "original_equipment_manufacturer_string",
                                                                                                                "part_number") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                                    self.part_number.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                                    self.manufacturer_assembly_number = value
                                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                                    self.manufacturer_assembly_revision = value
                                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                                    self.manufacturer_firmware_identifier = value
                                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                                    self.manufacturer_software_identifier = value
                                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                                    self.original_equipment_manufacturer_string = value
                                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "part-number"):
                                                                                                    self.part_number = value
                                                                                                    self.part_number.value_namespace = name_space
                                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                                        class Threshold(Entity):
                                                                                            """
                                                                                            Threshold
                                                                                            
                                                                                            .. attribute:: critical_hi
                                                                                            
                                                                                            	Critical High
                                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi>`
                                                                                            
                                                                                            .. attribute:: critical_lo
                                                                                            
                                                                                            	Critical Low
                                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo>`
                                                                                            
                                                                                            .. attribute:: major_hi
                                                                                            
                                                                                            	Major High
                                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi>`
                                                                                            
                                                                                            .. attribute:: major_lo
                                                                                            
                                                                                            	Major Low
                                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo>`
                                                                                            
                                                                                            .. attribute:: minor_hi
                                                                                            
                                                                                            	Minor High
                                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi>`
                                                                                            
                                                                                            .. attribute:: minor_lo
                                                                                            
                                                                                            	Minor Low
                                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold, self).__init__()

                                                                                                self.yang_name = "threshold"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                self._children_yang_names.add("critical-hi")

                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                self._children_yang_names.add("critical-lo")

                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                                self._children_yang_names.add("major-hi")

                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                                self._children_yang_names.add("major-lo")

                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                self._children_yang_names.add("minor-hi")

                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                self._children_yang_names.add("minor-lo")


                                                                                            class MajorLo(Entity):
                                                                                                """
                                                                                                Major Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo, self).__init__()

                                                                                                    self.yang_name = "major-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalHi(Entity):
                                                                                                """
                                                                                                Critical High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                                    self.yang_name = "critical-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorHi(Entity):
                                                                                                """
                                                                                                Minor High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi, self).__init__()

                                                                                                    self.yang_name = "minor-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MajorHi(Entity):
                                                                                                """
                                                                                                Major High
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi, self).__init__()

                                                                                                    self.yang_name = "major-hi"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "major-hi"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class CriticalLo(Entity):
                                                                                                """
                                                                                                Critical Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                                    self.yang_name = "critical-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "critical-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass


                                                                                            class MinorLo(Entity):
                                                                                                """
                                                                                                Minor Low
                                                                                                
                                                                                                .. attribute:: thresh_bag
                                                                                                
                                                                                                	Environment threshold info
                                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo, self).__init__()

                                                                                                    self.yang_name = "minor-lo"
                                                                                                    self.yang_parent_name = "threshold"

                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                                class ThreshBag(Entity):
                                                                                                    """
                                                                                                    Environment threshold info
                                                                                                    
                                                                                                    .. attribute:: threshold_evaluation
                                                                                                    
                                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_notification_enabled
                                                                                                    
                                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: threshold_relation
                                                                                                    
                                                                                                    	Indicates relation between sensor value and threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_severity
                                                                                                    
                                                                                                    	Indicates minor, major, critical severities
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: threshold_value
                                                                                                    
                                                                                                    	Value of the configured threshold
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                        self.yang_name = "thresh-bag"
                                                                                                        self.yang_parent_name = "minor-lo"

                                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("threshold_evaluation",
                                                                                                                        "threshold_notification_enabled",
                                                                                                                        "threshold_relation",
                                                                                                                        "threshold_severity",
                                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.threshold_evaluation.is_set or
                                                                                                            self.threshold_notification_enabled.is_set or
                                                                                                            self.threshold_relation.is_set or
                                                                                                            self.threshold_severity.is_set or
                                                                                                            self.threshold_value.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "threshold-evaluation"):
                                                                                                            self.threshold_evaluation = value
                                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                                            self.threshold_notification_enabled = value
                                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-relation"):
                                                                                                            self.threshold_relation = value
                                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-severity"):
                                                                                                            self.threshold_severity = value
                                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "threshold-value"):
                                                                                                            self.threshold_value = value
                                                                                                            self.threshold_value.value_namespace = name_space
                                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                                        if (self.thresh_bag is None):
                                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                            self.thresh_bag.parent = self
                                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                        return self.thresh_bag

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "thresh-bag"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    pass

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "critical-hi"):
                                                                                                    if (self.critical_hi is None):
                                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalHi()
                                                                                                        self.critical_hi.parent = self
                                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                                    return self.critical_hi

                                                                                                if (child_yang_name == "critical-lo"):
                                                                                                    if (self.critical_lo is None):
                                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.CriticalLo()
                                                                                                        self.critical_lo.parent = self
                                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                                    return self.critical_lo

                                                                                                if (child_yang_name == "major-hi"):
                                                                                                    if (self.major_hi is None):
                                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorHi()
                                                                                                        self.major_hi.parent = self
                                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                                    return self.major_hi

                                                                                                if (child_yang_name == "major-lo"):
                                                                                                    if (self.major_lo is None):
                                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MajorLo()
                                                                                                        self.major_lo.parent = self
                                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                                    return self.major_lo

                                                                                                if (child_yang_name == "minor-hi"):
                                                                                                    if (self.minor_hi is None):
                                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorHi()
                                                                                                        self.minor_hi.parent = self
                                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                                    return self.minor_hi

                                                                                                if (child_yang_name == "minor-lo"):
                                                                                                    if (self.minor_lo is None):
                                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold.MinorLo()
                                                                                                        self.minor_lo.parent = self
                                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                                    return self.minor_lo

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                pass


                                                                                        class FruInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM FRU info
                                                                                            
                                                                                            .. attribute:: card_administrative_state
                                                                                            
                                                                                            	card admin state\: shutdown or not
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_monitor_state
                                                                                            
                                                                                            	card is monitored by a manager or left unmonitored
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_operational_state
                                                                                            
                                                                                            	card operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: card_reset_reason
                                                                                            
                                                                                            	card reset reason enum
                                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                            
                                                                                            .. attribute:: card_up_time
                                                                                            
                                                                                            	card up time
                                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime>`
                                                                                            
                                                                                            .. attribute:: last_operational_state_change
                                                                                            
                                                                                            	last card oper change state
                                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                            
                                                                                            .. attribute:: power_administrative_state
                                                                                            
                                                                                            	power admin state\: up or down
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_current_measurement
                                                                                            
                                                                                            	power current\: not implemented
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: power_operational_state
                                                                                            
                                                                                            	Power operation state
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__init__()

                                                                                                self.yang_name = "fru-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                self._children_yang_names.add("card-up-time")

                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("card_administrative_state",
                                                                                                                "card_monitor_state",
                                                                                                                "card_operational_state",
                                                                                                                "card_reset_reason",
                                                                                                                "power_administrative_state",
                                                                                                                "power_current_measurement",
                                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                            class LastOperationalStateChange(Entity):
                                                                                                """
                                                                                                last card oper change state
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                                    self.yang_name = "last-operational-state-change"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                            class CardUpTime(Entity):
                                                                                                """
                                                                                                card up time
                                                                                                
                                                                                                .. attribute:: time_in_nano_seconds
                                                                                                
                                                                                                	Time Value in Nano\-seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: nanosecond
                                                                                                
                                                                                                .. attribute:: time_in_seconds
                                                                                                
                                                                                                	Time Value in Seconds
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** \-2147483648..2147483647
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                                    self.yang_name = "card-up-time"
                                                                                                    self.yang_parent_name = "fru-info"

                                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("time_in_nano_seconds",
                                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.time_in_nano_seconds.is_set or
                                                                                                        self.time_in_seconds.is_set)

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                                        self.time_in_nano_seconds = value
                                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "time-in-seconds"):
                                                                                                        self.time_in_seconds = value
                                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.card_administrative_state.is_set or
                                                                                                    self.card_monitor_state.is_set or
                                                                                                    self.card_operational_state.is_set or
                                                                                                    self.card_reset_reason.is_set or
                                                                                                    self.power_administrative_state.is_set or
                                                                                                    self.power_current_measurement.is_set or
                                                                                                    self.power_operational_state.is_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "fru-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "card-up-time"):
                                                                                                    if (self.card_up_time is None):
                                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.CardUpTime()
                                                                                                        self.card_up_time.parent = self
                                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                                    return self.card_up_time

                                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                                    if (self.last_operational_state_change is None):
                                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                        self.last_operational_state_change.parent = self
                                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                                    return self.last_operational_state_change

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "card-administrative-state"):
                                                                                                    self.card_administrative_state = value
                                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-monitor-state"):
                                                                                                    self.card_monitor_state = value
                                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-operational-state"):
                                                                                                    self.card_operational_state = value
                                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "card-reset-reason"):
                                                                                                    self.card_reset_reason = value
                                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-administrative-state"):
                                                                                                    self.power_administrative_state = value
                                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-current-measurement"):
                                                                                                    self.power_current_measurement = value
                                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "power-operational-state"):
                                                                                                    self.power_operational_state = value
                                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                        class InvBasicBag(Entity):
                                                                                            """
                                                                                            Inventory Basic Bag
                                                                                            
                                                                                            .. attribute:: alias
                                                                                            
                                                                                            	useful for storing an entity alias 
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_id_str
                                                                                            
                                                                                            	asset Identification string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: asset_identification
                                                                                            
                                                                                            	asset Identification
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: ceport
                                                                                            
                                                                                            	1 if ce port found, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: chip_hardware_revision
                                                                                            
                                                                                            	chip module hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: composite_class_code
                                                                                            
                                                                                            	Major&minor class of the entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	describes in user\-readable terms       what the entity in question does
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: environmental_monitor_path
                                                                                            
                                                                                            	sysdb name of sensor in the envmon EDM
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: firmware_revision
                                                                                            
                                                                                            	firmware revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: group_flag
                                                                                            
                                                                                            	indicates if this entity is group       or not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: hardware_revision
                                                                                            
                                                                                            	hw revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: is_field_replaceable_unit
                                                                                            
                                                                                            	1 if Field Replaceable Unit 0, if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: manufacturer_asset_tags
                                                                                            
                                                                                            	Manufacture Asset Tags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: manufacturer_name
                                                                                            
                                                                                            	manufacturer's name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: memory_size
                                                                                            
                                                                                            	Size of memory associated with       the entity where applicable
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: model_name
                                                                                            
                                                                                            	model name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: name
                                                                                            
                                                                                            	name string for the entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: new_deviation_number
                                                                                            
                                                                                            	integer value for New Deviation Number 0x88
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: physical_layer_interface_module_type
                                                                                            
                                                                                            	integer value for plim type if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: redundancystate
                                                                                            
                                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: serial_number
                                                                                            
                                                                                            	serial number
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: software_revision
                                                                                            
                                                                                            	software revision string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: unique_id
                                                                                            
                                                                                            	Unique id for an entity
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            .. attribute:: unrecognized_fru
                                                                                            
                                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: vendor_type
                                                                                            
                                                                                            	maps to the vendor OID string
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: xr_scoped
                                                                                            
                                                                                            	1 if xr scoped, 0 if not
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__init__()

                                                                                                self.yang_name = "inv-basic-bag"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                                self.name = YLeaf(YType.str, "name")

                                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("alias",
                                                                                                                "asset_id_str",
                                                                                                                "asset_identification",
                                                                                                                "ceport",
                                                                                                                "chip_hardware_revision",
                                                                                                                "composite_class_code",
                                                                                                                "description",
                                                                                                                "environmental_monitor_path",
                                                                                                                "firmware_revision",
                                                                                                                "group_flag",
                                                                                                                "hardware_revision",
                                                                                                                "is_field_replaceable_unit",
                                                                                                                "manufacturer_asset_tags",
                                                                                                                "manufacturer_name",
                                                                                                                "memory_size",
                                                                                                                "model_name",
                                                                                                                "name",
                                                                                                                "new_deviation_number",
                                                                                                                "physical_layer_interface_module_type",
                                                                                                                "redundancystate",
                                                                                                                "serial_number",
                                                                                                                "software_revision",
                                                                                                                "unique_id",
                                                                                                                "unrecognized_fru",
                                                                                                                "vendor_type",
                                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.alias.is_set or
                                                                                                    self.asset_id_str.is_set or
                                                                                                    self.asset_identification.is_set or
                                                                                                    self.ceport.is_set or
                                                                                                    self.chip_hardware_revision.is_set or
                                                                                                    self.composite_class_code.is_set or
                                                                                                    self.description.is_set or
                                                                                                    self.environmental_monitor_path.is_set or
                                                                                                    self.firmware_revision.is_set or
                                                                                                    self.group_flag.is_set or
                                                                                                    self.hardware_revision.is_set or
                                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                                    self.manufacturer_name.is_set or
                                                                                                    self.memory_size.is_set or
                                                                                                    self.model_name.is_set or
                                                                                                    self.name.is_set or
                                                                                                    self.new_deviation_number.is_set or
                                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                                    self.redundancystate.is_set or
                                                                                                    self.serial_number.is_set or
                                                                                                    self.software_revision.is_set or
                                                                                                    self.unique_id.is_set or
                                                                                                    self.unrecognized_fru.is_set or
                                                                                                    self.vendor_type.is_set or
                                                                                                    self.xr_scoped.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "alias"):
                                                                                                    self.alias = value
                                                                                                    self.alias.value_namespace = name_space
                                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-id-str"):
                                                                                                    self.asset_id_str = value
                                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "asset-identification"):
                                                                                                    self.asset_identification = value
                                                                                                    self.asset_identification.value_namespace = name_space
                                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "ceport"):
                                                                                                    self.ceport = value
                                                                                                    self.ceport.value_namespace = name_space
                                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "chip-hardware-revision"):
                                                                                                    self.chip_hardware_revision = value
                                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "composite-class-code"):
                                                                                                    self.composite_class_code = value
                                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "environmental-monitor-path"):
                                                                                                    self.environmental_monitor_path = value
                                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "firmware-revision"):
                                                                                                    self.firmware_revision = value
                                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "group-flag"):
                                                                                                    self.group_flag = value
                                                                                                    self.group_flag.value_namespace = name_space
                                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "hardware-revision"):
                                                                                                    self.hardware_revision = value
                                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                                    self.is_field_replaceable_unit = value
                                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                                    self.manufacturer_asset_tags = value
                                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "manufacturer-name"):
                                                                                                    self.manufacturer_name = value
                                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "memory-size"):
                                                                                                    self.memory_size = value
                                                                                                    self.memory_size.value_namespace = name_space
                                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "model-name"):
                                                                                                    self.model_name = value
                                                                                                    self.model_name.value_namespace = name_space
                                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "name"):
                                                                                                    self.name = value
                                                                                                    self.name.value_namespace = name_space
                                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "new-deviation-number"):
                                                                                                    self.new_deviation_number = value
                                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                                    self.physical_layer_interface_module_type = value
                                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "redundancystate"):
                                                                                                    self.redundancystate = value
                                                                                                    self.redundancystate.value_namespace = name_space
                                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "serial-number"):
                                                                                                    self.serial_number = value
                                                                                                    self.serial_number.value_namespace = name_space
                                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "software-revision"):
                                                                                                    self.software_revision = value
                                                                                                    self.software_revision.value_namespace = name_space
                                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unique-id"):
                                                                                                    self.unique_id = value
                                                                                                    self.unique_id.value_namespace = name_space
                                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "unrecognized-fru"):
                                                                                                    self.unrecognized_fru = value
                                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "vendor-type"):
                                                                                                    self.vendor_type = value
                                                                                                    self.vendor_type.value_namespace = name_space
                                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "xr-scoped"):
                                                                                                    self.xr_scoped = value
                                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                        class InvEepromInfo(Entity):
                                                                                            """
                                                                                            Inventory EDM EEPROM Information Bag
                                                                                            
                                                                                            .. attribute:: description
                                                                                            
                                                                                            	A textual description of physical entity
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: eeprom
                                                                                            
                                                                                            	EEPROM data not from hex data
                                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom>`
                                                                                            
                                                                                            .. attribute:: has_eeprom
                                                                                            
                                                                                            	use eeprom instead of opaque data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: inv_card_type
                                                                                            
                                                                                            	Inventory card type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: opaque_data
                                                                                            
                                                                                            	EEPROM hex data
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: opaque_data_size
                                                                                            
                                                                                            	size of the EEPROM hex data
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__init__()

                                                                                                self.yang_name = "inv-eeprom-info"
                                                                                                self.yang_parent_name = "attributes"

                                                                                                self.description = YLeaf(YType.str, "description")

                                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                                self._children_yang_names.add("eeprom")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("description",
                                                                                                                "has_eeprom",
                                                                                                                "inv_card_type",
                                                                                                                "opaque_data",
                                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                            class Eeprom(Entity):
                                                                                                """
                                                                                                EEPROM data not from hex data
                                                                                                
                                                                                                .. attribute:: asset_alias
                                                                                                
                                                                                                	Asset Alias
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: asset_id
                                                                                                
                                                                                                	Asset ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address1
                                                                                                
                                                                                                	Base Mac Address #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address2
                                                                                                
                                                                                                	Base Mac Address #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address3
                                                                                                
                                                                                                	Base Mac Address #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: base_mac_address4
                                                                                                
                                                                                                	Base Mac Address #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_checksum
                                                                                                
                                                                                                	Block Checksum
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_count
                                                                                                
                                                                                                	Block Count
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_length
                                                                                                
                                                                                                	Block Length
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_signature
                                                                                                
                                                                                                	Block Signature
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: block_version
                                                                                                
                                                                                                	Block Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: chassis_sid
                                                                                                
                                                                                                	Chassis serial number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: clei
                                                                                                
                                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_family
                                                                                                
                                                                                                	Controller family
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: controller_type
                                                                                                
                                                                                                	Controller type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: description
                                                                                                
                                                                                                	A textual description of physical entity
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num1
                                                                                                
                                                                                                	Deviation Number # 1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num2
                                                                                                
                                                                                                	Deviation Number # 2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num3
                                                                                                
                                                                                                	Deviation Number # 3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num4
                                                                                                
                                                                                                	Deviation Number # 4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num5
                                                                                                
                                                                                                	Deviation Number # 5
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num6
                                                                                                
                                                                                                	Deviation Number # 6
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: dev_num7
                                                                                                
                                                                                                	Deviation Number # 7
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eci
                                                                                                
                                                                                                	Equipment Catalog Item (ECI) number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: eeprom_size
                                                                                                
                                                                                                	EEPROM Size
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: engineer_use
                                                                                                
                                                                                                	Engineer Use
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_major_type
                                                                                                
                                                                                                	FRU Major Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: fru_minor_type
                                                                                                
                                                                                                	FRU Minor Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hw_version
                                                                                                
                                                                                                	Hardware Version
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: hwid
                                                                                                
                                                                                                	Hardware Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: idprom_format_rev
                                                                                                
                                                                                                	IDPROM Format Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size1
                                                                                                
                                                                                                	Mac Address Block Size #1
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size2
                                                                                                
                                                                                                	Mac Address Block Size #2
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size3
                                                                                                
                                                                                                	Mac Address Block Size #3
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mac_add_blk_size4
                                                                                                
                                                                                                	Mac Address Block Size #4
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: manu_test_data
                                                                                                
                                                                                                	Manufacturing Test Data
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_bits
                                                                                                
                                                                                                	MFG Bits
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: mfg_deviation
                                                                                                
                                                                                                	MFG Deviation
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: oem_string
                                                                                                
                                                                                                	OEM String
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_number
                                                                                                
                                                                                                	Part Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: part_revision
                                                                                                
                                                                                                	Part Revision
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pca_num
                                                                                                
                                                                                                	PCA number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcavid
                                                                                                
                                                                                                	PCA revision ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pcb_serial_num
                                                                                                
                                                                                                	PCB Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: pid
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_consumption
                                                                                                
                                                                                                	Power Consumption
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: power_supply_type
                                                                                                
                                                                                                	Power Supply Type
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: product_id
                                                                                                
                                                                                                	Product ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: rma
                                                                                                
                                                                                                	RMA Data
                                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                                
                                                                                                .. attribute:: rma_code
                                                                                                
                                                                                                	RMA Code
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: serial_number
                                                                                                
                                                                                                	Serial Number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: snmpoid
                                                                                                
                                                                                                	SNMP OID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_part_num
                                                                                                
                                                                                                	Top assembly part number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: top_assem_vid
                                                                                                
                                                                                                	Top assembly revision number
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_description
                                                                                                
                                                                                                	UDI description
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: udi_name
                                                                                                
                                                                                                	UDI name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                .. attribute:: vid
                                                                                                
                                                                                                	Version ID
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**length:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'invmgr-oper'
                                                                                                _revision = '2015-11-09'

                                                                                                def __init__(self):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                                    self.yang_name = "eeprom"
                                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                    self._children_yang_names.add("rma")

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._check_monkey_patching_error(name, value)
                                                                                                    with _handle_type_error():
                                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                "Please use list append or extend method."
                                                                                                                                .format(value))
                                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                                            value = value.name
                                                                                                        if name in ("asset_alias",
                                                                                                                    "asset_id",
                                                                                                                    "base_mac_address1",
                                                                                                                    "base_mac_address2",
                                                                                                                    "base_mac_address3",
                                                                                                                    "base_mac_address4",
                                                                                                                    "block_checksum",
                                                                                                                    "block_count",
                                                                                                                    "block_length",
                                                                                                                    "block_signature",
                                                                                                                    "block_version",
                                                                                                                    "chassis_sid",
                                                                                                                    "clei",
                                                                                                                    "controller_family",
                                                                                                                    "controller_type",
                                                                                                                    "description",
                                                                                                                    "dev_num1",
                                                                                                                    "dev_num2",
                                                                                                                    "dev_num3",
                                                                                                                    "dev_num4",
                                                                                                                    "dev_num5",
                                                                                                                    "dev_num6",
                                                                                                                    "dev_num7",
                                                                                                                    "eci",
                                                                                                                    "eeprom_size",
                                                                                                                    "engineer_use",
                                                                                                                    "fru_major_type",
                                                                                                                    "fru_minor_type",
                                                                                                                    "hw_version",
                                                                                                                    "hwid",
                                                                                                                    "idprom_format_rev",
                                                                                                                    "mac_add_blk_size1",
                                                                                                                    "mac_add_blk_size2",
                                                                                                                    "mac_add_blk_size3",
                                                                                                                    "mac_add_blk_size4",
                                                                                                                    "manu_test_data",
                                                                                                                    "mfg_bits",
                                                                                                                    "mfg_deviation",
                                                                                                                    "oem_string",
                                                                                                                    "part_number",
                                                                                                                    "part_revision",
                                                                                                                    "pca_num",
                                                                                                                    "pcavid",
                                                                                                                    "pcb_serial_num",
                                                                                                                    "pid",
                                                                                                                    "power_consumption",
                                                                                                                    "power_supply_type",
                                                                                                                    "product_id",
                                                                                                                    "rma_code",
                                                                                                                    "serial_number",
                                                                                                                    "snmpoid",
                                                                                                                    "top_assem_part_num",
                                                                                                                    "top_assem_vid",
                                                                                                                    "udi_description",
                                                                                                                    "udi_name",
                                                                                                                    "vid") and name in self.__dict__:
                                                                                                            if isinstance(value, YLeaf):
                                                                                                                self.__dict__[name].set(value.get())
                                                                                                            elif isinstance(value, YLeafList):
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                            else:
                                                                                                                self.__dict__[name].set(value)
                                                                                                        else:
                                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                    value.parent = self
                                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                    value.parent = self
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                                class Rma(Entity):
                                                                                                    """
                                                                                                    RMA Data
                                                                                                    
                                                                                                    .. attribute:: rma_history
                                                                                                    
                                                                                                    	RMA history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: rma_number
                                                                                                    
                                                                                                    	RMA tracking number format is N\-N\-N
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    .. attribute:: test_history
                                                                                                    
                                                                                                    	Test history
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**length:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'invmgr-oper'
                                                                                                    _revision = '2015-11-09'

                                                                                                    def __init__(self):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                        self.yang_name = "rma"
                                                                                                        self.yang_parent_name = "eeprom"

                                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._check_monkey_patching_error(name, value)
                                                                                                        with _handle_type_error():
                                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                                    "Please use list append or extend method."
                                                                                                                                    .format(value))
                                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                                value = value.name
                                                                                                            if name in ("rma_history",
                                                                                                                        "rma_number",
                                                                                                                        "test_history") and name in self.__dict__:
                                                                                                                if isinstance(value, YLeaf):
                                                                                                                    self.__dict__[name].set(value.get())
                                                                                                                elif isinstance(value, YLeafList):
                                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                                else:
                                                                                                                    self.__dict__[name].set(value)
                                                                                                            else:
                                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                        value.parent = self
                                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                        value.parent = self
                                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                                    def has_data(self):
                                                                                                        return (
                                                                                                            self.rma_history.is_set or
                                                                                                            self.rma_number.is_set or
                                                                                                            self.test_history.is_set)

                                                                                                    def has_operation(self):
                                                                                                        return (
                                                                                                            self.yfilter != YFilter.not_set or
                                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                                    def get_segment_path(self):
                                                                                                        path_buffer = ""
                                                                                                        path_buffer = "rma" + path_buffer

                                                                                                        return path_buffer

                                                                                                    def get_entity_path(self, ancestor):
                                                                                                        path_buffer = ""
                                                                                                        if (ancestor is None):
                                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                        else:
                                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                        leaf_name_data = LeafDataList()
                                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                        return entity_path

                                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                        if child is not None:
                                                                                                            return child

                                                                                                        return None

                                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                            return True
                                                                                                        return False

                                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                        if(value_path == "rma-history"):
                                                                                                            self.rma_history = value
                                                                                                            self.rma_history.value_namespace = name_space
                                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "rma-number"):
                                                                                                            self.rma_number = value
                                                                                                            self.rma_number.value_namespace = name_space
                                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                        if(value_path == "test-history"):
                                                                                                            self.test_history = value
                                                                                                            self.test_history.value_namespace = name_space
                                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                                def has_data(self):
                                                                                                    return (
                                                                                                        self.asset_alias.is_set or
                                                                                                        self.asset_id.is_set or
                                                                                                        self.base_mac_address1.is_set or
                                                                                                        self.base_mac_address2.is_set or
                                                                                                        self.base_mac_address3.is_set or
                                                                                                        self.base_mac_address4.is_set or
                                                                                                        self.block_checksum.is_set or
                                                                                                        self.block_count.is_set or
                                                                                                        self.block_length.is_set or
                                                                                                        self.block_signature.is_set or
                                                                                                        self.block_version.is_set or
                                                                                                        self.chassis_sid.is_set or
                                                                                                        self.clei.is_set or
                                                                                                        self.controller_family.is_set or
                                                                                                        self.controller_type.is_set or
                                                                                                        self.description.is_set or
                                                                                                        self.dev_num1.is_set or
                                                                                                        self.dev_num2.is_set or
                                                                                                        self.dev_num3.is_set or
                                                                                                        self.dev_num4.is_set or
                                                                                                        self.dev_num5.is_set or
                                                                                                        self.dev_num6.is_set or
                                                                                                        self.dev_num7.is_set or
                                                                                                        self.eci.is_set or
                                                                                                        self.eeprom_size.is_set or
                                                                                                        self.engineer_use.is_set or
                                                                                                        self.fru_major_type.is_set or
                                                                                                        self.fru_minor_type.is_set or
                                                                                                        self.hw_version.is_set or
                                                                                                        self.hwid.is_set or
                                                                                                        self.idprom_format_rev.is_set or
                                                                                                        self.mac_add_blk_size1.is_set or
                                                                                                        self.mac_add_blk_size2.is_set or
                                                                                                        self.mac_add_blk_size3.is_set or
                                                                                                        self.mac_add_blk_size4.is_set or
                                                                                                        self.manu_test_data.is_set or
                                                                                                        self.mfg_bits.is_set or
                                                                                                        self.mfg_deviation.is_set or
                                                                                                        self.oem_string.is_set or
                                                                                                        self.part_number.is_set or
                                                                                                        self.part_revision.is_set or
                                                                                                        self.pca_num.is_set or
                                                                                                        self.pcavid.is_set or
                                                                                                        self.pcb_serial_num.is_set or
                                                                                                        self.pid.is_set or
                                                                                                        self.power_consumption.is_set or
                                                                                                        self.power_supply_type.is_set or
                                                                                                        self.product_id.is_set or
                                                                                                        self.rma_code.is_set or
                                                                                                        self.serial_number.is_set or
                                                                                                        self.snmpoid.is_set or
                                                                                                        self.top_assem_part_num.is_set or
                                                                                                        self.top_assem_vid.is_set or
                                                                                                        self.udi_description.is_set or
                                                                                                        self.udi_name.is_set or
                                                                                                        self.vid.is_set or
                                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                                def has_operation(self):
                                                                                                    return (
                                                                                                        self.yfilter != YFilter.not_set or
                                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                                def get_segment_path(self):
                                                                                                    path_buffer = ""
                                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                                    return path_buffer

                                                                                                def get_entity_path(self, ancestor):
                                                                                                    path_buffer = ""
                                                                                                    if (ancestor is None):
                                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                    else:
                                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                    leaf_name_data = LeafDataList()
                                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                    return entity_path

                                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                    if child is not None:
                                                                                                        return child

                                                                                                    if (child_yang_name == "rma"):
                                                                                                        if (self.rma is None):
                                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                            self.rma.parent = self
                                                                                                            self._children_name_map["rma"] = "rma"
                                                                                                        return self.rma

                                                                                                    return None

                                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                        return True
                                                                                                    return False

                                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                    if(value_path == "asset-alias"):
                                                                                                        self.asset_alias = value
                                                                                                        self.asset_alias.value_namespace = name_space
                                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "asset-id"):
                                                                                                        self.asset_id = value
                                                                                                        self.asset_id.value_namespace = name_space
                                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address1"):
                                                                                                        self.base_mac_address1 = value
                                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address2"):
                                                                                                        self.base_mac_address2 = value
                                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address3"):
                                                                                                        self.base_mac_address3 = value
                                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "base-mac-address4"):
                                                                                                        self.base_mac_address4 = value
                                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-checksum"):
                                                                                                        self.block_checksum = value
                                                                                                        self.block_checksum.value_namespace = name_space
                                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-count"):
                                                                                                        self.block_count = value
                                                                                                        self.block_count.value_namespace = name_space
                                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-length"):
                                                                                                        self.block_length = value
                                                                                                        self.block_length.value_namespace = name_space
                                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-signature"):
                                                                                                        self.block_signature = value
                                                                                                        self.block_signature.value_namespace = name_space
                                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "block-version"):
                                                                                                        self.block_version = value
                                                                                                        self.block_version.value_namespace = name_space
                                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "chassis-sid"):
                                                                                                        self.chassis_sid = value
                                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "clei"):
                                                                                                        self.clei = value
                                                                                                        self.clei.value_namespace = name_space
                                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-family"):
                                                                                                        self.controller_family = value
                                                                                                        self.controller_family.value_namespace = name_space
                                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "controller-type"):
                                                                                                        self.controller_type = value
                                                                                                        self.controller_type.value_namespace = name_space
                                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "description"):
                                                                                                        self.description = value
                                                                                                        self.description.value_namespace = name_space
                                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num1"):
                                                                                                        self.dev_num1 = value
                                                                                                        self.dev_num1.value_namespace = name_space
                                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num2"):
                                                                                                        self.dev_num2 = value
                                                                                                        self.dev_num2.value_namespace = name_space
                                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num3"):
                                                                                                        self.dev_num3 = value
                                                                                                        self.dev_num3.value_namespace = name_space
                                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num4"):
                                                                                                        self.dev_num4 = value
                                                                                                        self.dev_num4.value_namespace = name_space
                                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num5"):
                                                                                                        self.dev_num5 = value
                                                                                                        self.dev_num5.value_namespace = name_space
                                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num6"):
                                                                                                        self.dev_num6 = value
                                                                                                        self.dev_num6.value_namespace = name_space
                                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "dev-num7"):
                                                                                                        self.dev_num7 = value
                                                                                                        self.dev_num7.value_namespace = name_space
                                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eci"):
                                                                                                        self.eci = value
                                                                                                        self.eci.value_namespace = name_space
                                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "eeprom-size"):
                                                                                                        self.eeprom_size = value
                                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "engineer-use"):
                                                                                                        self.engineer_use = value
                                                                                                        self.engineer_use.value_namespace = name_space
                                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-major-type"):
                                                                                                        self.fru_major_type = value
                                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "fru-minor-type"):
                                                                                                        self.fru_minor_type = value
                                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hw-version"):
                                                                                                        self.hw_version = value
                                                                                                        self.hw_version.value_namespace = name_space
                                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "hwid"):
                                                                                                        self.hwid = value
                                                                                                        self.hwid.value_namespace = name_space
                                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "idprom-format-rev"):
                                                                                                        self.idprom_format_rev = value
                                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                                        self.mac_add_blk_size1 = value
                                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                                        self.mac_add_blk_size2 = value
                                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                                        self.mac_add_blk_size3 = value
                                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                                        self.mac_add_blk_size4 = value
                                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "manu-test-data"):
                                                                                                        self.manu_test_data = value
                                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-bits"):
                                                                                                        self.mfg_bits = value
                                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "mfg-deviation"):
                                                                                                        self.mfg_deviation = value
                                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "oem-string"):
                                                                                                        self.oem_string = value
                                                                                                        self.oem_string.value_namespace = name_space
                                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-number"):
                                                                                                        self.part_number = value
                                                                                                        self.part_number.value_namespace = name_space
                                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "part-revision"):
                                                                                                        self.part_revision = value
                                                                                                        self.part_revision.value_namespace = name_space
                                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pca-num"):
                                                                                                        self.pca_num = value
                                                                                                        self.pca_num.value_namespace = name_space
                                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcavid"):
                                                                                                        self.pcavid = value
                                                                                                        self.pcavid.value_namespace = name_space
                                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pcb-serial-num"):
                                                                                                        self.pcb_serial_num = value
                                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "pid"):
                                                                                                        self.pid = value
                                                                                                        self.pid.value_namespace = name_space
                                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-consumption"):
                                                                                                        self.power_consumption = value
                                                                                                        self.power_consumption.value_namespace = name_space
                                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "power-supply-type"):
                                                                                                        self.power_supply_type = value
                                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "product-id"):
                                                                                                        self.product_id = value
                                                                                                        self.product_id.value_namespace = name_space
                                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "rma-code"):
                                                                                                        self.rma_code = value
                                                                                                        self.rma_code.value_namespace = name_space
                                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "serial-number"):
                                                                                                        self.serial_number = value
                                                                                                        self.serial_number.value_namespace = name_space
                                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "snmpoid"):
                                                                                                        self.snmpoid = value
                                                                                                        self.snmpoid.value_namespace = name_space
                                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-part-num"):
                                                                                                        self.top_assem_part_num = value
                                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "top-assem-vid"):
                                                                                                        self.top_assem_vid = value
                                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-description"):
                                                                                                        self.udi_description = value
                                                                                                        self.udi_description.value_namespace = name_space
                                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "udi-name"):
                                                                                                        self.udi_name = value
                                                                                                        self.udi_name.value_namespace = name_space
                                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                                    if(value_path == "vid"):
                                                                                                        self.vid = value
                                                                                                        self.vid.value_namespace = name_space
                                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.description.is_set or
                                                                                                    self.has_eeprom.is_set or
                                                                                                    self.inv_card_type.is_set or
                                                                                                    self.opaque_data.is_set or
                                                                                                    self.opaque_data_size.is_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                if (child_yang_name == "eeprom"):
                                                                                                    if (self.eeprom is None):
                                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo.Eeprom()
                                                                                                        self.eeprom.parent = self
                                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                                    return self.eeprom

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "description"):
                                                                                                    self.description = value
                                                                                                    self.description.value_namespace = name_space
                                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "has-eeprom"):
                                                                                                    self.has_eeprom = value
                                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "inv-card-type"):
                                                                                                    self.inv_card_type = value
                                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data"):
                                                                                                    self.opaque_data = value
                                                                                                    self.opaque_data.value_namespace = name_space
                                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "opaque-data-size"):
                                                                                                    self.opaque_data_size = value
                                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.module_done.is_set or
                                                                                                self.node_id.is_set or
                                                                                                self.vm_done.is_set or
                                                                                                self.vm_node_id.is_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "attributes" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                                if (self.env_sensor_info is None):
                                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfo()
                                                                                                    self.env_sensor_info.parent = self
                                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                                return self.env_sensor_info

                                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                                if (self.env_sensor_info_xml is None):
                                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.EnvSensorInfoXml()
                                                                                                    self.env_sensor_info_xml.parent = self
                                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                                return self.env_sensor_info_xml

                                                                                            if (child_yang_name == "fru-info"):
                                                                                                if (self.fru_info is None):
                                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.FruInfo()
                                                                                                    self.fru_info.parent = self
                                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                                return self.fru_info

                                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                                if (self.inv_asset_bag is None):
                                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvAssetBag()
                                                                                                    self.inv_asset_bag.parent = self
                                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                                return self.inv_asset_bag

                                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                                if (self.inv_basic_bag is None):
                                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvBasicBag()
                                                                                                    self.inv_basic_bag.parent = self
                                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                                return self.inv_basic_bag

                                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                                if (self.inv_eeprom_info is None):
                                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.InvEepromInfo()
                                                                                                    self.inv_eeprom_info.parent = self
                                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                                return self.inv_eeprom_info

                                                                                            if (child_yang_name == "pwg-info"):
                                                                                                if (self.pwg_info is None):
                                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.PwgInfo()
                                                                                                    self.pwg_info.parent = self
                                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                                return self.pwg_info

                                                                                            if (child_yang_name == "threshold"):
                                                                                                if (self.threshold is None):
                                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes.Threshold()
                                                                                                    self.threshold.parent = self
                                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                                return self.threshold

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "module-done"):
                                                                                                self.module_done = value
                                                                                                self.module_done.value_namespace = name_space
                                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "node-id"):
                                                                                                self.node_id = value
                                                                                                self.node_id.value_namespace = name_space
                                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-done"):
                                                                                                self.vm_done = value
                                                                                                self.vm_done.value_namespace = name_space
                                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vm-node-id"):
                                                                                                self.vm_node_id = value
                                                                                                self.vm_node_id.value_namespace = name_space
                                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.name.is_set or
                                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                                            (self.tsi9s is not None and self.tsi9s.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "tsi8" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "attributes"):
                                                                                            if (self.attributes is None):
                                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Attributes()
                                                                                                self.attributes.parent = self
                                                                                                self._children_name_map["attributes"] = "attributes"
                                                                                            return self.attributes

                                                                                        if (child_yang_name == "tsi9s"):
                                                                                            if (self.tsi9s is None):
                                                                                                self.tsi9s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8.Tsi9S()
                                                                                                self.tsi9s.parent = self
                                                                                                self._children_name_map["tsi9s"] = "tsi9s"
                                                                                            return self.tsi9s

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "attributes" or name == "tsi9s" or name == "name"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.tsi8:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "tsi8s" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "tsi8"):
                                                                                        for c in self.tsi8:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S.Tsi8()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.tsi8.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "tsi8"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class Attributes(Entity):
                                                                                """
                                                                                Attributes
                                                                                
                                                                                .. attribute:: env_sensor_info
                                                                                
                                                                                	Environment sensor info
                                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo>`
                                                                                
                                                                                .. attribute:: env_sensor_info_xml
                                                                                
                                                                                	Environment sensor info XML
                                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml>`
                                                                                
                                                                                .. attribute:: fru_info
                                                                                
                                                                                	Inventory EDM FRU info
                                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo>`
                                                                                
                                                                                .. attribute:: inv_asset_bag
                                                                                
                                                                                	Inventory Asset Bag
                                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag>`
                                                                                
                                                                                .. attribute:: inv_basic_bag
                                                                                
                                                                                	Inventory Basic Bag
                                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag>`
                                                                                
                                                                                .. attribute:: inv_eeprom_info
                                                                                
                                                                                	Inventory EDM EEPROM Information Bag
                                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo>`
                                                                                
                                                                                .. attribute:: module_done
                                                                                
                                                                                	Inventory EDM Module Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**default value**\: 1
                                                                                
                                                                                .. attribute:: node_id
                                                                                
                                                                                	Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pwg_info
                                                                                
                                                                                	Inventory EDM PWG info
                                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo>`
                                                                                
                                                                                .. attribute:: threshold
                                                                                
                                                                                	Threshold
                                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold>`
                                                                                
                                                                                .. attribute:: vm_done
                                                                                
                                                                                	VM Done Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                .. attribute:: vm_node_id
                                                                                
                                                                                	VM Node ID Tuple
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__init__()

                                                                                    self.yang_name = "attributes"
                                                                                    self.yang_parent_name = "tsi7"

                                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                    self._children_yang_names.add("env-sensor-info")

                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                    self._children_yang_names.add("fru-info")

                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                    self._children_yang_names.add("pwg-info")

                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                    self._children_yang_names.add("threshold")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("module_done",
                                                                                                    "node_id",
                                                                                                    "vm_done",
                                                                                                    "vm_node_id") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes, self).__setattr__(name, value)


                                                                                class EnvSensorInfo(Entity):
                                                                                    """
                                                                                    Environment sensor info
                                                                                    
                                                                                    .. attribute:: age_time_stamp
                                                                                    
                                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: alarm_type
                                                                                    
                                                                                    	Indicates threshold violation
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: device_description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: device_id
                                                                                    
                                                                                    	Identifier for this device
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: field_validity_bitmap
                                                                                    
                                                                                    	Sensor valid bitmap
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: precision
                                                                                    
                                                                                    	Sensor precision range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: scale
                                                                                    
                                                                                    	Sensor scale enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state enums
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__init__()

                                                                                        self.yang_name = "env-sensor-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                                        self.units = YLeaf(YType.str, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("age_time_stamp",
                                                                                                        "alarm_type",
                                                                                                        "data_type",
                                                                                                        "device_description",
                                                                                                        "device_id",
                                                                                                        "field_validity_bitmap",
                                                                                                        "precision",
                                                                                                        "scale",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.age_time_stamp.is_set or
                                                                                            self.alarm_type.is_set or
                                                                                            self.data_type.is_set or
                                                                                            self.device_description.is_set or
                                                                                            self.device_id.is_set or
                                                                                            self.field_validity_bitmap.is_set or
                                                                                            self.precision.is_set or
                                                                                            self.scale.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                            self.precision.yfilter != YFilter.not_set or
                                                                                            self.scale.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "age-time-stamp"):
                                                                                            self.age_time_stamp = value
                                                                                            self.age_time_stamp.value_namespace = name_space
                                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "alarm-type"):
                                                                                            self.alarm_type = value
                                                                                            self.alarm_type.value_namespace = name_space
                                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-description"):
                                                                                            self.device_description = value
                                                                                            self.device_description.value_namespace = name_space
                                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "device-id"):
                                                                                            self.device_id = value
                                                                                            self.device_id.value_namespace = name_space
                                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "field-validity-bitmap"):
                                                                                            self.field_validity_bitmap = value
                                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "precision"):
                                                                                            self.precision = value
                                                                                            self.precision.value_namespace = name_space
                                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "scale"):
                                                                                            self.scale = value
                                                                                            self.scale.value_namespace = name_space
                                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class PwgInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM PWG info
                                                                                    
                                                                                    .. attribute:: power_group_available_current
                                                                                    
                                                                                    	available current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_drawn_current
                                                                                    
                                                                                    	drawn current
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_group_power_units
                                                                                    
                                                                                    	power units
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: power_group_redundancy_mode
                                                                                    
                                                                                    	redundancy mode
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__init__()

                                                                                        self.yang_name = "pwg-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("power_group_available_current",
                                                                                                        "power_group_drawn_current",
                                                                                                        "power_group_power_units",
                                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.power_group_available_current.is_set or
                                                                                            self.power_group_drawn_current.is_set or
                                                                                            self.power_group_power_units.is_set or
                                                                                            self.power_group_redundancy_mode.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "pwg-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "power-group-available-current"):
                                                                                            self.power_group_available_current = value
                                                                                            self.power_group_available_current.value_namespace = name_space
                                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-drawn-current"):
                                                                                            self.power_group_drawn_current = value
                                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-power-units"):
                                                                                            self.power_group_power_units = value
                                                                                            self.power_group_power_units.value_namespace = name_space
                                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                                            self.power_group_redundancy_mode = value
                                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                                class EnvSensorInfoXml(Entity):
                                                                                    """
                                                                                    Environment sensor info XML
                                                                                    
                                                                                    .. attribute:: data_type
                                                                                    
                                                                                    	Sensor data type
                                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	Device Name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: status
                                                                                    
                                                                                    	Sensor operation state
                                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                                    
                                                                                    .. attribute:: threshold
                                                                                    
                                                                                    	Threshold information
                                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold>`
                                                                                    
                                                                                    .. attribute:: units
                                                                                    
                                                                                    	Units of variable being read
                                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                                    
                                                                                    .. attribute:: update_rate
                                                                                    
                                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                        self.yang_name = "env-sensor-info-xml"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                        self.value = YLeaf(YType.str, "value")

                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                        self._children_yang_names.add("threshold")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("data_type",
                                                                                                        "description",
                                                                                                        "status",
                                                                                                        "units",
                                                                                                        "update_rate",
                                                                                                        "value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                                    class Threshold(Entity):
                                                                                        """
                                                                                        Threshold information
                                                                                        
                                                                                        .. attribute:: threshold_array
                                                                                        
                                                                                        	Array of threshold
                                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                            self.yang_name = "threshold"
                                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                                            self.threshold_array = YList(self)

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in () and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                        class ThresholdArray(Entity):
                                                                                            """
                                                                                            Array of threshold
                                                                                            
                                                                                            .. attribute:: threshold_name
                                                                                            
                                                                                            	Threshold name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..50
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** \-2147483648..2147483647
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                                self.yang_name = "threshold-array"
                                                                                                self.yang_parent_name = "threshold"

                                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_name",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_name.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-name"):
                                                                                                    self.threshold_name = value
                                                                                                    self.threshold_name.value_namespace = name_space
                                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_data()):
                                                                                                    return True
                                                                                            return False

                                                                                        def has_operation(self):
                                                                                            for c in self.threshold_array:
                                                                                                if (c.has_operation()):
                                                                                                    return True
                                                                                            return self.yfilter != YFilter.not_set

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "threshold" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "threshold-array"):
                                                                                                for c in self.threshold_array:
                                                                                                    segment = c.get_segment_path()
                                                                                                    if (segment_path == segment):
                                                                                                        return c
                                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                                c.parent = self
                                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                                self._local_refs[local_reference_key] = c
                                                                                                self.threshold_array.append(c)
                                                                                                return c

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "threshold-array"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.data_type.is_set or
                                                                                            self.description.is_set or
                                                                                            self.status.is_set or
                                                                                            self.units.is_set or
                                                                                            self.update_rate.is_set or
                                                                                            self.value.is_set or
                                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.status.yfilter != YFilter.not_set or
                                                                                            self.units.yfilter != YFilter.not_set or
                                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                                            self.value.yfilter != YFilter.not_set or
                                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "threshold"):
                                                                                            if (self.threshold is None):
                                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml.Threshold()
                                                                                                self.threshold.parent = self
                                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                            return self.threshold

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "data-type"):
                                                                                            self.data_type = value
                                                                                            self.data_type.value_namespace = name_space
                                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "status"):
                                                                                            self.status = value
                                                                                            self.status.value_namespace = name_space
                                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "units"):
                                                                                            self.units = value
                                                                                            self.units.value_namespace = name_space
                                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "update-rate"):
                                                                                            self.update_rate = value
                                                                                            self.update_rate.value_namespace = name_space
                                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "value"):
                                                                                            self.value = value
                                                                                            self.value.value_namespace = name_space
                                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                                class InvAssetBag(Entity):
                                                                                    """
                                                                                    Inventory Asset Bag
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_number
                                                                                    
                                                                                    	Manufacture Assembly number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_assembly_revision
                                                                                    
                                                                                    	Manufacture assembly revision
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                                    
                                                                                    	Common Language Equipment           Identifier number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: manufacturer_software_identifier
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                                    
                                                                                    	String containing OEM information           if applicable
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: part_number
                                                                                    
                                                                                    	
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__init__()

                                                                                        self.yang_name = "inv-asset-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("manufacturer_assembly_number",
                                                                                                        "manufacturer_assembly_revision",
                                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                                        "manufacturer_firmware_identifier",
                                                                                                        "manufacturer_software_identifier",
                                                                                                        "original_equipment_manufacturer_string",
                                                                                                        "part_number") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.manufacturer_assembly_number.is_set or
                                                                                            self.manufacturer_assembly_revision.is_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                                            self.manufacturer_software_identifier.is_set or
                                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                                            self.part_number.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                                            self.manufacturer_assembly_number = value
                                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                                            self.manufacturer_assembly_revision = value
                                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                                            self.manufacturer_firmware_identifier = value
                                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                                            self.manufacturer_software_identifier = value
                                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                                            self.original_equipment_manufacturer_string = value
                                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "part-number"):
                                                                                            self.part_number = value
                                                                                            self.part_number.value_namespace = name_space
                                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                                class Threshold(Entity):
                                                                                    """
                                                                                    Threshold
                                                                                    
                                                                                    .. attribute:: critical_hi
                                                                                    
                                                                                    	Critical High
                                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi>`
                                                                                    
                                                                                    .. attribute:: critical_lo
                                                                                    
                                                                                    	Critical Low
                                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo>`
                                                                                    
                                                                                    .. attribute:: major_hi
                                                                                    
                                                                                    	Major High
                                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi>`
                                                                                    
                                                                                    .. attribute:: major_lo
                                                                                    
                                                                                    	Major Low
                                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo>`
                                                                                    
                                                                                    .. attribute:: minor_hi
                                                                                    
                                                                                    	Minor High
                                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi>`
                                                                                    
                                                                                    .. attribute:: minor_lo
                                                                                    
                                                                                    	Minor Low
                                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold, self).__init__()

                                                                                        self.yang_name = "threshold"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                        self._children_yang_names.add("critical-hi")

                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                        self._children_yang_names.add("critical-lo")

                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                        self._children_yang_names.add("major-hi")

                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                        self._children_yang_names.add("major-lo")

                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                        self._children_yang_names.add("minor-hi")

                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                        self._children_yang_names.add("minor-lo")


                                                                                    class MajorLo(Entity):
                                                                                        """
                                                                                        Major Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo, self).__init__()

                                                                                            self.yang_name = "major-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalHi(Entity):
                                                                                        """
                                                                                        Critical High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                            self.yang_name = "critical-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorHi(Entity):
                                                                                        """
                                                                                        Minor High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi, self).__init__()

                                                                                            self.yang_name = "minor-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MajorHi(Entity):
                                                                                        """
                                                                                        Major High
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi, self).__init__()

                                                                                            self.yang_name = "major-hi"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "major-hi"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "major-hi" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class CriticalLo(Entity):
                                                                                        """
                                                                                        Critical Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                            self.yang_name = "critical-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "critical-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "critical-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass


                                                                                    class MinorLo(Entity):
                                                                                        """
                                                                                        Minor Low
                                                                                        
                                                                                        .. attribute:: thresh_bag
                                                                                        
                                                                                        	Environment threshold info
                                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo, self).__init__()

                                                                                            self.yang_name = "minor-lo"
                                                                                            self.yang_parent_name = "threshold"

                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                            self._children_yang_names.add("thresh-bag")


                                                                                        class ThreshBag(Entity):
                                                                                            """
                                                                                            Environment threshold info
                                                                                            
                                                                                            .. attribute:: threshold_evaluation
                                                                                            
                                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_notification_enabled
                                                                                            
                                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: threshold_relation
                                                                                            
                                                                                            	Indicates relation between sensor value and threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_severity
                                                                                            
                                                                                            	Indicates minor, major, critical severities
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: threshold_value
                                                                                            
                                                                                            	Value of the configured threshold
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                                self.yang_name = "thresh-bag"
                                                                                                self.yang_parent_name = "minor-lo"

                                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("threshold_evaluation",
                                                                                                                "threshold_notification_enabled",
                                                                                                                "threshold_relation",
                                                                                                                "threshold_severity",
                                                                                                                "threshold_value") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.threshold_evaluation.is_set or
                                                                                                    self.threshold_notification_enabled.is_set or
                                                                                                    self.threshold_relation.is_set or
                                                                                                    self.threshold_severity.is_set or
                                                                                                    self.threshold_value.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "threshold-evaluation"):
                                                                                                    self.threshold_evaluation = value
                                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                                    self.threshold_notification_enabled = value
                                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-relation"):
                                                                                                    self.threshold_relation = value
                                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-severity"):
                                                                                                    self.threshold_severity = value
                                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "threshold-value"):
                                                                                                    self.threshold_value = value
                                                                                                    self.threshold_value.value_namespace = name_space
                                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "minor-lo" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "thresh-bag"):
                                                                                                if (self.thresh_bag is None):
                                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                                    self.thresh_bag.parent = self
                                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                                return self.thresh_bag

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "thresh-bag"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            pass

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "critical-hi"):
                                                                                            if (self.critical_hi is None):
                                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalHi()
                                                                                                self.critical_hi.parent = self
                                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                            return self.critical_hi

                                                                                        if (child_yang_name == "critical-lo"):
                                                                                            if (self.critical_lo is None):
                                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.CriticalLo()
                                                                                                self.critical_lo.parent = self
                                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                            return self.critical_lo

                                                                                        if (child_yang_name == "major-hi"):
                                                                                            if (self.major_hi is None):
                                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorHi()
                                                                                                self.major_hi.parent = self
                                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                            return self.major_hi

                                                                                        if (child_yang_name == "major-lo"):
                                                                                            if (self.major_lo is None):
                                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MajorLo()
                                                                                                self.major_lo.parent = self
                                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                            return self.major_lo

                                                                                        if (child_yang_name == "minor-hi"):
                                                                                            if (self.minor_hi is None):
                                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorHi()
                                                                                                self.minor_hi.parent = self
                                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                            return self.minor_hi

                                                                                        if (child_yang_name == "minor-lo"):
                                                                                            if (self.minor_lo is None):
                                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold.MinorLo()
                                                                                                self.minor_lo.parent = self
                                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                            return self.minor_lo

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        pass


                                                                                class FruInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM FRU info
                                                                                    
                                                                                    .. attribute:: card_administrative_state
                                                                                    
                                                                                    	card admin state\: shutdown or not
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_monitor_state
                                                                                    
                                                                                    	card is monitored by a manager or left unmonitored
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_operational_state
                                                                                    
                                                                                    	card operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: card_reset_reason
                                                                                    
                                                                                    	card reset reason enum
                                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                                    
                                                                                    .. attribute:: card_up_time
                                                                                    
                                                                                    	card up time
                                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime>`
                                                                                    
                                                                                    .. attribute:: last_operational_state_change
                                                                                    
                                                                                    	last card oper change state
                                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange>`
                                                                                    
                                                                                    .. attribute:: power_administrative_state
                                                                                    
                                                                                    	power admin state\: up or down
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_current_measurement
                                                                                    
                                                                                    	power current\: not implemented
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: power_operational_state
                                                                                    
                                                                                    	Power operation state
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__init__()

                                                                                        self.yang_name = "fru-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                        self._children_yang_names.add("card-up-time")

                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("card_administrative_state",
                                                                                                        "card_monitor_state",
                                                                                                        "card_operational_state",
                                                                                                        "card_reset_reason",
                                                                                                        "power_administrative_state",
                                                                                                        "power_current_measurement",
                                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo, self).__setattr__(name, value)


                                                                                    class LastOperationalStateChange(Entity):
                                                                                        """
                                                                                        last card oper change state
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                            self.yang_name = "last-operational-state-change"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                                    class CardUpTime(Entity):
                                                                                        """
                                                                                        card up time
                                                                                        
                                                                                        .. attribute:: time_in_nano_seconds
                                                                                        
                                                                                        	Time Value in Nano\-seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: nanosecond
                                                                                        
                                                                                        .. attribute:: time_in_seconds
                                                                                        
                                                                                        	Time Value in Seconds
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** \-2147483648..2147483647
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                            self.yang_name = "card-up-time"
                                                                                            self.yang_parent_name = "fru-info"

                                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("time_in_nano_seconds",
                                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.time_in_nano_seconds.is_set or
                                                                                                self.time_in_seconds.is_set)

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "card-up-time" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                                self.time_in_nano_seconds = value
                                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "time-in-seconds"):
                                                                                                self.time_in_seconds = value
                                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.card_administrative_state.is_set or
                                                                                            self.card_monitor_state.is_set or
                                                                                            self.card_operational_state.is_set or
                                                                                            self.card_reset_reason.is_set or
                                                                                            self.power_administrative_state.is_set or
                                                                                            self.power_current_measurement.is_set or
                                                                                            self.power_operational_state.is_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "fru-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "card-up-time"):
                                                                                            if (self.card_up_time is None):
                                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.CardUpTime()
                                                                                                self.card_up_time.parent = self
                                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                            return self.card_up_time

                                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                                            if (self.last_operational_state_change is None):
                                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo.LastOperationalStateChange()
                                                                                                self.last_operational_state_change.parent = self
                                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                            return self.last_operational_state_change

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "card-administrative-state"):
                                                                                            self.card_administrative_state = value
                                                                                            self.card_administrative_state.value_namespace = name_space
                                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-monitor-state"):
                                                                                            self.card_monitor_state = value
                                                                                            self.card_monitor_state.value_namespace = name_space
                                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-operational-state"):
                                                                                            self.card_operational_state = value
                                                                                            self.card_operational_state.value_namespace = name_space
                                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "card-reset-reason"):
                                                                                            self.card_reset_reason = value
                                                                                            self.card_reset_reason.value_namespace = name_space
                                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-administrative-state"):
                                                                                            self.power_administrative_state = value
                                                                                            self.power_administrative_state.value_namespace = name_space
                                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-current-measurement"):
                                                                                            self.power_current_measurement = value
                                                                                            self.power_current_measurement.value_namespace = name_space
                                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "power-operational-state"):
                                                                                            self.power_operational_state = value
                                                                                            self.power_operational_state.value_namespace = name_space
                                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                                class InvBasicBag(Entity):
                                                                                    """
                                                                                    Inventory Basic Bag
                                                                                    
                                                                                    .. attribute:: alias
                                                                                    
                                                                                    	useful for storing an entity alias 
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_id_str
                                                                                    
                                                                                    	asset Identification string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: asset_identification
                                                                                    
                                                                                    	asset Identification
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: ceport
                                                                                    
                                                                                    	1 if ce port found, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: chip_hardware_revision
                                                                                    
                                                                                    	chip module hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: composite_class_code
                                                                                    
                                                                                    	Major&minor class of the entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	describes in user\-readable terms       what the entity in question does
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: environmental_monitor_path
                                                                                    
                                                                                    	sysdb name of sensor in the envmon EDM
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: firmware_revision
                                                                                    
                                                                                    	firmware revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: group_flag
                                                                                    
                                                                                    	indicates if this entity is group       or not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: hardware_revision
                                                                                    
                                                                                    	hw revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: is_field_replaceable_unit
                                                                                    
                                                                                    	1 if Field Replaceable Unit 0, if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: manufacturer_asset_tags
                                                                                    
                                                                                    	Manufacture Asset Tags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: manufacturer_name
                                                                                    
                                                                                    	manufacturer's name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: memory_size
                                                                                    
                                                                                    	Size of memory associated with       the entity where applicable
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: model_name
                                                                                    
                                                                                    	model name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	name string for the entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: new_deviation_number
                                                                                    
                                                                                    	integer value for New Deviation Number 0x88
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: physical_layer_interface_module_type
                                                                                    
                                                                                    	integer value for plim type if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: redundancystate
                                                                                    
                                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: serial_number
                                                                                    
                                                                                    	serial number
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: software_revision
                                                                                    
                                                                                    	software revision string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: unique_id
                                                                                    
                                                                                    	Unique id for an entity
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    .. attribute:: unrecognized_fru
                                                                                    
                                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: vendor_type
                                                                                    
                                                                                    	maps to the vendor OID string
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: xr_scoped
                                                                                    
                                                                                    	1 if xr scoped, 0 if not
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__init__()

                                                                                        self.yang_name = "inv-basic-bag"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("alias",
                                                                                                        "asset_id_str",
                                                                                                        "asset_identification",
                                                                                                        "ceport",
                                                                                                        "chip_hardware_revision",
                                                                                                        "composite_class_code",
                                                                                                        "description",
                                                                                                        "environmental_monitor_path",
                                                                                                        "firmware_revision",
                                                                                                        "group_flag",
                                                                                                        "hardware_revision",
                                                                                                        "is_field_replaceable_unit",
                                                                                                        "manufacturer_asset_tags",
                                                                                                        "manufacturer_name",
                                                                                                        "memory_size",
                                                                                                        "model_name",
                                                                                                        "name",
                                                                                                        "new_deviation_number",
                                                                                                        "physical_layer_interface_module_type",
                                                                                                        "redundancystate",
                                                                                                        "serial_number",
                                                                                                        "software_revision",
                                                                                                        "unique_id",
                                                                                                        "unrecognized_fru",
                                                                                                        "vendor_type",
                                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.alias.is_set or
                                                                                            self.asset_id_str.is_set or
                                                                                            self.asset_identification.is_set or
                                                                                            self.ceport.is_set or
                                                                                            self.chip_hardware_revision.is_set or
                                                                                            self.composite_class_code.is_set or
                                                                                            self.description.is_set or
                                                                                            self.environmental_monitor_path.is_set or
                                                                                            self.firmware_revision.is_set or
                                                                                            self.group_flag.is_set or
                                                                                            self.hardware_revision.is_set or
                                                                                            self.is_field_replaceable_unit.is_set or
                                                                                            self.manufacturer_asset_tags.is_set or
                                                                                            self.manufacturer_name.is_set or
                                                                                            self.memory_size.is_set or
                                                                                            self.model_name.is_set or
                                                                                            self.name.is_set or
                                                                                            self.new_deviation_number.is_set or
                                                                                            self.physical_layer_interface_module_type.is_set or
                                                                                            self.redundancystate.is_set or
                                                                                            self.serial_number.is_set or
                                                                                            self.software_revision.is_set or
                                                                                            self.unique_id.is_set or
                                                                                            self.unrecognized_fru.is_set or
                                                                                            self.vendor_type.is_set or
                                                                                            self.xr_scoped.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.alias.yfilter != YFilter.not_set or
                                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                                            self.name.yfilter != YFilter.not_set or
                                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "alias"):
                                                                                            self.alias = value
                                                                                            self.alias.value_namespace = name_space
                                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-id-str"):
                                                                                            self.asset_id_str = value
                                                                                            self.asset_id_str.value_namespace = name_space
                                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "asset-identification"):
                                                                                            self.asset_identification = value
                                                                                            self.asset_identification.value_namespace = name_space
                                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "ceport"):
                                                                                            self.ceport = value
                                                                                            self.ceport.value_namespace = name_space
                                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "chip-hardware-revision"):
                                                                                            self.chip_hardware_revision = value
                                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "composite-class-code"):
                                                                                            self.composite_class_code = value
                                                                                            self.composite_class_code.value_namespace = name_space
                                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "environmental-monitor-path"):
                                                                                            self.environmental_monitor_path = value
                                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "firmware-revision"):
                                                                                            self.firmware_revision = value
                                                                                            self.firmware_revision.value_namespace = name_space
                                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "group-flag"):
                                                                                            self.group_flag = value
                                                                                            self.group_flag.value_namespace = name_space
                                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "hardware-revision"):
                                                                                            self.hardware_revision = value
                                                                                            self.hardware_revision.value_namespace = name_space
                                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                                            self.is_field_replaceable_unit = value
                                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                                            self.manufacturer_asset_tags = value
                                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "manufacturer-name"):
                                                                                            self.manufacturer_name = value
                                                                                            self.manufacturer_name.value_namespace = name_space
                                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "memory-size"):
                                                                                            self.memory_size = value
                                                                                            self.memory_size.value_namespace = name_space
                                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "model-name"):
                                                                                            self.model_name = value
                                                                                            self.model_name.value_namespace = name_space
                                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "name"):
                                                                                            self.name = value
                                                                                            self.name.value_namespace = name_space
                                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "new-deviation-number"):
                                                                                            self.new_deviation_number = value
                                                                                            self.new_deviation_number.value_namespace = name_space
                                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                                            self.physical_layer_interface_module_type = value
                                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "redundancystate"):
                                                                                            self.redundancystate = value
                                                                                            self.redundancystate.value_namespace = name_space
                                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "serial-number"):
                                                                                            self.serial_number = value
                                                                                            self.serial_number.value_namespace = name_space
                                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "software-revision"):
                                                                                            self.software_revision = value
                                                                                            self.software_revision.value_namespace = name_space
                                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unique-id"):
                                                                                            self.unique_id = value
                                                                                            self.unique_id.value_namespace = name_space
                                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "unrecognized-fru"):
                                                                                            self.unrecognized_fru = value
                                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "vendor-type"):
                                                                                            self.vendor_type = value
                                                                                            self.vendor_type.value_namespace = name_space
                                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "xr-scoped"):
                                                                                            self.xr_scoped = value
                                                                                            self.xr_scoped.value_namespace = name_space
                                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                                class InvEepromInfo(Entity):
                                                                                    """
                                                                                    Inventory EDM EEPROM Information Bag
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	A textual description of physical entity
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: eeprom
                                                                                    
                                                                                    	EEPROM data not from hex data
                                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom>`
                                                                                    
                                                                                    .. attribute:: has_eeprom
                                                                                    
                                                                                    	use eeprom instead of opaque data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: inv_card_type
                                                                                    
                                                                                    	Inventory card type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: opaque_data
                                                                                    
                                                                                    	EEPROM hex data
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: opaque_data_size
                                                                                    
                                                                                    	size of the EEPROM hex data
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__init__()

                                                                                        self.yang_name = "inv-eeprom-info"
                                                                                        self.yang_parent_name = "attributes"

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                        self._children_yang_names.add("eeprom")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("description",
                                                                                                        "has_eeprom",
                                                                                                        "inv_card_type",
                                                                                                        "opaque_data",
                                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                                    class Eeprom(Entity):
                                                                                        """
                                                                                        EEPROM data not from hex data
                                                                                        
                                                                                        .. attribute:: asset_alias
                                                                                        
                                                                                        	Asset Alias
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: asset_id
                                                                                        
                                                                                        	Asset ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address1
                                                                                        
                                                                                        	Base Mac Address #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address2
                                                                                        
                                                                                        	Base Mac Address #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address3
                                                                                        
                                                                                        	Base Mac Address #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: base_mac_address4
                                                                                        
                                                                                        	Base Mac Address #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_checksum
                                                                                        
                                                                                        	Block Checksum
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_count
                                                                                        
                                                                                        	Block Count
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_length
                                                                                        
                                                                                        	Block Length
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_signature
                                                                                        
                                                                                        	Block Signature
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: block_version
                                                                                        
                                                                                        	Block Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: chassis_sid
                                                                                        
                                                                                        	Chassis serial number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: clei
                                                                                        
                                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_family
                                                                                        
                                                                                        	Controller family
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: controller_type
                                                                                        
                                                                                        	Controller type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: description
                                                                                        
                                                                                        	A textual description of physical entity
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num1
                                                                                        
                                                                                        	Deviation Number # 1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num2
                                                                                        
                                                                                        	Deviation Number # 2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num3
                                                                                        
                                                                                        	Deviation Number # 3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num4
                                                                                        
                                                                                        	Deviation Number # 4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num5
                                                                                        
                                                                                        	Deviation Number # 5
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num6
                                                                                        
                                                                                        	Deviation Number # 6
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: dev_num7
                                                                                        
                                                                                        	Deviation Number # 7
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eci
                                                                                        
                                                                                        	Equipment Catalog Item (ECI) number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: eeprom_size
                                                                                        
                                                                                        	EEPROM Size
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: engineer_use
                                                                                        
                                                                                        	Engineer Use
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_major_type
                                                                                        
                                                                                        	FRU Major Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: fru_minor_type
                                                                                        
                                                                                        	FRU Minor Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hw_version
                                                                                        
                                                                                        	Hardware Version
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: hwid
                                                                                        
                                                                                        	Hardware Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: idprom_format_rev
                                                                                        
                                                                                        	IDPROM Format Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size1
                                                                                        
                                                                                        	Mac Address Block Size #1
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size2
                                                                                        
                                                                                        	Mac Address Block Size #2
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size3
                                                                                        
                                                                                        	Mac Address Block Size #3
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mac_add_blk_size4
                                                                                        
                                                                                        	Mac Address Block Size #4
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: manu_test_data
                                                                                        
                                                                                        	Manufacturing Test Data
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_bits
                                                                                        
                                                                                        	MFG Bits
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: mfg_deviation
                                                                                        
                                                                                        	MFG Deviation
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: oem_string
                                                                                        
                                                                                        	OEM String
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_number
                                                                                        
                                                                                        	Part Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: part_revision
                                                                                        
                                                                                        	Part Revision
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pca_num
                                                                                        
                                                                                        	PCA number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcavid
                                                                                        
                                                                                        	PCA revision ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pcb_serial_num
                                                                                        
                                                                                        	PCB Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: pid
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_consumption
                                                                                        
                                                                                        	Power Consumption
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: power_supply_type
                                                                                        
                                                                                        	Power Supply Type
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: product_id
                                                                                        
                                                                                        	Product ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: rma
                                                                                        
                                                                                        	RMA Data
                                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                        
                                                                                        .. attribute:: rma_code
                                                                                        
                                                                                        	RMA Code
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: serial_number
                                                                                        
                                                                                        	Serial Number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: snmpoid
                                                                                        
                                                                                        	SNMP OID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_part_num
                                                                                        
                                                                                        	Top assembly part number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: top_assem_vid
                                                                                        
                                                                                        	Top assembly revision number
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_description
                                                                                        
                                                                                        	UDI description
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: udi_name
                                                                                        
                                                                                        	UDI name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        .. attribute:: vid
                                                                                        
                                                                                        	Version ID
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**length:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'invmgr-oper'
                                                                                        _revision = '2015-11-09'

                                                                                        def __init__(self):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                            self.yang_name = "eeprom"
                                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                            self.description = YLeaf(YType.str, "description")

                                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                            self._children_yang_names.add("rma")

                                                                                        def __setattr__(self, name, value):
                                                                                            self._check_monkey_patching_error(name, value)
                                                                                            with _handle_type_error():
                                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                        "Please use list append or extend method."
                                                                                                                        .format(value))
                                                                                                if isinstance(value, Enum.YLeaf):
                                                                                                    value = value.name
                                                                                                if name in ("asset_alias",
                                                                                                            "asset_id",
                                                                                                            "base_mac_address1",
                                                                                                            "base_mac_address2",
                                                                                                            "base_mac_address3",
                                                                                                            "base_mac_address4",
                                                                                                            "block_checksum",
                                                                                                            "block_count",
                                                                                                            "block_length",
                                                                                                            "block_signature",
                                                                                                            "block_version",
                                                                                                            "chassis_sid",
                                                                                                            "clei",
                                                                                                            "controller_family",
                                                                                                            "controller_type",
                                                                                                            "description",
                                                                                                            "dev_num1",
                                                                                                            "dev_num2",
                                                                                                            "dev_num3",
                                                                                                            "dev_num4",
                                                                                                            "dev_num5",
                                                                                                            "dev_num6",
                                                                                                            "dev_num7",
                                                                                                            "eci",
                                                                                                            "eeprom_size",
                                                                                                            "engineer_use",
                                                                                                            "fru_major_type",
                                                                                                            "fru_minor_type",
                                                                                                            "hw_version",
                                                                                                            "hwid",
                                                                                                            "idprom_format_rev",
                                                                                                            "mac_add_blk_size1",
                                                                                                            "mac_add_blk_size2",
                                                                                                            "mac_add_blk_size3",
                                                                                                            "mac_add_blk_size4",
                                                                                                            "manu_test_data",
                                                                                                            "mfg_bits",
                                                                                                            "mfg_deviation",
                                                                                                            "oem_string",
                                                                                                            "part_number",
                                                                                                            "part_revision",
                                                                                                            "pca_num",
                                                                                                            "pcavid",
                                                                                                            "pcb_serial_num",
                                                                                                            "pid",
                                                                                                            "power_consumption",
                                                                                                            "power_supply_type",
                                                                                                            "product_id",
                                                                                                            "rma_code",
                                                                                                            "serial_number",
                                                                                                            "snmpoid",
                                                                                                            "top_assem_part_num",
                                                                                                            "top_assem_vid",
                                                                                                            "udi_description",
                                                                                                            "udi_name",
                                                                                                            "vid") and name in self.__dict__:
                                                                                                    if isinstance(value, YLeaf):
                                                                                                        self.__dict__[name].set(value.get())
                                                                                                    elif isinstance(value, YLeafList):
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                                    else:
                                                                                                        self.__dict__[name].set(value)
                                                                                                else:
                                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                            value.parent = self
                                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                            value.parent = self
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                        class Rma(Entity):
                                                                                            """
                                                                                            RMA Data
                                                                                            
                                                                                            .. attribute:: rma_history
                                                                                            
                                                                                            	RMA history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: rma_number
                                                                                            
                                                                                            	RMA tracking number format is N\-N\-N
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            .. attribute:: test_history
                                                                                            
                                                                                            	Test history
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**length:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'invmgr-oper'
                                                                                            _revision = '2015-11-09'

                                                                                            def __init__(self):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                                self.yang_name = "rma"
                                                                                                self.yang_parent_name = "eeprom"

                                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                                            def __setattr__(self, name, value):
                                                                                                self._check_monkey_patching_error(name, value)
                                                                                                with _handle_type_error():
                                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                            "Please use list append or extend method."
                                                                                                                            .format(value))
                                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                                        value = value.name
                                                                                                    if name in ("rma_history",
                                                                                                                "rma_number",
                                                                                                                "test_history") and name in self.__dict__:
                                                                                                        if isinstance(value, YLeaf):
                                                                                                            self.__dict__[name].set(value.get())
                                                                                                        elif isinstance(value, YLeafList):
                                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                        else:
                                                                                                            self.__dict__[name].set(value)
                                                                                                    else:
                                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                                value.parent = self
                                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                                value.parent = self
                                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                            def has_data(self):
                                                                                                return (
                                                                                                    self.rma_history.is_set or
                                                                                                    self.rma_number.is_set or
                                                                                                    self.test_history.is_set)

                                                                                            def has_operation(self):
                                                                                                return (
                                                                                                    self.yfilter != YFilter.not_set or
                                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                                            def get_segment_path(self):
                                                                                                path_buffer = ""
                                                                                                path_buffer = "rma" + path_buffer

                                                                                                return path_buffer

                                                                                            def get_entity_path(self, ancestor):
                                                                                                path_buffer = ""
                                                                                                if (ancestor is None):
                                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                                else:
                                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                                leaf_name_data = LeafDataList()
                                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                                return entity_path

                                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                                if child is not None:
                                                                                                    return child

                                                                                                return None

                                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                                    return True
                                                                                                return False

                                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                                if(value_path == "rma-history"):
                                                                                                    self.rma_history = value
                                                                                                    self.rma_history.value_namespace = name_space
                                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "rma-number"):
                                                                                                    self.rma_number = value
                                                                                                    self.rma_number.value_namespace = name_space
                                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                                if(value_path == "test-history"):
                                                                                                    self.test_history = value
                                                                                                    self.test_history.value_namespace = name_space
                                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                                        def has_data(self):
                                                                                            return (
                                                                                                self.asset_alias.is_set or
                                                                                                self.asset_id.is_set or
                                                                                                self.base_mac_address1.is_set or
                                                                                                self.base_mac_address2.is_set or
                                                                                                self.base_mac_address3.is_set or
                                                                                                self.base_mac_address4.is_set or
                                                                                                self.block_checksum.is_set or
                                                                                                self.block_count.is_set or
                                                                                                self.block_length.is_set or
                                                                                                self.block_signature.is_set or
                                                                                                self.block_version.is_set or
                                                                                                self.chassis_sid.is_set or
                                                                                                self.clei.is_set or
                                                                                                self.controller_family.is_set or
                                                                                                self.controller_type.is_set or
                                                                                                self.description.is_set or
                                                                                                self.dev_num1.is_set or
                                                                                                self.dev_num2.is_set or
                                                                                                self.dev_num3.is_set or
                                                                                                self.dev_num4.is_set or
                                                                                                self.dev_num5.is_set or
                                                                                                self.dev_num6.is_set or
                                                                                                self.dev_num7.is_set or
                                                                                                self.eci.is_set or
                                                                                                self.eeprom_size.is_set or
                                                                                                self.engineer_use.is_set or
                                                                                                self.fru_major_type.is_set or
                                                                                                self.fru_minor_type.is_set or
                                                                                                self.hw_version.is_set or
                                                                                                self.hwid.is_set or
                                                                                                self.idprom_format_rev.is_set or
                                                                                                self.mac_add_blk_size1.is_set or
                                                                                                self.mac_add_blk_size2.is_set or
                                                                                                self.mac_add_blk_size3.is_set or
                                                                                                self.mac_add_blk_size4.is_set or
                                                                                                self.manu_test_data.is_set or
                                                                                                self.mfg_bits.is_set or
                                                                                                self.mfg_deviation.is_set or
                                                                                                self.oem_string.is_set or
                                                                                                self.part_number.is_set or
                                                                                                self.part_revision.is_set or
                                                                                                self.pca_num.is_set or
                                                                                                self.pcavid.is_set or
                                                                                                self.pcb_serial_num.is_set or
                                                                                                self.pid.is_set or
                                                                                                self.power_consumption.is_set or
                                                                                                self.power_supply_type.is_set or
                                                                                                self.product_id.is_set or
                                                                                                self.rma_code.is_set or
                                                                                                self.serial_number.is_set or
                                                                                                self.snmpoid.is_set or
                                                                                                self.top_assem_part_num.is_set or
                                                                                                self.top_assem_vid.is_set or
                                                                                                self.udi_description.is_set or
                                                                                                self.udi_name.is_set or
                                                                                                self.vid.is_set or
                                                                                                (self.rma is not None and self.rma.has_data()))

                                                                                        def has_operation(self):
                                                                                            return (
                                                                                                self.yfilter != YFilter.not_set or
                                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                                self.description.yfilter != YFilter.not_set or
                                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                                        def get_segment_path(self):
                                                                                            path_buffer = ""
                                                                                            path_buffer = "eeprom" + path_buffer

                                                                                            return path_buffer

                                                                                        def get_entity_path(self, ancestor):
                                                                                            path_buffer = ""
                                                                                            if (ancestor is None):
                                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                            else:
                                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                            leaf_name_data = LeafDataList()
                                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                            return entity_path

                                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                            if child is not None:
                                                                                                return child

                                                                                            if (child_yang_name == "rma"):
                                                                                                if (self.rma is None):
                                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                                    self.rma.parent = self
                                                                                                    self._children_name_map["rma"] = "rma"
                                                                                                return self.rma

                                                                                            return None

                                                                                        def has_leaf_or_child_of_name(self, name):
                                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                                return True
                                                                                            return False

                                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                            if(value_path == "asset-alias"):
                                                                                                self.asset_alias = value
                                                                                                self.asset_alias.value_namespace = name_space
                                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "asset-id"):
                                                                                                self.asset_id = value
                                                                                                self.asset_id.value_namespace = name_space
                                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address1"):
                                                                                                self.base_mac_address1 = value
                                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address2"):
                                                                                                self.base_mac_address2 = value
                                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address3"):
                                                                                                self.base_mac_address3 = value
                                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "base-mac-address4"):
                                                                                                self.base_mac_address4 = value
                                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-checksum"):
                                                                                                self.block_checksum = value
                                                                                                self.block_checksum.value_namespace = name_space
                                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-count"):
                                                                                                self.block_count = value
                                                                                                self.block_count.value_namespace = name_space
                                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-length"):
                                                                                                self.block_length = value
                                                                                                self.block_length.value_namespace = name_space
                                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-signature"):
                                                                                                self.block_signature = value
                                                                                                self.block_signature.value_namespace = name_space
                                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "block-version"):
                                                                                                self.block_version = value
                                                                                                self.block_version.value_namespace = name_space
                                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "chassis-sid"):
                                                                                                self.chassis_sid = value
                                                                                                self.chassis_sid.value_namespace = name_space
                                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "clei"):
                                                                                                self.clei = value
                                                                                                self.clei.value_namespace = name_space
                                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-family"):
                                                                                                self.controller_family = value
                                                                                                self.controller_family.value_namespace = name_space
                                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "controller-type"):
                                                                                                self.controller_type = value
                                                                                                self.controller_type.value_namespace = name_space
                                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "description"):
                                                                                                self.description = value
                                                                                                self.description.value_namespace = name_space
                                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num1"):
                                                                                                self.dev_num1 = value
                                                                                                self.dev_num1.value_namespace = name_space
                                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num2"):
                                                                                                self.dev_num2 = value
                                                                                                self.dev_num2.value_namespace = name_space
                                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num3"):
                                                                                                self.dev_num3 = value
                                                                                                self.dev_num3.value_namespace = name_space
                                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num4"):
                                                                                                self.dev_num4 = value
                                                                                                self.dev_num4.value_namespace = name_space
                                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num5"):
                                                                                                self.dev_num5 = value
                                                                                                self.dev_num5.value_namespace = name_space
                                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num6"):
                                                                                                self.dev_num6 = value
                                                                                                self.dev_num6.value_namespace = name_space
                                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "dev-num7"):
                                                                                                self.dev_num7 = value
                                                                                                self.dev_num7.value_namespace = name_space
                                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eci"):
                                                                                                self.eci = value
                                                                                                self.eci.value_namespace = name_space
                                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "eeprom-size"):
                                                                                                self.eeprom_size = value
                                                                                                self.eeprom_size.value_namespace = name_space
                                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "engineer-use"):
                                                                                                self.engineer_use = value
                                                                                                self.engineer_use.value_namespace = name_space
                                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-major-type"):
                                                                                                self.fru_major_type = value
                                                                                                self.fru_major_type.value_namespace = name_space
                                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "fru-minor-type"):
                                                                                                self.fru_minor_type = value
                                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hw-version"):
                                                                                                self.hw_version = value
                                                                                                self.hw_version.value_namespace = name_space
                                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "hwid"):
                                                                                                self.hwid = value
                                                                                                self.hwid.value_namespace = name_space
                                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "idprom-format-rev"):
                                                                                                self.idprom_format_rev = value
                                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                                self.mac_add_blk_size1 = value
                                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                                self.mac_add_blk_size2 = value
                                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                                self.mac_add_blk_size3 = value
                                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                                self.mac_add_blk_size4 = value
                                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "manu-test-data"):
                                                                                                self.manu_test_data = value
                                                                                                self.manu_test_data.value_namespace = name_space
                                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-bits"):
                                                                                                self.mfg_bits = value
                                                                                                self.mfg_bits.value_namespace = name_space
                                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "mfg-deviation"):
                                                                                                self.mfg_deviation = value
                                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "oem-string"):
                                                                                                self.oem_string = value
                                                                                                self.oem_string.value_namespace = name_space
                                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-number"):
                                                                                                self.part_number = value
                                                                                                self.part_number.value_namespace = name_space
                                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "part-revision"):
                                                                                                self.part_revision = value
                                                                                                self.part_revision.value_namespace = name_space
                                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pca-num"):
                                                                                                self.pca_num = value
                                                                                                self.pca_num.value_namespace = name_space
                                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcavid"):
                                                                                                self.pcavid = value
                                                                                                self.pcavid.value_namespace = name_space
                                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pcb-serial-num"):
                                                                                                self.pcb_serial_num = value
                                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "pid"):
                                                                                                self.pid = value
                                                                                                self.pid.value_namespace = name_space
                                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-consumption"):
                                                                                                self.power_consumption = value
                                                                                                self.power_consumption.value_namespace = name_space
                                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "power-supply-type"):
                                                                                                self.power_supply_type = value
                                                                                                self.power_supply_type.value_namespace = name_space
                                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "product-id"):
                                                                                                self.product_id = value
                                                                                                self.product_id.value_namespace = name_space
                                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "rma-code"):
                                                                                                self.rma_code = value
                                                                                                self.rma_code.value_namespace = name_space
                                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "serial-number"):
                                                                                                self.serial_number = value
                                                                                                self.serial_number.value_namespace = name_space
                                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "snmpoid"):
                                                                                                self.snmpoid = value
                                                                                                self.snmpoid.value_namespace = name_space
                                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-part-num"):
                                                                                                self.top_assem_part_num = value
                                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "top-assem-vid"):
                                                                                                self.top_assem_vid = value
                                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-description"):
                                                                                                self.udi_description = value
                                                                                                self.udi_description.value_namespace = name_space
                                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "udi-name"):
                                                                                                self.udi_name = value
                                                                                                self.udi_name.value_namespace = name_space
                                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                            if(value_path == "vid"):
                                                                                                self.vid = value
                                                                                                self.vid.value_namespace = name_space
                                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.description.is_set or
                                                                                            self.has_eeprom.is_set or
                                                                                            self.inv_card_type.is_set or
                                                                                            self.opaque_data.is_set or
                                                                                            self.opaque_data_size.is_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.description.yfilter != YFilter.not_set or
                                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        if (child_yang_name == "eeprom"):
                                                                                            if (self.eeprom is None):
                                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo.Eeprom()
                                                                                                self.eeprom.parent = self
                                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                            return self.eeprom

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "description"):
                                                                                            self.description = value
                                                                                            self.description.value_namespace = name_space
                                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "has-eeprom"):
                                                                                            self.has_eeprom = value
                                                                                            self.has_eeprom.value_namespace = name_space
                                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "inv-card-type"):
                                                                                            self.inv_card_type = value
                                                                                            self.inv_card_type.value_namespace = name_space
                                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data"):
                                                                                            self.opaque_data = value
                                                                                            self.opaque_data.value_namespace = name_space
                                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "opaque-data-size"):
                                                                                            self.opaque_data_size = value
                                                                                            self.opaque_data_size.value_namespace = name_space
                                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.module_done.is_set or
                                                                                        self.node_id.is_set or
                                                                                        self.vm_done.is_set or
                                                                                        self.vm_node_id.is_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "attributes" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "env-sensor-info"):
                                                                                        if (self.env_sensor_info is None):
                                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfo()
                                                                                            self.env_sensor_info.parent = self
                                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                        return self.env_sensor_info

                                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                                        if (self.env_sensor_info_xml is None):
                                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.EnvSensorInfoXml()
                                                                                            self.env_sensor_info_xml.parent = self
                                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                        return self.env_sensor_info_xml

                                                                                    if (child_yang_name == "fru-info"):
                                                                                        if (self.fru_info is None):
                                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.FruInfo()
                                                                                            self.fru_info.parent = self
                                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                                        return self.fru_info

                                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                                        if (self.inv_asset_bag is None):
                                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvAssetBag()
                                                                                            self.inv_asset_bag.parent = self
                                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                        return self.inv_asset_bag

                                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                                        if (self.inv_basic_bag is None):
                                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvBasicBag()
                                                                                            self.inv_basic_bag.parent = self
                                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                        return self.inv_basic_bag

                                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                                        if (self.inv_eeprom_info is None):
                                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.InvEepromInfo()
                                                                                            self.inv_eeprom_info.parent = self
                                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                        return self.inv_eeprom_info

                                                                                    if (child_yang_name == "pwg-info"):
                                                                                        if (self.pwg_info is None):
                                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.PwgInfo()
                                                                                            self.pwg_info.parent = self
                                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                                        return self.pwg_info

                                                                                    if (child_yang_name == "threshold"):
                                                                                        if (self.threshold is None):
                                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes.Threshold()
                                                                                            self.threshold.parent = self
                                                                                            self._children_name_map["threshold"] = "threshold"
                                                                                        return self.threshold

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "module-done"):
                                                                                        self.module_done = value
                                                                                        self.module_done.value_namespace = name_space
                                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "node-id"):
                                                                                        self.node_id = value
                                                                                        self.node_id.value_namespace = name_space
                                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-done"):
                                                                                        self.vm_done = value
                                                                                        self.vm_done.value_namespace = name_space
                                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vm-node-id"):
                                                                                        self.vm_node_id = value
                                                                                        self.vm_node_id.value_namespace = name_space
                                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.name.is_set or
                                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                                    (self.tsi8s is not None and self.tsi8s.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "tsi7" + "[name='" + self.name.get() + "']" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "attributes"):
                                                                                    if (self.attributes is None):
                                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Attributes()
                                                                                        self.attributes.parent = self
                                                                                        self._children_name_map["attributes"] = "attributes"
                                                                                    return self.attributes

                                                                                if (child_yang_name == "tsi8s"):
                                                                                    if (self.tsi8s is None):
                                                                                        self.tsi8s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7.Tsi8S()
                                                                                        self.tsi8s.parent = self
                                                                                        self._children_name_map["tsi8s"] = "tsi8s"
                                                                                    return self.tsi8s

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "attributes" or name == "tsi8s" or name == "name"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.tsi7:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "tsi7s" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "tsi7"):
                                                                                for c in self.tsi7:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S.Tsi7()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.tsi7.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "tsi7"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class Attributes(Entity):
                                                                        """
                                                                        Attributes
                                                                        
                                                                        .. attribute:: env_sensor_info
                                                                        
                                                                        	Environment sensor info
                                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo>`
                                                                        
                                                                        .. attribute:: env_sensor_info_xml
                                                                        
                                                                        	Environment sensor info XML
                                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml>`
                                                                        
                                                                        .. attribute:: fru_info
                                                                        
                                                                        	Inventory EDM FRU info
                                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo>`
                                                                        
                                                                        .. attribute:: inv_asset_bag
                                                                        
                                                                        	Inventory Asset Bag
                                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag>`
                                                                        
                                                                        .. attribute:: inv_basic_bag
                                                                        
                                                                        	Inventory Basic Bag
                                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag>`
                                                                        
                                                                        .. attribute:: inv_eeprom_info
                                                                        
                                                                        	Inventory EDM EEPROM Information Bag
                                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo>`
                                                                        
                                                                        .. attribute:: module_done
                                                                        
                                                                        	Inventory EDM Module Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**default value**\: 1
                                                                        
                                                                        .. attribute:: node_id
                                                                        
                                                                        	Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pwg_info
                                                                        
                                                                        	Inventory EDM PWG info
                                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo>`
                                                                        
                                                                        .. attribute:: threshold
                                                                        
                                                                        	Threshold
                                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold>`
                                                                        
                                                                        .. attribute:: vm_done
                                                                        
                                                                        	VM Done Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        .. attribute:: vm_node_id
                                                                        
                                                                        	VM Node ID Tuple
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__init__()

                                                                            self.yang_name = "attributes"
                                                                            self.yang_parent_name = "tsi6"

                                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                            self._children_yang_names.add("env-sensor-info")

                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                            self._children_yang_names.add("fru-info")

                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                            self._children_yang_names.add("inv-asset-bag")

                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                            self._children_yang_names.add("inv-basic-bag")

                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                            self._children_yang_names.add("inv-eeprom-info")

                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                            self._children_yang_names.add("pwg-info")

                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                            self._children_yang_names.add("threshold")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("module_done",
                                                                                            "node_id",
                                                                                            "vm_done",
                                                                                            "vm_node_id") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes, self).__setattr__(name, value)


                                                                        class EnvSensorInfo(Entity):
                                                                            """
                                                                            Environment sensor info
                                                                            
                                                                            .. attribute:: age_time_stamp
                                                                            
                                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: alarm_type
                                                                            
                                                                            	Indicates threshold violation
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: device_description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: device_id
                                                                            
                                                                            	Identifier for this device
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: field_validity_bitmap
                                                                            
                                                                            	Sensor valid bitmap
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: precision
                                                                            
                                                                            	Sensor precision range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: scale
                                                                            
                                                                            	Sensor scale enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state enums
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__init__()

                                                                                self.yang_name = "env-sensor-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                                self.status = YLeaf(YType.uint32, "status")

                                                                                self.units = YLeaf(YType.str, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("age_time_stamp",
                                                                                                "alarm_type",
                                                                                                "data_type",
                                                                                                "device_description",
                                                                                                "device_id",
                                                                                                "field_validity_bitmap",
                                                                                                "precision",
                                                                                                "scale",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.age_time_stamp.is_set or
                                                                                    self.alarm_type.is_set or
                                                                                    self.data_type.is_set or
                                                                                    self.device_description.is_set or
                                                                                    self.device_id.is_set or
                                                                                    self.field_validity_bitmap.is_set or
                                                                                    self.precision.is_set or
                                                                                    self.scale.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                                    self.precision.yfilter != YFilter.not_set or
                                                                                    self.scale.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "age-time-stamp"):
                                                                                    self.age_time_stamp = value
                                                                                    self.age_time_stamp.value_namespace = name_space
                                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "alarm-type"):
                                                                                    self.alarm_type = value
                                                                                    self.alarm_type.value_namespace = name_space
                                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-description"):
                                                                                    self.device_description = value
                                                                                    self.device_description.value_namespace = name_space
                                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "device-id"):
                                                                                    self.device_id = value
                                                                                    self.device_id.value_namespace = name_space
                                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "field-validity-bitmap"):
                                                                                    self.field_validity_bitmap = value
                                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "precision"):
                                                                                    self.precision = value
                                                                                    self.precision.value_namespace = name_space
                                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "scale"):
                                                                                    self.scale = value
                                                                                    self.scale.value_namespace = name_space
                                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class PwgInfo(Entity):
                                                                            """
                                                                            Inventory EDM PWG info
                                                                            
                                                                            .. attribute:: power_group_available_current
                                                                            
                                                                            	available current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_drawn_current
                                                                            
                                                                            	drawn current
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_group_power_units
                                                                            
                                                                            	power units
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: power_group_redundancy_mode
                                                                            
                                                                            	redundancy mode
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__init__()

                                                                                self.yang_name = "pwg-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("power_group_available_current",
                                                                                                "power_group_drawn_current",
                                                                                                "power_group_power_units",
                                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.power_group_available_current.is_set or
                                                                                    self.power_group_drawn_current.is_set or
                                                                                    self.power_group_power_units.is_set or
                                                                                    self.power_group_redundancy_mode.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "pwg-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "power-group-available-current"):
                                                                                    self.power_group_available_current = value
                                                                                    self.power_group_available_current.value_namespace = name_space
                                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-drawn-current"):
                                                                                    self.power_group_drawn_current = value
                                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-power-units"):
                                                                                    self.power_group_power_units = value
                                                                                    self.power_group_power_units.value_namespace = name_space
                                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-group-redundancy-mode"):
                                                                                    self.power_group_redundancy_mode = value
                                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                        class EnvSensorInfoXml(Entity):
                                                                            """
                                                                            Environment sensor info XML
                                                                            
                                                                            .. attribute:: data_type
                                                                            
                                                                            	Sensor data type
                                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Device Name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: status
                                                                            
                                                                            	Sensor operation state
                                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                            
                                                                            .. attribute:: threshold
                                                                            
                                                                            	Threshold information
                                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold>`
                                                                            
                                                                            .. attribute:: units
                                                                            
                                                                            	Units of variable being read
                                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                            
                                                                            .. attribute:: update_rate
                                                                            
                                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__init__()

                                                                                self.yang_name = "env-sensor-info-xml"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                                self.value = YLeaf(YType.str, "value")

                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                                self._children_yang_names.add("threshold")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("data_type",
                                                                                                "description",
                                                                                                "status",
                                                                                                "units",
                                                                                                "update_rate",
                                                                                                "value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                            class Threshold(Entity):
                                                                                """
                                                                                Threshold information
                                                                                
                                                                                .. attribute:: threshold_array
                                                                                
                                                                                	Array of threshold
                                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                                    self.yang_name = "threshold"
                                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                                    self.threshold_array = YList(self)

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in () and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                                class ThresholdArray(Entity):
                                                                                    """
                                                                                    Array of threshold
                                                                                    
                                                                                    .. attribute:: threshold_name
                                                                                    
                                                                                    	Threshold name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..50
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** \-2147483648..2147483647
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                        self.yang_name = "threshold-array"
                                                                                        self.yang_parent_name = "threshold"

                                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_name",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_name.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "threshold-array" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-name"):
                                                                                            self.threshold_name = value
                                                                                            self.threshold_name.value_namespace = name_space
                                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_data()):
                                                                                            return True
                                                                                    return False

                                                                                def has_operation(self):
                                                                                    for c in self.threshold_array:
                                                                                        if (c.has_operation()):
                                                                                            return True
                                                                                    return self.yfilter != YFilter.not_set

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "threshold" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "threshold-array"):
                                                                                        for c in self.threshold_array:
                                                                                            segment = c.get_segment_path()
                                                                                            if (segment_path == segment):
                                                                                                return c
                                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                        c.parent = self
                                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                                        self._local_refs[local_reference_key] = c
                                                                                        self.threshold_array.append(c)
                                                                                        return c

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "threshold-array"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.data_type.is_set or
                                                                                    self.description.is_set or
                                                                                    self.status.is_set or
                                                                                    self.units.is_set or
                                                                                    self.update_rate.is_set or
                                                                                    self.value.is_set or
                                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.status.yfilter != YFilter.not_set or
                                                                                    self.units.yfilter != YFilter.not_set or
                                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                                    self.value.yfilter != YFilter.not_set or
                                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "threshold"):
                                                                                    if (self.threshold is None):
                                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml.Threshold()
                                                                                        self.threshold.parent = self
                                                                                        self._children_name_map["threshold"] = "threshold"
                                                                                    return self.threshold

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "data-type"):
                                                                                    self.data_type = value
                                                                                    self.data_type.value_namespace = name_space
                                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "status"):
                                                                                    self.status = value
                                                                                    self.status.value_namespace = name_space
                                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "units"):
                                                                                    self.units = value
                                                                                    self.units.value_namespace = name_space
                                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "update-rate"):
                                                                                    self.update_rate = value
                                                                                    self.update_rate.value_namespace = name_space
                                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "value"):
                                                                                    self.value = value
                                                                                    self.value.value_namespace = name_space
                                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                                        class InvAssetBag(Entity):
                                                                            """
                                                                            Inventory Asset Bag
                                                                            
                                                                            .. attribute:: manufacturer_assembly_number
                                                                            
                                                                            	Manufacture Assembly number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_assembly_revision
                                                                            
                                                                            	Manufacture assembly revision
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                                            
                                                                            	Common Language Equipment           Identifier number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_firmware_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: manufacturer_software_identifier
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: original_equipment_manufacturer_string
                                                                            
                                                                            	String containing OEM information           if applicable
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: part_number
                                                                            
                                                                            	
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__init__()

                                                                                self.yang_name = "inv-asset-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("manufacturer_assembly_number",
                                                                                                "manufacturer_assembly_revision",
                                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                                "manufacturer_firmware_identifier",
                                                                                                "manufacturer_software_identifier",
                                                                                                "original_equipment_manufacturer_string",
                                                                                                "part_number") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.manufacturer_assembly_number.is_set or
                                                                                    self.manufacturer_assembly_revision.is_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                                    self.manufacturer_software_identifier.is_set or
                                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                                    self.part_number.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                                    self.part_number.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "manufacturer-assembly-number"):
                                                                                    self.manufacturer_assembly_number = value
                                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                                    self.manufacturer_assembly_revision = value
                                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                                    self.manufacturer_firmware_identifier = value
                                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-software-identifier"):
                                                                                    self.manufacturer_software_identifier = value
                                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                                    self.original_equipment_manufacturer_string = value
                                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "part-number"):
                                                                                    self.part_number = value
                                                                                    self.part_number.value_namespace = name_space
                                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                                        class Threshold(Entity):
                                                                            """
                                                                            Threshold
                                                                            
                                                                            .. attribute:: critical_hi
                                                                            
                                                                            	Critical High
                                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi>`
                                                                            
                                                                            .. attribute:: critical_lo
                                                                            
                                                                            	Critical Low
                                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo>`
                                                                            
                                                                            .. attribute:: major_hi
                                                                            
                                                                            	Major High
                                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi>`
                                                                            
                                                                            .. attribute:: major_lo
                                                                            
                                                                            	Major Low
                                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo>`
                                                                            
                                                                            .. attribute:: minor_hi
                                                                            
                                                                            	Minor High
                                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi>`
                                                                            
                                                                            .. attribute:: minor_lo
                                                                            
                                                                            	Minor Low
                                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold, self).__init__()

                                                                                self.yang_name = "threshold"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                                self._children_yang_names.add("critical-hi")

                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                                self._children_yang_names.add("critical-lo")

                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                                self._children_yang_names.add("major-hi")

                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                                self._children_yang_names.add("major-lo")

                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                                self._children_yang_names.add("minor-hi")

                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                                self._children_yang_names.add("minor-lo")


                                                                            class MajorLo(Entity):
                                                                                """
                                                                                Major Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo, self).__init__()

                                                                                    self.yang_name = "major-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalHi(Entity):
                                                                                """
                                                                                Critical High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi, self).__init__()

                                                                                    self.yang_name = "critical-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorHi(Entity):
                                                                                """
                                                                                Minor High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi, self).__init__()

                                                                                    self.yang_name = "minor-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MajorHi(Entity):
                                                                                """
                                                                                Major High
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi, self).__init__()

                                                                                    self.yang_name = "major-hi"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "major-hi"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "major-hi" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class CriticalLo(Entity):
                                                                                """
                                                                                Critical Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo, self).__init__()

                                                                                    self.yang_name = "critical-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "critical-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "critical-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass


                                                                            class MinorLo(Entity):
                                                                                """
                                                                                Minor Low
                                                                                
                                                                                .. attribute:: thresh_bag
                                                                                
                                                                                	Environment threshold info
                                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo, self).__init__()

                                                                                    self.yang_name = "minor-lo"
                                                                                    self.yang_parent_name = "threshold"

                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                    self._children_yang_names.add("thresh-bag")


                                                                                class ThreshBag(Entity):
                                                                                    """
                                                                                    Environment threshold info
                                                                                    
                                                                                    .. attribute:: threshold_evaluation
                                                                                    
                                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_notification_enabled
                                                                                    
                                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: threshold_relation
                                                                                    
                                                                                    	Indicates relation between sensor value and threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_severity
                                                                                    
                                                                                    	Indicates minor, major, critical severities
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: threshold_value
                                                                                    
                                                                                    	Value of the configured threshold
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                        self.yang_name = "thresh-bag"
                                                                                        self.yang_parent_name = "minor-lo"

                                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("threshold_evaluation",
                                                                                                        "threshold_notification_enabled",
                                                                                                        "threshold_relation",
                                                                                                        "threshold_severity",
                                                                                                        "threshold_value") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.threshold_evaluation.is_set or
                                                                                            self.threshold_notification_enabled.is_set or
                                                                                            self.threshold_relation.is_set or
                                                                                            self.threshold_severity.is_set or
                                                                                            self.threshold_value.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "threshold-evaluation"):
                                                                                            self.threshold_evaluation = value
                                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-notification-enabled"):
                                                                                            self.threshold_notification_enabled = value
                                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-relation"):
                                                                                            self.threshold_relation = value
                                                                                            self.threshold_relation.value_namespace = name_space
                                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-severity"):
                                                                                            self.threshold_severity = value
                                                                                            self.threshold_severity.value_namespace = name_space
                                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "threshold-value"):
                                                                                            self.threshold_value = value
                                                                                            self.threshold_value.value_namespace = name_space
                                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "minor-lo" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "thresh-bag"):
                                                                                        if (self.thresh_bag is None):
                                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                            self.thresh_bag.parent = self
                                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                        return self.thresh_bag

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "thresh-bag"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    pass

                                                                            def has_data(self):
                                                                                return (
                                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "critical-hi"):
                                                                                    if (self.critical_hi is None):
                                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalHi()
                                                                                        self.critical_hi.parent = self
                                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                                    return self.critical_hi

                                                                                if (child_yang_name == "critical-lo"):
                                                                                    if (self.critical_lo is None):
                                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.CriticalLo()
                                                                                        self.critical_lo.parent = self
                                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                                    return self.critical_lo

                                                                                if (child_yang_name == "major-hi"):
                                                                                    if (self.major_hi is None):
                                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorHi()
                                                                                        self.major_hi.parent = self
                                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                                    return self.major_hi

                                                                                if (child_yang_name == "major-lo"):
                                                                                    if (self.major_lo is None):
                                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MajorLo()
                                                                                        self.major_lo.parent = self
                                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                                    return self.major_lo

                                                                                if (child_yang_name == "minor-hi"):
                                                                                    if (self.minor_hi is None):
                                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorHi()
                                                                                        self.minor_hi.parent = self
                                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                                    return self.minor_hi

                                                                                if (child_yang_name == "minor-lo"):
                                                                                    if (self.minor_lo is None):
                                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold.MinorLo()
                                                                                        self.minor_lo.parent = self
                                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                                    return self.minor_lo

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                pass


                                                                        class FruInfo(Entity):
                                                                            """
                                                                            Inventory EDM FRU info
                                                                            
                                                                            .. attribute:: card_administrative_state
                                                                            
                                                                            	card admin state\: shutdown or not
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_monitor_state
                                                                            
                                                                            	card is monitored by a manager or left unmonitored
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_operational_state
                                                                            
                                                                            	card operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: card_reset_reason
                                                                            
                                                                            	card reset reason enum
                                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                            
                                                                            .. attribute:: card_up_time
                                                                            
                                                                            	card up time
                                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime>`
                                                                            
                                                                            .. attribute:: last_operational_state_change
                                                                            
                                                                            	last card oper change state
                                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange>`
                                                                            
                                                                            .. attribute:: power_administrative_state
                                                                            
                                                                            	power admin state\: up or down
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_current_measurement
                                                                            
                                                                            	power current\: not implemented
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: power_operational_state
                                                                            
                                                                            	Power operation state
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__init__()

                                                                                self.yang_name = "fru-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                                self._children_yang_names.add("card-up-time")

                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                self._children_yang_names.add("last-operational-state-change")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("card_administrative_state",
                                                                                                "card_monitor_state",
                                                                                                "card_operational_state",
                                                                                                "card_reset_reason",
                                                                                                "power_administrative_state",
                                                                                                "power_current_measurement",
                                                                                                "power_operational_state") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo, self).__setattr__(name, value)


                                                                            class LastOperationalStateChange(Entity):
                                                                                """
                                                                                last card oper change state
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                                    self.yang_name = "last-operational-state-change"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                            class CardUpTime(Entity):
                                                                                """
                                                                                card up time
                                                                                
                                                                                .. attribute:: time_in_nano_seconds
                                                                                
                                                                                	Time Value in Nano\-seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: nanosecond
                                                                                
                                                                                .. attribute:: time_in_seconds
                                                                                
                                                                                	Time Value in Seconds
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** \-2147483648..2147483647
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                                    self.yang_name = "card-up-time"
                                                                                    self.yang_parent_name = "fru-info"

                                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("time_in_nano_seconds",
                                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.time_in_nano_seconds.is_set or
                                                                                        self.time_in_seconds.is_set)

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "card-up-time" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "time-in-nano-seconds"):
                                                                                        self.time_in_nano_seconds = value
                                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "time-in-seconds"):
                                                                                        self.time_in_seconds = value
                                                                                        self.time_in_seconds.value_namespace = name_space
                                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.card_administrative_state.is_set or
                                                                                    self.card_monitor_state.is_set or
                                                                                    self.card_operational_state.is_set or
                                                                                    self.card_reset_reason.is_set or
                                                                                    self.power_administrative_state.is_set or
                                                                                    self.power_current_measurement.is_set or
                                                                                    self.power_operational_state.is_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "fru-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "card-up-time"):
                                                                                    if (self.card_up_time is None):
                                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.CardUpTime()
                                                                                        self.card_up_time.parent = self
                                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                                    return self.card_up_time

                                                                                if (child_yang_name == "last-operational-state-change"):
                                                                                    if (self.last_operational_state_change is None):
                                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo.LastOperationalStateChange()
                                                                                        self.last_operational_state_change.parent = self
                                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                                    return self.last_operational_state_change

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "card-administrative-state"):
                                                                                    self.card_administrative_state = value
                                                                                    self.card_administrative_state.value_namespace = name_space
                                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-monitor-state"):
                                                                                    self.card_monitor_state = value
                                                                                    self.card_monitor_state.value_namespace = name_space
                                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-operational-state"):
                                                                                    self.card_operational_state = value
                                                                                    self.card_operational_state.value_namespace = name_space
                                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "card-reset-reason"):
                                                                                    self.card_reset_reason = value
                                                                                    self.card_reset_reason.value_namespace = name_space
                                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-administrative-state"):
                                                                                    self.power_administrative_state = value
                                                                                    self.power_administrative_state.value_namespace = name_space
                                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-current-measurement"):
                                                                                    self.power_current_measurement = value
                                                                                    self.power_current_measurement.value_namespace = name_space
                                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "power-operational-state"):
                                                                                    self.power_operational_state = value
                                                                                    self.power_operational_state.value_namespace = name_space
                                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                        class InvBasicBag(Entity):
                                                                            """
                                                                            Inventory Basic Bag
                                                                            
                                                                            .. attribute:: alias
                                                                            
                                                                            	useful for storing an entity alias 
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_id_str
                                                                            
                                                                            	asset Identification string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: asset_identification
                                                                            
                                                                            	asset Identification
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: ceport
                                                                            
                                                                            	1 if ce port found, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: chip_hardware_revision
                                                                            
                                                                            	chip module hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: composite_class_code
                                                                            
                                                                            	Major&minor class of the entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	describes in user\-readable terms       what the entity in question does
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: environmental_monitor_path
                                                                            
                                                                            	sysdb name of sensor in the envmon EDM
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: firmware_revision
                                                                            
                                                                            	firmware revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: group_flag
                                                                            
                                                                            	indicates if this entity is group       or not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: hardware_revision
                                                                            
                                                                            	hw revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: is_field_replaceable_unit
                                                                            
                                                                            	1 if Field Replaceable Unit 0, if not
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: manufacturer_asset_tags
                                                                            
                                                                            	Manufacture Asset Tags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: manufacturer_name
                                                                            
                                                                            	manufacturer's name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: memory_size
                                                                            
                                                                            	Size of memory associated with       the entity where applicable
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: model_name
                                                                            
                                                                            	model name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name string for the entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: new_deviation_number
                                                                            
                                                                            	integer value for New Deviation Number 0x88
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: physical_layer_interface_module_type
                                                                            
                                                                            	integer value for plim type if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: redundancystate
                                                                            
                                                                            	integer value for Redundancy State if     applicable to this entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: serial_number
                                                                            
                                                                            	serial number
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: software_revision
                                                                            
                                                                            	software revision string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: unique_id
                                                                            
                                                                            	Unique id for an entity
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            .. attribute:: unrecognized_fru
                                                                            
                                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: vendor_type
                                                                            
                                                                            	maps to the vendor OID string
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: xr_scoped
                                                                            
                                                                            	1 if xr scoped, 0 if not
                                                                            	**type**\:  bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__init__()

                                                                                self.yang_name = "inv-basic-bag"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.alias = YLeaf(YType.str, "alias")

                                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("alias",
                                                                                                "asset_id_str",
                                                                                                "asset_identification",
                                                                                                "ceport",
                                                                                                "chip_hardware_revision",
                                                                                                "composite_class_code",
                                                                                                "description",
                                                                                                "environmental_monitor_path",
                                                                                                "firmware_revision",
                                                                                                "group_flag",
                                                                                                "hardware_revision",
                                                                                                "is_field_replaceable_unit",
                                                                                                "manufacturer_asset_tags",
                                                                                                "manufacturer_name",
                                                                                                "memory_size",
                                                                                                "model_name",
                                                                                                "name",
                                                                                                "new_deviation_number",
                                                                                                "physical_layer_interface_module_type",
                                                                                                "redundancystate",
                                                                                                "serial_number",
                                                                                                "software_revision",
                                                                                                "unique_id",
                                                                                                "unrecognized_fru",
                                                                                                "vendor_type",
                                                                                                "xr_scoped") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.alias.is_set or
                                                                                    self.asset_id_str.is_set or
                                                                                    self.asset_identification.is_set or
                                                                                    self.ceport.is_set or
                                                                                    self.chip_hardware_revision.is_set or
                                                                                    self.composite_class_code.is_set or
                                                                                    self.description.is_set or
                                                                                    self.environmental_monitor_path.is_set or
                                                                                    self.firmware_revision.is_set or
                                                                                    self.group_flag.is_set or
                                                                                    self.hardware_revision.is_set or
                                                                                    self.is_field_replaceable_unit.is_set or
                                                                                    self.manufacturer_asset_tags.is_set or
                                                                                    self.manufacturer_name.is_set or
                                                                                    self.memory_size.is_set or
                                                                                    self.model_name.is_set or
                                                                                    self.name.is_set or
                                                                                    self.new_deviation_number.is_set or
                                                                                    self.physical_layer_interface_module_type.is_set or
                                                                                    self.redundancystate.is_set or
                                                                                    self.serial_number.is_set or
                                                                                    self.software_revision.is_set or
                                                                                    self.unique_id.is_set or
                                                                                    self.unrecognized_fru.is_set or
                                                                                    self.vendor_type.is_set or
                                                                                    self.xr_scoped.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.alias.yfilter != YFilter.not_set or
                                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                                    self.name.yfilter != YFilter.not_set or
                                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "alias"):
                                                                                    self.alias = value
                                                                                    self.alias.value_namespace = name_space
                                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-id-str"):
                                                                                    self.asset_id_str = value
                                                                                    self.asset_id_str.value_namespace = name_space
                                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "asset-identification"):
                                                                                    self.asset_identification = value
                                                                                    self.asset_identification.value_namespace = name_space
                                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "ceport"):
                                                                                    self.ceport = value
                                                                                    self.ceport.value_namespace = name_space
                                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "chip-hardware-revision"):
                                                                                    self.chip_hardware_revision = value
                                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "composite-class-code"):
                                                                                    self.composite_class_code = value
                                                                                    self.composite_class_code.value_namespace = name_space
                                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "environmental-monitor-path"):
                                                                                    self.environmental_monitor_path = value
                                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "firmware-revision"):
                                                                                    self.firmware_revision = value
                                                                                    self.firmware_revision.value_namespace = name_space
                                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "group-flag"):
                                                                                    self.group_flag = value
                                                                                    self.group_flag.value_namespace = name_space
                                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "hardware-revision"):
                                                                                    self.hardware_revision = value
                                                                                    self.hardware_revision.value_namespace = name_space
                                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "is-field-replaceable-unit"):
                                                                                    self.is_field_replaceable_unit = value
                                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-asset-tags"):
                                                                                    self.manufacturer_asset_tags = value
                                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "manufacturer-name"):
                                                                                    self.manufacturer_name = value
                                                                                    self.manufacturer_name.value_namespace = name_space
                                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "memory-size"):
                                                                                    self.memory_size = value
                                                                                    self.memory_size.value_namespace = name_space
                                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "model-name"):
                                                                                    self.model_name = value
                                                                                    self.model_name.value_namespace = name_space
                                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "name"):
                                                                                    self.name = value
                                                                                    self.name.value_namespace = name_space
                                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "new-deviation-number"):
                                                                                    self.new_deviation_number = value
                                                                                    self.new_deviation_number.value_namespace = name_space
                                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                                    self.physical_layer_interface_module_type = value
                                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "redundancystate"):
                                                                                    self.redundancystate = value
                                                                                    self.redundancystate.value_namespace = name_space
                                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "serial-number"):
                                                                                    self.serial_number = value
                                                                                    self.serial_number.value_namespace = name_space
                                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "software-revision"):
                                                                                    self.software_revision = value
                                                                                    self.software_revision.value_namespace = name_space
                                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unique-id"):
                                                                                    self.unique_id = value
                                                                                    self.unique_id.value_namespace = name_space
                                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "unrecognized-fru"):
                                                                                    self.unrecognized_fru = value
                                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "vendor-type"):
                                                                                    self.vendor_type = value
                                                                                    self.vendor_type.value_namespace = name_space
                                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "xr-scoped"):
                                                                                    self.xr_scoped = value
                                                                                    self.xr_scoped.value_namespace = name_space
                                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                        class InvEepromInfo(Entity):
                                                                            """
                                                                            Inventory EDM EEPROM Information Bag
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	A textual description of physical entity
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: eeprom
                                                                            
                                                                            	EEPROM data not from hex data
                                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom>`
                                                                            
                                                                            .. attribute:: has_eeprom
                                                                            
                                                                            	use eeprom instead of opaque data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: inv_card_type
                                                                            
                                                                            	Inventory card type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: opaque_data
                                                                            
                                                                            	EEPROM hex data
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: opaque_data_size
                                                                            
                                                                            	size of the EEPROM hex data
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__init__()

                                                                                self.yang_name = "inv-eeprom-info"
                                                                                self.yang_parent_name = "attributes"

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                                self._children_yang_names.add("eeprom")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("description",
                                                                                                "has_eeprom",
                                                                                                "inv_card_type",
                                                                                                "opaque_data",
                                                                                                "opaque_data_size") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                            class Eeprom(Entity):
                                                                                """
                                                                                EEPROM data not from hex data
                                                                                
                                                                                .. attribute:: asset_alias
                                                                                
                                                                                	Asset Alias
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: asset_id
                                                                                
                                                                                	Asset ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address1
                                                                                
                                                                                	Base Mac Address #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address2
                                                                                
                                                                                	Base Mac Address #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address3
                                                                                
                                                                                	Base Mac Address #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: base_mac_address4
                                                                                
                                                                                	Base Mac Address #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_checksum
                                                                                
                                                                                	Block Checksum
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_count
                                                                                
                                                                                	Block Count
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_length
                                                                                
                                                                                	Block Length
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_signature
                                                                                
                                                                                	Block Signature
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: block_version
                                                                                
                                                                                	Block Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: chassis_sid
                                                                                
                                                                                	Chassis serial number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: clei
                                                                                
                                                                                	Common Language Equipment Identifier (CLEI) code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_family
                                                                                
                                                                                	Controller family
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: controller_type
                                                                                
                                                                                	Controller type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	A textual description of physical entity
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num1
                                                                                
                                                                                	Deviation Number # 1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num2
                                                                                
                                                                                	Deviation Number # 2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num3
                                                                                
                                                                                	Deviation Number # 3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num4
                                                                                
                                                                                	Deviation Number # 4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num5
                                                                                
                                                                                	Deviation Number # 5
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num6
                                                                                
                                                                                	Deviation Number # 6
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: dev_num7
                                                                                
                                                                                	Deviation Number # 7
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eci
                                                                                
                                                                                	Equipment Catalog Item (ECI) number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: eeprom_size
                                                                                
                                                                                	EEPROM Size
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: engineer_use
                                                                                
                                                                                	Engineer Use
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_major_type
                                                                                
                                                                                	FRU Major Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: fru_minor_type
                                                                                
                                                                                	FRU Minor Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hw_version
                                                                                
                                                                                	Hardware Version
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: hwid
                                                                                
                                                                                	Hardware Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: idprom_format_rev
                                                                                
                                                                                	IDPROM Format Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size1
                                                                                
                                                                                	Mac Address Block Size #1
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size2
                                                                                
                                                                                	Mac Address Block Size #2
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size3
                                                                                
                                                                                	Mac Address Block Size #3
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mac_add_blk_size4
                                                                                
                                                                                	Mac Address Block Size #4
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: manu_test_data
                                                                                
                                                                                	Manufacturing Test Data
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_bits
                                                                                
                                                                                	MFG Bits
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: mfg_deviation
                                                                                
                                                                                	MFG Deviation
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: oem_string
                                                                                
                                                                                	OEM String
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_number
                                                                                
                                                                                	Part Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: part_revision
                                                                                
                                                                                	Part Revision
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pca_num
                                                                                
                                                                                	PCA number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcavid
                                                                                
                                                                                	PCA revision ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pcb_serial_num
                                                                                
                                                                                	PCB Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: pid
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_consumption
                                                                                
                                                                                	Power Consumption
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: power_supply_type
                                                                                
                                                                                	Power Supply Type
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: product_id
                                                                                
                                                                                	Product ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: rma
                                                                                
                                                                                	RMA Data
                                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                                
                                                                                .. attribute:: rma_code
                                                                                
                                                                                	RMA Code
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: serial_number
                                                                                
                                                                                	Serial Number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: snmpoid
                                                                                
                                                                                	SNMP OID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_part_num
                                                                                
                                                                                	Top assembly part number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: top_assem_vid
                                                                                
                                                                                	Top assembly revision number
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_description
                                                                                
                                                                                	UDI description
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: udi_name
                                                                                
                                                                                	UDI name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                .. attribute:: vid
                                                                                
                                                                                	Version ID
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'invmgr-oper'
                                                                                _revision = '2015-11-09'

                                                                                def __init__(self):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                                    self.yang_name = "eeprom"
                                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                    self._children_yang_names.add("rma")

                                                                                def __setattr__(self, name, value):
                                                                                    self._check_monkey_patching_error(name, value)
                                                                                    with _handle_type_error():
                                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                "Please use list append or extend method."
                                                                                                                .format(value))
                                                                                        if isinstance(value, Enum.YLeaf):
                                                                                            value = value.name
                                                                                        if name in ("asset_alias",
                                                                                                    "asset_id",
                                                                                                    "base_mac_address1",
                                                                                                    "base_mac_address2",
                                                                                                    "base_mac_address3",
                                                                                                    "base_mac_address4",
                                                                                                    "block_checksum",
                                                                                                    "block_count",
                                                                                                    "block_length",
                                                                                                    "block_signature",
                                                                                                    "block_version",
                                                                                                    "chassis_sid",
                                                                                                    "clei",
                                                                                                    "controller_family",
                                                                                                    "controller_type",
                                                                                                    "description",
                                                                                                    "dev_num1",
                                                                                                    "dev_num2",
                                                                                                    "dev_num3",
                                                                                                    "dev_num4",
                                                                                                    "dev_num5",
                                                                                                    "dev_num6",
                                                                                                    "dev_num7",
                                                                                                    "eci",
                                                                                                    "eeprom_size",
                                                                                                    "engineer_use",
                                                                                                    "fru_major_type",
                                                                                                    "fru_minor_type",
                                                                                                    "hw_version",
                                                                                                    "hwid",
                                                                                                    "idprom_format_rev",
                                                                                                    "mac_add_blk_size1",
                                                                                                    "mac_add_blk_size2",
                                                                                                    "mac_add_blk_size3",
                                                                                                    "mac_add_blk_size4",
                                                                                                    "manu_test_data",
                                                                                                    "mfg_bits",
                                                                                                    "mfg_deviation",
                                                                                                    "oem_string",
                                                                                                    "part_number",
                                                                                                    "part_revision",
                                                                                                    "pca_num",
                                                                                                    "pcavid",
                                                                                                    "pcb_serial_num",
                                                                                                    "pid",
                                                                                                    "power_consumption",
                                                                                                    "power_supply_type",
                                                                                                    "product_id",
                                                                                                    "rma_code",
                                                                                                    "serial_number",
                                                                                                    "snmpoid",
                                                                                                    "top_assem_part_num",
                                                                                                    "top_assem_vid",
                                                                                                    "udi_description",
                                                                                                    "udi_name",
                                                                                                    "vid") and name in self.__dict__:
                                                                                            if isinstance(value, YLeaf):
                                                                                                self.__dict__[name].set(value.get())
                                                                                            elif isinstance(value, YLeafList):
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                            else:
                                                                                                self.__dict__[name].set(value)
                                                                                        else:
                                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                    value.parent = self
                                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                    value.parent = self
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                                class Rma(Entity):
                                                                                    """
                                                                                    RMA Data
                                                                                    
                                                                                    .. attribute:: rma_history
                                                                                    
                                                                                    	RMA history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: rma_number
                                                                                    
                                                                                    	RMA tracking number format is N\-N\-N
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    .. attribute:: test_history
                                                                                    
                                                                                    	Test history
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'invmgr-oper'
                                                                                    _revision = '2015-11-09'

                                                                                    def __init__(self):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                        self.yang_name = "rma"
                                                                                        self.yang_parent_name = "eeprom"

                                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                                    def __setattr__(self, name, value):
                                                                                        self._check_monkey_patching_error(name, value)
                                                                                        with _handle_type_error():
                                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                                    "Please use list append or extend method."
                                                                                                                    .format(value))
                                                                                            if isinstance(value, Enum.YLeaf):
                                                                                                value = value.name
                                                                                            if name in ("rma_history",
                                                                                                        "rma_number",
                                                                                                        "test_history") and name in self.__dict__:
                                                                                                if isinstance(value, YLeaf):
                                                                                                    self.__dict__[name].set(value.get())
                                                                                                elif isinstance(value, YLeafList):
                                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                                else:
                                                                                                    self.__dict__[name].set(value)
                                                                                            else:
                                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                        value.parent = self
                                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                        value.parent = self
                                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                                    def has_data(self):
                                                                                        return (
                                                                                            self.rma_history.is_set or
                                                                                            self.rma_number.is_set or
                                                                                            self.test_history.is_set)

                                                                                    def has_operation(self):
                                                                                        return (
                                                                                            self.yfilter != YFilter.not_set or
                                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                                    def get_segment_path(self):
                                                                                        path_buffer = ""
                                                                                        path_buffer = "rma" + path_buffer

                                                                                        return path_buffer

                                                                                    def get_entity_path(self, ancestor):
                                                                                        path_buffer = ""
                                                                                        if (ancestor is None):
                                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                        else:
                                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                        leaf_name_data = LeafDataList()
                                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                        return entity_path

                                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                        if child is not None:
                                                                                            return child

                                                                                        return None

                                                                                    def has_leaf_or_child_of_name(self, name):
                                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                            return True
                                                                                        return False

                                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                        if(value_path == "rma-history"):
                                                                                            self.rma_history = value
                                                                                            self.rma_history.value_namespace = name_space
                                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "rma-number"):
                                                                                            self.rma_number = value
                                                                                            self.rma_number.value_namespace = name_space
                                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                        if(value_path == "test-history"):
                                                                                            self.test_history = value
                                                                                            self.test_history.value_namespace = name_space
                                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                                def has_data(self):
                                                                                    return (
                                                                                        self.asset_alias.is_set or
                                                                                        self.asset_id.is_set or
                                                                                        self.base_mac_address1.is_set or
                                                                                        self.base_mac_address2.is_set or
                                                                                        self.base_mac_address3.is_set or
                                                                                        self.base_mac_address4.is_set or
                                                                                        self.block_checksum.is_set or
                                                                                        self.block_count.is_set or
                                                                                        self.block_length.is_set or
                                                                                        self.block_signature.is_set or
                                                                                        self.block_version.is_set or
                                                                                        self.chassis_sid.is_set or
                                                                                        self.clei.is_set or
                                                                                        self.controller_family.is_set or
                                                                                        self.controller_type.is_set or
                                                                                        self.description.is_set or
                                                                                        self.dev_num1.is_set or
                                                                                        self.dev_num2.is_set or
                                                                                        self.dev_num3.is_set or
                                                                                        self.dev_num4.is_set or
                                                                                        self.dev_num5.is_set or
                                                                                        self.dev_num6.is_set or
                                                                                        self.dev_num7.is_set or
                                                                                        self.eci.is_set or
                                                                                        self.eeprom_size.is_set or
                                                                                        self.engineer_use.is_set or
                                                                                        self.fru_major_type.is_set or
                                                                                        self.fru_minor_type.is_set or
                                                                                        self.hw_version.is_set or
                                                                                        self.hwid.is_set or
                                                                                        self.idprom_format_rev.is_set or
                                                                                        self.mac_add_blk_size1.is_set or
                                                                                        self.mac_add_blk_size2.is_set or
                                                                                        self.mac_add_blk_size3.is_set or
                                                                                        self.mac_add_blk_size4.is_set or
                                                                                        self.manu_test_data.is_set or
                                                                                        self.mfg_bits.is_set or
                                                                                        self.mfg_deviation.is_set or
                                                                                        self.oem_string.is_set or
                                                                                        self.part_number.is_set or
                                                                                        self.part_revision.is_set or
                                                                                        self.pca_num.is_set or
                                                                                        self.pcavid.is_set or
                                                                                        self.pcb_serial_num.is_set or
                                                                                        self.pid.is_set or
                                                                                        self.power_consumption.is_set or
                                                                                        self.power_supply_type.is_set or
                                                                                        self.product_id.is_set or
                                                                                        self.rma_code.is_set or
                                                                                        self.serial_number.is_set or
                                                                                        self.snmpoid.is_set or
                                                                                        self.top_assem_part_num.is_set or
                                                                                        self.top_assem_vid.is_set or
                                                                                        self.udi_description.is_set or
                                                                                        self.udi_name.is_set or
                                                                                        self.vid.is_set or
                                                                                        (self.rma is not None and self.rma.has_data()))

                                                                                def has_operation(self):
                                                                                    return (
                                                                                        self.yfilter != YFilter.not_set or
                                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                                        self.clei.yfilter != YFilter.not_set or
                                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                                        self.description.yfilter != YFilter.not_set or
                                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                                        self.eci.yfilter != YFilter.not_set or
                                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                        self.pid.yfilter != YFilter.not_set or
                                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                                        self.vid.yfilter != YFilter.not_set or
                                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                                def get_segment_path(self):
                                                                                    path_buffer = ""
                                                                                    path_buffer = "eeprom" + path_buffer

                                                                                    return path_buffer

                                                                                def get_entity_path(self, ancestor):
                                                                                    path_buffer = ""
                                                                                    if (ancestor is None):
                                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                    else:
                                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                    leaf_name_data = LeafDataList()
                                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                    return entity_path

                                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                    if child is not None:
                                                                                        return child

                                                                                    if (child_yang_name == "rma"):
                                                                                        if (self.rma is None):
                                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                            self.rma.parent = self
                                                                                            self._children_name_map["rma"] = "rma"
                                                                                        return self.rma

                                                                                    return None

                                                                                def has_leaf_or_child_of_name(self, name):
                                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                        return True
                                                                                    return False

                                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                    if(value_path == "asset-alias"):
                                                                                        self.asset_alias = value
                                                                                        self.asset_alias.value_namespace = name_space
                                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "asset-id"):
                                                                                        self.asset_id = value
                                                                                        self.asset_id.value_namespace = name_space
                                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address1"):
                                                                                        self.base_mac_address1 = value
                                                                                        self.base_mac_address1.value_namespace = name_space
                                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address2"):
                                                                                        self.base_mac_address2 = value
                                                                                        self.base_mac_address2.value_namespace = name_space
                                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address3"):
                                                                                        self.base_mac_address3 = value
                                                                                        self.base_mac_address3.value_namespace = name_space
                                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "base-mac-address4"):
                                                                                        self.base_mac_address4 = value
                                                                                        self.base_mac_address4.value_namespace = name_space
                                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-checksum"):
                                                                                        self.block_checksum = value
                                                                                        self.block_checksum.value_namespace = name_space
                                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-count"):
                                                                                        self.block_count = value
                                                                                        self.block_count.value_namespace = name_space
                                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-length"):
                                                                                        self.block_length = value
                                                                                        self.block_length.value_namespace = name_space
                                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-signature"):
                                                                                        self.block_signature = value
                                                                                        self.block_signature.value_namespace = name_space
                                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "block-version"):
                                                                                        self.block_version = value
                                                                                        self.block_version.value_namespace = name_space
                                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "chassis-sid"):
                                                                                        self.chassis_sid = value
                                                                                        self.chassis_sid.value_namespace = name_space
                                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "clei"):
                                                                                        self.clei = value
                                                                                        self.clei.value_namespace = name_space
                                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-family"):
                                                                                        self.controller_family = value
                                                                                        self.controller_family.value_namespace = name_space
                                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "controller-type"):
                                                                                        self.controller_type = value
                                                                                        self.controller_type.value_namespace = name_space
                                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "description"):
                                                                                        self.description = value
                                                                                        self.description.value_namespace = name_space
                                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num1"):
                                                                                        self.dev_num1 = value
                                                                                        self.dev_num1.value_namespace = name_space
                                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num2"):
                                                                                        self.dev_num2 = value
                                                                                        self.dev_num2.value_namespace = name_space
                                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num3"):
                                                                                        self.dev_num3 = value
                                                                                        self.dev_num3.value_namespace = name_space
                                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num4"):
                                                                                        self.dev_num4 = value
                                                                                        self.dev_num4.value_namespace = name_space
                                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num5"):
                                                                                        self.dev_num5 = value
                                                                                        self.dev_num5.value_namespace = name_space
                                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num6"):
                                                                                        self.dev_num6 = value
                                                                                        self.dev_num6.value_namespace = name_space
                                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "dev-num7"):
                                                                                        self.dev_num7 = value
                                                                                        self.dev_num7.value_namespace = name_space
                                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eci"):
                                                                                        self.eci = value
                                                                                        self.eci.value_namespace = name_space
                                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "eeprom-size"):
                                                                                        self.eeprom_size = value
                                                                                        self.eeprom_size.value_namespace = name_space
                                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "engineer-use"):
                                                                                        self.engineer_use = value
                                                                                        self.engineer_use.value_namespace = name_space
                                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-major-type"):
                                                                                        self.fru_major_type = value
                                                                                        self.fru_major_type.value_namespace = name_space
                                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "fru-minor-type"):
                                                                                        self.fru_minor_type = value
                                                                                        self.fru_minor_type.value_namespace = name_space
                                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hw-version"):
                                                                                        self.hw_version = value
                                                                                        self.hw_version.value_namespace = name_space
                                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "hwid"):
                                                                                        self.hwid = value
                                                                                        self.hwid.value_namespace = name_space
                                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "idprom-format-rev"):
                                                                                        self.idprom_format_rev = value
                                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size1"):
                                                                                        self.mac_add_blk_size1 = value
                                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size2"):
                                                                                        self.mac_add_blk_size2 = value
                                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size3"):
                                                                                        self.mac_add_blk_size3 = value
                                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mac-add-blk-size4"):
                                                                                        self.mac_add_blk_size4 = value
                                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "manu-test-data"):
                                                                                        self.manu_test_data = value
                                                                                        self.manu_test_data.value_namespace = name_space
                                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-bits"):
                                                                                        self.mfg_bits = value
                                                                                        self.mfg_bits.value_namespace = name_space
                                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "mfg-deviation"):
                                                                                        self.mfg_deviation = value
                                                                                        self.mfg_deviation.value_namespace = name_space
                                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "oem-string"):
                                                                                        self.oem_string = value
                                                                                        self.oem_string.value_namespace = name_space
                                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-number"):
                                                                                        self.part_number = value
                                                                                        self.part_number.value_namespace = name_space
                                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "part-revision"):
                                                                                        self.part_revision = value
                                                                                        self.part_revision.value_namespace = name_space
                                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pca-num"):
                                                                                        self.pca_num = value
                                                                                        self.pca_num.value_namespace = name_space
                                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcavid"):
                                                                                        self.pcavid = value
                                                                                        self.pcavid.value_namespace = name_space
                                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pcb-serial-num"):
                                                                                        self.pcb_serial_num = value
                                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "pid"):
                                                                                        self.pid = value
                                                                                        self.pid.value_namespace = name_space
                                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-consumption"):
                                                                                        self.power_consumption = value
                                                                                        self.power_consumption.value_namespace = name_space
                                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "power-supply-type"):
                                                                                        self.power_supply_type = value
                                                                                        self.power_supply_type.value_namespace = name_space
                                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "product-id"):
                                                                                        self.product_id = value
                                                                                        self.product_id.value_namespace = name_space
                                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "rma-code"):
                                                                                        self.rma_code = value
                                                                                        self.rma_code.value_namespace = name_space
                                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "serial-number"):
                                                                                        self.serial_number = value
                                                                                        self.serial_number.value_namespace = name_space
                                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "snmpoid"):
                                                                                        self.snmpoid = value
                                                                                        self.snmpoid.value_namespace = name_space
                                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-part-num"):
                                                                                        self.top_assem_part_num = value
                                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "top-assem-vid"):
                                                                                        self.top_assem_vid = value
                                                                                        self.top_assem_vid.value_namespace = name_space
                                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-description"):
                                                                                        self.udi_description = value
                                                                                        self.udi_description.value_namespace = name_space
                                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "udi-name"):
                                                                                        self.udi_name = value
                                                                                        self.udi_name.value_namespace = name_space
                                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                                    if(value_path == "vid"):
                                                                                        self.vid = value
                                                                                        self.vid.value_namespace = name_space
                                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.description.is_set or
                                                                                    self.has_eeprom.is_set or
                                                                                    self.inv_card_type.is_set or
                                                                                    self.opaque_data.is_set or
                                                                                    self.opaque_data_size.is_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.description.yfilter != YFilter.not_set or
                                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                if (child_yang_name == "eeprom"):
                                                                                    if (self.eeprom is None):
                                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo.Eeprom()
                                                                                        self.eeprom.parent = self
                                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                                    return self.eeprom

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "description"):
                                                                                    self.description = value
                                                                                    self.description.value_namespace = name_space
                                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "has-eeprom"):
                                                                                    self.has_eeprom = value
                                                                                    self.has_eeprom.value_namespace = name_space
                                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "inv-card-type"):
                                                                                    self.inv_card_type = value
                                                                                    self.inv_card_type.value_namespace = name_space
                                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data"):
                                                                                    self.opaque_data = value
                                                                                    self.opaque_data.value_namespace = name_space
                                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "opaque-data-size"):
                                                                                    self.opaque_data_size = value
                                                                                    self.opaque_data_size.value_namespace = name_space
                                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.module_done.is_set or
                                                                                self.node_id.is_set or
                                                                                self.vm_done.is_set or
                                                                                self.vm_node_id.is_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                                (self.threshold is not None and self.threshold.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.module_done.yfilter != YFilter.not_set or
                                                                                self.node_id.yfilter != YFilter.not_set or
                                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "attributes" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "env-sensor-info"):
                                                                                if (self.env_sensor_info is None):
                                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfo()
                                                                                    self.env_sensor_info.parent = self
                                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                                return self.env_sensor_info

                                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                                if (self.env_sensor_info_xml is None):
                                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.EnvSensorInfoXml()
                                                                                    self.env_sensor_info_xml.parent = self
                                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                                return self.env_sensor_info_xml

                                                                            if (child_yang_name == "fru-info"):
                                                                                if (self.fru_info is None):
                                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.FruInfo()
                                                                                    self.fru_info.parent = self
                                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                                return self.fru_info

                                                                            if (child_yang_name == "inv-asset-bag"):
                                                                                if (self.inv_asset_bag is None):
                                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvAssetBag()
                                                                                    self.inv_asset_bag.parent = self
                                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                                return self.inv_asset_bag

                                                                            if (child_yang_name == "inv-basic-bag"):
                                                                                if (self.inv_basic_bag is None):
                                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvBasicBag()
                                                                                    self.inv_basic_bag.parent = self
                                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                                return self.inv_basic_bag

                                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                                if (self.inv_eeprom_info is None):
                                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.InvEepromInfo()
                                                                                    self.inv_eeprom_info.parent = self
                                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                                return self.inv_eeprom_info

                                                                            if (child_yang_name == "pwg-info"):
                                                                                if (self.pwg_info is None):
                                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.PwgInfo()
                                                                                    self.pwg_info.parent = self
                                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                                return self.pwg_info

                                                                            if (child_yang_name == "threshold"):
                                                                                if (self.threshold is None):
                                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes.Threshold()
                                                                                    self.threshold.parent = self
                                                                                    self._children_name_map["threshold"] = "threshold"
                                                                                return self.threshold

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "module-done"):
                                                                                self.module_done = value
                                                                                self.module_done.value_namespace = name_space
                                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "node-id"):
                                                                                self.node_id = value
                                                                                self.node_id.value_namespace = name_space
                                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-done"):
                                                                                self.vm_done = value
                                                                                self.vm_done.value_namespace = name_space
                                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vm-node-id"):
                                                                                self.vm_node_id = value
                                                                                self.vm_node_id.value_namespace = name_space
                                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.name.is_set or
                                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                                            (self.tsi7s is not None and self.tsi7s.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "tsi6" + "[name='" + self.name.get() + "']" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "attributes"):
                                                                            if (self.attributes is None):
                                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Attributes()
                                                                                self.attributes.parent = self
                                                                                self._children_name_map["attributes"] = "attributes"
                                                                            return self.attributes

                                                                        if (child_yang_name == "tsi7s"):
                                                                            if (self.tsi7s is None):
                                                                                self.tsi7s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6.Tsi7S()
                                                                                self.tsi7s.parent = self
                                                                                self._children_name_map["tsi7s"] = "tsi7s"
                                                                            return self.tsi7s

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "attributes" or name == "tsi7s" or name == "name"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.tsi6:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "tsi6s" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "tsi6"):
                                                                        for c in self.tsi6:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S.Tsi6()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.tsi6.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "tsi6"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class Attributes(Entity):
                                                                """
                                                                Attributes
                                                                
                                                                .. attribute:: env_sensor_info
                                                                
                                                                	Environment sensor info
                                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo>`
                                                                
                                                                .. attribute:: env_sensor_info_xml
                                                                
                                                                	Environment sensor info XML
                                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml>`
                                                                
                                                                .. attribute:: fru_info
                                                                
                                                                	Inventory EDM FRU info
                                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo>`
                                                                
                                                                .. attribute:: inv_asset_bag
                                                                
                                                                	Inventory Asset Bag
                                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag>`
                                                                
                                                                .. attribute:: inv_basic_bag
                                                                
                                                                	Inventory Basic Bag
                                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag>`
                                                                
                                                                .. attribute:: inv_eeprom_info
                                                                
                                                                	Inventory EDM EEPROM Information Bag
                                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo>`
                                                                
                                                                .. attribute:: module_done
                                                                
                                                                	Inventory EDM Module Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**default value**\: 1
                                                                
                                                                .. attribute:: node_id
                                                                
                                                                	Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pwg_info
                                                                
                                                                	Inventory EDM PWG info
                                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo>`
                                                                
                                                                .. attribute:: threshold
                                                                
                                                                	Threshold
                                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold>`
                                                                
                                                                .. attribute:: vm_done
                                                                
                                                                	VM Done Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                .. attribute:: vm_node_id
                                                                
                                                                	VM Node ID Tuple
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__init__()

                                                                    self.yang_name = "attributes"
                                                                    self.yang_parent_name = "tsi5"

                                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                    self._children_yang_names.add("env-sensor-info")

                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                    self._children_yang_names.add("fru-info")

                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                    self._children_yang_names.add("inv-asset-bag")

                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                    self._children_yang_names.add("inv-basic-bag")

                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                    self._children_yang_names.add("inv-eeprom-info")

                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                    self._children_yang_names.add("pwg-info")

                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                    self._children_yang_names.add("threshold")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("module_done",
                                                                                    "node_id",
                                                                                    "vm_done",
                                                                                    "vm_node_id") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes, self).__setattr__(name, value)


                                                                class EnvSensorInfo(Entity):
                                                                    """
                                                                    Environment sensor info
                                                                    
                                                                    .. attribute:: age_time_stamp
                                                                    
                                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: alarm_type
                                                                    
                                                                    	Indicates threshold violation
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: device_description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: device_id
                                                                    
                                                                    	Identifier for this device
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: field_validity_bitmap
                                                                    
                                                                    	Sensor valid bitmap
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: precision
                                                                    
                                                                    	Sensor precision range
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: scale
                                                                    
                                                                    	Sensor scale enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state enums
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__init__()

                                                                        self.yang_name = "env-sensor-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                                        self.status = YLeaf(YType.uint32, "status")

                                                                        self.units = YLeaf(YType.str, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("age_time_stamp",
                                                                                        "alarm_type",
                                                                                        "data_type",
                                                                                        "device_description",
                                                                                        "device_id",
                                                                                        "field_validity_bitmap",
                                                                                        "precision",
                                                                                        "scale",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.age_time_stamp.is_set or
                                                                            self.alarm_type.is_set or
                                                                            self.data_type.is_set or
                                                                            self.device_description.is_set or
                                                                            self.device_id.is_set or
                                                                            self.field_validity_bitmap.is_set or
                                                                            self.precision.is_set or
                                                                            self.scale.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.device_description.yfilter != YFilter.not_set or
                                                                            self.device_id.yfilter != YFilter.not_set or
                                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                            self.precision.yfilter != YFilter.not_set or
                                                                            self.scale.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "age-time-stamp"):
                                                                            self.age_time_stamp = value
                                                                            self.age_time_stamp.value_namespace = name_space
                                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "alarm-type"):
                                                                            self.alarm_type = value
                                                                            self.alarm_type.value_namespace = name_space
                                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-description"):
                                                                            self.device_description = value
                                                                            self.device_description.value_namespace = name_space
                                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "device-id"):
                                                                            self.device_id = value
                                                                            self.device_id.value_namespace = name_space
                                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "field-validity-bitmap"):
                                                                            self.field_validity_bitmap = value
                                                                            self.field_validity_bitmap.value_namespace = name_space
                                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "precision"):
                                                                            self.precision = value
                                                                            self.precision.value_namespace = name_space
                                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "scale"):
                                                                            self.scale = value
                                                                            self.scale.value_namespace = name_space
                                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class PwgInfo(Entity):
                                                                    """
                                                                    Inventory EDM PWG info
                                                                    
                                                                    .. attribute:: power_group_available_current
                                                                    
                                                                    	available current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_drawn_current
                                                                    
                                                                    	drawn current
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_group_power_units
                                                                    
                                                                    	power units
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: power_group_redundancy_mode
                                                                    
                                                                    	redundancy mode
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__init__()

                                                                        self.yang_name = "pwg-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("power_group_available_current",
                                                                                        "power_group_drawn_current",
                                                                                        "power_group_power_units",
                                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.power_group_available_current.is_set or
                                                                            self.power_group_drawn_current.is_set or
                                                                            self.power_group_power_units.is_set or
                                                                            self.power_group_redundancy_mode.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "pwg-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "power-group-available-current"):
                                                                            self.power_group_available_current = value
                                                                            self.power_group_available_current.value_namespace = name_space
                                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-drawn-current"):
                                                                            self.power_group_drawn_current = value
                                                                            self.power_group_drawn_current.value_namespace = name_space
                                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-power-units"):
                                                                            self.power_group_power_units = value
                                                                            self.power_group_power_units.value_namespace = name_space
                                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-group-redundancy-mode"):
                                                                            self.power_group_redundancy_mode = value
                                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                                class EnvSensorInfoXml(Entity):
                                                                    """
                                                                    Environment sensor info XML
                                                                    
                                                                    .. attribute:: data_type
                                                                    
                                                                    	Sensor data type
                                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Device Name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: status
                                                                    
                                                                    	Sensor operation state
                                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                                    
                                                                    .. attribute:: threshold
                                                                    
                                                                    	Threshold information
                                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold>`
                                                                    
                                                                    .. attribute:: units
                                                                    
                                                                    	Units of variable being read
                                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                                    
                                                                    .. attribute:: update_rate
                                                                    
                                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__init__()

                                                                        self.yang_name = "env-sensor-info-xml"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.status = YLeaf(YType.enumeration, "status")

                                                                        self.units = YLeaf(YType.enumeration, "units")

                                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                        self.value = YLeaf(YType.str, "value")

                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                        self._children_yang_names.add("threshold")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("data_type",
                                                                                        "description",
                                                                                        "status",
                                                                                        "units",
                                                                                        "update_rate",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                                    class Threshold(Entity):
                                                                        """
                                                                        Threshold information
                                                                        
                                                                        .. attribute:: threshold_array
                                                                        
                                                                        	Array of threshold
                                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                            self.yang_name = "threshold"
                                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                                            self.threshold_array = YList(self)

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in () and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                        class ThresholdArray(Entity):
                                                                            """
                                                                            Array of threshold
                                                                            
                                                                            .. attribute:: threshold_name
                                                                            
                                                                            	Threshold name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..50
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** \-2147483648..2147483647
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                                self.yang_name = "threshold-array"
                                                                                self.yang_parent_name = "threshold"

                                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_name",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_name.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "threshold-array" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-name"):
                                                                                    self.threshold_name = value
                                                                                    self.threshold_name.value_namespace = name_space
                                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_data()):
                                                                                    return True
                                                                            return False

                                                                        def has_operation(self):
                                                                            for c in self.threshold_array:
                                                                                if (c.has_operation()):
                                                                                    return True
                                                                            return self.yfilter != YFilter.not_set

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "threshold" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "threshold-array"):
                                                                                for c in self.threshold_array:
                                                                                    segment = c.get_segment_path()
                                                                                    if (segment_path == segment):
                                                                                        return c
                                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                                c.parent = self
                                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                                self._local_refs[local_reference_key] = c
                                                                                self.threshold_array.append(c)
                                                                                return c

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "threshold-array"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            self.data_type.is_set or
                                                                            self.description.is_set or
                                                                            self.status.is_set or
                                                                            self.units.is_set or
                                                                            self.update_rate.is_set or
                                                                            self.value.is_set or
                                                                            (self.threshold is not None and self.threshold.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.data_type.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.status.yfilter != YFilter.not_set or
                                                                            self.units.yfilter != YFilter.not_set or
                                                                            self.update_rate.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "threshold"):
                                                                            if (self.threshold is None):
                                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml.Threshold()
                                                                                self.threshold.parent = self
                                                                                self._children_name_map["threshold"] = "threshold"
                                                                            return self.threshold

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "data-type"):
                                                                            self.data_type = value
                                                                            self.data_type.value_namespace = name_space
                                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "status"):
                                                                            self.status = value
                                                                            self.status.value_namespace = name_space
                                                                            self.status.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "units"):
                                                                            self.units = value
                                                                            self.units.value_namespace = name_space
                                                                            self.units.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "update-rate"):
                                                                            self.update_rate = value
                                                                            self.update_rate.value_namespace = name_space
                                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class InvAssetBag(Entity):
                                                                    """
                                                                    Inventory Asset Bag
                                                                    
                                                                    .. attribute:: manufacturer_assembly_number
                                                                    
                                                                    	Manufacture Assembly number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_assembly_revision
                                                                    
                                                                    	Manufacture assembly revision
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                                    
                                                                    	Common Language Equipment           Identifier number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_firmware_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: manufacturer_software_identifier
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: original_equipment_manufacturer_string
                                                                    
                                                                    	String containing OEM information           if applicable
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: part_number
                                                                    
                                                                    	
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__init__()

                                                                        self.yang_name = "inv-asset-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("manufacturer_assembly_number",
                                                                                        "manufacturer_assembly_revision",
                                                                                        "manufacturer_common_language_equipment_identifier",
                                                                                        "manufacturer_firmware_identifier",
                                                                                        "manufacturer_software_identifier",
                                                                                        "original_equipment_manufacturer_string",
                                                                                        "part_number") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.manufacturer_assembly_number.is_set or
                                                                            self.manufacturer_assembly_revision.is_set or
                                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                                            self.manufacturer_firmware_identifier.is_set or
                                                                            self.manufacturer_software_identifier.is_set or
                                                                            self.original_equipment_manufacturer_string.is_set or
                                                                            self.part_number.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                            self.part_number.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "manufacturer-assembly-number"):
                                                                            self.manufacturer_assembly_number = value
                                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-assembly-revision"):
                                                                            self.manufacturer_assembly_revision = value
                                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                            self.manufacturer_common_language_equipment_identifier = value
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                                            self.manufacturer_firmware_identifier = value
                                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-software-identifier"):
                                                                            self.manufacturer_software_identifier = value
                                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                                            self.original_equipment_manufacturer_string = value
                                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "part-number"):
                                                                            self.part_number = value
                                                                            self.part_number.value_namespace = name_space
                                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                                class Threshold(Entity):
                                                                    """
                                                                    Threshold
                                                                    
                                                                    .. attribute:: critical_hi
                                                                    
                                                                    	Critical High
                                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi>`
                                                                    
                                                                    .. attribute:: critical_lo
                                                                    
                                                                    	Critical Low
                                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo>`
                                                                    
                                                                    .. attribute:: major_hi
                                                                    
                                                                    	Major High
                                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi>`
                                                                    
                                                                    .. attribute:: major_lo
                                                                    
                                                                    	Major Low
                                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo>`
                                                                    
                                                                    .. attribute:: minor_hi
                                                                    
                                                                    	Minor High
                                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi>`
                                                                    
                                                                    .. attribute:: minor_lo
                                                                    
                                                                    	Minor Low
                                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold, self).__init__()

                                                                        self.yang_name = "threshold"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                        self._children_yang_names.add("critical-hi")

                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                        self._children_yang_names.add("critical-lo")

                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                        self._children_yang_names.add("major-hi")

                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                        self._children_yang_names.add("major-lo")

                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                        self._children_yang_names.add("minor-hi")

                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                        self._children_yang_names.add("minor-lo")


                                                                    class MajorLo(Entity):
                                                                        """
                                                                        Major Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo, self).__init__()

                                                                            self.yang_name = "major-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalHi(Entity):
                                                                        """
                                                                        Critical High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi, self).__init__()

                                                                            self.yang_name = "critical-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorHi(Entity):
                                                                        """
                                                                        Minor High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi, self).__init__()

                                                                            self.yang_name = "minor-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MajorHi(Entity):
                                                                        """
                                                                        Major High
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi, self).__init__()

                                                                            self.yang_name = "major-hi"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "major-hi"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "major-hi" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class CriticalLo(Entity):
                                                                        """
                                                                        Critical Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo, self).__init__()

                                                                            self.yang_name = "critical-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "critical-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "critical-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass


                                                                    class MinorLo(Entity):
                                                                        """
                                                                        Minor Low
                                                                        
                                                                        .. attribute:: thresh_bag
                                                                        
                                                                        	Environment threshold info
                                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo, self).__init__()

                                                                            self.yang_name = "minor-lo"
                                                                            self.yang_parent_name = "threshold"

                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                            self._children_yang_names.add("thresh-bag")


                                                                        class ThreshBag(Entity):
                                                                            """
                                                                            Environment threshold info
                                                                            
                                                                            .. attribute:: threshold_evaluation
                                                                            
                                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_notification_enabled
                                                                            
                                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: threshold_relation
                                                                            
                                                                            	Indicates relation between sensor value and threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_severity
                                                                            
                                                                            	Indicates minor, major, critical severities
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: threshold_value
                                                                            
                                                                            	Value of the configured threshold
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                                self.yang_name = "thresh-bag"
                                                                                self.yang_parent_name = "minor-lo"

                                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("threshold_evaluation",
                                                                                                "threshold_notification_enabled",
                                                                                                "threshold_relation",
                                                                                                "threshold_severity",
                                                                                                "threshold_value") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.threshold_evaluation.is_set or
                                                                                    self.threshold_notification_enabled.is_set or
                                                                                    self.threshold_relation.is_set or
                                                                                    self.threshold_severity.is_set or
                                                                                    self.threshold_value.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "thresh-bag" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "threshold-evaluation"):
                                                                                    self.threshold_evaluation = value
                                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-notification-enabled"):
                                                                                    self.threshold_notification_enabled = value
                                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-relation"):
                                                                                    self.threshold_relation = value
                                                                                    self.threshold_relation.value_namespace = name_space
                                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-severity"):
                                                                                    self.threshold_severity = value
                                                                                    self.threshold_severity.value_namespace = name_space
                                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "threshold-value"):
                                                                                    self.threshold_value = value
                                                                                    self.threshold_value.value_namespace = name_space
                                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "minor-lo" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "thresh-bag"):
                                                                                if (self.thresh_bag is None):
                                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo.ThreshBag()
                                                                                    self.thresh_bag.parent = self
                                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                                return self.thresh_bag

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "thresh-bag"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            pass

                                                                    def has_data(self):
                                                                        return (
                                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "critical-hi"):
                                                                            if (self.critical_hi is None):
                                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalHi()
                                                                                self.critical_hi.parent = self
                                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                            return self.critical_hi

                                                                        if (child_yang_name == "critical-lo"):
                                                                            if (self.critical_lo is None):
                                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.CriticalLo()
                                                                                self.critical_lo.parent = self
                                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                            return self.critical_lo

                                                                        if (child_yang_name == "major-hi"):
                                                                            if (self.major_hi is None):
                                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorHi()
                                                                                self.major_hi.parent = self
                                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                            return self.major_hi

                                                                        if (child_yang_name == "major-lo"):
                                                                            if (self.major_lo is None):
                                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MajorLo()
                                                                                self.major_lo.parent = self
                                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                            return self.major_lo

                                                                        if (child_yang_name == "minor-hi"):
                                                                            if (self.minor_hi is None):
                                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorHi()
                                                                                self.minor_hi.parent = self
                                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                            return self.minor_hi

                                                                        if (child_yang_name == "minor-lo"):
                                                                            if (self.minor_lo is None):
                                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold.MinorLo()
                                                                                self.minor_lo.parent = self
                                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                            return self.minor_lo

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        pass


                                                                class FruInfo(Entity):
                                                                    """
                                                                    Inventory EDM FRU info
                                                                    
                                                                    .. attribute:: card_administrative_state
                                                                    
                                                                    	card admin state\: shutdown or not
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_monitor_state
                                                                    
                                                                    	card is monitored by a manager or left unmonitored
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_operational_state
                                                                    
                                                                    	card operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: card_reset_reason
                                                                    
                                                                    	card reset reason enum
                                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                                    
                                                                    .. attribute:: card_up_time
                                                                    
                                                                    	card up time
                                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime>`
                                                                    
                                                                    .. attribute:: last_operational_state_change
                                                                    
                                                                    	last card oper change state
                                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange>`
                                                                    
                                                                    .. attribute:: power_administrative_state
                                                                    
                                                                    	power admin state\: up or down
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_current_measurement
                                                                    
                                                                    	power current\: not implemented
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: power_operational_state
                                                                    
                                                                    	Power operation state
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__init__()

                                                                        self.yang_name = "fru-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                        self._children_yang_names.add("card-up-time")

                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                        self._children_yang_names.add("last-operational-state-change")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("card_administrative_state",
                                                                                        "card_monitor_state",
                                                                                        "card_operational_state",
                                                                                        "card_reset_reason",
                                                                                        "power_administrative_state",
                                                                                        "power_current_measurement",
                                                                                        "power_operational_state") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo, self).__setattr__(name, value)


                                                                    class LastOperationalStateChange(Entity):
                                                                        """
                                                                        last card oper change state
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                            self.yang_name = "last-operational-state-change"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                                    class CardUpTime(Entity):
                                                                        """
                                                                        card up time
                                                                        
                                                                        .. attribute:: time_in_nano_seconds
                                                                        
                                                                        	Time Value in Nano\-seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: nanosecond
                                                                        
                                                                        .. attribute:: time_in_seconds
                                                                        
                                                                        	Time Value in Seconds
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** \-2147483648..2147483647
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                            self.yang_name = "card-up-time"
                                                                            self.yang_parent_name = "fru-info"

                                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("time_in_nano_seconds",
                                                                                            "time_in_seconds") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.time_in_nano_seconds.is_set or
                                                                                self.time_in_seconds.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "card-up-time" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "time-in-nano-seconds"):
                                                                                self.time_in_nano_seconds = value
                                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "time-in-seconds"):
                                                                                self.time_in_seconds = value
                                                                                self.time_in_seconds.value_namespace = name_space
                                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.card_administrative_state.is_set or
                                                                            self.card_monitor_state.is_set or
                                                                            self.card_operational_state.is_set or
                                                                            self.card_reset_reason.is_set or
                                                                            self.power_administrative_state.is_set or
                                                                            self.power_current_measurement.is_set or
                                                                            self.power_operational_state.is_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "fru-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "card-up-time"):
                                                                            if (self.card_up_time is None):
                                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.CardUpTime()
                                                                                self.card_up_time.parent = self
                                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                            return self.card_up_time

                                                                        if (child_yang_name == "last-operational-state-change"):
                                                                            if (self.last_operational_state_change is None):
                                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo.LastOperationalStateChange()
                                                                                self.last_operational_state_change.parent = self
                                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                            return self.last_operational_state_change

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "card-administrative-state"):
                                                                            self.card_administrative_state = value
                                                                            self.card_administrative_state.value_namespace = name_space
                                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-monitor-state"):
                                                                            self.card_monitor_state = value
                                                                            self.card_monitor_state.value_namespace = name_space
                                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-operational-state"):
                                                                            self.card_operational_state = value
                                                                            self.card_operational_state.value_namespace = name_space
                                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "card-reset-reason"):
                                                                            self.card_reset_reason = value
                                                                            self.card_reset_reason.value_namespace = name_space
                                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-administrative-state"):
                                                                            self.power_administrative_state = value
                                                                            self.power_administrative_state.value_namespace = name_space
                                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-current-measurement"):
                                                                            self.power_current_measurement = value
                                                                            self.power_current_measurement.value_namespace = name_space
                                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "power-operational-state"):
                                                                            self.power_operational_state = value
                                                                            self.power_operational_state.value_namespace = name_space
                                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                                class InvBasicBag(Entity):
                                                                    """
                                                                    Inventory Basic Bag
                                                                    
                                                                    .. attribute:: alias
                                                                    
                                                                    	useful for storing an entity alias 
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_id_str
                                                                    
                                                                    	asset Identification string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: asset_identification
                                                                    
                                                                    	asset Identification
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: ceport
                                                                    
                                                                    	1 if ce port found, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: chip_hardware_revision
                                                                    
                                                                    	chip module hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: composite_class_code
                                                                    
                                                                    	Major&minor class of the entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	describes in user\-readable terms       what the entity in question does
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: environmental_monitor_path
                                                                    
                                                                    	sysdb name of sensor in the envmon EDM
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: firmware_revision
                                                                    
                                                                    	firmware revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: group_flag
                                                                    
                                                                    	indicates if this entity is group       or not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: hardware_revision
                                                                    
                                                                    	hw revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: is_field_replaceable_unit
                                                                    
                                                                    	1 if Field Replaceable Unit 0, if not
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: manufacturer_asset_tags
                                                                    
                                                                    	Manufacture Asset Tags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: manufacturer_name
                                                                    
                                                                    	manufacturer's name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: memory_size
                                                                    
                                                                    	Size of memory associated with       the entity where applicable
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: model_name
                                                                    
                                                                    	model name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name string for the entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: new_deviation_number
                                                                    
                                                                    	integer value for New Deviation Number 0x88
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: physical_layer_interface_module_type
                                                                    
                                                                    	integer value for plim type if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: redundancystate
                                                                    
                                                                    	integer value for Redundancy State if     applicable to this entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: serial_number
                                                                    
                                                                    	serial number
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: software_revision
                                                                    
                                                                    	software revision string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: unique_id
                                                                    
                                                                    	Unique id for an entity
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    .. attribute:: unrecognized_fru
                                                                    
                                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: vendor_type
                                                                    
                                                                    	maps to the vendor OID string
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: xr_scoped
                                                                    
                                                                    	1 if xr scoped, 0 if not
                                                                    	**type**\:  bool
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__init__()

                                                                        self.yang_name = "inv-basic-bag"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.alias = YLeaf(YType.str, "alias")

                                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("alias",
                                                                                        "asset_id_str",
                                                                                        "asset_identification",
                                                                                        "ceport",
                                                                                        "chip_hardware_revision",
                                                                                        "composite_class_code",
                                                                                        "description",
                                                                                        "environmental_monitor_path",
                                                                                        "firmware_revision",
                                                                                        "group_flag",
                                                                                        "hardware_revision",
                                                                                        "is_field_replaceable_unit",
                                                                                        "manufacturer_asset_tags",
                                                                                        "manufacturer_name",
                                                                                        "memory_size",
                                                                                        "model_name",
                                                                                        "name",
                                                                                        "new_deviation_number",
                                                                                        "physical_layer_interface_module_type",
                                                                                        "redundancystate",
                                                                                        "serial_number",
                                                                                        "software_revision",
                                                                                        "unique_id",
                                                                                        "unrecognized_fru",
                                                                                        "vendor_type",
                                                                                        "xr_scoped") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.alias.is_set or
                                                                            self.asset_id_str.is_set or
                                                                            self.asset_identification.is_set or
                                                                            self.ceport.is_set or
                                                                            self.chip_hardware_revision.is_set or
                                                                            self.composite_class_code.is_set or
                                                                            self.description.is_set or
                                                                            self.environmental_monitor_path.is_set or
                                                                            self.firmware_revision.is_set or
                                                                            self.group_flag.is_set or
                                                                            self.hardware_revision.is_set or
                                                                            self.is_field_replaceable_unit.is_set or
                                                                            self.manufacturer_asset_tags.is_set or
                                                                            self.manufacturer_name.is_set or
                                                                            self.memory_size.is_set or
                                                                            self.model_name.is_set or
                                                                            self.name.is_set or
                                                                            self.new_deviation_number.is_set or
                                                                            self.physical_layer_interface_module_type.is_set or
                                                                            self.redundancystate.is_set or
                                                                            self.serial_number.is_set or
                                                                            self.software_revision.is_set or
                                                                            self.unique_id.is_set or
                                                                            self.unrecognized_fru.is_set or
                                                                            self.vendor_type.is_set or
                                                                            self.xr_scoped.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.alias.yfilter != YFilter.not_set or
                                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                                            self.ceport.yfilter != YFilter.not_set or
                                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                                            self.group_flag.yfilter != YFilter.not_set or
                                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                                            self.memory_size.yfilter != YFilter.not_set or
                                                                            self.model_name.yfilter != YFilter.not_set or
                                                                            self.name.yfilter != YFilter.not_set or
                                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                                            self.serial_number.yfilter != YFilter.not_set or
                                                                            self.software_revision.yfilter != YFilter.not_set or
                                                                            self.unique_id.yfilter != YFilter.not_set or
                                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "alias"):
                                                                            self.alias = value
                                                                            self.alias.value_namespace = name_space
                                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-id-str"):
                                                                            self.asset_id_str = value
                                                                            self.asset_id_str.value_namespace = name_space
                                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "asset-identification"):
                                                                            self.asset_identification = value
                                                                            self.asset_identification.value_namespace = name_space
                                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "ceport"):
                                                                            self.ceport = value
                                                                            self.ceport.value_namespace = name_space
                                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "chip-hardware-revision"):
                                                                            self.chip_hardware_revision = value
                                                                            self.chip_hardware_revision.value_namespace = name_space
                                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "composite-class-code"):
                                                                            self.composite_class_code = value
                                                                            self.composite_class_code.value_namespace = name_space
                                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "environmental-monitor-path"):
                                                                            self.environmental_monitor_path = value
                                                                            self.environmental_monitor_path.value_namespace = name_space
                                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "firmware-revision"):
                                                                            self.firmware_revision = value
                                                                            self.firmware_revision.value_namespace = name_space
                                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "group-flag"):
                                                                            self.group_flag = value
                                                                            self.group_flag.value_namespace = name_space
                                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "hardware-revision"):
                                                                            self.hardware_revision = value
                                                                            self.hardware_revision.value_namespace = name_space
                                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "is-field-replaceable-unit"):
                                                                            self.is_field_replaceable_unit = value
                                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-asset-tags"):
                                                                            self.manufacturer_asset_tags = value
                                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "manufacturer-name"):
                                                                            self.manufacturer_name = value
                                                                            self.manufacturer_name.value_namespace = name_space
                                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "memory-size"):
                                                                            self.memory_size = value
                                                                            self.memory_size.value_namespace = name_space
                                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "model-name"):
                                                                            self.model_name = value
                                                                            self.model_name.value_namespace = name_space
                                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "name"):
                                                                            self.name = value
                                                                            self.name.value_namespace = name_space
                                                                            self.name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "new-deviation-number"):
                                                                            self.new_deviation_number = value
                                                                            self.new_deviation_number.value_namespace = name_space
                                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "physical-layer-interface-module-type"):
                                                                            self.physical_layer_interface_module_type = value
                                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "redundancystate"):
                                                                            self.redundancystate = value
                                                                            self.redundancystate.value_namespace = name_space
                                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "serial-number"):
                                                                            self.serial_number = value
                                                                            self.serial_number.value_namespace = name_space
                                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "software-revision"):
                                                                            self.software_revision = value
                                                                            self.software_revision.value_namespace = name_space
                                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unique-id"):
                                                                            self.unique_id = value
                                                                            self.unique_id.value_namespace = name_space
                                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "unrecognized-fru"):
                                                                            self.unrecognized_fru = value
                                                                            self.unrecognized_fru.value_namespace = name_space
                                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "vendor-type"):
                                                                            self.vendor_type = value
                                                                            self.vendor_type.value_namespace = name_space
                                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "xr-scoped"):
                                                                            self.xr_scoped = value
                                                                            self.xr_scoped.value_namespace = name_space
                                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                                class InvEepromInfo(Entity):
                                                                    """
                                                                    Inventory EDM EEPROM Information Bag
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	A textual description of physical entity
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: eeprom
                                                                    
                                                                    	EEPROM data not from hex data
                                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom>`
                                                                    
                                                                    .. attribute:: has_eeprom
                                                                    
                                                                    	use eeprom instead of opaque data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: inv_card_type
                                                                    
                                                                    	Inventory card type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: opaque_data
                                                                    
                                                                    	EEPROM hex data
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    .. attribute:: opaque_data_size
                                                                    
                                                                    	size of the EEPROM hex data
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__init__()

                                                                        self.yang_name = "inv-eeprom-info"
                                                                        self.yang_parent_name = "attributes"

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                        self._children_yang_names.add("eeprom")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("description",
                                                                                        "has_eeprom",
                                                                                        "inv_card_type",
                                                                                        "opaque_data",
                                                                                        "opaque_data_size") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                                    class Eeprom(Entity):
                                                                        """
                                                                        EEPROM data not from hex data
                                                                        
                                                                        .. attribute:: asset_alias
                                                                        
                                                                        	Asset Alias
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: asset_id
                                                                        
                                                                        	Asset ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address1
                                                                        
                                                                        	Base Mac Address #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address2
                                                                        
                                                                        	Base Mac Address #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address3
                                                                        
                                                                        	Base Mac Address #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: base_mac_address4
                                                                        
                                                                        	Base Mac Address #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_checksum
                                                                        
                                                                        	Block Checksum
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_count
                                                                        
                                                                        	Block Count
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_length
                                                                        
                                                                        	Block Length
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_signature
                                                                        
                                                                        	Block Signature
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: block_version
                                                                        
                                                                        	Block Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: chassis_sid
                                                                        
                                                                        	Chassis serial number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: clei
                                                                        
                                                                        	Common Language Equipment Identifier (CLEI) code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_family
                                                                        
                                                                        	Controller family
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: controller_type
                                                                        
                                                                        	Controller type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	A textual description of physical entity
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num1
                                                                        
                                                                        	Deviation Number # 1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num2
                                                                        
                                                                        	Deviation Number # 2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num3
                                                                        
                                                                        	Deviation Number # 3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num4
                                                                        
                                                                        	Deviation Number # 4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num5
                                                                        
                                                                        	Deviation Number # 5
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num6
                                                                        
                                                                        	Deviation Number # 6
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: dev_num7
                                                                        
                                                                        	Deviation Number # 7
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eci
                                                                        
                                                                        	Equipment Catalog Item (ECI) number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: eeprom_size
                                                                        
                                                                        	EEPROM Size
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: engineer_use
                                                                        
                                                                        	Engineer Use
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_major_type
                                                                        
                                                                        	FRU Major Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: fru_minor_type
                                                                        
                                                                        	FRU Minor Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hw_version
                                                                        
                                                                        	Hardware Version
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: hwid
                                                                        
                                                                        	Hardware Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: idprom_format_rev
                                                                        
                                                                        	IDPROM Format Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size1
                                                                        
                                                                        	Mac Address Block Size #1
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size2
                                                                        
                                                                        	Mac Address Block Size #2
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size3
                                                                        
                                                                        	Mac Address Block Size #3
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mac_add_blk_size4
                                                                        
                                                                        	Mac Address Block Size #4
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: manu_test_data
                                                                        
                                                                        	Manufacturing Test Data
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_bits
                                                                        
                                                                        	MFG Bits
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: mfg_deviation
                                                                        
                                                                        	MFG Deviation
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: oem_string
                                                                        
                                                                        	OEM String
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_number
                                                                        
                                                                        	Part Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: part_revision
                                                                        
                                                                        	Part Revision
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pca_num
                                                                        
                                                                        	PCA number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcavid
                                                                        
                                                                        	PCA revision ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pcb_serial_num
                                                                        
                                                                        	PCB Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: pid
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_consumption
                                                                        
                                                                        	Power Consumption
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: power_supply_type
                                                                        
                                                                        	Power Supply Type
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: product_id
                                                                        
                                                                        	Product ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: rma
                                                                        
                                                                        	RMA Data
                                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                        
                                                                        .. attribute:: rma_code
                                                                        
                                                                        	RMA Code
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: serial_number
                                                                        
                                                                        	Serial Number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: snmpoid
                                                                        
                                                                        	SNMP OID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_part_num
                                                                        
                                                                        	Top assembly part number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: top_assem_vid
                                                                        
                                                                        	Top assembly revision number
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_description
                                                                        
                                                                        	UDI description
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: udi_name
                                                                        
                                                                        	UDI name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        .. attribute:: vid
                                                                        
                                                                        	Version ID
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'invmgr-oper'
                                                                        _revision = '2015-11-09'

                                                                        def __init__(self):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                            self.yang_name = "eeprom"
                                                                            self.yang_parent_name = "inv-eeprom-info"

                                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                            self.clei = YLeaf(YType.str, "clei")

                                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                            self.eci = YLeaf(YType.str, "eci")

                                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                            self.pid = YLeaf(YType.str, "pid")

                                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                                            self.vid = YLeaf(YType.str, "vid")

                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                            self._children_yang_names.add("rma")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("asset_alias",
                                                                                            "asset_id",
                                                                                            "base_mac_address1",
                                                                                            "base_mac_address2",
                                                                                            "base_mac_address3",
                                                                                            "base_mac_address4",
                                                                                            "block_checksum",
                                                                                            "block_count",
                                                                                            "block_length",
                                                                                            "block_signature",
                                                                                            "block_version",
                                                                                            "chassis_sid",
                                                                                            "clei",
                                                                                            "controller_family",
                                                                                            "controller_type",
                                                                                            "description",
                                                                                            "dev_num1",
                                                                                            "dev_num2",
                                                                                            "dev_num3",
                                                                                            "dev_num4",
                                                                                            "dev_num5",
                                                                                            "dev_num6",
                                                                                            "dev_num7",
                                                                                            "eci",
                                                                                            "eeprom_size",
                                                                                            "engineer_use",
                                                                                            "fru_major_type",
                                                                                            "fru_minor_type",
                                                                                            "hw_version",
                                                                                            "hwid",
                                                                                            "idprom_format_rev",
                                                                                            "mac_add_blk_size1",
                                                                                            "mac_add_blk_size2",
                                                                                            "mac_add_blk_size3",
                                                                                            "mac_add_blk_size4",
                                                                                            "manu_test_data",
                                                                                            "mfg_bits",
                                                                                            "mfg_deviation",
                                                                                            "oem_string",
                                                                                            "part_number",
                                                                                            "part_revision",
                                                                                            "pca_num",
                                                                                            "pcavid",
                                                                                            "pcb_serial_num",
                                                                                            "pid",
                                                                                            "power_consumption",
                                                                                            "power_supply_type",
                                                                                            "product_id",
                                                                                            "rma_code",
                                                                                            "serial_number",
                                                                                            "snmpoid",
                                                                                            "top_assem_part_num",
                                                                                            "top_assem_vid",
                                                                                            "udi_description",
                                                                                            "udi_name",
                                                                                            "vid") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                        class Rma(Entity):
                                                                            """
                                                                            RMA Data
                                                                            
                                                                            .. attribute:: rma_history
                                                                            
                                                                            	RMA history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: rma_number
                                                                            
                                                                            	RMA tracking number format is N\-N\-N
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            .. attribute:: test_history
                                                                            
                                                                            	Test history
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'invmgr-oper'
                                                                            _revision = '2015-11-09'

                                                                            def __init__(self):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                                self.yang_name = "rma"
                                                                                self.yang_parent_name = "eeprom"

                                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                                            def __setattr__(self, name, value):
                                                                                self._check_monkey_patching_error(name, value)
                                                                                with _handle_type_error():
                                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                            "Please use list append or extend method."
                                                                                                            .format(value))
                                                                                    if isinstance(value, Enum.YLeaf):
                                                                                        value = value.name
                                                                                    if name in ("rma_history",
                                                                                                "rma_number",
                                                                                                "test_history") and name in self.__dict__:
                                                                                        if isinstance(value, YLeaf):
                                                                                            self.__dict__[name].set(value.get())
                                                                                        elif isinstance(value, YLeafList):
                                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                        else:
                                                                                            self.__dict__[name].set(value)
                                                                                    else:
                                                                                        if hasattr(value, "parent") and name != "parent":
                                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                                value.parent = self
                                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                                value.parent = self
                                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                            def has_data(self):
                                                                                return (
                                                                                    self.rma_history.is_set or
                                                                                    self.rma_number.is_set or
                                                                                    self.test_history.is_set)

                                                                            def has_operation(self):
                                                                                return (
                                                                                    self.yfilter != YFilter.not_set or
                                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                                    self.test_history.yfilter != YFilter.not_set)

                                                                            def get_segment_path(self):
                                                                                path_buffer = ""
                                                                                path_buffer = "rma" + path_buffer

                                                                                return path_buffer

                                                                            def get_entity_path(self, ancestor):
                                                                                path_buffer = ""
                                                                                if (ancestor is None):
                                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                                else:
                                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                                leaf_name_data = LeafDataList()
                                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                                return entity_path

                                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                                if child is not None:
                                                                                    return child

                                                                                return None

                                                                            def has_leaf_or_child_of_name(self, name):
                                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                                    return True
                                                                                return False

                                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                                if(value_path == "rma-history"):
                                                                                    self.rma_history = value
                                                                                    self.rma_history.value_namespace = name_space
                                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "rma-number"):
                                                                                    self.rma_number = value
                                                                                    self.rma_number.value_namespace = name_space
                                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                                if(value_path == "test-history"):
                                                                                    self.test_history = value
                                                                                    self.test_history.value_namespace = name_space
                                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                                        def has_data(self):
                                                                            return (
                                                                                self.asset_alias.is_set or
                                                                                self.asset_id.is_set or
                                                                                self.base_mac_address1.is_set or
                                                                                self.base_mac_address2.is_set or
                                                                                self.base_mac_address3.is_set or
                                                                                self.base_mac_address4.is_set or
                                                                                self.block_checksum.is_set or
                                                                                self.block_count.is_set or
                                                                                self.block_length.is_set or
                                                                                self.block_signature.is_set or
                                                                                self.block_version.is_set or
                                                                                self.chassis_sid.is_set or
                                                                                self.clei.is_set or
                                                                                self.controller_family.is_set or
                                                                                self.controller_type.is_set or
                                                                                self.description.is_set or
                                                                                self.dev_num1.is_set or
                                                                                self.dev_num2.is_set or
                                                                                self.dev_num3.is_set or
                                                                                self.dev_num4.is_set or
                                                                                self.dev_num5.is_set or
                                                                                self.dev_num6.is_set or
                                                                                self.dev_num7.is_set or
                                                                                self.eci.is_set or
                                                                                self.eeprom_size.is_set or
                                                                                self.engineer_use.is_set or
                                                                                self.fru_major_type.is_set or
                                                                                self.fru_minor_type.is_set or
                                                                                self.hw_version.is_set or
                                                                                self.hwid.is_set or
                                                                                self.idprom_format_rev.is_set or
                                                                                self.mac_add_blk_size1.is_set or
                                                                                self.mac_add_blk_size2.is_set or
                                                                                self.mac_add_blk_size3.is_set or
                                                                                self.mac_add_blk_size4.is_set or
                                                                                self.manu_test_data.is_set or
                                                                                self.mfg_bits.is_set or
                                                                                self.mfg_deviation.is_set or
                                                                                self.oem_string.is_set or
                                                                                self.part_number.is_set or
                                                                                self.part_revision.is_set or
                                                                                self.pca_num.is_set or
                                                                                self.pcavid.is_set or
                                                                                self.pcb_serial_num.is_set or
                                                                                self.pid.is_set or
                                                                                self.power_consumption.is_set or
                                                                                self.power_supply_type.is_set or
                                                                                self.product_id.is_set or
                                                                                self.rma_code.is_set or
                                                                                self.serial_number.is_set or
                                                                                self.snmpoid.is_set or
                                                                                self.top_assem_part_num.is_set or
                                                                                self.top_assem_vid.is_set or
                                                                                self.udi_description.is_set or
                                                                                self.udi_name.is_set or
                                                                                self.vid.is_set or
                                                                                (self.rma is not None and self.rma.has_data()))

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                                self.block_count.yfilter != YFilter.not_set or
                                                                                self.block_length.yfilter != YFilter.not_set or
                                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                                self.block_version.yfilter != YFilter.not_set or
                                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                                self.clei.yfilter != YFilter.not_set or
                                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                                self.description.yfilter != YFilter.not_set or
                                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                                self.eci.yfilter != YFilter.not_set or
                                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                                self.hwid.yfilter != YFilter.not_set or
                                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                                self.part_number.yfilter != YFilter.not_set or
                                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                                self.pid.yfilter != YFilter.not_set or
                                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                                self.product_id.yfilter != YFilter.not_set or
                                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                                self.vid.yfilter != YFilter.not_set or
                                                                                (self.rma is not None and self.rma.has_operation()))

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "eeprom" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            if (child_yang_name == "rma"):
                                                                                if (self.rma is None):
                                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                                    self.rma.parent = self
                                                                                    self._children_name_map["rma"] = "rma"
                                                                                return self.rma

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "asset-alias"):
                                                                                self.asset_alias = value
                                                                                self.asset_alias.value_namespace = name_space
                                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "asset-id"):
                                                                                self.asset_id = value
                                                                                self.asset_id.value_namespace = name_space
                                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address1"):
                                                                                self.base_mac_address1 = value
                                                                                self.base_mac_address1.value_namespace = name_space
                                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address2"):
                                                                                self.base_mac_address2 = value
                                                                                self.base_mac_address2.value_namespace = name_space
                                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address3"):
                                                                                self.base_mac_address3 = value
                                                                                self.base_mac_address3.value_namespace = name_space
                                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "base-mac-address4"):
                                                                                self.base_mac_address4 = value
                                                                                self.base_mac_address4.value_namespace = name_space
                                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-checksum"):
                                                                                self.block_checksum = value
                                                                                self.block_checksum.value_namespace = name_space
                                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-count"):
                                                                                self.block_count = value
                                                                                self.block_count.value_namespace = name_space
                                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-length"):
                                                                                self.block_length = value
                                                                                self.block_length.value_namespace = name_space
                                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-signature"):
                                                                                self.block_signature = value
                                                                                self.block_signature.value_namespace = name_space
                                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "block-version"):
                                                                                self.block_version = value
                                                                                self.block_version.value_namespace = name_space
                                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "chassis-sid"):
                                                                                self.chassis_sid = value
                                                                                self.chassis_sid.value_namespace = name_space
                                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "clei"):
                                                                                self.clei = value
                                                                                self.clei.value_namespace = name_space
                                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-family"):
                                                                                self.controller_family = value
                                                                                self.controller_family.value_namespace = name_space
                                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "controller-type"):
                                                                                self.controller_type = value
                                                                                self.controller_type.value_namespace = name_space
                                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "description"):
                                                                                self.description = value
                                                                                self.description.value_namespace = name_space
                                                                                self.description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num1"):
                                                                                self.dev_num1 = value
                                                                                self.dev_num1.value_namespace = name_space
                                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num2"):
                                                                                self.dev_num2 = value
                                                                                self.dev_num2.value_namespace = name_space
                                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num3"):
                                                                                self.dev_num3 = value
                                                                                self.dev_num3.value_namespace = name_space
                                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num4"):
                                                                                self.dev_num4 = value
                                                                                self.dev_num4.value_namespace = name_space
                                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num5"):
                                                                                self.dev_num5 = value
                                                                                self.dev_num5.value_namespace = name_space
                                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num6"):
                                                                                self.dev_num6 = value
                                                                                self.dev_num6.value_namespace = name_space
                                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "dev-num7"):
                                                                                self.dev_num7 = value
                                                                                self.dev_num7.value_namespace = name_space
                                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eci"):
                                                                                self.eci = value
                                                                                self.eci.value_namespace = name_space
                                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "eeprom-size"):
                                                                                self.eeprom_size = value
                                                                                self.eeprom_size.value_namespace = name_space
                                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "engineer-use"):
                                                                                self.engineer_use = value
                                                                                self.engineer_use.value_namespace = name_space
                                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-major-type"):
                                                                                self.fru_major_type = value
                                                                                self.fru_major_type.value_namespace = name_space
                                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "fru-minor-type"):
                                                                                self.fru_minor_type = value
                                                                                self.fru_minor_type.value_namespace = name_space
                                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hw-version"):
                                                                                self.hw_version = value
                                                                                self.hw_version.value_namespace = name_space
                                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "hwid"):
                                                                                self.hwid = value
                                                                                self.hwid.value_namespace = name_space
                                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "idprom-format-rev"):
                                                                                self.idprom_format_rev = value
                                                                                self.idprom_format_rev.value_namespace = name_space
                                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size1"):
                                                                                self.mac_add_blk_size1 = value
                                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size2"):
                                                                                self.mac_add_blk_size2 = value
                                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size3"):
                                                                                self.mac_add_blk_size3 = value
                                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mac-add-blk-size4"):
                                                                                self.mac_add_blk_size4 = value
                                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "manu-test-data"):
                                                                                self.manu_test_data = value
                                                                                self.manu_test_data.value_namespace = name_space
                                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-bits"):
                                                                                self.mfg_bits = value
                                                                                self.mfg_bits.value_namespace = name_space
                                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "mfg-deviation"):
                                                                                self.mfg_deviation = value
                                                                                self.mfg_deviation.value_namespace = name_space
                                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "oem-string"):
                                                                                self.oem_string = value
                                                                                self.oem_string.value_namespace = name_space
                                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-number"):
                                                                                self.part_number = value
                                                                                self.part_number.value_namespace = name_space
                                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "part-revision"):
                                                                                self.part_revision = value
                                                                                self.part_revision.value_namespace = name_space
                                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pca-num"):
                                                                                self.pca_num = value
                                                                                self.pca_num.value_namespace = name_space
                                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcavid"):
                                                                                self.pcavid = value
                                                                                self.pcavid.value_namespace = name_space
                                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pcb-serial-num"):
                                                                                self.pcb_serial_num = value
                                                                                self.pcb_serial_num.value_namespace = name_space
                                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "pid"):
                                                                                self.pid = value
                                                                                self.pid.value_namespace = name_space
                                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-consumption"):
                                                                                self.power_consumption = value
                                                                                self.power_consumption.value_namespace = name_space
                                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "power-supply-type"):
                                                                                self.power_supply_type = value
                                                                                self.power_supply_type.value_namespace = name_space
                                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "product-id"):
                                                                                self.product_id = value
                                                                                self.product_id.value_namespace = name_space
                                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "rma-code"):
                                                                                self.rma_code = value
                                                                                self.rma_code.value_namespace = name_space
                                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "serial-number"):
                                                                                self.serial_number = value
                                                                                self.serial_number.value_namespace = name_space
                                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "snmpoid"):
                                                                                self.snmpoid = value
                                                                                self.snmpoid.value_namespace = name_space
                                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-part-num"):
                                                                                self.top_assem_part_num = value
                                                                                self.top_assem_part_num.value_namespace = name_space
                                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "top-assem-vid"):
                                                                                self.top_assem_vid = value
                                                                                self.top_assem_vid.value_namespace = name_space
                                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-description"):
                                                                                self.udi_description = value
                                                                                self.udi_description.value_namespace = name_space
                                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "udi-name"):
                                                                                self.udi_name = value
                                                                                self.udi_name.value_namespace = name_space
                                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "vid"):
                                                                                self.vid = value
                                                                                self.vid.value_namespace = name_space
                                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.description.is_set or
                                                                            self.has_eeprom.is_set or
                                                                            self.inv_card_type.is_set or
                                                                            self.opaque_data.is_set or
                                                                            self.opaque_data_size.is_set or
                                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.description.yfilter != YFilter.not_set or
                                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "eeprom"):
                                                                            if (self.eeprom is None):
                                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo.Eeprom()
                                                                                self.eeprom.parent = self
                                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                            return self.eeprom

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "description"):
                                                                            self.description = value
                                                                            self.description.value_namespace = name_space
                                                                            self.description.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "has-eeprom"):
                                                                            self.has_eeprom = value
                                                                            self.has_eeprom.value_namespace = name_space
                                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "inv-card-type"):
                                                                            self.inv_card_type = value
                                                                            self.inv_card_type.value_namespace = name_space
                                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data"):
                                                                            self.opaque_data = value
                                                                            self.opaque_data.value_namespace = name_space
                                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "opaque-data-size"):
                                                                            self.opaque_data_size = value
                                                                            self.opaque_data_size.value_namespace = name_space
                                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.module_done.is_set or
                                                                        self.node_id.is_set or
                                                                        self.vm_done.is_set or
                                                                        self.vm_node_id.is_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                        (self.threshold is not None and self.threshold.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.module_done.yfilter != YFilter.not_set or
                                                                        self.node_id.yfilter != YFilter.not_set or
                                                                        self.vm_done.yfilter != YFilter.not_set or
                                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "attributes" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "env-sensor-info"):
                                                                        if (self.env_sensor_info is None):
                                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfo()
                                                                            self.env_sensor_info.parent = self
                                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                        return self.env_sensor_info

                                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                                        if (self.env_sensor_info_xml is None):
                                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.EnvSensorInfoXml()
                                                                            self.env_sensor_info_xml.parent = self
                                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                        return self.env_sensor_info_xml

                                                                    if (child_yang_name == "fru-info"):
                                                                        if (self.fru_info is None):
                                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.FruInfo()
                                                                            self.fru_info.parent = self
                                                                            self._children_name_map["fru_info"] = "fru-info"
                                                                        return self.fru_info

                                                                    if (child_yang_name == "inv-asset-bag"):
                                                                        if (self.inv_asset_bag is None):
                                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvAssetBag()
                                                                            self.inv_asset_bag.parent = self
                                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                        return self.inv_asset_bag

                                                                    if (child_yang_name == "inv-basic-bag"):
                                                                        if (self.inv_basic_bag is None):
                                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvBasicBag()
                                                                            self.inv_basic_bag.parent = self
                                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                        return self.inv_basic_bag

                                                                    if (child_yang_name == "inv-eeprom-info"):
                                                                        if (self.inv_eeprom_info is None):
                                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.InvEepromInfo()
                                                                            self.inv_eeprom_info.parent = self
                                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                        return self.inv_eeprom_info

                                                                    if (child_yang_name == "pwg-info"):
                                                                        if (self.pwg_info is None):
                                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.PwgInfo()
                                                                            self.pwg_info.parent = self
                                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                                        return self.pwg_info

                                                                    if (child_yang_name == "threshold"):
                                                                        if (self.threshold is None):
                                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes.Threshold()
                                                                            self.threshold.parent = self
                                                                            self._children_name_map["threshold"] = "threshold"
                                                                        return self.threshold

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "module-done"):
                                                                        self.module_done = value
                                                                        self.module_done.value_namespace = name_space
                                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "node-id"):
                                                                        self.node_id = value
                                                                        self.node_id.value_namespace = name_space
                                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-done"):
                                                                        self.vm_done = value
                                                                        self.vm_done.value_namespace = name_space
                                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vm-node-id"):
                                                                        self.vm_node_id = value
                                                                        self.vm_node_id.value_namespace = name_space
                                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.name.is_set or
                                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                                    (self.tsi6s is not None and self.tsi6s.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "tsi5" + "[name='" + self.name.get() + "']" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "attributes"):
                                                                    if (self.attributes is None):
                                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Attributes()
                                                                        self.attributes.parent = self
                                                                        self._children_name_map["attributes"] = "attributes"
                                                                    return self.attributes

                                                                if (child_yang_name == "tsi6s"):
                                                                    if (self.tsi6s is None):
                                                                        self.tsi6s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5.Tsi6S()
                                                                        self.tsi6s.parent = self
                                                                        self._children_name_map["tsi6s"] = "tsi6s"
                                                                    return self.tsi6s

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "attributes" or name == "tsi6s" or name == "name"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.tsi5:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.tsi5:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "tsi5s" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "tsi5"):
                                                                for c in self.tsi5:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S.Tsi5()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.tsi5.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "tsi5"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class Attributes(Entity):
                                                        """
                                                        Attributes
                                                        
                                                        .. attribute:: env_sensor_info
                                                        
                                                        	Environment sensor info
                                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo>`
                                                        
                                                        .. attribute:: env_sensor_info_xml
                                                        
                                                        	Environment sensor info XML
                                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml>`
                                                        
                                                        .. attribute:: fru_info
                                                        
                                                        	Inventory EDM FRU info
                                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo>`
                                                        
                                                        .. attribute:: inv_asset_bag
                                                        
                                                        	Inventory Asset Bag
                                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag>`
                                                        
                                                        .. attribute:: inv_basic_bag
                                                        
                                                        	Inventory Basic Bag
                                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag>`
                                                        
                                                        .. attribute:: inv_eeprom_info
                                                        
                                                        	Inventory EDM EEPROM Information Bag
                                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo>`
                                                        
                                                        .. attribute:: module_done
                                                        
                                                        	Inventory EDM Module Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**default value**\: 1
                                                        
                                                        .. attribute:: node_id
                                                        
                                                        	Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: pwg_info
                                                        
                                                        	Inventory EDM PWG info
                                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo>`
                                                        
                                                        .. attribute:: threshold
                                                        
                                                        	Threshold
                                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold>`
                                                        
                                                        .. attribute:: vm_done
                                                        
                                                        	VM Done Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        .. attribute:: vm_node_id
                                                        
                                                        	VM Node ID Tuple
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__init__()

                                                            self.yang_name = "attributes"
                                                            self.yang_parent_name = "tsi4"

                                                            self.module_done = YLeaf(YType.int32, "module-done")

                                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                            self._children_yang_names.add("env-sensor-info")

                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                            self._children_yang_names.add("env-sensor-info-xml")

                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                            self._children_yang_names.add("fru-info")

                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                            self._children_yang_names.add("inv-asset-bag")

                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                            self._children_yang_names.add("inv-basic-bag")

                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                            self._children_yang_names.add("inv-eeprom-info")

                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                            self._children_yang_names.add("pwg-info")

                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                            self._children_yang_names.add("threshold")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("module_done",
                                                                            "node_id",
                                                                            "vm_done",
                                                                            "vm_node_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes, self).__setattr__(name, value)


                                                        class EnvSensorInfo(Entity):
                                                            """
                                                            Environment sensor info
                                                            
                                                            .. attribute:: age_time_stamp
                                                            
                                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: alarm_type
                                                            
                                                            	Indicates threshold violation
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: device_description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: device_id
                                                            
                                                            	Identifier for this device
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: field_validity_bitmap
                                                            
                                                            	Sensor valid bitmap
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: precision
                                                            
                                                            	Sensor precision range
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: scale
                                                            
                                                            	Sensor scale enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state enums
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__init__()

                                                                self.yang_name = "env-sensor-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                                self.device_description = YLeaf(YType.str, "device-description")

                                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                                self.precision = YLeaf(YType.uint32, "precision")

                                                                self.scale = YLeaf(YType.uint32, "scale")

                                                                self.status = YLeaf(YType.uint32, "status")

                                                                self.units = YLeaf(YType.str, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("age_time_stamp",
                                                                                "alarm_type",
                                                                                "data_type",
                                                                                "device_description",
                                                                                "device_id",
                                                                                "field_validity_bitmap",
                                                                                "precision",
                                                                                "scale",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.age_time_stamp.is_set or
                                                                    self.alarm_type.is_set or
                                                                    self.data_type.is_set or
                                                                    self.device_description.is_set or
                                                                    self.device_id.is_set or
                                                                    self.field_validity_bitmap.is_set or
                                                                    self.precision.is_set or
                                                                    self.scale.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.device_description.yfilter != YFilter.not_set or
                                                                    self.device_id.yfilter != YFilter.not_set or
                                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                                    self.precision.yfilter != YFilter.not_set or
                                                                    self.scale.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "age-time-stamp"):
                                                                    self.age_time_stamp = value
                                                                    self.age_time_stamp.value_namespace = name_space
                                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "alarm-type"):
                                                                    self.alarm_type = value
                                                                    self.alarm_type.value_namespace = name_space
                                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-description"):
                                                                    self.device_description = value
                                                                    self.device_description.value_namespace = name_space
                                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "device-id"):
                                                                    self.device_id = value
                                                                    self.device_id.value_namespace = name_space
                                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "field-validity-bitmap"):
                                                                    self.field_validity_bitmap = value
                                                                    self.field_validity_bitmap.value_namespace = name_space
                                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "precision"):
                                                                    self.precision = value
                                                                    self.precision.value_namespace = name_space
                                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "scale"):
                                                                    self.scale = value
                                                                    self.scale.value_namespace = name_space
                                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class PwgInfo(Entity):
                                                            """
                                                            Inventory EDM PWG info
                                                            
                                                            .. attribute:: power_group_available_current
                                                            
                                                            	available current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_drawn_current
                                                            
                                                            	drawn current
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_group_power_units
                                                            
                                                            	power units
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: power_group_redundancy_mode
                                                            
                                                            	redundancy mode
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__init__()

                                                                self.yang_name = "pwg-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("power_group_available_current",
                                                                                "power_group_drawn_current",
                                                                                "power_group_power_units",
                                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.power_group_available_current.is_set or
                                                                    self.power_group_drawn_current.is_set or
                                                                    self.power_group_power_units.is_set or
                                                                    self.power_group_redundancy_mode.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "pwg-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "power-group-available-current"):
                                                                    self.power_group_available_current = value
                                                                    self.power_group_available_current.value_namespace = name_space
                                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-drawn-current"):
                                                                    self.power_group_drawn_current = value
                                                                    self.power_group_drawn_current.value_namespace = name_space
                                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-power-units"):
                                                                    self.power_group_power_units = value
                                                                    self.power_group_power_units.value_namespace = name_space
                                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-group-redundancy-mode"):
                                                                    self.power_group_redundancy_mode = value
                                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                        class EnvSensorInfoXml(Entity):
                                                            """
                                                            Environment sensor info XML
                                                            
                                                            .. attribute:: data_type
                                                            
                                                            	Sensor data type
                                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                            
                                                            .. attribute:: description
                                                            
                                                            	Device Name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: status
                                                            
                                                            	Sensor operation state
                                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                            
                                                            .. attribute:: threshold
                                                            
                                                            	Threshold information
                                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold>`
                                                            
                                                            .. attribute:: units
                                                            
                                                            	Units of variable being read
                                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                            
                                                            .. attribute:: update_rate
                                                            
                                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__init__()

                                                                self.yang_name = "env-sensor-info-xml"
                                                                self.yang_parent_name = "attributes"

                                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.status = YLeaf(YType.enumeration, "status")

                                                                self.units = YLeaf(YType.enumeration, "units")

                                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                                self.value = YLeaf(YType.str, "value")

                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                                self._children_yang_names.add("threshold")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("data_type",
                                                                                "description",
                                                                                "status",
                                                                                "units",
                                                                                "update_rate",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                            class Threshold(Entity):
                                                                """
                                                                Threshold information
                                                                
                                                                .. attribute:: threshold_array
                                                                
                                                                	Array of threshold
                                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                                    self.yang_name = "threshold"
                                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                                    self.threshold_array = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in () and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                                class ThresholdArray(Entity):
                                                                    """
                                                                    Array of threshold
                                                                    
                                                                    .. attribute:: threshold_name
                                                                    
                                                                    	Threshold name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..50
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** \-2147483648..2147483647
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                        self.yang_name = "threshold-array"
                                                                        self.yang_parent_name = "threshold"

                                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_name",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_name.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "threshold-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-name"):
                                                                            self.threshold_name = value
                                                                            self.threshold_name.value_namespace = name_space
                                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return False

                                                                def has_operation(self):
                                                                    for c in self.threshold_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return self.yfilter != YFilter.not_set

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "threshold" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "threshold-array"):
                                                                        for c in self.threshold_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.threshold_array.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "threshold-array"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    self.data_type.is_set or
                                                                    self.description.is_set or
                                                                    self.status.is_set or
                                                                    self.units.is_set or
                                                                    self.update_rate.is_set or
                                                                    self.value.is_set or
                                                                    (self.threshold is not None and self.threshold.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.data_type.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.status.yfilter != YFilter.not_set or
                                                                    self.units.yfilter != YFilter.not_set or
                                                                    self.update_rate.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    (self.threshold is not None and self.threshold.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "threshold"):
                                                                    if (self.threshold is None):
                                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml.Threshold()
                                                                        self.threshold.parent = self
                                                                        self._children_name_map["threshold"] = "threshold"
                                                                    return self.threshold

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "data-type"):
                                                                    self.data_type = value
                                                                    self.data_type.value_namespace = name_space
                                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "status"):
                                                                    self.status = value
                                                                    self.status.value_namespace = name_space
                                                                    self.status.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "units"):
                                                                    self.units = value
                                                                    self.units.value_namespace = name_space
                                                                    self.units.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "update-rate"):
                                                                    self.update_rate = value
                                                                    self.update_rate.value_namespace = name_space
                                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class InvAssetBag(Entity):
                                                            """
                                                            Inventory Asset Bag
                                                            
                                                            .. attribute:: manufacturer_assembly_number
                                                            
                                                            	Manufacture Assembly number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_assembly_revision
                                                            
                                                            	Manufacture assembly revision
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                                            
                                                            	Common Language Equipment           Identifier number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_firmware_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: manufacturer_software_identifier
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: original_equipment_manufacturer_string
                                                            
                                                            	String containing OEM information           if applicable
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: part_number
                                                            
                                                            	
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__init__()

                                                                self.yang_name = "inv-asset-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                                self.part_number = YLeaf(YType.str, "part-number")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("manufacturer_assembly_number",
                                                                                "manufacturer_assembly_revision",
                                                                                "manufacturer_common_language_equipment_identifier",
                                                                                "manufacturer_firmware_identifier",
                                                                                "manufacturer_software_identifier",
                                                                                "original_equipment_manufacturer_string",
                                                                                "part_number") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.manufacturer_assembly_number.is_set or
                                                                    self.manufacturer_assembly_revision.is_set or
                                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                                    self.manufacturer_firmware_identifier.is_set or
                                                                    self.manufacturer_software_identifier.is_set or
                                                                    self.original_equipment_manufacturer_string.is_set or
                                                                    self.part_number.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                                    self.part_number.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-asset-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "manufacturer-assembly-number"):
                                                                    self.manufacturer_assembly_number = value
                                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-assembly-revision"):
                                                                    self.manufacturer_assembly_revision = value
                                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                                    self.manufacturer_common_language_equipment_identifier = value
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-firmware-identifier"):
                                                                    self.manufacturer_firmware_identifier = value
                                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-software-identifier"):
                                                                    self.manufacturer_software_identifier = value
                                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "original-equipment-manufacturer-string"):
                                                                    self.original_equipment_manufacturer_string = value
                                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "part-number"):
                                                                    self.part_number = value
                                                                    self.part_number.value_namespace = name_space
                                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                                        class Threshold(Entity):
                                                            """
                                                            Threshold
                                                            
                                                            .. attribute:: critical_hi
                                                            
                                                            	Critical High
                                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi>`
                                                            
                                                            .. attribute:: critical_lo
                                                            
                                                            	Critical Low
                                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo>`
                                                            
                                                            .. attribute:: major_hi
                                                            
                                                            	Major High
                                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi>`
                                                            
                                                            .. attribute:: major_lo
                                                            
                                                            	Major Low
                                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo>`
                                                            
                                                            .. attribute:: minor_hi
                                                            
                                                            	Minor High
                                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi>`
                                                            
                                                            .. attribute:: minor_lo
                                                            
                                                            	Minor Low
                                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold, self).__init__()

                                                                self.yang_name = "threshold"
                                                                self.yang_parent_name = "attributes"

                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                                self._children_yang_names.add("critical-hi")

                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                                self._children_yang_names.add("critical-lo")

                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                                self._children_yang_names.add("major-hi")

                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                                self._children_yang_names.add("major-lo")

                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                                self._children_yang_names.add("minor-hi")

                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                                self._children_yang_names.add("minor-lo")


                                                            class MajorLo(Entity):
                                                                """
                                                                Major Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo, self).__init__()

                                                                    self.yang_name = "major-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalHi(Entity):
                                                                """
                                                                Critical High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi, self).__init__()

                                                                    self.yang_name = "critical-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorHi(Entity):
                                                                """
                                                                Minor High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi, self).__init__()

                                                                    self.yang_name = "minor-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MajorHi(Entity):
                                                                """
                                                                Major High
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi, self).__init__()

                                                                    self.yang_name = "major-hi"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "major-hi"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "major-hi" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class CriticalLo(Entity):
                                                                """
                                                                Critical Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo, self).__init__()

                                                                    self.yang_name = "critical-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "critical-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "critical-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass


                                                            class MinorLo(Entity):
                                                                """
                                                                Minor Low
                                                                
                                                                .. attribute:: thresh_bag
                                                                
                                                                	Environment threshold info
                                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo, self).__init__()

                                                                    self.yang_name = "minor-lo"
                                                                    self.yang_parent_name = "threshold"

                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                    self._children_yang_names.add("thresh-bag")


                                                                class ThreshBag(Entity):
                                                                    """
                                                                    Environment threshold info
                                                                    
                                                                    .. attribute:: threshold_evaluation
                                                                    
                                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_notification_enabled
                                                                    
                                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: threshold_relation
                                                                    
                                                                    	Indicates relation between sensor value and threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_severity
                                                                    
                                                                    	Indicates minor, major, critical severities
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: threshold_value
                                                                    
                                                                    	Value of the configured threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                        self.yang_name = "thresh-bag"
                                                                        self.yang_parent_name = "minor-lo"

                                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("threshold_evaluation",
                                                                                        "threshold_notification_enabled",
                                                                                        "threshold_relation",
                                                                                        "threshold_severity",
                                                                                        "threshold_value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.threshold_evaluation.is_set or
                                                                            self.threshold_notification_enabled.is_set or
                                                                            self.threshold_relation.is_set or
                                                                            self.threshold_severity.is_set or
                                                                            self.threshold_value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "thresh-bag" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "threshold-evaluation"):
                                                                            self.threshold_evaluation = value
                                                                            self.threshold_evaluation.value_namespace = name_space
                                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-notification-enabled"):
                                                                            self.threshold_notification_enabled = value
                                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-relation"):
                                                                            self.threshold_relation = value
                                                                            self.threshold_relation.value_namespace = name_space
                                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-severity"):
                                                                            self.threshold_severity = value
                                                                            self.threshold_severity.value_namespace = name_space
                                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "threshold-value"):
                                                                            self.threshold_value = value
                                                                            self.threshold_value.value_namespace = name_space
                                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "minor-lo" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "thresh-bag"):
                                                                        if (self.thresh_bag is None):
                                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo.ThreshBag()
                                                                            self.thresh_bag.parent = self
                                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                        return self.thresh_bag

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "thresh-bag"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    pass

                                                            def has_data(self):
                                                                return (
                                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "critical-hi"):
                                                                    if (self.critical_hi is None):
                                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalHi()
                                                                        self.critical_hi.parent = self
                                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                                    return self.critical_hi

                                                                if (child_yang_name == "critical-lo"):
                                                                    if (self.critical_lo is None):
                                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.CriticalLo()
                                                                        self.critical_lo.parent = self
                                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                                    return self.critical_lo

                                                                if (child_yang_name == "major-hi"):
                                                                    if (self.major_hi is None):
                                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorHi()
                                                                        self.major_hi.parent = self
                                                                        self._children_name_map["major_hi"] = "major-hi"
                                                                    return self.major_hi

                                                                if (child_yang_name == "major-lo"):
                                                                    if (self.major_lo is None):
                                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MajorLo()
                                                                        self.major_lo.parent = self
                                                                        self._children_name_map["major_lo"] = "major-lo"
                                                                    return self.major_lo

                                                                if (child_yang_name == "minor-hi"):
                                                                    if (self.minor_hi is None):
                                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorHi()
                                                                        self.minor_hi.parent = self
                                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                                    return self.minor_hi

                                                                if (child_yang_name == "minor-lo"):
                                                                    if (self.minor_lo is None):
                                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold.MinorLo()
                                                                        self.minor_lo.parent = self
                                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                                    return self.minor_lo

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                pass


                                                        class FruInfo(Entity):
                                                            """
                                                            Inventory EDM FRU info
                                                            
                                                            .. attribute:: card_administrative_state
                                                            
                                                            	card admin state\: shutdown or not
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_monitor_state
                                                            
                                                            	card is monitored by a manager or left unmonitored
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_operational_state
                                                            
                                                            	card operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: card_reset_reason
                                                            
                                                            	card reset reason enum
                                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                            
                                                            .. attribute:: card_up_time
                                                            
                                                            	card up time
                                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime>`
                                                            
                                                            .. attribute:: last_operational_state_change
                                                            
                                                            	last card oper change state
                                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange>`
                                                            
                                                            .. attribute:: power_administrative_state
                                                            
                                                            	power admin state\: up or down
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_current_measurement
                                                            
                                                            	power current\: not implemented
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: power_operational_state
                                                            
                                                            	Power operation state
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__init__()

                                                                self.yang_name = "fru-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                                self._children_yang_names.add("card-up-time")

                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                self._children_yang_names.add("last-operational-state-change")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("card_administrative_state",
                                                                                "card_monitor_state",
                                                                                "card_operational_state",
                                                                                "card_reset_reason",
                                                                                "power_administrative_state",
                                                                                "power_current_measurement",
                                                                                "power_operational_state") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo, self).__setattr__(name, value)


                                                            class LastOperationalStateChange(Entity):
                                                                """
                                                                last card oper change state
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                                    self.yang_name = "last-operational-state-change"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                            class CardUpTime(Entity):
                                                                """
                                                                card up time
                                                                
                                                                .. attribute:: time_in_nano_seconds
                                                                
                                                                	Time Value in Nano\-seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: nanosecond
                                                                
                                                                .. attribute:: time_in_seconds
                                                                
                                                                	Time Value in Seconds
                                                                	**type**\:  int
                                                                
                                                                	**range:** \-2147483648..2147483647
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__init__()

                                                                    self.yang_name = "card-up-time"
                                                                    self.yang_parent_name = "fru-info"

                                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("time_in_nano_seconds",
                                                                                    "time_in_seconds") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.time_in_nano_seconds.is_set or
                                                                        self.time_in_seconds.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "card-up-time" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "time-in-nano-seconds"):
                                                                        self.time_in_nano_seconds = value
                                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "time-in-seconds"):
                                                                        self.time_in_seconds = value
                                                                        self.time_in_seconds.value_namespace = name_space
                                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.card_administrative_state.is_set or
                                                                    self.card_monitor_state.is_set or
                                                                    self.card_operational_state.is_set or
                                                                    self.card_reset_reason.is_set or
                                                                    self.power_administrative_state.is_set or
                                                                    self.power_current_measurement.is_set or
                                                                    self.power_operational_state.is_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fru-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "card-up-time"):
                                                                    if (self.card_up_time is None):
                                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.CardUpTime()
                                                                        self.card_up_time.parent = self
                                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                                    return self.card_up_time

                                                                if (child_yang_name == "last-operational-state-change"):
                                                                    if (self.last_operational_state_change is None):
                                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo.LastOperationalStateChange()
                                                                        self.last_operational_state_change.parent = self
                                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                                    return self.last_operational_state_change

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "card-administrative-state"):
                                                                    self.card_administrative_state = value
                                                                    self.card_administrative_state.value_namespace = name_space
                                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-monitor-state"):
                                                                    self.card_monitor_state = value
                                                                    self.card_monitor_state.value_namespace = name_space
                                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-operational-state"):
                                                                    self.card_operational_state = value
                                                                    self.card_operational_state.value_namespace = name_space
                                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "card-reset-reason"):
                                                                    self.card_reset_reason = value
                                                                    self.card_reset_reason.value_namespace = name_space
                                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-administrative-state"):
                                                                    self.power_administrative_state = value
                                                                    self.power_administrative_state.value_namespace = name_space
                                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-current-measurement"):
                                                                    self.power_current_measurement = value
                                                                    self.power_current_measurement.value_namespace = name_space
                                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "power-operational-state"):
                                                                    self.power_operational_state = value
                                                                    self.power_operational_state.value_namespace = name_space
                                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                        class InvBasicBag(Entity):
                                                            """
                                                            Inventory Basic Bag
                                                            
                                                            .. attribute:: alias
                                                            
                                                            	useful for storing an entity alias 
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_id_str
                                                            
                                                            	asset Identification string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: asset_identification
                                                            
                                                            	asset Identification
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: ceport
                                                            
                                                            	1 if ce port found, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: chip_hardware_revision
                                                            
                                                            	chip module hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: composite_class_code
                                                            
                                                            	Major&minor class of the entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: description
                                                            
                                                            	describes in user\-readable terms       what the entity in question does
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: environmental_monitor_path
                                                            
                                                            	sysdb name of sensor in the envmon EDM
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: firmware_revision
                                                            
                                                            	firmware revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: group_flag
                                                            
                                                            	indicates if this entity is group       or not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: hardware_revision
                                                            
                                                            	hw revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: is_field_replaceable_unit
                                                            
                                                            	1 if Field Replaceable Unit 0, if not
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: manufacturer_asset_tags
                                                            
                                                            	Manufacture Asset Tags
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: manufacturer_name
                                                            
                                                            	manufacturer's name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: memory_size
                                                            
                                                            	Size of memory associated with       the entity where applicable
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: model_name
                                                            
                                                            	model name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: name
                                                            
                                                            	name string for the entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: new_deviation_number
                                                            
                                                            	integer value for New Deviation Number 0x88
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: physical_layer_interface_module_type
                                                            
                                                            	integer value for plim type if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: redundancystate
                                                            
                                                            	integer value for Redundancy State if     applicable to this entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: serial_number
                                                            
                                                            	serial number
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: software_revision
                                                            
                                                            	software revision string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: unique_id
                                                            
                                                            	Unique id for an entity
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            .. attribute:: unrecognized_fru
                                                            
                                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: vendor_type
                                                            
                                                            	maps to the vendor OID string
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: xr_scoped
                                                            
                                                            	1 if xr scoped, 0 if not
                                                            	**type**\:  bool
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__init__()

                                                                self.yang_name = "inv-basic-bag"
                                                                self.yang_parent_name = "attributes"

                                                                self.alias = YLeaf(YType.str, "alias")

                                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                                self.model_name = YLeaf(YType.str, "model-name")

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("alias",
                                                                                "asset_id_str",
                                                                                "asset_identification",
                                                                                "ceport",
                                                                                "chip_hardware_revision",
                                                                                "composite_class_code",
                                                                                "description",
                                                                                "environmental_monitor_path",
                                                                                "firmware_revision",
                                                                                "group_flag",
                                                                                "hardware_revision",
                                                                                "is_field_replaceable_unit",
                                                                                "manufacturer_asset_tags",
                                                                                "manufacturer_name",
                                                                                "memory_size",
                                                                                "model_name",
                                                                                "name",
                                                                                "new_deviation_number",
                                                                                "physical_layer_interface_module_type",
                                                                                "redundancystate",
                                                                                "serial_number",
                                                                                "software_revision",
                                                                                "unique_id",
                                                                                "unrecognized_fru",
                                                                                "vendor_type",
                                                                                "xr_scoped") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.alias.is_set or
                                                                    self.asset_id_str.is_set or
                                                                    self.asset_identification.is_set or
                                                                    self.ceport.is_set or
                                                                    self.chip_hardware_revision.is_set or
                                                                    self.composite_class_code.is_set or
                                                                    self.description.is_set or
                                                                    self.environmental_monitor_path.is_set or
                                                                    self.firmware_revision.is_set or
                                                                    self.group_flag.is_set or
                                                                    self.hardware_revision.is_set or
                                                                    self.is_field_replaceable_unit.is_set or
                                                                    self.manufacturer_asset_tags.is_set or
                                                                    self.manufacturer_name.is_set or
                                                                    self.memory_size.is_set or
                                                                    self.model_name.is_set or
                                                                    self.name.is_set or
                                                                    self.new_deviation_number.is_set or
                                                                    self.physical_layer_interface_module_type.is_set or
                                                                    self.redundancystate.is_set or
                                                                    self.serial_number.is_set or
                                                                    self.software_revision.is_set or
                                                                    self.unique_id.is_set or
                                                                    self.unrecognized_fru.is_set or
                                                                    self.vendor_type.is_set or
                                                                    self.xr_scoped.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.alias.yfilter != YFilter.not_set or
                                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                                    self.ceport.yfilter != YFilter.not_set or
                                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                                    self.group_flag.yfilter != YFilter.not_set or
                                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                                    self.memory_size.yfilter != YFilter.not_set or
                                                                    self.model_name.yfilter != YFilter.not_set or
                                                                    self.name.yfilter != YFilter.not_set or
                                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                                    self.serial_number.yfilter != YFilter.not_set or
                                                                    self.software_revision.yfilter != YFilter.not_set or
                                                                    self.unique_id.yfilter != YFilter.not_set or
                                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-basic-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "alias"):
                                                                    self.alias = value
                                                                    self.alias.value_namespace = name_space
                                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-id-str"):
                                                                    self.asset_id_str = value
                                                                    self.asset_id_str.value_namespace = name_space
                                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "asset-identification"):
                                                                    self.asset_identification = value
                                                                    self.asset_identification.value_namespace = name_space
                                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ceport"):
                                                                    self.ceport = value
                                                                    self.ceport.value_namespace = name_space
                                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "chip-hardware-revision"):
                                                                    self.chip_hardware_revision = value
                                                                    self.chip_hardware_revision.value_namespace = name_space
                                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "composite-class-code"):
                                                                    self.composite_class_code = value
                                                                    self.composite_class_code.value_namespace = name_space
                                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "environmental-monitor-path"):
                                                                    self.environmental_monitor_path = value
                                                                    self.environmental_monitor_path.value_namespace = name_space
                                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "firmware-revision"):
                                                                    self.firmware_revision = value
                                                                    self.firmware_revision.value_namespace = name_space
                                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "group-flag"):
                                                                    self.group_flag = value
                                                                    self.group_flag.value_namespace = name_space
                                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "hardware-revision"):
                                                                    self.hardware_revision = value
                                                                    self.hardware_revision.value_namespace = name_space
                                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "is-field-replaceable-unit"):
                                                                    self.is_field_replaceable_unit = value
                                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-asset-tags"):
                                                                    self.manufacturer_asset_tags = value
                                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "manufacturer-name"):
                                                                    self.manufacturer_name = value
                                                                    self.manufacturer_name.value_namespace = name_space
                                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "memory-size"):
                                                                    self.memory_size = value
                                                                    self.memory_size.value_namespace = name_space
                                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "model-name"):
                                                                    self.model_name = value
                                                                    self.model_name.value_namespace = name_space
                                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "name"):
                                                                    self.name = value
                                                                    self.name.value_namespace = name_space
                                                                    self.name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "new-deviation-number"):
                                                                    self.new_deviation_number = value
                                                                    self.new_deviation_number.value_namespace = name_space
                                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "physical-layer-interface-module-type"):
                                                                    self.physical_layer_interface_module_type = value
                                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "redundancystate"):
                                                                    self.redundancystate = value
                                                                    self.redundancystate.value_namespace = name_space
                                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "serial-number"):
                                                                    self.serial_number = value
                                                                    self.serial_number.value_namespace = name_space
                                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "software-revision"):
                                                                    self.software_revision = value
                                                                    self.software_revision.value_namespace = name_space
                                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unique-id"):
                                                                    self.unique_id = value
                                                                    self.unique_id.value_namespace = name_space
                                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "unrecognized-fru"):
                                                                    self.unrecognized_fru = value
                                                                    self.unrecognized_fru.value_namespace = name_space
                                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "vendor-type"):
                                                                    self.vendor_type = value
                                                                    self.vendor_type.value_namespace = name_space
                                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "xr-scoped"):
                                                                    self.xr_scoped = value
                                                                    self.xr_scoped.value_namespace = name_space
                                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                        class InvEepromInfo(Entity):
                                                            """
                                                            Inventory EDM EEPROM Information Bag
                                                            
                                                            .. attribute:: description
                                                            
                                                            	A textual description of physical entity
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: eeprom
                                                            
                                                            	EEPROM data not from hex data
                                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom>`
                                                            
                                                            .. attribute:: has_eeprom
                                                            
                                                            	use eeprom instead of opaque data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: inv_card_type
                                                            
                                                            	Inventory card type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: opaque_data
                                                            
                                                            	EEPROM hex data
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                            
                                                            .. attribute:: opaque_data_size
                                                            
                                                            	size of the EEPROM hex data
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__init__()

                                                                self.yang_name = "inv-eeprom-info"
                                                                self.yang_parent_name = "attributes"

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                                self._children_yang_names.add("eeprom")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("description",
                                                                                "has_eeprom",
                                                                                "inv_card_type",
                                                                                "opaque_data",
                                                                                "opaque_data_size") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                            class Eeprom(Entity):
                                                                """
                                                                EEPROM data not from hex data
                                                                
                                                                .. attribute:: asset_alias
                                                                
                                                                	Asset Alias
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: asset_id
                                                                
                                                                	Asset ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address1
                                                                
                                                                	Base Mac Address #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address2
                                                                
                                                                	Base Mac Address #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address3
                                                                
                                                                	Base Mac Address #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: base_mac_address4
                                                                
                                                                	Base Mac Address #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_checksum
                                                                
                                                                	Block Checksum
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_count
                                                                
                                                                	Block Count
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_length
                                                                
                                                                	Block Length
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_signature
                                                                
                                                                	Block Signature
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: block_version
                                                                
                                                                	Block Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: chassis_sid
                                                                
                                                                	Chassis serial number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: clei
                                                                
                                                                	Common Language Equipment Identifier (CLEI) code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_family
                                                                
                                                                	Controller family
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: controller_type
                                                                
                                                                	Controller type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: description
                                                                
                                                                	A textual description of physical entity
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num1
                                                                
                                                                	Deviation Number # 1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num2
                                                                
                                                                	Deviation Number # 2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num3
                                                                
                                                                	Deviation Number # 3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num4
                                                                
                                                                	Deviation Number # 4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num5
                                                                
                                                                	Deviation Number # 5
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num6
                                                                
                                                                	Deviation Number # 6
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: dev_num7
                                                                
                                                                	Deviation Number # 7
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eci
                                                                
                                                                	Equipment Catalog Item (ECI) number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: eeprom_size
                                                                
                                                                	EEPROM Size
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: engineer_use
                                                                
                                                                	Engineer Use
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_major_type
                                                                
                                                                	FRU Major Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: fru_minor_type
                                                                
                                                                	FRU Minor Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hw_version
                                                                
                                                                	Hardware Version
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: hwid
                                                                
                                                                	Hardware Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: idprom_format_rev
                                                                
                                                                	IDPROM Format Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size1
                                                                
                                                                	Mac Address Block Size #1
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size2
                                                                
                                                                	Mac Address Block Size #2
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size3
                                                                
                                                                	Mac Address Block Size #3
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mac_add_blk_size4
                                                                
                                                                	Mac Address Block Size #4
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: manu_test_data
                                                                
                                                                	Manufacturing Test Data
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_bits
                                                                
                                                                	MFG Bits
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: mfg_deviation
                                                                
                                                                	MFG Deviation
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: oem_string
                                                                
                                                                	OEM String
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_number
                                                                
                                                                	Part Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: part_revision
                                                                
                                                                	Part Revision
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pca_num
                                                                
                                                                	PCA number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcavid
                                                                
                                                                	PCA revision ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pcb_serial_num
                                                                
                                                                	PCB Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: pid
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_consumption
                                                                
                                                                	Power Consumption
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: power_supply_type
                                                                
                                                                	Power Supply Type
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: product_id
                                                                
                                                                	Product ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: rma
                                                                
                                                                	RMA Data
                                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                                
                                                                .. attribute:: rma_code
                                                                
                                                                	RMA Code
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: serial_number
                                                                
                                                                	Serial Number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: snmpoid
                                                                
                                                                	SNMP OID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_part_num
                                                                
                                                                	Top assembly part number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: top_assem_vid
                                                                
                                                                	Top assembly revision number
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_description
                                                                
                                                                	UDI description
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: udi_name
                                                                
                                                                	UDI name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                .. attribute:: vid
                                                                
                                                                	Version ID
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'invmgr-oper'
                                                                _revision = '2015-11-09'

                                                                def __init__(self):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                                    self.yang_name = "eeprom"
                                                                    self.yang_parent_name = "inv-eeprom-info"

                                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                                    self.clei = YLeaf(YType.str, "clei")

                                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                                    self.eci = YLeaf(YType.str, "eci")

                                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                                    self.pid = YLeaf(YType.str, "pid")

                                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                                    self.vid = YLeaf(YType.str, "vid")

                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                    self._children_yang_names.add("rma")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("asset_alias",
                                                                                    "asset_id",
                                                                                    "base_mac_address1",
                                                                                    "base_mac_address2",
                                                                                    "base_mac_address3",
                                                                                    "base_mac_address4",
                                                                                    "block_checksum",
                                                                                    "block_count",
                                                                                    "block_length",
                                                                                    "block_signature",
                                                                                    "block_version",
                                                                                    "chassis_sid",
                                                                                    "clei",
                                                                                    "controller_family",
                                                                                    "controller_type",
                                                                                    "description",
                                                                                    "dev_num1",
                                                                                    "dev_num2",
                                                                                    "dev_num3",
                                                                                    "dev_num4",
                                                                                    "dev_num5",
                                                                                    "dev_num6",
                                                                                    "dev_num7",
                                                                                    "eci",
                                                                                    "eeprom_size",
                                                                                    "engineer_use",
                                                                                    "fru_major_type",
                                                                                    "fru_minor_type",
                                                                                    "hw_version",
                                                                                    "hwid",
                                                                                    "idprom_format_rev",
                                                                                    "mac_add_blk_size1",
                                                                                    "mac_add_blk_size2",
                                                                                    "mac_add_blk_size3",
                                                                                    "mac_add_blk_size4",
                                                                                    "manu_test_data",
                                                                                    "mfg_bits",
                                                                                    "mfg_deviation",
                                                                                    "oem_string",
                                                                                    "part_number",
                                                                                    "part_revision",
                                                                                    "pca_num",
                                                                                    "pcavid",
                                                                                    "pcb_serial_num",
                                                                                    "pid",
                                                                                    "power_consumption",
                                                                                    "power_supply_type",
                                                                                    "product_id",
                                                                                    "rma_code",
                                                                                    "serial_number",
                                                                                    "snmpoid",
                                                                                    "top_assem_part_num",
                                                                                    "top_assem_vid",
                                                                                    "udi_description",
                                                                                    "udi_name",
                                                                                    "vid") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                                class Rma(Entity):
                                                                    """
                                                                    RMA Data
                                                                    
                                                                    .. attribute:: rma_history
                                                                    
                                                                    	RMA history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: rma_number
                                                                    
                                                                    	RMA tracking number format is N\-N\-N
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    .. attribute:: test_history
                                                                    
                                                                    	Test history
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'invmgr-oper'
                                                                    _revision = '2015-11-09'

                                                                    def __init__(self):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                        self.yang_name = "rma"
                                                                        self.yang_parent_name = "eeprom"

                                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("rma_history",
                                                                                        "rma_number",
                                                                                        "test_history") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.rma_history.is_set or
                                                                            self.rma_number.is_set or
                                                                            self.test_history.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.rma_history.yfilter != YFilter.not_set or
                                                                            self.rma_number.yfilter != YFilter.not_set or
                                                                            self.test_history.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "rma" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "rma-history"):
                                                                            self.rma_history = value
                                                                            self.rma_history.value_namespace = name_space
                                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "rma-number"):
                                                                            self.rma_number = value
                                                                            self.rma_number.value_namespace = name_space
                                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "test-history"):
                                                                            self.test_history = value
                                                                            self.test_history.value_namespace = name_space
                                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.asset_alias.is_set or
                                                                        self.asset_id.is_set or
                                                                        self.base_mac_address1.is_set or
                                                                        self.base_mac_address2.is_set or
                                                                        self.base_mac_address3.is_set or
                                                                        self.base_mac_address4.is_set or
                                                                        self.block_checksum.is_set or
                                                                        self.block_count.is_set or
                                                                        self.block_length.is_set or
                                                                        self.block_signature.is_set or
                                                                        self.block_version.is_set or
                                                                        self.chassis_sid.is_set or
                                                                        self.clei.is_set or
                                                                        self.controller_family.is_set or
                                                                        self.controller_type.is_set or
                                                                        self.description.is_set or
                                                                        self.dev_num1.is_set or
                                                                        self.dev_num2.is_set or
                                                                        self.dev_num3.is_set or
                                                                        self.dev_num4.is_set or
                                                                        self.dev_num5.is_set or
                                                                        self.dev_num6.is_set or
                                                                        self.dev_num7.is_set or
                                                                        self.eci.is_set or
                                                                        self.eeprom_size.is_set or
                                                                        self.engineer_use.is_set or
                                                                        self.fru_major_type.is_set or
                                                                        self.fru_minor_type.is_set or
                                                                        self.hw_version.is_set or
                                                                        self.hwid.is_set or
                                                                        self.idprom_format_rev.is_set or
                                                                        self.mac_add_blk_size1.is_set or
                                                                        self.mac_add_blk_size2.is_set or
                                                                        self.mac_add_blk_size3.is_set or
                                                                        self.mac_add_blk_size4.is_set or
                                                                        self.manu_test_data.is_set or
                                                                        self.mfg_bits.is_set or
                                                                        self.mfg_deviation.is_set or
                                                                        self.oem_string.is_set or
                                                                        self.part_number.is_set or
                                                                        self.part_revision.is_set or
                                                                        self.pca_num.is_set or
                                                                        self.pcavid.is_set or
                                                                        self.pcb_serial_num.is_set or
                                                                        self.pid.is_set or
                                                                        self.power_consumption.is_set or
                                                                        self.power_supply_type.is_set or
                                                                        self.product_id.is_set or
                                                                        self.rma_code.is_set or
                                                                        self.serial_number.is_set or
                                                                        self.snmpoid.is_set or
                                                                        self.top_assem_part_num.is_set or
                                                                        self.top_assem_vid.is_set or
                                                                        self.udi_description.is_set or
                                                                        self.udi_name.is_set or
                                                                        self.vid.is_set or
                                                                        (self.rma is not None and self.rma.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                                        self.asset_id.yfilter != YFilter.not_set or
                                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                                        self.block_count.yfilter != YFilter.not_set or
                                                                        self.block_length.yfilter != YFilter.not_set or
                                                                        self.block_signature.yfilter != YFilter.not_set or
                                                                        self.block_version.yfilter != YFilter.not_set or
                                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                                        self.clei.yfilter != YFilter.not_set or
                                                                        self.controller_family.yfilter != YFilter.not_set or
                                                                        self.controller_type.yfilter != YFilter.not_set or
                                                                        self.description.yfilter != YFilter.not_set or
                                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                                        self.eci.yfilter != YFilter.not_set or
                                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                                        self.hw_version.yfilter != YFilter.not_set or
                                                                        self.hwid.yfilter != YFilter.not_set or
                                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                                        self.oem_string.yfilter != YFilter.not_set or
                                                                        self.part_number.yfilter != YFilter.not_set or
                                                                        self.part_revision.yfilter != YFilter.not_set or
                                                                        self.pca_num.yfilter != YFilter.not_set or
                                                                        self.pcavid.yfilter != YFilter.not_set or
                                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                        self.pid.yfilter != YFilter.not_set or
                                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                                        self.product_id.yfilter != YFilter.not_set or
                                                                        self.rma_code.yfilter != YFilter.not_set or
                                                                        self.serial_number.yfilter != YFilter.not_set or
                                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                                        self.udi_description.yfilter != YFilter.not_set or
                                                                        self.udi_name.yfilter != YFilter.not_set or
                                                                        self.vid.yfilter != YFilter.not_set or
                                                                        (self.rma is not None and self.rma.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "eeprom" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "rma"):
                                                                        if (self.rma is None):
                                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                            self.rma.parent = self
                                                                            self._children_name_map["rma"] = "rma"
                                                                        return self.rma

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "asset-alias"):
                                                                        self.asset_alias = value
                                                                        self.asset_alias.value_namespace = name_space
                                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "asset-id"):
                                                                        self.asset_id = value
                                                                        self.asset_id.value_namespace = name_space
                                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address1"):
                                                                        self.base_mac_address1 = value
                                                                        self.base_mac_address1.value_namespace = name_space
                                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address2"):
                                                                        self.base_mac_address2 = value
                                                                        self.base_mac_address2.value_namespace = name_space
                                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address3"):
                                                                        self.base_mac_address3 = value
                                                                        self.base_mac_address3.value_namespace = name_space
                                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "base-mac-address4"):
                                                                        self.base_mac_address4 = value
                                                                        self.base_mac_address4.value_namespace = name_space
                                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-checksum"):
                                                                        self.block_checksum = value
                                                                        self.block_checksum.value_namespace = name_space
                                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-count"):
                                                                        self.block_count = value
                                                                        self.block_count.value_namespace = name_space
                                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-length"):
                                                                        self.block_length = value
                                                                        self.block_length.value_namespace = name_space
                                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-signature"):
                                                                        self.block_signature = value
                                                                        self.block_signature.value_namespace = name_space
                                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "block-version"):
                                                                        self.block_version = value
                                                                        self.block_version.value_namespace = name_space
                                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "chassis-sid"):
                                                                        self.chassis_sid = value
                                                                        self.chassis_sid.value_namespace = name_space
                                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "clei"):
                                                                        self.clei = value
                                                                        self.clei.value_namespace = name_space
                                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-family"):
                                                                        self.controller_family = value
                                                                        self.controller_family.value_namespace = name_space
                                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "controller-type"):
                                                                        self.controller_type = value
                                                                        self.controller_type.value_namespace = name_space
                                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "description"):
                                                                        self.description = value
                                                                        self.description.value_namespace = name_space
                                                                        self.description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num1"):
                                                                        self.dev_num1 = value
                                                                        self.dev_num1.value_namespace = name_space
                                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num2"):
                                                                        self.dev_num2 = value
                                                                        self.dev_num2.value_namespace = name_space
                                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num3"):
                                                                        self.dev_num3 = value
                                                                        self.dev_num3.value_namespace = name_space
                                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num4"):
                                                                        self.dev_num4 = value
                                                                        self.dev_num4.value_namespace = name_space
                                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num5"):
                                                                        self.dev_num5 = value
                                                                        self.dev_num5.value_namespace = name_space
                                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num6"):
                                                                        self.dev_num6 = value
                                                                        self.dev_num6.value_namespace = name_space
                                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "dev-num7"):
                                                                        self.dev_num7 = value
                                                                        self.dev_num7.value_namespace = name_space
                                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eci"):
                                                                        self.eci = value
                                                                        self.eci.value_namespace = name_space
                                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "eeprom-size"):
                                                                        self.eeprom_size = value
                                                                        self.eeprom_size.value_namespace = name_space
                                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "engineer-use"):
                                                                        self.engineer_use = value
                                                                        self.engineer_use.value_namespace = name_space
                                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-major-type"):
                                                                        self.fru_major_type = value
                                                                        self.fru_major_type.value_namespace = name_space
                                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "fru-minor-type"):
                                                                        self.fru_minor_type = value
                                                                        self.fru_minor_type.value_namespace = name_space
                                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hw-version"):
                                                                        self.hw_version = value
                                                                        self.hw_version.value_namespace = name_space
                                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "hwid"):
                                                                        self.hwid = value
                                                                        self.hwid.value_namespace = name_space
                                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "idprom-format-rev"):
                                                                        self.idprom_format_rev = value
                                                                        self.idprom_format_rev.value_namespace = name_space
                                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size1"):
                                                                        self.mac_add_blk_size1 = value
                                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size2"):
                                                                        self.mac_add_blk_size2 = value
                                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size3"):
                                                                        self.mac_add_blk_size3 = value
                                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mac-add-blk-size4"):
                                                                        self.mac_add_blk_size4 = value
                                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "manu-test-data"):
                                                                        self.manu_test_data = value
                                                                        self.manu_test_data.value_namespace = name_space
                                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-bits"):
                                                                        self.mfg_bits = value
                                                                        self.mfg_bits.value_namespace = name_space
                                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "mfg-deviation"):
                                                                        self.mfg_deviation = value
                                                                        self.mfg_deviation.value_namespace = name_space
                                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "oem-string"):
                                                                        self.oem_string = value
                                                                        self.oem_string.value_namespace = name_space
                                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-number"):
                                                                        self.part_number = value
                                                                        self.part_number.value_namespace = name_space
                                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "part-revision"):
                                                                        self.part_revision = value
                                                                        self.part_revision.value_namespace = name_space
                                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pca-num"):
                                                                        self.pca_num = value
                                                                        self.pca_num.value_namespace = name_space
                                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcavid"):
                                                                        self.pcavid = value
                                                                        self.pcavid.value_namespace = name_space
                                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pcb-serial-num"):
                                                                        self.pcb_serial_num = value
                                                                        self.pcb_serial_num.value_namespace = name_space
                                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pid"):
                                                                        self.pid = value
                                                                        self.pid.value_namespace = name_space
                                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-consumption"):
                                                                        self.power_consumption = value
                                                                        self.power_consumption.value_namespace = name_space
                                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "power-supply-type"):
                                                                        self.power_supply_type = value
                                                                        self.power_supply_type.value_namespace = name_space
                                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "product-id"):
                                                                        self.product_id = value
                                                                        self.product_id.value_namespace = name_space
                                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "rma-code"):
                                                                        self.rma_code = value
                                                                        self.rma_code.value_namespace = name_space
                                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "serial-number"):
                                                                        self.serial_number = value
                                                                        self.serial_number.value_namespace = name_space
                                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "snmpoid"):
                                                                        self.snmpoid = value
                                                                        self.snmpoid.value_namespace = name_space
                                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-part-num"):
                                                                        self.top_assem_part_num = value
                                                                        self.top_assem_part_num.value_namespace = name_space
                                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "top-assem-vid"):
                                                                        self.top_assem_vid = value
                                                                        self.top_assem_vid.value_namespace = name_space
                                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-description"):
                                                                        self.udi_description = value
                                                                        self.udi_description.value_namespace = name_space
                                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "udi-name"):
                                                                        self.udi_name = value
                                                                        self.udi_name.value_namespace = name_space
                                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "vid"):
                                                                        self.vid = value
                                                                        self.vid.value_namespace = name_space
                                                                        self.vid.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.description.is_set or
                                                                    self.has_eeprom.is_set or
                                                                    self.inv_card_type.is_set or
                                                                    self.opaque_data.is_set or
                                                                    self.opaque_data_size.is_set or
                                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.description.yfilter != YFilter.not_set or
                                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "eeprom"):
                                                                    if (self.eeprom is None):
                                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo.Eeprom()
                                                                        self.eeprom.parent = self
                                                                        self._children_name_map["eeprom"] = "eeprom"
                                                                    return self.eeprom

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "description"):
                                                                    self.description = value
                                                                    self.description.value_namespace = name_space
                                                                    self.description.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "has-eeprom"):
                                                                    self.has_eeprom = value
                                                                    self.has_eeprom.value_namespace = name_space
                                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "inv-card-type"):
                                                                    self.inv_card_type = value
                                                                    self.inv_card_type.value_namespace = name_space
                                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data"):
                                                                    self.opaque_data = value
                                                                    self.opaque_data.value_namespace = name_space
                                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "opaque-data-size"):
                                                                    self.opaque_data_size = value
                                                                    self.opaque_data_size.value_namespace = name_space
                                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.module_done.is_set or
                                                                self.node_id.is_set or
                                                                self.vm_done.is_set or
                                                                self.vm_node_id.is_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                                (self.threshold is not None and self.threshold.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.module_done.yfilter != YFilter.not_set or
                                                                self.node_id.yfilter != YFilter.not_set or
                                                                self.vm_done.yfilter != YFilter.not_set or
                                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                                (self.threshold is not None and self.threshold.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "attributes" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "env-sensor-info"):
                                                                if (self.env_sensor_info is None):
                                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfo()
                                                                    self.env_sensor_info.parent = self
                                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                                return self.env_sensor_info

                                                            if (child_yang_name == "env-sensor-info-xml"):
                                                                if (self.env_sensor_info_xml is None):
                                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.EnvSensorInfoXml()
                                                                    self.env_sensor_info_xml.parent = self
                                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                                return self.env_sensor_info_xml

                                                            if (child_yang_name == "fru-info"):
                                                                if (self.fru_info is None):
                                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.FruInfo()
                                                                    self.fru_info.parent = self
                                                                    self._children_name_map["fru_info"] = "fru-info"
                                                                return self.fru_info

                                                            if (child_yang_name == "inv-asset-bag"):
                                                                if (self.inv_asset_bag is None):
                                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvAssetBag()
                                                                    self.inv_asset_bag.parent = self
                                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                                return self.inv_asset_bag

                                                            if (child_yang_name == "inv-basic-bag"):
                                                                if (self.inv_basic_bag is None):
                                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvBasicBag()
                                                                    self.inv_basic_bag.parent = self
                                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                                return self.inv_basic_bag

                                                            if (child_yang_name == "inv-eeprom-info"):
                                                                if (self.inv_eeprom_info is None):
                                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.InvEepromInfo()
                                                                    self.inv_eeprom_info.parent = self
                                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                                return self.inv_eeprom_info

                                                            if (child_yang_name == "pwg-info"):
                                                                if (self.pwg_info is None):
                                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.PwgInfo()
                                                                    self.pwg_info.parent = self
                                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                                return self.pwg_info

                                                            if (child_yang_name == "threshold"):
                                                                if (self.threshold is None):
                                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes.Threshold()
                                                                    self.threshold.parent = self
                                                                    self._children_name_map["threshold"] = "threshold"
                                                                return self.threshold

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "module-done"):
                                                                self.module_done = value
                                                                self.module_done.value_namespace = name_space
                                                                self.module_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "node-id"):
                                                                self.node_id = value
                                                                self.node_id.value_namespace = name_space
                                                                self.node_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-done"):
                                                                self.vm_done = value
                                                                self.vm_done.value_namespace = name_space
                                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vm-node-id"):
                                                                self.vm_node_id = value
                                                                self.vm_node_id.value_namespace = name_space
                                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.name.is_set or
                                                            (self.attributes is not None and self.attributes.has_data()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            (self.attributes is not None and self.attributes.has_operation()) or
                                                            (self.tsi5s is not None and self.tsi5s.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "tsi4" + "[name='" + self.name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "attributes"):
                                                            if (self.attributes is None):
                                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Attributes()
                                                                self.attributes.parent = self
                                                                self._children_name_map["attributes"] = "attributes"
                                                            return self.attributes

                                                        if (child_yang_name == "tsi5s"):
                                                            if (self.tsi5s is None):
                                                                self.tsi5s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4.Tsi5S()
                                                                self.tsi5s.parent = self
                                                                self._children_name_map["tsi5s"] = "tsi5s"
                                                            return self.tsi5s

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attributes" or name == "tsi5s" or name == "name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.tsi4:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.tsi4:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "tsi4s" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "tsi4"):
                                                        for c in self.tsi4:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S.Tsi4()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.tsi4.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "tsi4"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Attributes(Entity):
                                                """
                                                Attributes
                                                
                                                .. attribute:: env_sensor_info
                                                
                                                	Environment sensor info
                                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo>`
                                                
                                                .. attribute:: env_sensor_info_xml
                                                
                                                	Environment sensor info XML
                                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml>`
                                                
                                                .. attribute:: fru_info
                                                
                                                	Inventory EDM FRU info
                                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo>`
                                                
                                                .. attribute:: inv_asset_bag
                                                
                                                	Inventory Asset Bag
                                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag>`
                                                
                                                .. attribute:: inv_basic_bag
                                                
                                                	Inventory Basic Bag
                                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag>`
                                                
                                                .. attribute:: inv_eeprom_info
                                                
                                                	Inventory EDM EEPROM Information Bag
                                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo>`
                                                
                                                .. attribute:: module_done
                                                
                                                	Inventory EDM Module Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**default value**\: 1
                                                
                                                .. attribute:: node_id
                                                
                                                	Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: pwg_info
                                                
                                                	Inventory EDM PWG info
                                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo>`
                                                
                                                .. attribute:: threshold
                                                
                                                	Threshold
                                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold>`
                                                
                                                .. attribute:: vm_done
                                                
                                                	VM Done Tuple
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                .. attribute:: vm_node_id
                                                
                                                	VM Node ID Tuple
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__init__()

                                                    self.yang_name = "attributes"
                                                    self.yang_parent_name = "tsi3"

                                                    self.module_done = YLeaf(YType.int32, "module-done")

                                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                    self._children_yang_names.add("env-sensor-info")

                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                    self._children_yang_names.add("env-sensor-info-xml")

                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                    self._children_yang_names.add("fru-info")

                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                    self._children_yang_names.add("inv-asset-bag")

                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                    self._children_yang_names.add("inv-basic-bag")

                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                    self._children_yang_names.add("inv-eeprom-info")

                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                    self._children_yang_names.add("pwg-info")

                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                    self._children_yang_names.add("threshold")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("module_done",
                                                                    "node_id",
                                                                    "vm_done",
                                                                    "vm_node_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes, self).__setattr__(name, value)


                                                class EnvSensorInfo(Entity):
                                                    """
                                                    Environment sensor info
                                                    
                                                    .. attribute:: age_time_stamp
                                                    
                                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: alarm_type
                                                    
                                                    	Indicates threshold violation
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: device_description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: device_id
                                                    
                                                    	Identifier for this device
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: field_validity_bitmap
                                                    
                                                    	Sensor valid bitmap
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: precision
                                                    
                                                    	Sensor precision range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: scale
                                                    
                                                    	Sensor scale enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state enums
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__init__()

                                                        self.yang_name = "env-sensor-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                                        self.device_description = YLeaf(YType.str, "device-description")

                                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                        self.precision = YLeaf(YType.uint32, "precision")

                                                        self.scale = YLeaf(YType.uint32, "scale")

                                                        self.status = YLeaf(YType.uint32, "status")

                                                        self.units = YLeaf(YType.str, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("age_time_stamp",
                                                                        "alarm_type",
                                                                        "data_type",
                                                                        "device_description",
                                                                        "device_id",
                                                                        "field_validity_bitmap",
                                                                        "precision",
                                                                        "scale",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.age_time_stamp.is_set or
                                                            self.alarm_type.is_set or
                                                            self.data_type.is_set or
                                                            self.device_description.is_set or
                                                            self.device_id.is_set or
                                                            self.field_validity_bitmap.is_set or
                                                            self.precision.is_set or
                                                            self.scale.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                                            self.alarm_type.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.device_description.yfilter != YFilter.not_set or
                                                            self.device_id.yfilter != YFilter.not_set or
                                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                            self.precision.yfilter != YFilter.not_set or
                                                            self.scale.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "age-time-stamp"):
                                                            self.age_time_stamp = value
                                                            self.age_time_stamp.value_namespace = name_space
                                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "alarm-type"):
                                                            self.alarm_type = value
                                                            self.alarm_type.value_namespace = name_space
                                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-description"):
                                                            self.device_description = value
                                                            self.device_description.value_namespace = name_space
                                                            self.device_description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "device-id"):
                                                            self.device_id = value
                                                            self.device_id.value_namespace = name_space
                                                            self.device_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "field-validity-bitmap"):
                                                            self.field_validity_bitmap = value
                                                            self.field_validity_bitmap.value_namespace = name_space
                                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "precision"):
                                                            self.precision = value
                                                            self.precision.value_namespace = name_space
                                                            self.precision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale"):
                                                            self.scale = value
                                                            self.scale.value_namespace = name_space
                                                            self.scale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PwgInfo(Entity):
                                                    """
                                                    Inventory EDM PWG info
                                                    
                                                    .. attribute:: power_group_available_current
                                                    
                                                    	available current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_drawn_current
                                                    
                                                    	drawn current
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_group_power_units
                                                    
                                                    	power units
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: power_group_redundancy_mode
                                                    
                                                    	redundancy mode
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__init__()

                                                        self.yang_name = "pwg-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("power_group_available_current",
                                                                        "power_group_drawn_current",
                                                                        "power_group_power_units",
                                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.power_group_available_current.is_set or
                                                            self.power_group_drawn_current.is_set or
                                                            self.power_group_power_units.is_set or
                                                            self.power_group_redundancy_mode.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pwg-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "power-group-available-current"):
                                                            self.power_group_available_current = value
                                                            self.power_group_available_current.value_namespace = name_space
                                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-drawn-current"):
                                                            self.power_group_drawn_current = value
                                                            self.power_group_drawn_current.value_namespace = name_space
                                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-power-units"):
                                                            self.power_group_power_units = value
                                                            self.power_group_power_units.value_namespace = name_space
                                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-group-redundancy-mode"):
                                                            self.power_group_redundancy_mode = value
                                                            self.power_group_redundancy_mode.value_namespace = name_space
                                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                                class EnvSensorInfoXml(Entity):
                                                    """
                                                    Environment sensor info XML
                                                    
                                                    .. attribute:: data_type
                                                    
                                                    	Sensor data type
                                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                                    
                                                    .. attribute:: description
                                                    
                                                    	Device Name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: status
                                                    
                                                    	Sensor operation state
                                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                                    
                                                    .. attribute:: threshold
                                                    
                                                    	Threshold information
                                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold>`
                                                    
                                                    .. attribute:: units
                                                    
                                                    	Units of variable being read
                                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                                    
                                                    .. attribute:: update_rate
                                                    
                                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__init__()

                                                        self.yang_name = "env-sensor-info-xml"
                                                        self.yang_parent_name = "attributes"

                                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.status = YLeaf(YType.enumeration, "status")

                                                        self.units = YLeaf(YType.enumeration, "units")

                                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                        self.value = YLeaf(YType.str, "value")

                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                        self._children_yang_names.add("threshold")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("data_type",
                                                                        "description",
                                                                        "status",
                                                                        "units",
                                                                        "update_rate",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                                    class Threshold(Entity):
                                                        """
                                                        Threshold information
                                                        
                                                        .. attribute:: threshold_array
                                                        
                                                        	Array of threshold
                                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                            self.yang_name = "threshold"
                                                            self.yang_parent_name = "env-sensor-info-xml"

                                                            self.threshold_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in () and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                        class ThresholdArray(Entity):
                                                            """
                                                            Array of threshold
                                                            
                                                            .. attribute:: threshold_name
                                                            
                                                            	Threshold name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..50
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** \-2147483648..2147483647
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                                self.yang_name = "threshold-array"
                                                                self.yang_parent_name = "threshold"

                                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_name",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_name.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "threshold-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-name"):
                                                                    self.threshold_name = value
                                                                    self.threshold_name.value_namespace = name_space
                                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return False

                                                        def has_operation(self):
                                                            for c in self.threshold_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return self.yfilter != YFilter.not_set

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "threshold-array"):
                                                                for c in self.threshold_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.threshold_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "threshold-array"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            self.data_type.is_set or
                                                            self.description.is_set or
                                                            self.status.is_set or
                                                            self.units.is_set or
                                                            self.update_rate.is_set or
                                                            self.value.is_set or
                                                            (self.threshold is not None and self.threshold.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.data_type.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.status.yfilter != YFilter.not_set or
                                                            self.units.yfilter != YFilter.not_set or
                                                            self.update_rate.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            (self.threshold is not None and self.threshold.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.status.get_name_leafdata())
                                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.units.get_name_leafdata())
                                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "threshold"):
                                                            if (self.threshold is None):
                                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml.Threshold()
                                                                self.threshold.parent = self
                                                                self._children_name_map["threshold"] = "threshold"
                                                            return self.threshold

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "data-type"):
                                                            self.data_type = value
                                                            self.data_type.value_namespace = name_space
                                                            self.data_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "status"):
                                                            self.status = value
                                                            self.status.value_namespace = name_space
                                                            self.status.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "units"):
                                                            self.units = value
                                                            self.units.value_namespace = name_space
                                                            self.units.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "update-rate"):
                                                            self.update_rate = value
                                                            self.update_rate.value_namespace = name_space
                                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class InvAssetBag(Entity):
                                                    """
                                                    Inventory Asset Bag
                                                    
                                                    .. attribute:: manufacturer_assembly_number
                                                    
                                                    	Manufacture Assembly number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_assembly_revision
                                                    
                                                    	Manufacture assembly revision
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                                    
                                                    	Common Language Equipment           Identifier number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_firmware_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: manufacturer_software_identifier
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: original_equipment_manufacturer_string
                                                    
                                                    	String containing OEM information           if applicable
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: part_number
                                                    
                                                    	
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__init__()

                                                        self.yang_name = "inv-asset-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                        self.part_number = YLeaf(YType.str, "part-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("manufacturer_assembly_number",
                                                                        "manufacturer_assembly_revision",
                                                                        "manufacturer_common_language_equipment_identifier",
                                                                        "manufacturer_firmware_identifier",
                                                                        "manufacturer_software_identifier",
                                                                        "original_equipment_manufacturer_string",
                                                                        "part_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.manufacturer_assembly_number.is_set or
                                                            self.manufacturer_assembly_revision.is_set or
                                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                                            self.manufacturer_firmware_identifier.is_set or
                                                            self.manufacturer_software_identifier.is_set or
                                                            self.original_equipment_manufacturer_string.is_set or
                                                            self.part_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                            self.part_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-asset-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "manufacturer-assembly-number"):
                                                            self.manufacturer_assembly_number = value
                                                            self.manufacturer_assembly_number.value_namespace = name_space
                                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-assembly-revision"):
                                                            self.manufacturer_assembly_revision = value
                                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                            self.manufacturer_common_language_equipment_identifier = value
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-firmware-identifier"):
                                                            self.manufacturer_firmware_identifier = value
                                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-software-identifier"):
                                                            self.manufacturer_software_identifier = value
                                                            self.manufacturer_software_identifier.value_namespace = name_space
                                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "original-equipment-manufacturer-string"):
                                                            self.original_equipment_manufacturer_string = value
                                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "part-number"):
                                                            self.part_number = value
                                                            self.part_number.value_namespace = name_space
                                                            self.part_number.value_namespace_prefix = name_space_prefix


                                                class Threshold(Entity):
                                                    """
                                                    Threshold
                                                    
                                                    .. attribute:: critical_hi
                                                    
                                                    	Critical High
                                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi>`
                                                    
                                                    .. attribute:: critical_lo
                                                    
                                                    	Critical Low
                                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo>`
                                                    
                                                    .. attribute:: major_hi
                                                    
                                                    	Major High
                                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi>`
                                                    
                                                    .. attribute:: major_lo
                                                    
                                                    	Major Low
                                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo>`
                                                    
                                                    .. attribute:: minor_hi
                                                    
                                                    	Minor High
                                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi>`
                                                    
                                                    .. attribute:: minor_lo
                                                    
                                                    	Minor Low
                                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold, self).__init__()

                                                        self.yang_name = "threshold"
                                                        self.yang_parent_name = "attributes"

                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                        self._children_yang_names.add("critical-hi")

                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                        self._children_yang_names.add("critical-lo")

                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                        self._children_yang_names.add("major-hi")

                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                        self._children_yang_names.add("major-lo")

                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                        self._children_yang_names.add("minor-hi")

                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                        self._children_yang_names.add("minor-lo")


                                                    class MajorLo(Entity):
                                                        """
                                                        Major Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo, self).__init__()

                                                            self.yang_name = "major-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalHi(Entity):
                                                        """
                                                        Critical High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi, self).__init__()

                                                            self.yang_name = "critical-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorHi(Entity):
                                                        """
                                                        Minor High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi, self).__init__()

                                                            self.yang_name = "minor-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MajorHi(Entity):
                                                        """
                                                        Major High
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi, self).__init__()

                                                            self.yang_name = "major-hi"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "major-hi"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "major-hi" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class CriticalLo(Entity):
                                                        """
                                                        Critical Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo, self).__init__()

                                                            self.yang_name = "critical-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "critical-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "critical-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class MinorLo(Entity):
                                                        """
                                                        Minor Low
                                                        
                                                        .. attribute:: thresh_bag
                                                        
                                                        	Environment threshold info
                                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo, self).__init__()

                                                            self.yang_name = "minor-lo"
                                                            self.yang_parent_name = "threshold"

                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                            self._children_yang_names.add("thresh-bag")


                                                        class ThreshBag(Entity):
                                                            """
                                                            Environment threshold info
                                                            
                                                            .. attribute:: threshold_evaluation
                                                            
                                                            	Indicates the result of the most recent evaluation of the thresholD
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_notification_enabled
                                                            
                                                            	Indicates whether or not a notification should result, in case of threshold violation
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: threshold_relation
                                                            
                                                            	Indicates relation between sensor value and threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_severity
                                                            
                                                            	Indicates minor, major, critical severities
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: threshold_value
                                                            
                                                            	Value of the configured threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                                self.yang_name = "thresh-bag"
                                                                self.yang_parent_name = "minor-lo"

                                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("threshold_evaluation",
                                                                                "threshold_notification_enabled",
                                                                                "threshold_relation",
                                                                                "threshold_severity",
                                                                                "threshold_value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.threshold_evaluation.is_set or
                                                                    self.threshold_notification_enabled.is_set or
                                                                    self.threshold_relation.is_set or
                                                                    self.threshold_severity.is_set or
                                                                    self.threshold_value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                                    self.threshold_value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "thresh-bag" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "threshold-evaluation"):
                                                                    self.threshold_evaluation = value
                                                                    self.threshold_evaluation.value_namespace = name_space
                                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-notification-enabled"):
                                                                    self.threshold_notification_enabled = value
                                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-relation"):
                                                                    self.threshold_relation = value
                                                                    self.threshold_relation.value_namespace = name_space
                                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-severity"):
                                                                    self.threshold_severity = value
                                                                    self.threshold_severity.value_namespace = name_space
                                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "threshold-value"):
                                                                    self.threshold_value = value
                                                                    self.threshold_value.value_namespace = name_space
                                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minor-lo" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "thresh-bag"):
                                                                if (self.thresh_bag is None):
                                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo.ThreshBag()
                                                                    self.thresh_bag.parent = self
                                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                                return self.thresh_bag

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "thresh-bag"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass

                                                    def has_data(self):
                                                        return (
                                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "critical-hi"):
                                                            if (self.critical_hi is None):
                                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalHi()
                                                                self.critical_hi.parent = self
                                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                            return self.critical_hi

                                                        if (child_yang_name == "critical-lo"):
                                                            if (self.critical_lo is None):
                                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.CriticalLo()
                                                                self.critical_lo.parent = self
                                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                            return self.critical_lo

                                                        if (child_yang_name == "major-hi"):
                                                            if (self.major_hi is None):
                                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorHi()
                                                                self.major_hi.parent = self
                                                                self._children_name_map["major_hi"] = "major-hi"
                                                            return self.major_hi

                                                        if (child_yang_name == "major-lo"):
                                                            if (self.major_lo is None):
                                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MajorLo()
                                                                self.major_lo.parent = self
                                                                self._children_name_map["major_lo"] = "major-lo"
                                                            return self.major_lo

                                                        if (child_yang_name == "minor-hi"):
                                                            if (self.minor_hi is None):
                                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorHi()
                                                                self.minor_hi.parent = self
                                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                            return self.minor_hi

                                                        if (child_yang_name == "minor-lo"):
                                                            if (self.minor_lo is None):
                                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold.MinorLo()
                                                                self.minor_lo.parent = self
                                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                            return self.minor_lo

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class FruInfo(Entity):
                                                    """
                                                    Inventory EDM FRU info
                                                    
                                                    .. attribute:: card_administrative_state
                                                    
                                                    	card admin state\: shutdown or not
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_monitor_state
                                                    
                                                    	card is monitored by a manager or left unmonitored
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_operational_state
                                                    
                                                    	card operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: card_reset_reason
                                                    
                                                    	card reset reason enum
                                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                                    
                                                    .. attribute:: card_up_time
                                                    
                                                    	card up time
                                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime>`
                                                    
                                                    .. attribute:: last_operational_state_change
                                                    
                                                    	last card oper change state
                                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange>`
                                                    
                                                    .. attribute:: power_administrative_state
                                                    
                                                    	power admin state\: up or down
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_current_measurement
                                                    
                                                    	power current\: not implemented
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: power_operational_state
                                                    
                                                    	Power operation state
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__init__()

                                                        self.yang_name = "fru-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                        self._children_yang_names.add("card-up-time")

                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                        self._children_yang_names.add("last-operational-state-change")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("card_administrative_state",
                                                                        "card_monitor_state",
                                                                        "card_operational_state",
                                                                        "card_reset_reason",
                                                                        "power_administrative_state",
                                                                        "power_current_measurement",
                                                                        "power_operational_state") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo, self).__setattr__(name, value)


                                                    class LastOperationalStateChange(Entity):
                                                        """
                                                        last card oper change state
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                            self.yang_name = "last-operational-state-change"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "last-operational-state-change" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                                    class CardUpTime(Entity):
                                                        """
                                                        card up time
                                                        
                                                        .. attribute:: time_in_nano_seconds
                                                        
                                                        	Time Value in Nano\-seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: nanosecond
                                                        
                                                        .. attribute:: time_in_seconds
                                                        
                                                        	Time Value in Seconds
                                                        	**type**\:  int
                                                        
                                                        	**range:** \-2147483648..2147483647
                                                        
                                                        	**units**\: second
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__init__()

                                                            self.yang_name = "card-up-time"
                                                            self.yang_parent_name = "fru-info"

                                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("time_in_nano_seconds",
                                                                            "time_in_seconds") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.time_in_nano_seconds.is_set or
                                                                self.time_in_seconds.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "card-up-time" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "time-in-nano-seconds"):
                                                                self.time_in_nano_seconds = value
                                                                self.time_in_nano_seconds.value_namespace = name_space
                                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "time-in-seconds"):
                                                                self.time_in_seconds = value
                                                                self.time_in_seconds.value_namespace = name_space
                                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.card_administrative_state.is_set or
                                                            self.card_monitor_state.is_set or
                                                            self.card_operational_state.is_set or
                                                            self.card_reset_reason.is_set or
                                                            self.power_administrative_state.is_set or
                                                            self.power_current_measurement.is_set or
                                                            self.power_operational_state.is_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                                            self.card_operational_state.yfilter != YFilter.not_set or
                                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                                            self.power_operational_state.yfilter != YFilter.not_set or
                                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fru-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "card-up-time"):
                                                            if (self.card_up_time is None):
                                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.CardUpTime()
                                                                self.card_up_time.parent = self
                                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                            return self.card_up_time

                                                        if (child_yang_name == "last-operational-state-change"):
                                                            if (self.last_operational_state_change is None):
                                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo.LastOperationalStateChange()
                                                                self.last_operational_state_change.parent = self
                                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                            return self.last_operational_state_change

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "card-administrative-state"):
                                                            self.card_administrative_state = value
                                                            self.card_administrative_state.value_namespace = name_space
                                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-monitor-state"):
                                                            self.card_monitor_state = value
                                                            self.card_monitor_state.value_namespace = name_space
                                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-operational-state"):
                                                            self.card_operational_state = value
                                                            self.card_operational_state.value_namespace = name_space
                                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "card-reset-reason"):
                                                            self.card_reset_reason = value
                                                            self.card_reset_reason.value_namespace = name_space
                                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-administrative-state"):
                                                            self.power_administrative_state = value
                                                            self.power_administrative_state.value_namespace = name_space
                                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-current-measurement"):
                                                            self.power_current_measurement = value
                                                            self.power_current_measurement.value_namespace = name_space
                                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "power-operational-state"):
                                                            self.power_operational_state = value
                                                            self.power_operational_state.value_namespace = name_space
                                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                                class InvBasicBag(Entity):
                                                    """
                                                    Inventory Basic Bag
                                                    
                                                    .. attribute:: alias
                                                    
                                                    	useful for storing an entity alias 
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_id_str
                                                    
                                                    	asset Identification string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: asset_identification
                                                    
                                                    	asset Identification
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: ceport
                                                    
                                                    	1 if ce port found, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: chip_hardware_revision
                                                    
                                                    	chip module hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: composite_class_code
                                                    
                                                    	Major&minor class of the entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: description
                                                    
                                                    	describes in user\-readable terms       what the entity in question does
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: environmental_monitor_path
                                                    
                                                    	sysdb name of sensor in the envmon EDM
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: firmware_revision
                                                    
                                                    	firmware revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: group_flag
                                                    
                                                    	indicates if this entity is group       or not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: hardware_revision
                                                    
                                                    	hw revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: is_field_replaceable_unit
                                                    
                                                    	1 if Field Replaceable Unit 0, if not
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: manufacturer_asset_tags
                                                    
                                                    	Manufacture Asset Tags
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: manufacturer_name
                                                    
                                                    	manufacturer's name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: memory_size
                                                    
                                                    	Size of memory associated with       the entity where applicable
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: model_name
                                                    
                                                    	model name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name string for the entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: new_deviation_number
                                                    
                                                    	integer value for New Deviation Number 0x88
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: physical_layer_interface_module_type
                                                    
                                                    	integer value for plim type if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: redundancystate
                                                    
                                                    	integer value for Redundancy State if     applicable to this entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: serial_number
                                                    
                                                    	serial number
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: software_revision
                                                    
                                                    	software revision string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: unique_id
                                                    
                                                    	Unique id for an entity
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    .. attribute:: unrecognized_fru
                                                    
                                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: vendor_type
                                                    
                                                    	maps to the vendor OID string
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: xr_scoped
                                                    
                                                    	1 if xr scoped, 0 if not
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__init__()

                                                        self.yang_name = "inv-basic-bag"
                                                        self.yang_parent_name = "attributes"

                                                        self.alias = YLeaf(YType.str, "alias")

                                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                                        self.model_name = YLeaf(YType.str, "model-name")

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("alias",
                                                                        "asset_id_str",
                                                                        "asset_identification",
                                                                        "ceport",
                                                                        "chip_hardware_revision",
                                                                        "composite_class_code",
                                                                        "description",
                                                                        "environmental_monitor_path",
                                                                        "firmware_revision",
                                                                        "group_flag",
                                                                        "hardware_revision",
                                                                        "is_field_replaceable_unit",
                                                                        "manufacturer_asset_tags",
                                                                        "manufacturer_name",
                                                                        "memory_size",
                                                                        "model_name",
                                                                        "name",
                                                                        "new_deviation_number",
                                                                        "physical_layer_interface_module_type",
                                                                        "redundancystate",
                                                                        "serial_number",
                                                                        "software_revision",
                                                                        "unique_id",
                                                                        "unrecognized_fru",
                                                                        "vendor_type",
                                                                        "xr_scoped") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.alias.is_set or
                                                            self.asset_id_str.is_set or
                                                            self.asset_identification.is_set or
                                                            self.ceport.is_set or
                                                            self.chip_hardware_revision.is_set or
                                                            self.composite_class_code.is_set or
                                                            self.description.is_set or
                                                            self.environmental_monitor_path.is_set or
                                                            self.firmware_revision.is_set or
                                                            self.group_flag.is_set or
                                                            self.hardware_revision.is_set or
                                                            self.is_field_replaceable_unit.is_set or
                                                            self.manufacturer_asset_tags.is_set or
                                                            self.manufacturer_name.is_set or
                                                            self.memory_size.is_set or
                                                            self.model_name.is_set or
                                                            self.name.is_set or
                                                            self.new_deviation_number.is_set or
                                                            self.physical_layer_interface_module_type.is_set or
                                                            self.redundancystate.is_set or
                                                            self.serial_number.is_set or
                                                            self.software_revision.is_set or
                                                            self.unique_id.is_set or
                                                            self.unrecognized_fru.is_set or
                                                            self.vendor_type.is_set or
                                                            self.xr_scoped.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.alias.yfilter != YFilter.not_set or
                                                            self.asset_id_str.yfilter != YFilter.not_set or
                                                            self.asset_identification.yfilter != YFilter.not_set or
                                                            self.ceport.yfilter != YFilter.not_set or
                                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                            self.composite_class_code.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                            self.firmware_revision.yfilter != YFilter.not_set or
                                                            self.group_flag.yfilter != YFilter.not_set or
                                                            self.hardware_revision.yfilter != YFilter.not_set or
                                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                                            self.memory_size.yfilter != YFilter.not_set or
                                                            self.model_name.yfilter != YFilter.not_set or
                                                            self.name.yfilter != YFilter.not_set or
                                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                            self.redundancystate.yfilter != YFilter.not_set or
                                                            self.serial_number.yfilter != YFilter.not_set or
                                                            self.software_revision.yfilter != YFilter.not_set or
                                                            self.unique_id.yfilter != YFilter.not_set or
                                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                                            self.vendor_type.yfilter != YFilter.not_set or
                                                            self.xr_scoped.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-basic-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.name.get_name_leafdata())
                                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "alias"):
                                                            self.alias = value
                                                            self.alias.value_namespace = name_space
                                                            self.alias.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-id-str"):
                                                            self.asset_id_str = value
                                                            self.asset_id_str.value_namespace = name_space
                                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "asset-identification"):
                                                            self.asset_identification = value
                                                            self.asset_identification.value_namespace = name_space
                                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ceport"):
                                                            self.ceport = value
                                                            self.ceport.value_namespace = name_space
                                                            self.ceport.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "chip-hardware-revision"):
                                                            self.chip_hardware_revision = value
                                                            self.chip_hardware_revision.value_namespace = name_space
                                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "composite-class-code"):
                                                            self.composite_class_code = value
                                                            self.composite_class_code.value_namespace = name_space
                                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "environmental-monitor-path"):
                                                            self.environmental_monitor_path = value
                                                            self.environmental_monitor_path.value_namespace = name_space
                                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "firmware-revision"):
                                                            self.firmware_revision = value
                                                            self.firmware_revision.value_namespace = name_space
                                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "group-flag"):
                                                            self.group_flag = value
                                                            self.group_flag.value_namespace = name_space
                                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "hardware-revision"):
                                                            self.hardware_revision = value
                                                            self.hardware_revision.value_namespace = name_space
                                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-field-replaceable-unit"):
                                                            self.is_field_replaceable_unit = value
                                                            self.is_field_replaceable_unit.value_namespace = name_space
                                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-asset-tags"):
                                                            self.manufacturer_asset_tags = value
                                                            self.manufacturer_asset_tags.value_namespace = name_space
                                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "manufacturer-name"):
                                                            self.manufacturer_name = value
                                                            self.manufacturer_name.value_namespace = name_space
                                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "memory-size"):
                                                            self.memory_size = value
                                                            self.memory_size.value_namespace = name_space
                                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "model-name"):
                                                            self.model_name = value
                                                            self.model_name.value_namespace = name_space
                                                            self.model_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "name"):
                                                            self.name = value
                                                            self.name.value_namespace = name_space
                                                            self.name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "new-deviation-number"):
                                                            self.new_deviation_number = value
                                                            self.new_deviation_number.value_namespace = name_space
                                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "physical-layer-interface-module-type"):
                                                            self.physical_layer_interface_module_type = value
                                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "redundancystate"):
                                                            self.redundancystate = value
                                                            self.redundancystate.value_namespace = name_space
                                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "serial-number"):
                                                            self.serial_number = value
                                                            self.serial_number.value_namespace = name_space
                                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "software-revision"):
                                                            self.software_revision = value
                                                            self.software_revision.value_namespace = name_space
                                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unique-id"):
                                                            self.unique_id = value
                                                            self.unique_id.value_namespace = name_space
                                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "unrecognized-fru"):
                                                            self.unrecognized_fru = value
                                                            self.unrecognized_fru.value_namespace = name_space
                                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "vendor-type"):
                                                            self.vendor_type = value
                                                            self.vendor_type.value_namespace = name_space
                                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "xr-scoped"):
                                                            self.xr_scoped = value
                                                            self.xr_scoped.value_namespace = name_space
                                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                                class InvEepromInfo(Entity):
                                                    """
                                                    Inventory EDM EEPROM Information Bag
                                                    
                                                    .. attribute:: description
                                                    
                                                    	A textual description of physical entity
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: eeprom
                                                    
                                                    	EEPROM data not from hex data
                                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom>`
                                                    
                                                    .. attribute:: has_eeprom
                                                    
                                                    	use eeprom instead of opaque data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: inv_card_type
                                                    
                                                    	Inventory card type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: opaque_data
                                                    
                                                    	EEPROM hex data
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    .. attribute:: opaque_data_size
                                                    
                                                    	size of the EEPROM hex data
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__init__()

                                                        self.yang_name = "inv-eeprom-info"
                                                        self.yang_parent_name = "attributes"

                                                        self.description = YLeaf(YType.str, "description")

                                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                        self._children_yang_names.add("eeprom")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("description",
                                                                        "has_eeprom",
                                                                        "inv_card_type",
                                                                        "opaque_data",
                                                                        "opaque_data_size") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                                    class Eeprom(Entity):
                                                        """
                                                        EEPROM data not from hex data
                                                        
                                                        .. attribute:: asset_alias
                                                        
                                                        	Asset Alias
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: asset_id
                                                        
                                                        	Asset ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address1
                                                        
                                                        	Base Mac Address #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address2
                                                        
                                                        	Base Mac Address #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address3
                                                        
                                                        	Base Mac Address #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: base_mac_address4
                                                        
                                                        	Base Mac Address #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_checksum
                                                        
                                                        	Block Checksum
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_count
                                                        
                                                        	Block Count
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_length
                                                        
                                                        	Block Length
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_signature
                                                        
                                                        	Block Signature
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: block_version
                                                        
                                                        	Block Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: chassis_sid
                                                        
                                                        	Chassis serial number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: clei
                                                        
                                                        	Common Language Equipment Identifier (CLEI) code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_family
                                                        
                                                        	Controller family
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: controller_type
                                                        
                                                        	Controller type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: description
                                                        
                                                        	A textual description of physical entity
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num1
                                                        
                                                        	Deviation Number # 1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num2
                                                        
                                                        	Deviation Number # 2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num3
                                                        
                                                        	Deviation Number # 3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num4
                                                        
                                                        	Deviation Number # 4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num5
                                                        
                                                        	Deviation Number # 5
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num6
                                                        
                                                        	Deviation Number # 6
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: dev_num7
                                                        
                                                        	Deviation Number # 7
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eci
                                                        
                                                        	Equipment Catalog Item (ECI) number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: eeprom_size
                                                        
                                                        	EEPROM Size
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: engineer_use
                                                        
                                                        	Engineer Use
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_major_type
                                                        
                                                        	FRU Major Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: fru_minor_type
                                                        
                                                        	FRU Minor Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hw_version
                                                        
                                                        	Hardware Version
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: hwid
                                                        
                                                        	Hardware Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: idprom_format_rev
                                                        
                                                        	IDPROM Format Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size1
                                                        
                                                        	Mac Address Block Size #1
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size2
                                                        
                                                        	Mac Address Block Size #2
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size3
                                                        
                                                        	Mac Address Block Size #3
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mac_add_blk_size4
                                                        
                                                        	Mac Address Block Size #4
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: manu_test_data
                                                        
                                                        	Manufacturing Test Data
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_bits
                                                        
                                                        	MFG Bits
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: mfg_deviation
                                                        
                                                        	MFG Deviation
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: oem_string
                                                        
                                                        	OEM String
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_number
                                                        
                                                        	Part Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: part_revision
                                                        
                                                        	Part Revision
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pca_num
                                                        
                                                        	PCA number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcavid
                                                        
                                                        	PCA revision ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pcb_serial_num
                                                        
                                                        	PCB Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: pid
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_consumption
                                                        
                                                        	Power Consumption
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: power_supply_type
                                                        
                                                        	Power Supply Type
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: product_id
                                                        
                                                        	Product ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: rma
                                                        
                                                        	RMA Data
                                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                        
                                                        .. attribute:: rma_code
                                                        
                                                        	RMA Code
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: serial_number
                                                        
                                                        	Serial Number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: snmpoid
                                                        
                                                        	SNMP OID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_part_num
                                                        
                                                        	Top assembly part number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: top_assem_vid
                                                        
                                                        	Top assembly revision number
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_description
                                                        
                                                        	UDI description
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: udi_name
                                                        
                                                        	UDI name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        .. attribute:: vid
                                                        
                                                        	Version ID
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'invmgr-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                            self.yang_name = "eeprom"
                                                            self.yang_parent_name = "inv-eeprom-info"

                                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                            self.block_count = YLeaf(YType.str, "block-count")

                                                            self.block_length = YLeaf(YType.str, "block-length")

                                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                                            self.block_version = YLeaf(YType.str, "block-version")

                                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                            self.clei = YLeaf(YType.str, "clei")

                                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                                            self.description = YLeaf(YType.str, "description")

                                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                            self.eci = YLeaf(YType.str, "eci")

                                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                                            self.hwid = YLeaf(YType.str, "hwid")

                                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                                            self.part_number = YLeaf(YType.str, "part-number")

                                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                            self.pid = YLeaf(YType.str, "pid")

                                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                            self.product_id = YLeaf(YType.str, "product-id")

                                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                                            self.vid = YLeaf(YType.str, "vid")

                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                            self._children_yang_names.add("rma")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("asset_alias",
                                                                            "asset_id",
                                                                            "base_mac_address1",
                                                                            "base_mac_address2",
                                                                            "base_mac_address3",
                                                                            "base_mac_address4",
                                                                            "block_checksum",
                                                                            "block_count",
                                                                            "block_length",
                                                                            "block_signature",
                                                                            "block_version",
                                                                            "chassis_sid",
                                                                            "clei",
                                                                            "controller_family",
                                                                            "controller_type",
                                                                            "description",
                                                                            "dev_num1",
                                                                            "dev_num2",
                                                                            "dev_num3",
                                                                            "dev_num4",
                                                                            "dev_num5",
                                                                            "dev_num6",
                                                                            "dev_num7",
                                                                            "eci",
                                                                            "eeprom_size",
                                                                            "engineer_use",
                                                                            "fru_major_type",
                                                                            "fru_minor_type",
                                                                            "hw_version",
                                                                            "hwid",
                                                                            "idprom_format_rev",
                                                                            "mac_add_blk_size1",
                                                                            "mac_add_blk_size2",
                                                                            "mac_add_blk_size3",
                                                                            "mac_add_blk_size4",
                                                                            "manu_test_data",
                                                                            "mfg_bits",
                                                                            "mfg_deviation",
                                                                            "oem_string",
                                                                            "part_number",
                                                                            "part_revision",
                                                                            "pca_num",
                                                                            "pcavid",
                                                                            "pcb_serial_num",
                                                                            "pid",
                                                                            "power_consumption",
                                                                            "power_supply_type",
                                                                            "product_id",
                                                                            "rma_code",
                                                                            "serial_number",
                                                                            "snmpoid",
                                                                            "top_assem_part_num",
                                                                            "top_assem_vid",
                                                                            "udi_description",
                                                                            "udi_name",
                                                                            "vid") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                        class Rma(Entity):
                                                            """
                                                            RMA Data
                                                            
                                                            .. attribute:: rma_history
                                                            
                                                            	RMA history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: rma_number
                                                            
                                                            	RMA tracking number format is N\-N\-N
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            .. attribute:: test_history
                                                            
                                                            	Test history
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'invmgr-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                                self.yang_name = "rma"
                                                                self.yang_parent_name = "eeprom"

                                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                                self.test_history = YLeaf(YType.str, "test-history")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("rma_history",
                                                                                "rma_number",
                                                                                "test_history") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.rma_history.is_set or
                                                                    self.rma_number.is_set or
                                                                    self.test_history.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.rma_history.yfilter != YFilter.not_set or
                                                                    self.rma_number.yfilter != YFilter.not_set or
                                                                    self.test_history.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "rma" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "rma-history"):
                                                                    self.rma_history = value
                                                                    self.rma_history.value_namespace = name_space
                                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "rma-number"):
                                                                    self.rma_number = value
                                                                    self.rma_number.value_namespace = name_space
                                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "test-history"):
                                                                    self.test_history = value
                                                                    self.test_history.value_namespace = name_space
                                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.asset_alias.is_set or
                                                                self.asset_id.is_set or
                                                                self.base_mac_address1.is_set or
                                                                self.base_mac_address2.is_set or
                                                                self.base_mac_address3.is_set or
                                                                self.base_mac_address4.is_set or
                                                                self.block_checksum.is_set or
                                                                self.block_count.is_set or
                                                                self.block_length.is_set or
                                                                self.block_signature.is_set or
                                                                self.block_version.is_set or
                                                                self.chassis_sid.is_set or
                                                                self.clei.is_set or
                                                                self.controller_family.is_set or
                                                                self.controller_type.is_set or
                                                                self.description.is_set or
                                                                self.dev_num1.is_set or
                                                                self.dev_num2.is_set or
                                                                self.dev_num3.is_set or
                                                                self.dev_num4.is_set or
                                                                self.dev_num5.is_set or
                                                                self.dev_num6.is_set or
                                                                self.dev_num7.is_set or
                                                                self.eci.is_set or
                                                                self.eeprom_size.is_set or
                                                                self.engineer_use.is_set or
                                                                self.fru_major_type.is_set or
                                                                self.fru_minor_type.is_set or
                                                                self.hw_version.is_set or
                                                                self.hwid.is_set or
                                                                self.idprom_format_rev.is_set or
                                                                self.mac_add_blk_size1.is_set or
                                                                self.mac_add_blk_size2.is_set or
                                                                self.mac_add_blk_size3.is_set or
                                                                self.mac_add_blk_size4.is_set or
                                                                self.manu_test_data.is_set or
                                                                self.mfg_bits.is_set or
                                                                self.mfg_deviation.is_set or
                                                                self.oem_string.is_set or
                                                                self.part_number.is_set or
                                                                self.part_revision.is_set or
                                                                self.pca_num.is_set or
                                                                self.pcavid.is_set or
                                                                self.pcb_serial_num.is_set or
                                                                self.pid.is_set or
                                                                self.power_consumption.is_set or
                                                                self.power_supply_type.is_set or
                                                                self.product_id.is_set or
                                                                self.rma_code.is_set or
                                                                self.serial_number.is_set or
                                                                self.snmpoid.is_set or
                                                                self.top_assem_part_num.is_set or
                                                                self.top_assem_vid.is_set or
                                                                self.udi_description.is_set or
                                                                self.udi_name.is_set or
                                                                self.vid.is_set or
                                                                (self.rma is not None and self.rma.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.asset_alias.yfilter != YFilter.not_set or
                                                                self.asset_id.yfilter != YFilter.not_set or
                                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                                self.block_checksum.yfilter != YFilter.not_set or
                                                                self.block_count.yfilter != YFilter.not_set or
                                                                self.block_length.yfilter != YFilter.not_set or
                                                                self.block_signature.yfilter != YFilter.not_set or
                                                                self.block_version.yfilter != YFilter.not_set or
                                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                                self.clei.yfilter != YFilter.not_set or
                                                                self.controller_family.yfilter != YFilter.not_set or
                                                                self.controller_type.yfilter != YFilter.not_set or
                                                                self.description.yfilter != YFilter.not_set or
                                                                self.dev_num1.yfilter != YFilter.not_set or
                                                                self.dev_num2.yfilter != YFilter.not_set or
                                                                self.dev_num3.yfilter != YFilter.not_set or
                                                                self.dev_num4.yfilter != YFilter.not_set or
                                                                self.dev_num5.yfilter != YFilter.not_set or
                                                                self.dev_num6.yfilter != YFilter.not_set or
                                                                self.dev_num7.yfilter != YFilter.not_set or
                                                                self.eci.yfilter != YFilter.not_set or
                                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                                self.engineer_use.yfilter != YFilter.not_set or
                                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                                self.hw_version.yfilter != YFilter.not_set or
                                                                self.hwid.yfilter != YFilter.not_set or
                                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                                self.oem_string.yfilter != YFilter.not_set or
                                                                self.part_number.yfilter != YFilter.not_set or
                                                                self.part_revision.yfilter != YFilter.not_set or
                                                                self.pca_num.yfilter != YFilter.not_set or
                                                                self.pcavid.yfilter != YFilter.not_set or
                                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                                self.pid.yfilter != YFilter.not_set or
                                                                self.power_consumption.yfilter != YFilter.not_set or
                                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                                self.product_id.yfilter != YFilter.not_set or
                                                                self.rma_code.yfilter != YFilter.not_set or
                                                                self.serial_number.yfilter != YFilter.not_set or
                                                                self.snmpoid.yfilter != YFilter.not_set or
                                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                                self.udi_description.yfilter != YFilter.not_set or
                                                                self.udi_name.yfilter != YFilter.not_set or
                                                                self.vid.yfilter != YFilter.not_set or
                                                                (self.rma is not None and self.rma.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "eeprom" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.description.get_name_leafdata())
                                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "rma"):
                                                                if (self.rma is None):
                                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom.Rma()
                                                                    self.rma.parent = self
                                                                    self._children_name_map["rma"] = "rma"
                                                                return self.rma

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "asset-alias"):
                                                                self.asset_alias = value
                                                                self.asset_alias.value_namespace = name_space
                                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "asset-id"):
                                                                self.asset_id = value
                                                                self.asset_id.value_namespace = name_space
                                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address1"):
                                                                self.base_mac_address1 = value
                                                                self.base_mac_address1.value_namespace = name_space
                                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address2"):
                                                                self.base_mac_address2 = value
                                                                self.base_mac_address2.value_namespace = name_space
                                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address3"):
                                                                self.base_mac_address3 = value
                                                                self.base_mac_address3.value_namespace = name_space
                                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "base-mac-address4"):
                                                                self.base_mac_address4 = value
                                                                self.base_mac_address4.value_namespace = name_space
                                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-checksum"):
                                                                self.block_checksum = value
                                                                self.block_checksum.value_namespace = name_space
                                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-count"):
                                                                self.block_count = value
                                                                self.block_count.value_namespace = name_space
                                                                self.block_count.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-length"):
                                                                self.block_length = value
                                                                self.block_length.value_namespace = name_space
                                                                self.block_length.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-signature"):
                                                                self.block_signature = value
                                                                self.block_signature.value_namespace = name_space
                                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "block-version"):
                                                                self.block_version = value
                                                                self.block_version.value_namespace = name_space
                                                                self.block_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "chassis-sid"):
                                                                self.chassis_sid = value
                                                                self.chassis_sid.value_namespace = name_space
                                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "clei"):
                                                                self.clei = value
                                                                self.clei.value_namespace = name_space
                                                                self.clei.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-family"):
                                                                self.controller_family = value
                                                                self.controller_family.value_namespace = name_space
                                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "controller-type"):
                                                                self.controller_type = value
                                                                self.controller_type.value_namespace = name_space
                                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "description"):
                                                                self.description = value
                                                                self.description.value_namespace = name_space
                                                                self.description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num1"):
                                                                self.dev_num1 = value
                                                                self.dev_num1.value_namespace = name_space
                                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num2"):
                                                                self.dev_num2 = value
                                                                self.dev_num2.value_namespace = name_space
                                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num3"):
                                                                self.dev_num3 = value
                                                                self.dev_num3.value_namespace = name_space
                                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num4"):
                                                                self.dev_num4 = value
                                                                self.dev_num4.value_namespace = name_space
                                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num5"):
                                                                self.dev_num5 = value
                                                                self.dev_num5.value_namespace = name_space
                                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num6"):
                                                                self.dev_num6 = value
                                                                self.dev_num6.value_namespace = name_space
                                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "dev-num7"):
                                                                self.dev_num7 = value
                                                                self.dev_num7.value_namespace = name_space
                                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eci"):
                                                                self.eci = value
                                                                self.eci.value_namespace = name_space
                                                                self.eci.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "eeprom-size"):
                                                                self.eeprom_size = value
                                                                self.eeprom_size.value_namespace = name_space
                                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "engineer-use"):
                                                                self.engineer_use = value
                                                                self.engineer_use.value_namespace = name_space
                                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-major-type"):
                                                                self.fru_major_type = value
                                                                self.fru_major_type.value_namespace = name_space
                                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fru-minor-type"):
                                                                self.fru_minor_type = value
                                                                self.fru_minor_type.value_namespace = name_space
                                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hw-version"):
                                                                self.hw_version = value
                                                                self.hw_version.value_namespace = name_space
                                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "hwid"):
                                                                self.hwid = value
                                                                self.hwid.value_namespace = name_space
                                                                self.hwid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "idprom-format-rev"):
                                                                self.idprom_format_rev = value
                                                                self.idprom_format_rev.value_namespace = name_space
                                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size1"):
                                                                self.mac_add_blk_size1 = value
                                                                self.mac_add_blk_size1.value_namespace = name_space
                                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size2"):
                                                                self.mac_add_blk_size2 = value
                                                                self.mac_add_blk_size2.value_namespace = name_space
                                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size3"):
                                                                self.mac_add_blk_size3 = value
                                                                self.mac_add_blk_size3.value_namespace = name_space
                                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mac-add-blk-size4"):
                                                                self.mac_add_blk_size4 = value
                                                                self.mac_add_blk_size4.value_namespace = name_space
                                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "manu-test-data"):
                                                                self.manu_test_data = value
                                                                self.manu_test_data.value_namespace = name_space
                                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-bits"):
                                                                self.mfg_bits = value
                                                                self.mfg_bits.value_namespace = name_space
                                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mfg-deviation"):
                                                                self.mfg_deviation = value
                                                                self.mfg_deviation.value_namespace = name_space
                                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "oem-string"):
                                                                self.oem_string = value
                                                                self.oem_string.value_namespace = name_space
                                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-number"):
                                                                self.part_number = value
                                                                self.part_number.value_namespace = name_space
                                                                self.part_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "part-revision"):
                                                                self.part_revision = value
                                                                self.part_revision.value_namespace = name_space
                                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pca-num"):
                                                                self.pca_num = value
                                                                self.pca_num.value_namespace = name_space
                                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcavid"):
                                                                self.pcavid = value
                                                                self.pcavid.value_namespace = name_space
                                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pcb-serial-num"):
                                                                self.pcb_serial_num = value
                                                                self.pcb_serial_num.value_namespace = name_space
                                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pid"):
                                                                self.pid = value
                                                                self.pid.value_namespace = name_space
                                                                self.pid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-consumption"):
                                                                self.power_consumption = value
                                                                self.power_consumption.value_namespace = name_space
                                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "power-supply-type"):
                                                                self.power_supply_type = value
                                                                self.power_supply_type.value_namespace = name_space
                                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "product-id"):
                                                                self.product_id = value
                                                                self.product_id.value_namespace = name_space
                                                                self.product_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "rma-code"):
                                                                self.rma_code = value
                                                                self.rma_code.value_namespace = name_space
                                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "serial-number"):
                                                                self.serial_number = value
                                                                self.serial_number.value_namespace = name_space
                                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "snmpoid"):
                                                                self.snmpoid = value
                                                                self.snmpoid.value_namespace = name_space
                                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-part-num"):
                                                                self.top_assem_part_num = value
                                                                self.top_assem_part_num.value_namespace = name_space
                                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "top-assem-vid"):
                                                                self.top_assem_vid = value
                                                                self.top_assem_vid.value_namespace = name_space
                                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-description"):
                                                                self.udi_description = value
                                                                self.udi_description.value_namespace = name_space
                                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "udi-name"):
                                                                self.udi_name = value
                                                                self.udi_name.value_namespace = name_space
                                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "vid"):
                                                                self.vid = value
                                                                self.vid.value_namespace = name_space
                                                                self.vid.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.description.is_set or
                                                            self.has_eeprom.is_set or
                                                            self.inv_card_type.is_set or
                                                            self.opaque_data.is_set or
                                                            self.opaque_data_size.is_set or
                                                            (self.eeprom is not None and self.eeprom.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.description.yfilter != YFilter.not_set or
                                                            self.has_eeprom.yfilter != YFilter.not_set or
                                                            self.inv_card_type.yfilter != YFilter.not_set or
                                                            self.opaque_data.yfilter != YFilter.not_set or
                                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "inv-eeprom-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.description.get_name_leafdata())
                                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "eeprom"):
                                                            if (self.eeprom is None):
                                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo.Eeprom()
                                                                self.eeprom.parent = self
                                                                self._children_name_map["eeprom"] = "eeprom"
                                                            return self.eeprom

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "description"):
                                                            self.description = value
                                                            self.description.value_namespace = name_space
                                                            self.description.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "has-eeprom"):
                                                            self.has_eeprom = value
                                                            self.has_eeprom.value_namespace = name_space
                                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "inv-card-type"):
                                                            self.inv_card_type = value
                                                            self.inv_card_type.value_namespace = name_space
                                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data"):
                                                            self.opaque_data = value
                                                            self.opaque_data.value_namespace = name_space
                                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "opaque-data-size"):
                                                            self.opaque_data_size = value
                                                            self.opaque_data_size.value_namespace = name_space
                                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.module_done.is_set or
                                                        self.node_id.is_set or
                                                        self.vm_done.is_set or
                                                        self.vm_node_id.is_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                        (self.threshold is not None and self.threshold.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.module_done.yfilter != YFilter.not_set or
                                                        self.node_id.yfilter != YFilter.not_set or
                                                        self.vm_done.yfilter != YFilter.not_set or
                                                        self.vm_node_id.yfilter != YFilter.not_set or
                                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                        (self.threshold is not None and self.threshold.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "attributes" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "env-sensor-info"):
                                                        if (self.env_sensor_info is None):
                                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfo()
                                                            self.env_sensor_info.parent = self
                                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                        return self.env_sensor_info

                                                    if (child_yang_name == "env-sensor-info-xml"):
                                                        if (self.env_sensor_info_xml is None):
                                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.EnvSensorInfoXml()
                                                            self.env_sensor_info_xml.parent = self
                                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                        return self.env_sensor_info_xml

                                                    if (child_yang_name == "fru-info"):
                                                        if (self.fru_info is None):
                                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.FruInfo()
                                                            self.fru_info.parent = self
                                                            self._children_name_map["fru_info"] = "fru-info"
                                                        return self.fru_info

                                                    if (child_yang_name == "inv-asset-bag"):
                                                        if (self.inv_asset_bag is None):
                                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvAssetBag()
                                                            self.inv_asset_bag.parent = self
                                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                        return self.inv_asset_bag

                                                    if (child_yang_name == "inv-basic-bag"):
                                                        if (self.inv_basic_bag is None):
                                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvBasicBag()
                                                            self.inv_basic_bag.parent = self
                                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                        return self.inv_basic_bag

                                                    if (child_yang_name == "inv-eeprom-info"):
                                                        if (self.inv_eeprom_info is None):
                                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.InvEepromInfo()
                                                            self.inv_eeprom_info.parent = self
                                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                        return self.inv_eeprom_info

                                                    if (child_yang_name == "pwg-info"):
                                                        if (self.pwg_info is None):
                                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.PwgInfo()
                                                            self.pwg_info.parent = self
                                                            self._children_name_map["pwg_info"] = "pwg-info"
                                                        return self.pwg_info

                                                    if (child_yang_name == "threshold"):
                                                        if (self.threshold is None):
                                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes.Threshold()
                                                            self.threshold.parent = self
                                                            self._children_name_map["threshold"] = "threshold"
                                                        return self.threshold

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "module-done"):
                                                        self.module_done = value
                                                        self.module_done.value_namespace = name_space
                                                        self.module_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "node-id"):
                                                        self.node_id = value
                                                        self.node_id.value_namespace = name_space
                                                        self.node_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-done"):
                                                        self.vm_done = value
                                                        self.vm_done.value_namespace = name_space
                                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vm-node-id"):
                                                        self.vm_node_id = value
                                                        self.vm_node_id.value_namespace = name_space
                                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.name.is_set or
                                                    (self.attributes is not None and self.attributes.has_data()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    (self.attributes is not None and self.attributes.has_operation()) or
                                                    (self.tsi4s is not None and self.tsi4s.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tsi3" + "[name='" + self.name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "attributes"):
                                                    if (self.attributes is None):
                                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Attributes()
                                                        self.attributes.parent = self
                                                        self._children_name_map["attributes"] = "attributes"
                                                    return self.attributes

                                                if (child_yang_name == "tsi4s"):
                                                    if (self.tsi4s is None):
                                                        self.tsi4s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3.Tsi4S()
                                                        self.tsi4s.parent = self
                                                        self._children_name_map["tsi4s"] = "tsi4s"
                                                    return self.tsi4s

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attributes" or name == "tsi4s" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tsi3:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.tsi3:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tsi3s" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "tsi3"):
                                                for c in self.tsi3:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S.Tsi3()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tsi3.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tsi3"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Attributes(Entity):
                                        """
                                        Attributes
                                        
                                        .. attribute:: env_sensor_info
                                        
                                        	Environment sensor info
                                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo>`
                                        
                                        .. attribute:: env_sensor_info_xml
                                        
                                        	Environment sensor info XML
                                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml>`
                                        
                                        .. attribute:: fru_info
                                        
                                        	Inventory EDM FRU info
                                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo>`
                                        
                                        .. attribute:: inv_asset_bag
                                        
                                        	Inventory Asset Bag
                                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag>`
                                        
                                        .. attribute:: inv_basic_bag
                                        
                                        	Inventory Basic Bag
                                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag>`
                                        
                                        .. attribute:: inv_eeprom_info
                                        
                                        	Inventory EDM EEPROM Information Bag
                                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo>`
                                        
                                        .. attribute:: module_done
                                        
                                        	Inventory EDM Module Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**default value**\: 1
                                        
                                        .. attribute:: node_id
                                        
                                        	Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pwg_info
                                        
                                        	Inventory EDM PWG info
                                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo>`
                                        
                                        .. attribute:: threshold
                                        
                                        	Threshold
                                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold>`
                                        
                                        .. attribute:: vm_done
                                        
                                        	VM Done Tuple
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: vm_node_id
                                        
                                        	VM Node ID Tuple
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__init__()

                                            self.yang_name = "attributes"
                                            self.yang_parent_name = "tsi2"

                                            self.module_done = YLeaf(YType.int32, "module-done")

                                            self.node_id = YLeaf(YType.uint32, "node-id")

                                            self.vm_done = YLeaf(YType.int32, "vm-done")

                                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                            self._children_yang_names.add("env-sensor-info")

                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                            self._children_yang_names.add("env-sensor-info-xml")

                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                            self._children_yang_names.add("fru-info")

                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                            self._children_yang_names.add("inv-asset-bag")

                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                            self._children_yang_names.add("inv-basic-bag")

                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                            self._children_yang_names.add("inv-eeprom-info")

                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                            self._children_yang_names.add("pwg-info")

                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                            self._children_yang_names.add("threshold")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("module_done",
                                                            "node_id",
                                                            "vm_done",
                                                            "vm_node_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes, self).__setattr__(name, value)


                                        class EnvSensorInfo(Entity):
                                            """
                                            Environment sensor info
                                            
                                            .. attribute:: age_time_stamp
                                            
                                            	Age of the sensor value; set to the current time if directly access the value from sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: alarm_type
                                            
                                            	Indicates threshold violation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: device_description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: device_id
                                            
                                            	Identifier for this device
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: field_validity_bitmap
                                            
                                            	Sensor valid bitmap
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: precision
                                            
                                            	Sensor precision range
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: scale
                                            
                                            	Sensor scale enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state enums
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__init__()

                                                self.yang_name = "env-sensor-info"
                                                self.yang_parent_name = "attributes"

                                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                                self.data_type = YLeaf(YType.uint32, "data-type")

                                                self.device_description = YLeaf(YType.str, "device-description")

                                                self.device_id = YLeaf(YType.uint32, "device-id")

                                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                                self.precision = YLeaf(YType.uint32, "precision")

                                                self.scale = YLeaf(YType.uint32, "scale")

                                                self.status = YLeaf(YType.uint32, "status")

                                                self.units = YLeaf(YType.str, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("age_time_stamp",
                                                                "alarm_type",
                                                                "data_type",
                                                                "device_description",
                                                                "device_id",
                                                                "field_validity_bitmap",
                                                                "precision",
                                                                "scale",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.age_time_stamp.is_set or
                                                    self.alarm_type.is_set or
                                                    self.data_type.is_set or
                                                    self.device_description.is_set or
                                                    self.device_id.is_set or
                                                    self.field_validity_bitmap.is_set or
                                                    self.precision.is_set or
                                                    self.scale.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                                    self.alarm_type.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.device_description.yfilter != YFilter.not_set or
                                                    self.device_id.yfilter != YFilter.not_set or
                                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                                    self.precision.yfilter != YFilter.not_set or
                                                    self.scale.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "age-time-stamp"):
                                                    self.age_time_stamp = value
                                                    self.age_time_stamp.value_namespace = name_space
                                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "alarm-type"):
                                                    self.alarm_type = value
                                                    self.alarm_type.value_namespace = name_space
                                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-description"):
                                                    self.device_description = value
                                                    self.device_description.value_namespace = name_space
                                                    self.device_description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "device-id"):
                                                    self.device_id = value
                                                    self.device_id.value_namespace = name_space
                                                    self.device_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "field-validity-bitmap"):
                                                    self.field_validity_bitmap = value
                                                    self.field_validity_bitmap.value_namespace = name_space
                                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                                if(value_path == "precision"):
                                                    self.precision = value
                                                    self.precision.value_namespace = name_space
                                                    self.precision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale"):
                                                    self.scale = value
                                                    self.scale.value_namespace = name_space
                                                    self.scale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PwgInfo(Entity):
                                            """
                                            Inventory EDM PWG info
                                            
                                            .. attribute:: power_group_available_current
                                            
                                            	available current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_drawn_current
                                            
                                            	drawn current
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_group_power_units
                                            
                                            	power units
                                            	**type**\:  str
                                            
                                            .. attribute:: power_group_redundancy_mode
                                            
                                            	redundancy mode
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__init__()

                                                self.yang_name = "pwg-info"
                                                self.yang_parent_name = "attributes"

                                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("power_group_available_current",
                                                                "power_group_drawn_current",
                                                                "power_group_power_units",
                                                                "power_group_redundancy_mode") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.power_group_available_current.is_set or
                                                    self.power_group_drawn_current.is_set or
                                                    self.power_group_power_units.is_set or
                                                    self.power_group_redundancy_mode.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pwg-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "power-group-available-current"):
                                                    self.power_group_available_current = value
                                                    self.power_group_available_current.value_namespace = name_space
                                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-drawn-current"):
                                                    self.power_group_drawn_current = value
                                                    self.power_group_drawn_current.value_namespace = name_space
                                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-power-units"):
                                                    self.power_group_power_units = value
                                                    self.power_group_power_units.value_namespace = name_space
                                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-group-redundancy-mode"):
                                                    self.power_group_redundancy_mode = value
                                                    self.power_group_redundancy_mode.value_namespace = name_space
                                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                        class EnvSensorInfoXml(Entity):
                                            """
                                            Environment sensor info XML
                                            
                                            .. attribute:: data_type
                                            
                                            	Sensor data type
                                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                            
                                            .. attribute:: description
                                            
                                            	Device Name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: status
                                            
                                            	Sensor operation state
                                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                            
                                            .. attribute:: threshold
                                            
                                            	Threshold information
                                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold>`
                                            
                                            .. attribute:: units
                                            
                                            	Units of variable being read
                                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                            
                                            .. attribute:: update_rate
                                            
                                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: value
                                            
                                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__init__()

                                                self.yang_name = "env-sensor-info-xml"
                                                self.yang_parent_name = "attributes"

                                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                                self.description = YLeaf(YType.str, "description")

                                                self.status = YLeaf(YType.enumeration, "status")

                                                self.units = YLeaf(YType.enumeration, "units")

                                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                                self.value = YLeaf(YType.str, "value")

                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                                self._children_yang_names.add("threshold")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("data_type",
                                                                "description",
                                                                "status",
                                                                "units",
                                                                "update_rate",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                            class Threshold(Entity):
                                                """
                                                Threshold information
                                                
                                                .. attribute:: threshold_array
                                                
                                                	Array of threshold
                                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                                    self.yang_name = "threshold"
                                                    self.yang_parent_name = "env-sensor-info-xml"

                                                    self.threshold_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                                class ThresholdArray(Entity):
                                                    """
                                                    Array of threshold
                                                    
                                                    .. attribute:: threshold_name
                                                    
                                                    	Threshold name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..50
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** \-2147483648..2147483647
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                        self.yang_name = "threshold-array"
                                                        self.yang_parent_name = "threshold"

                                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_name",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_name.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_name.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "threshold-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-name"):
                                                            self.threshold_name = value
                                                            self.threshold_name.value_namespace = name_space
                                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.threshold_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "threshold-array"):
                                                        for c in self.threshold_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.threshold_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "threshold-array"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.data_type.is_set or
                                                    self.description.is_set or
                                                    self.status.is_set or
                                                    self.units.is_set or
                                                    self.update_rate.is_set or
                                                    self.value.is_set or
                                                    (self.threshold is not None and self.threshold.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.data_type.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set or
                                                    self.units.yfilter != YFilter.not_set or
                                                    self.update_rate.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    (self.threshold is not None and self.threshold.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "env-sensor-info-xml" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())
                                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.units.get_name_leafdata())
                                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "threshold"):
                                                    if (self.threshold is None):
                                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml.Threshold()
                                                        self.threshold.parent = self
                                                        self._children_name_map["threshold"] = "threshold"
                                                    return self.threshold

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "data-type"):
                                                    self.data_type = value
                                                    self.data_type.value_namespace = name_space
                                                    self.data_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix
                                                if(value_path == "units"):
                                                    self.units = value
                                                    self.units.value_namespace = name_space
                                                    self.units.value_namespace_prefix = name_space_prefix
                                                if(value_path == "update-rate"):
                                                    self.update_rate = value
                                                    self.update_rate.value_namespace = name_space
                                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class InvAssetBag(Entity):
                                            """
                                            Inventory Asset Bag
                                            
                                            .. attribute:: manufacturer_assembly_number
                                            
                                            	Manufacture Assembly number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_assembly_revision
                                            
                                            	Manufacture assembly revision
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_common_language_equipment_identifier
                                            
                                            	Common Language Equipment           Identifier number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_firmware_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: manufacturer_software_identifier
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: original_equipment_manufacturer_string
                                            
                                            	String containing OEM information           if applicable
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: part_number
                                            
                                            	
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__init__()

                                                self.yang_name = "inv-asset-bag"
                                                self.yang_parent_name = "attributes"

                                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                                self.part_number = YLeaf(YType.str, "part-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("manufacturer_assembly_number",
                                                                "manufacturer_assembly_revision",
                                                                "manufacturer_common_language_equipment_identifier",
                                                                "manufacturer_firmware_identifier",
                                                                "manufacturer_software_identifier",
                                                                "original_equipment_manufacturer_string",
                                                                "part_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.manufacturer_assembly_number.is_set or
                                                    self.manufacturer_assembly_revision.is_set or
                                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                                    self.manufacturer_firmware_identifier.is_set or
                                                    self.manufacturer_software_identifier.is_set or
                                                    self.original_equipment_manufacturer_string.is_set or
                                                    self.part_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                                    self.part_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-asset-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "manufacturer-assembly-number"):
                                                    self.manufacturer_assembly_number = value
                                                    self.manufacturer_assembly_number.value_namespace = name_space
                                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-assembly-revision"):
                                                    self.manufacturer_assembly_revision = value
                                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                                    self.manufacturer_common_language_equipment_identifier = value
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-firmware-identifier"):
                                                    self.manufacturer_firmware_identifier = value
                                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-software-identifier"):
                                                    self.manufacturer_software_identifier = value
                                                    self.manufacturer_software_identifier.value_namespace = name_space
                                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "original-equipment-manufacturer-string"):
                                                    self.original_equipment_manufacturer_string = value
                                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                                if(value_path == "part-number"):
                                                    self.part_number = value
                                                    self.part_number.value_namespace = name_space
                                                    self.part_number.value_namespace_prefix = name_space_prefix


                                        class Threshold(Entity):
                                            """
                                            Threshold
                                            
                                            .. attribute:: critical_hi
                                            
                                            	Critical High
                                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi>`
                                            
                                            .. attribute:: critical_lo
                                            
                                            	Critical Low
                                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo>`
                                            
                                            .. attribute:: major_hi
                                            
                                            	Major High
                                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi>`
                                            
                                            .. attribute:: major_lo
                                            
                                            	Major Low
                                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo>`
                                            
                                            .. attribute:: minor_hi
                                            
                                            	Minor High
                                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi>`
                                            
                                            .. attribute:: minor_lo
                                            
                                            	Minor Low
                                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo>`
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold, self).__init__()

                                                self.yang_name = "threshold"
                                                self.yang_parent_name = "attributes"

                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                                self._children_yang_names.add("critical-hi")

                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                                self._children_yang_names.add("critical-lo")

                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                                self._children_yang_names.add("major-hi")

                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                                self._children_yang_names.add("major-lo")

                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                                self._children_yang_names.add("minor-hi")

                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                                self._children_yang_names.add("minor-lo")


                                            class MajorLo(Entity):
                                                """
                                                Major Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo, self).__init__()

                                                    self.yang_name = "major-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalHi(Entity):
                                                """
                                                Critical High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi, self).__init__()

                                                    self.yang_name = "critical-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorHi(Entity):
                                                """
                                                Minor High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi, self).__init__()

                                                    self.yang_name = "minor-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MajorHi(Entity):
                                                """
                                                Major High
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi, self).__init__()

                                                    self.yang_name = "major-hi"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "major-hi"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "major-hi" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class CriticalLo(Entity):
                                                """
                                                Critical Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo, self).__init__()

                                                    self.yang_name = "critical-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "critical-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "critical-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class MinorLo(Entity):
                                                """
                                                Minor Low
                                                
                                                .. attribute:: thresh_bag
                                                
                                                	Environment threshold info
                                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag>`
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo, self).__init__()

                                                    self.yang_name = "minor-lo"
                                                    self.yang_parent_name = "threshold"

                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                    self._children_yang_names.add("thresh-bag")


                                                class ThreshBag(Entity):
                                                    """
                                                    Environment threshold info
                                                    
                                                    .. attribute:: threshold_evaluation
                                                    
                                                    	Indicates the result of the most recent evaluation of the thresholD
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_notification_enabled
                                                    
                                                    	Indicates whether or not a notification should result, in case of threshold violation
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: threshold_relation
                                                    
                                                    	Indicates relation between sensor value and threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_severity
                                                    
                                                    	Indicates minor, major, critical severities
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: threshold_value
                                                    
                                                    	Value of the configured threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                        self.yang_name = "thresh-bag"
                                                        self.yang_parent_name = "minor-lo"

                                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("threshold_evaluation",
                                                                        "threshold_notification_enabled",
                                                                        "threshold_relation",
                                                                        "threshold_severity",
                                                                        "threshold_value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.threshold_evaluation.is_set or
                                                            self.threshold_notification_enabled.is_set or
                                                            self.threshold_relation.is_set or
                                                            self.threshold_severity.is_set or
                                                            self.threshold_value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                            self.threshold_relation.yfilter != YFilter.not_set or
                                                            self.threshold_severity.yfilter != YFilter.not_set or
                                                            self.threshold_value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "thresh-bag" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "threshold-evaluation"):
                                                            self.threshold_evaluation = value
                                                            self.threshold_evaluation.value_namespace = name_space
                                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-notification-enabled"):
                                                            self.threshold_notification_enabled = value
                                                            self.threshold_notification_enabled.value_namespace = name_space
                                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-relation"):
                                                            self.threshold_relation = value
                                                            self.threshold_relation.value_namespace = name_space
                                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-severity"):
                                                            self.threshold_severity = value
                                                            self.threshold_severity.value_namespace = name_space
                                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "threshold-value"):
                                                            self.threshold_value = value
                                                            self.threshold_value.value_namespace = name_space
                                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minor-lo" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "thresh-bag"):
                                                        if (self.thresh_bag is None):
                                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo.ThreshBag()
                                                            self.thresh_bag.parent = self
                                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                                        return self.thresh_bag

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "thresh-bag"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "critical-hi"):
                                                    if (self.critical_hi is None):
                                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalHi()
                                                        self.critical_hi.parent = self
                                                        self._children_name_map["critical_hi"] = "critical-hi"
                                                    return self.critical_hi

                                                if (child_yang_name == "critical-lo"):
                                                    if (self.critical_lo is None):
                                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.CriticalLo()
                                                        self.critical_lo.parent = self
                                                        self._children_name_map["critical_lo"] = "critical-lo"
                                                    return self.critical_lo

                                                if (child_yang_name == "major-hi"):
                                                    if (self.major_hi is None):
                                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorHi()
                                                        self.major_hi.parent = self
                                                        self._children_name_map["major_hi"] = "major-hi"
                                                    return self.major_hi

                                                if (child_yang_name == "major-lo"):
                                                    if (self.major_lo is None):
                                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MajorLo()
                                                        self.major_lo.parent = self
                                                        self._children_name_map["major_lo"] = "major-lo"
                                                    return self.major_lo

                                                if (child_yang_name == "minor-hi"):
                                                    if (self.minor_hi is None):
                                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorHi()
                                                        self.minor_hi.parent = self
                                                        self._children_name_map["minor_hi"] = "minor-hi"
                                                    return self.minor_hi

                                                if (child_yang_name == "minor-lo"):
                                                    if (self.minor_lo is None):
                                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold.MinorLo()
                                                        self.minor_lo.parent = self
                                                        self._children_name_map["minor_lo"] = "minor-lo"
                                                    return self.minor_lo

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class FruInfo(Entity):
                                            """
                                            Inventory EDM FRU info
                                            
                                            .. attribute:: card_administrative_state
                                            
                                            	card admin state\: shutdown or not
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_monitor_state
                                            
                                            	card is monitored by a manager or left unmonitored
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_operational_state
                                            
                                            	card operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: card_reset_reason
                                            
                                            	card reset reason enum
                                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                            
                                            .. attribute:: card_up_time
                                            
                                            	card up time
                                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime>`
                                            
                                            .. attribute:: last_operational_state_change
                                            
                                            	last card oper change state
                                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange>`
                                            
                                            .. attribute:: power_administrative_state
                                            
                                            	power admin state\: up or down
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_current_measurement
                                            
                                            	power current\: not implemented
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: power_operational_state
                                            
                                            	Power operation state
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__init__()

                                                self.yang_name = "fru-info"
                                                self.yang_parent_name = "attributes"

                                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                                self._children_yang_names.add("card-up-time")

                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                self._children_yang_names.add("last-operational-state-change")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("card_administrative_state",
                                                                "card_monitor_state",
                                                                "card_operational_state",
                                                                "card_reset_reason",
                                                                "power_administrative_state",
                                                                "power_current_measurement",
                                                                "power_operational_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo, self).__setattr__(name, value)


                                            class LastOperationalStateChange(Entity):
                                                """
                                                last card oper change state
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                                    self.yang_name = "last-operational-state-change"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-operational-state-change" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                            class CardUpTime(Entity):
                                                """
                                                card up time
                                                
                                                .. attribute:: time_in_nano_seconds
                                                
                                                	Time Value in Nano\-seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: nanosecond
                                                
                                                .. attribute:: time_in_seconds
                                                
                                                	Time Value in Seconds
                                                	**type**\:  int
                                                
                                                	**range:** \-2147483648..2147483647
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__init__()

                                                    self.yang_name = "card-up-time"
                                                    self.yang_parent_name = "fru-info"

                                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("time_in_nano_seconds",
                                                                    "time_in_seconds") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.time_in_nano_seconds.is_set or
                                                        self.time_in_seconds.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "card-up-time" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "time-in-nano-seconds"):
                                                        self.time_in_nano_seconds = value
                                                        self.time_in_nano_seconds.value_namespace = name_space
                                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "time-in-seconds"):
                                                        self.time_in_seconds = value
                                                        self.time_in_seconds.value_namespace = name_space
                                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.card_administrative_state.is_set or
                                                    self.card_monitor_state.is_set or
                                                    self.card_operational_state.is_set or
                                                    self.card_reset_reason.is_set or
                                                    self.power_administrative_state.is_set or
                                                    self.power_current_measurement.is_set or
                                                    self.power_operational_state.is_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                                    self.card_operational_state.yfilter != YFilter.not_set or
                                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                                    self.power_operational_state.yfilter != YFilter.not_set or
                                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fru-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "card-up-time"):
                                                    if (self.card_up_time is None):
                                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.CardUpTime()
                                                        self.card_up_time.parent = self
                                                        self._children_name_map["card_up_time"] = "card-up-time"
                                                    return self.card_up_time

                                                if (child_yang_name == "last-operational-state-change"):
                                                    if (self.last_operational_state_change is None):
                                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo.LastOperationalStateChange()
                                                        self.last_operational_state_change.parent = self
                                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                                    return self.last_operational_state_change

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "card-administrative-state"):
                                                    self.card_administrative_state = value
                                                    self.card_administrative_state.value_namespace = name_space
                                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-monitor-state"):
                                                    self.card_monitor_state = value
                                                    self.card_monitor_state.value_namespace = name_space
                                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-operational-state"):
                                                    self.card_operational_state = value
                                                    self.card_operational_state.value_namespace = name_space
                                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "card-reset-reason"):
                                                    self.card_reset_reason = value
                                                    self.card_reset_reason.value_namespace = name_space
                                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-administrative-state"):
                                                    self.power_administrative_state = value
                                                    self.power_administrative_state.value_namespace = name_space
                                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-current-measurement"):
                                                    self.power_current_measurement = value
                                                    self.power_current_measurement.value_namespace = name_space
                                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                                if(value_path == "power-operational-state"):
                                                    self.power_operational_state = value
                                                    self.power_operational_state.value_namespace = name_space
                                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                                        class InvBasicBag(Entity):
                                            """
                                            Inventory Basic Bag
                                            
                                            .. attribute:: alias
                                            
                                            	useful for storing an entity alias 
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_id_str
                                            
                                            	asset Identification string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: asset_identification
                                            
                                            	asset Identification
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: ceport
                                            
                                            	1 if ce port found, 0 if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: chip_hardware_revision
                                            
                                            	chip module hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: composite_class_code
                                            
                                            	Major&minor class of the entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: description
                                            
                                            	describes in user\-readable terms       what the entity in question does
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: environmental_monitor_path
                                            
                                            	sysdb name of sensor in the envmon EDM
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: firmware_revision
                                            
                                            	firmware revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: group_flag
                                            
                                            	indicates if this entity is group       or not
                                            	**type**\:  bool
                                            
                                            .. attribute:: hardware_revision
                                            
                                            	hw revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: is_field_replaceable_unit
                                            
                                            	1 if Field Replaceable Unit 0, if not
                                            	**type**\:  bool
                                            
                                            .. attribute:: manufacturer_asset_tags
                                            
                                            	Manufacture Asset Tags
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: manufacturer_name
                                            
                                            	manufacturer's name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: memory_size
                                            
                                            	Size of memory associated with       the entity where applicable
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: model_name
                                            
                                            	model name
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: name
                                            
                                            	name string for the entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: new_deviation_number
                                            
                                            	integer value for New Deviation Number 0x88
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: physical_layer_interface_module_type
                                            
                                            	integer value for plim type if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: redundancystate
                                            
                                            	integer value for Redundancy State if     applicable to this entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: serial_number
                                            
                                            	serial number
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: software_revision
                                            
                                            	software revision string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: unique_id
                                            
                                            	Unique id for an entity
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: unrecognized_fru
                                            
                                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                                            	**type**\:  bool
                                            
                                            .. attribute:: vendor_type
                                            
                                            	maps to the vendor OID string
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: xr_scoped
                                            
                                            	1 if xr scoped, 0 if not
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__init__()

                                                self.yang_name = "inv-basic-bag"
                                                self.yang_parent_name = "attributes"

                                                self.alias = YLeaf(YType.str, "alias")

                                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                                self.ceport = YLeaf(YType.boolean, "ceport")

                                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                                self.description = YLeaf(YType.str, "description")

                                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                                self.model_name = YLeaf(YType.str, "model-name")

                                                self.name = YLeaf(YType.str, "name")

                                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                                self.serial_number = YLeaf(YType.str, "serial-number")

                                                self.software_revision = YLeaf(YType.str, "software-revision")

                                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("alias",
                                                                "asset_id_str",
                                                                "asset_identification",
                                                                "ceport",
                                                                "chip_hardware_revision",
                                                                "composite_class_code",
                                                                "description",
                                                                "environmental_monitor_path",
                                                                "firmware_revision",
                                                                "group_flag",
                                                                "hardware_revision",
                                                                "is_field_replaceable_unit",
                                                                "manufacturer_asset_tags",
                                                                "manufacturer_name",
                                                                "memory_size",
                                                                "model_name",
                                                                "name",
                                                                "new_deviation_number",
                                                                "physical_layer_interface_module_type",
                                                                "redundancystate",
                                                                "serial_number",
                                                                "software_revision",
                                                                "unique_id",
                                                                "unrecognized_fru",
                                                                "vendor_type",
                                                                "xr_scoped") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.alias.is_set or
                                                    self.asset_id_str.is_set or
                                                    self.asset_identification.is_set or
                                                    self.ceport.is_set or
                                                    self.chip_hardware_revision.is_set or
                                                    self.composite_class_code.is_set or
                                                    self.description.is_set or
                                                    self.environmental_monitor_path.is_set or
                                                    self.firmware_revision.is_set or
                                                    self.group_flag.is_set or
                                                    self.hardware_revision.is_set or
                                                    self.is_field_replaceable_unit.is_set or
                                                    self.manufacturer_asset_tags.is_set or
                                                    self.manufacturer_name.is_set or
                                                    self.memory_size.is_set or
                                                    self.model_name.is_set or
                                                    self.name.is_set or
                                                    self.new_deviation_number.is_set or
                                                    self.physical_layer_interface_module_type.is_set or
                                                    self.redundancystate.is_set or
                                                    self.serial_number.is_set or
                                                    self.software_revision.is_set or
                                                    self.unique_id.is_set or
                                                    self.unrecognized_fru.is_set or
                                                    self.vendor_type.is_set or
                                                    self.xr_scoped.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.alias.yfilter != YFilter.not_set or
                                                    self.asset_id_str.yfilter != YFilter.not_set or
                                                    self.asset_identification.yfilter != YFilter.not_set or
                                                    self.ceport.yfilter != YFilter.not_set or
                                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                                    self.composite_class_code.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                                    self.firmware_revision.yfilter != YFilter.not_set or
                                                    self.group_flag.yfilter != YFilter.not_set or
                                                    self.hardware_revision.yfilter != YFilter.not_set or
                                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                                    self.memory_size.yfilter != YFilter.not_set or
                                                    self.model_name.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                                    self.redundancystate.yfilter != YFilter.not_set or
                                                    self.serial_number.yfilter != YFilter.not_set or
                                                    self.software_revision.yfilter != YFilter.not_set or
                                                    self.unique_id.yfilter != YFilter.not_set or
                                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                                    self.vendor_type.yfilter != YFilter.not_set or
                                                    self.xr_scoped.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-basic-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "alias"):
                                                    self.alias = value
                                                    self.alias.value_namespace = name_space
                                                    self.alias.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-id-str"):
                                                    self.asset_id_str = value
                                                    self.asset_id_str.value_namespace = name_space
                                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                                if(value_path == "asset-identification"):
                                                    self.asset_identification = value
                                                    self.asset_identification.value_namespace = name_space
                                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ceport"):
                                                    self.ceport = value
                                                    self.ceport.value_namespace = name_space
                                                    self.ceport.value_namespace_prefix = name_space_prefix
                                                if(value_path == "chip-hardware-revision"):
                                                    self.chip_hardware_revision = value
                                                    self.chip_hardware_revision.value_namespace = name_space
                                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "composite-class-code"):
                                                    self.composite_class_code = value
                                                    self.composite_class_code.value_namespace = name_space
                                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "environmental-monitor-path"):
                                                    self.environmental_monitor_path = value
                                                    self.environmental_monitor_path.value_namespace = name_space
                                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                                if(value_path == "firmware-revision"):
                                                    self.firmware_revision = value
                                                    self.firmware_revision.value_namespace = name_space
                                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "group-flag"):
                                                    self.group_flag = value
                                                    self.group_flag.value_namespace = name_space
                                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hardware-revision"):
                                                    self.hardware_revision = value
                                                    self.hardware_revision.value_namespace = name_space
                                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-field-replaceable-unit"):
                                                    self.is_field_replaceable_unit = value
                                                    self.is_field_replaceable_unit.value_namespace = name_space
                                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-asset-tags"):
                                                    self.manufacturer_asset_tags = value
                                                    self.manufacturer_asset_tags.value_namespace = name_space
                                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "manufacturer-name"):
                                                    self.manufacturer_name = value
                                                    self.manufacturer_name.value_namespace = name_space
                                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "memory-size"):
                                                    self.memory_size = value
                                                    self.memory_size.value_namespace = name_space
                                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                                if(value_path == "model-name"):
                                                    self.model_name = value
                                                    self.model_name.value_namespace = name_space
                                                    self.model_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "new-deviation-number"):
                                                    self.new_deviation_number = value
                                                    self.new_deviation_number.value_namespace = name_space
                                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "physical-layer-interface-module-type"):
                                                    self.physical_layer_interface_module_type = value
                                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "redundancystate"):
                                                    self.redundancystate = value
                                                    self.redundancystate.value_namespace = name_space
                                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "serial-number"):
                                                    self.serial_number = value
                                                    self.serial_number.value_namespace = name_space
                                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "software-revision"):
                                                    self.software_revision = value
                                                    self.software_revision.value_namespace = name_space
                                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unique-id"):
                                                    self.unique_id = value
                                                    self.unique_id.value_namespace = name_space
                                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unrecognized-fru"):
                                                    self.unrecognized_fru = value
                                                    self.unrecognized_fru.value_namespace = name_space
                                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                                if(value_path == "vendor-type"):
                                                    self.vendor_type = value
                                                    self.vendor_type.value_namespace = name_space
                                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "xr-scoped"):
                                                    self.xr_scoped = value
                                                    self.xr_scoped.value_namespace = name_space
                                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                                        class InvEepromInfo(Entity):
                                            """
                                            Inventory EDM EEPROM Information Bag
                                            
                                            .. attribute:: description
                                            
                                            	A textual description of physical entity
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: eeprom
                                            
                                            	EEPROM data not from hex data
                                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom>`
                                            
                                            .. attribute:: has_eeprom
                                            
                                            	use eeprom instead of opaque data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: inv_card_type
                                            
                                            	Inventory card type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: opaque_data
                                            
                                            	EEPROM hex data
                                            	**type**\:  str
                                            
                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                            
                                            .. attribute:: opaque_data_size
                                            
                                            	size of the EEPROM hex data
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__init__()

                                                self.yang_name = "inv-eeprom-info"
                                                self.yang_parent_name = "attributes"

                                                self.description = YLeaf(YType.str, "description")

                                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                                self._children_yang_names.add("eeprom")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("description",
                                                                "has_eeprom",
                                                                "inv_card_type",
                                                                "opaque_data",
                                                                "opaque_data_size") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                            class Eeprom(Entity):
                                                """
                                                EEPROM data not from hex data
                                                
                                                .. attribute:: asset_alias
                                                
                                                	Asset Alias
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: asset_id
                                                
                                                	Asset ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address1
                                                
                                                	Base Mac Address #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address2
                                                
                                                	Base Mac Address #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address3
                                                
                                                	Base Mac Address #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: base_mac_address4
                                                
                                                	Base Mac Address #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_checksum
                                                
                                                	Block Checksum
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_count
                                                
                                                	Block Count
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_length
                                                
                                                	Block Length
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_signature
                                                
                                                	Block Signature
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: block_version
                                                
                                                	Block Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: chassis_sid
                                                
                                                	Chassis serial number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: clei
                                                
                                                	Common Language Equipment Identifier (CLEI) code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_family
                                                
                                                	Controller family
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: controller_type
                                                
                                                	Controller type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: description
                                                
                                                	A textual description of physical entity
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num1
                                                
                                                	Deviation Number # 1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num2
                                                
                                                	Deviation Number # 2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num3
                                                
                                                	Deviation Number # 3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num4
                                                
                                                	Deviation Number # 4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num5
                                                
                                                	Deviation Number # 5
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num6
                                                
                                                	Deviation Number # 6
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: dev_num7
                                                
                                                	Deviation Number # 7
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eci
                                                
                                                	Equipment Catalog Item (ECI) number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: eeprom_size
                                                
                                                	EEPROM Size
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: engineer_use
                                                
                                                	Engineer Use
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_major_type
                                                
                                                	FRU Major Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: fru_minor_type
                                                
                                                	FRU Minor Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hw_version
                                                
                                                	Hardware Version
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: hwid
                                                
                                                	Hardware Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: idprom_format_rev
                                                
                                                	IDPROM Format Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size1
                                                
                                                	Mac Address Block Size #1
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size2
                                                
                                                	Mac Address Block Size #2
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size3
                                                
                                                	Mac Address Block Size #3
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mac_add_blk_size4
                                                
                                                	Mac Address Block Size #4
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: manu_test_data
                                                
                                                	Manufacturing Test Data
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_bits
                                                
                                                	MFG Bits
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: mfg_deviation
                                                
                                                	MFG Deviation
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: oem_string
                                                
                                                	OEM String
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_number
                                                
                                                	Part Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: part_revision
                                                
                                                	Part Revision
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pca_num
                                                
                                                	PCA number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcavid
                                                
                                                	PCA revision ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pcb_serial_num
                                                
                                                	PCB Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: pid
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_consumption
                                                
                                                	Power Consumption
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: power_supply_type
                                                
                                                	Power Supply Type
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: product_id
                                                
                                                	Product ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: rma
                                                
                                                	RMA Data
                                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma>`
                                                
                                                .. attribute:: rma_code
                                                
                                                	RMA Code
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: serial_number
                                                
                                                	Serial Number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: snmpoid
                                                
                                                	SNMP OID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_part_num
                                                
                                                	Top assembly part number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: top_assem_vid
                                                
                                                	Top assembly revision number
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_description
                                                
                                                	UDI description
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: udi_name
                                                
                                                	UDI name
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                .. attribute:: vid
                                                
                                                	Version ID
                                                	**type**\:  str
                                                
                                                	**length:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'invmgr-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                                    self.yang_name = "eeprom"
                                                    self.yang_parent_name = "inv-eeprom-info"

                                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                                    self.block_count = YLeaf(YType.str, "block-count")

                                                    self.block_length = YLeaf(YType.str, "block-length")

                                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                                    self.block_version = YLeaf(YType.str, "block-version")

                                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                                    self.clei = YLeaf(YType.str, "clei")

                                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                                    self.description = YLeaf(YType.str, "description")

                                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                                    self.eci = YLeaf(YType.str, "eci")

                                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                                    self.hwid = YLeaf(YType.str, "hwid")

                                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                                    self.part_number = YLeaf(YType.str, "part-number")

                                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                                    self.pid = YLeaf(YType.str, "pid")

                                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                                    self.product_id = YLeaf(YType.str, "product-id")

                                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                                    self.vid = YLeaf(YType.str, "vid")

                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                    self._children_yang_names.add("rma")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("asset_alias",
                                                                    "asset_id",
                                                                    "base_mac_address1",
                                                                    "base_mac_address2",
                                                                    "base_mac_address3",
                                                                    "base_mac_address4",
                                                                    "block_checksum",
                                                                    "block_count",
                                                                    "block_length",
                                                                    "block_signature",
                                                                    "block_version",
                                                                    "chassis_sid",
                                                                    "clei",
                                                                    "controller_family",
                                                                    "controller_type",
                                                                    "description",
                                                                    "dev_num1",
                                                                    "dev_num2",
                                                                    "dev_num3",
                                                                    "dev_num4",
                                                                    "dev_num5",
                                                                    "dev_num6",
                                                                    "dev_num7",
                                                                    "eci",
                                                                    "eeprom_size",
                                                                    "engineer_use",
                                                                    "fru_major_type",
                                                                    "fru_minor_type",
                                                                    "hw_version",
                                                                    "hwid",
                                                                    "idprom_format_rev",
                                                                    "mac_add_blk_size1",
                                                                    "mac_add_blk_size2",
                                                                    "mac_add_blk_size3",
                                                                    "mac_add_blk_size4",
                                                                    "manu_test_data",
                                                                    "mfg_bits",
                                                                    "mfg_deviation",
                                                                    "oem_string",
                                                                    "part_number",
                                                                    "part_revision",
                                                                    "pca_num",
                                                                    "pcavid",
                                                                    "pcb_serial_num",
                                                                    "pid",
                                                                    "power_consumption",
                                                                    "power_supply_type",
                                                                    "product_id",
                                                                    "rma_code",
                                                                    "serial_number",
                                                                    "snmpoid",
                                                                    "top_assem_part_num",
                                                                    "top_assem_vid",
                                                                    "udi_description",
                                                                    "udi_name",
                                                                    "vid") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                                class Rma(Entity):
                                                    """
                                                    RMA Data
                                                    
                                                    .. attribute:: rma_history
                                                    
                                                    	RMA history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: rma_number
                                                    
                                                    	RMA tracking number format is N\-N\-N
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    .. attribute:: test_history
                                                    
                                                    	Test history
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'invmgr-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                        self.yang_name = "rma"
                                                        self.yang_parent_name = "eeprom"

                                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                                        self.test_history = YLeaf(YType.str, "test-history")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("rma_history",
                                                                        "rma_number",
                                                                        "test_history") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.rma_history.is_set or
                                                            self.rma_number.is_set or
                                                            self.test_history.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.rma_history.yfilter != YFilter.not_set or
                                                            self.rma_number.yfilter != YFilter.not_set or
                                                            self.test_history.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "rma" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "rma-history"):
                                                            self.rma_history = value
                                                            self.rma_history.value_namespace = name_space
                                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rma-number"):
                                                            self.rma_number = value
                                                            self.rma_number.value_namespace = name_space
                                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "test-history"):
                                                            self.test_history = value
                                                            self.test_history.value_namespace = name_space
                                                            self.test_history.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.asset_alias.is_set or
                                                        self.asset_id.is_set or
                                                        self.base_mac_address1.is_set or
                                                        self.base_mac_address2.is_set or
                                                        self.base_mac_address3.is_set or
                                                        self.base_mac_address4.is_set or
                                                        self.block_checksum.is_set or
                                                        self.block_count.is_set or
                                                        self.block_length.is_set or
                                                        self.block_signature.is_set or
                                                        self.block_version.is_set or
                                                        self.chassis_sid.is_set or
                                                        self.clei.is_set or
                                                        self.controller_family.is_set or
                                                        self.controller_type.is_set or
                                                        self.description.is_set or
                                                        self.dev_num1.is_set or
                                                        self.dev_num2.is_set or
                                                        self.dev_num3.is_set or
                                                        self.dev_num4.is_set or
                                                        self.dev_num5.is_set or
                                                        self.dev_num6.is_set or
                                                        self.dev_num7.is_set or
                                                        self.eci.is_set or
                                                        self.eeprom_size.is_set or
                                                        self.engineer_use.is_set or
                                                        self.fru_major_type.is_set or
                                                        self.fru_minor_type.is_set or
                                                        self.hw_version.is_set or
                                                        self.hwid.is_set or
                                                        self.idprom_format_rev.is_set or
                                                        self.mac_add_blk_size1.is_set or
                                                        self.mac_add_blk_size2.is_set or
                                                        self.mac_add_blk_size3.is_set or
                                                        self.mac_add_blk_size4.is_set or
                                                        self.manu_test_data.is_set or
                                                        self.mfg_bits.is_set or
                                                        self.mfg_deviation.is_set or
                                                        self.oem_string.is_set or
                                                        self.part_number.is_set or
                                                        self.part_revision.is_set or
                                                        self.pca_num.is_set or
                                                        self.pcavid.is_set or
                                                        self.pcb_serial_num.is_set or
                                                        self.pid.is_set or
                                                        self.power_consumption.is_set or
                                                        self.power_supply_type.is_set or
                                                        self.product_id.is_set or
                                                        self.rma_code.is_set or
                                                        self.serial_number.is_set or
                                                        self.snmpoid.is_set or
                                                        self.top_assem_part_num.is_set or
                                                        self.top_assem_vid.is_set or
                                                        self.udi_description.is_set or
                                                        self.udi_name.is_set or
                                                        self.vid.is_set or
                                                        (self.rma is not None and self.rma.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.asset_alias.yfilter != YFilter.not_set or
                                                        self.asset_id.yfilter != YFilter.not_set or
                                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                                        self.block_checksum.yfilter != YFilter.not_set or
                                                        self.block_count.yfilter != YFilter.not_set or
                                                        self.block_length.yfilter != YFilter.not_set or
                                                        self.block_signature.yfilter != YFilter.not_set or
                                                        self.block_version.yfilter != YFilter.not_set or
                                                        self.chassis_sid.yfilter != YFilter.not_set or
                                                        self.clei.yfilter != YFilter.not_set or
                                                        self.controller_family.yfilter != YFilter.not_set or
                                                        self.controller_type.yfilter != YFilter.not_set or
                                                        self.description.yfilter != YFilter.not_set or
                                                        self.dev_num1.yfilter != YFilter.not_set or
                                                        self.dev_num2.yfilter != YFilter.not_set or
                                                        self.dev_num3.yfilter != YFilter.not_set or
                                                        self.dev_num4.yfilter != YFilter.not_set or
                                                        self.dev_num5.yfilter != YFilter.not_set or
                                                        self.dev_num6.yfilter != YFilter.not_set or
                                                        self.dev_num7.yfilter != YFilter.not_set or
                                                        self.eci.yfilter != YFilter.not_set or
                                                        self.eeprom_size.yfilter != YFilter.not_set or
                                                        self.engineer_use.yfilter != YFilter.not_set or
                                                        self.fru_major_type.yfilter != YFilter.not_set or
                                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                                        self.hw_version.yfilter != YFilter.not_set or
                                                        self.hwid.yfilter != YFilter.not_set or
                                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                        self.manu_test_data.yfilter != YFilter.not_set or
                                                        self.mfg_bits.yfilter != YFilter.not_set or
                                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                                        self.oem_string.yfilter != YFilter.not_set or
                                                        self.part_number.yfilter != YFilter.not_set or
                                                        self.part_revision.yfilter != YFilter.not_set or
                                                        self.pca_num.yfilter != YFilter.not_set or
                                                        self.pcavid.yfilter != YFilter.not_set or
                                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                                        self.pid.yfilter != YFilter.not_set or
                                                        self.power_consumption.yfilter != YFilter.not_set or
                                                        self.power_supply_type.yfilter != YFilter.not_set or
                                                        self.product_id.yfilter != YFilter.not_set or
                                                        self.rma_code.yfilter != YFilter.not_set or
                                                        self.serial_number.yfilter != YFilter.not_set or
                                                        self.snmpoid.yfilter != YFilter.not_set or
                                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                                        self.udi_description.yfilter != YFilter.not_set or
                                                        self.udi_name.yfilter != YFilter.not_set or
                                                        self.vid.yfilter != YFilter.not_set or
                                                        (self.rma is not None and self.rma.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "eeprom" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.description.get_name_leafdata())
                                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "rma"):
                                                        if (self.rma is None):
                                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom.Rma()
                                                            self.rma.parent = self
                                                            self._children_name_map["rma"] = "rma"
                                                        return self.rma

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "asset-alias"):
                                                        self.asset_alias = value
                                                        self.asset_alias.value_namespace = name_space
                                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "asset-id"):
                                                        self.asset_id = value
                                                        self.asset_id.value_namespace = name_space
                                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address1"):
                                                        self.base_mac_address1 = value
                                                        self.base_mac_address1.value_namespace = name_space
                                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address2"):
                                                        self.base_mac_address2 = value
                                                        self.base_mac_address2.value_namespace = name_space
                                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address3"):
                                                        self.base_mac_address3 = value
                                                        self.base_mac_address3.value_namespace = name_space
                                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "base-mac-address4"):
                                                        self.base_mac_address4 = value
                                                        self.base_mac_address4.value_namespace = name_space
                                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-checksum"):
                                                        self.block_checksum = value
                                                        self.block_checksum.value_namespace = name_space
                                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-count"):
                                                        self.block_count = value
                                                        self.block_count.value_namespace = name_space
                                                        self.block_count.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-length"):
                                                        self.block_length = value
                                                        self.block_length.value_namespace = name_space
                                                        self.block_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-signature"):
                                                        self.block_signature = value
                                                        self.block_signature.value_namespace = name_space
                                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "block-version"):
                                                        self.block_version = value
                                                        self.block_version.value_namespace = name_space
                                                        self.block_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "chassis-sid"):
                                                        self.chassis_sid = value
                                                        self.chassis_sid.value_namespace = name_space
                                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "clei"):
                                                        self.clei = value
                                                        self.clei.value_namespace = name_space
                                                        self.clei.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-family"):
                                                        self.controller_family = value
                                                        self.controller_family.value_namespace = name_space
                                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "controller-type"):
                                                        self.controller_type = value
                                                        self.controller_type.value_namespace = name_space
                                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "description"):
                                                        self.description = value
                                                        self.description.value_namespace = name_space
                                                        self.description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num1"):
                                                        self.dev_num1 = value
                                                        self.dev_num1.value_namespace = name_space
                                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num2"):
                                                        self.dev_num2 = value
                                                        self.dev_num2.value_namespace = name_space
                                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num3"):
                                                        self.dev_num3 = value
                                                        self.dev_num3.value_namespace = name_space
                                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num4"):
                                                        self.dev_num4 = value
                                                        self.dev_num4.value_namespace = name_space
                                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num5"):
                                                        self.dev_num5 = value
                                                        self.dev_num5.value_namespace = name_space
                                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num6"):
                                                        self.dev_num6 = value
                                                        self.dev_num6.value_namespace = name_space
                                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dev-num7"):
                                                        self.dev_num7 = value
                                                        self.dev_num7.value_namespace = name_space
                                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eci"):
                                                        self.eci = value
                                                        self.eci.value_namespace = name_space
                                                        self.eci.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "eeprom-size"):
                                                        self.eeprom_size = value
                                                        self.eeprom_size.value_namespace = name_space
                                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "engineer-use"):
                                                        self.engineer_use = value
                                                        self.engineer_use.value_namespace = name_space
                                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-major-type"):
                                                        self.fru_major_type = value
                                                        self.fru_major_type.value_namespace = name_space
                                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fru-minor-type"):
                                                        self.fru_minor_type = value
                                                        self.fru_minor_type.value_namespace = name_space
                                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hw-version"):
                                                        self.hw_version = value
                                                        self.hw_version.value_namespace = name_space
                                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "hwid"):
                                                        self.hwid = value
                                                        self.hwid.value_namespace = name_space
                                                        self.hwid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "idprom-format-rev"):
                                                        self.idprom_format_rev = value
                                                        self.idprom_format_rev.value_namespace = name_space
                                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size1"):
                                                        self.mac_add_blk_size1 = value
                                                        self.mac_add_blk_size1.value_namespace = name_space
                                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size2"):
                                                        self.mac_add_blk_size2 = value
                                                        self.mac_add_blk_size2.value_namespace = name_space
                                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size3"):
                                                        self.mac_add_blk_size3 = value
                                                        self.mac_add_blk_size3.value_namespace = name_space
                                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mac-add-blk-size4"):
                                                        self.mac_add_blk_size4 = value
                                                        self.mac_add_blk_size4.value_namespace = name_space
                                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "manu-test-data"):
                                                        self.manu_test_data = value
                                                        self.manu_test_data.value_namespace = name_space
                                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-bits"):
                                                        self.mfg_bits = value
                                                        self.mfg_bits.value_namespace = name_space
                                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mfg-deviation"):
                                                        self.mfg_deviation = value
                                                        self.mfg_deviation.value_namespace = name_space
                                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "oem-string"):
                                                        self.oem_string = value
                                                        self.oem_string.value_namespace = name_space
                                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-number"):
                                                        self.part_number = value
                                                        self.part_number.value_namespace = name_space
                                                        self.part_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "part-revision"):
                                                        self.part_revision = value
                                                        self.part_revision.value_namespace = name_space
                                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pca-num"):
                                                        self.pca_num = value
                                                        self.pca_num.value_namespace = name_space
                                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcavid"):
                                                        self.pcavid = value
                                                        self.pcavid.value_namespace = name_space
                                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pcb-serial-num"):
                                                        self.pcb_serial_num = value
                                                        self.pcb_serial_num.value_namespace = name_space
                                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pid"):
                                                        self.pid = value
                                                        self.pid.value_namespace = name_space
                                                        self.pid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-consumption"):
                                                        self.power_consumption = value
                                                        self.power_consumption.value_namespace = name_space
                                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "power-supply-type"):
                                                        self.power_supply_type = value
                                                        self.power_supply_type.value_namespace = name_space
                                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "product-id"):
                                                        self.product_id = value
                                                        self.product_id.value_namespace = name_space
                                                        self.product_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rma-code"):
                                                        self.rma_code = value
                                                        self.rma_code.value_namespace = name_space
                                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "serial-number"):
                                                        self.serial_number = value
                                                        self.serial_number.value_namespace = name_space
                                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "snmpoid"):
                                                        self.snmpoid = value
                                                        self.snmpoid.value_namespace = name_space
                                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-part-num"):
                                                        self.top_assem_part_num = value
                                                        self.top_assem_part_num.value_namespace = name_space
                                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "top-assem-vid"):
                                                        self.top_assem_vid = value
                                                        self.top_assem_vid.value_namespace = name_space
                                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-description"):
                                                        self.udi_description = value
                                                        self.udi_description.value_namespace = name_space
                                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "udi-name"):
                                                        self.udi_name = value
                                                        self.udi_name.value_namespace = name_space
                                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "vid"):
                                                        self.vid = value
                                                        self.vid.value_namespace = name_space
                                                        self.vid.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.description.is_set or
                                                    self.has_eeprom.is_set or
                                                    self.inv_card_type.is_set or
                                                    self.opaque_data.is_set or
                                                    self.opaque_data_size.is_set or
                                                    (self.eeprom is not None and self.eeprom.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.description.yfilter != YFilter.not_set or
                                                    self.has_eeprom.yfilter != YFilter.not_set or
                                                    self.inv_card_type.yfilter != YFilter.not_set or
                                                    self.opaque_data.yfilter != YFilter.not_set or
                                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                                    (self.eeprom is not None and self.eeprom.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inv-eeprom-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.description.get_name_leafdata())
                                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "eeprom"):
                                                    if (self.eeprom is None):
                                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo.Eeprom()
                                                        self.eeprom.parent = self
                                                        self._children_name_map["eeprom"] = "eeprom"
                                                    return self.eeprom

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "description"):
                                                    self.description = value
                                                    self.description.value_namespace = name_space
                                                    self.description.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-eeprom"):
                                                    self.has_eeprom = value
                                                    self.has_eeprom.value_namespace = name_space
                                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                                if(value_path == "inv-card-type"):
                                                    self.inv_card_type = value
                                                    self.inv_card_type.value_namespace = name_space
                                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data"):
                                                    self.opaque_data = value
                                                    self.opaque_data.value_namespace = name_space
                                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                                if(value_path == "opaque-data-size"):
                                                    self.opaque_data_size = value
                                                    self.opaque_data_size.value_namespace = name_space
                                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.module_done.is_set or
                                                self.node_id.is_set or
                                                self.vm_done.is_set or
                                                self.vm_node_id.is_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                                (self.fru_info is not None and self.fru_info.has_data()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                                (self.threshold is not None and self.threshold.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.module_done.yfilter != YFilter.not_set or
                                                self.node_id.yfilter != YFilter.not_set or
                                                self.vm_done.yfilter != YFilter.not_set or
                                                self.vm_node_id.yfilter != YFilter.not_set or
                                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                                (self.threshold is not None and self.threshold.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attributes" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.module_done.get_name_leafdata())
                                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.node_id.get_name_leafdata())
                                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "env-sensor-info"):
                                                if (self.env_sensor_info is None):
                                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfo()
                                                    self.env_sensor_info.parent = self
                                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                                return self.env_sensor_info

                                            if (child_yang_name == "env-sensor-info-xml"):
                                                if (self.env_sensor_info_xml is None):
                                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.EnvSensorInfoXml()
                                                    self.env_sensor_info_xml.parent = self
                                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                                return self.env_sensor_info_xml

                                            if (child_yang_name == "fru-info"):
                                                if (self.fru_info is None):
                                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.FruInfo()
                                                    self.fru_info.parent = self
                                                    self._children_name_map["fru_info"] = "fru-info"
                                                return self.fru_info

                                            if (child_yang_name == "inv-asset-bag"):
                                                if (self.inv_asset_bag is None):
                                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvAssetBag()
                                                    self.inv_asset_bag.parent = self
                                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                                return self.inv_asset_bag

                                            if (child_yang_name == "inv-basic-bag"):
                                                if (self.inv_basic_bag is None):
                                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvBasicBag()
                                                    self.inv_basic_bag.parent = self
                                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                                return self.inv_basic_bag

                                            if (child_yang_name == "inv-eeprom-info"):
                                                if (self.inv_eeprom_info is None):
                                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.InvEepromInfo()
                                                    self.inv_eeprom_info.parent = self
                                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                                return self.inv_eeprom_info

                                            if (child_yang_name == "pwg-info"):
                                                if (self.pwg_info is None):
                                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.PwgInfo()
                                                    self.pwg_info.parent = self
                                                    self._children_name_map["pwg_info"] = "pwg-info"
                                                return self.pwg_info

                                            if (child_yang_name == "threshold"):
                                                if (self.threshold is None):
                                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes.Threshold()
                                                    self.threshold.parent = self
                                                    self._children_name_map["threshold"] = "threshold"
                                                return self.threshold

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "module-done"):
                                                self.module_done = value
                                                self.module_done.value_namespace = name_space
                                                self.module_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "node-id"):
                                                self.node_id = value
                                                self.node_id.value_namespace = name_space
                                                self.node_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-done"):
                                                self.vm_done = value
                                                self.vm_done.value_namespace = name_space
                                                self.vm_done.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vm-node-id"):
                                                self.vm_node_id = value
                                                self.vm_node_id.value_namespace = name_space
                                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.name.is_set or
                                            (self.attributes is not None and self.attributes.has_data()) or
                                            (self.tsi3s is not None and self.tsi3s.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            (self.attributes is not None and self.attributes.has_operation()) or
                                            (self.tsi3s is not None and self.tsi3s.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tsi2" + "[name='" + self.name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attributes"):
                                            if (self.attributes is None):
                                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Attributes()
                                                self.attributes.parent = self
                                                self._children_name_map["attributes"] = "attributes"
                                            return self.attributes

                                        if (child_yang_name == "tsi3s"):
                                            if (self.tsi3s is None):
                                                self.tsi3s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2.Tsi3S()
                                                self.tsi3s.parent = self
                                                self._children_name_map["tsi3s"] = "tsi3s"
                                            return self.tsi3s

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attributes" or name == "tsi3s" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.tsi2:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.tsi2:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tsi2s" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "tsi2"):
                                        for c in self.tsi2:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S.Tsi2()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.tsi2.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "tsi2"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Attributes(Entity):
                                """
                                Attributes
                                
                                .. attribute:: env_sensor_info
                                
                                	Environment sensor info
                                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo>`
                                
                                .. attribute:: env_sensor_info_xml
                                
                                	Environment sensor info XML
                                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml>`
                                
                                .. attribute:: fru_info
                                
                                	Inventory EDM FRU info
                                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo>`
                                
                                .. attribute:: inv_asset_bag
                                
                                	Inventory Asset Bag
                                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag>`
                                
                                .. attribute:: inv_basic_bag
                                
                                	Inventory Basic Bag
                                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag>`
                                
                                .. attribute:: inv_eeprom_info
                                
                                	Inventory EDM EEPROM Information Bag
                                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo>`
                                
                                .. attribute:: module_done
                                
                                	Inventory EDM Module Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**default value**\: 1
                                
                                .. attribute:: node_id
                                
                                	Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: pwg_info
                                
                                	Inventory EDM PWG info
                                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo>`
                                
                                .. attribute:: threshold
                                
                                	Threshold
                                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold>`
                                
                                .. attribute:: vm_done
                                
                                	VM Done Tuple
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vm_node_id
                                
                                	VM Node ID Tuple
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes, self).__init__()

                                    self.yang_name = "attributes"
                                    self.yang_parent_name = "tsi1"

                                    self.module_done = YLeaf(YType.int32, "module-done")

                                    self.node_id = YLeaf(YType.uint32, "node-id")

                                    self.vm_done = YLeaf(YType.int32, "vm-done")

                                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                    self._children_yang_names.add("env-sensor-info")

                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                    self._children_yang_names.add("env-sensor-info-xml")

                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                    self._children_yang_names.add("fru-info")

                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                    self._children_yang_names.add("inv-asset-bag")

                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                    self._children_yang_names.add("inv-basic-bag")

                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                    self._children_yang_names.add("inv-eeprom-info")

                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                    self._children_yang_names.add("pwg-info")

                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                    self._children_yang_names.add("threshold")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("module_done",
                                                    "node_id",
                                                    "vm_done",
                                                    "vm_node_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes, self).__setattr__(name, value)


                                class EnvSensorInfo(Entity):
                                    """
                                    Environment sensor info
                                    
                                    .. attribute:: age_time_stamp
                                    
                                    	Age of the sensor value; set to the current time if directly access the value from sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: alarm_type
                                    
                                    	Indicates threshold violation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: device_description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: device_id
                                    
                                    	Identifier for this device
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: field_validity_bitmap
                                    
                                    	Sensor valid bitmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: precision
                                    
                                    	Sensor precision range
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: scale
                                    
                                    	Sensor scale enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state enums
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__init__()

                                        self.yang_name = "env-sensor-info"
                                        self.yang_parent_name = "attributes"

                                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                        self.data_type = YLeaf(YType.uint32, "data-type")

                                        self.device_description = YLeaf(YType.str, "device-description")

                                        self.device_id = YLeaf(YType.uint32, "device-id")

                                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                        self.precision = YLeaf(YType.uint32, "precision")

                                        self.scale = YLeaf(YType.uint32, "scale")

                                        self.status = YLeaf(YType.uint32, "status")

                                        self.units = YLeaf(YType.str, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.uint32, "value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("age_time_stamp",
                                                        "alarm_type",
                                                        "data_type",
                                                        "device_description",
                                                        "device_id",
                                                        "field_validity_bitmap",
                                                        "precision",
                                                        "scale",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.age_time_stamp.is_set or
                                            self.alarm_type.is_set or
                                            self.data_type.is_set or
                                            self.device_description.is_set or
                                            self.device_id.is_set or
                                            self.field_validity_bitmap.is_set or
                                            self.precision.is_set or
                                            self.scale.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.age_time_stamp.yfilter != YFilter.not_set or
                                            self.alarm_type.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.device_description.yfilter != YFilter.not_set or
                                            self.device_id.yfilter != YFilter.not_set or
                                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                                            self.precision.yfilter != YFilter.not_set or
                                            self.scale.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_description.get_name_leafdata())
                                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.device_id.get_name_leafdata())
                                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.precision.get_name_leafdata())
                                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.scale.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "age-time-stamp"):
                                            self.age_time_stamp = value
                                            self.age_time_stamp.value_namespace = name_space
                                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                        if(value_path == "alarm-type"):
                                            self.alarm_type = value
                                            self.alarm_type.value_namespace = name_space
                                            self.alarm_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-description"):
                                            self.device_description = value
                                            self.device_description.value_namespace = name_space
                                            self.device_description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "device-id"):
                                            self.device_id = value
                                            self.device_id.value_namespace = name_space
                                            self.device_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "field-validity-bitmap"):
                                            self.field_validity_bitmap = value
                                            self.field_validity_bitmap.value_namespace = name_space
                                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                        if(value_path == "precision"):
                                            self.precision = value
                                            self.precision.value_namespace = name_space
                                            self.precision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "scale"):
                                            self.scale = value
                                            self.scale.value_namespace = name_space
                                            self.scale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class PwgInfo(Entity):
                                    """
                                    Inventory EDM PWG info
                                    
                                    .. attribute:: power_group_available_current
                                    
                                    	available current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_drawn_current
                                    
                                    	drawn current
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_group_power_units
                                    
                                    	power units
                                    	**type**\:  str
                                    
                                    .. attribute:: power_group_redundancy_mode
                                    
                                    	redundancy mode
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__init__()

                                        self.yang_name = "pwg-info"
                                        self.yang_parent_name = "attributes"

                                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("power_group_available_current",
                                                        "power_group_drawn_current",
                                                        "power_group_power_units",
                                                        "power_group_redundancy_mode") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.power_group_available_current.is_set or
                                            self.power_group_drawn_current.is_set or
                                            self.power_group_power_units.is_set or
                                            self.power_group_redundancy_mode.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.power_group_available_current.yfilter != YFilter.not_set or
                                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                                            self.power_group_power_units.yfilter != YFilter.not_set or
                                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pwg-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "power-group-available-current"):
                                            self.power_group_available_current = value
                                            self.power_group_available_current.value_namespace = name_space
                                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-drawn-current"):
                                            self.power_group_drawn_current = value
                                            self.power_group_drawn_current.value_namespace = name_space
                                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-power-units"):
                                            self.power_group_power_units = value
                                            self.power_group_power_units.value_namespace = name_space
                                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-group-redundancy-mode"):
                                            self.power_group_redundancy_mode = value
                                            self.power_group_redundancy_mode.value_namespace = name_space
                                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                                class EnvSensorInfoXml(Entity):
                                    """
                                    Environment sensor info XML
                                    
                                    .. attribute:: data_type
                                    
                                    	Sensor data type
                                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                                    
                                    .. attribute:: description
                                    
                                    	Device Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: status
                                    
                                    	Sensor operation state
                                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                                    
                                    .. attribute:: threshold
                                    
                                    	Threshold information
                                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold>`
                                    
                                    .. attribute:: units
                                    
                                    	Units of variable being read
                                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                                    
                                    .. attribute:: update_rate
                                    
                                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: value
                                    
                                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__init__()

                                        self.yang_name = "env-sensor-info-xml"
                                        self.yang_parent_name = "attributes"

                                        self.data_type = YLeaf(YType.enumeration, "data-type")

                                        self.description = YLeaf(YType.str, "description")

                                        self.status = YLeaf(YType.enumeration, "status")

                                        self.units = YLeaf(YType.enumeration, "units")

                                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                                        self.value = YLeaf(YType.str, "value")

                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                        self._children_yang_names.add("threshold")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("data_type",
                                                        "description",
                                                        "status",
                                                        "units",
                                                        "update_rate",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                                    class Threshold(Entity):
                                        """
                                        Threshold information
                                        
                                        .. attribute:: threshold_array
                                        
                                        	Array of threshold
                                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                            self.yang_name = "threshold"
                                            self.yang_parent_name = "env-sensor-info-xml"

                                            self.threshold_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                        class ThresholdArray(Entity):
                                            """
                                            Array of threshold
                                            
                                            .. attribute:: threshold_name
                                            
                                            	Threshold name
                                            	**type**\:  str
                                            
                                            	**length:** 0..50
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                                self.yang_name = "threshold-array"
                                                self.yang_parent_name = "threshold"

                                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_name",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_name.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_name.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "threshold-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-name"):
                                                    self.threshold_name = value
                                                    self.threshold_name.value_namespace = name_space
                                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.threshold_array:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.threshold_array:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "threshold" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "threshold-array"):
                                                for c in self.threshold_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.threshold_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "threshold-array"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.data_type.is_set or
                                            self.description.is_set or
                                            self.status.is_set or
                                            self.units.is_set or
                                            self.update_rate.is_set or
                                            self.value.is_set or
                                            (self.threshold is not None and self.threshold.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.data_type.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set or
                                            self.units.yfilter != YFilter.not_set or
                                            self.update_rate.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set or
                                            (self.threshold is not None and self.threshold.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "env-sensor-info-xml" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_type.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())
                                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.units.get_name_leafdata())
                                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "threshold"):
                                            if (self.threshold is None):
                                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml.Threshold()
                                                self.threshold.parent = self
                                                self._children_name_map["threshold"] = "threshold"
                                            return self.threshold

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "data-type"):
                                            self.data_type = value
                                            self.data_type.value_namespace = name_space
                                            self.data_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix
                                        if(value_path == "units"):
                                            self.units = value
                                            self.units.value_namespace = name_space
                                            self.units.value_namespace_prefix = name_space_prefix
                                        if(value_path == "update-rate"):
                                            self.update_rate = value
                                            self.update_rate.value_namespace = name_space
                                            self.update_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix


                                class InvAssetBag(Entity):
                                    """
                                    Inventory Asset Bag
                                    
                                    .. attribute:: manufacturer_assembly_number
                                    
                                    	Manufacture Assembly number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_assembly_revision
                                    
                                    	Manufacture assembly revision
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_common_language_equipment_identifier
                                    
                                    	Common Language Equipment           Identifier number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_firmware_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: manufacturer_software_identifier
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: original_equipment_manufacturer_string
                                    
                                    	String containing OEM information           if applicable
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: part_number
                                    
                                    	
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__init__()

                                        self.yang_name = "inv-asset-bag"
                                        self.yang_parent_name = "attributes"

                                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                        self.part_number = YLeaf(YType.str, "part-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("manufacturer_assembly_number",
                                                        "manufacturer_assembly_revision",
                                                        "manufacturer_common_language_equipment_identifier",
                                                        "manufacturer_firmware_identifier",
                                                        "manufacturer_software_identifier",
                                                        "original_equipment_manufacturer_string",
                                                        "part_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.manufacturer_assembly_number.is_set or
                                            self.manufacturer_assembly_revision.is_set or
                                            self.manufacturer_common_language_equipment_identifier.is_set or
                                            self.manufacturer_firmware_identifier.is_set or
                                            self.manufacturer_software_identifier.is_set or
                                            self.original_equipment_manufacturer_string.is_set or
                                            self.part_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                            self.part_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-asset-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.part_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "manufacturer-assembly-number"):
                                            self.manufacturer_assembly_number = value
                                            self.manufacturer_assembly_number.value_namespace = name_space
                                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-assembly-revision"):
                                            self.manufacturer_assembly_revision = value
                                            self.manufacturer_assembly_revision.value_namespace = name_space
                                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                                            self.manufacturer_common_language_equipment_identifier = value
                                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-firmware-identifier"):
                                            self.manufacturer_firmware_identifier = value
                                            self.manufacturer_firmware_identifier.value_namespace = name_space
                                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-software-identifier"):
                                            self.manufacturer_software_identifier = value
                                            self.manufacturer_software_identifier.value_namespace = name_space
                                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "original-equipment-manufacturer-string"):
                                            self.original_equipment_manufacturer_string = value
                                            self.original_equipment_manufacturer_string.value_namespace = name_space
                                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                        if(value_path == "part-number"):
                                            self.part_number = value
                                            self.part_number.value_namespace = name_space
                                            self.part_number.value_namespace_prefix = name_space_prefix


                                class Threshold(Entity):
                                    """
                                    Threshold
                                    
                                    .. attribute:: critical_hi
                                    
                                    	Critical High
                                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi>`
                                    
                                    .. attribute:: critical_lo
                                    
                                    	Critical Low
                                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo>`
                                    
                                    .. attribute:: major_hi
                                    
                                    	Major High
                                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi>`
                                    
                                    .. attribute:: major_lo
                                    
                                    	Major Low
                                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo>`
                                    
                                    .. attribute:: minor_hi
                                    
                                    	Minor High
                                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi>`
                                    
                                    .. attribute:: minor_lo
                                    
                                    	Minor Low
                                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo>`
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold, self).__init__()

                                        self.yang_name = "threshold"
                                        self.yang_parent_name = "attributes"

                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                        self._children_yang_names.add("critical-hi")

                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                        self._children_yang_names.add("critical-lo")

                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                        self._children_yang_names.add("major-hi")

                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                        self._children_yang_names.add("major-lo")

                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                        self._children_yang_names.add("minor-hi")

                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                        self._children_yang_names.add("minor-lo")


                                    class MajorLo(Entity):
                                        """
                                        Major Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo, self).__init__()

                                            self.yang_name = "major-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalHi(Entity):
                                        """
                                        Critical High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi, self).__init__()

                                            self.yang_name = "critical-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorHi(Entity):
                                        """
                                        Minor High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi, self).__init__()

                                            self.yang_name = "minor-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MajorHi(Entity):
                                        """
                                        Major High
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi, self).__init__()

                                            self.yang_name = "major-hi"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "major-hi"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "major-hi" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class CriticalLo(Entity):
                                        """
                                        Critical Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo, self).__init__()

                                            self.yang_name = "critical-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "critical-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "critical-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class MinorLo(Entity):
                                        """
                                        Minor Low
                                        
                                        .. attribute:: thresh_bag
                                        
                                        	Environment threshold info
                                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag>`
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo, self).__init__()

                                            self.yang_name = "minor-lo"
                                            self.yang_parent_name = "threshold"

                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                            self._children_yang_names.add("thresh-bag")


                                        class ThreshBag(Entity):
                                            """
                                            Environment threshold info
                                            
                                            .. attribute:: threshold_evaluation
                                            
                                            	Indicates the result of the most recent evaluation of the thresholD
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_notification_enabled
                                            
                                            	Indicates whether or not a notification should result, in case of threshold violation
                                            	**type**\:  bool
                                            
                                            .. attribute:: threshold_relation
                                            
                                            	Indicates relation between sensor value and threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_severity
                                            
                                            	Indicates minor, major, critical severities
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: threshold_value
                                            
                                            	Value of the configured threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                                self.yang_name = "thresh-bag"
                                                self.yang_parent_name = "minor-lo"

                                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("threshold_evaluation",
                                                                "threshold_notification_enabled",
                                                                "threshold_relation",
                                                                "threshold_severity",
                                                                "threshold_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.threshold_evaluation.is_set or
                                                    self.threshold_notification_enabled.is_set or
                                                    self.threshold_relation.is_set or
                                                    self.threshold_severity.is_set or
                                                    self.threshold_value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                                    self.threshold_relation.yfilter != YFilter.not_set or
                                                    self.threshold_severity.yfilter != YFilter.not_set or
                                                    self.threshold_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "thresh-bag" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "threshold-evaluation"):
                                                    self.threshold_evaluation = value
                                                    self.threshold_evaluation.value_namespace = name_space
                                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-notification-enabled"):
                                                    self.threshold_notification_enabled = value
                                                    self.threshold_notification_enabled.value_namespace = name_space
                                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-relation"):
                                                    self.threshold_relation = value
                                                    self.threshold_relation.value_namespace = name_space
                                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-severity"):
                                                    self.threshold_severity = value
                                                    self.threshold_severity.value_namespace = name_space
                                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                                if(value_path == "threshold-value"):
                                                    self.threshold_value = value
                                                    self.threshold_value.value_namespace = name_space
                                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "minor-lo" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "thresh-bag"):
                                                if (self.thresh_bag is None):
                                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo.ThreshBag()
                                                    self.thresh_bag.parent = self
                                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                                return self.thresh_bag

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "thresh-bag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                                            (self.major_hi is not None and self.major_hi.has_data()) or
                                            (self.major_lo is not None and self.major_lo.has_data()) or
                                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                                            (self.minor_lo is not None and self.minor_lo.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                            (self.major_hi is not None and self.major_hi.has_operation()) or
                                            (self.major_lo is not None and self.major_lo.has_operation()) or
                                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "critical-hi"):
                                            if (self.critical_hi is None):
                                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalHi()
                                                self.critical_hi.parent = self
                                                self._children_name_map["critical_hi"] = "critical-hi"
                                            return self.critical_hi

                                        if (child_yang_name == "critical-lo"):
                                            if (self.critical_lo is None):
                                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.CriticalLo()
                                                self.critical_lo.parent = self
                                                self._children_name_map["critical_lo"] = "critical-lo"
                                            return self.critical_lo

                                        if (child_yang_name == "major-hi"):
                                            if (self.major_hi is None):
                                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorHi()
                                                self.major_hi.parent = self
                                                self._children_name_map["major_hi"] = "major-hi"
                                            return self.major_hi

                                        if (child_yang_name == "major-lo"):
                                            if (self.major_lo is None):
                                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MajorLo()
                                                self.major_lo.parent = self
                                                self._children_name_map["major_lo"] = "major-lo"
                                            return self.major_lo

                                        if (child_yang_name == "minor-hi"):
                                            if (self.minor_hi is None):
                                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorHi()
                                                self.minor_hi.parent = self
                                                self._children_name_map["minor_hi"] = "minor-hi"
                                            return self.minor_hi

                                        if (child_yang_name == "minor-lo"):
                                            if (self.minor_lo is None):
                                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold.MinorLo()
                                                self.minor_lo.parent = self
                                                self._children_name_map["minor_lo"] = "minor-lo"
                                            return self.minor_lo

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class FruInfo(Entity):
                                    """
                                    Inventory EDM FRU info
                                    
                                    .. attribute:: card_administrative_state
                                    
                                    	card admin state\: shutdown or not
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_monitor_state
                                    
                                    	card is monitored by a manager or left unmonitored
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_operational_state
                                    
                                    	card operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: card_reset_reason
                                    
                                    	card reset reason enum
                                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                                    
                                    .. attribute:: card_up_time
                                    
                                    	card up time
                                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime>`
                                    
                                    .. attribute:: last_operational_state_change
                                    
                                    	last card oper change state
                                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange>`
                                    
                                    .. attribute:: power_administrative_state
                                    
                                    	power admin state\: up or down
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_current_measurement
                                    
                                    	power current\: not implemented
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: power_operational_state
                                    
                                    	Power operation state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__init__()

                                        self.yang_name = "fru-info"
                                        self.yang_parent_name = "attributes"

                                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                        self._children_yang_names.add("card-up-time")

                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                        self._children_yang_names.add("last-operational-state-change")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("card_administrative_state",
                                                        "card_monitor_state",
                                                        "card_operational_state",
                                                        "card_reset_reason",
                                                        "power_administrative_state",
                                                        "power_current_measurement",
                                                        "power_operational_state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo, self).__setattr__(name, value)


                                    class LastOperationalStateChange(Entity):
                                        """
                                        last card oper change state
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                            self.yang_name = "last-operational-state-change"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-operational-state-change" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                                    class CardUpTime(Entity):
                                        """
                                        card up time
                                        
                                        .. attribute:: time_in_nano_seconds
                                        
                                        	Time Value in Nano\-seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: time_in_seconds
                                        
                                        	Time Value in Seconds
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__init__()

                                            self.yang_name = "card-up-time"
                                            self.yang_parent_name = "fru-info"

                                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("time_in_nano_seconds",
                                                            "time_in_seconds") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.time_in_nano_seconds.is_set or
                                                self.time_in_seconds.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                                self.time_in_seconds.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "card-up-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "time-in-nano-seconds"):
                                                self.time_in_nano_seconds = value
                                                self.time_in_nano_seconds.value_namespace = name_space
                                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                            if(value_path == "time-in-seconds"):
                                                self.time_in_seconds = value
                                                self.time_in_seconds.value_namespace = name_space
                                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.card_administrative_state.is_set or
                                            self.card_monitor_state.is_set or
                                            self.card_operational_state.is_set or
                                            self.card_reset_reason.is_set or
                                            self.power_administrative_state.is_set or
                                            self.power_current_measurement.is_set or
                                            self.power_operational_state.is_set or
                                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.card_administrative_state.yfilter != YFilter.not_set or
                                            self.card_monitor_state.yfilter != YFilter.not_set or
                                            self.card_operational_state.yfilter != YFilter.not_set or
                                            self.card_reset_reason.yfilter != YFilter.not_set or
                                            self.power_administrative_state.yfilter != YFilter.not_set or
                                            self.power_current_measurement.yfilter != YFilter.not_set or
                                            self.power_operational_state.yfilter != YFilter.not_set or
                                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fru-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "card-up-time"):
                                            if (self.card_up_time is None):
                                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.CardUpTime()
                                                self.card_up_time.parent = self
                                                self._children_name_map["card_up_time"] = "card-up-time"
                                            return self.card_up_time

                                        if (child_yang_name == "last-operational-state-change"):
                                            if (self.last_operational_state_change is None):
                                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo.LastOperationalStateChange()
                                                self.last_operational_state_change.parent = self
                                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                            return self.last_operational_state_change

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "card-administrative-state"):
                                            self.card_administrative_state = value
                                            self.card_administrative_state.value_namespace = name_space
                                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-monitor-state"):
                                            self.card_monitor_state = value
                                            self.card_monitor_state.value_namespace = name_space
                                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-operational-state"):
                                            self.card_operational_state = value
                                            self.card_operational_state.value_namespace = name_space
                                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "card-reset-reason"):
                                            self.card_reset_reason = value
                                            self.card_reset_reason.value_namespace = name_space
                                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-administrative-state"):
                                            self.power_administrative_state = value
                                            self.power_administrative_state.value_namespace = name_space
                                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-current-measurement"):
                                            self.power_current_measurement = value
                                            self.power_current_measurement.value_namespace = name_space
                                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                        if(value_path == "power-operational-state"):
                                            self.power_operational_state = value
                                            self.power_operational_state.value_namespace = name_space
                                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                                class InvBasicBag(Entity):
                                    """
                                    Inventory Basic Bag
                                    
                                    .. attribute:: alias
                                    
                                    	useful for storing an entity alias 
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_id_str
                                    
                                    	asset Identification string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: asset_identification
                                    
                                    	asset Identification
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ceport
                                    
                                    	1 if ce port found, 0 if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: chip_hardware_revision
                                    
                                    	chip module hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: composite_class_code
                                    
                                    	Major&minor class of the entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: description
                                    
                                    	describes in user\-readable terms       what the entity in question does
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: environmental_monitor_path
                                    
                                    	sysdb name of sensor in the envmon EDM
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: firmware_revision
                                    
                                    	firmware revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: group_flag
                                    
                                    	indicates if this entity is group       or not
                                    	**type**\:  bool
                                    
                                    .. attribute:: hardware_revision
                                    
                                    	hw revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: is_field_replaceable_unit
                                    
                                    	1 if Field Replaceable Unit 0, if not
                                    	**type**\:  bool
                                    
                                    .. attribute:: manufacturer_asset_tags
                                    
                                    	Manufacture Asset Tags
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: manufacturer_name
                                    
                                    	manufacturer's name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: memory_size
                                    
                                    	Size of memory associated with       the entity where applicable
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: model_name
                                    
                                    	model name
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: name
                                    
                                    	name string for the entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: new_deviation_number
                                    
                                    	integer value for New Deviation Number 0x88
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: physical_layer_interface_module_type
                                    
                                    	integer value for plim type if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: redundancystate
                                    
                                    	integer value for Redundancy State if     applicable to this entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: serial_number
                                    
                                    	serial number
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: software_revision
                                    
                                    	software revision string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: unique_id
                                    
                                    	Unique id for an entity
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: unrecognized_fru
                                    
                                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                                    	**type**\:  bool
                                    
                                    .. attribute:: vendor_type
                                    
                                    	maps to the vendor OID string
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: xr_scoped
                                    
                                    	1 if xr scoped, 0 if not
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__init__()

                                        self.yang_name = "inv-basic-bag"
                                        self.yang_parent_name = "attributes"

                                        self.alias = YLeaf(YType.str, "alias")

                                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                        self.ceport = YLeaf(YType.boolean, "ceport")

                                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                        self.description = YLeaf(YType.str, "description")

                                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                        self.memory_size = YLeaf(YType.int32, "memory-size")

                                        self.model_name = YLeaf(YType.str, "model-name")

                                        self.name = YLeaf(YType.str, "name")

                                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                        self.serial_number = YLeaf(YType.str, "serial-number")

                                        self.software_revision = YLeaf(YType.str, "software-revision")

                                        self.unique_id = YLeaf(YType.int32, "unique-id")

                                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("alias",
                                                        "asset_id_str",
                                                        "asset_identification",
                                                        "ceport",
                                                        "chip_hardware_revision",
                                                        "composite_class_code",
                                                        "description",
                                                        "environmental_monitor_path",
                                                        "firmware_revision",
                                                        "group_flag",
                                                        "hardware_revision",
                                                        "is_field_replaceable_unit",
                                                        "manufacturer_asset_tags",
                                                        "manufacturer_name",
                                                        "memory_size",
                                                        "model_name",
                                                        "name",
                                                        "new_deviation_number",
                                                        "physical_layer_interface_module_type",
                                                        "redundancystate",
                                                        "serial_number",
                                                        "software_revision",
                                                        "unique_id",
                                                        "unrecognized_fru",
                                                        "vendor_type",
                                                        "xr_scoped") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.alias.is_set or
                                            self.asset_id_str.is_set or
                                            self.asset_identification.is_set or
                                            self.ceport.is_set or
                                            self.chip_hardware_revision.is_set or
                                            self.composite_class_code.is_set or
                                            self.description.is_set or
                                            self.environmental_monitor_path.is_set or
                                            self.firmware_revision.is_set or
                                            self.group_flag.is_set or
                                            self.hardware_revision.is_set or
                                            self.is_field_replaceable_unit.is_set or
                                            self.manufacturer_asset_tags.is_set or
                                            self.manufacturer_name.is_set or
                                            self.memory_size.is_set or
                                            self.model_name.is_set or
                                            self.name.is_set or
                                            self.new_deviation_number.is_set or
                                            self.physical_layer_interface_module_type.is_set or
                                            self.redundancystate.is_set or
                                            self.serial_number.is_set or
                                            self.software_revision.is_set or
                                            self.unique_id.is_set or
                                            self.unrecognized_fru.is_set or
                                            self.vendor_type.is_set or
                                            self.xr_scoped.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.alias.yfilter != YFilter.not_set or
                                            self.asset_id_str.yfilter != YFilter.not_set or
                                            self.asset_identification.yfilter != YFilter.not_set or
                                            self.ceport.yfilter != YFilter.not_set or
                                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                                            self.composite_class_code.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                                            self.firmware_revision.yfilter != YFilter.not_set or
                                            self.group_flag.yfilter != YFilter.not_set or
                                            self.hardware_revision.yfilter != YFilter.not_set or
                                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                            self.manufacturer_name.yfilter != YFilter.not_set or
                                            self.memory_size.yfilter != YFilter.not_set or
                                            self.model_name.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set or
                                            self.new_deviation_number.yfilter != YFilter.not_set or
                                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                            self.redundancystate.yfilter != YFilter.not_set or
                                            self.serial_number.yfilter != YFilter.not_set or
                                            self.software_revision.yfilter != YFilter.not_set or
                                            self.unique_id.yfilter != YFilter.not_set or
                                            self.unrecognized_fru.yfilter != YFilter.not_set or
                                            self.vendor_type.yfilter != YFilter.not_set or
                                            self.xr_scoped.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-basic-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.alias.get_name_leafdata())
                                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ceport.get_name_leafdata())
                                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.model_name.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())
                                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "alias"):
                                            self.alias = value
                                            self.alias.value_namespace = name_space
                                            self.alias.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-id-str"):
                                            self.asset_id_str = value
                                            self.asset_id_str.value_namespace = name_space
                                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                                        if(value_path == "asset-identification"):
                                            self.asset_identification = value
                                            self.asset_identification.value_namespace = name_space
                                            self.asset_identification.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ceport"):
                                            self.ceport = value
                                            self.ceport.value_namespace = name_space
                                            self.ceport.value_namespace_prefix = name_space_prefix
                                        if(value_path == "chip-hardware-revision"):
                                            self.chip_hardware_revision = value
                                            self.chip_hardware_revision.value_namespace = name_space
                                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "composite-class-code"):
                                            self.composite_class_code = value
                                            self.composite_class_code.value_namespace = name_space
                                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "environmental-monitor-path"):
                                            self.environmental_monitor_path = value
                                            self.environmental_monitor_path.value_namespace = name_space
                                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "firmware-revision"):
                                            self.firmware_revision = value
                                            self.firmware_revision.value_namespace = name_space
                                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "group-flag"):
                                            self.group_flag = value
                                            self.group_flag.value_namespace = name_space
                                            self.group_flag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hardware-revision"):
                                            self.hardware_revision = value
                                            self.hardware_revision.value_namespace = name_space
                                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-field-replaceable-unit"):
                                            self.is_field_replaceable_unit = value
                                            self.is_field_replaceable_unit.value_namespace = name_space
                                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-asset-tags"):
                                            self.manufacturer_asset_tags = value
                                            self.manufacturer_asset_tags.value_namespace = name_space
                                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                        if(value_path == "manufacturer-name"):
                                            self.manufacturer_name = value
                                            self.manufacturer_name.value_namespace = name_space
                                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "memory-size"):
                                            self.memory_size = value
                                            self.memory_size.value_namespace = name_space
                                            self.memory_size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "model-name"):
                                            self.model_name = value
                                            self.model_name.value_namespace = name_space
                                            self.model_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "new-deviation-number"):
                                            self.new_deviation_number = value
                                            self.new_deviation_number.value_namespace = name_space
                                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "physical-layer-interface-module-type"):
                                            self.physical_layer_interface_module_type = value
                                            self.physical_layer_interface_module_type.value_namespace = name_space
                                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "redundancystate"):
                                            self.redundancystate = value
                                            self.redundancystate.value_namespace = name_space
                                            self.redundancystate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "serial-number"):
                                            self.serial_number = value
                                            self.serial_number.value_namespace = name_space
                                            self.serial_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "software-revision"):
                                            self.software_revision = value
                                            self.software_revision.value_namespace = name_space
                                            self.software_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unique-id"):
                                            self.unique_id = value
                                            self.unique_id.value_namespace = name_space
                                            self.unique_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unrecognized-fru"):
                                            self.unrecognized_fru = value
                                            self.unrecognized_fru.value_namespace = name_space
                                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vendor-type"):
                                            self.vendor_type = value
                                            self.vendor_type.value_namespace = name_space
                                            self.vendor_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "xr-scoped"):
                                            self.xr_scoped = value
                                            self.xr_scoped.value_namespace = name_space
                                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                                class InvEepromInfo(Entity):
                                    """
                                    Inventory EDM EEPROM Information Bag
                                    
                                    .. attribute:: description
                                    
                                    	A textual description of physical entity
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: eeprom
                                    
                                    	EEPROM data not from hex data
                                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom>`
                                    
                                    .. attribute:: has_eeprom
                                    
                                    	use eeprom instead of opaque data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inv_card_type
                                    
                                    	Inventory card type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: opaque_data
                                    
                                    	EEPROM hex data
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: opaque_data_size
                                    
                                    	size of the EEPROM hex data
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__init__()

                                        self.yang_name = "inv-eeprom-info"
                                        self.yang_parent_name = "attributes"

                                        self.description = YLeaf(YType.str, "description")

                                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                        self._children_yang_names.add("eeprom")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("description",
                                                        "has_eeprom",
                                                        "inv_card_type",
                                                        "opaque_data",
                                                        "opaque_data_size") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo, self).__setattr__(name, value)


                                    class Eeprom(Entity):
                                        """
                                        EEPROM data not from hex data
                                        
                                        .. attribute:: asset_alias
                                        
                                        	Asset Alias
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: asset_id
                                        
                                        	Asset ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address1
                                        
                                        	Base Mac Address #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address2
                                        
                                        	Base Mac Address #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address3
                                        
                                        	Base Mac Address #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: base_mac_address4
                                        
                                        	Base Mac Address #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_checksum
                                        
                                        	Block Checksum
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_count
                                        
                                        	Block Count
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_length
                                        
                                        	Block Length
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_signature
                                        
                                        	Block Signature
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: block_version
                                        
                                        	Block Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: chassis_sid
                                        
                                        	Chassis serial number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: clei
                                        
                                        	Common Language Equipment Identifier (CLEI) code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_family
                                        
                                        	Controller family
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: controller_type
                                        
                                        	Controller type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: description
                                        
                                        	A textual description of physical entity
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num1
                                        
                                        	Deviation Number # 1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num2
                                        
                                        	Deviation Number # 2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num3
                                        
                                        	Deviation Number # 3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num4
                                        
                                        	Deviation Number # 4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num5
                                        
                                        	Deviation Number # 5
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num6
                                        
                                        	Deviation Number # 6
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: dev_num7
                                        
                                        	Deviation Number # 7
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eci
                                        
                                        	Equipment Catalog Item (ECI) number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: eeprom_size
                                        
                                        	EEPROM Size
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: engineer_use
                                        
                                        	Engineer Use
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_major_type
                                        
                                        	FRU Major Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: fru_minor_type
                                        
                                        	FRU Minor Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hw_version
                                        
                                        	Hardware Version
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: hwid
                                        
                                        	Hardware Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: idprom_format_rev
                                        
                                        	IDPROM Format Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size1
                                        
                                        	Mac Address Block Size #1
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size2
                                        
                                        	Mac Address Block Size #2
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size3
                                        
                                        	Mac Address Block Size #3
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mac_add_blk_size4
                                        
                                        	Mac Address Block Size #4
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: manu_test_data
                                        
                                        	Manufacturing Test Data
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_bits
                                        
                                        	MFG Bits
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: mfg_deviation
                                        
                                        	MFG Deviation
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: oem_string
                                        
                                        	OEM String
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_number
                                        
                                        	Part Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: part_revision
                                        
                                        	Part Revision
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pca_num
                                        
                                        	PCA number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcavid
                                        
                                        	PCA revision ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pcb_serial_num
                                        
                                        	PCB Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: pid
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_consumption
                                        
                                        	Power Consumption
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: power_supply_type
                                        
                                        	Power Supply Type
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: product_id
                                        
                                        	Product ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: rma
                                        
                                        	RMA Data
                                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma>`
                                        
                                        .. attribute:: rma_code
                                        
                                        	RMA Code
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: serial_number
                                        
                                        	Serial Number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: snmpoid
                                        
                                        	SNMP OID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_part_num
                                        
                                        	Top assembly part number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: top_assem_vid
                                        
                                        	Top assembly revision number
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_description
                                        
                                        	UDI description
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: udi_name
                                        
                                        	UDI name
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        .. attribute:: vid
                                        
                                        	Version ID
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'invmgr-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                            self.yang_name = "eeprom"
                                            self.yang_parent_name = "inv-eeprom-info"

                                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                                            self.asset_id = YLeaf(YType.str, "asset-id")

                                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                                            self.block_count = YLeaf(YType.str, "block-count")

                                            self.block_length = YLeaf(YType.str, "block-length")

                                            self.block_signature = YLeaf(YType.str, "block-signature")

                                            self.block_version = YLeaf(YType.str, "block-version")

                                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                            self.clei = YLeaf(YType.str, "clei")

                                            self.controller_family = YLeaf(YType.str, "controller-family")

                                            self.controller_type = YLeaf(YType.str, "controller-type")

                                            self.description = YLeaf(YType.str, "description")

                                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                            self.eci = YLeaf(YType.str, "eci")

                                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                            self.hw_version = YLeaf(YType.str, "hw-version")

                                            self.hwid = YLeaf(YType.str, "hwid")

                                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                            self.oem_string = YLeaf(YType.str, "oem-string")

                                            self.part_number = YLeaf(YType.str, "part-number")

                                            self.part_revision = YLeaf(YType.str, "part-revision")

                                            self.pca_num = YLeaf(YType.str, "pca-num")

                                            self.pcavid = YLeaf(YType.str, "pcavid")

                                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                            self.pid = YLeaf(YType.str, "pid")

                                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                            self.product_id = YLeaf(YType.str, "product-id")

                                            self.rma_code = YLeaf(YType.str, "rma-code")

                                            self.serial_number = YLeaf(YType.str, "serial-number")

                                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                            self.udi_description = YLeaf(YType.str, "udi-description")

                                            self.udi_name = YLeaf(YType.str, "udi-name")

                                            self.vid = YLeaf(YType.str, "vid")

                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                            self._children_yang_names.add("rma")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("asset_alias",
                                                            "asset_id",
                                                            "base_mac_address1",
                                                            "base_mac_address2",
                                                            "base_mac_address3",
                                                            "base_mac_address4",
                                                            "block_checksum",
                                                            "block_count",
                                                            "block_length",
                                                            "block_signature",
                                                            "block_version",
                                                            "chassis_sid",
                                                            "clei",
                                                            "controller_family",
                                                            "controller_type",
                                                            "description",
                                                            "dev_num1",
                                                            "dev_num2",
                                                            "dev_num3",
                                                            "dev_num4",
                                                            "dev_num5",
                                                            "dev_num6",
                                                            "dev_num7",
                                                            "eci",
                                                            "eeprom_size",
                                                            "engineer_use",
                                                            "fru_major_type",
                                                            "fru_minor_type",
                                                            "hw_version",
                                                            "hwid",
                                                            "idprom_format_rev",
                                                            "mac_add_blk_size1",
                                                            "mac_add_blk_size2",
                                                            "mac_add_blk_size3",
                                                            "mac_add_blk_size4",
                                                            "manu_test_data",
                                                            "mfg_bits",
                                                            "mfg_deviation",
                                                            "oem_string",
                                                            "part_number",
                                                            "part_revision",
                                                            "pca_num",
                                                            "pcavid",
                                                            "pcb_serial_num",
                                                            "pid",
                                                            "power_consumption",
                                                            "power_supply_type",
                                                            "product_id",
                                                            "rma_code",
                                                            "serial_number",
                                                            "snmpoid",
                                                            "top_assem_part_num",
                                                            "top_assem_vid",
                                                            "udi_description",
                                                            "udi_name",
                                                            "vid") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                        class Rma(Entity):
                                            """
                                            RMA Data
                                            
                                            .. attribute:: rma_history
                                            
                                            	RMA history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: rma_number
                                            
                                            	RMA tracking number format is N\-N\-N
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            .. attribute:: test_history
                                            
                                            	Test history
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'invmgr-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                                self.yang_name = "rma"
                                                self.yang_parent_name = "eeprom"

                                                self.rma_history = YLeaf(YType.str, "rma-history")

                                                self.rma_number = YLeaf(YType.str, "rma-number")

                                                self.test_history = YLeaf(YType.str, "test-history")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("rma_history",
                                                                "rma_number",
                                                                "test_history") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.rma_history.is_set or
                                                    self.rma_number.is_set or
                                                    self.test_history.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.rma_history.yfilter != YFilter.not_set or
                                                    self.rma_number.yfilter != YFilter.not_set or
                                                    self.test_history.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "rma" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "rma-history"):
                                                    self.rma_history = value
                                                    self.rma_history.value_namespace = name_space
                                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rma-number"):
                                                    self.rma_number = value
                                                    self.rma_number.value_namespace = name_space
                                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                                if(value_path == "test-history"):
                                                    self.test_history = value
                                                    self.test_history.value_namespace = name_space
                                                    self.test_history.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.asset_alias.is_set or
                                                self.asset_id.is_set or
                                                self.base_mac_address1.is_set or
                                                self.base_mac_address2.is_set or
                                                self.base_mac_address3.is_set or
                                                self.base_mac_address4.is_set or
                                                self.block_checksum.is_set or
                                                self.block_count.is_set or
                                                self.block_length.is_set or
                                                self.block_signature.is_set or
                                                self.block_version.is_set or
                                                self.chassis_sid.is_set or
                                                self.clei.is_set or
                                                self.controller_family.is_set or
                                                self.controller_type.is_set or
                                                self.description.is_set or
                                                self.dev_num1.is_set or
                                                self.dev_num2.is_set or
                                                self.dev_num3.is_set or
                                                self.dev_num4.is_set or
                                                self.dev_num5.is_set or
                                                self.dev_num6.is_set or
                                                self.dev_num7.is_set or
                                                self.eci.is_set or
                                                self.eeprom_size.is_set or
                                                self.engineer_use.is_set or
                                                self.fru_major_type.is_set or
                                                self.fru_minor_type.is_set or
                                                self.hw_version.is_set or
                                                self.hwid.is_set or
                                                self.idprom_format_rev.is_set or
                                                self.mac_add_blk_size1.is_set or
                                                self.mac_add_blk_size2.is_set or
                                                self.mac_add_blk_size3.is_set or
                                                self.mac_add_blk_size4.is_set or
                                                self.manu_test_data.is_set or
                                                self.mfg_bits.is_set or
                                                self.mfg_deviation.is_set or
                                                self.oem_string.is_set or
                                                self.part_number.is_set or
                                                self.part_revision.is_set or
                                                self.pca_num.is_set or
                                                self.pcavid.is_set or
                                                self.pcb_serial_num.is_set or
                                                self.pid.is_set or
                                                self.power_consumption.is_set or
                                                self.power_supply_type.is_set or
                                                self.product_id.is_set or
                                                self.rma_code.is_set or
                                                self.serial_number.is_set or
                                                self.snmpoid.is_set or
                                                self.top_assem_part_num.is_set or
                                                self.top_assem_vid.is_set or
                                                self.udi_description.is_set or
                                                self.udi_name.is_set or
                                                self.vid.is_set or
                                                (self.rma is not None and self.rma.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.asset_alias.yfilter != YFilter.not_set or
                                                self.asset_id.yfilter != YFilter.not_set or
                                                self.base_mac_address1.yfilter != YFilter.not_set or
                                                self.base_mac_address2.yfilter != YFilter.not_set or
                                                self.base_mac_address3.yfilter != YFilter.not_set or
                                                self.base_mac_address4.yfilter != YFilter.not_set or
                                                self.block_checksum.yfilter != YFilter.not_set or
                                                self.block_count.yfilter != YFilter.not_set or
                                                self.block_length.yfilter != YFilter.not_set or
                                                self.block_signature.yfilter != YFilter.not_set or
                                                self.block_version.yfilter != YFilter.not_set or
                                                self.chassis_sid.yfilter != YFilter.not_set or
                                                self.clei.yfilter != YFilter.not_set or
                                                self.controller_family.yfilter != YFilter.not_set or
                                                self.controller_type.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.dev_num1.yfilter != YFilter.not_set or
                                                self.dev_num2.yfilter != YFilter.not_set or
                                                self.dev_num3.yfilter != YFilter.not_set or
                                                self.dev_num4.yfilter != YFilter.not_set or
                                                self.dev_num5.yfilter != YFilter.not_set or
                                                self.dev_num6.yfilter != YFilter.not_set or
                                                self.dev_num7.yfilter != YFilter.not_set or
                                                self.eci.yfilter != YFilter.not_set or
                                                self.eeprom_size.yfilter != YFilter.not_set or
                                                self.engineer_use.yfilter != YFilter.not_set or
                                                self.fru_major_type.yfilter != YFilter.not_set or
                                                self.fru_minor_type.yfilter != YFilter.not_set or
                                                self.hw_version.yfilter != YFilter.not_set or
                                                self.hwid.yfilter != YFilter.not_set or
                                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                                self.manu_test_data.yfilter != YFilter.not_set or
                                                self.mfg_bits.yfilter != YFilter.not_set or
                                                self.mfg_deviation.yfilter != YFilter.not_set or
                                                self.oem_string.yfilter != YFilter.not_set or
                                                self.part_number.yfilter != YFilter.not_set or
                                                self.part_revision.yfilter != YFilter.not_set or
                                                self.pca_num.yfilter != YFilter.not_set or
                                                self.pcavid.yfilter != YFilter.not_set or
                                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                                self.pid.yfilter != YFilter.not_set or
                                                self.power_consumption.yfilter != YFilter.not_set or
                                                self.power_supply_type.yfilter != YFilter.not_set or
                                                self.product_id.yfilter != YFilter.not_set or
                                                self.rma_code.yfilter != YFilter.not_set or
                                                self.serial_number.yfilter != YFilter.not_set or
                                                self.snmpoid.yfilter != YFilter.not_set or
                                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                                self.top_assem_vid.yfilter != YFilter.not_set or
                                                self.udi_description.yfilter != YFilter.not_set or
                                                self.udi_name.yfilter != YFilter.not_set or
                                                self.vid.yfilter != YFilter.not_set or
                                                (self.rma is not None and self.rma.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "eeprom" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_count.get_name_leafdata())
                                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_length.get_name_leafdata())
                                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.block_version.get_name_leafdata())
                                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.clei.get_name_leafdata())
                                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eci.get_name_leafdata())
                                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hwid.get_name_leafdata())
                                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_number.get_name_leafdata())
                                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pid.get_name_leafdata())
                                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.product_id.get_name_leafdata())
                                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.vid.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "rma"):
                                                if (self.rma is None):
                                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom.Rma()
                                                    self.rma.parent = self
                                                    self._children_name_map["rma"] = "rma"
                                                return self.rma

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "asset-alias"):
                                                self.asset_alias = value
                                                self.asset_alias.value_namespace = name_space
                                                self.asset_alias.value_namespace_prefix = name_space_prefix
                                            if(value_path == "asset-id"):
                                                self.asset_id = value
                                                self.asset_id.value_namespace = name_space
                                                self.asset_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address1"):
                                                self.base_mac_address1 = value
                                                self.base_mac_address1.value_namespace = name_space
                                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address2"):
                                                self.base_mac_address2 = value
                                                self.base_mac_address2.value_namespace = name_space
                                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address3"):
                                                self.base_mac_address3 = value
                                                self.base_mac_address3.value_namespace = name_space
                                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "base-mac-address4"):
                                                self.base_mac_address4 = value
                                                self.base_mac_address4.value_namespace = name_space
                                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-checksum"):
                                                self.block_checksum = value
                                                self.block_checksum.value_namespace = name_space
                                                self.block_checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-count"):
                                                self.block_count = value
                                                self.block_count.value_namespace = name_space
                                                self.block_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-length"):
                                                self.block_length = value
                                                self.block_length.value_namespace = name_space
                                                self.block_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-signature"):
                                                self.block_signature = value
                                                self.block_signature.value_namespace = name_space
                                                self.block_signature.value_namespace_prefix = name_space_prefix
                                            if(value_path == "block-version"):
                                                self.block_version = value
                                                self.block_version.value_namespace = name_space
                                                self.block_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "chassis-sid"):
                                                self.chassis_sid = value
                                                self.chassis_sid.value_namespace = name_space
                                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "clei"):
                                                self.clei = value
                                                self.clei.value_namespace = name_space
                                                self.clei.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-family"):
                                                self.controller_family = value
                                                self.controller_family.value_namespace = name_space
                                                self.controller_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "controller-type"):
                                                self.controller_type = value
                                                self.controller_type.value_namespace = name_space
                                                self.controller_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num1"):
                                                self.dev_num1 = value
                                                self.dev_num1.value_namespace = name_space
                                                self.dev_num1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num2"):
                                                self.dev_num2 = value
                                                self.dev_num2.value_namespace = name_space
                                                self.dev_num2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num3"):
                                                self.dev_num3 = value
                                                self.dev_num3.value_namespace = name_space
                                                self.dev_num3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num4"):
                                                self.dev_num4 = value
                                                self.dev_num4.value_namespace = name_space
                                                self.dev_num4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num5"):
                                                self.dev_num5 = value
                                                self.dev_num5.value_namespace = name_space
                                                self.dev_num5.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num6"):
                                                self.dev_num6 = value
                                                self.dev_num6.value_namespace = name_space
                                                self.dev_num6.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dev-num7"):
                                                self.dev_num7 = value
                                                self.dev_num7.value_namespace = name_space
                                                self.dev_num7.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eci"):
                                                self.eci = value
                                                self.eci.value_namespace = name_space
                                                self.eci.value_namespace_prefix = name_space_prefix
                                            if(value_path == "eeprom-size"):
                                                self.eeprom_size = value
                                                self.eeprom_size.value_namespace = name_space
                                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                                            if(value_path == "engineer-use"):
                                                self.engineer_use = value
                                                self.engineer_use.value_namespace = name_space
                                                self.engineer_use.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-major-type"):
                                                self.fru_major_type = value
                                                self.fru_major_type.value_namespace = name_space
                                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fru-minor-type"):
                                                self.fru_minor_type = value
                                                self.fru_minor_type.value_namespace = name_space
                                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hw-version"):
                                                self.hw_version = value
                                                self.hw_version.value_namespace = name_space
                                                self.hw_version.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hwid"):
                                                self.hwid = value
                                                self.hwid.value_namespace = name_space
                                                self.hwid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "idprom-format-rev"):
                                                self.idprom_format_rev = value
                                                self.idprom_format_rev.value_namespace = name_space
                                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size1"):
                                                self.mac_add_blk_size1 = value
                                                self.mac_add_blk_size1.value_namespace = name_space
                                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size2"):
                                                self.mac_add_blk_size2 = value
                                                self.mac_add_blk_size2.value_namespace = name_space
                                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size3"):
                                                self.mac_add_blk_size3 = value
                                                self.mac_add_blk_size3.value_namespace = name_space
                                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mac-add-blk-size4"):
                                                self.mac_add_blk_size4 = value
                                                self.mac_add_blk_size4.value_namespace = name_space
                                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "manu-test-data"):
                                                self.manu_test_data = value
                                                self.manu_test_data.value_namespace = name_space
                                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-bits"):
                                                self.mfg_bits = value
                                                self.mfg_bits.value_namespace = name_space
                                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "mfg-deviation"):
                                                self.mfg_deviation = value
                                                self.mfg_deviation.value_namespace = name_space
                                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "oem-string"):
                                                self.oem_string = value
                                                self.oem_string.value_namespace = name_space
                                                self.oem_string.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-number"):
                                                self.part_number = value
                                                self.part_number.value_namespace = name_space
                                                self.part_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "part-revision"):
                                                self.part_revision = value
                                                self.part_revision.value_namespace = name_space
                                                self.part_revision.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pca-num"):
                                                self.pca_num = value
                                                self.pca_num.value_namespace = name_space
                                                self.pca_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcavid"):
                                                self.pcavid = value
                                                self.pcavid.value_namespace = name_space
                                                self.pcavid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcb-serial-num"):
                                                self.pcb_serial_num = value
                                                self.pcb_serial_num.value_namespace = name_space
                                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pid"):
                                                self.pid = value
                                                self.pid.value_namespace = name_space
                                                self.pid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-consumption"):
                                                self.power_consumption = value
                                                self.power_consumption.value_namespace = name_space
                                                self.power_consumption.value_namespace_prefix = name_space_prefix
                                            if(value_path == "power-supply-type"):
                                                self.power_supply_type = value
                                                self.power_supply_type.value_namespace = name_space
                                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "product-id"):
                                                self.product_id = value
                                                self.product_id.value_namespace = name_space
                                                self.product_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rma-code"):
                                                self.rma_code = value
                                                self.rma_code.value_namespace = name_space
                                                self.rma_code.value_namespace_prefix = name_space_prefix
                                            if(value_path == "serial-number"):
                                                self.serial_number = value
                                                self.serial_number.value_namespace = name_space
                                                self.serial_number.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snmpoid"):
                                                self.snmpoid = value
                                                self.snmpoid.value_namespace = name_space
                                                self.snmpoid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-part-num"):
                                                self.top_assem_part_num = value
                                                self.top_assem_part_num.value_namespace = name_space
                                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                            if(value_path == "top-assem-vid"):
                                                self.top_assem_vid = value
                                                self.top_assem_vid.value_namespace = name_space
                                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-description"):
                                                self.udi_description = value
                                                self.udi_description.value_namespace = name_space
                                                self.udi_description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "udi-name"):
                                                self.udi_name = value
                                                self.udi_name.value_namespace = name_space
                                                self.udi_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "vid"):
                                                self.vid = value
                                                self.vid.value_namespace = name_space
                                                self.vid.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.description.is_set or
                                            self.has_eeprom.is_set or
                                            self.inv_card_type.is_set or
                                            self.opaque_data.is_set or
                                            self.opaque_data_size.is_set or
                                            (self.eeprom is not None and self.eeprom.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.has_eeprom.yfilter != YFilter.not_set or
                                            self.inv_card_type.yfilter != YFilter.not_set or
                                            self.opaque_data.yfilter != YFilter.not_set or
                                            self.opaque_data_size.yfilter != YFilter.not_set or
                                            (self.eeprom is not None and self.eeprom.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inv-eeprom-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "eeprom"):
                                            if (self.eeprom is None):
                                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo.Eeprom()
                                                self.eeprom.parent = self
                                                self._children_name_map["eeprom"] = "eeprom"
                                            return self.eeprom

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "has-eeprom"):
                                            self.has_eeprom = value
                                            self.has_eeprom.value_namespace = name_space
                                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inv-card-type"):
                                            self.inv_card_type = value
                                            self.inv_card_type.value_namespace = name_space
                                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data"):
                                            self.opaque_data = value
                                            self.opaque_data.value_namespace = name_space
                                            self.opaque_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "opaque-data-size"):
                                            self.opaque_data_size = value
                                            self.opaque_data_size.value_namespace = name_space
                                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.module_done.is_set or
                                        self.node_id.is_set or
                                        self.vm_done.is_set or
                                        self.vm_node_id.is_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                        (self.fru_info is not None and self.fru_info.has_data()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                                        (self.threshold is not None and self.threshold.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.module_done.yfilter != YFilter.not_set or
                                        self.node_id.yfilter != YFilter.not_set or
                                        self.vm_done.yfilter != YFilter.not_set or
                                        self.vm_node_id.yfilter != YFilter.not_set or
                                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                        (self.fru_info is not None and self.fru_info.has_operation()) or
                                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                        (self.threshold is not None and self.threshold.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attributes" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.module_done.get_name_leafdata())
                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "env-sensor-info"):
                                        if (self.env_sensor_info is None):
                                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfo()
                                            self.env_sensor_info.parent = self
                                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                        return self.env_sensor_info

                                    if (child_yang_name == "env-sensor-info-xml"):
                                        if (self.env_sensor_info_xml is None):
                                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.EnvSensorInfoXml()
                                            self.env_sensor_info_xml.parent = self
                                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                        return self.env_sensor_info_xml

                                    if (child_yang_name == "fru-info"):
                                        if (self.fru_info is None):
                                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.FruInfo()
                                            self.fru_info.parent = self
                                            self._children_name_map["fru_info"] = "fru-info"
                                        return self.fru_info

                                    if (child_yang_name == "inv-asset-bag"):
                                        if (self.inv_asset_bag is None):
                                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvAssetBag()
                                            self.inv_asset_bag.parent = self
                                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                        return self.inv_asset_bag

                                    if (child_yang_name == "inv-basic-bag"):
                                        if (self.inv_basic_bag is None):
                                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvBasicBag()
                                            self.inv_basic_bag.parent = self
                                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                        return self.inv_basic_bag

                                    if (child_yang_name == "inv-eeprom-info"):
                                        if (self.inv_eeprom_info is None):
                                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.InvEepromInfo()
                                            self.inv_eeprom_info.parent = self
                                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                        return self.inv_eeprom_info

                                    if (child_yang_name == "pwg-info"):
                                        if (self.pwg_info is None):
                                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.PwgInfo()
                                            self.pwg_info.parent = self
                                            self._children_name_map["pwg_info"] = "pwg-info"
                                        return self.pwg_info

                                    if (child_yang_name == "threshold"):
                                        if (self.threshold is None):
                                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes.Threshold()
                                            self.threshold.parent = self
                                            self._children_name_map["threshold"] = "threshold"
                                        return self.threshold

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "module-done"):
                                        self.module_done = value
                                        self.module_done.value_namespace = name_space
                                        self.module_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-id"):
                                        self.node_id = value
                                        self.node_id.value_namespace = name_space
                                        self.node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-done"):
                                        self.vm_done = value
                                        self.vm_done.value_namespace = name_space
                                        self.vm_done.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vm-node-id"):
                                        self.vm_node_id = value
                                        self.vm_node_id.value_namespace = name_space
                                        self.vm_node_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.name.is_set or
                                    (self.attributes is not None and self.attributes.has_data()) or
                                    (self.tsi2s is not None and self.tsi2s.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    (self.attributes is not None and self.attributes.has_operation()) or
                                    (self.tsi2s is not None and self.tsi2s.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tsi1" + "[name='" + self.name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attributes"):
                                    if (self.attributes is None):
                                        self.attributes = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Attributes()
                                        self.attributes.parent = self
                                        self._children_name_map["attributes"] = "attributes"
                                    return self.attributes

                                if (child_yang_name == "tsi2s"):
                                    if (self.tsi2s is None):
                                        self.tsi2s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1.Tsi2S()
                                        self.tsi2s.parent = self
                                        self._children_name_map["tsi2s"] = "tsi2s"
                                    return self.tsi2s

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attributes" or name == "tsi2s" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.tsi1:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.tsi1:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tsi1s" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "tsi1"):
                                for c in self.tsi1:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Inventory.Racks.Rack.Fantray.Slot.Tsi1S.Tsi1()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.tsi1.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tsi1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Attributes(Entity):
                        """
                        Attributes
                        
                        .. attribute:: env_sensor_info
                        
                        	Environment sensor info
                        	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo>`
                        
                        .. attribute:: env_sensor_info_xml
                        
                        	Environment sensor info XML
                        	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml>`
                        
                        .. attribute:: fru_info
                        
                        	Inventory EDM FRU info
                        	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo>`
                        
                        .. attribute:: inv_asset_bag
                        
                        	Inventory Asset Bag
                        	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag>`
                        
                        .. attribute:: inv_basic_bag
                        
                        	Inventory Basic Bag
                        	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag>`
                        
                        .. attribute:: inv_eeprom_info
                        
                        	Inventory EDM EEPROM Information Bag
                        	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo>`
                        
                        .. attribute:: module_done
                        
                        	Inventory EDM Module Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**default value**\: 1
                        
                        .. attribute:: node_id
                        
                        	Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: pwg_info
                        
                        	Inventory EDM PWG info
                        	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo>`
                        
                        .. attribute:: threshold
                        
                        	Threshold
                        	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold>`
                        
                        .. attribute:: vm_done
                        
                        	VM Done Tuple
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: vm_node_id
                        
                        	VM Node ID Tuple
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes, self).__init__()

                            self.yang_name = "attributes"
                            self.yang_parent_name = "slot"

                            self.module_done = YLeaf(YType.int32, "module-done")

                            self.node_id = YLeaf(YType.uint32, "node-id")

                            self.vm_done = YLeaf(YType.int32, "vm-done")

                            self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                            self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                            self._children_yang_names.add("env-sensor-info")

                            self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                            self._children_yang_names.add("env-sensor-info-xml")

                            self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"
                            self._children_yang_names.add("fru-info")

                            self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                            self._children_yang_names.add("inv-asset-bag")

                            self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                            self._children_yang_names.add("inv-basic-bag")

                            self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                            self._children_yang_names.add("inv-eeprom-info")

                            self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"
                            self._children_yang_names.add("pwg-info")

                            self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"
                            self._children_yang_names.add("threshold")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("module_done",
                                            "node_id",
                                            "vm_done",
                                            "vm_node_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes, self).__setattr__(name, value)


                        class EnvSensorInfo(Entity):
                            """
                            Environment sensor info
                            
                            .. attribute:: age_time_stamp
                            
                            	Age of the sensor value; set to the current time if directly access the value from sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: alarm_type
                            
                            	Indicates threshold violation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: data_type
                            
                            	Sensor data type enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: device_description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: device_id
                            
                            	Identifier for this device
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: field_validity_bitmap
                            
                            	Sensor valid bitmap
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: precision
                            
                            	Sensor precision range
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: scale
                            
                            	Sensor scale enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	Sensor operation state enums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo, self).__init__()

                                self.yang_name = "env-sensor-info"
                                self.yang_parent_name = "attributes"

                                self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                                self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                                self.data_type = YLeaf(YType.uint32, "data-type")

                                self.device_description = YLeaf(YType.str, "device-description")

                                self.device_id = YLeaf(YType.uint32, "device-id")

                                self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                                self.precision = YLeaf(YType.uint32, "precision")

                                self.scale = YLeaf(YType.uint32, "scale")

                                self.status = YLeaf(YType.uint32, "status")

                                self.units = YLeaf(YType.str, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.uint32, "value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("age_time_stamp",
                                                "alarm_type",
                                                "data_type",
                                                "device_description",
                                                "device_id",
                                                "field_validity_bitmap",
                                                "precision",
                                                "scale",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.age_time_stamp.is_set or
                                    self.alarm_type.is_set or
                                    self.data_type.is_set or
                                    self.device_description.is_set or
                                    self.device_id.is_set or
                                    self.field_validity_bitmap.is_set or
                                    self.precision.is_set or
                                    self.scale.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.age_time_stamp.yfilter != YFilter.not_set or
                                    self.alarm_type.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.device_description.yfilter != YFilter.not_set or
                                    self.device_id.yfilter != YFilter.not_set or
                                    self.field_validity_bitmap.yfilter != YFilter.not_set or
                                    self.precision.yfilter != YFilter.not_set or
                                    self.scale.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                                if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alarm_type.get_name_leafdata())
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_description.get_name_leafdata())
                                if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.device_id.get_name_leafdata())
                                if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                                if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.precision.get_name_leafdata())
                                if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.scale.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "age-time-stamp"):
                                    self.age_time_stamp = value
                                    self.age_time_stamp.value_namespace = name_space
                                    self.age_time_stamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "alarm-type"):
                                    self.alarm_type = value
                                    self.alarm_type.value_namespace = name_space
                                    self.alarm_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-description"):
                                    self.device_description = value
                                    self.device_description.value_namespace = name_space
                                    self.device_description.value_namespace_prefix = name_space_prefix
                                if(value_path == "device-id"):
                                    self.device_id = value
                                    self.device_id.value_namespace = name_space
                                    self.device_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "field-validity-bitmap"):
                                    self.field_validity_bitmap = value
                                    self.field_validity_bitmap.value_namespace = name_space
                                    self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                                if(value_path == "precision"):
                                    self.precision = value
                                    self.precision.value_namespace = name_space
                                    self.precision.value_namespace_prefix = name_space_prefix
                                if(value_path == "scale"):
                                    self.scale = value
                                    self.scale.value_namespace = name_space
                                    self.scale.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class PwgInfo(Entity):
                            """
                            Inventory EDM PWG info
                            
                            .. attribute:: power_group_available_current
                            
                            	available current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_drawn_current
                            
                            	drawn current
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_group_power_units
                            
                            	power units
                            	**type**\:  str
                            
                            .. attribute:: power_group_redundancy_mode
                            
                            	redundancy mode
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo, self).__init__()

                                self.yang_name = "pwg-info"
                                self.yang_parent_name = "attributes"

                                self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                                self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                                self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                                self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("power_group_available_current",
                                                "power_group_drawn_current",
                                                "power_group_power_units",
                                                "power_group_redundancy_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.power_group_available_current.is_set or
                                    self.power_group_drawn_current.is_set or
                                    self.power_group_power_units.is_set or
                                    self.power_group_redundancy_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.power_group_available_current.yfilter != YFilter.not_set or
                                    self.power_group_drawn_current.yfilter != YFilter.not_set or
                                    self.power_group_power_units.yfilter != YFilter.not_set or
                                    self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pwg-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                                if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                                if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                                if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "power-group-available-current"):
                                    self.power_group_available_current = value
                                    self.power_group_available_current.value_namespace = name_space
                                    self.power_group_available_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-drawn-current"):
                                    self.power_group_drawn_current = value
                                    self.power_group_drawn_current.value_namespace = name_space
                                    self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-power-units"):
                                    self.power_group_power_units = value
                                    self.power_group_power_units.value_namespace = name_space
                                    self.power_group_power_units.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-group-redundancy-mode"):
                                    self.power_group_redundancy_mode = value
                                    self.power_group_redundancy_mode.value_namespace = name_space
                                    self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                        class EnvSensorInfoXml(Entity):
                            """
                            Environment sensor info XML
                            
                            .. attribute:: data_type
                            
                            	Sensor data type
                            	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                            
                            .. attribute:: description
                            
                            	Device Name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: status
                            
                            	Sensor operation state
                            	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                            
                            .. attribute:: threshold
                            
                            	Threshold information
                            	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold>`
                            
                            .. attribute:: units
                            
                            	Units of variable being read
                            	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                            
                            .. attribute:: update_rate
                            
                            	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: value
                            
                            	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml, self).__init__()

                                self.yang_name = "env-sensor-info-xml"
                                self.yang_parent_name = "attributes"

                                self.data_type = YLeaf(YType.enumeration, "data-type")

                                self.description = YLeaf(YType.str, "description")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.units = YLeaf(YType.enumeration, "units")

                                self.update_rate = YLeaf(YType.uint32, "update-rate")

                                self.value = YLeaf(YType.str, "value")

                                self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                                self._children_yang_names.add("threshold")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("data_type",
                                                "description",
                                                "status",
                                                "units",
                                                "update_rate",
                                                "value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                            class Threshold(Entity):
                                """
                                Threshold information
                                
                                .. attribute:: threshold_array
                                
                                	Array of threshold
                                	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                                    self.yang_name = "threshold"
                                    self.yang_parent_name = "env-sensor-info-xml"

                                    self.threshold_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                                class ThresholdArray(Entity):
                                    """
                                    Array of threshold
                                    
                                    .. attribute:: threshold_name
                                    
                                    	Threshold name
                                    	**type**\:  str
                                    
                                    	**length:** 0..50
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                        self.yang_name = "threshold-array"
                                        self.yang_parent_name = "threshold"

                                        self.threshold_name = YLeaf(YType.str, "threshold-name")

                                        self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.int32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_name",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_name.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_name.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "threshold-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-name"):
                                            self.threshold_name = value
                                            self.threshold_name.value_namespace = name_space
                                            self.threshold_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.threshold_array:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.threshold_array:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "threshold" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "threshold-array"):
                                        for c in self.threshold_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.threshold_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "threshold-array"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.data_type.is_set or
                                    self.description.is_set or
                                    self.status.is_set or
                                    self.units.is_set or
                                    self.update_rate.is_set or
                                    self.value.is_set or
                                    (self.threshold is not None and self.threshold.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.data_type.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.units.yfilter != YFilter.not_set or
                                    self.update_rate.yfilter != YFilter.not_set or
                                    self.value.yfilter != YFilter.not_set or
                                    (self.threshold is not None and self.threshold.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "env-sensor-info-xml" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.data_type.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.units.get_name_leafdata())
                                if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.update_rate.get_name_leafdata())
                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "threshold"):
                                    if (self.threshold is None):
                                        self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml.Threshold()
                                        self.threshold.parent = self
                                        self._children_name_map["threshold"] = "threshold"
                                    return self.threshold

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "data-type"):
                                    self.data_type = value
                                    self.data_type.value_namespace = name_space
                                    self.data_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "units"):
                                    self.units = value
                                    self.units.value_namespace = name_space
                                    self.units.value_namespace_prefix = name_space_prefix
                                if(value_path == "update-rate"):
                                    self.update_rate = value
                                    self.update_rate.value_namespace = name_space
                                    self.update_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "value"):
                                    self.value = value
                                    self.value.value_namespace = name_space
                                    self.value.value_namespace_prefix = name_space_prefix


                        class InvAssetBag(Entity):
                            """
                            Inventory Asset Bag
                            
                            .. attribute:: manufacturer_assembly_number
                            
                            	Manufacture Assembly number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_assembly_revision
                            
                            	Manufacture assembly revision
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_common_language_equipment_identifier
                            
                            	Common Language Equipment           Identifier number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_firmware_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: manufacturer_software_identifier
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: original_equipment_manufacturer_string
                            
                            	String containing OEM information           if applicable
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: part_number
                            
                            	
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag, self).__init__()

                                self.yang_name = "inv-asset-bag"
                                self.yang_parent_name = "attributes"

                                self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                                self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                                self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                                self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                                self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                                self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                                self.part_number = YLeaf(YType.str, "part-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("manufacturer_assembly_number",
                                                "manufacturer_assembly_revision",
                                                "manufacturer_common_language_equipment_identifier",
                                                "manufacturer_firmware_identifier",
                                                "manufacturer_software_identifier",
                                                "original_equipment_manufacturer_string",
                                                "part_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.manufacturer_assembly_number.is_set or
                                    self.manufacturer_assembly_revision.is_set or
                                    self.manufacturer_common_language_equipment_identifier.is_set or
                                    self.manufacturer_firmware_identifier.is_set or
                                    self.manufacturer_software_identifier.is_set or
                                    self.original_equipment_manufacturer_string.is_set or
                                    self.part_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                                    self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                                    self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                                    self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                                    self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                                    self.part_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-asset-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                                if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                                if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                                if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                                if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                                if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                                if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.part_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "manufacturer-assembly-number"):
                                    self.manufacturer_assembly_number = value
                                    self.manufacturer_assembly_number.value_namespace = name_space
                                    self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-assembly-revision"):
                                    self.manufacturer_assembly_revision = value
                                    self.manufacturer_assembly_revision.value_namespace = name_space
                                    self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-common-language-equipment-identifier"):
                                    self.manufacturer_common_language_equipment_identifier = value
                                    self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                                    self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-firmware-identifier"):
                                    self.manufacturer_firmware_identifier = value
                                    self.manufacturer_firmware_identifier.value_namespace = name_space
                                    self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-software-identifier"):
                                    self.manufacturer_software_identifier = value
                                    self.manufacturer_software_identifier.value_namespace = name_space
                                    self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-equipment-manufacturer-string"):
                                    self.original_equipment_manufacturer_string = value
                                    self.original_equipment_manufacturer_string.value_namespace = name_space
                                    self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                                if(value_path == "part-number"):
                                    self.part_number = value
                                    self.part_number.value_namespace = name_space
                                    self.part_number.value_namespace_prefix = name_space_prefix


                        class Threshold(Entity):
                            """
                            Threshold
                            
                            .. attribute:: critical_hi
                            
                            	Critical High
                            	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi>`
                            
                            .. attribute:: critical_lo
                            
                            	Critical Low
                            	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo>`
                            
                            .. attribute:: major_hi
                            
                            	Major High
                            	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi>`
                            
                            .. attribute:: major_lo
                            
                            	Major Low
                            	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo>`
                            
                            .. attribute:: minor_hi
                            
                            	Minor High
                            	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi>`
                            
                            .. attribute:: minor_lo
                            
                            	Minor Low
                            	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo>`
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold, self).__init__()

                                self.yang_name = "threshold"
                                self.yang_parent_name = "attributes"

                                self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"
                                self._children_yang_names.add("critical-hi")

                                self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"
                                self._children_yang_names.add("critical-lo")

                                self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"
                                self._children_yang_names.add("major-hi")

                                self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"
                                self._children_yang_names.add("major-lo")

                                self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"
                                self._children_yang_names.add("minor-hi")

                                self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                                self._children_yang_names.add("minor-lo")


                            class MajorLo(Entity):
                                """
                                Major Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo, self).__init__()

                                    self.yang_name = "major-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalHi(Entity):
                                """
                                Critical High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi, self).__init__()

                                    self.yang_name = "critical-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorHi(Entity):
                                """
                                Minor High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi, self).__init__()

                                    self.yang_name = "minor-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MajorHi(Entity):
                                """
                                Major High
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi, self).__init__()

                                    self.yang_name = "major-hi"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "major-hi"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "major-hi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class CriticalLo(Entity):
                                """
                                Critical Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo, self).__init__()

                                    self.yang_name = "critical-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "critical-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "critical-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class MinorLo(Entity):
                                """
                                Minor Low
                                
                                .. attribute:: thresh_bag
                                
                                	Environment threshold info
                                	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag>`
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo, self).__init__()

                                    self.yang_name = "minor-lo"
                                    self.yang_parent_name = "threshold"

                                    self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                    self._children_yang_names.add("thresh-bag")


                                class ThreshBag(Entity):
                                    """
                                    Environment threshold info
                                    
                                    .. attribute:: threshold_evaluation
                                    
                                    	Indicates the result of the most recent evaluation of the thresholD
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_notification_enabled
                                    
                                    	Indicates whether or not a notification should result, in case of threshold violation
                                    	**type**\:  bool
                                    
                                    .. attribute:: threshold_relation
                                    
                                    	Indicates relation between sensor value and threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_severity
                                    
                                    	Indicates minor, major, critical severities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: threshold_value
                                    
                                    	Value of the configured threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                        self.yang_name = "thresh-bag"
                                        self.yang_parent_name = "minor-lo"

                                        self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                        self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                        self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                        self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                        self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("threshold_evaluation",
                                                        "threshold_notification_enabled",
                                                        "threshold_relation",
                                                        "threshold_severity",
                                                        "threshold_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.threshold_evaluation.is_set or
                                            self.threshold_notification_enabled.is_set or
                                            self.threshold_relation.is_set or
                                            self.threshold_severity.is_set or
                                            self.threshold_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.threshold_evaluation.yfilter != YFilter.not_set or
                                            self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                            self.threshold_relation.yfilter != YFilter.not_set or
                                            self.threshold_severity.yfilter != YFilter.not_set or
                                            self.threshold_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "thresh-bag" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                        if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                        if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                        if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                        if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "threshold-evaluation"):
                                            self.threshold_evaluation = value
                                            self.threshold_evaluation.value_namespace = name_space
                                            self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-notification-enabled"):
                                            self.threshold_notification_enabled = value
                                            self.threshold_notification_enabled.value_namespace = name_space
                                            self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-relation"):
                                            self.threshold_relation = value
                                            self.threshold_relation.value_namespace = name_space
                                            self.threshold_relation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-severity"):
                                            self.threshold_severity = value
                                            self.threshold_severity.value_namespace = name_space
                                            self.threshold_severity.value_namespace_prefix = name_space_prefix
                                        if(value_path == "threshold-value"):
                                            self.threshold_value = value
                                            self.threshold_value.value_namespace = name_space
                                            self.threshold_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.thresh_bag is not None and self.thresh_bag.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "minor-lo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "thresh-bag"):
                                        if (self.thresh_bag is None):
                                            self.thresh_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo.ThreshBag()
                                            self.thresh_bag.parent = self
                                            self._children_name_map["thresh_bag"] = "thresh-bag"
                                        return self.thresh_bag

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "thresh-bag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.critical_hi is not None and self.critical_hi.has_data()) or
                                    (self.critical_lo is not None and self.critical_lo.has_data()) or
                                    (self.major_hi is not None and self.major_hi.has_data()) or
                                    (self.major_lo is not None and self.major_lo.has_data()) or
                                    (self.minor_hi is not None and self.minor_hi.has_data()) or
                                    (self.minor_lo is not None and self.minor_lo.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.critical_hi is not None and self.critical_hi.has_operation()) or
                                    (self.critical_lo is not None and self.critical_lo.has_operation()) or
                                    (self.major_hi is not None and self.major_hi.has_operation()) or
                                    (self.major_lo is not None and self.major_lo.has_operation()) or
                                    (self.minor_hi is not None and self.minor_hi.has_operation()) or
                                    (self.minor_lo is not None and self.minor_lo.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "threshold" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "critical-hi"):
                                    if (self.critical_hi is None):
                                        self.critical_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalHi()
                                        self.critical_hi.parent = self
                                        self._children_name_map["critical_hi"] = "critical-hi"
                                    return self.critical_hi

                                if (child_yang_name == "critical-lo"):
                                    if (self.critical_lo is None):
                                        self.critical_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.CriticalLo()
                                        self.critical_lo.parent = self
                                        self._children_name_map["critical_lo"] = "critical-lo"
                                    return self.critical_lo

                                if (child_yang_name == "major-hi"):
                                    if (self.major_hi is None):
                                        self.major_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorHi()
                                        self.major_hi.parent = self
                                        self._children_name_map["major_hi"] = "major-hi"
                                    return self.major_hi

                                if (child_yang_name == "major-lo"):
                                    if (self.major_lo is None):
                                        self.major_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MajorLo()
                                        self.major_lo.parent = self
                                        self._children_name_map["major_lo"] = "major-lo"
                                    return self.major_lo

                                if (child_yang_name == "minor-hi"):
                                    if (self.minor_hi is None):
                                        self.minor_hi = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorHi()
                                        self.minor_hi.parent = self
                                        self._children_name_map["minor_hi"] = "minor-hi"
                                    return self.minor_hi

                                if (child_yang_name == "minor-lo"):
                                    if (self.minor_lo is None):
                                        self.minor_lo = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold.MinorLo()
                                        self.minor_lo.parent = self
                                        self._children_name_map["minor_lo"] = "minor-lo"
                                    return self.minor_lo

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class FruInfo(Entity):
                            """
                            Inventory EDM FRU info
                            
                            .. attribute:: card_administrative_state
                            
                            	card admin state\: shutdown or not
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_monitor_state
                            
                            	card is monitored by a manager or left unmonitored
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_operational_state
                            
                            	card operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: card_reset_reason
                            
                            	card reset reason enum
                            	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                            
                            .. attribute:: card_up_time
                            
                            	card up time
                            	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime>`
                            
                            .. attribute:: last_operational_state_change
                            
                            	last card oper change state
                            	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange>`
                            
                            .. attribute:: power_administrative_state
                            
                            	power admin state\: up or down
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_current_measurement
                            
                            	power current\: not implemented
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: power_operational_state
                            
                            	Power operation state
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo, self).__init__()

                                self.yang_name = "fru-info"
                                self.yang_parent_name = "attributes"

                                self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                                self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                                self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                                self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                                self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                                self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                                self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                                self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                                self._children_yang_names.add("card-up-time")

                                self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                self._children_yang_names.add("last-operational-state-change")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("card_administrative_state",
                                                "card_monitor_state",
                                                "card_operational_state",
                                                "card_reset_reason",
                                                "power_administrative_state",
                                                "power_current_measurement",
                                                "power_operational_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo, self).__setattr__(name, value)


                            class LastOperationalStateChange(Entity):
                                """
                                last card oper change state
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                                    self.yang_name = "last-operational-state-change"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "last-operational-state-change" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix


                            class CardUpTime(Entity):
                                """
                                card up time
                                
                                .. attribute:: time_in_nano_seconds
                                
                                	Time Value in Nano\-seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: time_in_seconds
                                
                                	Time Value in Seconds
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime, self).__init__()

                                    self.yang_name = "card-up-time"
                                    self.yang_parent_name = "fru-info"

                                    self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                                    self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time_in_nano_seconds",
                                                    "time_in_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.time_in_nano_seconds.is_set or
                                        self.time_in_seconds.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                        self.time_in_seconds.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "card-up-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                                    if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time-in-nano-seconds"):
                                        self.time_in_nano_seconds = value
                                        self.time_in_nano_seconds.value_namespace = name_space
                                        self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                                    if(value_path == "time-in-seconds"):
                                        self.time_in_seconds = value
                                        self.time_in_seconds.value_namespace = name_space
                                        self.time_in_seconds.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.card_administrative_state.is_set or
                                    self.card_monitor_state.is_set or
                                    self.card_operational_state.is_set or
                                    self.card_reset_reason.is_set or
                                    self.power_administrative_state.is_set or
                                    self.power_current_measurement.is_set or
                                    self.power_operational_state.is_set or
                                    (self.card_up_time is not None and self.card_up_time.has_data()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.card_administrative_state.yfilter != YFilter.not_set or
                                    self.card_monitor_state.yfilter != YFilter.not_set or
                                    self.card_operational_state.yfilter != YFilter.not_set or
                                    self.card_reset_reason.yfilter != YFilter.not_set or
                                    self.power_administrative_state.yfilter != YFilter.not_set or
                                    self.power_current_measurement.yfilter != YFilter.not_set or
                                    self.power_operational_state.yfilter != YFilter.not_set or
                                    (self.card_up_time is not None and self.card_up_time.has_operation()) or
                                    (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fru-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                                if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                                if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                                if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                                if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                                if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                                if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "card-up-time"):
                                    if (self.card_up_time is None):
                                        self.card_up_time = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.CardUpTime()
                                        self.card_up_time.parent = self
                                        self._children_name_map["card_up_time"] = "card-up-time"
                                    return self.card_up_time

                                if (child_yang_name == "last-operational-state-change"):
                                    if (self.last_operational_state_change is None):
                                        self.last_operational_state_change = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo.LastOperationalStateChange()
                                        self.last_operational_state_change.parent = self
                                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                                    return self.last_operational_state_change

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "card-administrative-state"):
                                    self.card_administrative_state = value
                                    self.card_administrative_state.value_namespace = name_space
                                    self.card_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-monitor-state"):
                                    self.card_monitor_state = value
                                    self.card_monitor_state.value_namespace = name_space
                                    self.card_monitor_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-operational-state"):
                                    self.card_operational_state = value
                                    self.card_operational_state.value_namespace = name_space
                                    self.card_operational_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "card-reset-reason"):
                                    self.card_reset_reason = value
                                    self.card_reset_reason.value_namespace = name_space
                                    self.card_reset_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-administrative-state"):
                                    self.power_administrative_state = value
                                    self.power_administrative_state.value_namespace = name_space
                                    self.power_administrative_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-current-measurement"):
                                    self.power_current_measurement = value
                                    self.power_current_measurement.value_namespace = name_space
                                    self.power_current_measurement.value_namespace_prefix = name_space_prefix
                                if(value_path == "power-operational-state"):
                                    self.power_operational_state = value
                                    self.power_operational_state.value_namespace = name_space
                                    self.power_operational_state.value_namespace_prefix = name_space_prefix


                        class InvBasicBag(Entity):
                            """
                            Inventory Basic Bag
                            
                            .. attribute:: alias
                            
                            	useful for storing an entity alias 
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_id_str
                            
                            	asset Identification string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: asset_identification
                            
                            	asset Identification
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ceport
                            
                            	1 if ce port found, 0 if not
                            	**type**\:  bool
                            
                            .. attribute:: chip_hardware_revision
                            
                            	chip module hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: composite_class_code
                            
                            	Major&minor class of the entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: description
                            
                            	describes in user\-readable terms       what the entity in question does
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: environmental_monitor_path
                            
                            	sysdb name of sensor in the envmon EDM
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: firmware_revision
                            
                            	firmware revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: group_flag
                            
                            	indicates if this entity is group       or not
                            	**type**\:  bool
                            
                            .. attribute:: hardware_revision
                            
                            	hw revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: is_field_replaceable_unit
                            
                            	1 if Field Replaceable Unit 0, if not
                            	**type**\:  bool
                            
                            .. attribute:: manufacturer_asset_tags
                            
                            	Manufacture Asset Tags
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: manufacturer_name
                            
                            	manufacturer's name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: memory_size
                            
                            	Size of memory associated with       the entity where applicable
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: model_name
                            
                            	model name
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: name
                            
                            	name string for the entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: new_deviation_number
                            
                            	integer value for New Deviation Number 0x88
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: physical_layer_interface_module_type
                            
                            	integer value for plim type if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: redundancystate
                            
                            	integer value for Redundancy State if     applicable to this entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: serial_number
                            
                            	serial number
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: software_revision
                            
                            	software revision string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: unique_id
                            
                            	Unique id for an entity
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: unrecognized_fru
                            
                            	1 if UnrecognizedFRU and 0 for recognizedFRU
                            	**type**\:  bool
                            
                            .. attribute:: vendor_type
                            
                            	maps to the vendor OID string
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: xr_scoped
                            
                            	1 if xr scoped, 0 if not
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag, self).__init__()

                                self.yang_name = "inv-basic-bag"
                                self.yang_parent_name = "attributes"

                                self.alias = YLeaf(YType.str, "alias")

                                self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                                self.asset_identification = YLeaf(YType.int32, "asset-identification")

                                self.ceport = YLeaf(YType.boolean, "ceport")

                                self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                                self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                                self.description = YLeaf(YType.str, "description")

                                self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                                self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                                self.group_flag = YLeaf(YType.boolean, "group-flag")

                                self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                                self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                                self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                                self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                                self.memory_size = YLeaf(YType.int32, "memory-size")

                                self.model_name = YLeaf(YType.str, "model-name")

                                self.name = YLeaf(YType.str, "name")

                                self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                                self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                                self.redundancystate = YLeaf(YType.int32, "redundancystate")

                                self.serial_number = YLeaf(YType.str, "serial-number")

                                self.software_revision = YLeaf(YType.str, "software-revision")

                                self.unique_id = YLeaf(YType.int32, "unique-id")

                                self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                                self.vendor_type = YLeaf(YType.str, "vendor-type")

                                self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("alias",
                                                "asset_id_str",
                                                "asset_identification",
                                                "ceport",
                                                "chip_hardware_revision",
                                                "composite_class_code",
                                                "description",
                                                "environmental_monitor_path",
                                                "firmware_revision",
                                                "group_flag",
                                                "hardware_revision",
                                                "is_field_replaceable_unit",
                                                "manufacturer_asset_tags",
                                                "manufacturer_name",
                                                "memory_size",
                                                "model_name",
                                                "name",
                                                "new_deviation_number",
                                                "physical_layer_interface_module_type",
                                                "redundancystate",
                                                "serial_number",
                                                "software_revision",
                                                "unique_id",
                                                "unrecognized_fru",
                                                "vendor_type",
                                                "xr_scoped") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.alias.is_set or
                                    self.asset_id_str.is_set or
                                    self.asset_identification.is_set or
                                    self.ceport.is_set or
                                    self.chip_hardware_revision.is_set or
                                    self.composite_class_code.is_set or
                                    self.description.is_set or
                                    self.environmental_monitor_path.is_set or
                                    self.firmware_revision.is_set or
                                    self.group_flag.is_set or
                                    self.hardware_revision.is_set or
                                    self.is_field_replaceable_unit.is_set or
                                    self.manufacturer_asset_tags.is_set or
                                    self.manufacturer_name.is_set or
                                    self.memory_size.is_set or
                                    self.model_name.is_set or
                                    self.name.is_set or
                                    self.new_deviation_number.is_set or
                                    self.physical_layer_interface_module_type.is_set or
                                    self.redundancystate.is_set or
                                    self.serial_number.is_set or
                                    self.software_revision.is_set or
                                    self.unique_id.is_set or
                                    self.unrecognized_fru.is_set or
                                    self.vendor_type.is_set or
                                    self.xr_scoped.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.alias.yfilter != YFilter.not_set or
                                    self.asset_id_str.yfilter != YFilter.not_set or
                                    self.asset_identification.yfilter != YFilter.not_set or
                                    self.ceport.yfilter != YFilter.not_set or
                                    self.chip_hardware_revision.yfilter != YFilter.not_set or
                                    self.composite_class_code.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.environmental_monitor_path.yfilter != YFilter.not_set or
                                    self.firmware_revision.yfilter != YFilter.not_set or
                                    self.group_flag.yfilter != YFilter.not_set or
                                    self.hardware_revision.yfilter != YFilter.not_set or
                                    self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                                    self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                                    self.manufacturer_name.yfilter != YFilter.not_set or
                                    self.memory_size.yfilter != YFilter.not_set or
                                    self.model_name.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set or
                                    self.new_deviation_number.yfilter != YFilter.not_set or
                                    self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                                    self.redundancystate.yfilter != YFilter.not_set or
                                    self.serial_number.yfilter != YFilter.not_set or
                                    self.software_revision.yfilter != YFilter.not_set or
                                    self.unique_id.yfilter != YFilter.not_set or
                                    self.unrecognized_fru.yfilter != YFilter.not_set or
                                    self.vendor_type.yfilter != YFilter.not_set or
                                    self.xr_scoped.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-basic-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.alias.get_name_leafdata())
                                if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                                if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.asset_identification.get_name_leafdata())
                                if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ceport.get_name_leafdata())
                                if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                                if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                                if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                                if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.group_flag.get_name_leafdata())
                                if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                                if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                                if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                                if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                                if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.memory_size.get_name_leafdata())
                                if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.model_name.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())
                                if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                                if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                                if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redundancystate.get_name_leafdata())
                                if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.serial_number.get_name_leafdata())
                                if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.software_revision.get_name_leafdata())
                                if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unique_id.get_name_leafdata())
                                if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                                if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vendor_type.get_name_leafdata())
                                if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "alias"):
                                    self.alias = value
                                    self.alias.value_namespace = name_space
                                    self.alias.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-id-str"):
                                    self.asset_id_str = value
                                    self.asset_id_str.value_namespace = name_space
                                    self.asset_id_str.value_namespace_prefix = name_space_prefix
                                if(value_path == "asset-identification"):
                                    self.asset_identification = value
                                    self.asset_identification.value_namespace = name_space
                                    self.asset_identification.value_namespace_prefix = name_space_prefix
                                if(value_path == "ceport"):
                                    self.ceport = value
                                    self.ceport.value_namespace = name_space
                                    self.ceport.value_namespace_prefix = name_space_prefix
                                if(value_path == "chip-hardware-revision"):
                                    self.chip_hardware_revision = value
                                    self.chip_hardware_revision.value_namespace = name_space
                                    self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "composite-class-code"):
                                    self.composite_class_code = value
                                    self.composite_class_code.value_namespace = name_space
                                    self.composite_class_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "environmental-monitor-path"):
                                    self.environmental_monitor_path = value
                                    self.environmental_monitor_path.value_namespace = name_space
                                    self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "firmware-revision"):
                                    self.firmware_revision = value
                                    self.firmware_revision.value_namespace = name_space
                                    self.firmware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "group-flag"):
                                    self.group_flag = value
                                    self.group_flag.value_namespace = name_space
                                    self.group_flag.value_namespace_prefix = name_space_prefix
                                if(value_path == "hardware-revision"):
                                    self.hardware_revision = value
                                    self.hardware_revision.value_namespace = name_space
                                    self.hardware_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-field-replaceable-unit"):
                                    self.is_field_replaceable_unit = value
                                    self.is_field_replaceable_unit.value_namespace = name_space
                                    self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-asset-tags"):
                                    self.manufacturer_asset_tags = value
                                    self.manufacturer_asset_tags.value_namespace = name_space
                                    self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                                if(value_path == "manufacturer-name"):
                                    self.manufacturer_name = value
                                    self.manufacturer_name.value_namespace = name_space
                                    self.manufacturer_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "memory-size"):
                                    self.memory_size = value
                                    self.memory_size.value_namespace = name_space
                                    self.memory_size.value_namespace_prefix = name_space_prefix
                                if(value_path == "model-name"):
                                    self.model_name = value
                                    self.model_name.value_namespace = name_space
                                    self.model_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix
                                if(value_path == "new-deviation-number"):
                                    self.new_deviation_number = value
                                    self.new_deviation_number.value_namespace = name_space
                                    self.new_deviation_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "physical-layer-interface-module-type"):
                                    self.physical_layer_interface_module_type = value
                                    self.physical_layer_interface_module_type.value_namespace = name_space
                                    self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "redundancystate"):
                                    self.redundancystate = value
                                    self.redundancystate.value_namespace = name_space
                                    self.redundancystate.value_namespace_prefix = name_space_prefix
                                if(value_path == "serial-number"):
                                    self.serial_number = value
                                    self.serial_number.value_namespace = name_space
                                    self.serial_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "software-revision"):
                                    self.software_revision = value
                                    self.software_revision.value_namespace = name_space
                                    self.software_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "unique-id"):
                                    self.unique_id = value
                                    self.unique_id.value_namespace = name_space
                                    self.unique_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "unrecognized-fru"):
                                    self.unrecognized_fru = value
                                    self.unrecognized_fru.value_namespace = name_space
                                    self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                                if(value_path == "vendor-type"):
                                    self.vendor_type = value
                                    self.vendor_type.value_namespace = name_space
                                    self.vendor_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "xr-scoped"):
                                    self.xr_scoped = value
                                    self.xr_scoped.value_namespace = name_space
                                    self.xr_scoped.value_namespace_prefix = name_space_prefix


                        class InvEepromInfo(Entity):
                            """
                            Inventory EDM EEPROM Information Bag
                            
                            .. attribute:: description
                            
                            	A textual description of physical entity
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: eeprom
                            
                            	EEPROM data not from hex data
                            	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom>`
                            
                            .. attribute:: has_eeprom
                            
                            	use eeprom instead of opaque data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inv_card_type
                            
                            	Inventory card type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: opaque_data
                            
                            	EEPROM hex data
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: opaque_data_size
                            
                            	size of the EEPROM hex data
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo, self).__init__()

                                self.yang_name = "inv-eeprom-info"
                                self.yang_parent_name = "attributes"

                                self.description = YLeaf(YType.str, "description")

                                self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                                self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                                self.opaque_data = YLeaf(YType.str, "opaque-data")

                                self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                                self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                                self._children_yang_names.add("eeprom")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("description",
                                                "has_eeprom",
                                                "inv_card_type",
                                                "opaque_data",
                                                "opaque_data_size") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo, self).__setattr__(name, value)


                            class Eeprom(Entity):
                                """
                                EEPROM data not from hex data
                                
                                .. attribute:: asset_alias
                                
                                	Asset Alias
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: asset_id
                                
                                	Asset ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address1
                                
                                	Base Mac Address #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address2
                                
                                	Base Mac Address #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address3
                                
                                	Base Mac Address #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: base_mac_address4
                                
                                	Base Mac Address #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_checksum
                                
                                	Block Checksum
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_count
                                
                                	Block Count
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_length
                                
                                	Block Length
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_signature
                                
                                	Block Signature
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: block_version
                                
                                	Block Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: chassis_sid
                                
                                	Chassis serial number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: clei
                                
                                	Common Language Equipment Identifier (CLEI) code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_family
                                
                                	Controller family
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: controller_type
                                
                                	Controller type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: description
                                
                                	A textual description of physical entity
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num1
                                
                                	Deviation Number # 1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num2
                                
                                	Deviation Number # 2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num3
                                
                                	Deviation Number # 3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num4
                                
                                	Deviation Number # 4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num5
                                
                                	Deviation Number # 5
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num6
                                
                                	Deviation Number # 6
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: dev_num7
                                
                                	Deviation Number # 7
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eci
                                
                                	Equipment Catalog Item (ECI) number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: eeprom_size
                                
                                	EEPROM Size
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: engineer_use
                                
                                	Engineer Use
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_major_type
                                
                                	FRU Major Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: fru_minor_type
                                
                                	FRU Minor Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hw_version
                                
                                	Hardware Version
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: hwid
                                
                                	Hardware Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: idprom_format_rev
                                
                                	IDPROM Format Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size1
                                
                                	Mac Address Block Size #1
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size2
                                
                                	Mac Address Block Size #2
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size3
                                
                                	Mac Address Block Size #3
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mac_add_blk_size4
                                
                                	Mac Address Block Size #4
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: manu_test_data
                                
                                	Manufacturing Test Data
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_bits
                                
                                	MFG Bits
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: mfg_deviation
                                
                                	MFG Deviation
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: oem_string
                                
                                	OEM String
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_number
                                
                                	Part Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: part_revision
                                
                                	Part Revision
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pca_num
                                
                                	PCA number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcavid
                                
                                	PCA revision ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pcb_serial_num
                                
                                	PCB Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: pid
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_consumption
                                
                                	Power Consumption
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: power_supply_type
                                
                                	Power Supply Type
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: product_id
                                
                                	Product ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: rma
                                
                                	RMA Data
                                	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma>`
                                
                                .. attribute:: rma_code
                                
                                	RMA Code
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: serial_number
                                
                                	Serial Number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: snmpoid
                                
                                	SNMP OID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_part_num
                                
                                	Top assembly part number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: top_assem_vid
                                
                                	Top assembly revision number
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_description
                                
                                	UDI description
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: udi_name
                                
                                	UDI name
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                .. attribute:: vid
                                
                                	Version ID
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'invmgr-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom, self).__init__()

                                    self.yang_name = "eeprom"
                                    self.yang_parent_name = "inv-eeprom-info"

                                    self.asset_alias = YLeaf(YType.str, "asset-alias")

                                    self.asset_id = YLeaf(YType.str, "asset-id")

                                    self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                                    self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                                    self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                                    self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                                    self.block_checksum = YLeaf(YType.str, "block-checksum")

                                    self.block_count = YLeaf(YType.str, "block-count")

                                    self.block_length = YLeaf(YType.str, "block-length")

                                    self.block_signature = YLeaf(YType.str, "block-signature")

                                    self.block_version = YLeaf(YType.str, "block-version")

                                    self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                                    self.clei = YLeaf(YType.str, "clei")

                                    self.controller_family = YLeaf(YType.str, "controller-family")

                                    self.controller_type = YLeaf(YType.str, "controller-type")

                                    self.description = YLeaf(YType.str, "description")

                                    self.dev_num1 = YLeaf(YType.str, "dev-num1")

                                    self.dev_num2 = YLeaf(YType.str, "dev-num2")

                                    self.dev_num3 = YLeaf(YType.str, "dev-num3")

                                    self.dev_num4 = YLeaf(YType.str, "dev-num4")

                                    self.dev_num5 = YLeaf(YType.str, "dev-num5")

                                    self.dev_num6 = YLeaf(YType.str, "dev-num6")

                                    self.dev_num7 = YLeaf(YType.str, "dev-num7")

                                    self.eci = YLeaf(YType.str, "eci")

                                    self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                                    self.engineer_use = YLeaf(YType.str, "engineer-use")

                                    self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                                    self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                                    self.hw_version = YLeaf(YType.str, "hw-version")

                                    self.hwid = YLeaf(YType.str, "hwid")

                                    self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                                    self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                                    self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                                    self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                                    self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                                    self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                                    self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                                    self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                                    self.oem_string = YLeaf(YType.str, "oem-string")

                                    self.part_number = YLeaf(YType.str, "part-number")

                                    self.part_revision = YLeaf(YType.str, "part-revision")

                                    self.pca_num = YLeaf(YType.str, "pca-num")

                                    self.pcavid = YLeaf(YType.str, "pcavid")

                                    self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                                    self.pid = YLeaf(YType.str, "pid")

                                    self.power_consumption = YLeaf(YType.str, "power-consumption")

                                    self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                                    self.product_id = YLeaf(YType.str, "product-id")

                                    self.rma_code = YLeaf(YType.str, "rma-code")

                                    self.serial_number = YLeaf(YType.str, "serial-number")

                                    self.snmpoid = YLeaf(YType.str, "snmpoid")

                                    self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                                    self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                                    self.udi_description = YLeaf(YType.str, "udi-description")

                                    self.udi_name = YLeaf(YType.str, "udi-name")

                                    self.vid = YLeaf(YType.str, "vid")

                                    self.rma = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                    self._children_yang_names.add("rma")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("asset_alias",
                                                    "asset_id",
                                                    "base_mac_address1",
                                                    "base_mac_address2",
                                                    "base_mac_address3",
                                                    "base_mac_address4",
                                                    "block_checksum",
                                                    "block_count",
                                                    "block_length",
                                                    "block_signature",
                                                    "block_version",
                                                    "chassis_sid",
                                                    "clei",
                                                    "controller_family",
                                                    "controller_type",
                                                    "description",
                                                    "dev_num1",
                                                    "dev_num2",
                                                    "dev_num3",
                                                    "dev_num4",
                                                    "dev_num5",
                                                    "dev_num6",
                                                    "dev_num7",
                                                    "eci",
                                                    "eeprom_size",
                                                    "engineer_use",
                                                    "fru_major_type",
                                                    "fru_minor_type",
                                                    "hw_version",
                                                    "hwid",
                                                    "idprom_format_rev",
                                                    "mac_add_blk_size1",
                                                    "mac_add_blk_size2",
                                                    "mac_add_blk_size3",
                                                    "mac_add_blk_size4",
                                                    "manu_test_data",
                                                    "mfg_bits",
                                                    "mfg_deviation",
                                                    "oem_string",
                                                    "part_number",
                                                    "part_revision",
                                                    "pca_num",
                                                    "pcavid",
                                                    "pcb_serial_num",
                                                    "pid",
                                                    "power_consumption",
                                                    "power_supply_type",
                                                    "product_id",
                                                    "rma_code",
                                                    "serial_number",
                                                    "snmpoid",
                                                    "top_assem_part_num",
                                                    "top_assem_vid",
                                                    "udi_description",
                                                    "udi_name",
                                                    "vid") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                                class Rma(Entity):
                                    """
                                    RMA Data
                                    
                                    .. attribute:: rma_history
                                    
                                    	RMA history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: rma_number
                                    
                                    	RMA tracking number format is N\-N\-N
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    .. attribute:: test_history
                                    
                                    	Test history
                                    	**type**\:  str
                                    
                                    	**length:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'invmgr-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                        self.yang_name = "rma"
                                        self.yang_parent_name = "eeprom"

                                        self.rma_history = YLeaf(YType.str, "rma-history")

                                        self.rma_number = YLeaf(YType.str, "rma-number")

                                        self.test_history = YLeaf(YType.str, "test-history")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rma_history",
                                                        "rma_number",
                                                        "test_history") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.rma_history.is_set or
                                            self.rma_number.is_set or
                                            self.test_history.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rma_history.yfilter != YFilter.not_set or
                                            self.rma_number.yfilter != YFilter.not_set or
                                            self.test_history.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rma" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_history.get_name_leafdata())
                                        if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rma_number.get_name_leafdata())
                                        if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.test_history.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rma-history"):
                                            self.rma_history = value
                                            self.rma_history.value_namespace = name_space
                                            self.rma_history.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rma-number"):
                                            self.rma_number = value
                                            self.rma_number.value_namespace = name_space
                                            self.rma_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "test-history"):
                                            self.test_history = value
                                            self.test_history.value_namespace = name_space
                                            self.test_history.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.asset_alias.is_set or
                                        self.asset_id.is_set or
                                        self.base_mac_address1.is_set or
                                        self.base_mac_address2.is_set or
                                        self.base_mac_address3.is_set or
                                        self.base_mac_address4.is_set or
                                        self.block_checksum.is_set or
                                        self.block_count.is_set or
                                        self.block_length.is_set or
                                        self.block_signature.is_set or
                                        self.block_version.is_set or
                                        self.chassis_sid.is_set or
                                        self.clei.is_set or
                                        self.controller_family.is_set or
                                        self.controller_type.is_set or
                                        self.description.is_set or
                                        self.dev_num1.is_set or
                                        self.dev_num2.is_set or
                                        self.dev_num3.is_set or
                                        self.dev_num4.is_set or
                                        self.dev_num5.is_set or
                                        self.dev_num6.is_set or
                                        self.dev_num7.is_set or
                                        self.eci.is_set or
                                        self.eeprom_size.is_set or
                                        self.engineer_use.is_set or
                                        self.fru_major_type.is_set or
                                        self.fru_minor_type.is_set or
                                        self.hw_version.is_set or
                                        self.hwid.is_set or
                                        self.idprom_format_rev.is_set or
                                        self.mac_add_blk_size1.is_set or
                                        self.mac_add_blk_size2.is_set or
                                        self.mac_add_blk_size3.is_set or
                                        self.mac_add_blk_size4.is_set or
                                        self.manu_test_data.is_set or
                                        self.mfg_bits.is_set or
                                        self.mfg_deviation.is_set or
                                        self.oem_string.is_set or
                                        self.part_number.is_set or
                                        self.part_revision.is_set or
                                        self.pca_num.is_set or
                                        self.pcavid.is_set or
                                        self.pcb_serial_num.is_set or
                                        self.pid.is_set or
                                        self.power_consumption.is_set or
                                        self.power_supply_type.is_set or
                                        self.product_id.is_set or
                                        self.rma_code.is_set or
                                        self.serial_number.is_set or
                                        self.snmpoid.is_set or
                                        self.top_assem_part_num.is_set or
                                        self.top_assem_vid.is_set or
                                        self.udi_description.is_set or
                                        self.udi_name.is_set or
                                        self.vid.is_set or
                                        (self.rma is not None and self.rma.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.asset_alias.yfilter != YFilter.not_set or
                                        self.asset_id.yfilter != YFilter.not_set or
                                        self.base_mac_address1.yfilter != YFilter.not_set or
                                        self.base_mac_address2.yfilter != YFilter.not_set or
                                        self.base_mac_address3.yfilter != YFilter.not_set or
                                        self.base_mac_address4.yfilter != YFilter.not_set or
                                        self.block_checksum.yfilter != YFilter.not_set or
                                        self.block_count.yfilter != YFilter.not_set or
                                        self.block_length.yfilter != YFilter.not_set or
                                        self.block_signature.yfilter != YFilter.not_set or
                                        self.block_version.yfilter != YFilter.not_set or
                                        self.chassis_sid.yfilter != YFilter.not_set or
                                        self.clei.yfilter != YFilter.not_set or
                                        self.controller_family.yfilter != YFilter.not_set or
                                        self.controller_type.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.dev_num1.yfilter != YFilter.not_set or
                                        self.dev_num2.yfilter != YFilter.not_set or
                                        self.dev_num3.yfilter != YFilter.not_set or
                                        self.dev_num4.yfilter != YFilter.not_set or
                                        self.dev_num5.yfilter != YFilter.not_set or
                                        self.dev_num6.yfilter != YFilter.not_set or
                                        self.dev_num7.yfilter != YFilter.not_set or
                                        self.eci.yfilter != YFilter.not_set or
                                        self.eeprom_size.yfilter != YFilter.not_set or
                                        self.engineer_use.yfilter != YFilter.not_set or
                                        self.fru_major_type.yfilter != YFilter.not_set or
                                        self.fru_minor_type.yfilter != YFilter.not_set or
                                        self.hw_version.yfilter != YFilter.not_set or
                                        self.hwid.yfilter != YFilter.not_set or
                                        self.idprom_format_rev.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                        self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                        self.manu_test_data.yfilter != YFilter.not_set or
                                        self.mfg_bits.yfilter != YFilter.not_set or
                                        self.mfg_deviation.yfilter != YFilter.not_set or
                                        self.oem_string.yfilter != YFilter.not_set or
                                        self.part_number.yfilter != YFilter.not_set or
                                        self.part_revision.yfilter != YFilter.not_set or
                                        self.pca_num.yfilter != YFilter.not_set or
                                        self.pcavid.yfilter != YFilter.not_set or
                                        self.pcb_serial_num.yfilter != YFilter.not_set or
                                        self.pid.yfilter != YFilter.not_set or
                                        self.power_consumption.yfilter != YFilter.not_set or
                                        self.power_supply_type.yfilter != YFilter.not_set or
                                        self.product_id.yfilter != YFilter.not_set or
                                        self.rma_code.yfilter != YFilter.not_set or
                                        self.serial_number.yfilter != YFilter.not_set or
                                        self.snmpoid.yfilter != YFilter.not_set or
                                        self.top_assem_part_num.yfilter != YFilter.not_set or
                                        self.top_assem_vid.yfilter != YFilter.not_set or
                                        self.udi_description.yfilter != YFilter.not_set or
                                        self.udi_name.yfilter != YFilter.not_set or
                                        self.vid.yfilter != YFilter.not_set or
                                        (self.rma is not None and self.rma.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "eeprom" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_alias.get_name_leafdata())
                                    if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.asset_id.get_name_leafdata())
                                    if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                                    if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                                    if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                                    if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                                    if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_checksum.get_name_leafdata())
                                    if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_count.get_name_leafdata())
                                    if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_length.get_name_leafdata())
                                    if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_signature.get_name_leafdata())
                                    if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.block_version.get_name_leafdata())
                                    if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                                    if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.clei.get_name_leafdata())
                                    if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_family.get_name_leafdata())
                                    if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.controller_type.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num1.get_name_leafdata())
                                    if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num2.get_name_leafdata())
                                    if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num3.get_name_leafdata())
                                    if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num4.get_name_leafdata())
                                    if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num5.get_name_leafdata())
                                    if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num6.get_name_leafdata())
                                    if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dev_num7.get_name_leafdata())
                                    if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eci.get_name_leafdata())
                                    if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                                    if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.engineer_use.get_name_leafdata())
                                    if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                                    if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                                    if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hw_version.get_name_leafdata())
                                    if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hwid.get_name_leafdata())
                                    if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                                    if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                                    if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                                    if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                                    if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                                    if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                                    if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                                    if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                                    if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.oem_string.get_name_leafdata())
                                    if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_number.get_name_leafdata())
                                    if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.part_revision.get_name_leafdata())
                                    if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pca_num.get_name_leafdata())
                                    if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcavid.get_name_leafdata())
                                    if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                                    if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pid.get_name_leafdata())
                                    if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_consumption.get_name_leafdata())
                                    if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                                    if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.product_id.get_name_leafdata())
                                    if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rma_code.get_name_leafdata())
                                    if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.serial_number.get_name_leafdata())
                                    if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.snmpoid.get_name_leafdata())
                                    if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                                    if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                                    if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_description.get_name_leafdata())
                                    if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.udi_name.get_name_leafdata())
                                    if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vid.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rma"):
                                        if (self.rma is None):
                                            self.rma = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom.Rma()
                                            self.rma.parent = self
                                            self._children_name_map["rma"] = "rma"
                                        return self.rma

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "asset-alias"):
                                        self.asset_alias = value
                                        self.asset_alias.value_namespace = name_space
                                        self.asset_alias.value_namespace_prefix = name_space_prefix
                                    if(value_path == "asset-id"):
                                        self.asset_id = value
                                        self.asset_id.value_namespace = name_space
                                        self.asset_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address1"):
                                        self.base_mac_address1 = value
                                        self.base_mac_address1.value_namespace = name_space
                                        self.base_mac_address1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address2"):
                                        self.base_mac_address2 = value
                                        self.base_mac_address2.value_namespace = name_space
                                        self.base_mac_address2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address3"):
                                        self.base_mac_address3 = value
                                        self.base_mac_address3.value_namespace = name_space
                                        self.base_mac_address3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "base-mac-address4"):
                                        self.base_mac_address4 = value
                                        self.base_mac_address4.value_namespace = name_space
                                        self.base_mac_address4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-checksum"):
                                        self.block_checksum = value
                                        self.block_checksum.value_namespace = name_space
                                        self.block_checksum.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-count"):
                                        self.block_count = value
                                        self.block_count.value_namespace = name_space
                                        self.block_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-length"):
                                        self.block_length = value
                                        self.block_length.value_namespace = name_space
                                        self.block_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-signature"):
                                        self.block_signature = value
                                        self.block_signature.value_namespace = name_space
                                        self.block_signature.value_namespace_prefix = name_space_prefix
                                    if(value_path == "block-version"):
                                        self.block_version = value
                                        self.block_version.value_namespace = name_space
                                        self.block_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "chassis-sid"):
                                        self.chassis_sid = value
                                        self.chassis_sid.value_namespace = name_space
                                        self.chassis_sid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "clei"):
                                        self.clei = value
                                        self.clei.value_namespace = name_space
                                        self.clei.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-family"):
                                        self.controller_family = value
                                        self.controller_family.value_namespace = name_space
                                        self.controller_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "controller-type"):
                                        self.controller_type = value
                                        self.controller_type.value_namespace = name_space
                                        self.controller_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num1"):
                                        self.dev_num1 = value
                                        self.dev_num1.value_namespace = name_space
                                        self.dev_num1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num2"):
                                        self.dev_num2 = value
                                        self.dev_num2.value_namespace = name_space
                                        self.dev_num2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num3"):
                                        self.dev_num3 = value
                                        self.dev_num3.value_namespace = name_space
                                        self.dev_num3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num4"):
                                        self.dev_num4 = value
                                        self.dev_num4.value_namespace = name_space
                                        self.dev_num4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num5"):
                                        self.dev_num5 = value
                                        self.dev_num5.value_namespace = name_space
                                        self.dev_num5.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num6"):
                                        self.dev_num6 = value
                                        self.dev_num6.value_namespace = name_space
                                        self.dev_num6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dev-num7"):
                                        self.dev_num7 = value
                                        self.dev_num7.value_namespace = name_space
                                        self.dev_num7.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eci"):
                                        self.eci = value
                                        self.eci.value_namespace = name_space
                                        self.eci.value_namespace_prefix = name_space_prefix
                                    if(value_path == "eeprom-size"):
                                        self.eeprom_size = value
                                        self.eeprom_size.value_namespace = name_space
                                        self.eeprom_size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "engineer-use"):
                                        self.engineer_use = value
                                        self.engineer_use.value_namespace = name_space
                                        self.engineer_use.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-major-type"):
                                        self.fru_major_type = value
                                        self.fru_major_type.value_namespace = name_space
                                        self.fru_major_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fru-minor-type"):
                                        self.fru_minor_type = value
                                        self.fru_minor_type.value_namespace = name_space
                                        self.fru_minor_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hw-version"):
                                        self.hw_version = value
                                        self.hw_version.value_namespace = name_space
                                        self.hw_version.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hwid"):
                                        self.hwid = value
                                        self.hwid.value_namespace = name_space
                                        self.hwid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "idprom-format-rev"):
                                        self.idprom_format_rev = value
                                        self.idprom_format_rev.value_namespace = name_space
                                        self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size1"):
                                        self.mac_add_blk_size1 = value
                                        self.mac_add_blk_size1.value_namespace = name_space
                                        self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size2"):
                                        self.mac_add_blk_size2 = value
                                        self.mac_add_blk_size2.value_namespace = name_space
                                        self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size3"):
                                        self.mac_add_blk_size3 = value
                                        self.mac_add_blk_size3.value_namespace = name_space
                                        self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mac-add-blk-size4"):
                                        self.mac_add_blk_size4 = value
                                        self.mac_add_blk_size4.value_namespace = name_space
                                        self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "manu-test-data"):
                                        self.manu_test_data = value
                                        self.manu_test_data.value_namespace = name_space
                                        self.manu_test_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-bits"):
                                        self.mfg_bits = value
                                        self.mfg_bits.value_namespace = name_space
                                        self.mfg_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mfg-deviation"):
                                        self.mfg_deviation = value
                                        self.mfg_deviation.value_namespace = name_space
                                        self.mfg_deviation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "oem-string"):
                                        self.oem_string = value
                                        self.oem_string.value_namespace = name_space
                                        self.oem_string.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-number"):
                                        self.part_number = value
                                        self.part_number.value_namespace = name_space
                                        self.part_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "part-revision"):
                                        self.part_revision = value
                                        self.part_revision.value_namespace = name_space
                                        self.part_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pca-num"):
                                        self.pca_num = value
                                        self.pca_num.value_namespace = name_space
                                        self.pca_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcavid"):
                                        self.pcavid = value
                                        self.pcavid.value_namespace = name_space
                                        self.pcavid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pcb-serial-num"):
                                        self.pcb_serial_num = value
                                        self.pcb_serial_num.value_namespace = name_space
                                        self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pid"):
                                        self.pid = value
                                        self.pid.value_namespace = name_space
                                        self.pid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-consumption"):
                                        self.power_consumption = value
                                        self.power_consumption.value_namespace = name_space
                                        self.power_consumption.value_namespace_prefix = name_space_prefix
                                    if(value_path == "power-supply-type"):
                                        self.power_supply_type = value
                                        self.power_supply_type.value_namespace = name_space
                                        self.power_supply_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "product-id"):
                                        self.product_id = value
                                        self.product_id.value_namespace = name_space
                                        self.product_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rma-code"):
                                        self.rma_code = value
                                        self.rma_code.value_namespace = name_space
                                        self.rma_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "serial-number"):
                                        self.serial_number = value
                                        self.serial_number.value_namespace = name_space
                                        self.serial_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "snmpoid"):
                                        self.snmpoid = value
                                        self.snmpoid.value_namespace = name_space
                                        self.snmpoid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-part-num"):
                                        self.top_assem_part_num = value
                                        self.top_assem_part_num.value_namespace = name_space
                                        self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                                    if(value_path == "top-assem-vid"):
                                        self.top_assem_vid = value
                                        self.top_assem_vid.value_namespace = name_space
                                        self.top_assem_vid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-description"):
                                        self.udi_description = value
                                        self.udi_description.value_namespace = name_space
                                        self.udi_description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "udi-name"):
                                        self.udi_name = value
                                        self.udi_name.value_namespace = name_space
                                        self.udi_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vid"):
                                        self.vid = value
                                        self.vid.value_namespace = name_space
                                        self.vid.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.description.is_set or
                                    self.has_eeprom.is_set or
                                    self.inv_card_type.is_set or
                                    self.opaque_data.is_set or
                                    self.opaque_data_size.is_set or
                                    (self.eeprom is not None and self.eeprom.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.has_eeprom.yfilter != YFilter.not_set or
                                    self.inv_card_type.yfilter != YFilter.not_set or
                                    self.opaque_data.yfilter != YFilter.not_set or
                                    self.opaque_data_size.yfilter != YFilter.not_set or
                                    (self.eeprom is not None and self.eeprom.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "inv-eeprom-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                                if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                                if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data.get_name_leafdata())
                                if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "eeprom"):
                                    if (self.eeprom is None):
                                        self.eeprom = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo.Eeprom()
                                        self.eeprom.parent = self
                                        self._children_name_map["eeprom"] = "eeprom"
                                    return self.eeprom

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-eeprom"):
                                    self.has_eeprom = value
                                    self.has_eeprom.value_namespace = name_space
                                    self.has_eeprom.value_namespace_prefix = name_space_prefix
                                if(value_path == "inv-card-type"):
                                    self.inv_card_type = value
                                    self.inv_card_type.value_namespace = name_space
                                    self.inv_card_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data"):
                                    self.opaque_data = value
                                    self.opaque_data.value_namespace = name_space
                                    self.opaque_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-data-size"):
                                    self.opaque_data_size = value
                                    self.opaque_data_size.value_namespace = name_space
                                    self.opaque_data_size.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.module_done.is_set or
                                self.node_id.is_set or
                                self.vm_done.is_set or
                                self.vm_node_id.is_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                                (self.fru_info is not None and self.fru_info.has_data()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                                (self.pwg_info is not None and self.pwg_info.has_data()) or
                                (self.threshold is not None and self.threshold.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.module_done.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.vm_done.yfilter != YFilter.not_set or
                                self.vm_node_id.yfilter != YFilter.not_set or
                                (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                                (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                                (self.fru_info is not None and self.fru_info.has_operation()) or
                                (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                                (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                                (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                                (self.pwg_info is not None and self.pwg_info.has_operation()) or
                                (self.threshold is not None and self.threshold.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attributes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.module_done.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_done.get_name_leafdata())
                            if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "env-sensor-info"):
                                if (self.env_sensor_info is None):
                                    self.env_sensor_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfo()
                                    self.env_sensor_info.parent = self
                                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                                return self.env_sensor_info

                            if (child_yang_name == "env-sensor-info-xml"):
                                if (self.env_sensor_info_xml is None):
                                    self.env_sensor_info_xml = Inventory.Racks.Rack.Fantray.Slot.Attributes.EnvSensorInfoXml()
                                    self.env_sensor_info_xml.parent = self
                                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                                return self.env_sensor_info_xml

                            if (child_yang_name == "fru-info"):
                                if (self.fru_info is None):
                                    self.fru_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.FruInfo()
                                    self.fru_info.parent = self
                                    self._children_name_map["fru_info"] = "fru-info"
                                return self.fru_info

                            if (child_yang_name == "inv-asset-bag"):
                                if (self.inv_asset_bag is None):
                                    self.inv_asset_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvAssetBag()
                                    self.inv_asset_bag.parent = self
                                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                                return self.inv_asset_bag

                            if (child_yang_name == "inv-basic-bag"):
                                if (self.inv_basic_bag is None):
                                    self.inv_basic_bag = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvBasicBag()
                                    self.inv_basic_bag.parent = self
                                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                                return self.inv_basic_bag

                            if (child_yang_name == "inv-eeprom-info"):
                                if (self.inv_eeprom_info is None):
                                    self.inv_eeprom_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.InvEepromInfo()
                                    self.inv_eeprom_info.parent = self
                                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                                return self.inv_eeprom_info

                            if (child_yang_name == "pwg-info"):
                                if (self.pwg_info is None):
                                    self.pwg_info = Inventory.Racks.Rack.Fantray.Slot.Attributes.PwgInfo()
                                    self.pwg_info.parent = self
                                    self._children_name_map["pwg_info"] = "pwg-info"
                                return self.pwg_info

                            if (child_yang_name == "threshold"):
                                if (self.threshold is None):
                                    self.threshold = Inventory.Racks.Rack.Fantray.Slot.Attributes.Threshold()
                                    self.threshold.parent = self
                                    self._children_name_map["threshold"] = "threshold"
                                return self.threshold

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "module-done"):
                                self.module_done = value
                                self.module_done.value_namespace = name_space
                                self.module_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-done"):
                                self.vm_done = value
                                self.vm_done.value_namespace = name_space
                                self.vm_done.value_namespace_prefix = name_space_prefix
                            if(value_path == "vm-node-id"):
                                self.vm_node_id = value
                                self.vm_node_id.value_namespace = name_space
                                self.vm_node_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.name.is_set or
                            (self.attributes is not None and self.attributes.has_data()) or
                            (self.tsi1s is not None and self.tsi1s.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            (self.attributes is not None and self.attributes.has_operation()) or
                            (self.tsi1s is not None and self.tsi1s.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slot" + "[name='" + self.name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attributes"):
                            if (self.attributes is None):
                                self.attributes = Inventory.Racks.Rack.Fantray.Slot.Attributes()
                                self.attributes.parent = self
                                self._children_name_map["attributes"] = "attributes"
                            return self.attributes

                        if (child_yang_name == "tsi1s"):
                            if (self.tsi1s is None):
                                self.tsi1s = Inventory.Racks.Rack.Fantray.Slot.Tsi1S()
                                self.tsi1s.parent = self
                                self._children_name_map["tsi1s"] = "tsi1s"
                            return self.tsi1s

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attributes" or name == "tsi1s" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.slot:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.slot:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "fantray" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "slot"):
                        for c in self.slot:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Inventory.Racks.Rack.Fantray.Slot()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.slot.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "slot"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Attributes(Entity):
                """
                Attributes
                
                .. attribute:: env_sensor_info
                
                	Environment sensor info
                	**type**\:   :py:class:`EnvSensorInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfo>`
                
                .. attribute:: env_sensor_info_xml
                
                	Environment sensor info XML
                	**type**\:   :py:class:`EnvSensorInfoXml <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml>`
                
                .. attribute:: fru_info
                
                	Inventory EDM FRU info
                	**type**\:   :py:class:`FruInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo>`
                
                .. attribute:: inv_asset_bag
                
                	Inventory Asset Bag
                	**type**\:   :py:class:`InvAssetBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvAssetBag>`
                
                .. attribute:: inv_basic_bag
                
                	Inventory Basic Bag
                	**type**\:   :py:class:`InvBasicBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvBasicBag>`
                
                .. attribute:: inv_eeprom_info
                
                	Inventory EDM EEPROM Information Bag
                	**type**\:   :py:class:`InvEepromInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo>`
                
                .. attribute:: module_done
                
                	Inventory EDM Module Done Tuple
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                	**default value**\: 1
                
                .. attribute:: node_id
                
                	Node ID Tuple
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pwg_info
                
                	Inventory EDM PWG info
                	**type**\:   :py:class:`PwgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.PwgInfo>`
                
                .. attribute:: threshold
                
                	Threshold
                	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold>`
                
                .. attribute:: vm_done
                
                	VM Done Tuple
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: vm_node_id
                
                	VM Node ID Tuple
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'invmgr-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Inventory.Racks.Rack.Attributes, self).__init__()

                    self.yang_name = "attributes"
                    self.yang_parent_name = "rack"

                    self.module_done = YLeaf(YType.int32, "module-done")

                    self.node_id = YLeaf(YType.uint32, "node-id")

                    self.vm_done = YLeaf(YType.int32, "vm-done")

                    self.vm_node_id = YLeaf(YType.uint32, "vm-node-id")

                    self.env_sensor_info = Inventory.Racks.Rack.Attributes.EnvSensorInfo()
                    self.env_sensor_info.parent = self
                    self._children_name_map["env_sensor_info"] = "env-sensor-info"
                    self._children_yang_names.add("env-sensor-info")

                    self.env_sensor_info_xml = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml()
                    self.env_sensor_info_xml.parent = self
                    self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                    self._children_yang_names.add("env-sensor-info-xml")

                    self.fru_info = Inventory.Racks.Rack.Attributes.FruInfo()
                    self.fru_info.parent = self
                    self._children_name_map["fru_info"] = "fru-info"
                    self._children_yang_names.add("fru-info")

                    self.inv_asset_bag = Inventory.Racks.Rack.Attributes.InvAssetBag()
                    self.inv_asset_bag.parent = self
                    self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                    self._children_yang_names.add("inv-asset-bag")

                    self.inv_basic_bag = Inventory.Racks.Rack.Attributes.InvBasicBag()
                    self.inv_basic_bag.parent = self
                    self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                    self._children_yang_names.add("inv-basic-bag")

                    self.inv_eeprom_info = Inventory.Racks.Rack.Attributes.InvEepromInfo()
                    self.inv_eeprom_info.parent = self
                    self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                    self._children_yang_names.add("inv-eeprom-info")

                    self.pwg_info = Inventory.Racks.Rack.Attributes.PwgInfo()
                    self.pwg_info.parent = self
                    self._children_name_map["pwg_info"] = "pwg-info"
                    self._children_yang_names.add("pwg-info")

                    self.threshold = Inventory.Racks.Rack.Attributes.Threshold()
                    self.threshold.parent = self
                    self._children_name_map["threshold"] = "threshold"
                    self._children_yang_names.add("threshold")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("module_done",
                                    "node_id",
                                    "vm_done",
                                    "vm_node_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Inventory.Racks.Rack.Attributes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Inventory.Racks.Rack.Attributes, self).__setattr__(name, value)


                class EnvSensorInfo(Entity):
                    """
                    Environment sensor info
                    
                    .. attribute:: age_time_stamp
                    
                    	Age of the sensor value; set to the current time if directly access the value from sensor
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: alarm_type
                    
                    	Indicates threshold violation
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: data_type
                    
                    	Sensor data type enums
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: device_description
                    
                    	Device Name
                    	**type**\:  str
                    
                    	**length:** 0..50
                    
                    .. attribute:: device_id
                    
                    	Identifier for this device
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: field_validity_bitmap
                    
                    	Sensor valid bitmap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: precision
                    
                    	Sensor precision range
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: scale
                    
                    	Sensor scale enums
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: status
                    
                    	Sensor operation state enums
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\:  str
                    
                    	**length:** 0..50
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate;set to 0 if sensor value is updated and evaluated immediately
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: value
                    
                    	Current reading of sensor
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.EnvSensorInfo, self).__init__()

                        self.yang_name = "env-sensor-info"
                        self.yang_parent_name = "attributes"

                        self.age_time_stamp = YLeaf(YType.uint32, "age-time-stamp")

                        self.alarm_type = YLeaf(YType.uint32, "alarm-type")

                        self.data_type = YLeaf(YType.uint32, "data-type")

                        self.device_description = YLeaf(YType.str, "device-description")

                        self.device_id = YLeaf(YType.uint32, "device-id")

                        self.field_validity_bitmap = YLeaf(YType.uint32, "field-validity-bitmap")

                        self.precision = YLeaf(YType.uint32, "precision")

                        self.scale = YLeaf(YType.uint32, "scale")

                        self.status = YLeaf(YType.uint32, "status")

                        self.units = YLeaf(YType.str, "units")

                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                        self.value = YLeaf(YType.uint32, "value")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("age_time_stamp",
                                        "alarm_type",
                                        "data_type",
                                        "device_description",
                                        "device_id",
                                        "field_validity_bitmap",
                                        "precision",
                                        "scale",
                                        "status",
                                        "units",
                                        "update_rate",
                                        "value") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.EnvSensorInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.EnvSensorInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.age_time_stamp.is_set or
                            self.alarm_type.is_set or
                            self.data_type.is_set or
                            self.device_description.is_set or
                            self.device_id.is_set or
                            self.field_validity_bitmap.is_set or
                            self.precision.is_set or
                            self.scale.is_set or
                            self.status.is_set or
                            self.units.is_set or
                            self.update_rate.is_set or
                            self.value.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.age_time_stamp.yfilter != YFilter.not_set or
                            self.alarm_type.yfilter != YFilter.not_set or
                            self.data_type.yfilter != YFilter.not_set or
                            self.device_description.yfilter != YFilter.not_set or
                            self.device_id.yfilter != YFilter.not_set or
                            self.field_validity_bitmap.yfilter != YFilter.not_set or
                            self.precision.yfilter != YFilter.not_set or
                            self.scale.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.units.yfilter != YFilter.not_set or
                            self.update_rate.yfilter != YFilter.not_set or
                            self.value.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "env-sensor-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.age_time_stamp.is_set or self.age_time_stamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.age_time_stamp.get_name_leafdata())
                        if (self.alarm_type.is_set or self.alarm_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.alarm_type.get_name_leafdata())
                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.data_type.get_name_leafdata())
                        if (self.device_description.is_set or self.device_description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.device_description.get_name_leafdata())
                        if (self.device_id.is_set or self.device_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.device_id.get_name_leafdata())
                        if (self.field_validity_bitmap.is_set or self.field_validity_bitmap.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.field_validity_bitmap.get_name_leafdata())
                        if (self.precision.is_set or self.precision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.precision.get_name_leafdata())
                        if (self.scale.is_set or self.scale.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.scale.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.units.get_name_leafdata())
                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.value.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "age-time-stamp" or name == "alarm-type" or name == "data-type" or name == "device-description" or name == "device-id" or name == "field-validity-bitmap" or name == "precision" or name == "scale" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "age-time-stamp"):
                            self.age_time_stamp = value
                            self.age_time_stamp.value_namespace = name_space
                            self.age_time_stamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "alarm-type"):
                            self.alarm_type = value
                            self.alarm_type.value_namespace = name_space
                            self.alarm_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "data-type"):
                            self.data_type = value
                            self.data_type.value_namespace = name_space
                            self.data_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "device-description"):
                            self.device_description = value
                            self.device_description.value_namespace = name_space
                            self.device_description.value_namespace_prefix = name_space_prefix
                        if(value_path == "device-id"):
                            self.device_id = value
                            self.device_id.value_namespace = name_space
                            self.device_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "field-validity-bitmap"):
                            self.field_validity_bitmap = value
                            self.field_validity_bitmap.value_namespace = name_space
                            self.field_validity_bitmap.value_namespace_prefix = name_space_prefix
                        if(value_path == "precision"):
                            self.precision = value
                            self.precision.value_namespace = name_space
                            self.precision.value_namespace_prefix = name_space_prefix
                        if(value_path == "scale"):
                            self.scale = value
                            self.scale.value_namespace = name_space
                            self.scale.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "units"):
                            self.units = value
                            self.units.value_namespace = name_space
                            self.units.value_namespace_prefix = name_space_prefix
                        if(value_path == "update-rate"):
                            self.update_rate = value
                            self.update_rate.value_namespace = name_space
                            self.update_rate.value_namespace_prefix = name_space_prefix
                        if(value_path == "value"):
                            self.value = value
                            self.value.value_namespace = name_space
                            self.value.value_namespace_prefix = name_space_prefix


                class PwgInfo(Entity):
                    """
                    Inventory EDM PWG info
                    
                    .. attribute:: power_group_available_current
                    
                    	available current
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: power_group_drawn_current
                    
                    	drawn current
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: power_group_power_units
                    
                    	power units
                    	**type**\:  str
                    
                    .. attribute:: power_group_redundancy_mode
                    
                    	redundancy mode
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.PwgInfo, self).__init__()

                        self.yang_name = "pwg-info"
                        self.yang_parent_name = "attributes"

                        self.power_group_available_current = YLeaf(YType.int32, "power-group-available-current")

                        self.power_group_drawn_current = YLeaf(YType.int32, "power-group-drawn-current")

                        self.power_group_power_units = YLeaf(YType.str, "power-group-power-units")

                        self.power_group_redundancy_mode = YLeaf(YType.int32, "power-group-redundancy-mode")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("power_group_available_current",
                                        "power_group_drawn_current",
                                        "power_group_power_units",
                                        "power_group_redundancy_mode") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.PwgInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.PwgInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.power_group_available_current.is_set or
                            self.power_group_drawn_current.is_set or
                            self.power_group_power_units.is_set or
                            self.power_group_redundancy_mode.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.power_group_available_current.yfilter != YFilter.not_set or
                            self.power_group_drawn_current.yfilter != YFilter.not_set or
                            self.power_group_power_units.yfilter != YFilter.not_set or
                            self.power_group_redundancy_mode.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pwg-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.power_group_available_current.is_set or self.power_group_available_current.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_group_available_current.get_name_leafdata())
                        if (self.power_group_drawn_current.is_set or self.power_group_drawn_current.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_group_drawn_current.get_name_leafdata())
                        if (self.power_group_power_units.is_set or self.power_group_power_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_group_power_units.get_name_leafdata())
                        if (self.power_group_redundancy_mode.is_set or self.power_group_redundancy_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_group_redundancy_mode.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "power-group-available-current" or name == "power-group-drawn-current" or name == "power-group-power-units" or name == "power-group-redundancy-mode"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "power-group-available-current"):
                            self.power_group_available_current = value
                            self.power_group_available_current.value_namespace = name_space
                            self.power_group_available_current.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-group-drawn-current"):
                            self.power_group_drawn_current = value
                            self.power_group_drawn_current.value_namespace = name_space
                            self.power_group_drawn_current.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-group-power-units"):
                            self.power_group_power_units = value
                            self.power_group_power_units.value_namespace = name_space
                            self.power_group_power_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-group-redundancy-mode"):
                            self.power_group_redundancy_mode = value
                            self.power_group_redundancy_mode.value_namespace = name_space
                            self.power_group_redundancy_mode.value_namespace_prefix = name_space_prefix


                class EnvSensorInfoXml(Entity):
                    """
                    Environment sensor info XML
                    
                    .. attribute:: data_type
                    
                    	Sensor data type
                    	**type**\:   :py:class:`SensorData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorData>`
                    
                    .. attribute:: description
                    
                    	Device Name
                    	**type**\:  str
                    
                    	**length:** 0..50
                    
                    .. attribute:: status
                    
                    	Sensor operation state
                    	**type**\:   :py:class:`SensorStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.SensorStatus>`
                    
                    .. attribute:: threshold
                    
                    	Threshold information
                    	**type**\:   :py:class:`Threshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold>`
                    
                    .. attribute:: units
                    
                    	Units of variable being read
                    	**type**\:   :py:class:`Unit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Unit>`
                    
                    .. attribute:: update_rate
                    
                    	Sensor value update rate; set to 0 if sensor value is updated and evaluated immediately
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: value
                    
                    	Current reading of sensor Displays in decimal(ex 1.234) for powersupply sensor type
                    	**type**\:  str
                    
                    	**length:** 0..50
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml, self).__init__()

                        self.yang_name = "env-sensor-info-xml"
                        self.yang_parent_name = "attributes"

                        self.data_type = YLeaf(YType.enumeration, "data-type")

                        self.description = YLeaf(YType.str, "description")

                        self.status = YLeaf(YType.enumeration, "status")

                        self.units = YLeaf(YType.enumeration, "units")

                        self.update_rate = YLeaf(YType.uint32, "update-rate")

                        self.value = YLeaf(YType.str, "value")

                        self.threshold = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold()
                        self.threshold.parent = self
                        self._children_name_map["threshold"] = "threshold"
                        self._children_yang_names.add("threshold")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("data_type",
                                        "description",
                                        "status",
                                        "units",
                                        "update_rate",
                                        "value") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml, self).__setattr__(name, value)


                    class Threshold(Entity):
                        """
                        Threshold information
                        
                        .. attribute:: threshold_array
                        
                        	Array of threshold
                        	**type**\: list of    :py:class:`ThresholdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold, self).__init__()

                            self.yang_name = "threshold"
                            self.yang_parent_name = "env-sensor-info-xml"

                            self.threshold_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold, self).__setattr__(name, value)


                        class ThresholdArray(Entity):
                            """
                            Array of threshold
                            
                            .. attribute:: threshold_name
                            
                            	Threshold name
                            	**type**\:  str
                            
                            	**length:** 0..50
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:   :py:class:`ThresholdRelation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdRelation>`
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:   :py:class:`ThresholdSeverity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.ThresholdSeverity>`
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__init__()

                                self.yang_name = "threshold-array"
                                self.yang_parent_name = "threshold"

                                self.threshold_name = YLeaf(YType.str, "threshold-name")

                                self.threshold_relation = YLeaf(YType.enumeration, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.enumeration, "threshold-severity")

                                self.threshold_value = YLeaf(YType.int32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_name",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_name.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_name.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "threshold-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_name.is_set or self.threshold_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_name.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-name" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-name"):
                                    self.threshold_name = value
                                    self.threshold_name.value_namespace = name_space
                                    self.threshold_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.threshold_array:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.threshold_array:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "threshold" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "threshold-array"):
                                for c in self.threshold_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold.ThresholdArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.threshold_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "threshold-array"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.data_type.is_set or
                            self.description.is_set or
                            self.status.is_set or
                            self.units.is_set or
                            self.update_rate.is_set or
                            self.value.is_set or
                            (self.threshold is not None and self.threshold.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.data_type.yfilter != YFilter.not_set or
                            self.description.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.units.yfilter != YFilter.not_set or
                            self.update_rate.yfilter != YFilter.not_set or
                            self.value.yfilter != YFilter.not_set or
                            (self.threshold is not None and self.threshold.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "env-sensor-info-xml" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.data_type.is_set or self.data_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.data_type.get_name_leafdata())
                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.description.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.units.is_set or self.units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.units.get_name_leafdata())
                        if (self.update_rate.is_set or self.update_rate.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.update_rate.get_name_leafdata())
                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.value.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "threshold"):
                            if (self.threshold is None):
                                self.threshold = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml.Threshold()
                                self.threshold.parent = self
                                self._children_name_map["threshold"] = "threshold"
                            return self.threshold

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "threshold" or name == "data-type" or name == "description" or name == "status" or name == "units" or name == "update-rate" or name == "value"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "data-type"):
                            self.data_type = value
                            self.data_type.value_namespace = name_space
                            self.data_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "description"):
                            self.description = value
                            self.description.value_namespace = name_space
                            self.description.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "units"):
                            self.units = value
                            self.units.value_namespace = name_space
                            self.units.value_namespace_prefix = name_space_prefix
                        if(value_path == "update-rate"):
                            self.update_rate = value
                            self.update_rate.value_namespace = name_space
                            self.update_rate.value_namespace_prefix = name_space_prefix
                        if(value_path == "value"):
                            self.value = value
                            self.value.value_namespace = name_space
                            self.value.value_namespace_prefix = name_space_prefix


                class InvAssetBag(Entity):
                    """
                    Inventory Asset Bag
                    
                    .. attribute:: manufacturer_assembly_number
                    
                    	Manufacture Assembly number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_assembly_revision
                    
                    	Manufacture assembly revision
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_common_language_equipment_identifier
                    
                    	Common Language Equipment           Identifier number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_firmware_identifier
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: manufacturer_software_identifier
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: original_equipment_manufacturer_string
                    
                    	String containing OEM information           if applicable
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: part_number
                    
                    	
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.InvAssetBag, self).__init__()

                        self.yang_name = "inv-asset-bag"
                        self.yang_parent_name = "attributes"

                        self.manufacturer_assembly_number = YLeaf(YType.str, "manufacturer-assembly-number")

                        self.manufacturer_assembly_revision = YLeaf(YType.str, "manufacturer-assembly-revision")

                        self.manufacturer_common_language_equipment_identifier = YLeaf(YType.str, "manufacturer-common-language-equipment-identifier")

                        self.manufacturer_firmware_identifier = YLeaf(YType.str, "manufacturer-firmware-identifier")

                        self.manufacturer_software_identifier = YLeaf(YType.str, "manufacturer-software-identifier")

                        self.original_equipment_manufacturer_string = YLeaf(YType.str, "original-equipment-manufacturer-string")

                        self.part_number = YLeaf(YType.str, "part-number")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("manufacturer_assembly_number",
                                        "manufacturer_assembly_revision",
                                        "manufacturer_common_language_equipment_identifier",
                                        "manufacturer_firmware_identifier",
                                        "manufacturer_software_identifier",
                                        "original_equipment_manufacturer_string",
                                        "part_number") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.InvAssetBag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.InvAssetBag, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.manufacturer_assembly_number.is_set or
                            self.manufacturer_assembly_revision.is_set or
                            self.manufacturer_common_language_equipment_identifier.is_set or
                            self.manufacturer_firmware_identifier.is_set or
                            self.manufacturer_software_identifier.is_set or
                            self.original_equipment_manufacturer_string.is_set or
                            self.part_number.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.manufacturer_assembly_number.yfilter != YFilter.not_set or
                            self.manufacturer_assembly_revision.yfilter != YFilter.not_set or
                            self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set or
                            self.manufacturer_firmware_identifier.yfilter != YFilter.not_set or
                            self.manufacturer_software_identifier.yfilter != YFilter.not_set or
                            self.original_equipment_manufacturer_string.yfilter != YFilter.not_set or
                            self.part_number.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "inv-asset-bag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.manufacturer_assembly_number.is_set or self.manufacturer_assembly_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_assembly_number.get_name_leafdata())
                        if (self.manufacturer_assembly_revision.is_set or self.manufacturer_assembly_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_assembly_revision.get_name_leafdata())
                        if (self.manufacturer_common_language_equipment_identifier.is_set or self.manufacturer_common_language_equipment_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_common_language_equipment_identifier.get_name_leafdata())
                        if (self.manufacturer_firmware_identifier.is_set or self.manufacturer_firmware_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_firmware_identifier.get_name_leafdata())
                        if (self.manufacturer_software_identifier.is_set or self.manufacturer_software_identifier.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_software_identifier.get_name_leafdata())
                        if (self.original_equipment_manufacturer_string.is_set or self.original_equipment_manufacturer_string.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.original_equipment_manufacturer_string.get_name_leafdata())
                        if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.part_number.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "manufacturer-assembly-number" or name == "manufacturer-assembly-revision" or name == "manufacturer-common-language-equipment-identifier" or name == "manufacturer-firmware-identifier" or name == "manufacturer-software-identifier" or name == "original-equipment-manufacturer-string" or name == "part-number"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "manufacturer-assembly-number"):
                            self.manufacturer_assembly_number = value
                            self.manufacturer_assembly_number.value_namespace = name_space
                            self.manufacturer_assembly_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-assembly-revision"):
                            self.manufacturer_assembly_revision = value
                            self.manufacturer_assembly_revision.value_namespace = name_space
                            self.manufacturer_assembly_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-common-language-equipment-identifier"):
                            self.manufacturer_common_language_equipment_identifier = value
                            self.manufacturer_common_language_equipment_identifier.value_namespace = name_space
                            self.manufacturer_common_language_equipment_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-firmware-identifier"):
                            self.manufacturer_firmware_identifier = value
                            self.manufacturer_firmware_identifier.value_namespace = name_space
                            self.manufacturer_firmware_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-software-identifier"):
                            self.manufacturer_software_identifier = value
                            self.manufacturer_software_identifier.value_namespace = name_space
                            self.manufacturer_software_identifier.value_namespace_prefix = name_space_prefix
                        if(value_path == "original-equipment-manufacturer-string"):
                            self.original_equipment_manufacturer_string = value
                            self.original_equipment_manufacturer_string.value_namespace = name_space
                            self.original_equipment_manufacturer_string.value_namespace_prefix = name_space_prefix
                        if(value_path == "part-number"):
                            self.part_number = value
                            self.part_number.value_namespace = name_space
                            self.part_number.value_namespace_prefix = name_space_prefix


                class Threshold(Entity):
                    """
                    Threshold
                    
                    .. attribute:: critical_hi
                    
                    	Critical High
                    	**type**\:   :py:class:`CriticalHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalHi>`
                    
                    .. attribute:: critical_lo
                    
                    	Critical Low
                    	**type**\:   :py:class:`CriticalLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalLo>`
                    
                    .. attribute:: major_hi
                    
                    	Major High
                    	**type**\:   :py:class:`MajorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorHi>`
                    
                    .. attribute:: major_lo
                    
                    	Major Low
                    	**type**\:   :py:class:`MajorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorLo>`
                    
                    .. attribute:: minor_hi
                    
                    	Minor High
                    	**type**\:   :py:class:`MinorHi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorHi>`
                    
                    .. attribute:: minor_lo
                    
                    	Minor Low
                    	**type**\:   :py:class:`MinorLo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorLo>`
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.Threshold, self).__init__()

                        self.yang_name = "threshold"
                        self.yang_parent_name = "attributes"

                        self.critical_hi = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi()
                        self.critical_hi.parent = self
                        self._children_name_map["critical_hi"] = "critical-hi"
                        self._children_yang_names.add("critical-hi")

                        self.critical_lo = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo()
                        self.critical_lo.parent = self
                        self._children_name_map["critical_lo"] = "critical-lo"
                        self._children_yang_names.add("critical-lo")

                        self.major_hi = Inventory.Racks.Rack.Attributes.Threshold.MajorHi()
                        self.major_hi.parent = self
                        self._children_name_map["major_hi"] = "major-hi"
                        self._children_yang_names.add("major-hi")

                        self.major_lo = Inventory.Racks.Rack.Attributes.Threshold.MajorLo()
                        self.major_lo.parent = self
                        self._children_name_map["major_lo"] = "major-lo"
                        self._children_yang_names.add("major-lo")

                        self.minor_hi = Inventory.Racks.Rack.Attributes.Threshold.MinorHi()
                        self.minor_hi.parent = self
                        self._children_name_map["minor_hi"] = "minor-hi"
                        self._children_yang_names.add("minor-hi")

                        self.minor_lo = Inventory.Racks.Rack.Attributes.Threshold.MinorLo()
                        self.minor_lo.parent = self
                        self._children_name_map["minor_lo"] = "minor-lo"
                        self._children_yang_names.add("minor-lo")


                    class MajorLo(Entity):
                        """
                        Major Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo, self).__init__()

                            self.yang_name = "major-lo"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-lo"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "major-lo" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class CriticalHi(Entity):
                        """
                        Critical High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi, self).__init__()

                            self.yang_name = "critical-hi"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-hi"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "critical-hi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class MinorHi(Entity):
                        """
                        Minor High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi, self).__init__()

                            self.yang_name = "minor-hi"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-hi"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "minor-hi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class MajorHi(Entity):
                        """
                        Major High
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi, self).__init__()

                            self.yang_name = "major-hi"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "major-hi"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "major-hi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MajorHi.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class CriticalLo(Entity):
                        """
                        Critical Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo, self).__init__()

                            self.yang_name = "critical-lo"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "critical-lo"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "critical-lo" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class MinorLo(Entity):
                        """
                        Minor Low
                        
                        .. attribute:: thresh_bag
                        
                        	Environment threshold info
                        	**type**\:   :py:class:`ThreshBag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag>`
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo, self).__init__()

                            self.yang_name = "minor-lo"
                            self.yang_parent_name = "threshold"

                            self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag()
                            self.thresh_bag.parent = self
                            self._children_name_map["thresh_bag"] = "thresh-bag"
                            self._children_yang_names.add("thresh-bag")


                        class ThreshBag(Entity):
                            """
                            Environment threshold info
                            
                            .. attribute:: threshold_evaluation
                            
                            	Indicates the result of the most recent evaluation of the thresholD
                            	**type**\:  bool
                            
                            .. attribute:: threshold_notification_enabled
                            
                            	Indicates whether or not a notification should result, in case of threshold violation
                            	**type**\:  bool
                            
                            .. attribute:: threshold_relation
                            
                            	Indicates relation between sensor value and threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_severity
                            
                            	Indicates minor, major, critical severities
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: threshold_value
                            
                            	Value of the configured threshold
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag, self).__init__()

                                self.yang_name = "thresh-bag"
                                self.yang_parent_name = "minor-lo"

                                self.threshold_evaluation = YLeaf(YType.boolean, "threshold-evaluation")

                                self.threshold_notification_enabled = YLeaf(YType.boolean, "threshold-notification-enabled")

                                self.threshold_relation = YLeaf(YType.uint32, "threshold-relation")

                                self.threshold_severity = YLeaf(YType.uint32, "threshold-severity")

                                self.threshold_value = YLeaf(YType.uint32, "threshold-value")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("threshold_evaluation",
                                                "threshold_notification_enabled",
                                                "threshold_relation",
                                                "threshold_severity",
                                                "threshold_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.threshold_evaluation.is_set or
                                    self.threshold_notification_enabled.is_set or
                                    self.threshold_relation.is_set or
                                    self.threshold_severity.is_set or
                                    self.threshold_value.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.threshold_evaluation.yfilter != YFilter.not_set or
                                    self.threshold_notification_enabled.yfilter != YFilter.not_set or
                                    self.threshold_relation.yfilter != YFilter.not_set or
                                    self.threshold_severity.yfilter != YFilter.not_set or
                                    self.threshold_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "thresh-bag" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.threshold_evaluation.is_set or self.threshold_evaluation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_evaluation.get_name_leafdata())
                                if (self.threshold_notification_enabled.is_set or self.threshold_notification_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_notification_enabled.get_name_leafdata())
                                if (self.threshold_relation.is_set or self.threshold_relation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_relation.get_name_leafdata())
                                if (self.threshold_severity.is_set or self.threshold_severity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_severity.get_name_leafdata())
                                if (self.threshold_value.is_set or self.threshold_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.threshold_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "threshold-evaluation" or name == "threshold-notification-enabled" or name == "threshold-relation" or name == "threshold-severity" or name == "threshold-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "threshold-evaluation"):
                                    self.threshold_evaluation = value
                                    self.threshold_evaluation.value_namespace = name_space
                                    self.threshold_evaluation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-notification-enabled"):
                                    self.threshold_notification_enabled = value
                                    self.threshold_notification_enabled.value_namespace = name_space
                                    self.threshold_notification_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-relation"):
                                    self.threshold_relation = value
                                    self.threshold_relation.value_namespace = name_space
                                    self.threshold_relation.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-severity"):
                                    self.threshold_severity = value
                                    self.threshold_severity.value_namespace = name_space
                                    self.threshold_severity.value_namespace_prefix = name_space_prefix
                                if(value_path == "threshold-value"):
                                    self.threshold_value = value
                                    self.threshold_value.value_namespace = name_space
                                    self.threshold_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.thresh_bag is not None and self.thresh_bag.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.thresh_bag is not None and self.thresh_bag.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "minor-lo" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "thresh-bag"):
                                if (self.thresh_bag is None):
                                    self.thresh_bag = Inventory.Racks.Rack.Attributes.Threshold.MinorLo.ThreshBag()
                                    self.thresh_bag.parent = self
                                    self._children_name_map["thresh_bag"] = "thresh-bag"
                                return self.thresh_bag

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "thresh-bag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.critical_hi is not None and self.critical_hi.has_data()) or
                            (self.critical_lo is not None and self.critical_lo.has_data()) or
                            (self.major_hi is not None and self.major_hi.has_data()) or
                            (self.major_lo is not None and self.major_lo.has_data()) or
                            (self.minor_hi is not None and self.minor_hi.has_data()) or
                            (self.minor_lo is not None and self.minor_lo.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.critical_hi is not None and self.critical_hi.has_operation()) or
                            (self.critical_lo is not None and self.critical_lo.has_operation()) or
                            (self.major_hi is not None and self.major_hi.has_operation()) or
                            (self.major_lo is not None and self.major_lo.has_operation()) or
                            (self.minor_hi is not None and self.minor_hi.has_operation()) or
                            (self.minor_lo is not None and self.minor_lo.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "threshold" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "critical-hi"):
                            if (self.critical_hi is None):
                                self.critical_hi = Inventory.Racks.Rack.Attributes.Threshold.CriticalHi()
                                self.critical_hi.parent = self
                                self._children_name_map["critical_hi"] = "critical-hi"
                            return self.critical_hi

                        if (child_yang_name == "critical-lo"):
                            if (self.critical_lo is None):
                                self.critical_lo = Inventory.Racks.Rack.Attributes.Threshold.CriticalLo()
                                self.critical_lo.parent = self
                                self._children_name_map["critical_lo"] = "critical-lo"
                            return self.critical_lo

                        if (child_yang_name == "major-hi"):
                            if (self.major_hi is None):
                                self.major_hi = Inventory.Racks.Rack.Attributes.Threshold.MajorHi()
                                self.major_hi.parent = self
                                self._children_name_map["major_hi"] = "major-hi"
                            return self.major_hi

                        if (child_yang_name == "major-lo"):
                            if (self.major_lo is None):
                                self.major_lo = Inventory.Racks.Rack.Attributes.Threshold.MajorLo()
                                self.major_lo.parent = self
                                self._children_name_map["major_lo"] = "major-lo"
                            return self.major_lo

                        if (child_yang_name == "minor-hi"):
                            if (self.minor_hi is None):
                                self.minor_hi = Inventory.Racks.Rack.Attributes.Threshold.MinorHi()
                                self.minor_hi.parent = self
                                self._children_name_map["minor_hi"] = "minor-hi"
                            return self.minor_hi

                        if (child_yang_name == "minor-lo"):
                            if (self.minor_lo is None):
                                self.minor_lo = Inventory.Racks.Rack.Attributes.Threshold.MinorLo()
                                self.minor_lo.parent = self
                                self._children_name_map["minor_lo"] = "minor-lo"
                            return self.minor_lo

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "critical-hi" or name == "critical-lo" or name == "major-hi" or name == "major-lo" or name == "minor-hi" or name == "minor-lo"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class FruInfo(Entity):
                    """
                    Inventory EDM FRU info
                    
                    .. attribute:: card_administrative_state
                    
                    	card admin state\: shutdown or not
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: card_monitor_state
                    
                    	card is monitored by a manager or left unmonitored
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: card_operational_state
                    
                    	card operation state
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: card_reset_reason
                    
                    	card reset reason enum
                    	**type**\:   :py:class:`CardResetReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.CardResetReason>`
                    
                    .. attribute:: card_up_time
                    
                    	card up time
                    	**type**\:   :py:class:`CardUpTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime>`
                    
                    .. attribute:: last_operational_state_change
                    
                    	last card oper change state
                    	**type**\:   :py:class:`LastOperationalStateChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange>`
                    
                    .. attribute:: power_administrative_state
                    
                    	power admin state\: up or down
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: power_current_measurement
                    
                    	power current\: not implemented
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: power_operational_state
                    
                    	Power operation state
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.FruInfo, self).__init__()

                        self.yang_name = "fru-info"
                        self.yang_parent_name = "attributes"

                        self.card_administrative_state = YLeaf(YType.int32, "card-administrative-state")

                        self.card_monitor_state = YLeaf(YType.int32, "card-monitor-state")

                        self.card_operational_state = YLeaf(YType.int32, "card-operational-state")

                        self.card_reset_reason = YLeaf(YType.enumeration, "card-reset-reason")

                        self.power_administrative_state = YLeaf(YType.int32, "power-administrative-state")

                        self.power_current_measurement = YLeaf(YType.int32, "power-current-measurement")

                        self.power_operational_state = YLeaf(YType.int32, "power-operational-state")

                        self.card_up_time = Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime()
                        self.card_up_time.parent = self
                        self._children_name_map["card_up_time"] = "card-up-time"
                        self._children_yang_names.add("card-up-time")

                        self.last_operational_state_change = Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange()
                        self.last_operational_state_change.parent = self
                        self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                        self._children_yang_names.add("last-operational-state-change")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("card_administrative_state",
                                        "card_monitor_state",
                                        "card_operational_state",
                                        "card_reset_reason",
                                        "power_administrative_state",
                                        "power_current_measurement",
                                        "power_operational_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.FruInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.FruInfo, self).__setattr__(name, value)


                    class LastOperationalStateChange(Entity):
                        """
                        last card oper change state
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange, self).__init__()

                            self.yang_name = "last-operational-state-change"
                            self.yang_parent_name = "fru-info"

                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("time_in_nano_seconds",
                                            "time_in_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.time_in_nano_seconds.is_set or
                                self.time_in_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                self.time_in_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-operational-state-change" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "time-in-nano-seconds"):
                                self.time_in_nano_seconds = value
                                self.time_in_nano_seconds.value_namespace = name_space
                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-seconds"):
                                self.time_in_seconds = value
                                self.time_in_seconds.value_namespace = name_space
                                self.time_in_seconds.value_namespace_prefix = name_space_prefix


                    class CardUpTime(Entity):
                        """
                        card up time
                        
                        .. attribute:: time_in_nano_seconds
                        
                        	Time Value in Nano\-seconds
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: time_in_seconds
                        
                        	Time Value in Seconds
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime, self).__init__()

                            self.yang_name = "card-up-time"
                            self.yang_parent_name = "fru-info"

                            self.time_in_nano_seconds = YLeaf(YType.int32, "time-in-nano-seconds")

                            self.time_in_seconds = YLeaf(YType.int32, "time-in-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("time_in_nano_seconds",
                                            "time_in_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.time_in_nano_seconds.is_set or
                                self.time_in_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.time_in_nano_seconds.yfilter != YFilter.not_set or
                                self.time_in_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "card-up-time" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.time_in_nano_seconds.is_set or self.time_in_nano_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_nano_seconds.get_name_leafdata())
                            if (self.time_in_seconds.is_set or self.time_in_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "time-in-nano-seconds" or name == "time-in-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "time-in-nano-seconds"):
                                self.time_in_nano_seconds = value
                                self.time_in_nano_seconds.value_namespace = name_space
                                self.time_in_nano_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-seconds"):
                                self.time_in_seconds = value
                                self.time_in_seconds.value_namespace = name_space
                                self.time_in_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.card_administrative_state.is_set or
                            self.card_monitor_state.is_set or
                            self.card_operational_state.is_set or
                            self.card_reset_reason.is_set or
                            self.power_administrative_state.is_set or
                            self.power_current_measurement.is_set or
                            self.power_operational_state.is_set or
                            (self.card_up_time is not None and self.card_up_time.has_data()) or
                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.card_administrative_state.yfilter != YFilter.not_set or
                            self.card_monitor_state.yfilter != YFilter.not_set or
                            self.card_operational_state.yfilter != YFilter.not_set or
                            self.card_reset_reason.yfilter != YFilter.not_set or
                            self.power_administrative_state.yfilter != YFilter.not_set or
                            self.power_current_measurement.yfilter != YFilter.not_set or
                            self.power_operational_state.yfilter != YFilter.not_set or
                            (self.card_up_time is not None and self.card_up_time.has_operation()) or
                            (self.last_operational_state_change is not None and self.last_operational_state_change.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fru-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.card_administrative_state.is_set or self.card_administrative_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.card_administrative_state.get_name_leafdata())
                        if (self.card_monitor_state.is_set or self.card_monitor_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.card_monitor_state.get_name_leafdata())
                        if (self.card_operational_state.is_set or self.card_operational_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.card_operational_state.get_name_leafdata())
                        if (self.card_reset_reason.is_set or self.card_reset_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.card_reset_reason.get_name_leafdata())
                        if (self.power_administrative_state.is_set or self.power_administrative_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_administrative_state.get_name_leafdata())
                        if (self.power_current_measurement.is_set or self.power_current_measurement.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_current_measurement.get_name_leafdata())
                        if (self.power_operational_state.is_set or self.power_operational_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.power_operational_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "card-up-time"):
                            if (self.card_up_time is None):
                                self.card_up_time = Inventory.Racks.Rack.Attributes.FruInfo.CardUpTime()
                                self.card_up_time.parent = self
                                self._children_name_map["card_up_time"] = "card-up-time"
                            return self.card_up_time

                        if (child_yang_name == "last-operational-state-change"):
                            if (self.last_operational_state_change is None):
                                self.last_operational_state_change = Inventory.Racks.Rack.Attributes.FruInfo.LastOperationalStateChange()
                                self.last_operational_state_change.parent = self
                                self._children_name_map["last_operational_state_change"] = "last-operational-state-change"
                            return self.last_operational_state_change

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "card-up-time" or name == "last-operational-state-change" or name == "card-administrative-state" or name == "card-monitor-state" or name == "card-operational-state" or name == "card-reset-reason" or name == "power-administrative-state" or name == "power-current-measurement" or name == "power-operational-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "card-administrative-state"):
                            self.card_administrative_state = value
                            self.card_administrative_state.value_namespace = name_space
                            self.card_administrative_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "card-monitor-state"):
                            self.card_monitor_state = value
                            self.card_monitor_state.value_namespace = name_space
                            self.card_monitor_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "card-operational-state"):
                            self.card_operational_state = value
                            self.card_operational_state.value_namespace = name_space
                            self.card_operational_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "card-reset-reason"):
                            self.card_reset_reason = value
                            self.card_reset_reason.value_namespace = name_space
                            self.card_reset_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-administrative-state"):
                            self.power_administrative_state = value
                            self.power_administrative_state.value_namespace = name_space
                            self.power_administrative_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-current-measurement"):
                            self.power_current_measurement = value
                            self.power_current_measurement.value_namespace = name_space
                            self.power_current_measurement.value_namespace_prefix = name_space_prefix
                        if(value_path == "power-operational-state"):
                            self.power_operational_state = value
                            self.power_operational_state.value_namespace = name_space
                            self.power_operational_state.value_namespace_prefix = name_space_prefix


                class InvBasicBag(Entity):
                    """
                    Inventory Basic Bag
                    
                    .. attribute:: alias
                    
                    	useful for storing an entity alias 
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: asset_id_str
                    
                    	asset Identification string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: asset_identification
                    
                    	asset Identification
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: ceport
                    
                    	1 if ce port found, 0 if not
                    	**type**\:  bool
                    
                    .. attribute:: chip_hardware_revision
                    
                    	chip module hw revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: composite_class_code
                    
                    	Major&minor class of the entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: description
                    
                    	describes in user\-readable terms       what the entity in question does
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: environmental_monitor_path
                    
                    	sysdb name of sensor in the envmon EDM
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: firmware_revision
                    
                    	firmware revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: group_flag
                    
                    	indicates if this entity is group       or not
                    	**type**\:  bool
                    
                    .. attribute:: hardware_revision
                    
                    	hw revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: is_field_replaceable_unit
                    
                    	1 if Field Replaceable Unit 0, if not
                    	**type**\:  bool
                    
                    .. attribute:: manufacturer_asset_tags
                    
                    	Manufacture Asset Tags
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: manufacturer_name
                    
                    	manufacturer's name
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: memory_size
                    
                    	Size of memory associated with       the entity where applicable
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: model_name
                    
                    	model name
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: name
                    
                    	name string for the entity
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: new_deviation_number
                    
                    	integer value for New Deviation Number 0x88
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: physical_layer_interface_module_type
                    
                    	integer value for plim type if     applicable to this entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: redundancystate
                    
                    	integer value for Redundancy State if     applicable to this entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: serial_number
                    
                    	serial number
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: software_revision
                    
                    	software revision string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: unique_id
                    
                    	Unique id for an entity
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: unrecognized_fru
                    
                    	1 if UnrecognizedFRU and 0 for recognizedFRU
                    	**type**\:  bool
                    
                    .. attribute:: vendor_type
                    
                    	maps to the vendor OID string
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: xr_scoped
                    
                    	1 if xr scoped, 0 if not
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.InvBasicBag, self).__init__()

                        self.yang_name = "inv-basic-bag"
                        self.yang_parent_name = "attributes"

                        self.alias = YLeaf(YType.str, "alias")

                        self.asset_id_str = YLeaf(YType.str, "asset-id-str")

                        self.asset_identification = YLeaf(YType.int32, "asset-identification")

                        self.ceport = YLeaf(YType.boolean, "ceport")

                        self.chip_hardware_revision = YLeaf(YType.str, "chip-hardware-revision")

                        self.composite_class_code = YLeaf(YType.int32, "composite-class-code")

                        self.description = YLeaf(YType.str, "description")

                        self.environmental_monitor_path = YLeaf(YType.str, "environmental-monitor-path")

                        self.firmware_revision = YLeaf(YType.str, "firmware-revision")

                        self.group_flag = YLeaf(YType.boolean, "group-flag")

                        self.hardware_revision = YLeaf(YType.str, "hardware-revision")

                        self.is_field_replaceable_unit = YLeaf(YType.boolean, "is-field-replaceable-unit")

                        self.manufacturer_asset_tags = YLeaf(YType.int32, "manufacturer-asset-tags")

                        self.manufacturer_name = YLeaf(YType.str, "manufacturer-name")

                        self.memory_size = YLeaf(YType.int32, "memory-size")

                        self.model_name = YLeaf(YType.str, "model-name")

                        self.name = YLeaf(YType.str, "name")

                        self.new_deviation_number = YLeaf(YType.int32, "new-deviation-number")

                        self.physical_layer_interface_module_type = YLeaf(YType.int32, "physical-layer-interface-module-type")

                        self.redundancystate = YLeaf(YType.int32, "redundancystate")

                        self.serial_number = YLeaf(YType.str, "serial-number")

                        self.software_revision = YLeaf(YType.str, "software-revision")

                        self.unique_id = YLeaf(YType.int32, "unique-id")

                        self.unrecognized_fru = YLeaf(YType.boolean, "unrecognized-fru")

                        self.vendor_type = YLeaf(YType.str, "vendor-type")

                        self.xr_scoped = YLeaf(YType.boolean, "xr-scoped")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("alias",
                                        "asset_id_str",
                                        "asset_identification",
                                        "ceport",
                                        "chip_hardware_revision",
                                        "composite_class_code",
                                        "description",
                                        "environmental_monitor_path",
                                        "firmware_revision",
                                        "group_flag",
                                        "hardware_revision",
                                        "is_field_replaceable_unit",
                                        "manufacturer_asset_tags",
                                        "manufacturer_name",
                                        "memory_size",
                                        "model_name",
                                        "name",
                                        "new_deviation_number",
                                        "physical_layer_interface_module_type",
                                        "redundancystate",
                                        "serial_number",
                                        "software_revision",
                                        "unique_id",
                                        "unrecognized_fru",
                                        "vendor_type",
                                        "xr_scoped") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.InvBasicBag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.InvBasicBag, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.alias.is_set or
                            self.asset_id_str.is_set or
                            self.asset_identification.is_set or
                            self.ceport.is_set or
                            self.chip_hardware_revision.is_set or
                            self.composite_class_code.is_set or
                            self.description.is_set or
                            self.environmental_monitor_path.is_set or
                            self.firmware_revision.is_set or
                            self.group_flag.is_set or
                            self.hardware_revision.is_set or
                            self.is_field_replaceable_unit.is_set or
                            self.manufacturer_asset_tags.is_set or
                            self.manufacturer_name.is_set or
                            self.memory_size.is_set or
                            self.model_name.is_set or
                            self.name.is_set or
                            self.new_deviation_number.is_set or
                            self.physical_layer_interface_module_type.is_set or
                            self.redundancystate.is_set or
                            self.serial_number.is_set or
                            self.software_revision.is_set or
                            self.unique_id.is_set or
                            self.unrecognized_fru.is_set or
                            self.vendor_type.is_set or
                            self.xr_scoped.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.alias.yfilter != YFilter.not_set or
                            self.asset_id_str.yfilter != YFilter.not_set or
                            self.asset_identification.yfilter != YFilter.not_set or
                            self.ceport.yfilter != YFilter.not_set or
                            self.chip_hardware_revision.yfilter != YFilter.not_set or
                            self.composite_class_code.yfilter != YFilter.not_set or
                            self.description.yfilter != YFilter.not_set or
                            self.environmental_monitor_path.yfilter != YFilter.not_set or
                            self.firmware_revision.yfilter != YFilter.not_set or
                            self.group_flag.yfilter != YFilter.not_set or
                            self.hardware_revision.yfilter != YFilter.not_set or
                            self.is_field_replaceable_unit.yfilter != YFilter.not_set or
                            self.manufacturer_asset_tags.yfilter != YFilter.not_set or
                            self.manufacturer_name.yfilter != YFilter.not_set or
                            self.memory_size.yfilter != YFilter.not_set or
                            self.model_name.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set or
                            self.new_deviation_number.yfilter != YFilter.not_set or
                            self.physical_layer_interface_module_type.yfilter != YFilter.not_set or
                            self.redundancystate.yfilter != YFilter.not_set or
                            self.serial_number.yfilter != YFilter.not_set or
                            self.software_revision.yfilter != YFilter.not_set or
                            self.unique_id.yfilter != YFilter.not_set or
                            self.unrecognized_fru.yfilter != YFilter.not_set or
                            self.vendor_type.yfilter != YFilter.not_set or
                            self.xr_scoped.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "inv-basic-bag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.alias.is_set or self.alias.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.alias.get_name_leafdata())
                        if (self.asset_id_str.is_set or self.asset_id_str.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.asset_id_str.get_name_leafdata())
                        if (self.asset_identification.is_set or self.asset_identification.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.asset_identification.get_name_leafdata())
                        if (self.ceport.is_set or self.ceport.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ceport.get_name_leafdata())
                        if (self.chip_hardware_revision.is_set or self.chip_hardware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.chip_hardware_revision.get_name_leafdata())
                        if (self.composite_class_code.is_set or self.composite_class_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.composite_class_code.get_name_leafdata())
                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.description.get_name_leafdata())
                        if (self.environmental_monitor_path.is_set or self.environmental_monitor_path.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.environmental_monitor_path.get_name_leafdata())
                        if (self.firmware_revision.is_set or self.firmware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.firmware_revision.get_name_leafdata())
                        if (self.group_flag.is_set or self.group_flag.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.group_flag.get_name_leafdata())
                        if (self.hardware_revision.is_set or self.hardware_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hardware_revision.get_name_leafdata())
                        if (self.is_field_replaceable_unit.is_set or self.is_field_replaceable_unit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_field_replaceable_unit.get_name_leafdata())
                        if (self.manufacturer_asset_tags.is_set or self.manufacturer_asset_tags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_asset_tags.get_name_leafdata())
                        if (self.manufacturer_name.is_set or self.manufacturer_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.manufacturer_name.get_name_leafdata())
                        if (self.memory_size.is_set or self.memory_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.memory_size.get_name_leafdata())
                        if (self.model_name.is_set or self.model_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.model_name.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())
                        if (self.new_deviation_number.is_set or self.new_deviation_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.new_deviation_number.get_name_leafdata())
                        if (self.physical_layer_interface_module_type.is_set or self.physical_layer_interface_module_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_layer_interface_module_type.get_name_leafdata())
                        if (self.redundancystate.is_set or self.redundancystate.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.redundancystate.get_name_leafdata())
                        if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.serial_number.get_name_leafdata())
                        if (self.software_revision.is_set or self.software_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.software_revision.get_name_leafdata())
                        if (self.unique_id.is_set or self.unique_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unique_id.get_name_leafdata())
                        if (self.unrecognized_fru.is_set or self.unrecognized_fru.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unrecognized_fru.get_name_leafdata())
                        if (self.vendor_type.is_set or self.vendor_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vendor_type.get_name_leafdata())
                        if (self.xr_scoped.is_set or self.xr_scoped.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.xr_scoped.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "alias" or name == "asset-id-str" or name == "asset-identification" or name == "ceport" or name == "chip-hardware-revision" or name == "composite-class-code" or name == "description" or name == "environmental-monitor-path" or name == "firmware-revision" or name == "group-flag" or name == "hardware-revision" or name == "is-field-replaceable-unit" or name == "manufacturer-asset-tags" or name == "manufacturer-name" or name == "memory-size" or name == "model-name" or name == "name" or name == "new-deviation-number" or name == "physical-layer-interface-module-type" or name == "redundancystate" or name == "serial-number" or name == "software-revision" or name == "unique-id" or name == "unrecognized-fru" or name == "vendor-type" or name == "xr-scoped"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "alias"):
                            self.alias = value
                            self.alias.value_namespace = name_space
                            self.alias.value_namespace_prefix = name_space_prefix
                        if(value_path == "asset-id-str"):
                            self.asset_id_str = value
                            self.asset_id_str.value_namespace = name_space
                            self.asset_id_str.value_namespace_prefix = name_space_prefix
                        if(value_path == "asset-identification"):
                            self.asset_identification = value
                            self.asset_identification.value_namespace = name_space
                            self.asset_identification.value_namespace_prefix = name_space_prefix
                        if(value_path == "ceport"):
                            self.ceport = value
                            self.ceport.value_namespace = name_space
                            self.ceport.value_namespace_prefix = name_space_prefix
                        if(value_path == "chip-hardware-revision"):
                            self.chip_hardware_revision = value
                            self.chip_hardware_revision.value_namespace = name_space
                            self.chip_hardware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "composite-class-code"):
                            self.composite_class_code = value
                            self.composite_class_code.value_namespace = name_space
                            self.composite_class_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "description"):
                            self.description = value
                            self.description.value_namespace = name_space
                            self.description.value_namespace_prefix = name_space_prefix
                        if(value_path == "environmental-monitor-path"):
                            self.environmental_monitor_path = value
                            self.environmental_monitor_path.value_namespace = name_space
                            self.environmental_monitor_path.value_namespace_prefix = name_space_prefix
                        if(value_path == "firmware-revision"):
                            self.firmware_revision = value
                            self.firmware_revision.value_namespace = name_space
                            self.firmware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "group-flag"):
                            self.group_flag = value
                            self.group_flag.value_namespace = name_space
                            self.group_flag.value_namespace_prefix = name_space_prefix
                        if(value_path == "hardware-revision"):
                            self.hardware_revision = value
                            self.hardware_revision.value_namespace = name_space
                            self.hardware_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-field-replaceable-unit"):
                            self.is_field_replaceable_unit = value
                            self.is_field_replaceable_unit.value_namespace = name_space
                            self.is_field_replaceable_unit.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-asset-tags"):
                            self.manufacturer_asset_tags = value
                            self.manufacturer_asset_tags.value_namespace = name_space
                            self.manufacturer_asset_tags.value_namespace_prefix = name_space_prefix
                        if(value_path == "manufacturer-name"):
                            self.manufacturer_name = value
                            self.manufacturer_name.value_namespace = name_space
                            self.manufacturer_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "memory-size"):
                            self.memory_size = value
                            self.memory_size.value_namespace = name_space
                            self.memory_size.value_namespace_prefix = name_space_prefix
                        if(value_path == "model-name"):
                            self.model_name = value
                            self.model_name.value_namespace = name_space
                            self.model_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix
                        if(value_path == "new-deviation-number"):
                            self.new_deviation_number = value
                            self.new_deviation_number.value_namespace = name_space
                            self.new_deviation_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-layer-interface-module-type"):
                            self.physical_layer_interface_module_type = value
                            self.physical_layer_interface_module_type.value_namespace = name_space
                            self.physical_layer_interface_module_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "redundancystate"):
                            self.redundancystate = value
                            self.redundancystate.value_namespace = name_space
                            self.redundancystate.value_namespace_prefix = name_space_prefix
                        if(value_path == "serial-number"):
                            self.serial_number = value
                            self.serial_number.value_namespace = name_space
                            self.serial_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "software-revision"):
                            self.software_revision = value
                            self.software_revision.value_namespace = name_space
                            self.software_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "unique-id"):
                            self.unique_id = value
                            self.unique_id.value_namespace = name_space
                            self.unique_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "unrecognized-fru"):
                            self.unrecognized_fru = value
                            self.unrecognized_fru.value_namespace = name_space
                            self.unrecognized_fru.value_namespace_prefix = name_space_prefix
                        if(value_path == "vendor-type"):
                            self.vendor_type = value
                            self.vendor_type.value_namespace = name_space
                            self.vendor_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "xr-scoped"):
                            self.xr_scoped = value
                            self.xr_scoped.value_namespace = name_space
                            self.xr_scoped.value_namespace_prefix = name_space_prefix


                class InvEepromInfo(Entity):
                    """
                    Inventory EDM EEPROM Information Bag
                    
                    .. attribute:: description
                    
                    	A textual description of physical entity
                    	**type**\:  str
                    
                    	**length:** 0..255
                    
                    .. attribute:: eeprom
                    
                    	EEPROM data not from hex data
                    	**type**\:   :py:class:`Eeprom <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom>`
                    
                    .. attribute:: has_eeprom
                    
                    	use eeprom instead of opaque data
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: inv_card_type
                    
                    	Inventory card type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: opaque_data
                    
                    	EEPROM hex data
                    	**type**\:  str
                    
                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                    
                    .. attribute:: opaque_data_size
                    
                    	size of the EEPROM hex data
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'invmgr-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Inventory.Racks.Rack.Attributes.InvEepromInfo, self).__init__()

                        self.yang_name = "inv-eeprom-info"
                        self.yang_parent_name = "attributes"

                        self.description = YLeaf(YType.str, "description")

                        self.has_eeprom = YLeaf(YType.uint32, "has-eeprom")

                        self.inv_card_type = YLeaf(YType.uint8, "inv-card-type")

                        self.opaque_data = YLeaf(YType.str, "opaque-data")

                        self.opaque_data_size = YLeaf(YType.uint32, "opaque-data-size")

                        self.eeprom = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom()
                        self.eeprom.parent = self
                        self._children_name_map["eeprom"] = "eeprom"
                        self._children_yang_names.add("eeprom")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("description",
                                        "has_eeprom",
                                        "inv_card_type",
                                        "opaque_data",
                                        "opaque_data_size") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Inventory.Racks.Rack.Attributes.InvEepromInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Inventory.Racks.Rack.Attributes.InvEepromInfo, self).__setattr__(name, value)


                    class Eeprom(Entity):
                        """
                        EEPROM data not from hex data
                        
                        .. attribute:: asset_alias
                        
                        	Asset Alias
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: asset_id
                        
                        	Asset ID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: base_mac_address1
                        
                        	Base Mac Address #1
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: base_mac_address2
                        
                        	Base Mac Address #2
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: base_mac_address3
                        
                        	Base Mac Address #3
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: base_mac_address4
                        
                        	Base Mac Address #4
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: block_checksum
                        
                        	Block Checksum
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: block_count
                        
                        	Block Count
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: block_length
                        
                        	Block Length
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: block_signature
                        
                        	Block Signature
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: block_version
                        
                        	Block Version
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: chassis_sid
                        
                        	Chassis serial number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: clei
                        
                        	Common Language Equipment Identifier (CLEI) code
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: controller_family
                        
                        	Controller family
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: controller_type
                        
                        	Controller type
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: description
                        
                        	A textual description of physical entity
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num1
                        
                        	Deviation Number # 1
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num2
                        
                        	Deviation Number # 2
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num3
                        
                        	Deviation Number # 3
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num4
                        
                        	Deviation Number # 4
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num5
                        
                        	Deviation Number # 5
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num6
                        
                        	Deviation Number # 6
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: dev_num7
                        
                        	Deviation Number # 7
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: eci
                        
                        	Equipment Catalog Item (ECI) number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: eeprom_size
                        
                        	EEPROM Size
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: engineer_use
                        
                        	Engineer Use
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: fru_major_type
                        
                        	FRU Major Type
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: fru_minor_type
                        
                        	FRU Minor Type
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: hw_version
                        
                        	Hardware Version
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: hwid
                        
                        	Hardware Revision
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: idprom_format_rev
                        
                        	IDPROM Format Revision
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mac_add_blk_size1
                        
                        	Mac Address Block Size #1
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mac_add_blk_size2
                        
                        	Mac Address Block Size #2
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mac_add_blk_size3
                        
                        	Mac Address Block Size #3
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mac_add_blk_size4
                        
                        	Mac Address Block Size #4
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: manu_test_data
                        
                        	Manufacturing Test Data
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mfg_bits
                        
                        	MFG Bits
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: mfg_deviation
                        
                        	MFG Deviation
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: oem_string
                        
                        	OEM String
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: part_number
                        
                        	Part Number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: part_revision
                        
                        	Part Revision
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: pca_num
                        
                        	PCA number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: pcavid
                        
                        	PCA revision ID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: pcb_serial_num
                        
                        	PCB Serial Number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: pid
                        
                        	Product ID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: power_consumption
                        
                        	Power Consumption
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: power_supply_type
                        
                        	Power Supply Type
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: product_id
                        
                        	Product ID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: rma
                        
                        	RMA Data
                        	**type**\:   :py:class:`Rma <ydk.models.cisco_ios_xr.Cisco_IOS_XR_invmgr_oper.Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma>`
                        
                        .. attribute:: rma_code
                        
                        	RMA Code
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: serial_number
                        
                        	Serial Number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: snmpoid
                        
                        	SNMP OID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: top_assem_part_num
                        
                        	Top assembly part number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: top_assem_vid
                        
                        	Top assembly revision number
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: udi_description
                        
                        	UDI description
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: udi_name
                        
                        	UDI name
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        .. attribute:: vid
                        
                        	Version ID
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        

                        """

                        _prefix = 'invmgr-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom, self).__init__()

                            self.yang_name = "eeprom"
                            self.yang_parent_name = "inv-eeprom-info"

                            self.asset_alias = YLeaf(YType.str, "asset-alias")

                            self.asset_id = YLeaf(YType.str, "asset-id")

                            self.base_mac_address1 = YLeaf(YType.str, "base-mac-address1")

                            self.base_mac_address2 = YLeaf(YType.str, "base-mac-address2")

                            self.base_mac_address3 = YLeaf(YType.str, "base-mac-address3")

                            self.base_mac_address4 = YLeaf(YType.str, "base-mac-address4")

                            self.block_checksum = YLeaf(YType.str, "block-checksum")

                            self.block_count = YLeaf(YType.str, "block-count")

                            self.block_length = YLeaf(YType.str, "block-length")

                            self.block_signature = YLeaf(YType.str, "block-signature")

                            self.block_version = YLeaf(YType.str, "block-version")

                            self.chassis_sid = YLeaf(YType.str, "chassis-sid")

                            self.clei = YLeaf(YType.str, "clei")

                            self.controller_family = YLeaf(YType.str, "controller-family")

                            self.controller_type = YLeaf(YType.str, "controller-type")

                            self.description = YLeaf(YType.str, "description")

                            self.dev_num1 = YLeaf(YType.str, "dev-num1")

                            self.dev_num2 = YLeaf(YType.str, "dev-num2")

                            self.dev_num3 = YLeaf(YType.str, "dev-num3")

                            self.dev_num4 = YLeaf(YType.str, "dev-num4")

                            self.dev_num5 = YLeaf(YType.str, "dev-num5")

                            self.dev_num6 = YLeaf(YType.str, "dev-num6")

                            self.dev_num7 = YLeaf(YType.str, "dev-num7")

                            self.eci = YLeaf(YType.str, "eci")

                            self.eeprom_size = YLeaf(YType.str, "eeprom-size")

                            self.engineer_use = YLeaf(YType.str, "engineer-use")

                            self.fru_major_type = YLeaf(YType.str, "fru-major-type")

                            self.fru_minor_type = YLeaf(YType.str, "fru-minor-type")

                            self.hw_version = YLeaf(YType.str, "hw-version")

                            self.hwid = YLeaf(YType.str, "hwid")

                            self.idprom_format_rev = YLeaf(YType.str, "idprom-format-rev")

                            self.mac_add_blk_size1 = YLeaf(YType.str, "mac-add-blk-size1")

                            self.mac_add_blk_size2 = YLeaf(YType.str, "mac-add-blk-size2")

                            self.mac_add_blk_size3 = YLeaf(YType.str, "mac-add-blk-size3")

                            self.mac_add_blk_size4 = YLeaf(YType.str, "mac-add-blk-size4")

                            self.manu_test_data = YLeaf(YType.str, "manu-test-data")

                            self.mfg_bits = YLeaf(YType.str, "mfg-bits")

                            self.mfg_deviation = YLeaf(YType.str, "mfg-deviation")

                            self.oem_string = YLeaf(YType.str, "oem-string")

                            self.part_number = YLeaf(YType.str, "part-number")

                            self.part_revision = YLeaf(YType.str, "part-revision")

                            self.pca_num = YLeaf(YType.str, "pca-num")

                            self.pcavid = YLeaf(YType.str, "pcavid")

                            self.pcb_serial_num = YLeaf(YType.str, "pcb-serial-num")

                            self.pid = YLeaf(YType.str, "pid")

                            self.power_consumption = YLeaf(YType.str, "power-consumption")

                            self.power_supply_type = YLeaf(YType.str, "power-supply-type")

                            self.product_id = YLeaf(YType.str, "product-id")

                            self.rma_code = YLeaf(YType.str, "rma-code")

                            self.serial_number = YLeaf(YType.str, "serial-number")

                            self.snmpoid = YLeaf(YType.str, "snmpoid")

                            self.top_assem_part_num = YLeaf(YType.str, "top-assem-part-num")

                            self.top_assem_vid = YLeaf(YType.str, "top-assem-vid")

                            self.udi_description = YLeaf(YType.str, "udi-description")

                            self.udi_name = YLeaf(YType.str, "udi-name")

                            self.vid = YLeaf(YType.str, "vid")

                            self.rma = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma()
                            self.rma.parent = self
                            self._children_name_map["rma"] = "rma"
                            self._children_yang_names.add("rma")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("asset_alias",
                                            "asset_id",
                                            "base_mac_address1",
                                            "base_mac_address2",
                                            "base_mac_address3",
                                            "base_mac_address4",
                                            "block_checksum",
                                            "block_count",
                                            "block_length",
                                            "block_signature",
                                            "block_version",
                                            "chassis_sid",
                                            "clei",
                                            "controller_family",
                                            "controller_type",
                                            "description",
                                            "dev_num1",
                                            "dev_num2",
                                            "dev_num3",
                                            "dev_num4",
                                            "dev_num5",
                                            "dev_num6",
                                            "dev_num7",
                                            "eci",
                                            "eeprom_size",
                                            "engineer_use",
                                            "fru_major_type",
                                            "fru_minor_type",
                                            "hw_version",
                                            "hwid",
                                            "idprom_format_rev",
                                            "mac_add_blk_size1",
                                            "mac_add_blk_size2",
                                            "mac_add_blk_size3",
                                            "mac_add_blk_size4",
                                            "manu_test_data",
                                            "mfg_bits",
                                            "mfg_deviation",
                                            "oem_string",
                                            "part_number",
                                            "part_revision",
                                            "pca_num",
                                            "pcavid",
                                            "pcb_serial_num",
                                            "pid",
                                            "power_consumption",
                                            "power_supply_type",
                                            "product_id",
                                            "rma_code",
                                            "serial_number",
                                            "snmpoid",
                                            "top_assem_part_num",
                                            "top_assem_vid",
                                            "udi_description",
                                            "udi_name",
                                            "vid") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom, self).__setattr__(name, value)


                        class Rma(Entity):
                            """
                            RMA Data
                            
                            .. attribute:: rma_history
                            
                            	RMA history
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: rma_number
                            
                            	RMA tracking number format is N\-N\-N
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            .. attribute:: test_history
                            
                            	Test history
                            	**type**\:  str
                            
                            	**length:** 0..255
                            
                            

                            """

                            _prefix = 'invmgr-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma, self).__init__()

                                self.yang_name = "rma"
                                self.yang_parent_name = "eeprom"

                                self.rma_history = YLeaf(YType.str, "rma-history")

                                self.rma_number = YLeaf(YType.str, "rma-number")

                                self.test_history = YLeaf(YType.str, "test-history")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rma_history",
                                                "rma_number",
                                                "test_history") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.rma_history.is_set or
                                    self.rma_number.is_set or
                                    self.test_history.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rma_history.yfilter != YFilter.not_set or
                                    self.rma_number.yfilter != YFilter.not_set or
                                    self.test_history.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rma" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rma_history.is_set or self.rma_history.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rma_history.get_name_leafdata())
                                if (self.rma_number.is_set or self.rma_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rma_number.get_name_leafdata())
                                if (self.test_history.is_set or self.test_history.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.test_history.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "rma-history" or name == "rma-number" or name == "test-history"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rma-history"):
                                    self.rma_history = value
                                    self.rma_history.value_namespace = name_space
                                    self.rma_history.value_namespace_prefix = name_space_prefix
                                if(value_path == "rma-number"):
                                    self.rma_number = value
                                    self.rma_number.value_namespace = name_space
                                    self.rma_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "test-history"):
                                    self.test_history = value
                                    self.test_history.value_namespace = name_space
                                    self.test_history.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.asset_alias.is_set or
                                self.asset_id.is_set or
                                self.base_mac_address1.is_set or
                                self.base_mac_address2.is_set or
                                self.base_mac_address3.is_set or
                                self.base_mac_address4.is_set or
                                self.block_checksum.is_set or
                                self.block_count.is_set or
                                self.block_length.is_set or
                                self.block_signature.is_set or
                                self.block_version.is_set or
                                self.chassis_sid.is_set or
                                self.clei.is_set or
                                self.controller_family.is_set or
                                self.controller_type.is_set or
                                self.description.is_set or
                                self.dev_num1.is_set or
                                self.dev_num2.is_set or
                                self.dev_num3.is_set or
                                self.dev_num4.is_set or
                                self.dev_num5.is_set or
                                self.dev_num6.is_set or
                                self.dev_num7.is_set or
                                self.eci.is_set or
                                self.eeprom_size.is_set or
                                self.engineer_use.is_set or
                                self.fru_major_type.is_set or
                                self.fru_minor_type.is_set or
                                self.hw_version.is_set or
                                self.hwid.is_set or
                                self.idprom_format_rev.is_set or
                                self.mac_add_blk_size1.is_set or
                                self.mac_add_blk_size2.is_set or
                                self.mac_add_blk_size3.is_set or
                                self.mac_add_blk_size4.is_set or
                                self.manu_test_data.is_set or
                                self.mfg_bits.is_set or
                                self.mfg_deviation.is_set or
                                self.oem_string.is_set or
                                self.part_number.is_set or
                                self.part_revision.is_set or
                                self.pca_num.is_set or
                                self.pcavid.is_set or
                                self.pcb_serial_num.is_set or
                                self.pid.is_set or
                                self.power_consumption.is_set or
                                self.power_supply_type.is_set or
                                self.product_id.is_set or
                                self.rma_code.is_set or
                                self.serial_number.is_set or
                                self.snmpoid.is_set or
                                self.top_assem_part_num.is_set or
                                self.top_assem_vid.is_set or
                                self.udi_description.is_set or
                                self.udi_name.is_set or
                                self.vid.is_set or
                                (self.rma is not None and self.rma.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.asset_alias.yfilter != YFilter.not_set or
                                self.asset_id.yfilter != YFilter.not_set or
                                self.base_mac_address1.yfilter != YFilter.not_set or
                                self.base_mac_address2.yfilter != YFilter.not_set or
                                self.base_mac_address3.yfilter != YFilter.not_set or
                                self.base_mac_address4.yfilter != YFilter.not_set or
                                self.block_checksum.yfilter != YFilter.not_set or
                                self.block_count.yfilter != YFilter.not_set or
                                self.block_length.yfilter != YFilter.not_set or
                                self.block_signature.yfilter != YFilter.not_set or
                                self.block_version.yfilter != YFilter.not_set or
                                self.chassis_sid.yfilter != YFilter.not_set or
                                self.clei.yfilter != YFilter.not_set or
                                self.controller_family.yfilter != YFilter.not_set or
                                self.controller_type.yfilter != YFilter.not_set or
                                self.description.yfilter != YFilter.not_set or
                                self.dev_num1.yfilter != YFilter.not_set or
                                self.dev_num2.yfilter != YFilter.not_set or
                                self.dev_num3.yfilter != YFilter.not_set or
                                self.dev_num4.yfilter != YFilter.not_set or
                                self.dev_num5.yfilter != YFilter.not_set or
                                self.dev_num6.yfilter != YFilter.not_set or
                                self.dev_num7.yfilter != YFilter.not_set or
                                self.eci.yfilter != YFilter.not_set or
                                self.eeprom_size.yfilter != YFilter.not_set or
                                self.engineer_use.yfilter != YFilter.not_set or
                                self.fru_major_type.yfilter != YFilter.not_set or
                                self.fru_minor_type.yfilter != YFilter.not_set or
                                self.hw_version.yfilter != YFilter.not_set or
                                self.hwid.yfilter != YFilter.not_set or
                                self.idprom_format_rev.yfilter != YFilter.not_set or
                                self.mac_add_blk_size1.yfilter != YFilter.not_set or
                                self.mac_add_blk_size2.yfilter != YFilter.not_set or
                                self.mac_add_blk_size3.yfilter != YFilter.not_set or
                                self.mac_add_blk_size4.yfilter != YFilter.not_set or
                                self.manu_test_data.yfilter != YFilter.not_set or
                                self.mfg_bits.yfilter != YFilter.not_set or
                                self.mfg_deviation.yfilter != YFilter.not_set or
                                self.oem_string.yfilter != YFilter.not_set or
                                self.part_number.yfilter != YFilter.not_set or
                                self.part_revision.yfilter != YFilter.not_set or
                                self.pca_num.yfilter != YFilter.not_set or
                                self.pcavid.yfilter != YFilter.not_set or
                                self.pcb_serial_num.yfilter != YFilter.not_set or
                                self.pid.yfilter != YFilter.not_set or
                                self.power_consumption.yfilter != YFilter.not_set or
                                self.power_supply_type.yfilter != YFilter.not_set or
                                self.product_id.yfilter != YFilter.not_set or
                                self.rma_code.yfilter != YFilter.not_set or
                                self.serial_number.yfilter != YFilter.not_set or
                                self.snmpoid.yfilter != YFilter.not_set or
                                self.top_assem_part_num.yfilter != YFilter.not_set or
                                self.top_assem_vid.yfilter != YFilter.not_set or
                                self.udi_description.yfilter != YFilter.not_set or
                                self.udi_name.yfilter != YFilter.not_set or
                                self.vid.yfilter != YFilter.not_set or
                                (self.rma is not None and self.rma.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "eeprom" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.asset_alias.is_set or self.asset_alias.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.asset_alias.get_name_leafdata())
                            if (self.asset_id.is_set or self.asset_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.asset_id.get_name_leafdata())
                            if (self.base_mac_address1.is_set or self.base_mac_address1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.base_mac_address1.get_name_leafdata())
                            if (self.base_mac_address2.is_set or self.base_mac_address2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.base_mac_address2.get_name_leafdata())
                            if (self.base_mac_address3.is_set or self.base_mac_address3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.base_mac_address3.get_name_leafdata())
                            if (self.base_mac_address4.is_set or self.base_mac_address4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.base_mac_address4.get_name_leafdata())
                            if (self.block_checksum.is_set or self.block_checksum.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.block_checksum.get_name_leafdata())
                            if (self.block_count.is_set or self.block_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.block_count.get_name_leafdata())
                            if (self.block_length.is_set or self.block_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.block_length.get_name_leafdata())
                            if (self.block_signature.is_set or self.block_signature.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.block_signature.get_name_leafdata())
                            if (self.block_version.is_set or self.block_version.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.block_version.get_name_leafdata())
                            if (self.chassis_sid.is_set or self.chassis_sid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.chassis_sid.get_name_leafdata())
                            if (self.clei.is_set or self.clei.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.clei.get_name_leafdata())
                            if (self.controller_family.is_set or self.controller_family.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.controller_family.get_name_leafdata())
                            if (self.controller_type.is_set or self.controller_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.controller_type.get_name_leafdata())
                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.description.get_name_leafdata())
                            if (self.dev_num1.is_set or self.dev_num1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num1.get_name_leafdata())
                            if (self.dev_num2.is_set or self.dev_num2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num2.get_name_leafdata())
                            if (self.dev_num3.is_set or self.dev_num3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num3.get_name_leafdata())
                            if (self.dev_num4.is_set or self.dev_num4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num4.get_name_leafdata())
                            if (self.dev_num5.is_set or self.dev_num5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num5.get_name_leafdata())
                            if (self.dev_num6.is_set or self.dev_num6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num6.get_name_leafdata())
                            if (self.dev_num7.is_set or self.dev_num7.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dev_num7.get_name_leafdata())
                            if (self.eci.is_set or self.eci.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.eci.get_name_leafdata())
                            if (self.eeprom_size.is_set or self.eeprom_size.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.eeprom_size.get_name_leafdata())
                            if (self.engineer_use.is_set or self.engineer_use.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.engineer_use.get_name_leafdata())
                            if (self.fru_major_type.is_set or self.fru_major_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fru_major_type.get_name_leafdata())
                            if (self.fru_minor_type.is_set or self.fru_minor_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fru_minor_type.get_name_leafdata())
                            if (self.hw_version.is_set or self.hw_version.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hw_version.get_name_leafdata())
                            if (self.hwid.is_set or self.hwid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hwid.get_name_leafdata())
                            if (self.idprom_format_rev.is_set or self.idprom_format_rev.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.idprom_format_rev.get_name_leafdata())
                            if (self.mac_add_blk_size1.is_set or self.mac_add_blk_size1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mac_add_blk_size1.get_name_leafdata())
                            if (self.mac_add_blk_size2.is_set or self.mac_add_blk_size2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mac_add_blk_size2.get_name_leafdata())
                            if (self.mac_add_blk_size3.is_set or self.mac_add_blk_size3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mac_add_blk_size3.get_name_leafdata())
                            if (self.mac_add_blk_size4.is_set or self.mac_add_blk_size4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mac_add_blk_size4.get_name_leafdata())
                            if (self.manu_test_data.is_set or self.manu_test_data.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.manu_test_data.get_name_leafdata())
                            if (self.mfg_bits.is_set or self.mfg_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mfg_bits.get_name_leafdata())
                            if (self.mfg_deviation.is_set or self.mfg_deviation.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mfg_deviation.get_name_leafdata())
                            if (self.oem_string.is_set or self.oem_string.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oem_string.get_name_leafdata())
                            if (self.part_number.is_set or self.part_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.part_number.get_name_leafdata())
                            if (self.part_revision.is_set or self.part_revision.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.part_revision.get_name_leafdata())
                            if (self.pca_num.is_set or self.pca_num.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pca_num.get_name_leafdata())
                            if (self.pcavid.is_set or self.pcavid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcavid.get_name_leafdata())
                            if (self.pcb_serial_num.is_set or self.pcb_serial_num.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcb_serial_num.get_name_leafdata())
                            if (self.pid.is_set or self.pid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pid.get_name_leafdata())
                            if (self.power_consumption.is_set or self.power_consumption.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.power_consumption.get_name_leafdata())
                            if (self.power_supply_type.is_set or self.power_supply_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.power_supply_type.get_name_leafdata())
                            if (self.product_id.is_set or self.product_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.product_id.get_name_leafdata())
                            if (self.rma_code.is_set or self.rma_code.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rma_code.get_name_leafdata())
                            if (self.serial_number.is_set or self.serial_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.serial_number.get_name_leafdata())
                            if (self.snmpoid.is_set or self.snmpoid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.snmpoid.get_name_leafdata())
                            if (self.top_assem_part_num.is_set or self.top_assem_part_num.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.top_assem_part_num.get_name_leafdata())
                            if (self.top_assem_vid.is_set or self.top_assem_vid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.top_assem_vid.get_name_leafdata())
                            if (self.udi_description.is_set or self.udi_description.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.udi_description.get_name_leafdata())
                            if (self.udi_name.is_set or self.udi_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.udi_name.get_name_leafdata())
                            if (self.vid.is_set or self.vid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vid.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rma"):
                                if (self.rma is None):
                                    self.rma = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom.Rma()
                                    self.rma.parent = self
                                    self._children_name_map["rma"] = "rma"
                                return self.rma

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rma" or name == "asset-alias" or name == "asset-id" or name == "base-mac-address1" or name == "base-mac-address2" or name == "base-mac-address3" or name == "base-mac-address4" or name == "block-checksum" or name == "block-count" or name == "block-length" or name == "block-signature" or name == "block-version" or name == "chassis-sid" or name == "clei" or name == "controller-family" or name == "controller-type" or name == "description" or name == "dev-num1" or name == "dev-num2" or name == "dev-num3" or name == "dev-num4" or name == "dev-num5" or name == "dev-num6" or name == "dev-num7" or name == "eci" or name == "eeprom-size" or name == "engineer-use" or name == "fru-major-type" or name == "fru-minor-type" or name == "hw-version" or name == "hwid" or name == "idprom-format-rev" or name == "mac-add-blk-size1" or name == "mac-add-blk-size2" or name == "mac-add-blk-size3" or name == "mac-add-blk-size4" or name == "manu-test-data" or name == "mfg-bits" or name == "mfg-deviation" or name == "oem-string" or name == "part-number" or name == "part-revision" or name == "pca-num" or name == "pcavid" or name == "pcb-serial-num" or name == "pid" or name == "power-consumption" or name == "power-supply-type" or name == "product-id" or name == "rma-code" or name == "serial-number" or name == "snmpoid" or name == "top-assem-part-num" or name == "top-assem-vid" or name == "udi-description" or name == "udi-name" or name == "vid"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "asset-alias"):
                                self.asset_alias = value
                                self.asset_alias.value_namespace = name_space
                                self.asset_alias.value_namespace_prefix = name_space_prefix
                            if(value_path == "asset-id"):
                                self.asset_id = value
                                self.asset_id.value_namespace = name_space
                                self.asset_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "base-mac-address1"):
                                self.base_mac_address1 = value
                                self.base_mac_address1.value_namespace = name_space
                                self.base_mac_address1.value_namespace_prefix = name_space_prefix
                            if(value_path == "base-mac-address2"):
                                self.base_mac_address2 = value
                                self.base_mac_address2.value_namespace = name_space
                                self.base_mac_address2.value_namespace_prefix = name_space_prefix
                            if(value_path == "base-mac-address3"):
                                self.base_mac_address3 = value
                                self.base_mac_address3.value_namespace = name_space
                                self.base_mac_address3.value_namespace_prefix = name_space_prefix
                            if(value_path == "base-mac-address4"):
                                self.base_mac_address4 = value
                                self.base_mac_address4.value_namespace = name_space
                                self.base_mac_address4.value_namespace_prefix = name_space_prefix
                            if(value_path == "block-checksum"):
                                self.block_checksum = value
                                self.block_checksum.value_namespace = name_space
                                self.block_checksum.value_namespace_prefix = name_space_prefix
                            if(value_path == "block-count"):
                                self.block_count = value
                                self.block_count.value_namespace = name_space
                                self.block_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "block-length"):
                                self.block_length = value
                                self.block_length.value_namespace = name_space
                                self.block_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "block-signature"):
                                self.block_signature = value
                                self.block_signature.value_namespace = name_space
                                self.block_signature.value_namespace_prefix = name_space_prefix
                            if(value_path == "block-version"):
                                self.block_version = value
                                self.block_version.value_namespace = name_space
                                self.block_version.value_namespace_prefix = name_space_prefix
                            if(value_path == "chassis-sid"):
                                self.chassis_sid = value
                                self.chassis_sid.value_namespace = name_space
                                self.chassis_sid.value_namespace_prefix = name_space_prefix
                            if(value_path == "clei"):
                                self.clei = value
                                self.clei.value_namespace = name_space
                                self.clei.value_namespace_prefix = name_space_prefix
                            if(value_path == "controller-family"):
                                self.controller_family = value
                                self.controller_family.value_namespace = name_space
                                self.controller_family.value_namespace_prefix = name_space_prefix
                            if(value_path == "controller-type"):
                                self.controller_type = value
                                self.controller_type.value_namespace = name_space
                                self.controller_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "description"):
                                self.description = value
                                self.description.value_namespace = name_space
                                self.description.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num1"):
                                self.dev_num1 = value
                                self.dev_num1.value_namespace = name_space
                                self.dev_num1.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num2"):
                                self.dev_num2 = value
                                self.dev_num2.value_namespace = name_space
                                self.dev_num2.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num3"):
                                self.dev_num3 = value
                                self.dev_num3.value_namespace = name_space
                                self.dev_num3.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num4"):
                                self.dev_num4 = value
                                self.dev_num4.value_namespace = name_space
                                self.dev_num4.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num5"):
                                self.dev_num5 = value
                                self.dev_num5.value_namespace = name_space
                                self.dev_num5.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num6"):
                                self.dev_num6 = value
                                self.dev_num6.value_namespace = name_space
                                self.dev_num6.value_namespace_prefix = name_space_prefix
                            if(value_path == "dev-num7"):
                                self.dev_num7 = value
                                self.dev_num7.value_namespace = name_space
                                self.dev_num7.value_namespace_prefix = name_space_prefix
                            if(value_path == "eci"):
                                self.eci = value
                                self.eci.value_namespace = name_space
                                self.eci.value_namespace_prefix = name_space_prefix
                            if(value_path == "eeprom-size"):
                                self.eeprom_size = value
                                self.eeprom_size.value_namespace = name_space
                                self.eeprom_size.value_namespace_prefix = name_space_prefix
                            if(value_path == "engineer-use"):
                                self.engineer_use = value
                                self.engineer_use.value_namespace = name_space
                                self.engineer_use.value_namespace_prefix = name_space_prefix
                            if(value_path == "fru-major-type"):
                                self.fru_major_type = value
                                self.fru_major_type.value_namespace = name_space
                                self.fru_major_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "fru-minor-type"):
                                self.fru_minor_type = value
                                self.fru_minor_type.value_namespace = name_space
                                self.fru_minor_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "hw-version"):
                                self.hw_version = value
                                self.hw_version.value_namespace = name_space
                                self.hw_version.value_namespace_prefix = name_space_prefix
                            if(value_path == "hwid"):
                                self.hwid = value
                                self.hwid.value_namespace = name_space
                                self.hwid.value_namespace_prefix = name_space_prefix
                            if(value_path == "idprom-format-rev"):
                                self.idprom_format_rev = value
                                self.idprom_format_rev.value_namespace = name_space
                                self.idprom_format_rev.value_namespace_prefix = name_space_prefix
                            if(value_path == "mac-add-blk-size1"):
                                self.mac_add_blk_size1 = value
                                self.mac_add_blk_size1.value_namespace = name_space
                                self.mac_add_blk_size1.value_namespace_prefix = name_space_prefix
                            if(value_path == "mac-add-blk-size2"):
                                self.mac_add_blk_size2 = value
                                self.mac_add_blk_size2.value_namespace = name_space
                                self.mac_add_blk_size2.value_namespace_prefix = name_space_prefix
                            if(value_path == "mac-add-blk-size3"):
                                self.mac_add_blk_size3 = value
                                self.mac_add_blk_size3.value_namespace = name_space
                                self.mac_add_blk_size3.value_namespace_prefix = name_space_prefix
                            if(value_path == "mac-add-blk-size4"):
                                self.mac_add_blk_size4 = value
                                self.mac_add_blk_size4.value_namespace = name_space
                                self.mac_add_blk_size4.value_namespace_prefix = name_space_prefix
                            if(value_path == "manu-test-data"):
                                self.manu_test_data = value
                                self.manu_test_data.value_namespace = name_space
                                self.manu_test_data.value_namespace_prefix = name_space_prefix
                            if(value_path == "mfg-bits"):
                                self.mfg_bits = value
                                self.mfg_bits.value_namespace = name_space
                                self.mfg_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "mfg-deviation"):
                                self.mfg_deviation = value
                                self.mfg_deviation.value_namespace = name_space
                                self.mfg_deviation.value_namespace_prefix = name_space_prefix
                            if(value_path == "oem-string"):
                                self.oem_string = value
                                self.oem_string.value_namespace = name_space
                                self.oem_string.value_namespace_prefix = name_space_prefix
                            if(value_path == "part-number"):
                                self.part_number = value
                                self.part_number.value_namespace = name_space
                                self.part_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "part-revision"):
                                self.part_revision = value
                                self.part_revision.value_namespace = name_space
                                self.part_revision.value_namespace_prefix = name_space_prefix
                            if(value_path == "pca-num"):
                                self.pca_num = value
                                self.pca_num.value_namespace = name_space
                                self.pca_num.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcavid"):
                                self.pcavid = value
                                self.pcavid.value_namespace = name_space
                                self.pcavid.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcb-serial-num"):
                                self.pcb_serial_num = value
                                self.pcb_serial_num.value_namespace = name_space
                                self.pcb_serial_num.value_namespace_prefix = name_space_prefix
                            if(value_path == "pid"):
                                self.pid = value
                                self.pid.value_namespace = name_space
                                self.pid.value_namespace_prefix = name_space_prefix
                            if(value_path == "power-consumption"):
                                self.power_consumption = value
                                self.power_consumption.value_namespace = name_space
                                self.power_consumption.value_namespace_prefix = name_space_prefix
                            if(value_path == "power-supply-type"):
                                self.power_supply_type = value
                                self.power_supply_type.value_namespace = name_space
                                self.power_supply_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "product-id"):
                                self.product_id = value
                                self.product_id.value_namespace = name_space
                                self.product_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "rma-code"):
                                self.rma_code = value
                                self.rma_code.value_namespace = name_space
                                self.rma_code.value_namespace_prefix = name_space_prefix
                            if(value_path == "serial-number"):
                                self.serial_number = value
                                self.serial_number.value_namespace = name_space
                                self.serial_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "snmpoid"):
                                self.snmpoid = value
                                self.snmpoid.value_namespace = name_space
                                self.snmpoid.value_namespace_prefix = name_space_prefix
                            if(value_path == "top-assem-part-num"):
                                self.top_assem_part_num = value
                                self.top_assem_part_num.value_namespace = name_space
                                self.top_assem_part_num.value_namespace_prefix = name_space_prefix
                            if(value_path == "top-assem-vid"):
                                self.top_assem_vid = value
                                self.top_assem_vid.value_namespace = name_space
                                self.top_assem_vid.value_namespace_prefix = name_space_prefix
                            if(value_path == "udi-description"):
                                self.udi_description = value
                                self.udi_description.value_namespace = name_space
                                self.udi_description.value_namespace_prefix = name_space_prefix
                            if(value_path == "udi-name"):
                                self.udi_name = value
                                self.udi_name.value_namespace = name_space
                                self.udi_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "vid"):
                                self.vid = value
                                self.vid.value_namespace = name_space
                                self.vid.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.description.is_set or
                            self.has_eeprom.is_set or
                            self.inv_card_type.is_set or
                            self.opaque_data.is_set or
                            self.opaque_data_size.is_set or
                            (self.eeprom is not None and self.eeprom.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.description.yfilter != YFilter.not_set or
                            self.has_eeprom.yfilter != YFilter.not_set or
                            self.inv_card_type.yfilter != YFilter.not_set or
                            self.opaque_data.yfilter != YFilter.not_set or
                            self.opaque_data_size.yfilter != YFilter.not_set or
                            (self.eeprom is not None and self.eeprom.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "inv-eeprom-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.description.get_name_leafdata())
                        if (self.has_eeprom.is_set or self.has_eeprom.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_eeprom.get_name_leafdata())
                        if (self.inv_card_type.is_set or self.inv_card_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inv_card_type.get_name_leafdata())
                        if (self.opaque_data.is_set or self.opaque_data.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.opaque_data.get_name_leafdata())
                        if (self.opaque_data_size.is_set or self.opaque_data_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.opaque_data_size.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "eeprom"):
                            if (self.eeprom is None):
                                self.eeprom = Inventory.Racks.Rack.Attributes.InvEepromInfo.Eeprom()
                                self.eeprom.parent = self
                                self._children_name_map["eeprom"] = "eeprom"
                            return self.eeprom

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "eeprom" or name == "description" or name == "has-eeprom" or name == "inv-card-type" or name == "opaque-data" or name == "opaque-data-size"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "description"):
                            self.description = value
                            self.description.value_namespace = name_space
                            self.description.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-eeprom"):
                            self.has_eeprom = value
                            self.has_eeprom.value_namespace = name_space
                            self.has_eeprom.value_namespace_prefix = name_space_prefix
                        if(value_path == "inv-card-type"):
                            self.inv_card_type = value
                            self.inv_card_type.value_namespace = name_space
                            self.inv_card_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "opaque-data"):
                            self.opaque_data = value
                            self.opaque_data.value_namespace = name_space
                            self.opaque_data.value_namespace_prefix = name_space_prefix
                        if(value_path == "opaque-data-size"):
                            self.opaque_data_size = value
                            self.opaque_data_size.value_namespace = name_space
                            self.opaque_data_size.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.module_done.is_set or
                        self.node_id.is_set or
                        self.vm_done.is_set or
                        self.vm_node_id.is_set or
                        (self.env_sensor_info is not None and self.env_sensor_info.has_data()) or
                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_data()) or
                        (self.fru_info is not None and self.fru_info.has_data()) or
                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_data()) or
                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_data()) or
                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_data()) or
                        (self.pwg_info is not None and self.pwg_info.has_data()) or
                        (self.threshold is not None and self.threshold.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.module_done.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.vm_done.yfilter != YFilter.not_set or
                        self.vm_node_id.yfilter != YFilter.not_set or
                        (self.env_sensor_info is not None and self.env_sensor_info.has_operation()) or
                        (self.env_sensor_info_xml is not None and self.env_sensor_info_xml.has_operation()) or
                        (self.fru_info is not None and self.fru_info.has_operation()) or
                        (self.inv_asset_bag is not None and self.inv_asset_bag.has_operation()) or
                        (self.inv_basic_bag is not None and self.inv_basic_bag.has_operation()) or
                        (self.inv_eeprom_info is not None and self.inv_eeprom_info.has_operation()) or
                        (self.pwg_info is not None and self.pwg_info.has_operation()) or
                        (self.threshold is not None and self.threshold.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "attributes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.module_done.is_set or self.module_done.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.module_done.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.vm_done.is_set or self.vm_done.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vm_done.get_name_leafdata())
                    if (self.vm_node_id.is_set or self.vm_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vm_node_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "env-sensor-info"):
                        if (self.env_sensor_info is None):
                            self.env_sensor_info = Inventory.Racks.Rack.Attributes.EnvSensorInfo()
                            self.env_sensor_info.parent = self
                            self._children_name_map["env_sensor_info"] = "env-sensor-info"
                        return self.env_sensor_info

                    if (child_yang_name == "env-sensor-info-xml"):
                        if (self.env_sensor_info_xml is None):
                            self.env_sensor_info_xml = Inventory.Racks.Rack.Attributes.EnvSensorInfoXml()
                            self.env_sensor_info_xml.parent = self
                            self._children_name_map["env_sensor_info_xml"] = "env-sensor-info-xml"
                        return self.env_sensor_info_xml

                    if (child_yang_name == "fru-info"):
                        if (self.fru_info is None):
                            self.fru_info = Inventory.Racks.Rack.Attributes.FruInfo()
                            self.fru_info.parent = self
                            self._children_name_map["fru_info"] = "fru-info"
                        return self.fru_info

                    if (child_yang_name == "inv-asset-bag"):
                        if (self.inv_asset_bag is None):
                            self.inv_asset_bag = Inventory.Racks.Rack.Attributes.InvAssetBag()
                            self.inv_asset_bag.parent = self
                            self._children_name_map["inv_asset_bag"] = "inv-asset-bag"
                        return self.inv_asset_bag

                    if (child_yang_name == "inv-basic-bag"):
                        if (self.inv_basic_bag is None):
                            self.inv_basic_bag = Inventory.Racks.Rack.Attributes.InvBasicBag()
                            self.inv_basic_bag.parent = self
                            self._children_name_map["inv_basic_bag"] = "inv-basic-bag"
                        return self.inv_basic_bag

                    if (child_yang_name == "inv-eeprom-info"):
                        if (self.inv_eeprom_info is None):
                            self.inv_eeprom_info = Inventory.Racks.Rack.Attributes.InvEepromInfo()
                            self.inv_eeprom_info.parent = self
                            self._children_name_map["inv_eeprom_info"] = "inv-eeprom-info"
                        return self.inv_eeprom_info

                    if (child_yang_name == "pwg-info"):
                        if (self.pwg_info is None):
                            self.pwg_info = Inventory.Racks.Rack.Attributes.PwgInfo()
                            self.pwg_info.parent = self
                            self._children_name_map["pwg_info"] = "pwg-info"
                        return self.pwg_info

                    if (child_yang_name == "threshold"):
                        if (self.threshold is None):
                            self.threshold = Inventory.Racks.Rack.Attributes.Threshold()
                            self.threshold.parent = self
                            self._children_name_map["threshold"] = "threshold"
                        return self.threshold

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "env-sensor-info" or name == "env-sensor-info-xml" or name == "fru-info" or name == "inv-asset-bag" or name == "inv-basic-bag" or name == "inv-eeprom-info" or name == "pwg-info" or name == "threshold" or name == "module-done" or name == "node-id" or name == "vm-done" or name == "vm-node-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "module-done"):
                        self.module_done = value
                        self.module_done.value_namespace = name_space
                        self.module_done.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "vm-done"):
                        self.vm_done = value
                        self.vm_done.value_namespace = name_space
                        self.vm_done.value_namespace_prefix = name_space_prefix
                    if(value_path == "vm-node-id"):
                        self.vm_node_id = value
                        self.vm_node_id.value_namespace = name_space
                        self.vm_node_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.name.is_set or
                    (self.attributes is not None and self.attributes.has_data()) or
                    (self.entity_ is not None and self.entity_.has_data()) or
                    (self.fantray is not None and self.fantray.has_data()) or
                    (self.powershelf is not None and self.powershelf.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.name.yfilter != YFilter.not_set or
                    (self.attributes is not None and self.attributes.has_operation()) or
                    (self.entity_ is not None and self.entity_.has_operation()) or
                    (self.fantray is not None and self.fantray.has_operation()) or
                    (self.powershelf is not None and self.powershelf.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rack" + "[name='" + self.name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-invmgr-oper:inventory/racks/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "attributes"):
                    if (self.attributes is None):
                        self.attributes = Inventory.Racks.Rack.Attributes()
                        self.attributes.parent = self
                        self._children_name_map["attributes"] = "attributes"
                    return self.attributes

                if (child_yang_name == "entity"):
                    if (self.entity_ is None):
                        self.entity_ = Inventory.Racks.Rack.Entity_()
                        self.entity_.parent = self
                        self._children_name_map["entity_"] = "entity"
                    return self.entity_

                if (child_yang_name == "fantray"):
                    if (self.fantray is None):
                        self.fantray = Inventory.Racks.Rack.Fantray()
                        self.fantray.parent = self
                        self._children_name_map["fantray"] = "fantray"
                    return self.fantray

                if (child_yang_name == "powershelf"):
                    if (self.powershelf is None):
                        self.powershelf = Inventory.Racks.Rack.Powershelf()
                        self.powershelf.parent = self
                        self._children_name_map["powershelf"] = "powershelf"
                    return self.powershelf

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "attributes" or name == "entity" or name == "fantray" or name == "powershelf" or name == "name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "name"):
                    self.name = value
                    self.name.value_namespace = name_space
                    self.name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.rack:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.rack:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "racks" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-invmgr-oper:inventory/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "rack"):
                for c in self.rack:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Inventory.Racks.Rack()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.rack.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "rack"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.entities is not None and self.entities.has_data()) or
            (self.racks is not None and self.racks.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.entities is not None and self.entities.has_operation()) or
            (self.racks is not None and self.racks.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-invmgr-oper:inventory" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "entities"):
            if (self.entities is None):
                self.entities = Inventory.Entities()
                self.entities.parent = self
                self._children_name_map["entities"] = "entities"
            return self.entities

        if (child_yang_name == "racks"):
            if (self.racks is None):
                self.racks = Inventory.Racks()
                self.racks.parent = self
                self._children_name_map["racks"] = "racks"
            return self.racks

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "entities" or name == "racks"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = Inventory()
        return self._top_entity

